"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/contextkey/common/contextkey","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","fs","child_process","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","os","net","vs/platform/files/common/watcher","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/model","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/codiconsUtil","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/editor/common/model/textModelSearch","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","http","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/uint","vs/base/common/uriIpc","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/console","vs/amdX","vs/base/common/dataTransfer","vs/base/node/ports","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(re){for(var e=[],o=0,R=re.length;o<R;o++)e[o]=Ee[re[o]];return e};define(Ee[163],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class o{static get(){const I=new Map,M=new Map,L=new Map,p=new Map;function $(C,y){C.has(y.detail)||C.set(y.detail,-y.timestamp)}function w(C,y){const a=C.get(y.detail);a&&(a>=0||C.set(y.detail,a+y.timestamp))}let A=[];typeof re=="function"&&typeof re.getStats=="function"&&(A=re.getStats().slice(0).sort((C,y)=>C.timestamp-y.timestamp));for(const C of A)switch(C.type){case 10:$(I,C);break;case 11:case 12:w(I,C);break;case 21:$(M,C);break;case 22:w(M,C);break;case 33:$(L,C);break;case 34:w(L,C);break;case 31:$(p,C);break;case 32:w(p,C);break}let P=0;L.forEach(C=>P+=C);function b(C){const y=[];return C.forEach((a,m)=>y.push([m,a])),y}return{amdLoad:b(I),amdInvoke:b(M),nodeRequire:b(L),nodeEval:b(p),nodeRequireTotal:P}}static toMarkdownTable(I,M){let L="";const p=[];return I.forEach(($,w)=>{p[w]=$.length}),M.forEach($=>{$.forEach((w,A)=>{typeof w>"u"&&(w=$[A]="-");const P=w.toString().length;p[A]=Math.max(P,p[A])})}),I.forEach(($,w)=>{L+=`| ${$+" ".repeat(p[w]-$.toString().length)} `}),L+=`|
`,I.forEach(($,w)=>{L+=`| ${"-".repeat(p[w])} `}),L+=`|
`,M.forEach($=>{$.forEach((w,A)=>{typeof w<"u"&&(L+=`| ${w+" ".repeat(p[A]-w.toString().length)} `)}),L+=`|
`}),L}}e.$U=o}),define(Ee[164],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=o,e.$gb=R,e.$hb=I,e.$ib=M,e.$jb=L,e.$kb=p,e.$lb=$,e.$nb=A,e.$ob=P,e.$pb=b,e.$qb=C,e.$rb=y;function o(a,m,c){const i=R(a,m);if(i!==-1)return a[i]}function R(a,m,c=a.length-1){for(let i=c;i>=0;i--){const n=a[i];if(m(n))return i}return-1}function I(a,m){const c=M(a,m);return c===-1?void 0:a[c]}function M(a,m,c=0,i=a.length){let n=c,r=i;for(;n<r;){const s=Math.floor((n+r)/2);m(a[s])?n=s+1:r=s}return n-1}function L(a,m){const c=p(a,m);return c===a.length?void 0:a[c]}function p(a,m,c=0,i=a.length){let n=c,r=i;for(;n<r;){const s=Math.floor((n+r)/2);m(a[s])?r=s:n=s+1}return n}function $(a,m,c=0,i=a.length){const n=p(a,m,c,i);return n===a.length?-1:n}class w{constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(w.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!m(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const c=M(this.e,m,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}e.$mb=w,w.assertInvariants=!1;function A(a,m){if(a.length===0)return;let c=a[0];for(let i=1;i<a.length;i++){const n=a[i];m(n,c)>0&&(c=n)}return c}function P(a,m){if(a.length===0)return;let c=a[0];for(let i=1;i<a.length;i++){const n=a[i];m(n,c)>=0&&(c=n)}return c}function b(a,m){return A(a,(c,i)=>-m(c,i))}function C(a,m){if(a.length===0)return-1;let c=0;for(let i=1;i<a.length;i++){const n=a[i];m(n,a[c])>0&&(c=i)}return c}function y(a,m){for(const c of a){const i=m(c);if(i!==void 0)return i}}}),define(Ee[73],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E=o,e.$F=R,e.$G=I,e.$H=M;function o(L,p){const $=Object.create(null);for(const w of L){const A=p(w);let P=$[A];P||(P=$[A]=[]),P.push(w)}return $}function R(L,p){const $=[],w=[];for(const A of L)p.has(A)||$.push(A);for(const A of p)L.has(A)||w.push(A);return{removed:$,added:w}}function I(L,p){const $=[],w=[];for(const[A,P]of L)p.has(A)||$.push(P);for(const[A,P]of p)L.has(A)||w.push(P);return{removed:$,added:w}}function M(L,p){const $=new Set;for(const w of p)L.has(w)&&$.add(w);return $}}),define(Ee[54],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=R,e.$Nh=I,e.$Oh=M;function o(L){return(p,$,w)=>{let A=null,P=null;if(typeof w.value=="function"?(A="value",P=w.value):typeof w.get=="function"&&(A="get",P=w.get),!P)throw new Error("not supported");w[A]=L(P,$)}}function R(L,p,$){let w=null,A=null;if(typeof $.value=="function"?(w="value",A=$.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(w="get",A=$.get),!A)throw new Error("not supported");const P=`$memoize$${p}`;$[w]=function(...b){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,b)}),this[P]}}function I(L,p,$){return o((w,A)=>{const P=`$debounce$${A}`,b=`$debounce$result$${A}`;return function(...C){this[b]||(this[b]=$?$():void 0),clearTimeout(this[P]),p&&(this[b]=p(this[b],...C),C=[this[b]]),this[P]=setTimeout(()=>{w.apply(this,C),this[b]=$?$():void 0},L)}})}function M(L,p,$){return o((w,A)=>{const P=`$throttle$timer$${A}`,b=`$throttle$result$${A}`,C=`$throttle$lastRun$${A}`,y=`$throttle$pending$${A}`;return function(...a){if(this[b]||(this[b]=$?$():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),p&&(this[b]=p(this[b],...a)),this[y])return;const m=this[C]+L;m<=Date.now()?(this[C]=Date.now(),w.apply(this,[this[b]]),this[b]=$?$():void 0):(this[y]=!0,this[P]=setTimeout(()=>{this[y]=!1,this[C]=Date.now(),w.apply(this,[this[b]]),this[b]=$?$():void 0},m-Date.now()))}})}}),define(Ee[13],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=R,e.$Z=I,e.$1=M,e.$2=L,e.$3=p,e.$4=w,e.$6=P,e.$7=b,e.$8=C,e.$0=a;class o{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(f=>{f(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=o,e.$X=new o;function R(s){e.$X.setUnexpectedErrorHandler(s)}function I(s){if(!s||typeof s!="object")return!1;const t=s;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function M(s){w(s)||e.$X.onUnexpectedError(s)}function L(s){w(s)||e.$X.onUnexpectedExternalError(s)}function p(s){if(s instanceof Error){const{name:t,message:f}=s,d=s.stacktrace||s.stack;return{$isError:!0,name:t,message:f,stack:d,noTelemetry:n.isErrorNoTelemetry(s)}}return s}const $="Canceled";function w(s){return s instanceof A?!0:s instanceof Error&&s.name===$&&s.message===$}class A extends Error{constructor(){super($),this.name=this.message}}e.$5=A;function P(){const s=new Error($);return s.name=s.message,s}function b(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function C(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class y extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=y;function a(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=m;class c extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=c;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const f=new n;return f.message=t.message,f.stack=t.stack,f}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=n;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.$cb=r}),define(Ee[19],Ce([1,0,13,164]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=I,e.$tb=M,e.$ub=L,e.$vb=p,e.$wb=$,e.$xb=w,e.$yb=A,e.$zb=P,e.$Ab=b,e.$Bb=C,e.$Cb=y,e.$Db=a,e.$Eb=m,e.top=c,e.$Gb=i,e.$Hb=r,e.$Ib=s,e.$Jb=t,e.$Kb=f,e.$Lb=d,e.$Mb=u,e.$Nb=h,e.$Ob=l,e.$Pb=g,e.$Qb=E,e.$Rb=v,e.$Sb=S,e.$Tb=k,e.$Ub=D,e.$Vb=F,e.$Wb=W,e.$Xb=B,e.$Yb=j,e.$Zb=N,e.$1b=T,e.$2b=O,e.$3b=z,e.$4b=Q,e.$5b=Z,e.$6b=J,e.$7b=te,e.$8b=pe,e.$$b=U;function I(ie,se=0){return ie[ie.length-(1+se)]}function M(ie){if(ie.length===0)throw new Error("Invalid tail call");return[ie.slice(0,ie.length-1),ie[ie.length-1]]}function L(ie,se,oe=(G,ee)=>G===ee){if(ie===se)return!0;if(!ie||!se||ie.length!==se.length)return!1;for(let G=0,ee=ie.length;G<ee;G++)if(!oe(ie[G],se[G]))return!1;return!0}function p(ie,se){const oe=ie.length-1;se<oe&&(ie[se]=ie[oe]),ie.pop()}function $(ie,se,oe){return w(ie.length,G=>oe(ie[G],se))}function w(ie,se){let oe=0,G=ie-1;for(;oe<=G;){const ee=(oe+G)/2|0,le=se(ee);if(le<0)oe=ee+1;else if(le>0)G=ee-1;else return ee}return-(oe+1)}function A(ie,se,oe){if(ie=ie|0,ie>=se.length)throw new TypeError("invalid index");const G=se[Math.floor(se.length*Math.random())],ee=[],le=[],de=[];for(const Me of se){const be=oe(Me,G);be<0?ee.push(Me):be>0?le.push(Me):de.push(Me)}return ie<ee.length?A(ie,ee,oe):ie<ee.length+de.length?de[0]:A(ie-(ee.length+de.length),le,oe)}function P(ie,se){const oe=[];let G;for(const ee of ie.slice(0).sort(se))!G||se(G[0],ee)!==0?(G=[ee],oe.push(G)):G.push(ee);return oe}function*b(ie,se){let oe,G;for(const ee of ie)G!==void 0&&se(G,ee)?oe.push(ee):(oe&&(yield oe),oe=[ee]),G=ee;oe&&(yield oe)}function C(ie,se){for(let oe=0;oe<=ie.length;oe++)se(oe===0?void 0:ie[oe-1],oe===ie.length?void 0:ie[oe])}function y(ie,se){for(let oe=0;oe<ie.length;oe++)se(oe===0?void 0:ie[oe-1],ie[oe],oe+1===ie.length?void 0:ie[oe+1])}function a(ie,se,oe){const G=[];function ee(Me,be,Pe){if(be===0&&Pe.length===0)return;const Re=G[G.length-1];Re&&Re.start+Re.deleteCount===Me?(Re.deleteCount+=be,Re.toInsert.push(...Pe)):G.push({start:Me,deleteCount:be,toInsert:Pe})}let le=0,de=0;for(;;){if(le===ie.length){ee(le,0,se.slice(de));break}if(de===se.length){ee(le,ie.length-le,[]);break}const Me=ie[le],be=se[de],Pe=oe(Me,be);Pe===0?(le+=1,de+=1):Pe<0?(ee(le,1,[]),le+=1):Pe>0&&(ee(le,0,[be]),de+=1)}return G}function m(ie,se,oe){const G=a(ie,se,oe),ee=[],le=[];for(const de of G)ee.push(...ie.slice(de.start,de.start+de.deleteCount)),le.push(...de.toInsert);return{removed:ee,added:le}}function c(ie,se,oe){if(oe===0)return[];const G=ie.slice(0,oe).sort(se);return n(ie,se,G,oe,ie.length),G}function i(ie,se,oe,G,ee){return oe===0?Promise.resolve([]):new Promise((le,de)=>{(async()=>{const Me=ie.length,be=ie.slice(0,oe).sort(se);for(let Pe=oe,Re=Math.min(oe+G,Me);Pe<Me;Pe=Re,Re=Math.min(Re+G,Me)){if(Pe>oe&&await new Promise(ze=>setTimeout(ze)),ee&&ee.isCancellationRequested)throw new o.$5;n(ie,se,be,Pe,Re)}return be})().then(le,de)})}function n(ie,se,oe,G,ee){for(const le=oe.length;G<ee;G++){const de=ie[G];if(se(de,oe[le-1])<0){oe.pop();const Me=(0,R.$kb)(oe,be=>se(de,be)<0);oe.splice(Me,0,de)}}}function r(ie){return ie.filter(se=>!!se)}function s(ie){let se=0;for(let oe=0;oe<ie.length;oe++)ie[oe]&&(ie[se]=ie[oe],se+=1);ie.length=se}function t(ie,se,oe){ie.splice(oe,0,ie.splice(se,1)[0])}function f(ie){return!Array.isArray(ie)||ie.length===0}function d(ie){return Array.isArray(ie)&&ie.length>0}function u(ie,se=oe=>oe){const oe=new Set;return ie.filter(G=>{const ee=se(G);return oe.has(ee)?!1:(oe.add(ee),!0)})}function h(ie){const se=new Set;return oe=>{const G=ie(oe);return se.has(G)?!1:(se.add(G),!0)}}function l(ie,se){return ie.length>0?ie[0]:se}function g(ie,se){return ie.length>0?ie[ie.length-1]:se}function E(ie,se,oe=(G,ee)=>G===ee){let G=0;for(let ee=0,le=Math.min(ie.length,se.length);ee<le&&oe(ie[ee],se[ee]);ee++)G++;return G}function v(ie){return[].concat(...ie)}function S(ie,se){let oe=typeof se=="number"?ie:0;typeof se=="number"?oe=ie:(oe=0,se=ie);const G=[];if(oe<=se)for(let ee=oe;ee<se;ee++)G.push(ee);else for(let ee=oe;ee>se;ee--)G.push(ee);return G}function k(ie,se,oe){return ie.reduce((G,ee)=>(G[se(ee)]=oe?oe(ee):ee,G),Object.create(null))}function D(ie,se){return ie.push(se),()=>F(ie,se)}function F(ie,se){const oe=ie.indexOf(se);if(oe>-1)return ie.splice(oe,1),se}function W(ie,se,oe){const G=ie.slice(0,se),ee=ie.slice(se);return G.concat(oe,ee)}function B(ie,se){let oe;if(typeof se=="number"){let G=se;oe=()=>{const ee=Math.sin(G++)*179426549;return ee-Math.floor(ee)}}else oe=Math.random;for(let G=ie.length-1;G>0;G-=1){const ee=Math.floor(oe()*(G+1)),le=ie[G];ie[G]=ie[ee],ie[ee]=le}}function j(ie,se){const oe=ie.indexOf(se);oe>-1&&(ie.splice(oe,1),ie.unshift(se))}function N(ie,se){const oe=ie.indexOf(se);oe>-1&&(ie.splice(oe,1),ie.push(se))}function T(ie,se){for(const oe of se)ie.push(oe)}function O(ie,se){return Array.isArray(ie)?ie.map(se):se(ie)}function z(ie){return Array.isArray(ie)?ie:[ie]}function Q(ie){return ie[Math.floor(Math.random()*ie.length)]}function Z(ie,se,oe){const G=x(ie,se),ee=ie.length,le=oe.length;ie.length=ee+le;for(let de=ee-1;de>=G;de--)ie[de+le]=ie[de];for(let de=0;de<le;de++)ie[de+G]=oe[de]}function J(ie,se,oe,G){const ee=x(ie,se);let le=ie.splice(ee,oe);return le===void 0&&(le=[]),Z(ie,ee,G),le}function x(ie,se){return se<0?Math.max(se+ie.length,0):Math.min(se,ie.length)}var ce;(function(ie){function se(le){return le<0}ie.isLessThan=se;function oe(le){return le<=0}ie.isLessThanOrEqual=oe;function G(le){return le>0}ie.isGreaterThan=G;function ee(le){return le===0}ie.isNeitherLessOrGreaterThan=ee,ie.greaterThan=1,ie.lessThan=-1,ie.neitherLessOrGreaterThan=0})(ce||(e.CompareResult=ce={}));function te(ie,se){return(oe,G)=>se(ie(oe),ie(G))}function pe(...ie){return(se,oe)=>{for(const G of ie){const ee=G(se,oe);if(!ce.isNeitherLessOrGreaterThan(ee))return ee}return ce.neitherLessOrGreaterThan}}const ye=(ie,se)=>ie-se;e.$9b=ye;const _=(ie,se)=>(0,e.$9b)(ie?1:0,se?1:0);e.$0b=_;function U(ie){return(se,oe)=>-ie(se,oe)}class he{constructor(se){this.g=se,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(se){let oe=this.c;for(;oe<this.g.length&&se(this.g[oe]);)oe++;const G=oe===this.c?null:this.g.slice(this.c,oe);return this.c=oe,G}takeFromEndWhile(se){let oe=this.d;for(;oe>=0&&se(this.g[oe]);)oe--;const G=oe===this.d?null:this.g.slice(oe+1,this.d+1);return this.d=oe,G}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const se=this.g[this.c];return this.c++,se}removeLast(){const se=this.g[this.d];return this.d--,se}takeCount(se){const oe=this.g.slice(this.c,this.c+se);return this.c+=se,oe}}e.$_b=he;class Se{constructor(se){this.iterate=se}forEach(se){this.iterate(oe=>(se(oe),!0))}toArray(){const se=[];return this.iterate(oe=>(se.push(oe),!0)),se}filter(se){return new Se(oe=>this.iterate(G=>se(G)?oe(G):!0))}map(se){return new Se(oe=>this.iterate(G=>oe(se(G))))}some(se){let oe=!1;return this.iterate(G=>(oe=se(G),!oe)),oe}findFirst(se){let oe;return this.iterate(G=>se(G)?(oe=G,!1):!0),oe}findLast(se){let oe;return this.iterate(G=>(se(G)&&(oe=G),!0)),oe}findLastMaxBy(se){let oe,G=!0;return this.iterate(ee=>((G||ce.isGreaterThan(se(ee,oe)))&&(G=!1,oe=ee),!0)),oe}}e.$ac=Se,Se.empty=new Se(ie=>{});class me{constructor(se){this.c=se}static createSortPermutation(se,oe){const G=Array.from(se.keys()).sort((ee,le)=>oe(se[ee],se[le]));return new me(G)}apply(se){return se.map((oe,G)=>se[this.c[G]])}inverse(){const se=this.c.slice();for(let oe=0;oe<this.c.length;oe++)se[this.c[oe]]=oe;return new me(se)}}e.$bc=me}),define(Ee[61],Ce([1,0,13]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=R,e.$0c=I,e.$$c=M,e.$_c=L,e.$ad=p,e.$bd=$;function R(w,A){if(!w)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}function I(w,A="Unreachable"){throw new Error(A)}function M(w){if(!w)throw new o.$cb("Assertion Failed")}function L(w){w||(0,o.$1)(new o.$cb("Soft Assertion Failed"))}function p(w){if(!w()){debugger;w(),(0,o.$1)(new o.$cb("Assertion Failed"))}}function $(w,A){let P=0;for(;P<w.length-1;){const b=w[P],C=w[P+1];if(!A(b,C))return!1;P++}return!0}}),define(Ee[74],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=o;function o(R,I){const M=this;let L=!1,p;return function(){if(L)return p;if(L=!0,I)try{p=R.apply(M,arguments)}finally{I()}else p=R.apply(M,arguments);return p}}}),define(Ee[125],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UO=e.$TO=void 0;class o{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$TO=o,e.$UO=new o("id#")}),define(Ee[39],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var o;(function(R){function I(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}R.is=I;const M=Object.freeze([]);function L(){return M}R.empty=L;function*p(t){yield t}R.single=p;function $(t){return I(t)?t:p(t)}R.wrap=$;function w(t){return t||M}R.from=w;function*A(t){for(let f=t.length-1;f>=0;f--)yield t[f]}R.reverse=A;function P(t){return!t||t[Symbol.iterator]().next().done===!0}R.isEmpty=P;function b(t){return t[Symbol.iterator]().next().value}R.first=b;function C(t,f){for(const d of t)if(f(d))return!0;return!1}R.some=C;function y(t,f){for(const d of t)if(f(d))return d}R.find=y;function*a(t,f){for(const d of t)f(d)&&(yield d)}R.filter=a;function*m(t,f){let d=0;for(const u of t)yield f(u,d++)}R.map=m;function*c(...t){for(const f of t)yield*f}R.concat=c;function i(t,f,d){let u=d;for(const h of t)u=f(u,h);return u}R.reduce=i;function*n(t,f,d=t.length){for(f<0&&(f+=t.length),d<0?d+=t.length:d>t.length&&(d=t.length);f<d;f++)yield t[f]}R.slice=n;function r(t,f=Number.POSITIVE_INFINITY){const d=[];if(f===0)return[d,t];const u=t[Symbol.iterator]();for(let h=0;h<f;h++){const l=u.next();if(l.done)return[d,R.empty()];d.push(l.value)}return[d,{[Symbol.iterator](){return u}}]}R.consume=r;async function s(t){const f=[];for await(const d of t)f.push(d);return Promise.resolve(f)}R.asyncToArray=s})(o||(e.Iterable=o={}))}),define(Ee[165],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$un=L,e.$vn=P,e.$wn=b,e.$xn=C,e.$yn=y,e.$zn=a,e.$An=m,e.$Bn=c,e.$Cn=i,e.$Dn=n,e.$En=r,e.$Fn=s;var o;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(o||(e.ScanError=o={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function L(t,f=!1){let d=0;const u=t.length;let h="",l=0,g=16,E=0;function v(j){let N=0,T=0;for(;N<j;){const O=t.charCodeAt(d);if(O>=48&&O<=57)T=T*16+O-48;else if(O>=65&&O<=70)T=T*16+O-65+10;else if(O>=97&&O<=102)T=T*16+O-97+10;else break;d++,N++}return N<j&&(T=-1),T}function S(j){d=j,h="",l=0,g=16,E=0}function k(){const j=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&w(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&w(t.charCodeAt(d)))for(d++;d<t.length&&w(t.charCodeAt(d));)d++;else return E=3,t.substring(j,d);let N=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&w(t.charCodeAt(d))){for(d++;d<t.length&&w(t.charCodeAt(d));)d++;N=d}else E=3;return t.substring(j,N)}function D(){let j="",N=d;for(;;){if(d>=u){j+=t.substring(N,d),E=2;break}const T=t.charCodeAt(d);if(T===34){j+=t.substring(N,d),d++;break}if(T===92){if(j+=t.substring(N,d),d++,d>=u){E=2;break}switch(t.charCodeAt(d++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const z=v(4);z>=0?j+=String.fromCharCode(z):E=4;break}default:E=5}N=d;continue}if(T>=0&&T<=31)if($(T)){j+=t.substring(N,d),E=2;break}else E=6;d++}return j}function F(){if(h="",E=0,l=d,d>=u)return l=u,g=17;let j=t.charCodeAt(d);if(p(j)){do d++,h+=String.fromCharCode(j),j=t.charCodeAt(d);while(p(j));return g=15}if($(j))return d++,h+=String.fromCharCode(j),j===13&&t.charCodeAt(d)===10&&(d++,h+=`
`),g=14;switch(j){case 123:return d++,g=1;case 125:return d++,g=2;case 91:return d++,g=3;case 93:return d++,g=4;case 58:return d++,g=6;case 44:return d++,g=5;case 34:return d++,h=D(),g=10;case 47:{const N=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<u&&!$(t.charCodeAt(d));)d++;return h=t.substring(N,d),g=12}if(t.charCodeAt(d+1)===42){d+=2;const T=u-1;let O=!1;for(;d<T;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,O=!0;break}d++}return O||(d++,E=1),h=t.substring(N,d),g=13}return h+=String.fromCharCode(j),d++,g=16}case 45:if(h+=String.fromCharCode(j),d++,d===u||!w(t.charCodeAt(d)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=k(),g=11;default:for(;d<u&&W(j);)d++,j=t.charCodeAt(d);if(l!==d){switch(h=t.substring(l,d),h){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return h+=String.fromCharCode(j),d++,g=16}}function W(j){if(p(j)||$(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function B(){let j;do j=F();while(j>=12&&j<=15);return j}return{setPosition:S,getPosition:()=>d,scan:f?B:F,getToken:()=>g,getTokenValue:()=>h,getTokenOffset:()=>l,getTokenLength:()=>d-l,getTokenError:()=>E}}function p(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function P(t,f){const d=[],u=new Object;let h;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function E(v,S,k,D){l.value=v,l.offset=S,l.length=k,l.type=D,l.colonOffset=void 0,h=l}try{n(t,{onObjectBegin:(v,S)=>{if(f<=v)throw u;h=void 0,g=f>v,d.push("")},onObjectProperty:(v,S,k)=>{if(f<S||(E(v,S,k,"property"),d[d.length-1]=v,f<=S+k))throw u},onObjectEnd:(v,S)=>{if(f<=v)throw u;h=void 0,d.pop()},onArrayBegin:(v,S)=>{if(f<=v)throw u;h=void 0,d.push(0)},onArrayEnd:(v,S)=>{if(f<=v)throw u;h=void 0,d.pop()},onLiteralValue:(v,S,k)=>{if(f<S||(E(v,S,k,s(v)),f<=S+k))throw u},onSeparator:(v,S,k)=>{if(f<=S)throw u;if(v===":"&&h&&h.type==="property")h.colonOffset=S,g=!1,h=void 0;else if(v===","){const D=d[d.length-1];typeof D=="number"?d[d.length-1]=D+1:(g=!0,d[d.length-1]=""),h=void 0}}})}catch(v){if(v!==u)throw v}return{path:d,previousNode:h,isAtPropertyKey:g,matches:v=>{let S=0;for(let k=0;S<v.length&&k<d.length;k++)if(v[S]===d[k]||v[S]==="*")S++;else if(v[S]!=="**")return!1;return S===v.length}}}function b(t,f=[],d=M.DEFAULT){let u=null,h=[];const l=[];function g(v){Array.isArray(h)?h.push(v):u!==null&&(h[u]=v)}return n(t,{onObjectBegin:()=>{const v={};g(v),l.push(h),h=v,u=null},onObjectProperty:v=>{u=v},onObjectEnd:()=>{h=l.pop()},onArrayBegin:()=>{const v=[];g(v),l.push(h),h=v,u=null},onArrayEnd:()=>{h=l.pop()},onLiteralValue:g,onError:(v,S,k)=>{f.push({error:v,offset:S,length:k})}},d),h[0]}function C(t,f=[],d=M.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(v){u.type==="property"&&(u.length=v-u.offset,u=u.parent)}function l(v){return u.children.push(v),v}n(t,{onObjectBegin:v=>{u=l({type:"object",offset:v,length:-1,parent:u,children:[]})},onObjectProperty:(v,S,k)=>{u=l({type:"property",offset:S,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:v,offset:S,length:k,parent:u})},onObjectEnd:(v,S)=>{u.length=v+S-u.offset,u=u.parent,h(v+S)},onArrayBegin:(v,S)=>{u=l({type:"array",offset:v,length:-1,parent:u,children:[]})},onArrayEnd:(v,S)=>{u.length=v+S-u.offset,u=u.parent,h(v+S)},onLiteralValue:(v,S,k)=>{l({type:s(v),offset:S,length:k,parent:u,value:v}),h(S+k)},onSeparator:(v,S,k)=>{u.type==="property"&&(v===":"?u.colonOffset=S:v===","&&h(S))},onError:(v,S,k)=>{f.push({error:v,offset:S,length:k})}},d);const E=u.children[0];return E&&delete E.parent,E}function y(t,f){if(!t)return;let d=t;for(const u of f)if(typeof u=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let h=!1;for(const l of d.children)if(Array.isArray(l.children)&&l.children[0].value===u){d=l.children[1],h=!0;break}if(!h)return}else{const h=u;if(d.type!=="array"||h<0||!Array.isArray(d.children)||h>=d.children.length)return;d=d.children[h]}return d}function a(t){if(!t.parent||!t.parent.children)return[];const f=a(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;f.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&f.push(d)}return f}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const f=Object.create(null);for(const d of t.children){const u=d.children[1];u&&(f[d.children[0].value]=m(u))}return f}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function c(t,f,d=!1){return f>=t.offset&&f<t.offset+t.length||d&&f===t.offset+t.length}function i(t,f,d=!1){if(c(t,f,d)){const u=t.children;if(Array.isArray(u))for(let h=0;h<u.length&&u[h].offset<=f;h++){const l=i(u[h],f,d);if(l)return l}return t}}function n(t,f,d=M.DEFAULT){const u=L(t,!1);function h(te){return te?()=>te(u.getTokenOffset(),u.getTokenLength()):()=>!0}function l(te){return te?pe=>te(pe,u.getTokenOffset(),u.getTokenLength()):()=>!0}const g=h(f.onObjectBegin),E=l(f.onObjectProperty),v=h(f.onObjectEnd),S=h(f.onArrayBegin),k=h(f.onArrayEnd),D=l(f.onLiteralValue),F=l(f.onSeparator),W=h(f.onComment),B=l(f.onError),j=d&&d.disallowComments,N=d&&d.allowTrailingComma;function T(){for(;;){const te=u.scan();switch(u.getTokenError()){case 4:O(14);break;case 5:O(15);break;case 3:O(13);break;case 1:j||O(11);break;case 2:O(12);break;case 6:O(16);break}switch(te){case 12:case 13:j?O(10):W();break;case 16:O(1);break;case 15:case 14:break;default:return te}}}function O(te,pe=[],ye=[]){if(B(te),pe.length+ye.length>0){let _=u.getToken();for(;_!==17;){if(pe.indexOf(_)!==-1){T();break}else if(ye.indexOf(_)!==-1)break;_=T()}}}function z(te){const pe=u.getTokenValue();return te?D(pe):E(pe),T(),!0}function Q(){switch(u.getToken()){case 11:{let te=0;try{te=JSON.parse(u.getTokenValue()),typeof te!="number"&&(O(2),te=0)}catch{O(2)}D(te);break}case 7:D(null);break;case 8:D(!0);break;case 9:D(!1);break;default:return!1}return T(),!0}function Z(){return u.getToken()!==10?(O(3,[],[2,5]),!1):(z(!1),u.getToken()===6?(F(":"),T(),ce()||O(4,[],[2,5])):O(5,[],[2,5]),!0)}function J(){g(),T();let te=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(te||O(4,[],[]),F(","),T(),u.getToken()===2&&N)break}else te&&O(6,[],[]);Z()||O(4,[],[2,5]),te=!0}return v(),u.getToken()!==2?O(7,[2],[]):T(),!0}function x(){S(),T();let te=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(te||O(4,[],[]),F(","),T(),u.getToken()===4&&N)break}else te&&O(6,[],[]);ce()||O(4,[],[4,5]),te=!0}return k(),u.getToken()!==4?O(8,[4],[]):T(),!0}function ce(){switch(u.getToken()){case 3:return x();case 1:return J();case 10:return z(!0);default:return Q()}}return T(),u.getToken()===17?d.allowEmptyContent?!0:(O(4,[],[]),!1):ce()?(u.getToken()!==17&&O(9,[],[]),!0):(O(4,[],[]),!1)}function r(t,f){const d=L(t),u=[];let h,l=0,g;do switch(g=d.getPosition(),h=d.scan(),h){case 12:case 13:case 17:l!==g&&u.push(t.substring(l,g)),f!==void 0&&u.push(d.getTokenValue().replace(/[^\r\n]/g,f)),l=d.getPosition();break}while(h!==17);return u.join("")}function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Ee[46],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class o{constructor(I){this.d=I,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(I){this.c=I}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=o}),define(Ee[75],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class o{constructor(M){this.element=M,this.next=o.Undefined,this.prev=o.Undefined}}o.Undefined=new o(void 0);class R{constructor(){this.a=o.Undefined,this.b=o.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===o.Undefined}clear(){let M=this.a;for(;M!==o.Undefined;){const L=M.next;M.prev=o.Undefined,M.next=o.Undefined,M=L}this.a=o.Undefined,this.b=o.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,L){const p=new o(M);if(this.a===o.Undefined)this.a=p,this.b=p;else if(L){const w=this.b;this.b=p,p.prev=w,w.next=p}else{const w=this.a;this.a=p,p.next=w,w.prev=p}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(p))}}shift(){if(this.a!==o.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==o.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==o.Undefined&&M.next!==o.Undefined){const L=M.prev;L.next=M.next,M.next.prev=L}else M.prev===o.Undefined&&M.next===o.Undefined?(this.a=o.Undefined,this.b=o.Undefined):M.next===o.Undefined?(this.b=this.b.prev,this.b.next=o.Undefined):M.prev===o.Undefined&&(this.a=this.a.next,this.a.prev=o.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==o.Undefined;)yield M.element,M=M.next}}e.$5c=R}),define(Ee[27],Ce([1,0]),function(re,e){"use strict";var o,R,I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=M,e.$zc=L,e.$Ac=p,e.$Ic=i;function M(n,r,s){let t=n.get(r);return t===void 0&&(t=s,n.set(r,t)),t}function L(n){const r=[];return n.forEach((s,t)=>{r.push(`${t} => ${s}`)}),`Map(${n.size}) {${r.join(", ")}}`}function p(n){const r=[];return n.forEach(s=>{r.push(s)}),`Set(${n.size}) {${r.join(", ")}}`}class ${constructor(r,s){this.uri=r,this.value=s}}function w(n){return Array.isArray(n)}class A{constructor(r,s){if(this[o]="ResourceMap",r instanceof A)this.d=new Map(r.d),this.e=s??A.c;else if(w(r)){this.d=new Map,this.e=s??A.c;for(const[t,f]of r)this.set(t,f)}else this.d=new Map,this.e=r??A.c}set(r,s){return this.d.set(this.e(r),new $(r,s)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[t,f]of this.d)r(f.value,f.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(o=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Bc=A,A.c=n=>n.toString();class P{constructor(r,s){this[R]="ResourceSet",!r||typeof r=="function"?this.c=new A(r):(this.c=new A(s),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,s){this.c.forEach((t,f)=>r.call(s,f,f,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=P;var b;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class C{constructor(){this[I]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,s=0){const t=this.c.get(r);if(t)return s!==0&&this.l(t,s),t.value}set(r,s,t=0){let f=this.c.get(r);if(f)f.value=s,t!==0&&this.l(f,t);else{switch(f={key:r,value:s,next:void 0,previous:void 0},t){case 0:this.j(f);break;case 1:this.i(f);break;case 2:this.j(f);break;default:this.j(f);break}this.c.set(r,f),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this.c.get(r);if(s)return this.c.delete(r),this.k(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.k(r),this.f--,r.value}forEach(r,s){const t=this.g;let f=this.d;for(;f;){if(s?r.bind(s)(f.value,f.key,this):r(f.value,f.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const r=this,s=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:t.key,done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return f}values(){const r=this,s=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:t.value,done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return f}entries(){const r=this,s=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:[t.key,t.value],done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return f}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this.d,t=this.size;for(;s&&t>r;)this.c.delete(s.key),s=s.next,t--;this.d=s,this.f=t,s&&(s.previous=void 0),this.g++}i(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}j(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}k(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const s=r.next,t=r.previous;if(!s||!t)throw new Error("Invalid list");s.previous=t,t.next=s}r.next=void 0,r.previous=void 0,this.g++}l(r,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this.d)return;const t=r.next,f=r.previous;r===this.e?(f.next=void 0,this.e=f):(t.previous=f,f.next=t),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(s===2){if(r===this.e)return;const t=r.next,f=r.previous;r===this.d?(t.previous=void 0,this.d=t):(t.previous=f,f.next=t),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((s,t)=>{r.push([t,s])}),r}fromJSON(r){this.clear();for(const[s,t]of r)this.set(s,t)}}e.$Dc=C;class y extends C{constructor(r,s=1){super(),this.m=r,this.n=Math.min(Math.max(0,s),1)}get limit(){return this.m}set limit(r){this.m=r,this.o()}get ratio(){return this.n}set ratio(r){this.n=Math.min(Math.max(0,r),1),this.o()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=y;class a{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let s=this.c.get(r)||0;return s===0?!1:(s--,s===0?this.c.delete(r):this.c.set(r,s),!0)}has(r){return this.c.has(r)}}e.$Fc=a;class m{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[s,t]of r)this.set(s,t)}clear(){this.c.clear(),this.d.clear()}set(r,s){this.c.set(r,s),this.d.set(s,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const s=this.c.get(r);return s===void 0?!1:(this.c.delete(r),this.d.delete(s),!0)}forEach(r,s){this.c.forEach((t,f)=>{r.call(s,t,f,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=m;class c{constructor(){this.c=new Map}add(r,s){let t=this.c.get(r);t||(t=new Set,this.c.set(r,t)),t.add(s)}delete(r,s){const t=this.c.get(r);t&&(t.delete(s),t.size===0&&this.c.delete(r))}forEach(r,s){const t=this.c.get(r);t&&t.forEach(s)}get(r){const s=this.c.get(r);return s||new Set}}e.$Hc=c;function i(n,r){if(n===r)return!0;if(n.size!==r.size)return!1;for(const[s,t]of n)if(!r.has(s)||r.get(s)!==t)return!1;for(const[s]of r)if(!n.has(s))return!1;return!0}}),define(Ee[3],Ce([1,0,19,73,27,74,39]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=A,e.$Lc=P,e.$Mc=b,e.$Nc=a,e.$Oc=m,e.$Pc=c,e.$Qc=i,e.$Rc=n,e.$Sc=r,e.$3c=v;const p=!1;let $=null;class w{constructor(){this.b=new Map}c(D){let F=this.b.get(D);return F||(F={parent:null,source:null,isSingleton:!1,value:D,idx:w.a++},this.b.set(D,F)),F}trackDisposable(D){const F=this.c(D);F.source||(F.source=new Error().stack)}setParent(D,F){const W=this.c(D);W.parent=F}markAsDisposed(D){this.b.delete(D)}markAsSingleton(D){this.c(D).isSingleton=!0}f(D,F){const W=F.get(D);if(W)return W;const B=D.parent?this.f(this.c(D.parent),F):D;return F.set(D,B),B}getTrackedDisposables(){const D=new Map;return[...this.b.entries()].filter(([,W])=>W.source!==null&&!this.f(W,D).isSingleton).flatMap(([W])=>W)}computeLeakingDisposables(D=10,F){let W;if(F)W=F;else{const O=new Map,z=[...this.b.values()].filter(Z=>Z.source!==null&&!this.f(Z,O).isSingleton);if(z.length===0)return;const Q=new Set(z.map(Z=>Z.value));if(W=z.filter(Z=>!(Z.parent&&Q.has(Z.parent))),W.length===0)throw new Error("There are cyclic diposable chains!")}if(!W)return;function B(O){function z(Z,J){for(;Z.length>0&&J.some(x=>typeof x=="string"?x===Z[0]:Z[0].match(x));)Z.shift()}const Q=O.source.split(`
`).map(Z=>Z.trim().replace("at ","")).filter(Z=>Z!=="");return z(Q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Q.reverse()}const j=new I.$Hc;for(const O of W){const z=B(O);for(let Q=0;Q<=z.length;Q++)j.add(z.slice(0,Q).join(`
`),O)}W.sort((0,o.$7b)(O=>O.idx,o.$9b));let N="",T=0;for(const O of W.slice(0,D)){T++;const z=B(O),Q=[];for(let Z=0;Z<z.length;Z++){let J=z[Z];J=`(shared with ${j.get(z.slice(0,Z+1).join(`
`)).size}/${W.length} leaks) at ${J}`;const ce=j.get(z.slice(0,Z).join(`
`)),te=(0,R.$E)([...ce].map(pe=>B(pe)[Z]),pe=>pe);delete te[z[Z]];for(const[pe,ye]of Object.entries(te))Q.unshift(`    - stacktraces of ${ye.length} other leaks continue with ${pe}`);Q.unshift(J)}N+=`


==================== Leaking disposable ${T}/${W.length}: ${O.value.constructor.name} ====================
${Q.join(`
`)}
============================================================

`}return W.length>D&&(N+=`


... and ${W.length-D} more leaking disposables

`),{leaks:W,details:N}}}e.$Jc=w,w.a=0;function A(k){$=k}if(p){const k="__is_disposable_tracked__";A(new class{trackDisposable(D){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{D[k]||console.log(F)},3e3)}setParent(D,F){if(D&&D!==t.None)try{D[k]=!0}catch{}}markAsDisposed(D){if(D&&D!==t.None)try{D[k]=!0}catch{}}markAsSingleton(D){}})}function P(k){return $?.trackDisposable(k),k}function b(k){$?.markAsDisposed(k)}function C(k,D){$?.setParent(k,D)}function y(k,D){if($)for(const F of k)$.setParent(F,D)}function a(k){return $?.markAsSingleton(k),k}function m(k){return typeof k.dispose=="function"&&k.dispose.length===0}function c(k){if(L.Iterable.is(k)){const D=[];for(const F of k)if(F)try{F.dispose()}catch(W){D.push(W)}if(D.length===1)throw D[0];if(D.length>1)throw new AggregateError(D,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}function i(k){for(const D of k)m(D)&&D.dispose();return[]}function n(...k){const D=r(()=>c(k));return y(k,D),D}function r(k){const D=P({dispose:(0,M.$db)(()=>{b(D),k()})});return D}class s{constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{c(this.f)}finally{this.f.clear()}}add(D){if(!D)return D;if(D===this)throw new Error("Cannot register a disposable on itself!");return C(D,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(D),D}delete(D){if(D){if(D===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(D),D.dispose()}}deleteAndLeak(D){D&&this.f.has(D)&&(this.f.delete(D),C(D,null))}}e.$Tc=s,s.DISABLE_DISPOSED_WARNING=!1;class t{constructor(){this.q=new s,P(this),C(this.q,this)}dispose(){b(this),this.q.dispose()}B(D){if(D===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(D)}}e.$Uc=t,t.None=Object.freeze({dispose(){}});class f{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(D){this.b||D===this.a||(this.a?.dispose(),D&&C(D,this),this.a=D)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const D=this.a;return this.a=void 0,D&&C(D,null),D}}e.$Vc=f;class d{constructor(D){this.a=new f,this.b=!1,this.a.value=D}get value(){return this.a.value}set value(D){this.b||D===this.a.value||(this.a.value=D)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=d;class u{constructor(D){this.b=D,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=u;class h{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(D){let F=D;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,b(this))},this}}e.$Yc=h;class l{constructor(){this.a=new Map}acquire(D,...F){let W=this.a.get(D);W||(W={counter:0,object:this.b(D,...F)},this.a.set(D,W));const{object:B}=W,j=(0,M.$db)(()=>{--W.counter===0&&(this.c(D,W.object),this.a.delete(D))});return W.counter++,{object:B,dispose:j}}}e.$Zc=l;class g{constructor(D){this.a=D}async acquire(D,...F){const W=this.a.acquire(D,...F);try{return{object:await W.object,dispose:()=>W.dispose()}}catch(B){throw W.dispose(),B}}}e.$1c=g;class E{constructor(D){this.object=D}dispose(){}}e.$2c=E;function v(k){const D=new s;try{k(D)}finally{D.dispose()}}class S{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{c(this.a.values())}finally{this.a.clear()}}has(D){return this.a.has(D)}get size(){return this.a.size}get(D){return this.a.get(D)}set(D,F,W=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),W||this.a.get(D)?.dispose(),this.a.set(D,F)}deleteAndDispose(D){this.a.get(D)?.dispose(),this.a.delete(D)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=S}),function(re,e){typeof define=="function"&&define.amd?define(Ee[166],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(re=typeof globalThis<"u"?globalThis:re||self,e(re.marked={}))}(this,function(re){"use strict";function e(ie,se){for(var oe=0;oe<se.length;oe++){var G=se[oe];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(ie,G.key,G)}}function o(ie,se,oe){return se&&e(ie.prototype,se),oe&&e(ie,oe),Object.defineProperty(ie,"prototype",{writable:!1}),ie}function R(ie,se){if(ie){if(typeof ie=="string")return I(ie,se);var oe=Object.prototype.toString.call(ie).slice(8,-1);if(oe==="Object"&&ie.constructor&&(oe=ie.constructor.name),oe==="Map"||oe==="Set")return Array.from(ie);if(oe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(oe))return I(ie,se)}}function I(ie,se){(se==null||se>ie.length)&&(se=ie.length);for(var oe=0,G=new Array(se);oe<se;oe++)G[oe]=ie[oe];return G}function M(ie,se){var oe=typeof Symbol<"u"&&ie[Symbol.iterator]||ie["@@iterator"];if(oe)return(oe=oe.call(ie)).next.bind(oe);if(Array.isArray(ie)||(oe=R(ie))||se&&ie&&typeof ie.length=="number"){oe&&(ie=oe);var G=0;return function(){return G>=ie.length?{done:!0}:{done:!1,value:ie[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=L();function p(ie){re.defaults=ie}var $=/[&<>"']/,w=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},C=function(se){return b[se]};function y(ie,se){if(se){if($.test(ie))return ie.replace(w,C)}else if(A.test(ie))return ie.replace(P,C);return ie}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(ie){return ie.replace(a,function(se,oe){return oe=oe.toLowerCase(),oe==="colon"?":":oe.charAt(0)==="#"?oe.charAt(1)==="x"?String.fromCharCode(parseInt(oe.substring(2),16)):String.fromCharCode(+oe.substring(1)):""})}var c=/(^|[^\[])\^/g;function i(ie,se){ie=typeof ie=="string"?ie:ie.source,se=se||"";var oe={replace:function(ee,le){return le=le.source||le,le=le.replace(c,"$1"),ie=ie.replace(ee,le),oe},getRegex:function(){return new RegExp(ie,se)}};return oe}var n=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function s(ie,se,oe){if(ie){var G;try{G=decodeURIComponent(m(oe)).replace(n,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}se&&!r.test(oe)&&(oe=h(se,oe));try{oe=encodeURI(oe).replace(/%25/g,"%")}catch{return null}return oe}var t={},f=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function h(ie,se){t[" "+ie]||(f.test(ie)?t[" "+ie]=ie+"/":t[" "+ie]=v(ie,"/",!0)),ie=t[" "+ie];var oe=ie.indexOf(":")===-1;return se.substring(0,2)==="//"?oe?se:ie.replace(d,"$1")+se:se.charAt(0)==="/"?oe?se:ie.replace(u,"$1")+se:ie+se}var l={exec:function(){}};function g(ie){for(var se=1,oe,G;se<arguments.length;se++){oe=arguments[se];for(G in oe)Object.prototype.hasOwnProperty.call(oe,G)&&(ie[G]=oe[G])}return ie}function E(ie,se){var oe=ie.replace(/\|/g,function(le,de,Me){for(var be=!1,Pe=de;--Pe>=0&&Me[Pe]==="\\";)be=!be;return be?"|":" |"}),G=oe.split(/ \|/),ee=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>se)G.splice(se);else for(;G.length<se;)G.push("");for(;ee<G.length;ee++)G[ee]=G[ee].trim().replace(/\\\|/g,"|");return G}function v(ie,se,oe){var G=ie.length;if(G===0)return"";for(var ee=0;ee<G;){var le=ie.charAt(G-ee-1);if(le===se&&!oe)ee++;else if(le!==se&&oe)ee++;else break}return ie.slice(0,G-ee)}function S(ie,se){if(ie.indexOf(se[1])===-1)return-1;for(var oe=ie.length,G=0,ee=0;ee<oe;ee++)if(ie[ee]==="\\")ee++;else if(ie[ee]===se[0])G++;else if(ie[ee]===se[1]&&(G--,G<0))return ee;return-1}function k(ie){ie&&ie.sanitize&&!ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function D(ie,se){if(se<1)return"";for(var oe="";se>1;)se&1&&(oe+=ie),se>>=1,ie+=ie;return oe+ie}function F(ie,se,oe,G){var ee=se.href,le=se.title?y(se.title):null,de=ie[1].replace(/\\([\[\]])/g,"$1");if(ie[0].charAt(0)!=="!"){G.state.inLink=!0;var Me={type:"link",raw:oe,href:ee,title:le,text:de,tokens:G.inlineTokens(de)};return G.state.inLink=!1,Me}return{type:"image",raw:oe,href:ee,title:le,text:y(de)}}function W(ie,se){var oe=ie.match(/^(\s+)(?:```)/);if(oe===null)return se;var G=oe[1];return se.split(`
`).map(function(ee){var le=ee.match(/^\s+/);if(le===null)return ee;var de=le[0];return de.length>=G.length?ee.slice(G.length):ee}).join(`
`)}var B=function(){function ie(oe){this.options=oe||re.defaults}var se=ie.prototype;return se.space=function(G){var ee=this.rules.block.newline.exec(G);if(ee&&ee[0].length>0)return{type:"space",raw:ee[0]}},se.code=function(G){var ee=this.rules.block.code.exec(G);if(ee){var le=ee[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ee[0],codeBlockStyle:"indented",text:this.options.pedantic?le:v(le,`
`)}}},se.fences=function(G){var ee=this.rules.block.fences.exec(G);if(ee){var le=ee[0],de=W(le,ee[3]||"");return{type:"code",raw:le,lang:ee[2]?ee[2].trim():ee[2],text:de}}},se.heading=function(G){var ee=this.rules.block.heading.exec(G);if(ee){var le=ee[2].trim();if(/#$/.test(le)){var de=v(le,"#");(this.options.pedantic||!de||/ $/.test(de))&&(le=de.trim())}return{type:"heading",raw:ee[0],depth:ee[1].length,text:le,tokens:this.lexer.inline(le)}}},se.hr=function(G){var ee=this.rules.block.hr.exec(G);if(ee)return{type:"hr",raw:ee[0]}},se.blockquote=function(G){var ee=this.rules.block.blockquote.exec(G);if(ee){var le=ee[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ee[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},se.list=function(G){var ee=this.rules.block.list.exec(G);if(ee){var le,de,Me,be,Pe,Re,ze,V,H,Y,X,fe,we=ee[1].trim(),Te=we.length>1,Ve={type:"list",raw:"",ordered:Te,start:Te?+we.slice(0,-1):"",loose:!1,items:[]};we=Te?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Te?we:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(fe=!1,!(!(ee=Ye.exec(G))||this.rules.block.hr.test(G)));){if(le=ee[0],G=G.substring(le.length),V=ee[2].split(`
`,1)[0],H=G.split(`
`,1)[0],this.options.pedantic?(be=2,X=V.trimLeft()):(be=ee[2].search(/[^ ]/),be=be>4?1:be,X=V.slice(be),be+=ee[1].length),Re=!1,!V&&/^ *$/.test(H)&&(le+=H+`
`,G=G.substring(H.length+1),fe=!0),!fe)for(var nt=new RegExp("^ {0,"+Math.min(3,be-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ot=new RegExp("^ {0,"+Math.min(3,be-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),lt=new RegExp("^ {0,"+Math.min(3,be-1)+"}(?:```|~~~)"),at=new RegExp("^ {0,"+Math.min(3,be-1)+"}#");G&&(Y=G.split(`
`,1)[0],V=Y,this.options.pedantic&&(V=V.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(lt.test(V)||at.test(V)||nt.test(V)||ot.test(G)));){if(V.search(/[^ ]/)>=be||!V.trim())X+=`
`+V.slice(be);else if(!Re)X+=`
`+V;else break;!Re&&!V.trim()&&(Re=!0),le+=Y+`
`,G=G.substring(Y.length+1)}Ve.loose||(ze?Ve.loose=!0:/\n *\n *$/.test(le)&&(ze=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(X),de&&(Me=de[0]!=="[ ] ",X=X.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:le,task:!!de,checked:Me,loose:!1,text:X}),Ve.raw+=le}Ve.items[Ve.items.length-1].raw=le.trimRight(),Ve.items[Ve.items.length-1].text=X.trimRight(),Ve.raw=Ve.raw.trimRight();var st=Ve.items.length;for(Pe=0;Pe<st;Pe++){this.lexer.state.top=!1,Ve.items[Pe].tokens=this.lexer.blockTokens(Ve.items[Pe].text,[]);var Ie=Ve.items[Pe].tokens.filter(function(Ae){return Ae.type==="space"}),We=Ie.every(function(Ae){for(var Ke=Ae.raw.split(""),ae=0,ue=M(Ke),De;!(De=ue()).done;){var Je=De.value;if(Je===`
`&&(ae+=1),ae>1)return!0}return!1});!Ve.loose&&Ie.length&&We&&(Ve.loose=!0,Ve.items[Pe].loose=!0)}return Ve}},se.html=function(G){var ee=this.rules.block.html.exec(G);if(ee){var le={type:"html",raw:ee[0],pre:!this.options.sanitizer&&(ee[1]==="pre"||ee[1]==="script"||ee[1]==="style"),text:ee[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(ee[0]):y(ee[0]);le.type="paragraph",le.text=de,le.tokens=this.lexer.inline(de)}return le}},se.def=function(G){var ee=this.rules.block.def.exec(G);if(ee){ee[3]&&(ee[3]=ee[3].substring(1,ee[3].length-1));var le=ee[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:ee[0],href:ee[2],title:ee[3]}}},se.table=function(G){var ee=this.rules.block.table.exec(G);if(ee){var le={type:"table",header:E(ee[1]).map(function(ze){return{text:ze}}),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ee[3]&&ee[3].trim()?ee[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=ee[0];var de=le.align.length,Me,be,Pe,Re;for(Me=0;Me<de;Me++)/^ *-+: *$/.test(le.align[Me])?le.align[Me]="right":/^ *:-+: *$/.test(le.align[Me])?le.align[Me]="center":/^ *:-+ *$/.test(le.align[Me])?le.align[Me]="left":le.align[Me]=null;for(de=le.rows.length,Me=0;Me<de;Me++)le.rows[Me]=E(le.rows[Me],le.header.length).map(function(ze){return{text:ze}});for(de=le.header.length,be=0;be<de;be++)le.header[be].tokens=this.lexer.inline(le.header[be].text);for(de=le.rows.length,be=0;be<de;be++)for(Re=le.rows[be],Pe=0;Pe<Re.length;Pe++)Re[Pe].tokens=this.lexer.inline(Re[Pe].text);return le}}},se.lheading=function(G){var ee=this.rules.block.lheading.exec(G);if(ee)return{type:"heading",raw:ee[0],depth:ee[2].charAt(0)==="="?1:2,text:ee[1],tokens:this.lexer.inline(ee[1])}},se.paragraph=function(G){var ee=this.rules.block.paragraph.exec(G);if(ee){var le=ee[1].charAt(ee[1].length-1)===`
`?ee[1].slice(0,-1):ee[1];return{type:"paragraph",raw:ee[0],text:le,tokens:this.lexer.inline(le)}}},se.text=function(G){var ee=this.rules.block.text.exec(G);if(ee)return{type:"text",raw:ee[0],text:ee[0],tokens:this.lexer.inline(ee[0])}},se.escape=function(G){var ee=this.rules.inline.escape.exec(G);if(ee)return{type:"escape",raw:ee[0],text:y(ee[1])}},se.tag=function(G){var ee=this.rules.inline.tag.exec(G);if(ee)return!this.lexer.state.inLink&&/^<a /i.test(ee[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ee[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):y(ee[0]):ee[0]}},se.link=function(G){var ee=this.rules.inline.link.exec(G);if(ee){var le=ee[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var de=v(le.slice(0,-1),"\\");if((le.length-de.length)%2===0)return}else{var Me=S(ee[2],"()");if(Me>-1){var be=ee[0].indexOf("!")===0?5:4,Pe=be+ee[1].length+Me;ee[2]=ee[2].substring(0,Me),ee[0]=ee[0].substring(0,Pe).trim(),ee[3]=""}}var Re=ee[2],ze="";if(this.options.pedantic){var V=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);V&&(Re=V[1],ze=V[3])}else ze=ee[3]?ee[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(le)?Re=Re.slice(1):Re=Re.slice(1,-1)),F(ee,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},ee[0],this.lexer)}},se.reflink=function(G,ee){var le;if((le=this.rules.inline.reflink.exec(G))||(le=this.rules.inline.nolink.exec(G))){var de=(le[2]||le[1]).replace(/\s+/g," ");if(de=ee[de.toLowerCase()],!de||!de.href){var Me=le[0].charAt(0);return{type:"text",raw:Me,text:Me}}return F(le,de,le[0],this.lexer)}},se.emStrong=function(G,ee,le){le===void 0&&(le="");var de=this.rules.inline.emStrong.lDelim.exec(G);if(de&&!(de[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=de[1]||de[2]||"";if(!Me||Me&&(le===""||this.rules.inline.punctuation.exec(le))){var be=de[0].length-1,Pe,Re,ze=be,V=0,H=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,ee=ee.slice(-1*G.length+be);(de=H.exec(ee))!=null;)if(Pe=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!Pe){if(Re=Pe.length,de[3]||de[4]){ze+=Re;continue}else if((de[5]||de[6])&&be%3&&!((be+Re)%3)){V+=Re;continue}if(ze-=Re,!(ze>0)){if(Re=Math.min(Re,Re+ze+V),Math.min(be,Re)%2){var Y=G.slice(1,be+de.index+Re);return{type:"em",raw:G.slice(0,be+de.index+Re+1),text:Y,tokens:this.lexer.inlineTokens(Y)}}var X=G.slice(2,be+de.index+Re-1);return{type:"strong",raw:G.slice(0,be+de.index+Re+1),text:X,tokens:this.lexer.inlineTokens(X)}}}}}},se.codespan=function(G){var ee=this.rules.inline.code.exec(G);if(ee){var le=ee[2].replace(/\n/g," "),de=/[^ ]/.test(le),Me=/^ /.test(le)&&/ $/.test(le);return de&&Me&&(le=le.substring(1,le.length-1)),le=y(le,!0),{type:"codespan",raw:ee[0],text:le}}},se.br=function(G){var ee=this.rules.inline.br.exec(G);if(ee)return{type:"br",raw:ee[0]}},se.del=function(G){var ee=this.rules.inline.del.exec(G);if(ee)return{type:"del",raw:ee[0],text:ee[2],tokens:this.lexer.inlineTokens(ee[2])}},se.autolink=function(G,ee){var le=this.rules.inline.autolink.exec(G);if(le){var de,Me;return le[2]==="@"?(de=y(this.options.mangle?ee(le[1]):le[1]),Me="mailto:"+de):(de=y(le[1]),Me=de),{type:"link",raw:le[0],text:de,href:Me,tokens:[{type:"text",raw:de,text:de}]}}},se.url=function(G,ee){var le;if(le=this.rules.inline.url.exec(G)){var de,Me;if(le[2]==="@")de=y(this.options.mangle?ee(le[0]):le[0]),Me="mailto:"+de;else{var be;do be=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(be!==le[0]);de=y(le[0]),le[1]==="www."?Me="http://"+de:Me=de}return{type:"link",raw:le[0],text:de,href:Me,tokens:[{type:"text",raw:de,text:de}]}}},se.inlineText=function(G,ee){var le=this.rules.inline.text.exec(G);if(le){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):y(le[0]):le[0]:de=y(this.options.smartypants?ee(le[0]):le[0]),{type:"text",raw:le[0],text:de}}},ie}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=i(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=i(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=i(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=i(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=i(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=i(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=g({},j),j.gfm=g({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=i(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=i(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=g({},j.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:i(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=i(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=i(j._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=i(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=i(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=i(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=i(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=i(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=i(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=i(N.reflink).replace("label",N._label).replace("ref",j._label).getRegex(),N.nolink=i(N.nolink).replace("ref",j._label).getRegex(),N.reflinkSearch=i(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=g({},N),N.pedantic=g({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=g({},N.normal,{escape:i(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=i(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=g({},N.gfm,{br:i(N.br).replace("{2,}","*").getRegex(),text:i(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(ie){return ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function O(ie){var se="",oe,G,ee=ie.length;for(oe=0;oe<ee;oe++)G=ie.charCodeAt(oe),Math.random()>.5&&(G="x"+G.toString(16)),se+="&#"+G+";";return se}var z=function(){function ie(oe){this.tokens=[],this.tokens.links=Object.create(null),this.options=oe||re.defaults,this.options.tokenizer=this.options.tokenizer||new B,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:j.normal,inline:N.normal};this.options.pedantic?(G.block=j.pedantic,G.inline=N.pedantic):this.options.gfm&&(G.block=j.gfm,this.options.breaks?G.inline=N.breaks:G.inline=N.gfm),this.tokenizer.rules=G}ie.lex=function(G,ee){var le=new ie(ee);return le.lex(G)},ie.lexInline=function(G,ee){var le=new ie(ee);return le.inlineTokens(G)};var se=ie.prototype;return se.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var ee;ee=this.inlineQueue.shift();)this.inlineTokens(ee.src,ee.tokens);return this.tokens},se.blockTokens=function(G,ee){var le=this;ee===void 0&&(ee=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(ze,V,H){return V+"    ".repeat(H.length)});for(var de,Me,be,Pe;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(de=ze.call({lexer:le},G,ee))?(G=G.substring(de.raw.length),ee.push(de),!0):!1}))){if(de=this.tokenizer.space(G)){G=G.substring(de.raw.length),de.raw.length===1&&ee.length>0?ee[ee.length-1].raw+=`
`:ee.push(de);continue}if(de=this.tokenizer.code(G)){G=G.substring(de.raw.length),Me=ee[ee.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+de.raw,Me.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ee.push(de);continue}if(de=this.tokenizer.fences(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.heading(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.hr(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.blockquote(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.list(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.html(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.def(G)){G=G.substring(de.raw.length),Me=ee[ee.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+de.raw,Me.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.lheading(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(be=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,V=G.slice(1),H=void 0;le.options.extensions.startBlock.forEach(function(Y){H=Y.call({lexer:this},V),typeof H=="number"&&H>=0&&(ze=Math.min(ze,H))}),ze<1/0&&ze>=0&&(be=G.substring(0,ze+1))}(),this.state.top&&(de=this.tokenizer.paragraph(be))){Me=ee[ee.length-1],Pe&&Me.type==="paragraph"?(Me.raw+=`
`+de.raw,Me.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ee.push(de),Pe=be.length!==G.length,G=G.substring(de.raw.length);continue}if(de=this.tokenizer.text(G)){G=G.substring(de.raw.length),Me=ee[ee.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+de.raw,Me.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ee.push(de);continue}if(G){var Re="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,ee},se.inline=function(G,ee){return ee===void 0&&(ee=[]),this.inlineQueue.push({src:G,tokens:ee}),ee},se.inlineTokens=function(G,ee){var le=this;ee===void 0&&(ee=[]);var de,Me,be,Pe=G,Re,ze,V;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)H.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Re.index)+"["+D("a",Re[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Re.index)+"["+D("a",Re[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Re.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(ze||(V=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(X){return(de=X.call({lexer:le},G,ee))?(G=G.substring(de.raw.length),ee.push(de),!0):!1}))){if(de=this.tokenizer.escape(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.tag(G)){G=G.substring(de.raw.length),Me=ee[ee.length-1],Me&&de.type==="text"&&Me.type==="text"?(Me.raw+=de.raw,Me.text+=de.text):ee.push(de);continue}if(de=this.tokenizer.link(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(de.raw.length),Me=ee[ee.length-1],Me&&de.type==="text"&&Me.type==="text"?(Me.raw+=de.raw,Me.text+=de.text):ee.push(de);continue}if(de=this.tokenizer.emStrong(G,Pe,V)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.codespan(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.br(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.del(G)){G=G.substring(de.raw.length),ee.push(de);continue}if(de=this.tokenizer.autolink(G,O)){G=G.substring(de.raw.length),ee.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(G,O))){G=G.substring(de.raw.length),ee.push(de);continue}if(be=G,this.options.extensions&&this.options.extensions.startInline&&function(){var X=1/0,fe=G.slice(1),we=void 0;le.options.extensions.startInline.forEach(function(Te){we=Te.call({lexer:this},fe),typeof we=="number"&&we>=0&&(X=Math.min(X,we))}),X<1/0&&X>=0&&(be=G.substring(0,X+1))}(),de=this.tokenizer.inlineText(be,T)){G=G.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(V=de.raw.slice(-1)),ze=!0,Me=ee[ee.length-1],Me&&Me.type==="text"?(Me.raw+=de.raw,Me.text+=de.text):ee.push(de);continue}if(G){var Y="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(Y);break}else throw new Error(Y)}}return ee},o(ie,null,[{key:"rules",get:function(){return{block:j,inline:N}}}]),ie}(),Q=function(){function ie(oe){this.options=oe||re.defaults}var se=ie.prototype;return se.code=function(G,ee,le){var de=(ee||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(G,de);Me!=null&&Me!==G&&(le=!0,G=Me)}return G=G.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+y(de,!0)+'">'+(le?G:y(G,!0))+`</code></pre>
`:"<pre><code>"+(le?G:y(G,!0))+`</code></pre>
`},se.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},se.html=function(G){return G},se.heading=function(G,ee,le,de){if(this.options.headerIds){var Me=this.options.headerPrefix+de.slug(le);return"<h"+ee+' id="'+Me+'">'+G+"</h"+ee+`>
`}return"<h"+ee+">"+G+"</h"+ee+`>
`},se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},se.list=function(G,ee,le){var de=ee?"ol":"ul",Me=ee&&le!==1?' start="'+le+'"':"";return"<"+de+Me+`>
`+G+"</"+de+`>
`},se.listitem=function(G){return"<li>"+G+`</li>
`},se.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},se.paragraph=function(G){return"<p>"+G+`</p>
`},se.table=function(G,ee){return ee&&(ee="<tbody>"+ee+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+ee+`</table>
`},se.tablerow=function(G){return`<tr>
`+G+`</tr>
`},se.tablecell=function(G,ee){var le=ee.header?"th":"td",de=ee.align?"<"+le+' align="'+ee.align+'">':"<"+le+">";return de+G+("</"+le+`>
`)},se.strong=function(G){return"<strong>"+G+"</strong>"},se.em=function(G){return"<em>"+G+"</em>"},se.codespan=function(G){return"<code>"+G+"</code>"},se.br=function(){return this.options.xhtml?"<br/>":"<br>"},se.del=function(G){return"<del>"+G+"</del>"},se.link=function(G,ee,le){if(G=s(this.options.sanitize,this.options.baseUrl,G),G===null)return le;var de='<a href="'+y(G)+'"';return ee&&(de+=' title="'+ee+'"'),de+=">"+le+"</a>",de},se.image=function(G,ee,le){if(G=s(this.options.sanitize,this.options.baseUrl,G),G===null)return le;var de='<img src="'+G+'" alt="'+le+'"';return ee&&(de+=' title="'+ee+'"'),de+=this.options.xhtml?"/>":">",de},se.text=function(G){return G},ie}(),Z=function(){function ie(){}var se=ie.prototype;return se.strong=function(G){return G},se.em=function(G){return G},se.codespan=function(G){return G},se.del=function(G){return G},se.html=function(G){return G},se.text=function(G){return G},se.link=function(G,ee,le){return""+le},se.image=function(G,ee,le){return""+le},se.br=function(){return""},ie}(),J=function(){function ie(){this.seen={}}var se=ie.prototype;return se.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},se.getNextSafeSlug=function(G,ee){var le=G,de=0;if(this.seen.hasOwnProperty(le)){de=this.seen[G];do de++,le=G+"-"+de;while(this.seen.hasOwnProperty(le))}return ee||(this.seen[G]=de,this.seen[le]=0),le},se.slug=function(G,ee){ee===void 0&&(ee={});var le=this.serialize(G);return this.getNextSafeSlug(le,ee.dryrun)},ie}(),x=function(){function ie(oe){this.options=oe||re.defaults,this.options.renderer=this.options.renderer||new Q,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Z,this.slugger=new J}ie.parse=function(G,ee){var le=new ie(ee);return le.parse(G)},ie.parseInline=function(G,ee){var le=new ie(ee);return le.parseInline(G)};var se=ie.prototype;return se.parse=function(G,ee){ee===void 0&&(ee=!0);var le="",de,Me,be,Pe,Re,ze,V,H,Y,X,fe,we,Te,Ve,Ye,nt,ot,lt,at,st=G.length;for(de=0;de<st;de++){if(X=G[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[X.type]&&(at=this.options.extensions.renderers[X.type].call({parser:this},X),at!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(X.type))){le+=at||"";continue}switch(X.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(X.tokens),X.depth,m(this.parseInline(X.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(X.text,X.lang,X.escaped);continue}case"table":{for(H="",V="",Pe=X.header.length,Me=0;Me<Pe;Me++)V+=this.renderer.tablecell(this.parseInline(X.header[Me].tokens),{header:!0,align:X.align[Me]});for(H+=this.renderer.tablerow(V),Y="",Pe=X.rows.length,Me=0;Me<Pe;Me++){for(ze=X.rows[Me],V="",Re=ze.length,be=0;be<Re;be++)V+=this.renderer.tablecell(this.parseInline(ze[be].tokens),{header:!1,align:X.align[be]});Y+=this.renderer.tablerow(V)}le+=this.renderer.table(H,Y);continue}case"blockquote":{Y=this.parse(X.tokens),le+=this.renderer.blockquote(Y);continue}case"list":{for(fe=X.ordered,we=X.start,Te=X.loose,Pe=X.items.length,Y="",Me=0;Me<Pe;Me++)Ye=X.items[Me],nt=Ye.checked,ot=Ye.task,Ve="",Ye.task&&(lt=this.renderer.checkbox(nt),Te?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=lt+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=lt+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:lt}):Ve+=lt),Ve+=this.parse(Ye.tokens,Te),Y+=this.renderer.listitem(Ve,ot,nt);le+=this.renderer.list(Y,fe,we);continue}case"html":{le+=this.renderer.html(X.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(X.tokens));continue}case"text":{for(Y=X.tokens?this.parseInline(X.tokens):X.text;de+1<st&&G[de+1].type==="text";)X=G[++de],Y+=`
`+(X.tokens?this.parseInline(X.tokens):X.text);le+=ee?this.renderer.paragraph(Y):Y;continue}default:{var Ie='Token with "'+X.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return le},se.parseInline=function(G,ee){ee=ee||this.renderer;var le="",de,Me,be,Pe=G.length;for(de=0;de<Pe;de++){if(Me=G[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(be=this.options.extensions.renderers[Me.type].call({parser:this},Me),be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){le+=be||"";continue}switch(Me.type){case"escape":{le+=ee.text(Me.text);break}case"html":{le+=ee.html(Me.text);break}case"link":{le+=ee.link(Me.href,Me.title,this.parseInline(Me.tokens,ee));break}case"image":{le+=ee.image(Me.href,Me.title,Me.text);break}case"strong":{le+=ee.strong(this.parseInline(Me.tokens,ee));break}case"em":{le+=ee.em(this.parseInline(Me.tokens,ee));break}case"codespan":{le+=ee.codespan(Me.text);break}case"br":{le+=ee.br();break}case"del":{le+=ee.del(this.parseInline(Me.tokens,ee));break}case"text":{le+=ee.text(Me.text);break}default:{var Re='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return le},ie}();function ce(ie,se,oe){if(typeof ie>"u"||ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");if(typeof se=="function"&&(oe=se,se=null),se=g({},ce.defaults,se||{}),k(se),oe){var G=se.highlight,ee;try{ee=z.lex(ie,se)}catch(Pe){return oe(Pe)}var le=function(Re){var ze;if(!Re)try{se.walkTokens&&ce.walkTokens(ee,se.walkTokens),ze=x.parse(ee,se)}catch(V){Re=V}return se.highlight=G,Re?oe(Re):oe(null,ze)};if(!G||G.length<3||(delete se.highlight,!ee.length))return le();var de=0;ce.walkTokens(ee,function(Pe){Pe.type==="code"&&(de++,setTimeout(function(){G(Pe.text,Pe.lang,function(Re,ze){if(Re)return le(Re);ze!=null&&ze!==Pe.text&&(Pe.text=ze,Pe.escaped=!0),de--,de===0&&le()})},0))}),de===0&&le();return}function Me(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+y(Pe.message+"",!0)+"</pre>";throw Pe}try{var be=z.lex(ie,se);if(se.walkTokens){if(se.async)return Promise.all(ce.walkTokens(be,se.walkTokens)).then(function(){return x.parse(be,se)}).catch(Me);ce.walkTokens(be,se.walkTokens)}return x.parse(be,se)}catch(Pe){Me(Pe)}}ce.options=ce.setOptions=function(ie){return g(ce.defaults,ie),p(ce.defaults),ce},ce.getDefaults=L,ce.defaults=re.defaults,ce.use=function(){for(var ie=arguments.length,se=new Array(ie),oe=0;oe<ie;oe++)se[oe]=arguments[oe];var G=g.apply(void 0,[{}].concat(se)),ee=ce.defaults.extensions||{renderers:{},childTokens:{}},le;se.forEach(function(de){if(de.extensions&&(le=!0,de.extensions.forEach(function(be){if(!be.name)throw new Error("extension name required");if(be.renderer){var Pe=ee.renderers?ee.renderers[be.name]:null;Pe?ee.renderers[be.name]=function(){for(var Re=arguments.length,ze=new Array(Re),V=0;V<Re;V++)ze[V]=arguments[V];var H=be.renderer.apply(this,ze);return H===!1&&(H=Pe.apply(this,ze)),H}:ee.renderers[be.name]=be.renderer}if(be.tokenizer){if(!be.level||be.level!=="block"&&be.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ee[be.level]?ee[be.level].unshift(be.tokenizer):ee[be.level]=[be.tokenizer],be.start&&(be.level==="block"?ee.startBlock?ee.startBlock.push(be.start):ee.startBlock=[be.start]:be.level==="inline"&&(ee.startInline?ee.startInline.push(be.start):ee.startInline=[be.start]))}be.childTokens&&(ee.childTokens[be.name]=be.childTokens)})),de.renderer&&function(){var be=ce.defaults.renderer||new Q,Pe=function(V){var H=be[V];be[V]=function(){for(var Y=arguments.length,X=new Array(Y),fe=0;fe<Y;fe++)X[fe]=arguments[fe];var we=de.renderer[V].apply(be,X);return we===!1&&(we=H.apply(be,X)),we}};for(var Re in de.renderer)Pe(Re);G.renderer=be}(),de.tokenizer&&function(){var be=ce.defaults.tokenizer||new B,Pe=function(V){var H=be[V];be[V]=function(){for(var Y=arguments.length,X=new Array(Y),fe=0;fe<Y;fe++)X[fe]=arguments[fe];var we=de.tokenizer[V].apply(be,X);return we===!1&&(we=H.apply(be,X)),we}};for(var Re in de.tokenizer)Pe(Re);G.tokenizer=be}(),de.walkTokens){var Me=ce.defaults.walkTokens;G.walkTokens=function(be){var Pe=[];return Pe.push(de.walkTokens.call(this,be)),Me&&(Pe=Pe.concat(Me.call(this,be))),Pe}}le&&(G.extensions=ee),ce.setOptions(G)})},ce.walkTokens=function(ie,se){for(var oe=[],G=function(){var Me=le.value;switch(oe=oe.concat(se.call(ce,Me)),Me.type){case"table":{for(var be=M(Me.header),Pe;!(Pe=be()).done;){var Re=Pe.value;oe=oe.concat(ce.walkTokens(Re.tokens,se))}for(var ze=M(Me.rows),V;!(V=ze()).done;)for(var H=V.value,Y=M(H),X;!(X=Y()).done;){var fe=X.value;oe=oe.concat(ce.walkTokens(fe.tokens,se))}break}case"list":{oe=oe.concat(ce.walkTokens(Me.items,se));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Me.type]?ce.defaults.extensions.childTokens[Me.type].forEach(function(we){oe=oe.concat(ce.walkTokens(Me[we],se))}):Me.tokens&&(oe=oe.concat(ce.walkTokens(Me.tokens,se)))}},ee=M(ie),le;!(le=ee()).done;)G();return oe},ce.parseInline=function(ie,se){if(typeof ie>"u"||ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");se=g({},ce.defaults,se||{}),k(se);try{var oe=z.lexInline(ie,se);return se.walkTokens&&ce.walkTokens(oe,se.walkTokens),x.parseInline(oe,se)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+y(G.message+"",!0)+"</pre>";throw G}},ce.Parser=x,ce.parser=x.parse,ce.Renderer=Q,ce.TextRenderer=Z,ce.Lexer=z,ce.lexer=z.lex,ce.Tokenizer=B,ce.Slugger=J,ce.parse=ce;var te=ce.options,pe=ce.setOptions,ye=ce.use,_=ce.walkTokens,U=ce.parseInline,he=ce,Se=x.parse,me=z.lex;re.Lexer=z,re.Parser=x,re.Renderer=Q,re.Slugger=J,re.TextRenderer=Z,re.Tokenizer=B,re.getDefaults=L,re.lexer=me,re.marked=ce,re.options=te,re.parse=he,re.parseInline=U,re.parser=Se,re.setOptions=pe,re.use=ye,re.walkTokens=_,Object.defineProperty(re,"__esModule",{value:!0})}),define(Ee[167],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=o;function o(a){const m=M(a);if(m&&m.length>0)return new Uint32Array(m)}let R=0;const I=new Uint32Array(10);function M(a){if(R=0,L(a,P,4352),R>0||(L(a,b,4449),R>0)||(L(a,C,4520),R>0)||(L(a,y,12593),R))return I.subarray(0,R);if(a>=44032&&a<=55203){const m=a-44032,c=m%588,i=Math.floor(m/588),n=Math.floor(c/28),r=c%28-1;if(i<P.length?L(i,P,0):4352+i-12593<y.length&&L(4352+i,y,12593),n<b.length?L(n,b,0):4449+n-12593<y.length&&L(4449+n-12593,y,12593),r>=0&&(r<C.length?L(r,C,0):4520+r-12593<y.length&&L(4520+r-12593,y,12593)),R>0)return I.subarray(0,R)}}function L(a,m,c){a>=c&&a<c+m.length&&p(m[a-c])}function p(a){a!==0&&(I[R++]=a&255,a>>8&&(I[R++]=a>>8&255),a>>16&&(I[R++]=a>>16&255))}var $;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var w;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(w||(w={}));var A;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(A||(A={}));const P=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),b=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),C=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),y=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ee[76],Ce([1,0,27]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=void 0,e.$1l=I,e.$2l=L;const R=new o.$Ec(1e4);function I(w){return $(w,"NFC",R)}const M=new o.$Ec(1e4);function L(w){return $(w,"NFD",M)}const p=/[^\u0000-\u0080]/;function $(w,A,P){if(!w)return w;const b=P.get(w);if(b)return b;let C;return p.test(w)?C=w.normalize(A):C=w,P.set(w,C),C}e.$3l=function(){const w=/[\u0300-\u036f]/g;return function(A){return L(A).replace(w,"")}}()}),define(Ee[126],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=void 0,e.$om=o,e.rot=R;function o(p,$,w){return Math.min(Math.max(p,$),w)}function R(p,$){return($+p%$)%$}class I{constructor(){this.a=0}getNext(){return this.a++}}e.$qm=I;class M{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$rm=M;class L{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const w=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$sm=L}),function(){function re(I){const M=[];typeof I=="number"&&M.push("code/timeOrigin",I);function L($){M.push($,Date.now())}function p(){const $=[];for(let w=0;w<M.length;w+=2)$.push({name:M[w],startTime:M[w+1]});return $}return{mark:L,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const L of performance.getEntriesByType("mark"))M.push({name:L.name,startTime:Math.round(I+L.startTime)});return M}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function o(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return o(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=o(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=o(R))}(),define(Ee[11],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$a=void 0,e.$b=t,e.$x=g,e.$D=E,e.$a="en";let o=!1,R=!1,I=!1,M=!1,L=!1,p=!1,$=!1,w=!1,A=!1,P=!1,b,C=e.$a,y=e.$a,a,m;const c=globalThis;let i;typeof c.vscode<"u"&&typeof c.vscode.process<"u"?i=c.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(i=process);const n=typeof i?.versions?.electron=="string",r=n&&i?.type==="renderer";if(typeof i=="object"){o=i.platform==="win32",R=i.platform==="darwin",I=i.platform==="linux",M=I&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,$=n,A=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=e.$a,C=e.$a;const v=i.env.VSCODE_NLS_CONFIG;if(v)try{const S=JSON.parse(v),k=S.availableLanguages["*"];b=S.locale,y=S.osLocale,C=k||e.$a,a=S._translationsConfigFile}catch{}L=!0}else if(typeof navigator=="object"&&!r){m=navigator.userAgent,o=m.indexOf("Windows")>=0,R=m.indexOf("Macintosh")>=0,w=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=m.indexOf("Linux")>=0,P=m?.indexOf("Mobi")>=0,p=!0,b=e.$a,C=b,y=navigator.language;const v=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),S=v&&v.getAttribute("data-settings");if(S)try{const k=JSON.parse(S),D=k.availableLanguages["*"];b=k.locale,y=k.osLocale,C=D||e.$a,a=k._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var s;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(s||(e.Platform=s={}));function t(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let f=0;R?f=1:o?f=3:I&&(f=2),e.$c=o,e.$d=R,e.$e=I,e.$f=M,e.$g=L,e.$h=$,e.$i=p,e.$j=p&&typeof c.importScripts=="function",e.$k=e.$j?c.origin:void 0,e.$l=w,e.$m=P,e.$n=A,e.$o=f,e.$p=m,e.$q=C;var d;(function(v){function S(){return e.$q}v.value=S;function k(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}v.isDefaultVariant=k;function D(){return e.$q==="en"}v.isDefault=D})(d||(e.Language=d={})),e.$r=b,e.$s=y,e.$t=a,e.$u=typeof c.postMessage=="function"&&!c.importScripts,e.$v=(()=>{if(e.$u){const v=[];c.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let D=0,F=v.length;D<F;D++){const W=v[D];if(W.id===k.data.vscodeScheduleAsyncWork){v.splice(D,1),W.callback();return}}});let S=0;return k=>{const D=++S;v.push({id:D,callback:k}),c.postMessage({vscodeScheduleAsyncWork:D},"*")}}return v=>setTimeout(v)})();var u;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(u||(e.OperatingSystem=u={})),e.OS=R||w?2:o?1:3;let h=!0,l=!1;function g(){if(!l){l=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,h=new Uint16Array(v.buffer)[0]===513}return h}e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0);function E(v){return parseFloat(v)>=20}}),define(Ee[168],Ce([1,0,39]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DO=void 0;const R=Symbol("unset");class I{constructor(){this.a=new L,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||o.Iterable.empty()}insert($,w,A){this.d($,P=>P._value=w,A)}mutate($,w){this.d($,A=>A._value=w(A._value===R?void 0:A._value))}delete($){const w=this.c($);if(!w)return;let A=w.length-1;const P=w[A].node._value;if(P!==R){for(this.b--,w[A].node._value=R;A>0;A--){const{node:b,part:C}=w[A];if(b.children?.size||b._value!==R)break;w[A-1].node.children.delete(C)}return P}}*deleteRecursive($){const w=this.c($);if(!w)return;const A=w[w.length-1].node;for(let P=w.length-1;P>0;P--){const b=w[P-1];if(b.node.children.delete(w[P].part),b.node.children.size>0||b.node._value!==R)break}for(const P of M(A))P._value!==R&&(this.b--,yield P._value)}find($){let w=this.a;for(const A of $){const P=w.children?.get(A);if(!P)return;w=P}return w._value===R?void 0:w._value}hasKeyOrParent($){let w=this.a;for(const A of $){const P=w.children?.get(A);if(!P)return!1;if(P._value!==R)return!0;w=P}return!1}hasKeyOrChildren($){let w=this.a;for(const A of $){const P=w.children?.get(A);if(!P)return!1;w=P}return!0}hasKey($){let w=this.a;for(const A of $){const P=w.children?.get(A);if(!P)return!1;w=P}return w._value!==R}c($){const w=[{part:"",node:this.a}];let A=0;for(const P of $){const b=w[A].node.children?.get(P);if(!b)return;w.push({part:P,node:b}),A++}return w}d($,w,A){let P=this.a;for(const y of $){if(P.children)if(P.children.has(y))P=P.children.get(y);else{const a=new L;P.children.set(y,a),P=a}else{const a=new L;P.children=new Map([[y,a]]),P=a}A?.(P)}const b=P._value===R?0:1;w(P);const C=P._value===R?0:1;this.b+=C-b}*values(){for(const{_value:$}of M(this.a))$!==R&&(yield $)}}e.$DO=I;function*M(p){const $=[p];for(;$.length>0;){const w=$.pop();if(yield w,w.children)for(const A of w.children.values())$.push(A)}}class L{constructor(){this._value=R}get value(){return this._value===R?void 0:this._value}set value($){this._value=$===void 0?R:$}}}),define(Ee[49],Ce([1,0,11]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let R;const I=globalThis.vscode;if(typeof I<"u"&&typeof I.process<"u"){const M=I.process;R={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return o.$c?"win32":o.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.$ec=R.platform,e.$fc=R.arch}),define(Ee[17],Ce([1,0,49]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const R=65,I=97,M=90,L=122,p=46,$=47,w=92,A=58,P=63;class b extends Error{constructor(f,d,u){let h;typeof d=="string"&&d.indexOf("not ")===0?(h="must not be",d=d.replace(/^not /,"")):h="must be";const l=f.indexOf(".")!==-1?"property":"argument";let g=`The "${f}" ${l} ${h} of type ${d}`;g+=`. Received type ${typeof u}`,super(g),this.code="ERR_INVALID_ARG_TYPE"}}function C(t,f){if(t===null||typeof t!="object")throw new b(f,"Object",t)}function y(t,f){if(typeof t!="string")throw new b(f,"string",t)}const a=o.$ec==="win32";function m(t){return t===$||t===w}function c(t){return t===$}function i(t){return t>=R&&t<=M||t>=I&&t<=L}function n(t,f,d,u){let h="",l=0,g=-1,E=0,v=0;for(let S=0;S<=t.length;++S){if(S<t.length)v=t.charCodeAt(S);else{if(u(v))break;v=$}if(u(v)){if(!(g===S-1||E===1))if(E===2){if(h.length<2||l!==2||h.charCodeAt(h.length-1)!==p||h.charCodeAt(h.length-2)!==p){if(h.length>2){const k=h.lastIndexOf(d);k===-1?(h="",l=0):(h=h.slice(0,k),l=h.length-1-h.lastIndexOf(d)),g=S,E=0;continue}else if(h.length!==0){h="",l=0,g=S,E=0;continue}}f&&(h+=h.length>0?`${d}..`:"..",l=2)}else h.length>0?h+=`${d}${t.slice(g+1,S)}`:h=t.slice(g+1,S),l=S-g-1;g=S,E=0}else v===p&&E!==-1?++E:E=-1}return h}function r(t,f){C(f,"pathObject");const d=f.dir||f.root,u=f.base||`${f.name||""}${f.ext||""}`;return d?d===f.root?`${d}${u}`:`${d}${t}${u}`:u}e.$gc={resolve(...t){let f="",d="",u=!1;for(let h=t.length-1;h>=-1;h--){let l;if(h>=0){if(l=t[h],y(l,"path"),l.length===0)continue}else f.length===0?l=o.cwd():(l=o.env[`=${f}`]||o.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==f.toLowerCase()&&l.charCodeAt(2)===w)&&(l=`${f}\\`));const g=l.length;let E=0,v="",S=!1;const k=l.charCodeAt(0);if(g===1)m(k)&&(E=1,S=!0);else if(m(k))if(S=!0,m(l.charCodeAt(1))){let D=2,F=D;for(;D<g&&!m(l.charCodeAt(D));)D++;if(D<g&&D!==F){const W=l.slice(F,D);for(F=D;D<g&&m(l.charCodeAt(D));)D++;if(D<g&&D!==F){for(F=D;D<g&&!m(l.charCodeAt(D));)D++;(D===g||D!==F)&&(v=`\\\\${W}\\${l.slice(F,D)}`,E=D)}}}else E=1;else i(k)&&l.charCodeAt(1)===A&&(v=l.slice(0,2),E=2,g>2&&m(l.charCodeAt(2))&&(S=!0,E=3));if(v.length>0)if(f.length>0){if(v.toLowerCase()!==f.toLowerCase())continue}else f=v;if(u){if(f.length>0)break}else if(d=`${l.slice(E)}\\${d}`,u=S,S&&f.length>0)break}return d=n(d,!u,"\\",m),u?`${f}\\${d}`:`${f}${d}`||"."},normalize(t){y(t,"path");const f=t.length;if(f===0)return".";let d=0,u,h=!1;const l=t.charCodeAt(0);if(f===1)return c(l)?"\\":t;if(m(l))if(h=!0,m(t.charCodeAt(1))){let E=2,v=E;for(;E<f&&!m(t.charCodeAt(E));)E++;if(E<f&&E!==v){const S=t.slice(v,E);for(v=E;E<f&&m(t.charCodeAt(E));)E++;if(E<f&&E!==v){for(v=E;E<f&&!m(t.charCodeAt(E));)E++;if(E===f)return`\\\\${S}\\${t.slice(v)}\\`;E!==v&&(u=`\\\\${S}\\${t.slice(v,E)}`,d=E)}}}else d=1;else i(l)&&t.charCodeAt(1)===A&&(u=t.slice(0,2),d=2,f>2&&m(t.charCodeAt(2))&&(h=!0,d=3));let g=d<f?n(t.slice(d),!h,"\\",m):"";return g.length===0&&!h&&(g="."),g.length>0&&m(t.charCodeAt(f-1))&&(g+="\\"),u===void 0?h?`\\${g}`:g:h?`${u}\\${g}`:`${u}${g}`},isAbsolute(t){y(t,"path");const f=t.length;if(f===0)return!1;const d=t.charCodeAt(0);return m(d)||f>2&&i(d)&&t.charCodeAt(1)===A&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let f,d;for(let l=0;l<t.length;++l){const g=t[l];y(g,"path"),g.length>0&&(f===void 0?f=d=g:f+=`\\${g}`)}if(f===void 0)return".";let u=!0,h=0;if(typeof d=="string"&&m(d.charCodeAt(0))){++h;const l=d.length;l>1&&m(d.charCodeAt(1))&&(++h,l>2&&(m(d.charCodeAt(2))?++h:u=!1))}if(u){for(;h<f.length&&m(f.charCodeAt(h));)h++;h>=2&&(f=`\\${f.slice(h)}`)}return e.$gc.normalize(f)},relative(t,f){if(y(t,"from"),y(f,"to"),t===f)return"";const d=e.$gc.resolve(t),u=e.$gc.resolve(f);if(d===u||(t=d.toLowerCase(),f=u.toLowerCase(),t===f))return"";let h=0;for(;h<t.length&&t.charCodeAt(h)===w;)h++;let l=t.length;for(;l-1>h&&t.charCodeAt(l-1)===w;)l--;const g=l-h;let E=0;for(;E<f.length&&f.charCodeAt(E)===w;)E++;let v=f.length;for(;v-1>E&&f.charCodeAt(v-1)===w;)v--;const S=v-E,k=g<S?g:S;let D=-1,F=0;for(;F<k;F++){const B=t.charCodeAt(h+F);if(B!==f.charCodeAt(E+F))break;B===w&&(D=F)}if(F!==k){if(D===-1)return u}else{if(S>k){if(f.charCodeAt(E+F)===w)return u.slice(E+F+1);if(F===2)return u.slice(E+F)}g>k&&(t.charCodeAt(h+F)===w?D=F:F===2&&(D=3)),D===-1&&(D=0)}let W="";for(F=h+D+1;F<=l;++F)(F===l||t.charCodeAt(F)===w)&&(W+=W.length===0?"..":"\\..");return E+=D,W.length>0?`${W}${u.slice(E,v)}`:(u.charCodeAt(E)===w&&++E,u.slice(E,v))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const f=e.$gc.resolve(t);if(f.length<=2)return t;if(f.charCodeAt(0)===w){if(f.charCodeAt(1)===w){const d=f.charCodeAt(2);if(d!==P&&d!==p)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(i(f.charCodeAt(0))&&f.charCodeAt(1)===A&&f.charCodeAt(2)===w)return`\\\\?\\${f}`;return t},dirname(t){y(t,"path");const f=t.length;if(f===0)return".";let d=-1,u=0;const h=t.charCodeAt(0);if(f===1)return m(h)?t:".";if(m(h)){if(d=u=1,m(t.charCodeAt(1))){let E=2,v=E;for(;E<f&&!m(t.charCodeAt(E));)E++;if(E<f&&E!==v){for(v=E;E<f&&m(t.charCodeAt(E));)E++;if(E<f&&E!==v){for(v=E;E<f&&!m(t.charCodeAt(E));)E++;if(E===f)return t;E!==v&&(d=u=E+1)}}}}else i(h)&&t.charCodeAt(1)===A&&(d=f>2&&m(t.charCodeAt(2))?3:2,u=d);let l=-1,g=!0;for(let E=f-1;E>=u;--E)if(m(t.charCodeAt(E))){if(!g){l=E;break}}else g=!1;if(l===-1){if(d===-1)return".";l=d}return t.slice(0,l)},basename(t,f){f!==void 0&&y(f,"ext"),y(t,"path");let d=0,u=-1,h=!0,l;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(d=2),f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let g=f.length-1,E=-1;for(l=t.length-1;l>=d;--l){const v=t.charCodeAt(l);if(m(v)){if(!h){d=l+1;break}}else E===-1&&(h=!1,E=l+1),g>=0&&(v===f.charCodeAt(g)?--g===-1&&(u=l):(g=-1,u=E))}return d===u?u=E:u===-1&&(u=t.length),t.slice(d,u)}for(l=t.length-1;l>=d;--l)if(m(t.charCodeAt(l))){if(!h){d=l+1;break}}else u===-1&&(h=!1,u=l+1);return u===-1?"":t.slice(d,u)},extname(t){y(t,"path");let f=0,d=-1,u=0,h=-1,l=!0,g=0;t.length>=2&&t.charCodeAt(1)===A&&i(t.charCodeAt(0))&&(f=u=2);for(let E=t.length-1;E>=f;--E){const v=t.charCodeAt(E);if(m(v)){if(!l){u=E+1;break}continue}h===-1&&(l=!1,h=E+1),v===p?d===-1?d=E:g!==1&&(g=1):d!==-1&&(g=-1)}return d===-1||h===-1||g===0||g===1&&d===h-1&&d===u+1?"":t.slice(d,h)},format:r.bind(null,"\\"),parse(t){y(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const d=t.length;let u=0,h=t.charCodeAt(0);if(d===1)return m(h)?(f.root=f.dir=t,f):(f.base=f.name=t,f);if(m(h)){if(u=1,m(t.charCodeAt(1))){let D=2,F=D;for(;D<d&&!m(t.charCodeAt(D));)D++;if(D<d&&D!==F){for(F=D;D<d&&m(t.charCodeAt(D));)D++;if(D<d&&D!==F){for(F=D;D<d&&!m(t.charCodeAt(D));)D++;D===d?u=D:D!==F&&(u=D+1)}}}}else if(i(h)&&t.charCodeAt(1)===A){if(d<=2)return f.root=f.dir=t,f;if(u=2,m(t.charCodeAt(2))){if(d===3)return f.root=f.dir=t,f;u=3}}u>0&&(f.root=t.slice(0,u));let l=-1,g=u,E=-1,v=!0,S=t.length-1,k=0;for(;S>=u;--S){if(h=t.charCodeAt(S),m(h)){if(!v){g=S+1;break}continue}E===-1&&(v=!1,E=S+1),h===p?l===-1?l=S:k!==1&&(k=1):l!==-1&&(k=-1)}return E!==-1&&(l===-1||k===0||k===1&&l===E-1&&l===g+1?f.base=f.name=t.slice(g,E):(f.name=t.slice(g,l),f.base=t.slice(g,E),f.ext=t.slice(l,E))),g>0&&g!==u?f.dir=t.slice(0,g-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(a){const t=/\\/g;return()=>{const f=o.cwd().replace(t,"/");return f.slice(f.indexOf("/"))}}return()=>o.cwd()})();e.$hc={resolve(...t){let f="",d=!1;for(let u=t.length-1;u>=-1&&!d;u--){const h=u>=0?t[u]:s();y(h,"path"),h.length!==0&&(f=`${h}/${f}`,d=h.charCodeAt(0)===$)}return f=n(f,!d,"/",c),d?`/${f}`:f.length>0?f:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===$,d=t.charCodeAt(t.length-1)===$;return t=n(t,!f,"/",c),t.length===0?f?"/":d?"./":".":(d&&(t+="/"),f?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let f;for(let d=0;d<t.length;++d){const u=t[d];y(u,"path"),u.length>0&&(f===void 0?f=u:f+=`/${u}`)}return f===void 0?".":e.$hc.normalize(f)},relative(t,f){if(y(t,"from"),y(f,"to"),t===f||(t=e.$hc.resolve(t),f=e.$hc.resolve(f),t===f))return"";const d=1,u=t.length,h=u-d,l=1,g=f.length-l,E=h<g?h:g;let v=-1,S=0;for(;S<E;S++){const D=t.charCodeAt(d+S);if(D!==f.charCodeAt(l+S))break;D===$&&(v=S)}if(S===E)if(g>E){if(f.charCodeAt(l+S)===$)return f.slice(l+S+1);if(S===0)return f.slice(l+S)}else h>E&&(t.charCodeAt(d+S)===$?v=S:S===0&&(v=0));let k="";for(S=d+v+1;S<=u;++S)(S===u||t.charCodeAt(S)===$)&&(k+=k.length===0?"..":"/..");return`${k}${f.slice(l+v)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===$;let d=-1,u=!0;for(let h=t.length-1;h>=1;--h)if(t.charCodeAt(h)===$){if(!u){d=h;break}}else u=!1;return d===-1?f?"/":".":f&&d===1?"//":t.slice(0,d)},basename(t,f){f!==void 0&&y(f,"ext"),y(t,"path");let d=0,u=-1,h=!0,l;if(f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let g=f.length-1,E=-1;for(l=t.length-1;l>=0;--l){const v=t.charCodeAt(l);if(v===$){if(!h){d=l+1;break}}else E===-1&&(h=!1,E=l+1),g>=0&&(v===f.charCodeAt(g)?--g===-1&&(u=l):(g=-1,u=E))}return d===u?u=E:u===-1&&(u=t.length),t.slice(d,u)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===$){if(!h){d=l+1;break}}else u===-1&&(h=!1,u=l+1);return u===-1?"":t.slice(d,u)},extname(t){y(t,"path");let f=-1,d=0,u=-1,h=!0,l=0;for(let g=t.length-1;g>=0;--g){const E=t.charCodeAt(g);if(E===$){if(!h){d=g+1;break}continue}u===-1&&(h=!1,u=g+1),E===p?f===-1?f=g:l!==1&&(l=1):f!==-1&&(l=-1)}return f===-1||u===-1||l===0||l===1&&f===u-1&&f===d+1?"":t.slice(f,u)},format:r.bind(null,"/"),parse(t){y(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const d=t.charCodeAt(0)===$;let u;d?(f.root="/",u=1):u=0;let h=-1,l=0,g=-1,E=!0,v=t.length-1,S=0;for(;v>=u;--v){const k=t.charCodeAt(v);if(k===$){if(!E){l=v+1;break}continue}g===-1&&(E=!1,g=v+1),k===p?h===-1?h=v:S!==1&&(S=1):h!==-1&&(S=-1)}if(g!==-1){const k=l===0&&d?1:l;h===-1||S===0||S===1&&h===g-1&&h===l+1?f.base=f.name=t.slice(k,g):(f.name=t.slice(k,h),f.base=t.slice(k,g),f.ext=t.slice(h,g))}return l>0?f.dir=t.slice(0,l-1):d&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=a?e.$gc.normalize:e.$hc.normalize,e.$jc=a?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=a?e.$gc.join:e.$hc.join,e.$lc=a?e.$gc.resolve:e.$hc.resolve,e.$mc=a?e.$gc.relative:e.$hc.relative,e.$nc=a?e.$gc.dirname:e.$hc.dirname,e.$oc=a?e.$gc.basename:e.$hc.basename,e.$pc=a?e.$gc.extname:e.$hc.extname,e.$qc=a?e.$gc.format:e.$hc.format,e.$rc=a?e.$gc.parse:e.$hc.parse,e.$sc=a?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=a?e.$gc.sep:e.$hc.sep,e.$uc=a?e.$gc.delimiter:e.$hc.delimiter}),define(Ee[127],Ce([1,0,46,17]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=p,e.$5q=$,e.$6q=w,e.$7q=A,e.$8q=P,e.$9q=b,e.$0q=C,e.$$q=y,e.$_q=a,e.$ar=m,e.$br=h,e.$cr=l,e.$dr=g;const I=new o.$V(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),M=new o.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new o.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(E,v,S=!1){const k=E||"",D=v||"",F=I.value.collator.compare(k,D);return I.value.collatorIsNumeric&&F===0&&k!==D?k<D?-1:1:F}function $(E,v){const S=M.value.collator;return E=E||"",v=v||"",r(S,E,v)}function w(E,v){const S=M.value.collator;return E=E||"",v=v||"",d(E,v)||r(S,E,v)}function A(E,v){const S=M.value.collator;return E=E||"",v=v||"",f(E,v)||r(S,E,v)}function P(E,v){return E=E||"",v=v||"",E===v?0:E<v?-1:1}function b(E,v){const[S,k]=i(E),[D,F]=i(v);let W=I.value.collator.compare(k,F);if(W===0){if(I.value.collatorIsNumeric&&k!==F)return k<F?-1:1;if(W=I.value.collator.compare(S,D),I.value.collatorIsNumeric&&W===0&&S!==D)return S<D?-1:1}return W}function C(E,v){E=E||"",v=v||"";const S=n(E),k=n(v),D=M.value.collator,F=L.value.collator;return r(F,S,k)||r(D,E,v)}function y(E,v){E=E||"",v=v||"";const S=n(E),k=n(v),D=M.value.collator,F=L.value.collator;return r(F,S,k)||d(E,v)||r(D,E,v)}function a(E,v){E=E||"",v=v||"";const S=n(E),k=n(v),D=M.value.collator,F=L.value.collator;return r(F,S,k)||f(E,v)||r(D,E,v)}function m(E,v){E=E||"",v=v||"";const S=n(E).toLowerCase(),k=n(v).toLowerCase();return S!==k?S<k?-1:1:E!==v?E<v?-1:1:0}const c=/^(.*?)(\.([^.]*))?$/;function i(E,v=!1){const S=E?c.exec(E):[];let k=[S&&S[1]||"",S&&S[3]||""];return v&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function n(E){const v=E?c.exec(E):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function r(E,v,S){const k=E.compare(v,S);return k!==0?k:v.length!==S.length?v.length<S.length?-1:1:0}function s(E){const v=E.charAt(0);return v.toLocaleUpperCase()!==v}function t(E){const v=E.charAt(0);return v.toLocaleLowerCase()!==v}function f(E,v){return s(E)&&t(v)?-1:t(E)&&s(v)?1:0}function d(E,v){return t(E)&&s(v)?-1:s(E)&&t(v)?1:0}function u(E,v,S=!1){return S||(E=E&&E.toLowerCase(),v=v&&v.toLowerCase()),E===v?0:E<v?-1:1}function h(E,v,S=!1){const k=E.split(R.sep),D=v.split(R.sep),F=k.length-1,W=D.length-1;let B,j;for(let N=0;;N++){if(B=F===N,j=W===N,B&&j)return p(k[N],D[N],S);if(B)return-1;if(j)return 1;const T=u(k[N],D[N],S);if(T!==0)return T}}function l(E,v,S){const k=E.toLowerCase(),D=v.toLowerCase(),F=g(E,v,S);if(F)return F;const W=k.endsWith(S),B=D.endsWith(S);if(W!==B)return W?-1:1;const j=p(k,D);return j!==0?j:k.localeCompare(D)}function g(E,v,S){const k=E.toLowerCase(),D=v.toLowerCase(),F=k.startsWith(S),W=D.startsWith(S);if(F!==W)return F?-1:1;if(F&&W){if(k.length<D.length)return-1;if(k.length>D.length)return 1}return 0}}),define(Ee[98],Ce([1,0,17]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=void 0,e.$Bs=M,e.$Cs=L,e.$Ds=p,e.$Es=w,e.$As=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(A){const P=(0,o.$pc)(A),b=R[P.toLowerCase()];return b!==void 0?b:L(A)}function L(A){const P=(0,o.$pc)(A);return I[P.toLowerCase()]}function p(A){for(const P in I)if(I[P]===A)return P}const $=/^(.+)\/(.+?)(;.+)?$/;function w(A,P){const b=$.exec(A);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:P?void 0:A}}),define(Ee[99],Ce([1,0,11]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$_l=M,e.$am=L;var R;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(R||(e.Source=R={}));var I;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(I||(e.TerminateResponseCode=I={}));function M(p,...$){const w=$.reduce((b,C)=>(b[C]=!0,b),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(p).filter(b=>!w[b]).forEach(b=>{for(let C=0;C<A.length;C++)if(b.search(A[C])!==-1){delete p[b];break}})}function L(p){p&&(delete p.DEBUG,o.$d&&delete p.DYLD_LIBRARY_PATH,o.$e&&delete p.LD_PRELOAD)}}),function(re,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var o=e();for(var R in o)(typeof exports=="object"?exports:re)[R]=o[R]}}(typeof self<"u"?self:this,function(){return function(re){var e={};function o(R){if(e[R])return e[R].exports;var I=e[R]={i:R,l:!1,exports:{}};return re[R].call(I.exports,I,I.exports,o),I.l=!0,I.exports}return o.m=re,o.c=e,o.d=function(R,I,M){o.o(R,I)||Object.defineProperty(R,I,{enumerable:!0,get:M})},o.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},o.t=function(R,I){if(1&I&&(R=o(R)),8&I||4&I&&typeof R=="object"&&R&&R.__esModule)return R;var M=Object.create(null);if(o.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:R}),2&I&&typeof R!="string")for(var L in R)o.d(M,L,function(p){return R[p]}.bind(null,L));return M},o.n=function(R){var I=R&&R.__esModule?function(){return R.default}:function(){return R};return o.d(I,"a",I),I},o.o=function(R,I){return Object.prototype.hasOwnProperty.call(R,I)},o.p="",o(o.s=0)}([function(re,e,o){(function(R){var I;e=re.exports=ye,I=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],$=e.src=[],w=0,A=w++;$[A]="0|[1-9]\\d*";var P=w++;$[P]="[0-9]+";var b=w++;$[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=w++;$[C]="("+$[A]+")\\.("+$[A]+")\\.("+$[A]+")";var y=w++;$[y]="("+$[P]+")\\.("+$[P]+")\\.("+$[P]+")";var a=w++;$[a]="(?:"+$[A]+"|"+$[b]+")";var m=w++;$[m]="(?:"+$[P]+"|"+$[b]+")";var c=w++;$[c]="(?:-("+$[a]+"(?:\\."+$[a]+")*))";var i=w++;$[i]="(?:-?("+$[m]+"(?:\\."+$[m]+")*))";var n=w++;$[n]="[0-9A-Za-z-]+";var r=w++;$[r]="(?:\\+("+$[n]+"(?:\\."+$[n]+")*))";var s=w++,t="v?"+$[C]+$[c]+"?"+$[r]+"?";$[s]="^"+t+"$";var f="[v=\\s]*"+$[y]+$[i]+"?"+$[r]+"?",d=w++;$[d]="^"+f+"$";var u=w++;$[u]="((?:<|>)?=?)";var h=w++;$[h]=$[P]+"|x|X|\\*";var l=w++;$[l]=$[A]+"|x|X|\\*";var g=w++;$[g]="[v=\\s]*("+$[l]+")(?:\\.("+$[l]+")(?:\\.("+$[l]+")(?:"+$[c]+")?"+$[r]+"?)?)?";var E=w++;$[E]="[v=\\s]*("+$[h]+")(?:\\.("+$[h]+")(?:\\.("+$[h]+")(?:"+$[i]+")?"+$[r]+"?)?)?";var v=w++;$[v]="^"+$[u]+"\\s*"+$[g]+"$";var S=w++;$[S]="^"+$[u]+"\\s*"+$[E]+"$";var k=w++;$[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=w++;$[D]="(?:~>?)";var F=w++;$[F]="(\\s*)"+$[D]+"\\s+",p[F]=new RegExp($[F],"g");var W=w++;$[W]="^"+$[D]+$[g]+"$";var B=w++;$[B]="^"+$[D]+$[E]+"$";var j=w++;$[j]="(?:\\^)";var N=w++;$[N]="(\\s*)"+$[j]+"\\s+",p[N]=new RegExp($[N],"g");var T=w++;$[T]="^"+$[j]+$[g]+"$";var O=w++;$[O]="^"+$[j]+$[E]+"$";var z=w++;$[z]="^"+$[u]+"\\s*("+f+")$|^$";var Q=w++;$[Q]="^"+$[u]+"\\s*("+t+")$|^$";var Z=w++;$[Z]="(\\s*)"+$[u]+"\\s*("+f+"|"+$[g]+")",p[Z]=new RegExp($[Z],"g");var J=w++;$[J]="^\\s*("+$[g]+")\\s+-\\s+("+$[g]+")\\s*$";var x=w++;$[x]="^\\s*("+$[E]+")\\s+-\\s+("+$[E]+")\\s*$";var ce=w++;$[ce]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)I(te,$[te]),p[te]||(p[te]=new RegExp($[te]));function pe(H,Y){if(H instanceof ye)return H;if(typeof H!="string"||H.length>M||!(Y?p[d]:p[s]).test(H))return null;try{return new ye(H,Y)}catch{return null}}function ye(H,Y){if(H instanceof ye){if(H.loose===Y)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ye))return new ye(H,Y);I("SemVer",H,Y),this.loose=Y;var X=H.trim().match(Y?p[d]:p[s]);if(!X)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var we=+fe;if(we>=0&&we<L)return we}return fe}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}e.parse=pe,e.valid=function(H,Y){var X=pe(H,Y);return X?X.version:null},e.clean=function(H,Y){var X=pe(H.trim().replace(/^[=v]+/,""),Y);return X?X.version:null},e.SemVer=ye,ye.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ye.prototype.toString=function(){return this.version},ye.prototype.compare=function(H){return I("SemVer.compare",this.version,this.loose,H),H instanceof ye||(H=new ye(H,this.loose)),this.compareMain(H)||this.comparePre(H)},ye.prototype.compareMain=function(H){return H instanceof ye||(H=new ye(H,this.loose)),U(this.major,H.major)||U(this.minor,H.minor)||U(this.patch,H.patch)},ye.prototype.comparePre=function(H){if(H instanceof ye||(H=new ye(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var Y=0;do{var X=this.prerelease[Y],fe=H.prerelease[Y];if(I("prerelease compare",Y,X,fe),X===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(X===void 0)return-1;if(X!==fe)return U(X,fe)}while(++Y)},ye.prototype.inc=function(H,Y){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,Y,X,fe){typeof X=="string"&&(fe=X,X=void 0);try{return new ye(H,X).inc(Y,fe).version}catch{return null}},e.diff=function(H,Y){if(ie(H,Y))return null;var X=pe(H),fe=pe(Y);if(X.prerelease.length||fe.prerelease.length){for(var we in X)if((we==="major"||we==="minor"||we==="patch")&&X[we]!==fe[we])return"pre"+we;return"prerelease"}for(var we in X)if((we==="major"||we==="minor"||we==="patch")&&X[we]!==fe[we])return we},e.compareIdentifiers=U;var _=/^[0-9]+$/;function U(H,Y){var X=_.test(H),fe=_.test(Y);return X&&fe&&(H=+H,Y=+Y),X&&!fe?-1:fe&&!X?1:H<Y?-1:H>Y?1:0}function he(H,Y,X){return new ye(H,X).compare(new ye(Y,X))}function Se(H,Y,X){return he(H,Y,X)>0}function me(H,Y,X){return he(H,Y,X)<0}function ie(H,Y,X){return he(H,Y,X)===0}function se(H,Y,X){return he(H,Y,X)!==0}function oe(H,Y,X){return he(H,Y,X)>=0}function G(H,Y,X){return he(H,Y,X)<=0}function ee(H,Y,X,fe){var we;switch(Y){case"===":typeof H=="object"&&(H=H.version),typeof X=="object"&&(X=X.version),we=H===X;break;case"!==":typeof H=="object"&&(H=H.version),typeof X=="object"&&(X=X.version),we=H!==X;break;case"":case"=":case"==":we=ie(H,X,fe);break;case"!=":we=se(H,X,fe);break;case">":we=Se(H,X,fe);break;case">=":we=oe(H,X,fe);break;case"<":we=me(H,X,fe);break;case"<=":we=G(H,X,fe);break;default:throw new TypeError("Invalid operator: "+Y)}return we}function le(H,Y){if(H instanceof le){if(H.loose===Y)return H;H=H.value}if(!(this instanceof le))return new le(H,Y);I("comparator",H,Y),this.loose=Y,this.parse(H),this.semver===de?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(H,Y){return U(Y,H)},e.major=function(H,Y){return new ye(H,Y).major},e.minor=function(H,Y){return new ye(H,Y).minor},e.patch=function(H,Y){return new ye(H,Y).patch},e.compare=he,e.compareLoose=function(H,Y){return he(H,Y,!0)},e.rcompare=function(H,Y,X){return he(Y,H,X)},e.sort=function(H,Y){return H.sort(function(X,fe){return e.compare(X,fe,Y)})},e.rsort=function(H,Y){return H.sort(function(X,fe){return e.rcompare(X,fe,Y)})},e.gt=Se,e.lt=me,e.eq=ie,e.neq=se,e.gte=oe,e.lte=G,e.cmp=ee,e.Comparator=le;var de={};function Me(H,Y){if(H instanceof Me)return H.loose===Y?H:new Me(H.raw,Y);if(H instanceof le)return new Me(H.value,Y);if(!(this instanceof Me))return new Me(H,Y);if(this.loose=Y,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function be(H){return!H||H.toLowerCase()==="x"||H==="*"}function Pe(H,Y,X,fe,we,Te,Ve,Ye,nt,ot,lt,at,st){return((Y=be(X)?"":be(fe)?">="+X+".0.0":be(we)?">="+X+"."+fe+".0":">="+Y)+" "+(Ye=be(nt)?"":be(ot)?"<"+(+nt+1)+".0.0":be(lt)?"<"+nt+"."+(+ot+1)+".0":at?"<="+nt+"."+ot+"."+lt+"-"+at:"<="+Ye)).trim()}function Re(H,Y){for(var X=0;X<H.length;X++)if(!H[X].test(Y))return!1;if(Y.prerelease.length){for(X=0;X<H.length;X++)if(I(H[X].semver),H[X].semver!==de&&H[X].semver.prerelease.length>0){var fe=H[X].semver;if(fe.major===Y.major&&fe.minor===Y.minor&&fe.patch===Y.patch)return!0}return!1}return!0}function ze(H,Y,X){try{Y=new Me(Y,X)}catch{return!1}return Y.test(H)}function V(H,Y,X,fe){var we,Te,Ve,Ye,nt;switch(H=new ye(H,fe),Y=new Me(Y,fe),X){case">":we=Se,Te=G,Ve=me,Ye=">",nt=">=";break;case"<":we=me,Te=oe,Ve=Se,Ye="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(H,Y,fe))return!1;for(var ot=0;ot<Y.set.length;++ot){var lt=Y.set[ot],at=null,st=null;if(lt.forEach(function(Ie){Ie.semver===de&&(Ie=new le(">=0.0.0")),at=at||Ie,st=st||Ie,we(Ie.semver,at.semver,fe)?at=Ie:Ve(Ie.semver,st.semver,fe)&&(st=Ie)}),at.operator===Ye||at.operator===nt||(!st.operator||st.operator===Ye)&&Te(H,st.semver)||st.operator===nt&&Ve(H,st.semver))return!1}return!0}le.prototype.parse=function(H){var Y=this.loose?p[z]:p[Q],X=H.match(Y);if(!X)throw new TypeError("Invalid comparator: "+H);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new ye(X[2],this.loose):this.semver=de},le.prototype.toString=function(){return this.value},le.prototype.test=function(H){return I("Comparator.test",H,this.loose),this.semver===de||(typeof H=="string"&&(H=new ye(H,this.loose)),ee(H,this.operator,this.semver,this.loose))},le.prototype.intersects=function(H,Y){if(!(H instanceof le))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new Me(H.value,Y),ze(this.value,X,Y);if(H.operator==="")return X=new Me(this.value,Y),ze(H.semver,X,Y);var fe=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),Te=this.semver.version===H.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),Ye=ee(this.semver,"<",H.semver,Y)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),nt=ee(this.semver,">",H.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return fe||we||Te&&Ve||Ye||nt},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(H){var Y=this.loose;H=H.trim(),I("range",H,Y);var X=Y?p[x]:p[J];H=H.replace(X,Pe),I("hyphen replace",H),H=H.replace(p[Z],"$1$2$3"),I("comparator trim",H,p[Z]),H=(H=(H=H.replace(p[F],"$1~")).replace(p[N],"$1^")).split(/\s+/).join(" ");var fe=Y?p[z]:p[Q],we=H.split(" ").map(function(Te){return function(Ve,Ye){return I("comp",Ve),Ve=function(nt,ot){return nt.trim().split(/\s+/).map(function(lt){return function(at,st){I("caret",at,st);var Ie=st?p[O]:p[T];return at.replace(Ie,function(We,Ae,Ke,ae,ue){var De;return I("caret",at,We,Ae,Ke,ae,ue),be(Ae)?De="":be(Ke)?De=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":be(ae)?De=Ae==="0"?">="+Ae+"."+Ke+".0 <"+Ae+"."+(+Ke+1)+".0":">="+Ae+"."+Ke+".0 <"+(+Ae+1)+".0.0":ue?(I("replaceCaret pr",ue),ue.charAt(0)!=="-"&&(ue="-"+ue),De=Ae==="0"?Ke==="0"?">="+Ae+"."+Ke+"."+ae+ue+" <"+Ae+"."+Ke+"."+(+ae+1):">="+Ae+"."+Ke+"."+ae+ue+" <"+Ae+"."+(+Ke+1)+".0":">="+Ae+"."+Ke+"."+ae+ue+" <"+(+Ae+1)+".0.0"):(I("no pr"),De=Ae==="0"?Ke==="0"?">="+Ae+"."+Ke+"."+ae+" <"+Ae+"."+Ke+"."+(+ae+1):">="+Ae+"."+Ke+"."+ae+" <"+Ae+"."+(+Ke+1)+".0":">="+Ae+"."+Ke+"."+ae+" <"+(+Ae+1)+".0.0"),I("caret return",De),De})}(lt,ot)}).join(" ")}(Ve,Ye),I("caret",Ve),Ve=function(nt,ot){return nt.trim().split(/\s+/).map(function(lt){return function(at,st){var Ie=st?p[B]:p[W];return at.replace(Ie,function(We,Ae,Ke,ae,ue){var De;return I("tilde",at,We,Ae,Ke,ae,ue),be(Ae)?De="":be(Ke)?De=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":be(ae)?De=">="+Ae+"."+Ke+".0 <"+Ae+"."+(+Ke+1)+".0":ue?(I("replaceTilde pr",ue),ue.charAt(0)!=="-"&&(ue="-"+ue),De=">="+Ae+"."+Ke+"."+ae+ue+" <"+Ae+"."+(+Ke+1)+".0"):De=">="+Ae+"."+Ke+"."+ae+" <"+Ae+"."+(+Ke+1)+".0",I("tilde return",De),De})}(lt,ot)}).join(" ")}(Ve,Ye),I("tildes",Ve),Ve=function(nt,ot){return I("replaceXRanges",nt,ot),nt.split(/\s+/).map(function(lt){return function(at,st){at=at.trim();var Ie=st?p[S]:p[v];return at.replace(Ie,function(We,Ae,Ke,ae,ue,De){I("xRange",at,We,Ae,Ke,ae,ue,De);var Je=be(Ke),et=Je||be(ae),Ne=et||be(ue);return Ae==="="&&Ne&&(Ae=""),Je?We=Ae===">"||Ae==="<"?"<0.0.0":"*":Ae&&Ne?(et&&(ae=0),Ne&&(ue=0),Ae===">"?(Ae=">=",et?(Ke=+Ke+1,ae=0,ue=0):Ne&&(ae=+ae+1,ue=0)):Ae==="<="&&(Ae="<",et?Ke=+Ke+1:ae=+ae+1),We=Ae+Ke+"."+ae+"."+ue):et?We=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":Ne&&(We=">="+Ke+"."+ae+".0 <"+Ke+"."+(+ae+1)+".0"),I("xRange return",We),We})}(lt,ot)}).join(" ")}(Ve,Ye),I("xrange",Ve),Ve=function(nt,ot){return I("replaceStars",nt,ot),nt.trim().replace(p[ce],"")}(Ve,Ye),I("stars",Ve),Ve}(Te,Y)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Te){return!!Te.match(fe)})),we=we.map(function(Te){return new le(Te,Y)})},Me.prototype.intersects=function(H,Y){if(!(H instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(fe){return H.set.some(function(we){return we.every(function(Te){return fe.intersects(Te,Y)})})})})},e.toComparators=function(H,Y){return new Me(H,Y).set.map(function(X){return X.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new ye(H,this.loose));for(var Y=0;Y<this.set.length;Y++)if(Re(this.set[Y],H))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(H,Y,X){var fe=null,we=null;try{var Te=new Me(Y,X)}catch{return null}return H.forEach(function(Ve){Te.test(Ve)&&(fe&&we.compare(Ve)!==-1||(we=new ye(fe=Ve,X)))}),fe},e.minSatisfying=function(H,Y,X){var fe=null,we=null;try{var Te=new Me(Y,X)}catch{return null}return H.forEach(function(Ve){Te.test(Ve)&&(fe&&we.compare(Ve)!==1||(we=new ye(fe=Ve,X)))}),fe},e.validRange=function(H,Y){try{return new Me(H,Y).range||"*"}catch{return null}},e.ltr=function(H,Y,X){return V(H,Y,"<",X)},e.gtr=function(H,Y,X){return V(H,Y,">",X)},e.outside=V,e.prerelease=function(H,Y){var X=pe(H,Y);return X&&X.prerelease.length?X.prerelease:null},e.intersects=function(H,Y,X){return H=new Me(H,X),Y=new Me(Y,X),H.intersects(Y)},e.coerce=function(H){if(H instanceof ye)return H;if(typeof H!="string")return null;var Y=H.match(p[k]);return Y==null?null:pe((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,o(1))},function(re,e){var o,R,I=re.exports={};function M(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function p(m){if(o===setTimeout)return setTimeout(m,0);if((o===M||!o)&&setTimeout)return o=setTimeout,setTimeout(m,0);try{return o(m,0)}catch{try{return o.call(null,m,0)}catch{return o.call(this,m,0)}}}(function(){try{o=typeof setTimeout=="function"?setTimeout:M}catch{o=M}try{R=typeof clearTimeout=="function"?clearTimeout:L}catch{R=L}})();var $,w=[],A=!1,P=-1;function b(){A&&$&&(A=!1,$.length?w=$.concat(w):P=-1,w.length&&C())}function C(){if(!A){var m=p(b);A=!0;for(var c=w.length;c;){for($=w,w=[];++P<c;)$&&$[P].run();P=-1,c=w.length}$=null,A=!1,function(i){if(R===clearTimeout)return clearTimeout(i);if((R===L||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(i);try{R(i)}catch{try{return R.call(null,i)}catch{return R.call(this,i)}}}(m)}}function y(m,c){this.fun=m,this.array=c}function a(){}I.nextTick=function(m){var c=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)c[i-1]=arguments[i];w.push(new y(m,c)),w.length!==1||A||p(C)},y.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=a,I.addListener=a,I.once=a,I.off=a,I.removeListener=a,I.removeAllListeners=a,I.emit=a,I.prependListener=a,I.prependOnceListener=a,I.listeners=function(m){return[]},I.binding=function(m){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(m){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Ee[40],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0;const o=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(M){return new R(M)}constructor(M){this.c=o&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$3d=R}),define(Ee[4],Ce([1,0,13,74,3,75,40]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$5d=e.Event=void 0,e.$6d=C;const p=!1,$=!1,w=!1;var A;(function(k){k.None=()=>I.$Uc.None;function D(le){if(w){const{onDidAddListener:de}=le,Me=a.create();let be=0;le.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Me.print()),de?.()}}}function F(le,de){return J(le,()=>{},0,void 0,!0,void 0,de)}k.defer=F;function W(le){return(de,Me=null,be)=>{let Pe=!1,Re;return Re=le(ze=>{if(!Pe)return Re?Re.dispose():Pe=!0,de.call(Me,ze)},null,be),Pe&&Re.dispose(),Re}}k.once=W;function B(le,de,Me){return Q((be,Pe=null,Re)=>le(ze=>be.call(Pe,de(ze)),null,Re),Me)}k.map=B;function j(le,de,Me){return Q((be,Pe=null,Re)=>le(ze=>{de(ze),be.call(Pe,ze)},null,Re),Me)}k.forEach=j;function N(le,de,Me){return Q((be,Pe=null,Re)=>le(ze=>de(ze)&&be.call(Pe,ze),null,Re),Me)}k.filter=N;function T(le){return le}k.signal=T;function O(...le){return(de,Me=null,be)=>{const Pe=(0,I.$Rc)(...le.map(Re=>Re(ze=>de.call(Me,ze))));return Z(Pe,be)}}k.any=O;function z(le,de,Me,be){let Pe=Me;return B(le,Re=>(Pe=de(Pe,Re),Pe),be)}k.reduce=z;function Q(le,de){let Me;const be={onWillAddFirstListener(){Me=le(Pe.fire,Pe)},onDidRemoveLastListener(){Me?.dispose()}};de||D(be);const Pe=new s(be);return de?.add(Pe),Pe.event}function Z(le,de){return de instanceof Array?de.push(le):de&&de.add(le),le}function J(le,de,Me=100,be=!1,Pe=!1,Re,ze){let V,H,Y,X=0,fe;const we={leakWarningThreshold:Re,onWillAddFirstListener(){V=le(Ve=>{X++,H=de(H,Ve),be&&!Y&&(Te.fire(H),H=void 0),fe=()=>{const Ye=H;H=void 0,Y=void 0,(!be||X>1)&&Te.fire(Ye),X=0},typeof Me=="number"?(clearTimeout(Y),Y=setTimeout(fe,Me)):Y===void 0&&(Y=0,queueMicrotask(fe))})},onWillRemoveListener(){Pe&&X>0&&fe?.()},onDidRemoveLastListener(){fe=void 0,V.dispose()}};ze||D(we);const Te=new s(we);return ze?.add(Te),Te.event}k.debounce=J;function x(le,de=0,Me){return k.debounce(le,(be,Pe)=>be?(be.push(Pe),be):[Pe],de,void 0,!0,void 0,Me)}k.accumulate=x;function ce(le,de=(be,Pe)=>be===Pe,Me){let be=!0,Pe;return N(le,Re=>{const ze=be||!de(Re,Pe);return be=!1,Pe=Re,ze},Me)}k.latch=ce;function te(le,de,Me){return[k.filter(le,de,Me),k.filter(le,be=>!de(be),Me)]}k.split=te;function pe(le,de=!1,Me=[],be){let Pe=Me.slice(),Re=le(H=>{Pe?Pe.push(H):V.fire(H)});be&&be.add(Re);const ze=()=>{Pe?.forEach(H=>V.fire(H)),Pe=null},V=new s({onWillAddFirstListener(){Re||(Re=le(H=>V.fire(H)),be&&be.add(Re))},onDidAddFirstListener(){Pe&&(de?setTimeout(ze):ze())},onDidRemoveLastListener(){Re&&Re.dispose(),Re=null}});return be&&be.add(V),V.event}k.buffer=pe;function ye(le,de){return(be,Pe,Re)=>{const ze=de(new U);return le(function(V){const H=ze.evaluate(V);H!==_&&be.call(Pe,H)},void 0,Re)}}k.chain=ye;const _=Symbol("HaltChainable");class U{constructor(){this.f=[]}map(de){return this.f.push(de),this}forEach(de){return this.f.push(Me=>(de(Me),Me)),this}filter(de){return this.f.push(Me=>de(Me)?Me:_),this}reduce(de,Me){let be=Me;return this.f.push(Pe=>(be=de(be,Pe),be)),this}latch(de=(Me,be)=>Me===be){let Me=!0,be;return this.f.push(Pe=>{const Re=Me||!de(Pe,be);return Me=!1,be=Pe,Re?Pe:_}),this}evaluate(de){for(const Me of this.f)if(de=Me(de),de===_)break;return de}}function he(le,de,Me=be=>be){const be=(...V)=>ze.fire(Me(...V)),Pe=()=>le.on(de,be),Re=()=>le.removeListener(de,be),ze=new s({onWillAddFirstListener:Pe,onDidRemoveLastListener:Re});return ze.event}k.fromNodeEventEmitter=he;function Se(le,de,Me=be=>be){const be=(...V)=>ze.fire(Me(...V)),Pe=()=>le.addEventListener(de,be),Re=()=>le.removeEventListener(de,be),ze=new s({onWillAddFirstListener:Pe,onDidRemoveLastListener:Re});return ze.event}k.fromDOMEventEmitter=Se;function me(le){return new Promise(de=>W(le)(de))}k.toPromise=me;function ie(le){const de=new s;return le.then(Me=>{de.fire(Me)},()=>{de.fire(void 0)}).finally(()=>{de.dispose()}),de.event}k.fromPromise=ie;function se(le,de,Me){return de(Me),le(be=>de(be))}k.runAndSubscribe=se;class oe{constructor(de,Me){this._observable=de,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{de.addObserver(this)},onDidRemoveLastListener:()=>{de.removeObserver(this)}};Me||D(be),this.emitter=new s(be),Me&&Me.add(this.emitter)}beginUpdate(de){this.f++}handlePossibleChange(de){}handleChange(de,Me){this.g=!0}endUpdate(de){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function G(le,de){return new oe(le,de).emitter.event}k.fromObservable=G;function ee(le){return(de,Me,be)=>{let Pe=0,Re=!1;const ze={beginUpdate(){Pe++},endUpdate(){Pe--,Pe===0&&(le.reportChanges(),Re&&(Re=!1,de.call(Me)))},handlePossibleChange(){},handleChange(){Re=!0}};le.addObserver(ze),le.reportChanges();const V={dispose(){le.removeObserver(ze)}};return be instanceof I.$Tc?be.add(V):Array.isArray(be)&&be.push(V),V}}k.fromObservableLight=ee})(A||(e.Event=A={}));class P{constructor(D){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${D}_${P.f++}`,P.all.add(this)}start(D){this.g=new L.$3d,this.listenerCount=D}stop(){if(this.g){const D=this.g.elapsed();this.durations.push(D),this.elapsedOverall+=D,this.invocationCount+=1,this.g=void 0}}}e.$5d=P,P.all=new Set,P.f=0;let b=-1;function C(k){const D=b;return b=k,{dispose(){b=D}}}class y{constructor(D,F=Math.random().toString(18).slice(2,5)){this.threshold=D,this.name=F,this.g=0}dispose(){this.f?.clear()}check(D,F){const W=this.threshold;if(W<=0||F<W)return;this.f||(this.f=new Map);const B=this.f.get(D.value)||0;if(this.f.set(D.value,B+1),this.g-=1,this.g<=0){this.g=W*.5;let j,N=0;for(const[T,O]of this.f)(!j||N<O)&&(j=T,N=O);console.warn(`[${this.name}] potential listener LEAK detected, having ${F} listeners already. MOST frequent listener (${N}):`),console.warn(j)}return()=>{const j=this.f.get(D.value)||0;this.f.set(D.value,j-1)}}}class a{static create(){return new a(new Error().stack??"")}constructor(D){this.value=D}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class c{constructor(D){this.value=D,this.id=m++}}const i=2,n=(k,D)=>{if(k instanceof c)D(k);else for(let F=0;F<k.length;F++){const W=k[F];W&&D(W)}},r=p?new FinalizationRegistry(k=>{typeof k=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(k))}):void 0;class s{constructor(D){this.w=0,this.f=D,this.g=b>0||this.f?.leakWarningThreshold?new y(this.f?.leakWarningThreshold??b):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if($){const D=this.t;queueMicrotask(()=>{n(D,F=>F.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(D,F,W)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),I.$Uc.None;if(this.m)return I.$Uc.None;F&&(D=D.bind(F));const B=new c(D);let j,N;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(B.stack=a.create(),j=this.g.check(B.stack,this.w+1)),$&&(B.stack=N??a.create()),this.t?this.t instanceof c?(this.u??(this.u=new f),this.t=[this.t,B]):this.t.push(B):(this.f?.onWillAddFirstListener?.(this),this.t=B,this.f?.onDidAddFirstListener?.(this)),this.w++;const T=(0,I.$Sc)(()=>{r?.unregister(T),j?.(),this.x(B)});if(W instanceof I.$Tc?W.add(T):Array.isArray(W)&&W.push(T),r){const O=new Error().stack.split(`
`).slice(2).join(`
`).trim();r.register(T,O,T)}return T}),this.q}x(D){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const F=this.t,W=F.indexOf(D);if(W===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,F[W]=void 0;const B=this.u.current===this;if(this.w*i<=F.length){let j=0;for(let N=0;N<F.length;N++)F[N]?F[j++]=F[N]:B&&(this.u.end--,j<this.u.i&&this.u.i--);F.length=j}}y(D,F){if(!D)return;const W=this.f?.onListenerError||o.$1;if(!W){D.value(F);return}try{D.value(F)}catch(B){W(B)}}z(D){const F=D.current.t;for(;D.i<D.end;)this.y(F[D.i++],D.value);D.reset()}fire(D){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof c)this.y(this.t,D);else{const F=this.u;F.enqueue(this,D,this.t.length),this.z(F)}this.j?.stop()}hasListeners(){return this.w>0}}e.$7d=s;const t=()=>new f;e.$8d=t;class f{constructor(){this.i=-1,this.end=0}enqueue(D,F,W){this.i=0,this.end=W,this.current=D,this.value=F}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class d extends s{async fireAsync(D,F,W){if(this.t)for(this.h||(this.h=new M.$5c),n(this.t,B=>this.h.push([B.value,D]));this.h.size>0&&!F.isCancellationRequested;){const[B,j]=this.h.shift(),N=[],T={...j,token:F,waitUntil:O=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");W&&(O=W(O,B)),N.push(O)}};try{B(T)}catch(O){(0,o.$1)(O);continue}Object.freeze(N),await Promise.allSettled(N).then(O=>{for(const z of O)z.status==="rejected"&&(0,o.$1)(z.reason)})}}}e.$9d=d;class u extends s{get isPaused(){return this.h!==0}constructor(D){super(D),this.h=0,this.s=new M.$5c,this.A=D?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const D=Array.from(this.s);this.s.clear(),super.fire(this.A(D))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(D){this.w&&(this.h!==0?this.s.push(D):super.fire(D))}}e.$0d=u;class h extends u{constructor(D){super(D),this.k=D.delay??100}fire(D){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(D)}}e.$$d=h;class l extends s{constructor(D){super(D),this.h=[],this.k=D?.merge}fire(D){this.hasListeners()&&(this.h.push(D),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(F=>super.fire(F)),this.h=[]}))}}e.$_d=l;class g{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(D){const F={event:D,listener:null};this.h.push(F),this.g&&this.m(F);const W=()=>{this.g&&this.o(F);const B=this.h.indexOf(F);this.h.splice(B,1)};return(0,I.$Sc)((0,R.$db)(W))}j(){this.g=!0,this.h.forEach(D=>this.m(D))}k(){this.g=!1,this.h.forEach(D=>this.o(D))}m(D){D.listener=D.event(F=>this.f.fire(F))}o(D){D.listener?.dispose(),D.listener=null}dispose(){this.f.dispose();for(const D of this.h)D.listener?.dispose();this.h=[]}}e.$ae=g;class E{constructor(D,F,W,B){this.f=new I.$Tc;const j=this.f.add(new g),N=this.f.add(new I.$4c);function T(O){N.set(O,j.add(B(O)))}for(const O of D)T(O);this.f.add(F(O=>{T(O)})),this.f.add(W(O=>{N.deleteAndDispose(O)})),this.event=j.event}dispose(){this.f.dispose()}}e.$be=E;class v{constructor(){this.f=[]}wrapEvent(D){return(F,W,B)=>D(j=>{const N=this.f[this.f.length-1];N?N.push(()=>F.call(W,j)):F.call(W,j)},void 0,B)}bufferEvents(D){const F=[];this.f.push(F);const W=D();return this.f.pop(),F.forEach(B=>B()),W}}e.$ce=v;class S{constructor(){this.f=!1,this.g=A.None,this.h=I.$Uc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(D){this.g=D,this.f&&(this.h.dispose(),this.h=D(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$de=S}),define(Ee[22],Ce([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.CancellationToken=void 0;const R=Object.freeze(function(p,$){const w=setTimeout(p.bind($),0);return{dispose(){clearTimeout(w)}}});var I;(function(p){function $(w){return w===p.None||w===p.Cancelled||w instanceof M?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}p.isCancellationToken=$,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:o.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(I||(e.CancellationToken=I={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new o.$7d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=I.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=I.None}}e.$ee=L}),define(Ee[169],Ce([1,0,22]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Re=e.$Qe=e.$Pe=void 0;class R{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new o.$ee,$=this.b(p.token);return this.a={promise:$,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$Pe=R;class I{constructor(p,$=JSON.stringify){this.c=p,this.d=$,this.a=void 0,this.b=void 0}get(p){const $=this.d(p);return this.b!==$&&(this.b=$,this.a=this.c(p)),this.a}}e.$Qe=I;class M{get cachedValues(){return this.a}constructor(p){this.b=p,this.a=new Map}get(p){if(this.a.has(p))return this.a.get(p);const $=this.b(p);return this.a.set(p,$),$}}e.$Re=M}),define(Ee[100],Ce([1,0,13,3]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=I,e.$ge=M,e.$he=L,e.$ie=p,e.$je=w,e.$ke=A,e.$le=P,e.$me=b,e.$ne=C,e.$oe=y,e.$pe=a,e.$qe=m,e.$re=c,e.$se=i,e.$te=n;function I(r){const s=r;return s?typeof s.read=="function":!1}function M(r){const s=r;return s?[s.on,s.pause,s.resume,s.destroy].every(t=>typeof t=="function"):!1}function L(r){const s=r;return s?M(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function p(r,s){return new $(r,s)}class ${constructor(s,t){this.e=s,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(t=>t(s))}h(s){this.c.error.length===0?(0,o.$1)(s):this.c.error.slice(0).forEach(t=>t(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,t){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(s,t){if(this.a.destroyed)return;let f;switch(s){case"data":f=this.c.data;break;case"end":f=this.c.end;break;case"error":f=this.c.error;break}if(f){const d=f.indexOf(t);d>=0&&f.splice(d,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(f=>f())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(r,s){const t=[];let f;for(;(f=r.read())!==null;)t.push(f);return s(t)}function A(r,s,t){const f=[];let d;for(;(d=r.read())!==null&&f.length<t;)f.push(d);return d===null&&f.length>0?s(f):{read:()=>{if(f.length>0)return f.shift();if(typeof d<"u"){const u=d;return d=void 0,u}return r.read()}}}function P(r,s){return new Promise((t,f)=>{const d=[];b(r,{onData:u=>{s&&d.push(u)},onError:u=>{s?f(u):t(void 0)},onEnd:()=>{t(s?s(d):void 0)}})})}function b(r,s,t){r.on("error",f=>{t?.isCancellationRequested||s.onError(f)}),r.on("end",()=>{t?.isCancellationRequested||s.onEnd()}),r.on("data",f=>{t?.isCancellationRequested||s.onData(f)})}function C(r,s){return new Promise((t,f)=>{const d=new R.$Tc,u=[],h=E=>{if(u.push(E),u.length>s)return d.dispose(),r.pause(),t({stream:r,buffer:u,ended:!1})},l=E=>(d.dispose(),f(E)),g=()=>(d.dispose(),t({stream:r,buffer:u,ended:!0}));d.add((0,R.$Sc)(()=>r.removeListener("error",l))),r.on("error",l),d.add((0,R.$Sc)(()=>r.removeListener("end",g))),r.on("end",g),d.add((0,R.$Sc)(()=>r.removeListener("data",h))),r.on("data",h)})}function y(r,s){const t=p(s);return t.end(r),t}function a(){const r=p(()=>{throw new Error("not supported")});return r.end(),r}function m(r){let s=!1;return{read:()=>s?null:(s=!0,r)}}function c(r,s,t){const f=p(t);return b(r,{onData:d=>f.write(s.data(d)),onError:d=>f.error(s.error?s.error(d):d),onEnd:()=>f.end()}),f}function i(r,s,t){let f=!1;return{read:()=>{const d=s.read();return f?d:(f=!0,d!==null?t([r,d]):r)}}}function n(r,s,t){let f=!1;const d=p(t);return b(s,{onData:u=>f?d.write(u):(f=!0,d.write(t([r,u]))),onError:u=>d.error(u),onEnd:()=>{f||(f=!0,d.write(r)),d.end()}}),d}}),define(Ee[21],Ce([1,0,46,100]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=w,e.$we=A,e.$xe=P,e.$ye=b,e.$ze=C,e.$Ae=y,e.$Be=a,e.$Ce=m,e.$De=c,e.$Ee=i,e.$Fe=n,e.$Ge=r,e.$He=s,e.$Ie=t,e.$Je=f,e.$Ke=d,e.$Le=u,e.$Me=h,e.$Ne=l,e.$Oe=v;const I=typeof Buffer<"u",M=new o.$V(()=>new Uint8Array(256));let L,p;class ${static alloc(k){return I?new $(Buffer.allocUnsafe(k)):new $(new Uint8Array(k))}static wrap(k){return I&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new $(k)}static fromString(k,D){return!(D?.dontUseNodeBuffer||!1)&&I?new $(Buffer.from(k)):(L||(L=new TextEncoder),new $(L.encode(k)))}static fromByteArray(k){const D=$.alloc(k.length);for(let F=0,W=k.length;F<W;F++)D.buffer[F]=k[F];return D}static concat(k,D){if(typeof D>"u"){D=0;for(let B=0,j=k.length;B<j;B++)D+=k[B].byteLength}const F=$.alloc(D);let W=0;for(let B=0,j=k.length;B<j;B++){const N=k[B];F.set(N,W),W+=N.byteLength}return F}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=$.alloc(this.byteLength);return k.set(this),k}toString(){return I?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(k,D){return new $(this.buffer.subarray(k,D))}set(k,D){if(k instanceof $)this.buffer.set(k.buffer,D);else if(k instanceof Uint8Array)this.buffer.set(k,D);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),D);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return b(this.buffer,k)}writeUInt32BE(k,D){C(this.buffer,k,D)}readUInt32LE(k){return y(this.buffer,k)}writeUInt32LE(k,D){a(this.buffer,k,D)}readUInt8(k){return m(this.buffer,k)}writeUInt8(k,D){c(this.buffer,k,D)}indexOf(k,D=0){return w(this.buffer,k instanceof $?k.buffer:k,D)}}e.$ue=$;function w(S,k,D=0){const F=k.byteLength,W=S.byteLength;if(F===0)return 0;if(F===1)return S.indexOf(k[0]);if(F>W-D)return-1;const B=M.value;B.fill(k.length);for(let O=0;O<k.length;O++)B[k[O]]=k.length-O-1;let j=D+k.length-1,N=j,T=-1;for(;j<W;)if(S[j]===k[N]){if(N===0){T=j;break}j--,N--}else j+=Math.max(k.length-N,B[S[j]]),N=k.length-1;return T}function A(S,k){return S[k+0]<<0>>>0|S[k+1]<<8>>>0}function P(S,k,D){S[D+0]=k&255,k=k>>>8,S[D+1]=k&255}function b(S,k){return S[k]*2**24+S[k+1]*2**16+S[k+2]*2**8+S[k+3]}function C(S,k,D){S[D+3]=k,k=k>>>8,S[D+2]=k,k=k>>>8,S[D+1]=k,k=k>>>8,S[D]=k}function y(S,k){return S[k+0]<<0>>>0|S[k+1]<<8>>>0|S[k+2]<<16>>>0|S[k+3]<<24>>>0}function a(S,k,D){S[D+0]=k&255,k=k>>>8,S[D+1]=k&255,k=k>>>8,S[D+2]=k&255,k=k>>>8,S[D+3]=k&255}function m(S,k){return S[k]}function c(S,k,D){S[D]=k}function i(S){return R.$je(S,k=>$.concat(k))}function n(S){return R.$qe(S)}function r(S){return R.$le(S,k=>$.concat(k))}async function s(S){return S.ended?$.concat(S.buffer):$.concat([...S.buffer,await r(S.stream)])}function t(S){return R.$oe(S,k=>$.concat(k))}function f(S){return R.$re(S,{data:k=>typeof k=="string"?$.fromString(k):$.wrap(k)},k=>$.concat(k))}function d(S){return R.$ie(k=>$.concat(k),S)}function u(S,k){return R.$se(S,k,D=>$.concat(D))}function h(S,k){return R.$te(S,k,D=>$.concat(D))}function l(S){let k=0,D=0,F=0;const W=new Uint8Array(Math.floor(S.length/4*3)),B=N=>{switch(D){case 3:W[F++]=k|N,D=0;break;case 2:W[F++]=k|N>>>2,k=N<<6,D=3;break;case 1:W[F++]=k|N>>>4,k=N<<4,D=2;break;default:k=N<<2,D=1}};for(let N=0;N<S.length;N++){const T=S.charCodeAt(N);if(T>=65&&T<=90)B(T-65);else if(T>=97&&T<=122)B(T-97+26);else if(T>=48&&T<=57)B(T-48+52);else if(T===43||T===45)B(62);else if(T===47||T===95)B(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${S[N]}`)}}const j=F;for(;D>0;)B(0);return $.wrap(W).slice(0,j)}const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:S},k=!0,D=!1){const F=D?E:g;let W="";const B=S.byteLength%3;let j=0;for(;j<S.byteLength-B;j+=3){const N=S[j+0],T=S[j+1],O=S[j+2];W+=F[N>>>2],W+=F[(N<<4|T>>>4)&63],W+=F[(T<<2|O>>>6)&63],W+=F[O&63]}if(B===1){const N=S[j+0];W+=F[N>>>2],W+=F[N<<4&63],k&&(W+="==")}else if(B===2){const N=S[j+0],T=S[j+1];W+=F[N>>>2],W+=F[(N<<4|T>>>4)&63],W+=F[T<<2&63],k&&(W+="=")}return W}}),define(Ee[14],Ce([1,0,169,46]),function(re,e,o,R){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Uf=e.$Tf=e.$Sf=e.GraphemeBreakType=e.$If=e.$Bf=e.$uf=e.$tf=void 0,e.$Ue=M,e.$Ve=p,e.$We=w,e.$Xe=A,e.$Ye=P,e.$Ze=b,e.$1e=C,e.$2e=y,e.$3e=a,e.$4e=m,e.$5e=c,e.$6e=i,e.$7e=n,e.$8e=r,e.$9e=s,e.$0e=t,e.$$e=f,e.$_e=d,e.$af=u,e.$bf=h,e.$cf=l,e.$df=g,e.$ef=E,e.$ff=v,e.$gf=S,e.$hf=k,e.$if=D,e.$jf=F,e.$kf=W,e.$lf=B,e.$mf=j,e.$nf=N,e.$of=T,e.$pf=O,e.$qf=z,e.$rf=Q,e.$sf=Z,e.$vf=te,e.$wf=pe,e.$xf=ye,e.$yf=_,e.$zf=Se,e.$Af=ie,e.$Cf=se,e.$Df=oe,e.$Ef=G,e.$Ff=ee,e.$Gf=de,e.$Hf=Me,e.$Jf=be,e.$Kf=Pe,e.$Lf=Re,e.$Mf=ze,e.$Nf=V,e.$Of=H,e.$Pf=Y,e.$Qf=X,e.$Rf=Ye;function M(Ie){return!Ie||typeof Ie!="string"?!0:Ie.trim().length===0}const L=/{(\d+)}/g;function p(Ie,...We){return We.length===0?Ie:Ie.replace(L,function(Ae,Ke){const ae=parseInt(Ke,10);return isNaN(ae)||ae<0||ae>=We.length?Ae:We[ae]})}const $=/{([^}]+)}/g;function w(Ie,We){return Object.keys(We).length===0?Ie:Ie.replace($,(Ae,Ke)=>We[Ke]??Ae)}function A(Ie){return Ie.replace(/[<>"'&]/g,We=>{switch(We){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return We})}function P(Ie){return Ie.replace(/[<>&]/g,function(We){switch(We){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return We}})}function b(Ie){return Ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function C(Ie,We){let Ae=0;const Ke=We.charCodeAt(0);for(let ae=Ie.length-1;ae>=0;ae--)Ie.charCodeAt(ae)===Ke&&Ae++;return Ae}function y(Ie,We,Ae="\u2026"){return Ie.length<=We?Ie:`${Ie.substr(0,We)}${Ae}`}function a(Ie,We,Ae="\u2026"){if(Ie.length<=We)return Ie;const Ke=Math.ceil(We/2)-Ae.length/2,ae=Math.floor(We/2)-Ae.length/2;return`${Ie.substr(0,Ke)}${Ae}${Ie.substr(Ie.length-ae)}`}function m(Ie,We=" "){const Ae=c(Ie,We);return i(Ae,We)}function c(Ie,We){if(!Ie||!We)return Ie;const Ae=We.length;if(Ae===0||Ie.length===0)return Ie;let Ke=0;for(;Ie.indexOf(We,Ke)===Ke;)Ke=Ke+Ae;return Ie.substring(Ke)}function i(Ie,We){if(!Ie||!We)return Ie;const Ae=We.length,Ke=Ie.length;if(Ae===0||Ke===0)return Ie;let ae=Ke,ue=-1;for(;ue=Ie.lastIndexOf(We,ae-1),!(ue===-1||ue+Ae!==ae);){if(ue===0)return"";ae=ue}return Ie.substring(0,ae)}function n(Ie){return Ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function r(Ie){return Ie.replace(/\*/g,"")}function s(Ie,We,Ae={}){if(!Ie)throw new Error("Cannot create regex from empty string");We||(Ie=b(Ie)),Ae.wholeWord&&(/\B/.test(Ie.charAt(0))||(Ie="\\b"+Ie),/\B/.test(Ie.charAt(Ie.length-1))||(Ie=Ie+"\\b"));let Ke="";return Ae.global&&(Ke+="g"),Ae.matchCase||(Ke+="i"),Ae.multiline&&(Ke+="m"),Ae.unicode&&(Ke+="u"),new RegExp(Ie,Ke)}function t(Ie){return Ie.source==="^"||Ie.source==="^$"||Ie.source==="$"||Ie.source==="^\\s*$"?!1:!!(Ie.exec("")&&Ie.lastIndex===0)}function f(Ie){return Ie.split(/\r\n|\r|\n/)}function d(Ie){const We=[],Ae=Ie.split(/(\r\n|\r|\n)/);for(let Ke=0;Ke<Math.ceil(Ae.length/2);Ke++)We.push(Ae[2*Ke]+(Ae[2*Ke+1]??""));return We}function u(Ie){for(let We=0,Ae=Ie.length;We<Ae;We++){const Ke=Ie.charCodeAt(We);if(Ke!==32&&Ke!==9)return We}return-1}function h(Ie,We=0,Ae=Ie.length){for(let Ke=We;Ke<Ae;Ke++){const ae=Ie.charCodeAt(Ke);if(ae!==32&&ae!==9)return Ie.substring(We,Ke)}return Ie.substring(We,Ae)}function l(Ie,We=Ie.length-1){for(let Ae=We;Ae>=0;Ae--){const Ke=Ie.charCodeAt(Ae);if(Ke!==32&&Ke!==9)return Ae}return-1}function g(Ie,We,Ae){const Ke=[];let ae=0;for(const ue of Ie.matchAll(We)){if(Ke.push(Ie.slice(ae,ue.index)),ue.index===void 0)throw new Error("match.index should be defined");ae=ue.index+ue[0].length,Ke.push(Ae(ue[0],...ue.slice(1),ue.index,Ie,ue.groups))}return Ke.push(Ie.slice(ae)),Promise.all(Ke).then(ue=>ue.join(""))}function E(Ie,We){return Ie<We?-1:Ie>We?1:0}function v(Ie,We,Ae=0,Ke=Ie.length,ae=0,ue=We.length){for(;Ae<Ke&&ae<ue;Ae++,ae++){const et=Ie.charCodeAt(Ae),Ne=We.charCodeAt(ae);if(et<Ne)return-1;if(et>Ne)return 1}const De=Ke-Ae,Je=ue-ae;return De<Je?-1:De>Je?1:0}function S(Ie,We){return k(Ie,We,0,Ie.length,0,We.length)}function k(Ie,We,Ae=0,Ke=Ie.length,ae=0,ue=We.length){for(;Ae<Ke&&ae<ue;Ae++,ae++){let et=Ie.charCodeAt(Ae),Ne=We.charCodeAt(ae);if(et===Ne)continue;if(et>=128||Ne>=128)return v(Ie.toLowerCase(),We.toLowerCase(),Ae,Ke,ae,ue);F(et)&&(et-=32),F(Ne)&&(Ne-=32);const ht=et-Ne;if(ht!==0)return ht}const De=Ke-Ae,Je=ue-ae;return De<Je?-1:De>Je?1:0}function D(Ie){return Ie>=48&&Ie<=57}function F(Ie){return Ie>=97&&Ie<=122}function W(Ie){return Ie>=65&&Ie<=90}function B(Ie,We){return Ie.length===We.length&&k(Ie,We)===0}function j(Ie,We){const Ae=We.length;return We.length>Ie.length?!1:k(Ie,We,0,Ae)===0}function N(Ie,We){const Ae=Math.min(Ie.length,We.length);let Ke;for(Ke=0;Ke<Ae;Ke++)if(Ie.charCodeAt(Ke)!==We.charCodeAt(Ke))return Ke;return Ae}function T(Ie,We){const Ae=Math.min(Ie.length,We.length);let Ke;const ae=Ie.length-1,ue=We.length-1;for(Ke=0;Ke<Ae;Ke++)if(Ie.charCodeAt(ae-Ke)!==We.charCodeAt(ue-Ke))return Ke;return Ae}function O(Ie){return 55296<=Ie&&Ie<=56319}function z(Ie){return 56320<=Ie&&Ie<=57343}function Q(Ie,We){return(Ie-55296<<10)+(We-56320)+65536}function Z(Ie,We,Ae){const Ke=Ie.charCodeAt(Ae);if(O(Ke)&&Ae+1<We){const ae=Ie.charCodeAt(Ae+1);if(z(ae))return Q(Ke,ae)}return Ke}function J(Ie,We){const Ae=Ie.charCodeAt(We-1);if(z(Ae)&&We>1){const Ke=Ie.charCodeAt(We-2);if(O(Ke))return Q(Ke,Ae)}return Ae}class x{get offset(){return this.e}constructor(We,Ae=0){this.c=We,this.d=We.length,this.e=Ae}setOffset(We){this.e=We}prevCodePoint(){const We=J(this.c,this.e);return this.e-=We>=65536?2:1,We}nextCodePoint(){const We=Z(this.c,this.d,this.e);return this.e+=We>=65536?2:1,We}eol(){return this.e>=this.d}}e.$tf=x;class ce{get offset(){return this.c.offset}constructor(We,Ae=0){this.c=new x(We,Ae)}nextGraphemeLength(){const We=Te.getInstance(),Ae=this.c,Ke=Ae.offset;let ae=We.getGraphemeBreakType(Ae.nextCodePoint());for(;!Ae.eol();){const ue=Ae.offset,De=We.getGraphemeBreakType(Ae.nextCodePoint());if(fe(ae,De)){Ae.setOffset(ue);break}ae=De}return Ae.offset-Ke}prevGraphemeLength(){const We=Te.getInstance(),Ae=this.c,Ke=Ae.offset;let ae=We.getGraphemeBreakType(Ae.prevCodePoint());for(;Ae.offset>0;){const ue=Ae.offset,De=We.getGraphemeBreakType(Ae.prevCodePoint());if(fe(De,ae)){Ae.setOffset(ue);break}ae=De}return Ke-Ae.offset}eol(){return this.c.eol()}}e.$uf=ce;function te(Ie,We){return new ce(Ie,We).nextGraphemeLength()}function pe(Ie,We){return new ce(Ie,We).prevGraphemeLength()}function ye(Ie,We){We>0&&z(Ie.charCodeAt(We))&&We--;const Ae=We+te(Ie,We);return[Ae-pe(Ie,Ae),Ae]}function _(Ie){const We=new ce(Ie);let Ae=0;for(;!We.eol();)Ae++,We.nextGraphemeLength();return Ae}let U;function he(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Se(Ie){return U||(U=he()),U.test(Ie)}const me=/^[\t\n\r\x20-\x7E]*$/;function ie(Ie){return me.test(Ie)}e.$Bf=/[\u2028\u2029]/;function se(Ie){return e.$Bf.test(Ie)}function oe(Ie){return Ie>=11904&&Ie<=55215||Ie>=63744&&Ie<=64255||Ie>=65281&&Ie<=65374}function G(Ie){return Ie>=127462&&Ie<=127487||Ie===8986||Ie===8987||Ie===9200||Ie===9203||Ie>=9728&&Ie<=10175||Ie===11088||Ie===11093||Ie>=127744&&Ie<=128591||Ie>=128640&&Ie<=128764||Ie>=128992&&Ie<=129008||Ie>=129280&&Ie<=129535||Ie>=129648&&Ie<=129782}function ee(Ie,We,Ae=""){const Ke=Ie.trimStart();if(Ke.length<We)return Ke;const ae=/\b/g;let ue=0;for(;ae.test(Ke)&&!(Ke.length-ae.lastIndex<We);)ue=ae.lastIndex,ae.lastIndex+=1;return ue===0?Ke:Ae+Ke.substring(ue).trimStart()}const le=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*de(Ie){let We=0;for(const Ae of Ie.matchAll(le))We!==Ae.index&&(yield{isCode:!1,str:Ie.substring(We,Ae.index)}),yield{isCode:!0,str:Ae[0]},We=Ae.index+Ae[0].length;We!==Ie.length&&(yield{isCode:!1,str:Ie.substring(We)})}function Me(Ie){return Ie&&(Ie=Ie.replace(le,"")),Ie}e.$If="\uFEFF";function be(Ie){return!!(Ie&&Ie.length>0&&Ie.charCodeAt(0)===65279)}function Pe(Ie){return be(Ie)?Ie.substr(1):Ie}function Re(Ie,We){if(!Ie||!We||Ie.length<We.length)return!1;const Ae=We.length,Ke=Ie.toLowerCase();let ae=0,ue=-1;for(;ae<Ae;){const De=Ke.indexOf(We[ae],ue+1);if(De<0)return!1;ue=De,ae++}return!0}function ze(Ie,We=!1){return Ie?(We&&(Ie=Ie.replace(/\\./g,"")),Ie.toLowerCase()!==Ie):!1}function V(Ie){return Ie.charAt(0).toUpperCase()+Ie.slice(1)}function H(Ie,We=1){if(We===0)return"";let Ae=-1;do Ae=Ie.indexOf(`
`,Ae+1),We--;while(We>0&&Ae>=0);return Ae===-1?Ie:(Ie[Ae-1]==="\r"&&Ae--,Ie.substr(0,Ae))}function Y(Ie){return Ie=Ie%(2*26),Ie<26?String.fromCharCode(97+Ie):String.fromCharCode(65+Ie-26)}function X(Ie){return Te.getInstance().getGraphemeBreakType(Ie)}function fe(Ie,We){return Ie===0?We!==5&&We!==7:Ie===2&&We===3?!1:Ie===4||Ie===2||Ie===3||We===4||We===2||We===3?!0:!(Ie===8&&(We===8||We===9||We===11||We===12)||(Ie===11||Ie===9)&&(We===9||We===10)||(Ie===12||Ie===10)&&We===10||We===5||We===13||We===7||Ie===1||Ie===13&&We===14||Ie===6&&We===6)}var we;(function(Ie){Ie[Ie.Other=0]="Other",Ie[Ie.Prepend=1]="Prepend",Ie[Ie.CR=2]="CR",Ie[Ie.LF=3]="LF",Ie[Ie.Control=4]="Control",Ie[Ie.Extend=5]="Extend",Ie[Ie.Regional_Indicator=6]="Regional_Indicator",Ie[Ie.SpacingMark=7]="SpacingMark",Ie[Ie.L=8]="L",Ie[Ie.V=9]="V",Ie[Ie.T=10]="T",Ie[Ie.LV=11]="LV",Ie[Ie.LVT=12]="LVT",Ie[Ie.ZWJ=13]="ZWJ",Ie[Ie.Extended_Pictographic=14]="Extended_Pictographic"})(we||(e.GraphemeBreakType=we={}));class Te{static getInstance(){return Te.c||(Te.c=new Te),Te.c}constructor(){this.d=Ve()}getGraphemeBreakType(We){if(We<32)return We===10?3:We===13?2:4;if(We<127)return 0;const Ae=this.d,Ke=Ae.length/3;let ae=1;for(;ae<=Ke;)if(We<Ae[3*ae])ae=2*ae;else if(We>Ae[3*ae+1])ae=2*ae+1;else return Ae[3*ae+2];return 0}}Te.c=null;function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ye(Ie,We){if(Ie===0)return 0;const Ae=nt(Ie,We);if(Ae!==void 0)return Ae;const Ke=new x(We,Ie);return Ke.prevCodePoint(),Ke.offset}function nt(Ie,We){const Ae=new x(We,Ie);let Ke=Ae.prevCodePoint();for(;ot(Ke)||Ke===65039||Ke===8419;){if(Ae.offset===0)return;Ke=Ae.prevCodePoint()}if(!G(Ke))return;let ae=Ae.offset;return ae>0&&Ae.prevCodePoint()===8205&&(ae=Ae.offset),ae}function ot(Ie){return 127995<=Ie&&Ie<=127999}var lt;(function(Ie){Ie[Ie.zwj=8205]="zwj",Ie[Ie.emojiVariantSelector=65039]="emojiVariantSelector",Ie[Ie.enclosingKeyCap=8419]="enclosingKeyCap"})(lt||(lt={})),e.$Sf="\xA0";class at{static getInstance(We){return I.d.get(Array.from(We))}static getLocales(){return I.e.value}constructor(We){this.f=We}isAmbiguous(We){return this.f.has(We)}getPrimaryConfusable(We){return this.f.get(We)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Tf=at,I=at,at.c=new R.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),at.d=new o.$Qe(Ie=>{function We(Ne){const ht=new Map;for(let vt=0;vt<Ne.length;vt+=2)ht.set(Ne[vt],Ne[vt+1]);return ht}function Ae(Ne,ht){const vt=new Map(Ne);for(const[Mt,zt]of ht)vt.set(Mt,zt);return vt}function Ke(Ne,ht){if(!Ne)return ht;const vt=new Map;for(const[Mt,zt]of Ne)ht.has(Mt)&&vt.set(Mt,zt);return vt}const ae=I.c.value;let ue=Ie.filter(Ne=>!Ne.startsWith("_")&&Ne in ae);ue.length===0&&(ue=["_default"]);let De;for(const Ne of ue){const ht=We(ae[Ne]);De=Ke(De,ht)}const Je=We(ae._common),et=Ae(Je,De);return new I(et)}),at.e=new R.$V(()=>Object.keys(I.c.value).filter(Ie=>!Ie.startsWith("_")));class st{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(st.c())),this.d}static isInvisibleCharacter(We){return st.e().has(We)}static get codePoints(){return st.e()}}e.$Uf=st,st.d=void 0}),define(Ee[128],Ce([1,0,27,167,14]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.FuzzyScore=e.$kk=e.$jk=void 0,e.or=M,e.$lk=p,e.$mk=$,e.$nk=P,e.$ok=l,e.$pk=g,e.$qk=F,e.$rk=W,e.$sk=B,e.$tk=j,e.$uk=he,e.$wk=se,e.$xk=ee,e.$yk=le;function M(...be){return function(Pe,Re){for(let ze=0,V=be.length;ze<V;ze++){const H=be[ze](Pe,Re);if(H)return H}return null}}e.$jk=L.bind(void 0,!1),e.$kk=L.bind(void 0,!0);function L(be,Pe,Re){if(!Re||Re.length<Pe.length)return null;let ze;return be?ze=I.$mf(Re,Pe):ze=Re.indexOf(Pe)===0,ze?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function p(be,Pe){const Re=Pe.toLowerCase().indexOf(be.toLowerCase());return Re===-1?null:[{start:Re,end:Re+be.length}]}function $(be,Pe){return w(be.toLowerCase(),Pe.toLowerCase(),0,0)}function w(be,Pe,Re,ze){if(Re===be.length)return[];if(ze===Pe.length)return null;if(be[Re]===Pe[ze]){let V=null;return(V=w(be,Pe,Re+1,ze+1))?r({start:ze,end:ze+1},V):null}return w(be,Pe,Re,ze+1)}function A(be){return 97<=be&&be<=122}function P(be){return 65<=be&&be<=90}function b(be){return 48<=be&&be<=57}function C(be){return be===32||be===9||be===10||be===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(be=>y.add(be.charCodeAt(0)));function a(be){return C(be)||y.has(be)}function m(be,Pe){return be===Pe||a(be)&&a(Pe)}const c=new Map;function i(be){if(c.has(be))return c.get(be);let Pe;const Re=(0,R.$hk)(be);return Re&&(Pe=Re),c.set(be,Pe),Pe}function n(be){return A(be)||P(be)||b(be)}function r(be,Pe){return Pe.length===0?Pe=[be]:be.end===Pe[0].start?Pe[0].start=be.start:Pe.unshift(be),Pe}function s(be,Pe){for(let Re=Pe;Re<be.length;Re++){const ze=be.charCodeAt(Re);if(P(ze)||b(ze)||Re>0&&!n(be.charCodeAt(Re-1)))return Re}return be.length}function t(be,Pe,Re,ze){if(Re===be.length)return[];if(ze===Pe.length)return null;if(be[Re]!==Pe[ze].toLowerCase())return null;{let V=null,H=ze+1;for(V=t(be,Pe,Re+1,ze+1);!V&&(H=s(Pe,H))<Pe.length;)V=t(be,Pe,Re+1,H),H++;return V===null?null:r({start:ze,end:ze+1},V)}}function f(be){let Pe=0,Re=0,ze=0,V=0,H=0;for(let Te=0;Te<be.length;Te++)H=be.charCodeAt(Te),P(H)&&Pe++,A(H)&&Re++,n(H)&&ze++,b(H)&&V++;const Y=Pe/be.length,X=Re/be.length,fe=ze/be.length,we=V/be.length;return{upperPercent:Y,lowerPercent:X,alphaPercent:fe,numericPercent:we}}function d(be){const{upperPercent:Pe,lowerPercent:Re}=be;return Re===0&&Pe>.6}function u(be){const{upperPercent:Pe,lowerPercent:Re,alphaPercent:ze,numericPercent:V}=be;return Re>.2&&Pe<.8&&ze>.6&&V<.2}function h(be){let Pe=0,Re=0,ze=0,V=0;for(let H=0;H<be.length;H++)ze=be.charCodeAt(H),P(ze)&&Pe++,A(ze)&&Re++,C(ze)&&V++;return(Pe===0||Re===0)&&V===0?be.length<=30:Pe<=5}function l(be,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!h(be))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Re=f(Pe);if(!u(Re)){if(!d(Re))return null;Pe=Pe.toLowerCase()}let ze=null,V=0;for(be=be.toLowerCase();V<Pe.length&&(ze=t(be,Pe,0,V))===null;)V=s(Pe,V+1);return ze}function g(be,Pe,Re=!1){if(!Pe||Pe.length===0)return null;let ze=null,V=0;for(be=be.toLowerCase(),Pe=Pe.toLowerCase();V<Pe.length&&(ze=E(be,Pe,0,V,Re),ze===null);)V=v(Pe,V+1);return ze}function E(be,Pe,Re,ze,V){let H=0;if(Re===be.length)return[];if(ze===Pe.length)return null;if(!m(be.charCodeAt(Re),Pe.charCodeAt(ze))){const fe=i(be.charCodeAt(Re));if(!fe)return null;for(let we=0;we<fe.length;we++)if(!m(fe[we],Pe.charCodeAt(ze+we)))return null;H+=fe.length-1}let Y=null,X=ze+H+1;if(Y=E(be,Pe,Re+1,X,V),!V)for(;!Y&&(X=v(Pe,X))<Pe.length;)Y=E(be,Pe,Re+1,X,V),X++;if(!Y)return null;if(be.charCodeAt(Re)!==Pe.charCodeAt(ze)){const fe=i(be.charCodeAt(Re));if(!fe)return Y;for(let we=0;we<fe.length;we++)if(fe[we]!==Pe.charCodeAt(ze+we))return Y}return r({start:ze,end:ze+H+1},Y)}function v(be,Pe){for(let Re=Pe;Re<be.length;Re++)if(a(be.charCodeAt(Re))||Re>0&&a(be.charCodeAt(Re-1)))return Re;return be.length}const S=M(e.$kk,l,p),k=M(e.$kk,l,$),D=new o.$Ec(1e4);function F(be,Pe,Re=!1){if(typeof be!="string"||typeof Pe!="string")return null;let ze=D.get(be);ze||(ze=new RegExp(I.$7e(be),"i"),D.set(be,ze));const V=ze.exec(Pe);return V?[{start:V.index,end:V.index+V[0].length}]:Re?k(be,Pe):S(be,Pe)}function W(be,Pe){const Re=se(be,be.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Re?j(Re):null}function B(be,Pe,Re,ze,V,H){const Y=Math.min(13,be.length);for(;Re<Y;Re++){const X=se(be,Pe,Re,ze,V,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(X)return X}return[0,H]}function j(be){if(typeof be>"u")return[];const Pe=[],Re=be[1];for(let ze=be.length-1;ze>1;ze--){const V=be[ze]+Re,H=Pe[Pe.length-1];H&&H.end===V?H.end=V+1:Pe.push({start:V,end:V+1})}return Pe}const N=128;function T(){const be=[],Pe=[];for(let Re=0;Re<=N;Re++)Pe[Re]=0;for(let Re=0;Re<=N;Re++)be.push(Pe.slice(0));return be}function O(be){const Pe=[];for(let Re=0;Re<=be;Re++)Pe[Re]=0;return Pe}const z=O(2*N),Q=O(2*N),Z=T(),J=T(),x=T(),ce=!1;function te(be,Pe,Re,ze,V){function H(X,fe,we=" "){for(;X.length<fe;)X=we+X;return X}let Y=` |   |${ze.split("").map(X=>H(X,3)).join("|")}
`;for(let X=0;X<=Re;X++)X===0?Y+=" |":Y+=`${Pe[X-1]}|`,Y+=be[X].slice(0,V+1).map(fe=>H(fe.toString(),3)).join("|")+`
`;return Y}function pe(be,Pe,Re,ze){be=be.substr(Pe),Re=Re.substr(ze),console.log(te(J,be,be.length,Re,Re.length)),console.log(te(x,be,be.length,Re,Re.length)),console.log(te(Z,be,be.length,Re,Re.length))}function ye(be,Pe){if(Pe<0||Pe>=be.length)return!1;const Re=be.codePointAt(Pe);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!I.$Ef(Re)}}function _(be,Pe){if(Pe<0||Pe>=be.length)return!1;switch(be.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function U(be,Pe,Re){return Pe[be]!==Re[be]}function he(be,Pe,Re,ze,V,H,Y=!1){for(;Pe<Re&&V<H;)be[Pe]===ze[V]&&(Y&&(z[Pe]=V),Pe+=1),V+=1;return Pe===Re}var Se;(function(be){be[be.Diag=1]="Diag",be[be.Left=2]="Left",be[be.LeftLeft=3]="LeftLeft"})(Se||(Se={}));var me;(function(be){be.Default=[-100,0];function Pe(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}be.isDefault=Pe})(me||(e.FuzzyScore=me={}));class ie{constructor(Pe,Re){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Re}}e.$vk=ie,ie.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function se(be,Pe,Re,ze,V,H,Y=ie.default){const X=be.length>N?N:be.length,fe=ze.length>N?N:ze.length;if(Re>=X||H>=fe||X-Re>fe-H||!he(Pe,Re,X,V,H,fe,!0))return;oe(X,fe,Re,H,Pe,V);let we=1,Te=1,Ve=Re,Ye=H;const nt=[!1];for(we=1,Ve=Re;Ve<X;we++,Ve++){const Ie=z[Ve],We=Q[Ve],Ae=Ve+1<X?Q[Ve+1]:fe;for(Te=Ie-H+1,Ye=Ie;Ye<Ae;Te++,Ye++){let Ke=Number.MIN_SAFE_INTEGER,ae=!1;Ye<=We&&(Ke=G(be,Pe,Ve,Re,ze,V,Ye,fe,H,Z[we-1][Te-1]===0,nt));let ue=0;Ke!==Number.MAX_SAFE_INTEGER&&(ae=!0,ue=Ke+J[we-1][Te-1]);const De=Ye>Ie,Je=De?J[we][Te-1]+(Z[we][Te-1]>0?-5:0):0,et=Ye>Ie+1&&Z[we][Te-1]>0,Ne=et?J[we][Te-2]+(Z[we][Te-2]>0?-5:0):0;if(et&&(!De||Ne>=Je)&&(!ae||Ne>=ue))J[we][Te]=Ne,x[we][Te]=3,Z[we][Te]=0;else if(De&&(!ae||Je>=ue))J[we][Te]=Je,x[we][Te]=2,Z[we][Te]=0;else if(ae)J[we][Te]=ue,x[we][Te]=1,Z[we][Te]=Z[we-1][Te-1]+1;else throw new Error("not possible")}}if(ce&&pe(be,Re,ze,H),!nt[0]&&!Y.firstMatchCanBeWeak)return;we--,Te--;const ot=[J[we][Te],H];let lt=0,at=0;for(;we>=1;){let Ie=Te;do{const We=x[we][Ie];if(We===3)Ie=Ie-2;else if(We===2)Ie=Ie-1;else break}while(Ie>=1);lt>1&&Pe[Re+we-1]===V[H+Te-1]&&!U(Ie+H-1,ze,V)&&lt+1>Z[we][Ie]&&(Ie=Te),Ie===Te?lt++:lt=1,at||(at=Ie),we--,Te=Ie-1,ot.push(Te)}fe===X&&Y.boostFullMatch&&(ot[0]+=2);const st=at-X;return ot[0]-=st,ot}function oe(be,Pe,Re,ze,V,H){let Y=be-1,X=Pe-1;for(;Y>=Re&&X>=ze;)V[Y]===H[X]&&(Q[Y]=X,Y--),X--}function G(be,Pe,Re,ze,V,H,Y,X,fe,we,Te){if(Pe[Re]!==H[Y])return Number.MIN_SAFE_INTEGER;let Ve=1,Ye=!1;return Y===Re-ze?Ve=be[Re]===V[Y]?7:5:U(Y,V,H)&&(Y===0||!U(Y-1,V,H))?(Ve=be[Re]===V[Y]?7:5,Ye=!0):ye(H,Y)&&(Y===0||!ye(H,Y-1))?Ve=5:(ye(H,Y-1)||_(H,Y-1))&&(Ve=5,Ye=!0),Ve>1&&Re===ze&&(Te[0]=!0),Ye||(Ye=U(Y,V,H)||ye(H,Y-1)||_(H,Y-1)),Re===ze?Y>fe&&(Ve-=Ye?3:5):we?Ve+=Ye?2:0:Ve+=Ye?0:1,Y+1===X&&(Ve-=Ye?3:5),Ve}function ee(be,Pe,Re,ze,V,H,Y){return de(be,Pe,Re,ze,V,H,!0,Y)}function le(be,Pe,Re,ze,V,H,Y){return de(be,Pe,Re,ze,V,H,!1,Y)}function de(be,Pe,Re,ze,V,H,Y,X){let fe=se(be,Pe,Re,ze,V,H,X);if(fe&&!Y)return fe;if(be.length>=3){const we=Math.min(7,be.length-1);for(let Te=Re+1;Te<we;Te++){const Ve=Me(be,Te);if(Ve){const Ye=se(Ve,Ve.toLowerCase(),Re,ze,V,H,X);Ye&&(Ye[0]-=3,(!fe||Ye[0]>fe[0])&&(fe=Ye))}}}return fe}function Me(be,Pe){if(Pe+1>=be.length)return;const Re=be[Pe],ze=be[Pe+1];if(Re!==ze)return be.slice(0,Pe)+ze+Re+be.slice(Pe+2)}}),define(Ee[55],Ce([1,0,14]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$aj=void 0,e.$9i=R,e.$0i=I,e.$$i=M,e.$_i=p,e.$bj=a;function R(c){return I(c,0)}function I(c,i){switch(typeof c){case"object":return c===null?M(349,i):Array.isArray(c)?$(c,i):w(c,i);case"string":return p(c,i);case"boolean":return L(c,i);case"number":return M(c,i);case"undefined":return M(937,i);default:return M(617,i)}}function M(c,i){return(i<<5)-i+c|0}function L(c,i){return M(c?433:863,i)}function p(c,i){i=M(149417,i);for(let n=0,r=c.length;n<r;n++)i=M(c.charCodeAt(n),i);return i}function $(c,i){return i=M(104579,i),c.reduce((n,r)=>I(r,n),i)}function w(c,i){return i=M(181387,i),Object.keys(c).sort().reduce((n,r)=>(n=p(r,n),I(c[r],n)),i)}class A{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=I(i,this.g),this.g}}e.$aj=A;var P;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function b(c,i,n=32){const r=n-i,s=~((1<<r)-1);return(c<<i|(s&c)>>>r)>>>0}function C(c,i=0,n=c.byteLength,r=0){for(let s=0;s<n;s++)c[i+s]=r}function y(c,i,n="0"){for(;c.length<i;)c=n+c;return c}function a(c,i=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(n=>n.toString(16).padStart(2,"0")).join(""):y((c>>>0).toString(16),i/4)}class m{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const r=this.p;let s=this.r,t=this.u,f,d;for(t!==0?(f=t,d=-1,t=0):(f=i.charCodeAt(0),d=0);;){let u=f;if(o.$pf(f))if(d+1<n){const h=i.charCodeAt(d+1);o.$qf(h)?(d++,u=o.$rf(f,h)):u=65533}else{t=f;break}else o.$qf(f)&&(u=65533);if(s=this.w(r,s,u),d++,d<n)f=i.charCodeAt(d);else break}this.r=s,this.u=t}w(i,n,r){return r<128?i[n++]=r:r<2048?(i[n++]=192|(r&1984)>>>6,i[n++]=128|(r&63)>>>0):r<65536?(i[n++]=224|(r&61440)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0):(i[n++]=240|(r&1835008)>>>18,i[n++]=128|(r&258048)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64],i[1]=i[65],i[2]=i[66]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,C(this.p,this.r),this.r>56&&(this.y(),C(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=m.g,n=this.q;for(let g=0;g<64;g+=4)i.setUint32(g,n.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)i.setUint32(g,b(i.getUint32(g-12,!1)^i.getUint32(g-32,!1)^i.getUint32(g-56,!1)^i.getUint32(g-64,!1),1),!1);let r=this.h,s=this.l,t=this.m,f=this.n,d=this.o,u,h,l;for(let g=0;g<80;g++)g<20?(u=s&t|~s&f,h=1518500249):g<40?(u=s^t^f,h=1859775393):g<60?(u=s&t|s&f|t&f,h=2400959708):(u=s^t^f,h=3395469782),l=b(r,5)+u+d+h+i.getUint32(g*4,!1)&4294967295,d=f,f=t,t=b(s,30),s=r,r=l;this.h=this.h+r&4294967295,this.l=this.l+s&4294967295,this.m=this.m+t&4294967295,this.n=this.n+f&4294967295,this.o=this.o+d&4294967295}}e.$cj=m,m.g=new DataView(new ArrayBuffer(320))}),define(Ee[129],Ce([1,0,127,128,55,17,11,14]),function(re,e,o,R,I,M,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=A,e.$fr=m,e.$gr=d,e.$hr=S,e.$ir=j,e.$jr=T;const $=0,w=[$,[]];function A(O,z,Q,Z){if(!O||!z)return w;const J=O.length,x=z.length;if(J<x)return w;const ce=O.toLowerCase();return P(z,Q,x,O,ce,J,Z)}function P(O,z,Q,Z,J,x,ce){const te=[],pe=[];for(let he=0;he<Q;he++){const Se=he*x,me=Se-x,ie=he>0,se=O[he],oe=z[he];for(let G=0;G<x;G++){const ee=G>0,le=Se+G,de=le-1,Me=me+G-1,be=ee?te[de]:0,Pe=ie&&ee?te[Me]:0,Re=ie&&ee?pe[Me]:0;let ze;!Pe&&ie?ze=0:ze=b(se,oe,Z,J,G,Re),ze&&Pe+ze>=be&&(ce||ie||J.startsWith(z,G))?(pe[le]=Re+1,te[le]=Pe+ze):(pe[le]=$,te[le]=be)}}const ye=[];let _=Q-1,U=x-1;for(;_>=0&&U>=0;){const he=_*x+U;pe[he]===$||(ye.push(U),_--),U--}return[te[Q*x-1],ye.reverse()]}function b(O,z,Q,Z,J,x){let ce=0;if(!C(z,Z[J]))return ce;if(ce+=1,x>0&&(ce+=x*5),O===Q[J]&&(ce+=1),J===0)ce+=8;else{const te=y(Q.charCodeAt(J-1));te?ce+=te:(0,R.$nk)(Q.charCodeAt(J))&&x===0&&(ce+=2)}return ce}function C(O,z){return O===z?!0:O==="/"||O==="\\"?z==="/"||z==="\\":!1}function y(O){switch(O){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function m(O,z,Q=0,Z=0){const J=z;return J.values&&J.values.length>1?c(O,J.values,Q,Z):i(O,z,Q,Z)}function c(O,z,Q,Z){let J=0;const x=[];for(const ce of z){const[te,pe]=i(O,ce,Q,Z);if(typeof te!="number")return a;J+=te,x.push(...pe)}return[J,E(x)]}function i(O,z,Q,Z){const J=(0,R.$wk)(z.original,z.originalLowercase,Q,O,O.toLowerCase(),Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return J?[J[0],(0,R.$tk)(J)]:a}const n=Object.freeze({score:0}),r=1<<18,s=1<<17,t=65536;function f(O,z,Q,Z){const J=Z.values?Z.values:[Z];return(0,I.$9i)({[Z.normalized]:{values:J.map(ce=>({value:ce.normalized,expectContiguousMatch:ce.expectContiguousMatch})),label:O,description:z,allowNonContiguousMatches:Q}})}function d(O,z,Q,Z,J){if(!O||!z.normalized)return n;const x=Z.getItemLabel(O);if(!x)return n;const ce=Z.getItemDescription(O),te=f(x,ce,Q,z),pe=J[te];if(pe)return pe;const ye=u(x,ce,Z.getItemPath(O),z,Q);return J[te]=ye,ye}function u(O,z,Q,Z,J){const x=!Q||!Z.containsPathSeparator;return Q&&(L.$e?Z.pathNormalized===Q:(0,p.$lf)(Z.pathNormalized,Q))?{score:r,labelMatch:[{start:0,end:O.length}],descriptionMatch:z?[{start:0,end:z.length}]:void 0}:Z.values&&Z.values.length>1?h(O,z,Q,Z.values,x,J):l(O,z,Q,Z,x,J)}function h(O,z,Q,Z,J,x){let ce=0;const te=[],pe=[];for(const ye of Z){const{score:_,labelMatch:U,descriptionMatch:he}=l(O,z,Q,ye,J,x);if(_===$)return n;ce+=_,U&&te.push(...U),he&&pe.push(...he)}return{score:ce,labelMatch:E(te),descriptionMatch:E(pe)}}function l(O,z,Q,Z,J,x){if(J||!z){const[ce,te]=A(O,Z.normalized,Z.normalizedLowercase,x&&!Z.expectContiguousMatch);if(ce){const pe=(0,R.$kk)(Z.normalized,O);let ye;if(pe){ye=s;const _=Math.round(Z.normalized.length/O.length*100);ye+=_}else ye=t;return{score:ye+ce,labelMatch:pe||g(te)}}}if(z){let ce=z;Q&&(ce=`${z}${M.sep}`);const te=ce.length,pe=`${ce}${O}`,[ye,_]=A(pe,Z.normalized,Z.normalizedLowercase,x&&!Z.expectContiguousMatch);if(ye){const U=g(_),he=[],Se=[];return U.forEach(me=>{me.start<te&&me.end>te?(he.push({start:0,end:me.end-te}),Se.push({start:me.start,end:te})):me.start>=te?he.push({start:me.start-te,end:me.end-te}):Se.push(me)}),{score:ye,labelMatch:he,descriptionMatch:Se}}}return n}function g(O){const z=[];if(!O)return z;let Q;for(const Z of O)Q&&Q.end===Z?Q.end+=1:(Q={start:Z,end:Z+1},z.push(Q));return z}function E(O){const z=O.sort((J,x)=>J.start-x.start),Q=[];let Z;for(const J of z)!Z||!v(Z,J)?(Z=J,Q.push(J)):(Z.start=Math.min(Z.start,J.start),Z.end=Math.max(Z.end,J.end));return Q}function v(O,z){return!(O.end<z.start||z.end<O.start)}function S(O,z,Q,Z,J,x){const ce=d(O,Q,Z,J,x),te=d(z,Q,Z,J,x),pe=ce.score,ye=te.score;if((pe===r||ye===r)&&pe!==ye)return pe===r?-1:1;if(pe>t||ye>t){if(pe!==ye)return pe>ye?-1:1;if(pe<s&&ye<s){const se=D(ce.labelMatch,te.labelMatch);if(se!==0)return se}const me=J.getItemLabel(O)||"",ie=J.getItemLabel(z)||"";if(me.length!==ie.length)return me.length-ie.length}if(pe!==ye)return pe>ye?-1:1;const _=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0,U=Array.isArray(te.labelMatch)&&te.labelMatch.length>0;if(_&&!U)return-1;if(U&&!_)return 1;const he=k(O,ce,J),Se=k(z,te,J);return he&&Se&&he!==Se?Se>he?-1:1:F(O,z,Q,J)}function k(O,z,Q){let Z=-1,J=-1;if(z.descriptionMatch&&z.descriptionMatch.length?Z=z.descriptionMatch[0].start:z.labelMatch&&z.labelMatch.length&&(Z=z.labelMatch[0].start),z.labelMatch&&z.labelMatch.length){if(J=z.labelMatch[z.labelMatch.length-1].end,z.descriptionMatch&&z.descriptionMatch.length){const x=Q.getItemDescription(O);x&&(J+=x.length)}}else z.descriptionMatch&&z.descriptionMatch.length&&(J=z.descriptionMatch[z.descriptionMatch.length-1].end);return J-Z}function D(O,z){if(!O&&!z||(!O||!O.length)&&(!z||!z.length))return 0;if(!z||!z.length)return-1;if(!O||!O.length)return 1;const Q=O[0].start,J=O[O.length-1].end-Q,x=z[0].start,te=z[z.length-1].end-x;return J===te?0:te<J?1:-1}function F(O,z,Q,Z){const J=Z.getItemLabel(O)||"",x=Z.getItemLabel(z)||"",ce=Z.getItemDescription(O),te=Z.getItemDescription(z),pe=J.length+(ce?ce.length:0),ye=x.length+(te?te.length:0);if(pe!==ye)return pe-ye;const _=Z.getItemPath(O),U=Z.getItemPath(z);return _&&U&&_.length!==U.length?_.length-U.length:J!==x?(0,o.$cr)(J,x,Q.normalized):ce&&te&&ce!==te?(0,o.$cr)(ce,te,Q.normalized):_&&U&&_!==U?(0,o.$cr)(_,U,Q.normalized):0}function W(O){return O.startsWith('"')&&O.endsWith('"')}const B=" ";function j(O){typeof O!="string"&&(O="");const z=O.toLowerCase(),{pathNormalized:Q,normalized:Z,normalizedLowercase:J}=N(O),x=Q.indexOf(M.sep)>=0,ce=W(O);let te;const pe=O.split(B);if(pe.length>1)for(const ye of pe){const _=W(ye),{pathNormalized:U,normalized:he,normalizedLowercase:Se}=N(ye);he&&(te||(te=[]),te.push({original:ye,originalLowercase:ye.toLowerCase(),pathNormalized:U,normalized:he,normalizedLowercase:Se,expectContiguousMatch:_}))}return{original:O,originalLowercase:z,pathNormalized:Q,normalized:Z,normalizedLowercase:J,values:te,containsPathSeparator:x,expectContiguousMatch:ce}}function N(O){let z;L.$c?z=O.replace(/\//g,M.sep):z=O.replace(/\\/g,M.sep);const Q=(0,p.$8e)(z).replace(/\s|"/g,"");return{pathNormalized:z,normalized:Q,normalizedLowercase:Q.toLowerCase()}}function T(O){return Array.isArray(O)?j(O.map(z=>z.original).join(B)):j(O.original)}}),define(Ee[41],Ce([1,0,14]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(R||(R={})),function(I){const M="error",L="warning",p="warn",$="info",w="ignore";function A(b){return b?o.$lf(M,b)?I.Error:o.$lf(L,b)||o.$lf(p,b)?I.Warning:o.$lf($,b)?I.Info:I.Ignore:I.Ignore}I.fromValue=A;function P(b){switch(b){case I.Error:return M;case I.Warning:return L;case I.Info:return $;default:return w}}I.toString=P}(R||(R={})),e.default=R}),define(Ee[170],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(Ee[77],Ce([1,0,19,14]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;class I{constructor(){this.b="",this.c=0}reset(C){return this.b=C,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(C){const y=C.charCodeAt(0),a=this.b.charCodeAt(this.c);return y-a}value(){return this.b[this.c]}}e.$ki=I;class M{constructor(C=!0){this.e=C}reset(C){return this.b=C,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let C=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(C)this.c++;else break;else C=!1;return this}cmp(C){return this.e?(0,R.$ff)(C,this.b,0,C.length,this.c,this.d):(0,R.$hf)(C,this.b,0,C.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$li=M;class L{constructor(C=!0,y=!0){this.f=C,this.g=y}reset(C){this.d=0,this.e=0,this.b=C,this.c=C.length;for(let y=C.length-1;y>=0;y--,this.c--){const a=this.b.charCodeAt(y);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let C=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(C)this.d++;else break;else C=!1}return this}cmp(C){return this.g?(0,R.$ff)(C,this.b,0,C.length,this.d,this.e):(0,R.$hf)(C,this.b,0,C.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$mi=L;var p;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(p||(p={}));class ${constructor(C,y){this.f=C,this.g=y,this.d=[],this.e=0}reset(C){return this.c=C,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f(C)),this.b.reset(C.path),this.b.value()&&this.d.push(3)),this.g(C)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(C){if(this.d[this.e]===1)return(0,R.$gf)(C,this.c.scheme);if(this.d[this.e]===2)return(0,R.$gf)(C,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(C);if(this.d[this.e]===4)return(0,R.$ef)(C,this.c.query);if(this.d[this.e]===5)return(0,R.$ef)(C,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ni=$;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const C=this.right;return this.right=C.left,C.left=this,this.updateHeight(),C.updateHeight(),C}rotateRight(){const C=this.left;return this.left=C.right,C.right=this,this.updateHeight(),C.updateHeight(),C}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(A||(A={}));class P{static forUris(C=()=>!1,y=()=>!1){return new P(new $(C,y))}static forPaths(C=!1){return new P(new L(void 0,!C))}static forStrings(){return new P(new I)}static forConfigKeys(){return new P(new M)}constructor(C){this.b=C}clear(){this.c=void 0}fill(C,y){if(y){const a=y.slice(0);(0,o.$Xb)(a);for(const m of a)this.set(m,C)}else{const a=C.slice(0);(0,o.$Xb)(a);for(const m of a)this.set(m[0],m[1])}}set(C,y){const a=this.b.reset(C);let m;this.c||(this.c=new w,this.c.segment=a.value());const c=[];for(m=this.c;;){const n=a.cmp(m.segment);if(n>0)m.left||(m.left=new w,m.left.segment=a.value()),c.push([-1,m]),m=m.left;else if(n<0)m.right||(m.right=new w,m.right.segment=a.value()),c.push([1,m]),m=m.right;else if(a.hasNext())a.next(),m.mid||(m.mid=new w,m.mid.segment=a.value()),c.push([0,m]),m=m.mid;else break}const i=m.value;m.value=y,m.key=C;for(let n=c.length-1;n>=0;n--){const r=c[n][1];r.updateHeight();const s=r.balanceFactor();if(s<-1||s>1){const t=c[n][0],f=c[n+1][0];if(t===1&&f===1)c[n][1]=r.rotateLeft();else if(t===-1&&f===-1)c[n][1]=r.rotateRight();else if(t===1&&f===-1)r.right=c[n+1][1]=c[n+1][1].rotateRight(),c[n][1]=r.rotateLeft();else if(t===-1&&f===1)r.left=c[n+1][1]=c[n+1][1].rotateLeft(),c[n][1]=r.rotateRight();else throw new Error;if(n>0)switch(c[n-1][0]){case-1:c[n-1][1].left=c[n][1];break;case 1:c[n-1][1].right=c[n][1];break;case 0:c[n-1][1].mid=c[n][1];break}else this.c=c[0][1]}}return i}get(C){return this.d(C)?.value}d(C){const y=this.b.reset(C);let a=this.c;for(;a;){const m=y.cmp(a.segment);if(m>0)a=a.left;else if(m<0)a=a.right;else if(y.hasNext())y.next(),a=a.mid;else break}return a}has(C){const y=this.d(C);return!(y?.value===void 0&&y?.mid===void 0)}delete(C){return this.e(C,!1)}deleteSuperstr(C){return this.e(C,!0)}e(C,y){const a=this.b.reset(C),m=[];let c=this.c;for(;c;){const i=a.cmp(c.segment);if(i>0)m.push([-1,c]),c=c.left;else if(i<0)m.push([1,c]),c=c.right;else if(a.hasNext())a.next(),m.push([0,c]),c=c.mid;else break}if(c){if(y?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const i=this.f(c.right);if(i.key){const{key:n,value:r,segment:s}=i;this.e(i.key,!1),c.key=n,c.value=r,c.segment=s}}else{const i=c.left??c.right;if(m.length>0){const[n,r]=m[m.length-1];switch(n){case-1:r.left=i;break;case 0:r.mid=i;break;case 1:r.right=i;break}}else this.c=i}for(let i=m.length-1;i>=0;i--){const n=m[i][1];n.updateHeight();const r=n.balanceFactor();if(r>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),m[i][1]=n.rotateLeft()):r<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),m[i][1]=n.rotateRight()),i>0)switch(m[i-1][0]){case-1:m[i-1][1].left=m[i][1];break;case 1:m[i-1][1].right=m[i][1];break;case 0:m[i-1][1].mid=m[i][1];break}else this.c=m[0][1]}}}f(C){for(;C.left;)C=C.left;return C}findSubstr(C){const y=this.b.reset(C);let a=this.c,m;for(;a;){const c=y.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(y.hasNext())y.next(),m=a.value||m,a=a.mid;else break}return a&&a.value||m}findSuperstr(C){return this.g(C,!1)}g(C,y){const a=this.b.reset(C);let m=this.c;for(;m;){const c=a.cmp(m.segment);if(c>0)m=m.left;else if(c<0)m=m.right;else if(a.hasNext())a.next(),m=m.mid;else return m.mid?this.h(m.mid):y?m.value:void 0}}hasElementOrSubtree(C){return this.g(C,!0)!==void 0}forEach(C){for(const[y,a]of this)C(a,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(C){const y=[];return this.j(C,y),y[Symbol.iterator]()}j(C,y){C&&(C.left&&this.j(C.left,y),C.value&&y.push([C.key,C.value]),C.mid&&this.j(C.mid,y),C.right&&this.j(C.right,y))}_isBalanced(){const C=y=>{if(!y)return!0;const a=y.balanceFactor();return a<-1||a>1?!1:C(y.left)&&C(y.right)};return C(this.c)}}e.$oi=P}),define(Ee[18],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vf=o,e.$Wf=R,e.$Xf=I,e.$Yf=M,e.$Zf=L,e.$1f=p,e.$2f=$,e.$3f=w,e.$4f=A,e.$5f=P,e.$6f=b,e.$7f=C,e.$8f=y,e.$9f=m,e.$0f=c,e.$$f=i,e.$_f=n,e.$ag=r;function o(s){return typeof s=="string"}function R(s){return Array.isArray(s)&&s.every(t=>o(t))}function I(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function M(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}function L(s){return typeof s=="number"&&!isNaN(s)}function p(s){return!!s&&typeof s[Symbol.iterator]=="function"}function $(s){return s===!0||s===!1}function w(s){return typeof s>"u"}function A(s){return!P(s)}function P(s){return w(s)||s===null}function b(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function C(s){if(P(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function y(...s){const t=[];for(let f=0;f<s.length;f++){const d=s[f];if(P(d))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);t.push(d)}return t}const a=Object.prototype.hasOwnProperty;function m(s){if(!I(s))return!1;for(const t in s)if(a.call(s,t))return!1;return!0}function c(s){return typeof s=="function"}function i(...s){return s.length>0&&s.every(c)}function n(s,t){const f=Math.min(s.length,t.length);for(let d=0;d<f;d++)r(s[d],t[d])}function r(s,t){if(o(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(c(t)){try{if(s instanceof t)return}catch{}if(!P(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Ee[101],Ce([1,0,18]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=I,e.$Dj=M;const R=Object.create(null);function I(L,p){if((0,o.$Vf)(p)){const $=R[p];if($===void 0)throw new Error(`${L} references an unknown codicon: ${p}`);p=$}return R[L]=p,{id:L}}function M(){return R}}),define(Ee[171],Ce([1,0,101]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=void 0,e.$Ej={add:(0,o.$Cj)("add",6e4),plus:(0,o.$Cj)("plus",6e4),gistNew:(0,o.$Cj)("gist-new",6e4),repoCreate:(0,o.$Cj)("repo-create",6e4),lightbulb:(0,o.$Cj)("lightbulb",60001),lightBulb:(0,o.$Cj)("light-bulb",60001),repo:(0,o.$Cj)("repo",60002),repoDelete:(0,o.$Cj)("repo-delete",60002),gistFork:(0,o.$Cj)("gist-fork",60003),repoForked:(0,o.$Cj)("repo-forked",60003),gitPullRequest:(0,o.$Cj)("git-pull-request",60004),gitPullRequestAbandoned:(0,o.$Cj)("git-pull-request-abandoned",60004),recordKeys:(0,o.$Cj)("record-keys",60005),keyboard:(0,o.$Cj)("keyboard",60005),tag:(0,o.$Cj)("tag",60006),gitPullRequestLabel:(0,o.$Cj)("git-pull-request-label",60006),tagAdd:(0,o.$Cj)("tag-add",60006),tagRemove:(0,o.$Cj)("tag-remove",60006),person:(0,o.$Cj)("person",60007),personFollow:(0,o.$Cj)("person-follow",60007),personOutline:(0,o.$Cj)("person-outline",60007),personFilled:(0,o.$Cj)("person-filled",60007),gitBranch:(0,o.$Cj)("git-branch",60008),gitBranchCreate:(0,o.$Cj)("git-branch-create",60008),gitBranchDelete:(0,o.$Cj)("git-branch-delete",60008),sourceControl:(0,o.$Cj)("source-control",60008),mirror:(0,o.$Cj)("mirror",60009),mirrorPublic:(0,o.$Cj)("mirror-public",60009),star:(0,o.$Cj)("star",60010),starAdd:(0,o.$Cj)("star-add",60010),starDelete:(0,o.$Cj)("star-delete",60010),starEmpty:(0,o.$Cj)("star-empty",60010),comment:(0,o.$Cj)("comment",60011),commentAdd:(0,o.$Cj)("comment-add",60011),alert:(0,o.$Cj)("alert",60012),warning:(0,o.$Cj)("warning",60012),search:(0,o.$Cj)("search",60013),searchSave:(0,o.$Cj)("search-save",60013),logOut:(0,o.$Cj)("log-out",60014),signOut:(0,o.$Cj)("sign-out",60014),logIn:(0,o.$Cj)("log-in",60015),signIn:(0,o.$Cj)("sign-in",60015),eye:(0,o.$Cj)("eye",60016),eyeUnwatch:(0,o.$Cj)("eye-unwatch",60016),eyeWatch:(0,o.$Cj)("eye-watch",60016),circleFilled:(0,o.$Cj)("circle-filled",60017),primitiveDot:(0,o.$Cj)("primitive-dot",60017),closeDirty:(0,o.$Cj)("close-dirty",60017),debugBreakpoint:(0,o.$Cj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,o.$Cj)("debug-breakpoint-disabled",60017),debugHint:(0,o.$Cj)("debug-hint",60017),terminalDecorationSuccess:(0,o.$Cj)("terminal-decoration-success",60017),primitiveSquare:(0,o.$Cj)("primitive-square",60018),edit:(0,o.$Cj)("edit",60019),pencil:(0,o.$Cj)("pencil",60019),info:(0,o.$Cj)("info",60020),issueOpened:(0,o.$Cj)("issue-opened",60020),gistPrivate:(0,o.$Cj)("gist-private",60021),gitForkPrivate:(0,o.$Cj)("git-fork-private",60021),lock:(0,o.$Cj)("lock",60021),mirrorPrivate:(0,o.$Cj)("mirror-private",60021),close:(0,o.$Cj)("close",60022),removeClose:(0,o.$Cj)("remove-close",60022),x:(0,o.$Cj)("x",60022),repoSync:(0,o.$Cj)("repo-sync",60023),sync:(0,o.$Cj)("sync",60023),clone:(0,o.$Cj)("clone",60024),desktopDownload:(0,o.$Cj)("desktop-download",60024),beaker:(0,o.$Cj)("beaker",60025),microscope:(0,o.$Cj)("microscope",60025),vm:(0,o.$Cj)("vm",60026),deviceDesktop:(0,o.$Cj)("device-desktop",60026),file:(0,o.$Cj)("file",60027),fileText:(0,o.$Cj)("file-text",60027),more:(0,o.$Cj)("more",60028),ellipsis:(0,o.$Cj)("ellipsis",60028),kebabHorizontal:(0,o.$Cj)("kebab-horizontal",60028),mailReply:(0,o.$Cj)("mail-reply",60029),reply:(0,o.$Cj)("reply",60029),organization:(0,o.$Cj)("organization",60030),organizationFilled:(0,o.$Cj)("organization-filled",60030),organizationOutline:(0,o.$Cj)("organization-outline",60030),newFile:(0,o.$Cj)("new-file",60031),fileAdd:(0,o.$Cj)("file-add",60031),newFolder:(0,o.$Cj)("new-folder",60032),fileDirectoryCreate:(0,o.$Cj)("file-directory-create",60032),trash:(0,o.$Cj)("trash",60033),trashcan:(0,o.$Cj)("trashcan",60033),history:(0,o.$Cj)("history",60034),clock:(0,o.$Cj)("clock",60034),folder:(0,o.$Cj)("folder",60035),fileDirectory:(0,o.$Cj)("file-directory",60035),symbolFolder:(0,o.$Cj)("symbol-folder",60035),logoGithub:(0,o.$Cj)("logo-github",60036),markGithub:(0,o.$Cj)("mark-github",60036),github:(0,o.$Cj)("github",60036),terminal:(0,o.$Cj)("terminal",60037),console:(0,o.$Cj)("console",60037),repl:(0,o.$Cj)("repl",60037),zap:(0,o.$Cj)("zap",60038),symbolEvent:(0,o.$Cj)("symbol-event",60038),error:(0,o.$Cj)("error",60039),stop:(0,o.$Cj)("stop",60039),variable:(0,o.$Cj)("variable",60040),symbolVariable:(0,o.$Cj)("symbol-variable",60040),array:(0,o.$Cj)("array",60042),symbolArray:(0,o.$Cj)("symbol-array",60042),symbolModule:(0,o.$Cj)("symbol-module",60043),symbolPackage:(0,o.$Cj)("symbol-package",60043),symbolNamespace:(0,o.$Cj)("symbol-namespace",60043),symbolObject:(0,o.$Cj)("symbol-object",60043),symbolMethod:(0,o.$Cj)("symbol-method",60044),symbolFunction:(0,o.$Cj)("symbol-function",60044),symbolConstructor:(0,o.$Cj)("symbol-constructor",60044),symbolBoolean:(0,o.$Cj)("symbol-boolean",60047),symbolNull:(0,o.$Cj)("symbol-null",60047),symbolNumeric:(0,o.$Cj)("symbol-numeric",60048),symbolNumber:(0,o.$Cj)("symbol-number",60048),symbolStructure:(0,o.$Cj)("symbol-structure",60049),symbolStruct:(0,o.$Cj)("symbol-struct",60049),symbolParameter:(0,o.$Cj)("symbol-parameter",60050),symbolTypeParameter:(0,o.$Cj)("symbol-type-parameter",60050),symbolKey:(0,o.$Cj)("symbol-key",60051),symbolText:(0,o.$Cj)("symbol-text",60051),symbolReference:(0,o.$Cj)("symbol-reference",60052),goToFile:(0,o.$Cj)("go-to-file",60052),symbolEnum:(0,o.$Cj)("symbol-enum",60053),symbolValue:(0,o.$Cj)("symbol-value",60053),symbolRuler:(0,o.$Cj)("symbol-ruler",60054),symbolUnit:(0,o.$Cj)("symbol-unit",60054),activateBreakpoints:(0,o.$Cj)("activate-breakpoints",60055),archive:(0,o.$Cj)("archive",60056),arrowBoth:(0,o.$Cj)("arrow-both",60057),arrowDown:(0,o.$Cj)("arrow-down",60058),arrowLeft:(0,o.$Cj)("arrow-left",60059),arrowRight:(0,o.$Cj)("arrow-right",60060),arrowSmallDown:(0,o.$Cj)("arrow-small-down",60061),arrowSmallLeft:(0,o.$Cj)("arrow-small-left",60062),arrowSmallRight:(0,o.$Cj)("arrow-small-right",60063),arrowSmallUp:(0,o.$Cj)("arrow-small-up",60064),arrowUp:(0,o.$Cj)("arrow-up",60065),bell:(0,o.$Cj)("bell",60066),bold:(0,o.$Cj)("bold",60067),book:(0,o.$Cj)("book",60068),bookmark:(0,o.$Cj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,o.$Cj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,o.$Cj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,o.$Cj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,o.$Cj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,o.$Cj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,o.$Cj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,o.$Cj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,o.$Cj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,o.$Cj)("debug-breakpoint-log-disabled",60075),briefcase:(0,o.$Cj)("briefcase",60076),broadcast:(0,o.$Cj)("broadcast",60077),browser:(0,o.$Cj)("browser",60078),bug:(0,o.$Cj)("bug",60079),calendar:(0,o.$Cj)("calendar",60080),caseSensitive:(0,o.$Cj)("case-sensitive",60081),check:(0,o.$Cj)("check",60082),checklist:(0,o.$Cj)("checklist",60083),chevronDown:(0,o.$Cj)("chevron-down",60084),chevronLeft:(0,o.$Cj)("chevron-left",60085),chevronRight:(0,o.$Cj)("chevron-right",60086),chevronUp:(0,o.$Cj)("chevron-up",60087),chromeClose:(0,o.$Cj)("chrome-close",60088),chromeMaximize:(0,o.$Cj)("chrome-maximize",60089),chromeMinimize:(0,o.$Cj)("chrome-minimize",60090),chromeRestore:(0,o.$Cj)("chrome-restore",60091),circleOutline:(0,o.$Cj)("circle-outline",60092),circle:(0,o.$Cj)("circle",60092),debugBreakpointUnverified:(0,o.$Cj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,o.$Cj)("terminal-decoration-incomplete",60092),circleSlash:(0,o.$Cj)("circle-slash",60093),circuitBoard:(0,o.$Cj)("circuit-board",60094),clearAll:(0,o.$Cj)("clear-all",60095),clippy:(0,o.$Cj)("clippy",60096),closeAll:(0,o.$Cj)("close-all",60097),cloudDownload:(0,o.$Cj)("cloud-download",60098),cloudUpload:(0,o.$Cj)("cloud-upload",60099),code:(0,o.$Cj)("code",60100),collapseAll:(0,o.$Cj)("collapse-all",60101),colorMode:(0,o.$Cj)("color-mode",60102),commentDiscussion:(0,o.$Cj)("comment-discussion",60103),creditCard:(0,o.$Cj)("credit-card",60105),dash:(0,o.$Cj)("dash",60108),dashboard:(0,o.$Cj)("dashboard",60109),database:(0,o.$Cj)("database",60110),debugContinue:(0,o.$Cj)("debug-continue",60111),debugDisconnect:(0,o.$Cj)("debug-disconnect",60112),debugPause:(0,o.$Cj)("debug-pause",60113),debugRestart:(0,o.$Cj)("debug-restart",60114),debugStart:(0,o.$Cj)("debug-start",60115),debugStepInto:(0,o.$Cj)("debug-step-into",60116),debugStepOut:(0,o.$Cj)("debug-step-out",60117),debugStepOver:(0,o.$Cj)("debug-step-over",60118),debugStop:(0,o.$Cj)("debug-stop",60119),debug:(0,o.$Cj)("debug",60120),deviceCameraVideo:(0,o.$Cj)("device-camera-video",60121),deviceCamera:(0,o.$Cj)("device-camera",60122),deviceMobile:(0,o.$Cj)("device-mobile",60123),diffAdded:(0,o.$Cj)("diff-added",60124),diffIgnored:(0,o.$Cj)("diff-ignored",60125),diffModified:(0,o.$Cj)("diff-modified",60126),diffRemoved:(0,o.$Cj)("diff-removed",60127),diffRenamed:(0,o.$Cj)("diff-renamed",60128),diff:(0,o.$Cj)("diff",60129),diffSidebyside:(0,o.$Cj)("diff-sidebyside",60129),discard:(0,o.$Cj)("discard",60130),editorLayout:(0,o.$Cj)("editor-layout",60131),emptyWindow:(0,o.$Cj)("empty-window",60132),exclude:(0,o.$Cj)("exclude",60133),extensions:(0,o.$Cj)("extensions",60134),eyeClosed:(0,o.$Cj)("eye-closed",60135),fileBinary:(0,o.$Cj)("file-binary",60136),fileCode:(0,o.$Cj)("file-code",60137),fileMedia:(0,o.$Cj)("file-media",60138),filePdf:(0,o.$Cj)("file-pdf",60139),fileSubmodule:(0,o.$Cj)("file-submodule",60140),fileSymlinkDirectory:(0,o.$Cj)("file-symlink-directory",60141),fileSymlinkFile:(0,o.$Cj)("file-symlink-file",60142),fileZip:(0,o.$Cj)("file-zip",60143),files:(0,o.$Cj)("files",60144),filter:(0,o.$Cj)("filter",60145),flame:(0,o.$Cj)("flame",60146),foldDown:(0,o.$Cj)("fold-down",60147),foldUp:(0,o.$Cj)("fold-up",60148),fold:(0,o.$Cj)("fold",60149),folderActive:(0,o.$Cj)("folder-active",60150),folderOpened:(0,o.$Cj)("folder-opened",60151),gear:(0,o.$Cj)("gear",60152),gift:(0,o.$Cj)("gift",60153),gistSecret:(0,o.$Cj)("gist-secret",60154),gist:(0,o.$Cj)("gist",60155),gitCommit:(0,o.$Cj)("git-commit",60156),gitCompare:(0,o.$Cj)("git-compare",60157),compareChanges:(0,o.$Cj)("compare-changes",60157),gitMerge:(0,o.$Cj)("git-merge",60158),githubAction:(0,o.$Cj)("github-action",60159),githubAlt:(0,o.$Cj)("github-alt",60160),globe:(0,o.$Cj)("globe",60161),grabber:(0,o.$Cj)("grabber",60162),graph:(0,o.$Cj)("graph",60163),gripper:(0,o.$Cj)("gripper",60164),heart:(0,o.$Cj)("heart",60165),home:(0,o.$Cj)("home",60166),horizontalRule:(0,o.$Cj)("horizontal-rule",60167),hubot:(0,o.$Cj)("hubot",60168),inbox:(0,o.$Cj)("inbox",60169),issueReopened:(0,o.$Cj)("issue-reopened",60171),issues:(0,o.$Cj)("issues",60172),italic:(0,o.$Cj)("italic",60173),jersey:(0,o.$Cj)("jersey",60174),json:(0,o.$Cj)("json",60175),kebabVertical:(0,o.$Cj)("kebab-vertical",60176),key:(0,o.$Cj)("key",60177),law:(0,o.$Cj)("law",60178),lightbulbAutofix:(0,o.$Cj)("lightbulb-autofix",60179),linkExternal:(0,o.$Cj)("link-external",60180),link:(0,o.$Cj)("link",60181),listOrdered:(0,o.$Cj)("list-ordered",60182),listUnordered:(0,o.$Cj)("list-unordered",60183),liveShare:(0,o.$Cj)("live-share",60184),loading:(0,o.$Cj)("loading",60185),location:(0,o.$Cj)("location",60186),mailRead:(0,o.$Cj)("mail-read",60187),mail:(0,o.$Cj)("mail",60188),markdown:(0,o.$Cj)("markdown",60189),megaphone:(0,o.$Cj)("megaphone",60190),mention:(0,o.$Cj)("mention",60191),milestone:(0,o.$Cj)("milestone",60192),gitPullRequestMilestone:(0,o.$Cj)("git-pull-request-milestone",60192),mortarBoard:(0,o.$Cj)("mortar-board",60193),move:(0,o.$Cj)("move",60194),multipleWindows:(0,o.$Cj)("multiple-windows",60195),mute:(0,o.$Cj)("mute",60196),noNewline:(0,o.$Cj)("no-newline",60197),note:(0,o.$Cj)("note",60198),octoface:(0,o.$Cj)("octoface",60199),openPreview:(0,o.$Cj)("open-preview",60200),package:(0,o.$Cj)("package",60201),paintcan:(0,o.$Cj)("paintcan",60202),pin:(0,o.$Cj)("pin",60203),play:(0,o.$Cj)("play",60204),run:(0,o.$Cj)("run",60204),plug:(0,o.$Cj)("plug",60205),preserveCase:(0,o.$Cj)("preserve-case",60206),preview:(0,o.$Cj)("preview",60207),project:(0,o.$Cj)("project",60208),pulse:(0,o.$Cj)("pulse",60209),question:(0,o.$Cj)("question",60210),quote:(0,o.$Cj)("quote",60211),radioTower:(0,o.$Cj)("radio-tower",60212),reactions:(0,o.$Cj)("reactions",60213),references:(0,o.$Cj)("references",60214),refresh:(0,o.$Cj)("refresh",60215),regex:(0,o.$Cj)("regex",60216),remoteExplorer:(0,o.$Cj)("remote-explorer",60217),remote:(0,o.$Cj)("remote",60218),remove:(0,o.$Cj)("remove",60219),replaceAll:(0,o.$Cj)("replace-all",60220),replace:(0,o.$Cj)("replace",60221),repoClone:(0,o.$Cj)("repo-clone",60222),repoForcePush:(0,o.$Cj)("repo-force-push",60223),repoPull:(0,o.$Cj)("repo-pull",60224),repoPush:(0,o.$Cj)("repo-push",60225),report:(0,o.$Cj)("report",60226),requestChanges:(0,o.$Cj)("request-changes",60227),rocket:(0,o.$Cj)("rocket",60228),rootFolderOpened:(0,o.$Cj)("root-folder-opened",60229),rootFolder:(0,o.$Cj)("root-folder",60230),rss:(0,o.$Cj)("rss",60231),ruby:(0,o.$Cj)("ruby",60232),saveAll:(0,o.$Cj)("save-all",60233),saveAs:(0,o.$Cj)("save-as",60234),save:(0,o.$Cj)("save",60235),screenFull:(0,o.$Cj)("screen-full",60236),screenNormal:(0,o.$Cj)("screen-normal",60237),searchStop:(0,o.$Cj)("search-stop",60238),server:(0,o.$Cj)("server",60240),settingsGear:(0,o.$Cj)("settings-gear",60241),settings:(0,o.$Cj)("settings",60242),shield:(0,o.$Cj)("shield",60243),smiley:(0,o.$Cj)("smiley",60244),sortPrecedence:(0,o.$Cj)("sort-precedence",60245),splitHorizontal:(0,o.$Cj)("split-horizontal",60246),splitVertical:(0,o.$Cj)("split-vertical",60247),squirrel:(0,o.$Cj)("squirrel",60248),starFull:(0,o.$Cj)("star-full",60249),starHalf:(0,o.$Cj)("star-half",60250),symbolClass:(0,o.$Cj)("symbol-class",60251),symbolColor:(0,o.$Cj)("symbol-color",60252),symbolConstant:(0,o.$Cj)("symbol-constant",60253),symbolEnumMember:(0,o.$Cj)("symbol-enum-member",60254),symbolField:(0,o.$Cj)("symbol-field",60255),symbolFile:(0,o.$Cj)("symbol-file",60256),symbolInterface:(0,o.$Cj)("symbol-interface",60257),symbolKeyword:(0,o.$Cj)("symbol-keyword",60258),symbolMisc:(0,o.$Cj)("symbol-misc",60259),symbolOperator:(0,o.$Cj)("symbol-operator",60260),symbolProperty:(0,o.$Cj)("symbol-property",60261),wrench:(0,o.$Cj)("wrench",60261),wrenchSubaction:(0,o.$Cj)("wrench-subaction",60261),symbolSnippet:(0,o.$Cj)("symbol-snippet",60262),tasklist:(0,o.$Cj)("tasklist",60263),telescope:(0,o.$Cj)("telescope",60264),textSize:(0,o.$Cj)("text-size",60265),threeBars:(0,o.$Cj)("three-bars",60266),thumbsdown:(0,o.$Cj)("thumbsdown",60267),thumbsup:(0,o.$Cj)("thumbsup",60268),tools:(0,o.$Cj)("tools",60269),triangleDown:(0,o.$Cj)("triangle-down",60270),triangleLeft:(0,o.$Cj)("triangle-left",60271),triangleRight:(0,o.$Cj)("triangle-right",60272),triangleUp:(0,o.$Cj)("triangle-up",60273),twitter:(0,o.$Cj)("twitter",60274),unfold:(0,o.$Cj)("unfold",60275),unlock:(0,o.$Cj)("unlock",60276),unmute:(0,o.$Cj)("unmute",60277),unverified:(0,o.$Cj)("unverified",60278),verified:(0,o.$Cj)("verified",60279),versions:(0,o.$Cj)("versions",60280),vmActive:(0,o.$Cj)("vm-active",60281),vmOutline:(0,o.$Cj)("vm-outline",60282),vmRunning:(0,o.$Cj)("vm-running",60283),watch:(0,o.$Cj)("watch",60284),whitespace:(0,o.$Cj)("whitespace",60285),wholeWord:(0,o.$Cj)("whole-word",60286),window:(0,o.$Cj)("window",60287),wordWrap:(0,o.$Cj)("word-wrap",60288),zoomIn:(0,o.$Cj)("zoom-in",60289),zoomOut:(0,o.$Cj)("zoom-out",60290),listFilter:(0,o.$Cj)("list-filter",60291),listFlat:(0,o.$Cj)("list-flat",60292),listSelection:(0,o.$Cj)("list-selection",60293),selection:(0,o.$Cj)("selection",60293),listTree:(0,o.$Cj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,o.$Cj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,o.$Cj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,o.$Cj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,o.$Cj)("debug-stackframe-active",60297),circleSmallFilled:(0,o.$Cj)("circle-small-filled",60298),debugStackframeDot:(0,o.$Cj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,o.$Cj)("terminal-decoration-mark",60298),debugStackframe:(0,o.$Cj)("debug-stackframe",60299),debugStackframeFocused:(0,o.$Cj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,o.$Cj)("debug-breakpoint-unsupported",60300),symbolString:(0,o.$Cj)("symbol-string",60301),debugReverseContinue:(0,o.$Cj)("debug-reverse-continue",60302),debugStepBack:(0,o.$Cj)("debug-step-back",60303),debugRestartFrame:(0,o.$Cj)("debug-restart-frame",60304),debugAlt:(0,o.$Cj)("debug-alt",60305),callIncoming:(0,o.$Cj)("call-incoming",60306),callOutgoing:(0,o.$Cj)("call-outgoing",60307),menu:(0,o.$Cj)("menu",60308),expandAll:(0,o.$Cj)("expand-all",60309),feedback:(0,o.$Cj)("feedback",60310),gitPullRequestReviewer:(0,o.$Cj)("git-pull-request-reviewer",60310),groupByRefType:(0,o.$Cj)("group-by-ref-type",60311),ungroupByRefType:(0,o.$Cj)("ungroup-by-ref-type",60312),account:(0,o.$Cj)("account",60313),gitPullRequestAssignee:(0,o.$Cj)("git-pull-request-assignee",60313),bellDot:(0,o.$Cj)("bell-dot",60314),debugConsole:(0,o.$Cj)("debug-console",60315),library:(0,o.$Cj)("library",60316),output:(0,o.$Cj)("output",60317),runAll:(0,o.$Cj)("run-all",60318),syncIgnored:(0,o.$Cj)("sync-ignored",60319),pinned:(0,o.$Cj)("pinned",60320),githubInverted:(0,o.$Cj)("github-inverted",60321),serverProcess:(0,o.$Cj)("server-process",60322),serverEnvironment:(0,o.$Cj)("server-environment",60323),pass:(0,o.$Cj)("pass",60324),issueClosed:(0,o.$Cj)("issue-closed",60324),stopCircle:(0,o.$Cj)("stop-circle",60325),playCircle:(0,o.$Cj)("play-circle",60326),record:(0,o.$Cj)("record",60327),debugAltSmall:(0,o.$Cj)("debug-alt-small",60328),vmConnect:(0,o.$Cj)("vm-connect",60329),cloud:(0,o.$Cj)("cloud",60330),merge:(0,o.$Cj)("merge",60331),export:(0,o.$Cj)("export",60332),graphLeft:(0,o.$Cj)("graph-left",60333),magnet:(0,o.$Cj)("magnet",60334),notebook:(0,o.$Cj)("notebook",60335),redo:(0,o.$Cj)("redo",60336),checkAll:(0,o.$Cj)("check-all",60337),pinnedDirty:(0,o.$Cj)("pinned-dirty",60338),passFilled:(0,o.$Cj)("pass-filled",60339),circleLargeFilled:(0,o.$Cj)("circle-large-filled",60340),circleLarge:(0,o.$Cj)("circle-large",60341),circleLargeOutline:(0,o.$Cj)("circle-large-outline",60341),combine:(0,o.$Cj)("combine",60342),gather:(0,o.$Cj)("gather",60342),table:(0,o.$Cj)("table",60343),variableGroup:(0,o.$Cj)("variable-group",60344),typeHierarchy:(0,o.$Cj)("type-hierarchy",60345),typeHierarchySub:(0,o.$Cj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,o.$Cj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,o.$Cj)("git-pull-request-create",60348),runAbove:(0,o.$Cj)("run-above",60349),runBelow:(0,o.$Cj)("run-below",60350),notebookTemplate:(0,o.$Cj)("notebook-template",60351),debugRerun:(0,o.$Cj)("debug-rerun",60352),workspaceTrusted:(0,o.$Cj)("workspace-trusted",60353),workspaceUntrusted:(0,o.$Cj)("workspace-untrusted",60354),workspaceUnknown:(0,o.$Cj)("workspace-unknown",60355),terminalCmd:(0,o.$Cj)("terminal-cmd",60356),terminalDebian:(0,o.$Cj)("terminal-debian",60357),terminalLinux:(0,o.$Cj)("terminal-linux",60358),terminalPowershell:(0,o.$Cj)("terminal-powershell",60359),terminalTmux:(0,o.$Cj)("terminal-tmux",60360),terminalUbuntu:(0,o.$Cj)("terminal-ubuntu",60361),terminalBash:(0,o.$Cj)("terminal-bash",60362),arrowSwap:(0,o.$Cj)("arrow-swap",60363),copy:(0,o.$Cj)("copy",60364),personAdd:(0,o.$Cj)("person-add",60365),filterFilled:(0,o.$Cj)("filter-filled",60366),wand:(0,o.$Cj)("wand",60367),debugLineByLine:(0,o.$Cj)("debug-line-by-line",60368),inspect:(0,o.$Cj)("inspect",60369),layers:(0,o.$Cj)("layers",60370),layersDot:(0,o.$Cj)("layers-dot",60371),layersActive:(0,o.$Cj)("layers-active",60372),compass:(0,o.$Cj)("compass",60373),compassDot:(0,o.$Cj)("compass-dot",60374),compassActive:(0,o.$Cj)("compass-active",60375),azure:(0,o.$Cj)("azure",60376),issueDraft:(0,o.$Cj)("issue-draft",60377),gitPullRequestClosed:(0,o.$Cj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,o.$Cj)("git-pull-request-draft",60379),debugAll:(0,o.$Cj)("debug-all",60380),debugCoverage:(0,o.$Cj)("debug-coverage",60381),runErrors:(0,o.$Cj)("run-errors",60382),folderLibrary:(0,o.$Cj)("folder-library",60383),debugContinueSmall:(0,o.$Cj)("debug-continue-small",60384),beakerStop:(0,o.$Cj)("beaker-stop",60385),graphLine:(0,o.$Cj)("graph-line",60386),graphScatter:(0,o.$Cj)("graph-scatter",60387),pieChart:(0,o.$Cj)("pie-chart",60388),bracket:(0,o.$Cj)("bracket",60175),bracketDot:(0,o.$Cj)("bracket-dot",60389),bracketError:(0,o.$Cj)("bracket-error",60390),lockSmall:(0,o.$Cj)("lock-small",60391),azureDevops:(0,o.$Cj)("azure-devops",60392),verifiedFilled:(0,o.$Cj)("verified-filled",60393),newline:(0,o.$Cj)("newline",60394),layout:(0,o.$Cj)("layout",60395),layoutActivitybarLeft:(0,o.$Cj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,o.$Cj)("layout-activitybar-right",60397),layoutPanelLeft:(0,o.$Cj)("layout-panel-left",60398),layoutPanelCenter:(0,o.$Cj)("layout-panel-center",60399),layoutPanelJustify:(0,o.$Cj)("layout-panel-justify",60400),layoutPanelRight:(0,o.$Cj)("layout-panel-right",60401),layoutPanel:(0,o.$Cj)("layout-panel",60402),layoutSidebarLeft:(0,o.$Cj)("layout-sidebar-left",60403),layoutSidebarRight:(0,o.$Cj)("layout-sidebar-right",60404),layoutStatusbar:(0,o.$Cj)("layout-statusbar",60405),layoutMenubar:(0,o.$Cj)("layout-menubar",60406),layoutCentered:(0,o.$Cj)("layout-centered",60407),target:(0,o.$Cj)("target",60408),indent:(0,o.$Cj)("indent",60409),recordSmall:(0,o.$Cj)("record-small",60410),errorSmall:(0,o.$Cj)("error-small",60411),terminalDecorationError:(0,o.$Cj)("terminal-decoration-error",60411),arrowCircleDown:(0,o.$Cj)("arrow-circle-down",60412),arrowCircleLeft:(0,o.$Cj)("arrow-circle-left",60413),arrowCircleRight:(0,o.$Cj)("arrow-circle-right",60414),arrowCircleUp:(0,o.$Cj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,o.$Cj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,o.$Cj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,o.$Cj)("layout-sidebar-left-off",60418),blank:(0,o.$Cj)("blank",60419),heartFilled:(0,o.$Cj)("heart-filled",60420),map:(0,o.$Cj)("map",60421),mapHorizontal:(0,o.$Cj)("map-horizontal",60421),foldHorizontal:(0,o.$Cj)("fold-horizontal",60421),mapFilled:(0,o.$Cj)("map-filled",60422),mapHorizontalFilled:(0,o.$Cj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,o.$Cj)("fold-horizontal-filled",60422),circleSmall:(0,o.$Cj)("circle-small",60423),bellSlash:(0,o.$Cj)("bell-slash",60424),bellSlashDot:(0,o.$Cj)("bell-slash-dot",60425),commentUnresolved:(0,o.$Cj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,o.$Cj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,o.$Cj)("git-pull-request-new-changes",60428),searchFuzzy:(0,o.$Cj)("search-fuzzy",60429),commentDraft:(0,o.$Cj)("comment-draft",60430),send:(0,o.$Cj)("send",60431),sparkle:(0,o.$Cj)("sparkle",60432),insert:(0,o.$Cj)("insert",60433),mic:(0,o.$Cj)("mic",60434),thumbsdownFilled:(0,o.$Cj)("thumbsdown-filled",60435),thumbsupFilled:(0,o.$Cj)("thumbsup-filled",60436),coffee:(0,o.$Cj)("coffee",60437),snake:(0,o.$Cj)("snake",60438),game:(0,o.$Cj)("game",60439),vr:(0,o.$Cj)("vr",60440),chip:(0,o.$Cj)("chip",60441),piano:(0,o.$Cj)("piano",60442),music:(0,o.$Cj)("music",60443),micFilled:(0,o.$Cj)("mic-filled",60444),repoFetch:(0,o.$Cj)("repo-fetch",60445),copilot:(0,o.$Cj)("copilot",60446),lightbulbSparkle:(0,o.$Cj)("lightbulb-sparkle",60447),robot:(0,o.$Cj)("robot",60448),sparkleFilled:(0,o.$Cj)("sparkle-filled",60449),diffSingle:(0,o.$Cj)("diff-single",60450),diffMultiple:(0,o.$Cj)("diff-multiple",60451),surroundWith:(0,o.$Cj)("surround-with",60452),share:(0,o.$Cj)("share",60453),gitStash:(0,o.$Cj)("git-stash",60454),gitStashApply:(0,o.$Cj)("git-stash-apply",60455),gitStashPop:(0,o.$Cj)("git-stash-pop",60456),vscode:(0,o.$Cj)("vscode",60457),vscodeInsiders:(0,o.$Cj)("vscode-insiders",60458),codeOss:(0,o.$Cj)("code-oss",60459),runCoverage:(0,o.$Cj)("run-coverage",60460),runAllCoverage:(0,o.$Cj)("run-all-coverage",60461),coverage:(0,o.$Cj)("coverage",60462),githubProject:(0,o.$Cj)("github-project",60463),mapVertical:(0,o.$Cj)("map-vertical",60464),foldVertical:(0,o.$Cj)("fold-vertical",60464),mapVerticalFilled:(0,o.$Cj)("map-vertical-filled",60465),foldVerticalFilled:(0,o.$Cj)("fold-vertical-filled",60465)}}),define(Ee[78],Ce([1,0,101,171]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hj=e.$Gj=void 0,e.$Fj=I;function I(){return Object.values(e.$Hj)}e.$Gj={dialogError:(0,o.$Cj)("dialog-error","error"),dialogWarning:(0,o.$Cj)("dialog-warning","warning"),dialogInfo:(0,o.$Cj)("dialog-info","info"),dialogClose:(0,o.$Cj)("dialog-close","close"),treeItemExpanded:(0,o.$Cj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,o.$Cj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,o.$Cj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,o.$Cj)("tree-filter-clear","close"),treeItemLoading:(0,o.$Cj)("tree-item-loading","loading"),menuSelection:(0,o.$Cj)("menu-selection","check"),menuSubmenu:(0,o.$Cj)("menu-submenu","chevron-right"),menuBarMore:(0,o.$Cj)("menubar-more","more"),scrollbarButtonLeft:(0,o.$Cj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,o.$Cj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,o.$Cj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,o.$Cj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,o.$Cj)("toolbar-more","more"),quickInputBack:(0,o.$Cj)("quick-input-back","arrow-left"),dropDownButton:(0,o.$Cj)("drop-down-button",60084),symbolCustomColor:(0,o.$Cj)("symbol-customcolor",60252),exportIcon:(0,o.$Cj)("export",60332),workspaceUnspecified:(0,o.$Cj)("workspace-unspecified",60355),newLine:(0,o.$Cj)("newline",60394),thumbsDownFilled:(0,o.$Cj)("thumbsdown-filled",60435),thumbsUpFilled:(0,o.$Cj)("thumbsup-filled",60436),gitFetch:(0,o.$Cj)("git-fetch",60445),lightbulbSparkleAutofix:(0,o.$Cj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,o.$Cj)("debug-breakpoint-pending",60377)},e.$Hj={...R.$Ej,...e.$Gj}}),define(Ee[34],Ce([1,0,17,11,14,18]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=L,e.$cg=p,e.$dg=$,e.$eg=w,e.$fg=A,e.$gg=y,e.$hg=a,e.$ig=m,e.$jg=c,e.$kg=i,e.$lg=n,e.$mg=r,e.$ng=s,e.$og=t,e.$pg=f,e.$qg=h;function L(l){return l===47||l===92}function p(l){return l.replace(/[\\/]/g,o.$hc.sep)}function $(l){return l.indexOf("/")===-1&&(l=p(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}function w(l,g=o.$hc.sep){if(!l)return"";const E=l.length,v=l.charCodeAt(0);if(L(v)){if(L(l.charCodeAt(1))&&!L(l.charCodeAt(2))){let k=3;const D=k;for(;k<E&&!L(l.charCodeAt(k));k++);if(D!==k&&!L(l.charCodeAt(k+1))){for(k+=1;k<E;k++)if(L(l.charCodeAt(k)))return l.slice(0,k+1).replace(/[\\/]/g,g)}}return g}else if(c(v)&&l.charCodeAt(1)===58)return L(l.charCodeAt(2))?l.slice(0,2)+g:l.slice(0,2);let S=l.indexOf("://");if(S!==-1){for(S+=3;S<E;S++)if(L(l.charCodeAt(S)))return l.slice(0,S+1)}return""}function A(l){if(!R.$c||!l||l.length<5)return!1;let g=l.charCodeAt(0);if(g!==92||(g=l.charCodeAt(1),g!==92))return!1;let E=2;const v=E;for(;E<l.length&&(g=l.charCodeAt(E),g!==92);E++);return!(v===E||(g=l.charCodeAt(E+1),isNaN(g)||g===92))}const P=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,C=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(l,g=R.$c){const E=g?P:b;return!(!l||l.length===0||/^\s+$/.test(l)||(E.lastIndex=0,E.test(l))||g&&C.test(l)||l==="."||l===".."||g&&l[l.length-1]==="."||g&&l.length!==l.trim().length||l.length>255)}function a(l,g,E){const v=l===g;return!E||v?v:!l||!g?!1:(0,I.$lf)(l,g)}function m(l,g,E,v=o.sep){if(l===g)return!0;if(!l||!g||g.length>l.length)return!1;if(E){if(!(0,I.$mf)(l,g))return!1;if(g.length===l.length)return!0;let k=g.length;return g.charAt(g.length-1)===v&&k--,l.charAt(k)===v}return g.charAt(g.length-1)!==v&&(g+=v),l.indexOf(g)===0}function c(l){return l>=65&&l<=90||l>=97&&l<=122}function i(l,g){return R.$c&&l.endsWith(":")&&(l+=o.sep),(0,o.$jc)(l)||(l=(0,o.$kc)(g,l)),l=(0,o.$ic)(l),R.$c?(l=(0,I.$6e)(l,o.sep),l.endsWith(":")&&(l+=o.sep)):(l=(0,I.$6e)(l,o.sep),l||(l=o.sep)),l}function n(l){const g=(0,o.$ic)(l);return R.$c?l.length>3?!1:r(g)&&(l.length===2||g.charCodeAt(2)===92):g===o.$hc.sep}function r(l,g=R.$c){return g?c(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}function s(l,g=R.$c){return r(l,g)?l[0]:void 0}function t(l,g,E){return g.length>l.length?-1:l===g?0:(E&&(l=l.toLowerCase(),g=g.toLowerCase()),l.indexOf(g))}function f(l){const g=l.split(":");let E,v,S;for(const k of g){const D=Number(k);(0,M.$Zf)(D)?v===void 0?v=D:S===void 0&&(S=D):E=E?[E,k].join(":"):k}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:v!==void 0?v:void 0,column:S!==void 0?S:v!==void 0?1:void 0}}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function h(l,g,E=8){let v="";for(let k=0;k<E;k++){let D;k===0&&R.$c&&!g&&(E===3||E===4)?D=u:D=d,v+=D.charAt(Math.floor(Math.random()*D.length))}let S;return g?S=`${g}-${v}`:S=v,l?(0,o.$kc)(l,S):S}}),define(Ee[24],Ce([1,0,18]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=R,e.$Qn=I,e.$Rn=L,e.$Sn=$,e.$Tn=w,e.$Un=A,e.$Vn=P,e.$Wn=b,e.$Xn=C,e.$Yn=y,e.$Zn=a,e.$1n=m;function R(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const i=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([n,r])=>{i[n]=r&&typeof r=="object"?R(r):r}),i}function I(c){if(!c||typeof c!="object")return c;const i=[c];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const r in n)if(M.call(n,r)){const s=n[r];typeof s=="object"&&!Object.isFrozen(s)&&!(0,o.$Yf)(s)&&i.push(s)}}return c}const M=Object.prototype.hasOwnProperty;function L(c,i){return p(c,i,new Set)}function p(c,i,n){if((0,o.$5f)(c))return c;const r=i(c);if(typeof r<"u")return r;if(Array.isArray(c)){const s=[];for(const t of c)s.push(p(t,i,n));return s}if((0,o.$Xf)(c)){if(n.has(c))throw new Error("Cannot clone recursive data-structure");n.add(c);const s={};for(const t in c)M.call(c,t)&&(s[t]=p(c[t],i,n));return n.delete(c),s}return c}function $(c,i,n=!0){return(0,o.$Xf)(c)?((0,o.$Xf)(i)&&Object.keys(i).forEach(r=>{r in c?n&&((0,o.$Xf)(c[r])&&(0,o.$Xf)(i[r])?$(c[r],i[r],n):c[r]=i[r]):c[r]=i[r]}),c):i}function w(c,i){if(c===i)return!0;if(c==null||i===null||i===void 0||typeof c!=typeof i||typeof c!="object"||Array.isArray(c)!==Array.isArray(i))return!1;let n,r;if(Array.isArray(c)){if(c.length!==i.length)return!1;for(n=0;n<c.length;n++)if(!w(c[n],i[n]))return!1}else{const s=[];for(r in c)s.push(r);s.sort();const t=[];for(r in i)t.push(r);if(t.sort(),!w(s,t))return!1;for(n=0;n<s.length;n++)if(!w(c[s[n]],i[s[n]]))return!1}return!0}function A(c){const i=new Set;return JSON.stringify(c,(n,r)=>{if((0,o.$Xf)(r)||Array.isArray(r)){if(i.has(r))return"[Circular]";i.add(r)}return r})}function P(c,i){const n=Object.create(null);return!c||!i||Object.keys(i).forEach(s=>{const t=c[s],f=i[s];w(t,f)||(n[s]=f)}),n}function b(c,i){const n=i.toLowerCase(),r=Object.keys(c).find(s=>s.toLowerCase()===n);return r?c[r]:c[i]}function C(c,i){const n=Object.create(null);for(const[r,s]of Object.entries(c))i(r,s)&&(n[r]=s);return n}function y(c){let i=[];for(;Object.prototype!==c;)i=i.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return i}function a(c){const i=[];for(const n of y(c))typeof c[n]=="function"&&i.push(n);return i}function m(c,i){const n=s=>function(){const t=Array.prototype.slice.call(arguments,0);return i(s,t)},r={};for(const s of c)r[s]=n(s);return r}}),define(Ee[56],Ce([1,0,78]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Ij=I;var R;(function(L){function p($){return $&&typeof $=="object"&&typeof $.id=="string"}L.isThemeColor=p})(R||(e.ThemeColor=R={}));function I(L){return{id:L}}var M;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function $(i){const n=p.exec(i.id);if(!n)return $(o.$Hj.error);const[,r,s]=n,t=["codicon","codicon-"+r];return s&&t.push("codicon-modifier-"+s.substring(1)),t}L.asClassNameArray=$;function w(i){return $(i).join(" ")}L.asClassName=w;function A(i){return"."+$(i).join(".")}L.asCSSSelector=A;function P(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||R.isThemeColor(i.color))}L.isThemeIcon=P;const b=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function C(i){const n=b.exec(i);if(!n)return;const[,r]=n;return{id:r}}L.fromString=C;function y(i){return{id:i}}L.fromId=y;function a(i,n){let r=i.id;const s=r.lastIndexOf("~");return s!==-1&&(r=r.substring(0,s)),n&&(r=`${r}~${n}`),{id:r}}L.modify=a;function m(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}L.getModifier=m;function c(i,n){return i.id===n.id&&i.color?.id===n.color?.id}L.isEqual=c})(M||(e.ThemeIcon=M={}))}),define(Ee[172],Ce([1,0,128,14,56]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=$,e.$Ak=A,e.$Bk=b,e.$Ck=C,e.$Dk=a,e.$Ek=m;const M="$(",L=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${L.source}`,"g");function $(c){return c.replace(p,(i,n)=>n?i:`\\${i}`)}const w=new RegExp(`\\\\${L.source}`,"g");function A(c){return c.replace(w,i=>`\\${i}`)}const P=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function b(c){return c.indexOf(M)===-1?c:c.replace(P,(i,n,r,s)=>r?i:n||s||"")}function C(c){return c?c.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}const y=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(c){y.lastIndex=0;let i="";const n=[];let r=0;for(;;){const s=y.lastIndex,t=y.exec(c),f=c.substring(s,t?.index);if(f.length>0){i+=f;for(let d=0;d<f.length;d++)n.push(r)}if(!t)break;r+=t[0].length}return{text:i,iconOffsets:n}}function m(c,i,n=!1){const{text:r,iconOffsets:s}=i;if(!s||s.length===0)return(0,o.$qk)(c,r,n);const t=(0,R.$5e)(r," "),f=r.length-t.length,d=(0,o.$qk)(c,t,n);if(d)for(const u of d){const h=s[u.start+f]+f;u.start+=h,u.end+=h}return d}}),define(Ee[130],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$Se=R,e.$Te=I;var o;(function(M){M[M.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",M[M.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",M[M.MAX_UINT_8=255]="MAX_UINT_8",M[M.MAX_UINT_16=65535]="MAX_UINT_16",M[M.MAX_UINT_32=4294967295]="MAX_UINT_32",M[M.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(o||(e.Constants=o={}));function R(M){return M<0?0:M>255?255:M|0}function I(M){return M<0?0:M>4294967295?4294967295:M|0}}),define(Ee[2],Ce([1,0,17,11]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=y,e.$xc=r;const I=/^\w[\w\d+.-]*$/,M=/^\//,L=/^\/\//;function p(u,h){if(!u.scheme&&h)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!I.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!M.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(u,h){return!u&&!h?"file":u}function w(u,h){switch(u){case"https":case"http":case"file":h?h[0]!==P&&(h=P+h):h=P;break}return h}const A="",P="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class C{static isUri(h){return h instanceof C?!0:h?typeof h.authority=="string"&&typeof h.fragment=="string"&&typeof h.path=="string"&&typeof h.query=="string"&&typeof h.scheme=="string"&&typeof h.fsPath=="string"&&typeof h.with=="function"&&typeof h.toString=="function":!1}constructor(h,l,g,E,v,S=!1){typeof h=="object"?(this.scheme=h.scheme||A,this.authority=h.authority||A,this.path=h.path||A,this.query=h.query||A,this.fragment=h.fragment||A):(this.scheme=$(h,S),this.authority=l||A,this.path=w(this.scheme,g||A),this.query=E||A,this.fragment=v||A,p(this,S))}get fsPath(){return r(this,!1)}with(h){if(!h)return this;let{scheme:l,authority:g,path:E,query:v,fragment:S}=h;return l===void 0?l=this.scheme:l===null&&(l=A),g===void 0?g=this.authority:g===null&&(g=A),E===void 0?E=this.path:E===null&&(E=A),v===void 0?v=this.query:v===null&&(v=A),S===void 0?S=this.fragment:S===null&&(S=A),l===this.scheme&&g===this.authority&&E===this.path&&v===this.query&&S===this.fragment?this:new m(l,g,E,v,S)}static parse(h,l=!1){const g=b.exec(h);return g?new m(g[2]||A,d(g[4]||A),d(g[5]||A),d(g[7]||A),d(g[9]||A),l):new m(A,A,A,A,A)}static file(h){let l=A;if(R.$c&&(h=h.replace(/\\/g,P)),h[0]===P&&h[1]===P){const g=h.indexOf(P,2);g===-1?(l=h.substring(2),h=P):(l=h.substring(2,g),h=h.substring(g)||P)}return new m("file",l,h,A,A)}static from(h,l){return new m(h.scheme,h.authority,h.path,h.query,h.fragment,l)}static joinPath(h,...l){if(!h.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return R.$c&&h.scheme==="file"?g=C.file(o.$gc.join(r(h,!0),...l)).path:g=o.$hc.join(h.path,...l),h.with({path:g})}toString(h=!1){return s(this,h)}toJSON(){return this}static revive(h){if(h){if(h instanceof C)return h;{const l=new m(h);return l._formatted=h.external??null,l._fsPath=h._sep===a?h.fsPath??null:null,l}}else return h}}e.URI=C;function y(u){return!u||typeof u!="object"?!1:typeof u.scheme=="string"&&(typeof u.authority=="string"||typeof u.authority>"u")&&(typeof u.path=="string"||typeof u.path>"u")&&(typeof u.query=="string"||typeof u.query>"u")&&(typeof u.fragment=="string"||typeof u.fragment>"u")}const a=R.$c?1:void 0;class m extends C{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(h=!1){return h?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const h={$mid:1};return this._fsPath&&(h.fsPath=this._fsPath,h._sep=a),this._formatted&&(h.external=this._formatted),this.path&&(h.path=this.path),this.scheme&&(h.scheme=this.scheme),this.authority&&(h.authority=this.authority),this.query&&(h.query=this.query),this.fragment&&(h.fragment=this.fragment),h}}const c={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function i(u,h,l){let g,E=-1;for(let v=0;v<u.length;v++){const S=u.charCodeAt(v);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||h&&S===47||l&&S===91||l&&S===93||l&&S===58)E!==-1&&(g+=encodeURIComponent(u.substring(E,v)),E=-1),g!==void 0&&(g+=u.charAt(v));else{g===void 0&&(g=u.substr(0,v));const k=c[S];k!==void 0?(E!==-1&&(g+=encodeURIComponent(u.substring(E,v)),E=-1),g+=k):E===-1&&(E=v)}}return E!==-1&&(g+=encodeURIComponent(u.substring(E))),g!==void 0?g:u}function n(u){let h;for(let l=0;l<u.length;l++){const g=u.charCodeAt(l);g===35||g===63?(h===void 0&&(h=u.substr(0,l)),h+=c[g]):h!==void 0&&(h+=u[l])}return h!==void 0?h:u}function r(u,h){let l;return u.authority&&u.path.length>1&&u.scheme==="file"?l=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===47&&(u.path.charCodeAt(1)>=65&&u.path.charCodeAt(1)<=90||u.path.charCodeAt(1)>=97&&u.path.charCodeAt(1)<=122)&&u.path.charCodeAt(2)===58?h?l=u.path.substr(1):l=u.path[1].toLowerCase()+u.path.substr(2):l=u.path,R.$c&&(l=l.replace(/\//g,"\\")),l}function s(u,h){const l=h?n:i;let g="",{scheme:E,authority:v,path:S,query:k,fragment:D}=u;if(E&&(g+=E,g+=":"),(v||E==="file")&&(g+=P,g+=P),v){let F=v.indexOf("@");if(F!==-1){const W=v.substr(0,F);v=v.substr(F+1),F=W.lastIndexOf(":"),F===-1?g+=l(W,!1,!1):(g+=l(W.substr(0,F),!1,!1),g+=":",g+=l(W.substr(F+1),!1,!0)),g+="@"}v=v.toLowerCase(),F=v.lastIndexOf(":"),F===-1?g+=l(v,!1,!0):(g+=l(v.substr(0,F),!1,!0),g+=v.substr(F))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const F=S.charCodeAt(1);F>=65&&F<=90&&(S=`/${String.fromCharCode(F+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const F=S.charCodeAt(0);F>=65&&F<=90&&(S=`${String.fromCharCode(F+32)}:${S.substr(2)}`)}g+=l(S,!0,!1)}return k&&(g+="?",g+=l(k,!1,!1)),D&&(g+="#",g+=h?D:i(D,!1,!1)),g}function t(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+t(u.substr(3)):u}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(u){return u.match(f)?u.replace(f,h=>t(h)):u}}),define(Ee[173],Ce([1,0,2]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=R,e.$Hq=I,e.$Iq=M,e.log=p;function R(w){const A=w;return A&&typeof A.type=="string"&&typeof A.severity=="string"}function I(w){const A=[];let P;try{const b=JSON.parse(w.arguments),C=b[b.length-1];C&&C.__$stack&&(b.pop(),P=C.__$stack),A.push(...b)}catch{A.push("Unable to log remote console arguments",w.arguments)}return{args:A,stack:P}}function M(w){if(typeof w!="string")return M(I(w).stack);const A=w;if(A){const P=L(A),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(b&&b.length===4)return{uri:o.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}function L(w){if(!w)return w;const A=w.indexOf(`
`);return A===-1?w:w.substring(0,A)}function p(w,A){const{args:P,stack:b}=I(w),C=typeof P[0]=="string"&&P.length===1;let y=L(b);y&&(y=`(${y.trim()})`);let a=[];if(typeof P[0]=="string"?y&&C?a=[`%c[${A}] %c${P[0]} %c${y}`,$("blue"),$(""),$("grey")]:a=[`%c[${A}] %c${P[0]}`,$("blue"),$(""),...P.slice(1)]:a=[`%c[${A}]%`,$("blue"),...P],y&&!C&&a.push(y),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,a)}function $(w){return`color: ${w}`}}),define(Ee[57],Ce([1,0,21,2]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=I,e.$Qh=M,e.$Rh=p;function I($){return JSON.stringify($,L)}function M($){let w=JSON.parse($);return w=p(w),w}function L($,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function p($,w=0){if(!$||w>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return R.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof o.$ue||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let A=0;A<$.length;++A)$[A]=p($[A],w+1);else for(const A in $)Object.hasOwnProperty.call($,A)&&($[A]=p($[A],w+1))}return $}}),define(Ee[15],Ce([1,0,13,11,14,2,17]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$vg=e.$ug=e.$tg=e.Schemas=void 0,e.$rg=$,e.$sg=w,e.$wg=P;var p;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeManagedRemoteResource="vscode-managed-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.vscodeChatCodeBlock="vscode-chat-code-block",y.vscodeChatSesssion="vscode-chat-editor",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm",y.codeSetting="code-setting"})(p||(e.Schemas=p={}));function $(y,a){return M.URI.isUri(y)?(0,I.$lf)(y.scheme,a):(0,I.$mf)(y,a+":")}function w(y,...a){return a.some(m=>$(y,m))}e.$tg="vscode-tkn",e.$ug="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a,m){this.f=P(a,m)}getServerRootPath(){return this.f}get g(){return L.$hc.join(this.f,p.vscodeRemoteResource)}set(a,m,c){this.a[a]=m,this.b[a]=c}setConnectionToken(a,m){this.c[a]=m}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(s){return o.$1(s),a}const m=a.authority;let c=this.a[m];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const i=this.b[m],n=this.c[m];let r=`path=${encodeURIComponent(a.path)}`;return typeof n=="string"&&(r+=`&${e.$ug}=${encodeURIComponent(n)}`),M.URI.from({scheme:R.$i?this.d:p.vscodeRemoteResource,authority:`${c}:${i}`,path:R.$i?(window.location.pathname+"/"+this.g).replace(/\/\/+/g,"/"):this.g,query:r})}}e.$vg=new A;function P(y,a){return L.$hc.join(a??"/",`${y.quality??"oss"}-${y.commit??"dev"}`)}e.$xg="vs/../../extensions",e.$yg="vs/../../node_modules",e.$zg="vs/../../node_modules.asar",e.$Ag="vs/../../node_modules.asar.unpacked",e.$Bg="vscode-app";class b{asBrowserUri(a){const m=this.b(a,re);return this.uriToBrowserUri(m)}uriToBrowserUri(a){return a.scheme===p.vscodeRemote?e.$vg.rewrite(a):a.scheme===p.file&&(R.$g||R.$k===`${p.vscodeFileResource}://${b.a}`)?a.with({scheme:p.vscodeFileResource,authority:a.authority||b.a,query:null,fragment:null}):a}asFileUri(a){const m=this.b(a,re);return this.uriToFileUri(m)}uriToFileUri(a){return a.scheme===p.vscodeFileResource?a.with({scheme:p.file,authority:a.authority!==b.a?a.authority:null,query:null,fragment:null}):a}b(a,m){return M.URI.isUri(a)?a:M.URI.parse(m.toUrl(a))}}b.a=e.$Bg,e.$Cg=new b;var C;(function(y){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);y.CoopAndCoep=Object.freeze(a.get("3"));const m="vscode-coi";function c(n){let r;typeof n=="string"?r=new URL(n).searchParams:n instanceof URL?r=n.searchParams:M.URI.isUri(n)&&(r=new URL(n.toString(!0)).searchParams);const s=r?.get(m);if(s)return a.get(s)}y.getHeadersFromQuery=c;function i(n,r,s){if(!globalThis.crossOriginIsolated)return;const t=r&&s?"3":s?"2":"1";n instanceof URLSearchParams?n.set(m,t):n[m]=t}y.addSearchParam=i})(C||(e.COI=C={}))}),define(Ee[174],Ce([1,0,163,15,11,2]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KD=A;class L{constructor(b,C,y){this.id=b,this.dependencies=C,this.callback=y}}class p{constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,C,y)=>{typeof b!="string"&&(y=C,C=b,b=null),(typeof C!="object"||!Array.isArray(C))&&(y=C,C=null),this.c.push(new L(b,C,y))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const C=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!C)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(C.dependencies)&&C.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${C.dependencies.join(", ")}`);return typeof C.callback=="function"?C.callback([]):C.callback}h(b){return new Promise((C,y)=>{const a=document.createElement("script");a.setAttribute("async","async"),a.setAttribute("type","text/javascript");const m=()=>{a.removeEventListener("load",c),a.removeEventListener("error",i)},c=n=>{m(),C(this.c.pop())},i=n=>{m(),y(n)};a.addEventListener("load",c),a.addEventListener("error",i),this.f&&(b=this.f.createScriptURL(b)),a.setAttribute("src",b),window.document.getElementsByTagName("head")[0].appendChild(a)})}i(b){return new Promise((C,y)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),C(this.c.pop())}catch(a){y(a)}})}async j(b){try{const C=globalThis._VSCODE_NODE_MODULES.fs,y=globalThis._VSCODE_NODE_MODULES.vm,a=globalThis._VSCODE_NODE_MODULES.module,m=M.URI.parse(b).fsPath,c=C.readFileSync(m).toString(),i=a.wrap(c.replace(/^#!.*/,""));return new y.Script(i).runInThisContext().apply(),this.c.pop()}catch(C){throw C}}}p.INSTANCE=new p;const $=new Map;let w={};typeof globalThis.require=="object"&&(w=globalThis.require.paths??{});async function A(P,b,C){if(o.$T){C===void 0&&(C=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),w[P]&&(P=w[P]);const y=`${P}/${b}`;if($.has(y))return $.get(y);let a;if(/^\w[\w\d+.-]*:\/\//.test(y))a=y;else{const n=`${C&&!I.$i?R.$zg:R.$yg}/${y}`;a=R.$Cg.asBrowserUri(n).toString(!0)}const m=p.INSTANCE.load(a);return $.set(y,m),m}else return await new Promise((y,a)=>{re([P],y,a)})}}),define(Ee[23],Ce([1,0,34,15,17,11,14,2]),function(re,e,o,R,I,M,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0,e.$Jg=$,e.$5g=A,e.$6g=b;function $(C){return(0,p.$xc)(C,!0)}class w{constructor(y){this.a=y}compare(y,a,m=!1){return y===a?0:(0,L.$ef)(this.getComparisonKey(y,m),this.getComparisonKey(a,m))}isEqual(y,a,m=!1){return y===a?!0:!y||!a?!1:this.getComparisonKey(y,m)===this.getComparisonKey(a,m)}getComparisonKey(y,a=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,a,m=!1){if(y.scheme===a.scheme){if(y.scheme===R.Schemas.file)return o.$ig($(y),$(a),this.a(y))&&y.query===a.query&&(m||y.fragment===a.fragment);if((0,e.$1g)(y.authority,a.authority))return o.$ig(y.path,a.path,this.a(y),"/")&&y.query===a.query&&(m||y.fragment===a.fragment)}return!1}joinPath(y,...a){return p.URI.joinPath(y,...a)}basenameOrAuthority(y){return(0,e.$Sg)(y)||y.authority}basename(y){return I.$hc.basename(y.path)}extname(y){return I.$hc.extname(y.path)}dirname(y){if(y.path.length===0)return y;let a;return y.scheme===R.Schemas.file?a=p.URI.file(I.$nc($(y))).path:(a=I.$hc.dirname(y.path),y.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),a="/")),y.with({path:a})}normalizePath(y){if(!y.path.length)return y;let a;return y.scheme===R.Schemas.file?a=p.URI.file(I.$ic($(y))).path:a=I.$hc.normalize(y.path),y.with({path:a})}relativePath(y,a){if(y.scheme!==a.scheme||!(0,e.$1g)(y.authority,a.authority))return;if(y.scheme===R.Schemas.file){const i=I.$mc($(y),$(a));return M.$c?o.$cg(i):i}let m=y.path||"/";const c=a.path||"/";if(this.a(y)){let i=0;for(const n=Math.min(m.length,c.length);i<n&&!(m.charCodeAt(i)!==c.charCodeAt(i)&&m.charAt(i).toLowerCase()!==c.charAt(i).toLowerCase());i++);m=c.substr(0,i)+m.substr(i)}return I.$hc.relative(m,c)}resolvePath(y,a){if(y.scheme===R.Schemas.file){const m=p.URI.file(I.$lc($(y),a));return y.with({authority:m.authority,path:m.path})}return a=o.$dg(a),y.with({path:I.$hc.resolve(y.path,a)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,a){return y===a||y!==void 0&&a!==void 0&&(0,L.$lf)(y,a)}hasTrailingPathSeparator(y,a=I.sep){if(y.scheme===R.Schemas.file){const m=$(y);return m.length>o.$eg(m).length&&m[m.length-1]===a}else{const m=y.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,a=I.sep){return(0,e.$2g)(y,a)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,a=I.sep){let m=!1;if(y.scheme===R.Schemas.file){const c=$(y);m=c!==void 0&&c.length===o.$eg(c).length&&c[c.length-1]===a}else{a="/";const c=y.path;m=c.length===1&&c.charCodeAt(c.length-1)===47}return!m&&!(0,e.$2g)(y,a)?y.with({path:y.path+"/"}):y}}e.$Kg=w,e.$Lg=new w(()=>!1),e.$Mg=new w(C=>C.scheme===R.Schemas.file?!M.$e:!0),e.$Ng=new w(C=>!0),e.$Og=e.$Lg.isEqual.bind(e.$Lg),e.$Pg=e.$Lg.isEqualOrParent.bind(e.$Lg),e.$Qg=e.$Lg.getComparisonKey.bind(e.$Lg),e.$Rg=e.$Lg.basenameOrAuthority.bind(e.$Lg),e.$Sg=e.$Lg.basename.bind(e.$Lg),e.$Tg=e.$Lg.extname.bind(e.$Lg),e.$Ug=e.$Lg.dirname.bind(e.$Lg),e.$Vg=e.$Lg.joinPath.bind(e.$Lg),e.$Wg=e.$Lg.normalizePath.bind(e.$Lg),e.$Xg=e.$Lg.relativePath.bind(e.$Lg),e.$Yg=e.$Lg.resolvePath.bind(e.$Lg),e.$Zg=e.$Lg.isAbsolutePath.bind(e.$Lg),e.$1g=e.$Lg.isEqualAuthority.bind(e.$Lg),e.$2g=e.$Lg.hasTrailingPathSeparator.bind(e.$Lg),e.$3g=e.$Lg.removeTrailingPathSeparator.bind(e.$Lg),e.$4g=e.$Lg.addTrailingPathSeparator.bind(e.$Lg);function A(C,y){const a=[];for(let m=0;m<C.length;m++){const c=y(C[m]);C.some((i,n)=>n===m?!1:(0,e.$Pg)(c,y(i)))||a.push(C[m])}return a}var P;(function(C){C.META_DATA_LABEL="label",C.META_DATA_DESCRIPTION="description",C.META_DATA_SIZE="size",C.META_DATA_MIME="mime";function y(a){const m=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(n=>{const[r,s]=n.split(":");r&&s&&m.set(r,s)});const i=a.path.substring(0,a.path.indexOf(";"));return i&&m.set(C.META_DATA_MIME,i),m}C.parseMetaData=y})(P||(e.DataUri=P={}));function b(C,y,a){if(y){let m=C.path;return m&&m[0]!==I.$hc.sep&&(m=I.$hc.sep+m),C.with({scheme:a,authority:y,path:m})}return C.with({scheme:a})}}),define(Ee[8],Ce([1,0,22,13,4,3,23,11,170,46]),function(re,e,o,R,I,M,L,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.Promises=e.$Fh=e.$Eh=e.$Dh=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=void 0,e.$7g=A,e.$8g=P,e.$9g=b,e.$0g=C,e.$$g=y,e.$_g=a,e.$ah=m,e.$bh=c,e.$jh=l,e.$kh=g,e.$lh=E,e.$mh=v,e.$nh=S,e.$Ch=J,e.$Kh=ie;function A(oe){return!!oe&&typeof oe.then=="function"}function P(oe){const G=new o.$ee,ee=oe(G.token),le=new Promise((de,Me)=>{const be=G.token.onCancellationRequested(()=>{be.dispose(),Me(new R.$5)});Promise.resolve(ee).then(Pe=>{be.dispose(),G.dispose(),de(Pe)},Pe=>{be.dispose(),G.dispose(),Me(Pe)})});return new class{cancel(){G.cancel(),G.dispose()}then(de,Me){return le.then(de,Me)}catch(de){return this.then(void 0,de)}finally(de){return le.finally(de)}}}function b(oe,G,ee){return new Promise((le,de)=>{const Me=G.onCancellationRequested(()=>{Me.dispose(),le(ee)});oe.then(le,de).finally(()=>Me.dispose())})}function C(oe,G){return new Promise((ee,le)=>{const de=G.onCancellationRequested(()=>{de.dispose(),le(new R.$5)});oe.then(ee,le).finally(()=>de.dispose())})}async function y(oe){let G=-1;const ee=oe.map((le,de)=>le.then(Me=>(G=de,Me)));try{return await Promise.race(ee)}finally{oe.forEach((le,de)=>{de!==G&&le.cancel()})}}function a(oe,G,ee){let le;const de=setTimeout(()=>{le?.(void 0),ee?.()},G);return Promise.race([oe.finally(()=>clearTimeout(de)),new Promise(Me=>le=Me)])}function m(oe){return new Promise((G,ee)=>{const le=oe();A(le)?le.then(G,ee):G(le)})}function c(){let oe,G;return{promise:new Promise((le,de)=>{oe=le,G=de}),resolve:oe,reject:G}}class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(G){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=G,!this.b){const ee=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(ee,ee).then(le)})}return new Promise((ee,le)=>{this.b.then(ee,le)})}return this.a=G(),new Promise((ee,le)=>{this.a.then(de=>{this.a=null,ee(de)},de=>{this.a=null,le(de)})})}dispose(){this.f=!0}}e.$ch=i;class n{constructor(){this.a=Promise.resolve(null)}queue(G){return this.a=this.a.then(()=>G(),()=>G())}}e.$dh=n;class r{constructor(){this.a=new Map}queue(G,ee){const de=(this.a.get(G)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.a.get(G)===de&&this.a.delete(G)});return this.a.set(G,de),de}}e.$eh=r;const s=(oe,G)=>{let ee=!0;const le=setTimeout(()=>{ee=!1,G()},oe);return{isTriggered:()=>ee,dispose:()=>{clearTimeout(le),ee=!1}}},t=oe=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,oe())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};class f{constructor(G){this.defaultDelay=G,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(G,ee=this.defaultDelay){this.g=G,this.h(),this.b||(this.b=new Promise((de,Me)=>{this.d=de,this.f=Me}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=ee===$.$4d?t(le):s(ee,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$fh=f;class d{constructor(G){this.a=new f(G),this.b=new i}trigger(G,ee){return this.a.trigger(()=>this.b.queue(G),ee)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$gh=d;class u{constructor(){this.a=!1,this.b=new Promise((G,ee)=>{this.d=G})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$hh=u;class h extends u{constructor(G){super(),this.f=setTimeout(()=>this.open(),G)}open(){clearTimeout(this.f),super.open()}}e.$ih=h;function l(oe,G){return G?new Promise((ee,le)=>{const de=setTimeout(()=>{Me.dispose(),ee()},oe),Me=G.onCancellationRequested(()=>{clearTimeout(de),Me.dispose(),le(new R.$5)})}):P(ee=>l(oe,ee))}function g(oe,G=0,ee){const le=setTimeout(()=>{oe(),ee&&de.dispose()},G),de=(0,M.$Sc)(()=>{clearTimeout(le),ee?.deleteAndLeak(de)});return ee?.add(de),de}function E(oe){const G=[];let ee=0;const le=oe.length;function de(){return ee<le?oe[ee++]():null}function Me(be){be!=null&&G.push(be);const Pe=de();return Pe?Pe.then(Me):Promise.resolve(G)}return Promise.resolve(null).then(Me)}function v(oe,G=le=>!!le,ee=null){let le=0;const de=oe.length,Me=()=>{if(le>=de)return Promise.resolve(ee);const be=oe[le++];return Promise.resolve(be()).then(Re=>G(Re)?Promise.resolve(Re):Me())};return Me()}function S(oe,G=le=>!!le,ee=null){if(oe.length===0)return Promise.resolve(ee);let le=oe.length;const de=()=>{le=-1;for(const Me of oe)Me.cancel?.()};return new Promise((Me,be)=>{for(const Pe of oe)Pe.then(Re=>{--le>=0&&G(Re)?(de(),Me(Re)):le===0&&Me(ee)}).catch(Re=>{--le>=0&&(de(),be(Re))})})}class k{constructor(G){this.a=0,this.b=!1,this.f=G,this.g=[],this.d=0,this.h=new I.$7d}whenIdle(){return this.size>0?I.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(G){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ee,le)=>{this.g.push({factory:G,c:ee,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const G=this.g.shift();this.d++;const ee=G.factory();ee.then(G.c,G.e),ee.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$oh=k;class D extends k{constructor(){super(1)}}e.$ph=D;class F{constructor(){this.a=new x,this.b=0}queue(G){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,G())):this.a.run(this.b++,G())}}e.$qh=F;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const G=new pe;return this.b.add(G),G.p}g(){for(const[,G]of this.a)if(G.size>0)return!1;return!0}queueSize(G,ee=L.$Lg){const le=ee.getComparisonKey(G);return this.a.get(le)?.size??0}queueFor(G,ee,le=L.$Lg){const de=le.getComparisonKey(G);let Me=this.a.get(de);if(!Me){Me=new D;const be=this.f++,Pe=I.Event.once(Me.onDrained)(()=>{Me?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$4c),this.d.set(be,Pe),this.a.set(de,Me)}return Me.queue(ee)}h(){this.g()&&this.j()}j(){for(const G of this.b)G.complete();this.b.clear()}dispose(){for(const[,G]of this.a)G.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$rh=W;class B{constructor(G,ee){this.a=-1,typeof G=="function"&&typeof ee=="number"&&this.setIfNotSet(G,ee)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(G,ee){this.cancel(),this.a=setTimeout(()=>{this.a=-1,G()},ee)}setIfNotSet(G,ee){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,G()},ee))}}e.$sh=B;class j{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(G,ee,le=globalThis){this.cancel();const de=le.setInterval(()=>{G()},ee);this.d=(0,M.$Sc)(()=>{le.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$th=j;class N{constructor(G,ee){this.b=-1,this.a=G,this.d=ee,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(G=this.d){this.cancel(),this.b=setTimeout(this.f,G)}get delay(){return this.d}set delay(G){this.d=G}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$uh=N;class T{constructor(G,ee){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.a=G,this.b=ee,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(G=this.b){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(G/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$vh=T;class O extends N{constructor(G,ee){super(G,ee),this.j=[]}work(G){this.j.push(G),this.isScheduled()||this.schedule()}h(){const G=this.j;this.j=[],this.a?.(G)}dispose(){this.j=[],super.dispose()}}e.$wh=O;class z extends M.$Uc{constructor(G,ee){super(),this.g=G,this.h=ee,this.a=[],this.b=this.B(new M.$Vc),this.f=!1}get pending(){return this.a.length}work(G){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+G.length>this.g.maxBufferedWork)return!1}else if(this.pending+G.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ee of G)this.a.push(ee);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new N(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$xh=z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$zh=(oe,G)=>{(0,p.$v)(()=>{if(ee)return;const le=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.$zh=(oe,G,ee)=>{const le=oe.requestIdleCallback(G,typeof ee=="number"?{timeout:ee}:void 0);let de=!1;return{dispose(){de||(de=!0,oe.cancelIdleCallback(le))}}},e.$yh=oe=>(0,e.$zh)(globalThis,oe)}();class Q{constructor(G,ee){this.g=!1,this.d=()=>{try{this.j=ee()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$zh)(G,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ah=Q;class Z extends Q{constructor(G){super(globalThis,G)}}e.$Bh=Z;async function J(oe,G,ee){let le;for(let de=0;de<ee;de++)try{return await oe()}catch(Me){le=Me,await l(G)}throw le}class x{isRunning(G){return typeof G=="number"?this.a?.taskId===G:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(G,ee,le){return this.a={taskId:G,cancel:()=>le?.(),promise:ee},ee.then(()=>this.d(G),()=>this.d(G)),ee}d(G){this.a&&G===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const G=this.b;this.b=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}queue(G){if(this.b)this.b.run=G;else{const{promise:ee,resolve:le,reject:de}=c();this.b={run:G,promise:ee,promiseResolve:le,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Dh=x;class ce{constructor(G,ee=()=>Date.now()){this.d=G,this.f=ee,this.a=0,this.b=0}increment(){const G=this.f();return G-this.a>this.d&&(this.a=G,this.b=0),this.b++,this.b}}e.$Eh=ce;var te;(function(oe){oe[oe.Resolved=0]="Resolved",oe[oe.Rejected=1]="Rejected"})(te||(te={}));class pe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((G,ee)=>{this.a=G,this.b=ee})}complete(G){return new Promise(ee=>{this.a(G),this.d={outcome:0,value:G},ee()})}error(G){return new Promise(ee=>{this.b(G),this.d={outcome:1,value:G},ee()})}cancel(){return this.error(new R.$5)}}e.$Fh=pe;var ye;(function(oe){async function G(le){let de;const Me=await Promise.all(le.map(be=>be.then(Pe=>Pe,Pe=>{de||(de=Pe)})));if(typeof de<"u")throw de;return Me}oe.settled=G;function ee(le){return new Promise(async(de,Me)=>{try{await le(de,Me)}catch(be){Me(be)}})}oe.withAsyncBody=ee})(ye||(e.Promises=ye={}));class _{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(G){this.a=void 0,this.b=void 0,this.d=!1,this.promise=G.then(ee=>(this.a=ee,this.d=!0,ee),ee=>{throw this.b=ee,this.d=!0,ee})}requireValue(){if(!this.d)throw new R.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Gh=_;class U{constructor(G){this.b=G,this.a=new w.$V(()=>new _(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Hh=U;var he;(function(oe){oe[oe.Initial=0]="Initial",oe[oe.DoneOK=1]="DoneOK",oe[oe.DoneError=2]="DoneError"})(he||(he={}));class Se{static fromArray(G){return new Se(ee=>{ee.emitMany(G)})}static fromPromise(G){return new Se(async ee=>{ee.emitMany(await G)})}static fromPromises(G){return new Se(async ee=>{await Promise.all(G.map(async le=>ee.emitOne(await le)))})}static merge(G){return new Se(async ee=>{await Promise.all(G.map(async le=>{for await(const de of le)ee.emitOne(de)}))})}constructor(G){this.a=0,this.b=[],this.d=null,this.f=new I.$7d,queueMicrotask(async()=>{const ee={emitOne:le=>this.g(le),emitMany:le=>this.h(le),reject:le=>this.k(le)};try{await Promise.resolve(G(ee)),this.j()}catch(le){this.k(le)}finally{ee.emitOne=void 0,ee.emitMany=void 0,ee.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(G<this.b.length)return{done:!1,value:this.b[G++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(G,ee){return new Se(async le=>{for await(const de of G)le.emitOne(ee(de))})}map(G){return Se.map(this,G)}static filter(G,ee){return new Se(async le=>{for await(const de of G)ee(de)&&le.emitOne(de)})}filter(G){return Se.filter(this,G)}static coalesce(G){return Se.filter(G,ee=>!!ee)}coalesce(){return Se.coalesce(this)}static async toPromise(G){const ee=[];for await(const le of G)ee.push(le);return ee}toPromise(){return Se.toPromise(this)}g(G){this.a===0&&(this.b.push(G),this.f.fire())}h(G){this.a===0&&(this.b=this.b.concat(G),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(G){this.a===0&&(this.a=2,this.d=G,this.f.fire())}}e.$Ih=Se,Se.EMPTY=Se.fromArray([]);class me extends Se{constructor(G,ee){super(ee),this.l=G}cancel(){this.l.cancel()}}e.$Jh=me;function ie(oe){const G=new o.$ee,ee=oe(G.token);return new me(G,async le=>{const de=G.token.onCancellationRequested(()=>{de.dispose(),G.dispose(),le.reject(new R.$5)});try{for await(const Me of ee){if(G.token.isCancellationRequested)return;le.emitOne(Me)}de.dispose(),G.dispose()}catch(Me){de.dispose(),G.dispose(),le.reject(Me)}})}class se{constructor(){this.a=new pe,this.b=new Se(le=>{if(G){le.reject(G);return}return ee&&le.emitMany(ee),this.d=de=>le.reject(de),this.f=de=>le.emitOne(de),this.a.p});let G,ee;this.f=le=>{ee||(ee=[]),ee.push(le)},this.d=le=>{G||(G=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(G){this.d(G),this.a.complete()}emitOne(G){this.f(G)}}e.$Lh=se}),define(Ee[35],Ce([1,0,19,8,34,27,17,11,14]),function(re,e,o,R,I,M,L,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=void 0,e.$0j=w,e.$ak=y,e.$bk=D,e.$ck=F,e.$dk=W,e.$ek=B,e.$fk=j,e.$gk=z;function w(){return Object.create(null)}e.$$j="**",e.$_j="/";const A="[/\\\\]",P="[^/\\\\]",b=/\//g;function C(Q,Z){switch(Q){case 0:return"";case 1:return`${P}*?`;default:return`(?:${A}|${P}+${A}${Z?`|${A}${P}+`:""})*?`}}function y(Q,Z){if(!Q)return[];const J=[];let x=!1,ce=!1,te="";for(const pe of Q){switch(pe){case Z:if(!x&&!ce){J.push(te),te="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}te+=pe}return te&&J.push(te),J}function a(Q){if(!Q)return"";let Z="";const J=y(Q,e.$_j);if(J.every(x=>x===e.$$j))Z=".*";else{let x=!1;J.forEach((ce,te)=>{if(ce===e.$$j){if(x)return;Z+=C(2,te===J.length-1)}else{let pe=!1,ye="",_=!1,U="";for(const he of ce){if(he!=="}"&&pe){ye+=he;continue}if(_&&(he!=="]"||!U)){let Se;he==="-"?Se=he:(he==="^"||he==="!")&&!U?Se="^":he===e.$_j?Se="":Se=(0,$.$Ze)(he),U+=Se;continue}switch(he){case"{":pe=!0;continue;case"[":_=!0;continue;case"}":{const me=`(?:${y(ye,",").map(ie=>a(ie)).join("|")})`;Z+=me,pe=!1,ye="";break}case"]":{Z+="["+U+"]",_=!1,U="";break}case"?":Z+=P;continue;case"*":Z+=C(1);continue;default:Z+=(0,$.$Ze)(he)}}te<J.length-1&&(J[te+1]!==e.$$j||te+2<J.length)&&(Z+=A)}x=ce===e.$$j})}return Z}const m=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Ec(1e4),f=function(){return!1},d=function(){return null};function u(Q,Z){if(!Q)return d;let J;typeof Q!="string"?J=Q.pattern:J=Q,J=J.trim();const x=`${J}_${!!Z.trimForExclusions}`;let ce=t.get(x);if(ce)return h(ce,Q);let te;return m.test(J)?ce=g(J.substr(4),J):(te=c.exec(l(J,Z)))?ce=E(te[1],J):(Z.trimForExclusions?n:i).test(J)?ce=v(J,Z):(te=r.exec(l(J,Z)))?ce=S(te[1].substr(1),J,!0):(te=s.exec(l(J,Z)))?ce=S(te[1],J,!1):ce=k(J),t.set(x,ce),h(ce,Q)}function h(Q,Z){if(typeof Z=="string")return Q;const J=function(x,ce){return(0,I.$ig)(x,Z.base,!p.$e)?Q((0,$.$5e)(x.substr(Z.base.length),L.sep),ce):null};return J.allBasenames=Q.allBasenames,J.allPaths=Q.allPaths,J.basenames=Q.basenames,J.patterns=Q.patterns,J}function l(Q,Z){return Z.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function g(Q,Z){return function(J,x){return typeof J=="string"&&J.endsWith(Q)?Z:null}}function E(Q,Z){const J=`/${Q}`,x=`\\${Q}`,ce=function(pe,ye){return typeof pe!="string"?null:ye?ye===Q?Z:null:pe===Q||pe.endsWith(J)||pe.endsWith(x)?Z:null},te=[Q];return ce.basenames=te,ce.patterns=[Z],ce.allBasenames=te,ce}function v(Q,Z){const J=O(Q.slice(1,-1).split(",").map(ye=>u(ye,Z)).filter(ye=>ye!==d),Q),x=J.length;if(!x)return d;if(x===1)return J[0];const ce=function(ye,_){for(let U=0,he=J.length;U<he;U++)if(J[U](ye,_))return Q;return null},te=J.find(ye=>!!ye.allBasenames);te&&(ce.allBasenames=te.allBasenames);const pe=J.reduce((ye,_)=>_.allPaths?ye.concat(_.allPaths):ye,[]);return pe.length&&(ce.allPaths=pe),ce}function S(Q,Z,J){const x=L.sep===L.$hc.sep,ce=x?Q:Q.replace(b,L.sep),te=L.sep+ce,pe=L.$hc.sep+Q;let ye;return J?ye=function(_,U){return typeof _=="string"&&(_===ce||_.endsWith(te)||!x&&(_===Q||_.endsWith(pe)))?Z:null}:ye=function(_,U){return typeof _=="string"&&(_===ce||!x&&_===Q)?Z:null},ye.allPaths=[(J?"*/":"./")+Q],ye}function k(Q){try{const Z=new RegExp(`^${a(Q)}$`);return function(J){return Z.lastIndex=0,typeof J=="string"&&Z.test(J)?Q:null}}catch{return d}}function D(Q,Z,J){return!Q||typeof Z!="string"?!1:F(Q)(Z,void 0,J)}function F(Q,Z={}){if(!Q)return f;if(typeof Q=="string"||W(Q)){const J=u(Q,Z);if(J===d)return f;const x=function(ce,te){return!!J(ce,te)};return J.allBasenames&&(x.allBasenames=J.allBasenames),J.allPaths&&(x.allPaths=J.allPaths),x}return N(Q,Z)}function W(Q){const Z=Q;return Z?typeof Z.base=="string"&&typeof Z.pattern=="string":!1}function B(Q){return Q.allBasenames||[]}function j(Q){return Q.allPaths||[]}function N(Q,Z){const J=O(Object.getOwnPropertyNames(Q).map(ye=>T(ye,Q[ye],Z)).filter(ye=>ye!==d)),x=J.length;if(!x)return d;if(!J.some(ye=>!!ye.requiresSiblings)){if(x===1)return J[0];const ye=function(he,Se){let me;for(let ie=0,se=J.length;ie<se;ie++){const oe=J[ie](he,Se);if(typeof oe=="string")return oe;(0,R.$7g)(oe)&&(me||(me=[]),me.push(oe))}return me?(async()=>{for(const ie of me){const se=await ie;if(typeof se=="string")return se}return null})():null},_=J.find(he=>!!he.allBasenames);_&&(ye.allBasenames=_.allBasenames);const U=J.reduce((he,Se)=>Se.allPaths?he.concat(Se.allPaths):he,[]);return U.length&&(ye.allPaths=U),ye}const ce=function(ye,_,U){let he,Se;for(let me=0,ie=J.length;me<ie;me++){const se=J[me];se.requiresSiblings&&U&&(_||(_=(0,L.$oc)(ye)),he||(he=_.substr(0,_.length-(0,L.$pc)(ye).length)));const oe=se(ye,_,he,U);if(typeof oe=="string")return oe;(0,R.$7g)(oe)&&(Se||(Se=[]),Se.push(oe))}return Se?(async()=>{for(const me of Se){const ie=await me;if(typeof ie=="string")return ie}return null})():null},te=J.find(ye=>!!ye.allBasenames);te&&(ce.allBasenames=te.allBasenames);const pe=J.reduce((ye,_)=>_.allPaths?ye.concat(_.allPaths):ye,[]);return pe.length&&(ce.allPaths=pe),ce}function T(Q,Z,J){if(Z===!1)return d;const x=u(Q,J);if(x===d)return d;if(typeof Z=="boolean")return x;if(Z){const ce=Z.when;if(typeof ce=="string"){const te=(pe,ye,_,U)=>{if(!U||!x(pe,ye))return null;const he=ce.replace("$(basename)",()=>_),Se=U(he);return(0,R.$7g)(Se)?Se.then(me=>me?Q:null):Se?Q:null};return te.requiresSiblings=!0,te}}return x}function O(Q,Z){const J=Q.filter(ye=>!!ye.basenames);if(J.length<2)return Q;const x=J.reduce((ye,_)=>{const U=_.basenames;return U?ye.concat(U):ye},[]);let ce;if(Z){ce=[];for(let ye=0,_=x.length;ye<_;ye++)ce.push(Z)}else ce=J.reduce((ye,_)=>{const U=_.patterns;return U?ye.concat(U):ye},[]);const te=function(ye,_){if(typeof ye!="string")return null;if(!_){let he;for(he=ye.length;he>0;he--){const Se=ye.charCodeAt(he-1);if(Se===47||Se===92)break}_=ye.substr(he)}const U=x.indexOf(_);return U!==-1?ce[U]:null};te.basenames=x,te.patterns=ce,te.allBasenames=x;const pe=Q.filter(ye=>!ye.basenames);return pe.push(te),pe}function z(Q,Z){return(0,o.$ub)(Q,Z,(J,x)=>typeof J=="string"&&typeof x=="string"?J===x:typeof J!="string"&&typeof x!="string"?J.base===x.base&&J.pattern===x.pattern:!1)}}),define(Ee[79],Ce([1,0,13,172,23,14,2]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.MarkdownStringTextNewlineStyle=void 0,e.$Gk=w,e.$Hk=A,e.$Ik=P,e.$Jk=b,e.$Kk=C,e.$Lk=y,e.$Mk=a,e.$Nk=m;var p;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class ${constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,o.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=b(this.supportThemeIcons?(0,R.$zk)(i):i).replace(/([ \t]+)/g,(r,s)=>"&nbsp;".repeat(s.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${C(n,i)}
`,this}appendLink(i,n,r){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(i,n){const r=new RegExp((0,M.$Ze)(n),"g");return i.replace(r,(s,t)=>i.charAt(t-1)!=="\\"?`\\${s}`:s)}}e.$Fk=$;function w(c){return A(c)?!c.value:Array.isArray(c)?c.every(w):!0}function A(c){return c instanceof $?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}function P(c,i){return c===i?!0:!c||!i?!1:c.value===i.value&&c.isTrusted===i.isTrusted&&c.supportThemeIcons===i.supportThemeIcons&&c.supportHtml===i.supportHtml&&(c.baseUri===i.baseUri||!!c.baseUri&&!!i.baseUri&&(0,I.$Og)(L.URI.from(c.baseUri),L.URI.from(i.baseUri)))}function b(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function C(c,i){const n=c.match(/^`+/gm)?.reduce((s,t)=>s.length>t.length?s:t).length??0,r=n>=3?n+1:3;return[`${"`".repeat(r)}${i}`,c,`${"`".repeat(r)}`].join(`
`)}function y(c){return c.replace(/"/g,"&quot;")}function a(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m(c){const i=[],n=c.split("|").map(s=>s.trim());c=n[0];const r=n[1];if(r){const s=/height=(\d+)/.exec(r),t=/width=(\d+)/.exec(r),f=s?s[1]:"",d=t?t[1]:"",u=isFinite(parseInt(d)),h=isFinite(parseInt(f));u&&i.push(`width="${d}"`),h&&i.push(`height="${f}"`)}return{href:c,dimensions:i}}}),define(Ee[102],Ce([1,0,19,34,17,11,23,14]),function(re,e,o,R,I,M,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=$,e.$iw=A,e.$jw=b,e.$kw=C,e.$lw=c,e.$mw=n,e.$nw=r,e.$ow=s,e.$pw=t,e.$qw=f;function $(u,h){const{os:l,tildify:g,relative:E}=h;if(E){const k=w(u,E,l);if(typeof k=="string")return k}let v=u.fsPath;if(l===1&&!M.$c?v=v.replace(/\//g,"\\"):l!==1&&M.$c&&(v=v.replace(/\\/g,"/")),l!==1&&g?.userHome){const k=g.userHome.fsPath;let D;u.scheme!==g.userHome.scheme&&u.path[0]===I.$hc.sep&&u.path[1]!==I.$hc.sep?D=g.userHome.with({path:u.path}).fsPath:D=v,v=b(D,k,l)}return(l===1?I.$gc:I.$hc).normalize(A(v,l===1))}function w(u,h,l){const g=l===1?I.$gc:I.$hc,E=l===3?L.$Lg:L.$Ng,v=h.getWorkspace(),S=(0,o.$Ob)(v.folders);if(!S)return;u.scheme!==S.uri.scheme&&u.path[0]===I.$hc.sep&&u.path[1]!==I.$hc.sep&&(u=S.uri.with({path:u.path}));const k=h.getWorkspaceFolder(u);if(!k)return;let D;if(E.isEqual(k.uri,u)?D="":D=E.relativePath(k.uri,u)??"",D&&(D=g.normalize(D)),v.folders.length>1&&!h.noPrefix){const F=k.name?k.name:E.basenameOrAuthority(k.uri);D=D?`${F} \u2022 ${D}`:F}return D}function A(u,h=M.$c){return(0,R.$mg)(u,h)?u.charAt(0).toUpperCase()+u.slice(1):u}let P=Object.create(null);function b(u,h,l=M.OS){if(l===1||!u||!h)return u;let g=P.original===h?P.normalized:void 0;g||(g=h,M.$c&&(g=(0,R.$cg)(g)),g=`${(0,p.$6e)(g,I.$hc.sep)}${I.$hc.sep}`,P={original:h,normalized:g});let E=u;return M.$c&&(E=(0,R.$cg)(E)),(l===3?E.startsWith(g):(0,p.$mf)(E,g))?`~/${E.substr(g.length)}`:u}function C(u,h){return u.replace(/^~($|\/|\\)/,`${h}$1`)}const y="\u2026",a="\\\\",m="~";function c(u,h=I.sep){const l=new Array(u.length);let g=!1;for(let E=0;E<u.length;E++){const v=u[E];if(v===""){l[E]=`.${h}`;continue}if(!v){l[E]=v;continue}g=!0;let S="",k=v;k.indexOf(a)===0?(S=k.substr(0,k.indexOf(a)+a.length),k=k.substr(k.indexOf(a)+a.length)):k.indexOf(h)===0?(S=k.substr(0,k.indexOf(h)+h.length),k=k.substr(k.indexOf(h)+h.length)):k.indexOf(m)===0&&(S=k.substr(0,k.indexOf(m)+m.length),k=k.substr(k.indexOf(m)+m.length));const D=k.split(h);for(let F=1;g&&F<=D.length;F++)for(let W=D.length-F;g&&W>=0;W--){g=!1;let B=D.slice(W,W+F).join(h);for(let j=0;!g&&j<u.length;j++)if(j!==E&&u[j]&&u[j].indexOf(B)>-1){const N=W+F===D.length,T=W>0&&u[j].indexOf(h)>-1?h+B:B,O=u[j].endsWith(T);g=!N||O}if(!g){let j="";(D[0].endsWith(":")||S!=="")&&(W===1&&(W=0,F++,B=D[0]+h+B),W>0&&(j=D[0]+h),j=S+j),W>0&&(j=j+y+h),j=j+B,W+F<D.length&&(j=j+h+y),l[E]=j}}g&&(l[E]=v)}return l}var i;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(u,h=Object.create(null)){const l=[];let g=!1,E="";for(const v of u)if(v==="$"||g&&v==="{")E&&l.push({value:E,type:i.TEXT}),E="",g=!0;else if(v==="}"&&g){const S=h[E];if(typeof S=="string")S.length&&l.push({value:S,type:i.VARIABLE});else if(S){const k=l[l.length-1];(!k||k.type!==i.SEPARATOR)&&l.push({value:S.label,type:i.SEPARATOR})}E="",g=!1}else E+=v;return E&&!g&&l.push({value:E,type:i.TEXT}),l.filter((v,S)=>{if(v.type===i.SEPARATOR){const k=l[S-1],D=l[S+1];return[k,D].every(F=>F&&(F.type===i.VARIABLE||F.type===i.TEXT)&&F.value.length>0)}return!0}).map(v=>v.value).join("")}function r(u,h){return M.$d||h?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$d?"&":"&&"):u.replace(/&&|&/g,l=>l==="&"?"&&":"&")}function s(u,h){return M.$d||h?u.replace(/\(&&\w\)|&&/g,""):M.$c?u.replace(/&&|&/g,l=>l==="&"?"&&":"&"):u.replace(/&&/g,"_")}function t(u){return u.replace(/&/g,"&&")}function f(u){if(u.endsWith("]")){const h=u.lastIndexOf(" [",u.length-2);if(h!==-1){const l=d(u.substring(0,h)),g=u.substring(h);return{name:l.name+g,parentPath:l.parentPath}}}return d(u)}function d(u){const h=u.indexOf("/")!==-1?I.$hc:I.$gc,l=h.basename(u),g=h.dirname(u);return l.length?{name:l,parentPath:g}:{name:g,parentPath:""}}}),define(Ee[131],Ce([1,0,21,2]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=e.$ln=void 0,e.$nn=p,e.$on=w,e.$pn=A;function I(P){return P.toJSON()}class M{constructor(b){this.a=b}transformIncoming(b){const C=this.a.transformIncoming(b);return C===b?b:I(R.URI.from(C))}transformOutgoing(b){const C=this.a.transformOutgoing(b);return C===b?b:I(R.URI.from(C))}transformOutgoingURI(b){const C=this.a.transformOutgoing(b);return C===b?b:R.URI.from(C)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$ln=M,e.$mn=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function L(P,b,C){if(!P||C>200)return null;if(typeof P=="object"){if(P instanceof R.URI)return b.transformOutgoing(P);for(const y in P)if(Object.hasOwnProperty.call(P,y)){const a=L(P[y],b,C+1);a!==null&&(P[y]=a)}}return null}function p(P,b){const C=L(P,b,0);return C===null?P:C}function $(P,b,C,y){if(!P||y>200)return null;if(typeof P=="object"){if(P.$mid===1)return C?R.URI.revive(b.transformIncoming(P)):b.transformIncoming(P);if(P instanceof o.$ue)return null;for(const a in P)if(Object.hasOwnProperty.call(P,a)){const m=$(P[a],b,C,y+1);m!==null&&(P[a]=m)}}return null}function w(P,b){const C=$(P,b,!1,0);return C===null?P:C}function A(P,b){const C=$(P,b,!0,0);return C===null?P:C}}),define(Ee[30],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=void 0,e.$Dg=R;const o=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(I){return o.test(I)}e.$Eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(p){for(let $=0;$<p.length;$++)p[$]=Math.floor(Math.random()*256);return p};const M=new Uint8Array(16),L=[];for(let p=0;p<256;p++)L.push(p.toString(16).padStart(2,"0"));return function(){I(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let $=0,w="";return w+=L[M[$++]],w+=L[M[$++]],w+=L[M[$++]],w+=L[M[$++]],w+="-",w+=L[M[$++]],w+=L[M[$++]],w+="-",w+=L[M[$++]],w+=L[M[$++]],w+="-",w+=L[M[$++]],w+=L[M[$++]],w+="-",w+=L[M[$++]],w+=L[M[$++]],w+=L[M[$++]],w+=L[M[$++]],w+=L[M[$++]],w+=L[M[$++]],w}}()}),define(Ee[175],Ce([1,0,19,39,30]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=e.$Kt=void 0,e.$It=M,e.$Jt=L,e.$Lt=w;function M(P){return{asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}function L(P,b,C){const y={id:(0,I.$Eg)(),name:P,uri:b,data:C};return{asString:async()=>"",asFile:()=>y,value:void 0}}class p{constructor(){this.a=new Map}get size(){let b=0;for(const C of this.a)b++;return b}has(b){return this.a.has(this.b(b))}matches(b){const C=[...this.a.keys()];return R.Iterable.some(this,([y,a])=>a.asFile())&&C.push("files"),A($(b),C)}get(b){return this.a.get(this.b(b))?.[0]}append(b,C){const y=this.a.get(b);y?y.push(C):this.a.set(this.b(b),[C])}replace(b,C){this.a.set(this.b(b),[C])}delete(b){this.a.delete(this.b(b))}*[Symbol.iterator](){for(const[b,C]of this.a)for(const y of C)yield[b,y]}b(b){return $(b)}}e.$Kt=p;function $(P){return P.toLowerCase()}function w(P,b){return A($(P),b.map($))}function A(P,b){if(P==="*/*")return b.length>0;if(b.includes(P))return!0;const C=P.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!C)return!1;const[y,a,m]=C;return m==="*"?b.some(c=>c.startsWith(a+"/")):!1}e.$Mt=Object.freeze({create:P=>(0,o.$Mb)(P.map(b=>b.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.$Mt.split(P).filter(b=>!b.startsWith("#"))})}),define(Ee[31],Ce([1,0,50,62,394,8,34,76,17,11,23,2]),function(re,e,o,R,I,M,L,p,$,w,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=n,e.whenDeleted=t,e.configureFlushOnWrite=l,e.writeFileSync=E;var b;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function C(T,O=b.UNLINK,z){if((0,L.$lg)(T))throw new Error("rimraf - will refuse to recursively delete root");return O===b.UNLINK?a(T):y(T,z)}async function y(T,O=(0,L.$qg)((0,R.tmpdir)())){try{try{await o.promises.rename(T,O)}catch(z){return z.code==="ENOENT"?void 0:a(T)}a(O).catch(z=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function a(T){return(0,I.promisify)(o.rm)(T,{recursive:!0,force:!0,maxRetries:3})}function m(T){if((0,L.$lg)(T))throw new Error("rimraf - will refuse to recursively delete root");o.rmSync(T,{recursive:!0,force:!0,maxRetries:3})}async function c(T,O){return r(await(O?i(T):(0,I.promisify)(o.readdir)(T)))}async function i(T){try{return await(0,I.promisify)(o.readdir)(T,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const O=[],z=await c(T);for(const Q of z){let Z=!1,J=!1,x=!1;try{const ce=await e.Promises.lstat((0,$.$kc)(T,Q));Z=ce.isFile(),J=ce.isDirectory(),x=ce.isSymbolicLink()}catch(ce){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ce)}O.push({name:Q,isFile:()=>Z,isDirectory:()=>J,isSymbolicLink:()=>x})}return O}function n(T){return r(o.readdirSync(T))}function r(T){return T.map(O=>typeof O=="string"?w.$d?(0,p.$1l)(O):O:(O.name=w.$d?(0,p.$1l)(O.name):O.name,O))}async function s(T){const O=await c(T),z=[];for(const Q of O)await f.existsDirectory((0,$.$kc)(T,Q))&&z.push(Q);return z}function t(T,O=1e3){return new Promise(z=>{let Q=!1;const Z=setInterval(()=>{Q||(Q=!0,o.access(T,J=>{Q=!1,J&&(clearInterval(Z),z(void 0))}))},O)})}var f;(function(T){async function O(Z){let J;try{if(J=await e.Promises.lstat(Z),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(w.$c&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(ce){if(ce.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw ce}throw x}}T.stat=O;async function z(Z){try{const{stat:J,symbolicLink:x}=await T.stat(Z);return J.isFile()&&x?.dangling!==!0}catch{}return!1}T.existsFile=z;async function Q(Z){try{const{stat:J,symbolicLink:x}=await T.stat(Z);return J.isDirectory()&&x?.dangling!==!0}catch{}return!1}T.existsDirectory=Q})(f||(e.SymlinkSupport=f={}));const d=new M.$rh;function u(T,O,z){return d.queueFor(P.URI.file(T),()=>{const Q=v(z);return new Promise((Z,J)=>g(T,O,Q,x=>x?J(x):Z()))},A.$Mg)}let h=!0;function l(T){h=T}function g(T,O,z,Q){if(!h)return o.writeFile(T,O,{mode:z.mode,flag:z.flag},Q);o.open(T,z.flag,z.mode,(Z,J)=>{if(Z)return Q(Z);o.writeFile(J,O,x=>{if(x)return o.close(J,()=>Q(x));o.fdatasync(J,ce=>(ce&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ce),l(!1)),o.close(J,te=>Q(te))))})})}function E(T,O,z){const Q=v(z);if(!h)return o.writeFileSync(T,O,{mode:Q.mode,flag:Q.flag});const Z=o.openSync(T,Q.flag,Q.mode);try{o.writeFileSync(Z,O);try{o.fdatasyncSync(Z)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),l(!1)}}finally{o.closeSync(Z)}}function v(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function S(T,O,z=6e4){if(T!==O)try{w.$c&&typeof z=="number"?await k(T,O,Date.now(),z):await(0,I.promisify)(o.rename)(T,O)}catch(Q){if(T.toLowerCase()!==O.toLowerCase()&&Q.code==="EXDEV"||T.endsWith("."))await D(T,O,{preserveSymlinks:!1}),await C(T,b.MOVE);else throw Q}}async function k(T,O,z,Q,Z=0){try{return await(0,I.promisify)(o.rename)(T,O)}catch(J){if(J.code!=="EACCES"&&J.code!=="EPERM"&&J.code!=="EBUSY")throw J;if(Date.now()-z>=Q)throw console.error(`[node.js fs] rename failed after ${Z} retries with error: ${J}`),J;if(Z===0){let x=!1;try{const{stat:ce}=await f.stat(O);ce.isFile()||(x=!0)}catch{}if(x)throw J}return await(0,M.$jh)(Math.min(100,Z*10)),k(T,O,z,Q,Z+1)}}async function D(T,O,z){return W(T,O,{root:{source:T,target:O},options:z,handledSourcePaths:new Set})}const F=511;async function W(T,O,z){if(z.handledSourcePaths.has(T))return;z.handledSourcePaths.add(T);const{stat:Q,symbolicLink:Z}=await f.stat(T);if(Z){if(z.options.preserveSymlinks)try{return await N(T,O,z)}catch{}if(Z.dangling)return}return Q.isDirectory()?B(T,O,Q.mode&F,z):j(T,O,Q.mode&F)}async function B(T,O,z,Q){await e.Promises.mkdir(O,{recursive:!0,mode:z});const Z=await c(T);for(const J of Z)await W((0,$.$kc)(T,J),(0,$.$kc)(O,J),Q)}async function j(T,O,z){await e.Promises.copyFile(T,O),await e.Promises.chmod(O,z)}async function N(T,O,z){let Q=await e.Promises.readlink(T);(0,L.$ig)(Q,z.root.source,!w.$e)&&(Q=(0,$.$kc)(z.root.target,Q.substr(z.root.source.length+1))),await e.Promises.symlink(Q,O)}e.Promises=new class{get access(){return(0,I.promisify)(o.access)}get stat(){return(0,I.promisify)(o.stat)}get lstat(){return(0,I.promisify)(o.lstat)}get utimes(){return(0,I.promisify)(o.utimes)}get read(){return(T,O,z,Q,Z)=>new Promise((J,x)=>{o.read(T,O,z,Q,Z,(ce,te,pe)=>ce?x(ce):J({bytesRead:te,buffer:pe}))})}get readFile(){return(0,I.promisify)(o.readFile)}get write(){return(T,O,z,Q,Z)=>new Promise((J,x)=>{o.write(T,O,z,Q,Z,(ce,te,pe)=>ce?x(ce):J({bytesWritten:te,buffer:pe}))})}get appendFile(){return(0,I.promisify)(o.appendFile)}get fdatasync(){return(0,I.promisify)(o.fdatasync)}get truncate(){return(0,I.promisify)(o.truncate)}get copyFile(){return(0,I.promisify)(o.copyFile)}get open(){return(0,I.promisify)(o.open)}get close(){return(0,I.promisify)(o.close)}get symlink(){return(0,I.promisify)(o.symlink)}get readlink(){return(0,I.promisify)(o.readlink)}get chmod(){return(0,I.promisify)(o.chmod)}get mkdir(){return(0,I.promisify)(o.mkdir)}get unlink(){return(0,I.promisify)(o.unlink)}get rmdir(){return(0,I.promisify)(o.rmdir)}get realpath(){return(0,I.promisify)(o.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return s}get writeFile(){return u}get rm(){return C}get rename(){return S}get copy(){return D}}}),define(Ee[103],Ce([1,0,50,17,11,14,31]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=p,e.$Pq=$,e.$Qq=w,e.$Rq=A;function p(b){if(I.$e)return b;const C=(0,R.$nc)(b);if(b===C)return b;const y=((0,R.$oc)(b)||b).toLowerCase();try{const m=(0,L.readdirSync)(C).filter(c=>c.toLowerCase()===y);if(m.length===1){const c=p(C);if(c)return(0,R.$kc)(c,m[0])}else if(m.length>1){const c=m.indexOf(y);if(c>=0){const i=p(C);if(i)return(0,R.$kc)(i,m[c])}}}catch{}return null}async function $(b,C){if(I.$e)return b;const y=(0,R.$nc)(b);if(b===y)return b;const a=((0,R.$oc)(b)||b).toLowerCase();try{if(C?.isCancellationRequested)return null;const c=(await L.Promises.readdir(y)).filter(i=>i.toLowerCase()===a);if(c.length===1){const i=await $(y,C);if(i)return(0,R.$kc)(i,c[0])}else if(c.length>1){const i=c.indexOf(a);if(i>=0){const n=await $(y,C);if(n)return(0,R.$kc)(n,c[i])}}}catch{}return null}async function w(b){try{return await L.Promises.realpath(b)}catch{const y=P(b);return await L.Promises.access(y,o.constants.R_OK),y}}function A(b){try{return o.realpathSync(b)}catch{const y=P(b);return o.accessSync(y,o.constants.R_OK),y}}function P(b){return(0,M.$6e)((0,R.$ic)(b),R.sep)}}),define(Ee[176],Ce([1,0,63]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hg=void 0,e.$Gg=R,e.$Ig=M;function R(p,$,w,A=1){let P=!1;return new Promise(b=>{const C=setTimeout(()=>{if(!P)return P=!0,b(0)},w);I(p,$,A,y=>{if(!P)return P=!0,clearTimeout(C),b(y)})})}function I(p,$,w,A){if($===0)return A(0);const P=new o.Socket;P.once("connect",()=>(L(P),I(p+w,$-1,w,A))),P.once("data",()=>{}),P.once("error",b=>(L(P),b.code!=="ECONNREFUSED"?I(p+w,$-1,w,A):A(p))),P.connect(p,"127.0.0.1")}e.$Hg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(p,$,w,A="127.0.0.1"){let P=!1,b,C=1;const y=o.createServer({pauseOnConnect:!0});function a(m,c){P||(P=!0,y.removeAllListeners(),y.close(),b&&clearTimeout(b),c(m))}return new Promise(m=>{b=setTimeout(()=>{a(0,m)},w),y.on("listening",()=>{a(p,m)}),y.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&C<$?(p++,C++,y.listen(p,A)):a(0,m)}),y.on("close",()=>{a(0,m)}),y.listen(p,A)})}function L(p){try{p.removeAllListeners("connect"),p.removeAllListeners("error"),p.end(),p.destroy(),p.unref()}catch($){console.error($)}}}),define(Ee[104],Ce([1,0,17,11,49,99,18,31]),function(re,e,o,R,I,M,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$bm=$,e.$cm=w,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function $(P=I.env){return P.comspec||"cmd.exe"}function w(P){let b=[],C=!1;const y=function(a){if(C){b.push(a);return}(!P.send(a,c=>{if(c&&console.error(c),C=!1,b.length>0){const i=b.slice(0);b=[],i.forEach(n=>y(n))}})||R.$c)&&(C=!0)};return{send:y}}var A;(function(P){async function b(C,y,a){if(o.$jc(C))return C;if(y===void 0&&(y=I.cwd()),o.$nc(C)!=="."||(a===void 0&&L.$Vf(I.env.PATH)&&(a=I.env.PATH.split(o.$uc)),a===void 0||a.length===0))return o.$kc(y,C);async function c(i){if(await p.Promises.exists(i)){let n;try{n=await p.Promises.stat(i)}catch(r){r.message.startsWith("EACCES")&&(n=await p.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of a){let n;if(o.$jc(i)?n=o.$kc(i,C):n=o.$kc(y,i,C),await c(n))return n;let r=n+".com";if(await c(r)||(r=n+".exe",await c(r)))return r}return o.$kc(y,C)}P.findExecutable=b})(A||(e.win32=A={}))});var Qe=this&&this.__decorate||function(re,e,o,R){var I=arguments.length,M=I<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,o):R,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(re,e,o,R);else for(var p=re.length-1;p>=0;p--)(L=re[p])&&(M=(I<3?L(M):I>3?L(e,o,M):L(e,o))||M);return I>3&&M&&Object.defineProperty(e,o,M),M};define(Ee[80],Ce([1,0,19,8,21,22,54,13,4,3,57,14,18]),function(re,e,o,R,I,M,L,p,$,w,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.ProxyChannel=e.$3h=e.$Zh=e.$Yh=e.$Xh=e.RequestInitiator=e.$Wh=e.$Th=e.$Sh=void 0,e.$Uh=l,e.$Vh=g,e.$1h=F,e.$2h=W;var C;(function(Z){Z[Z.Promise=100]="Promise",Z[Z.PromiseCancel=101]="PromiseCancel",Z[Z.EventListen=102]="EventListen",Z[Z.EventDispose=103]="EventDispose"})(C||(C={}));function y(Z){switch(Z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(Z){Z[Z.Initialize=200]="Initialize",Z[Z.PromiseSuccess=201]="PromiseSuccess",Z[Z.PromiseError=202]="PromiseError",Z[Z.PromiseErrorObj=203]="PromiseErrorObj",Z[Z.EventFire=204]="EventFire"})(a||(a={}));function m(Z){switch(Z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(Z){Z[Z.Uninitialized=0]="Uninitialized",Z[Z.Idle=1]="Idle"})(c||(c={}));function i(Z){let J=0;for(let x=0;;x+=7){const ce=Z.read(1);if(J|=(ce.buffer[0]&127)<<x,!(ce.buffer[0]&128))return J}}const n=d(0);function r(Z,J){if(J===0){Z.write(n);return}let x=0;for(let te=J;te!==0;te=te>>>7)x++;const ce=I.$ue.alloc(x);for(let te=0;J!==0;te++)ce.buffer[te]=J&127,J=J>>>7,J>0&&(ce.buffer[te]|=128);Z.write(ce)}class s{constructor(J){this.b=J,this.a=0}read(J){const x=this.b.slice(this.a,this.a+J);return this.a+=x.byteLength,x}}e.$Sh=s;class t{constructor(){this.a=[]}get buffer(){return I.$ue.concat(this.a)}write(J){this.a.push(J)}}e.$Th=t;var f;(function(Z){Z[Z.Undefined=0]="Undefined",Z[Z.String=1]="String",Z[Z.Buffer=2]="Buffer",Z[Z.VSBuffer=3]="VSBuffer",Z[Z.Array=4]="Array",Z[Z.Object=5]="Object",Z[Z.Int=6]="Int"})(f||(f={}));function d(Z){const J=I.$ue.alloc(1);return J.writeUInt8(Z,0),J}const u={Undefined:d(f.Undefined),String:d(f.String),Buffer:d(f.Buffer),VSBuffer:d(f.VSBuffer),Array:d(f.Array),Object:d(f.Object),Uint:d(f.Int)},h=typeof Buffer<"u";function l(Z,J){if(typeof J>"u")Z.write(u.Undefined);else if(typeof J=="string"){const x=I.$ue.fromString(J);Z.write(u.String),r(Z,x.byteLength),Z.write(x)}else if(h&&Buffer.isBuffer(J)){const x=I.$ue.wrap(J);Z.write(u.Buffer),r(Z,x.byteLength),Z.write(x)}else if(J instanceof I.$ue)Z.write(u.VSBuffer),r(Z,J.byteLength),Z.write(J);else if(Array.isArray(J)){Z.write(u.Array),r(Z,J.length);for(const x of J)l(Z,x)}else if(typeof J=="number"&&(J|0)===J)Z.write(u.Uint),r(Z,J);else{const x=I.$ue.fromString(JSON.stringify(J));Z.write(u.Object),r(Z,x.byteLength),Z.write(x)}}function g(Z){switch(Z.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return Z.read(i(Z)).toString();case f.Buffer:return Z.read(i(Z)).buffer;case f.VSBuffer:return Z.read(i(Z));case f.Array:{const x=i(Z),ce=[];for(let te=0;te<x;te++)ce.push(g(Z));return ce}case f.Object:return JSON.parse(Z.read(i(Z)).toString());case f.Int:return i(Z)}}class E{constructor(J,x,ce=null,te=1e3){this.h=J,this.j=x,this.k=ce,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(pe=>this.q(pe)),this.m({type:200})}registerChannel(J,x){this.b.set(J,x),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const x=this.o([J.type]);this.k?.logOutgoing(x,0,1,m(J.type));return}case 201:case 202:case 204:case 203:{const x=this.o([J.type,J.id],J.data);this.k?.logOutgoing(x,J.id,1,m(J.type),J.data);return}}}o(J,x=void 0){const ce=new t;return l(ce,J),l(ce,x),this.p(ce.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const x=new s(J),ce=g(x),te=g(x),pe=ce[0];switch(pe){case 100:return this.k?.logIncoming(J.byteLength,ce[1],1,`${y(pe)}: ${ce[2]}.${ce[3]}`,te),this.s({type:pe,id:ce[1],channelName:ce[2],name:ce[3],arg:te});case 102:return this.k?.logIncoming(J.byteLength,ce[1],1,`${y(pe)}: ${ce[2]}.${ce[3]}`,te),this.t({type:pe,id:ce[1],channelName:ce[2],name:ce[3],arg:te});case 101:return this.k?.logIncoming(J.byteLength,ce[1],1,`${y(pe)}`),this.u({type:pe,id:ce[1]});case 103:return this.k?.logIncoming(J.byteLength,ce[1],1,`${y(pe)}`),this.u({type:pe,id:ce[1]})}}s(J){const x=this.b.get(J.channelName);if(!x){this.v(J);return}const ce=new M.$ee;let te;try{te=x.call(this.j,J.name,J.arg,ce.token)}catch(_){te=Promise.reject(_)}const pe=J.id;te.then(_=>{this.m({id:pe,data:_,type:201})},_=>{_ instanceof Error?this.m({id:pe,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.m({id:pe,data:_,type:203})}).finally(()=>{ye.dispose(),this.d.delete(J.id)});const ye=(0,w.$Sc)(()=>ce.cancel());this.d.set(J.id,ye)}t(J){const x=this.b.get(J.channelName);if(!x){this.v(J);return}const ce=J.id,pe=x.listen(this.j,J.name,J.arg)(ye=>this.m({id:ce,data:ye,type:204}));this.d.set(J.id,pe)}u(J){const x=this.d.get(J.id);x&&(x.dispose(),this.d.delete(J.id))}v(J){let x=this.g.get(J.channelName);x||(x=[],this.g.set(J.channelName,x));const ce=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:J,timeoutTimer:ce})}w(J){const x=this.g.get(J);if(x){for(const ce of x)switch(clearTimeout(ce.timeoutTimer),ce.request.type){case 100:this.s(ce.request);break;case 102:this.t(ce.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.$Pc)(this.d.values()),this.d.clear()}}e.$Wh=E;var v;(function(Z){Z[Z.LocalSide=0]="LocalSide",Z[Z.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));class S{constructor(J,x=null){this.l=J,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$7d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ce=>this.s(ce)),this.j=x}getChannel(J){const x=this;return{call(ce,te,pe){return x.a?Promise.reject(new p.$5):x.m(J,ce,te,pe)},listen(ce,te){return x.a?$.Event.None:x.o(J,ce,te)}}}m(J,x,ce,te=M.CancellationToken.None){const pe=this.g++,_={id:pe,type:100,channelName:J,name:x,arg:ce};if(te.isCancellationRequested)return Promise.reject(new p.$5);let U;return new Promise((Se,me)=>{if(te.isCancellationRequested)return me(new p.$5);const ie=()=>{const ee=le=>{switch(le.type){case 201:this.f.delete(pe),Se(le.data);break;case 202:{this.f.delete(pe);const de=new Error(le.data.message);de.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,de.name=le.data.name,me(de);break}case 203:this.f.delete(pe),me(le.data);break}};this.f.set(pe,ee),this.p(_)};let se=null;this.b===c.Idle?ie():(se=(0,R.$8g)(ee=>this.u()),se.then(()=>{se=null,ie()}));const oe=()=>{se?(se.cancel(),se=null):this.p({id:pe,type:101}),me(new p.$5)},G=te.onCancellationRequested(oe);U=(0,w.$Rc)((0,w.$Sc)(oe),G),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(J,x,ce){const te=this.g++,ye={id:te,type:102,channelName:J,name:x,arg:ce};let _=null;const U=new $.$7d({onWillAddFirstListener:()=>{_=(0,R.$8g)(Se=>this.u()),_.then(()=>{_=null,this.d.add(U),this.p(ye)})},onDidRemoveLastListener:()=>{_?(_.cancel(),_=null):(this.d.delete(U),this.p({id:te,type:103}))}}),he=Se=>U.fire(Se.data);return this.f.set(te,he),U.event}p(J){switch(J.type){case 100:case 102:{const x=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(x,J.id,0,`${y(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const x=this.q([J.type,J.id]);this.j?.logOutgoing(x,J.id,0,y(J.type));return}}}q(J,x=void 0){const ce=new t;return l(ce,J),l(ce,x),this.r(ce.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const x=new s(J),ce=g(x),te=g(x),pe=ce[0];switch(pe){case 200:return this.j?.logIncoming(J.byteLength,0,0,m(pe)),this.t({type:ce[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,ce[1],0,m(pe),te),this.t({type:ce[0],id:ce[1],data:te})}}t(J){if(J.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.$Pc)(this.d.values()),this.d.clear()}}e.$Xh=S,Qe([L.$Mh],S.prototype,"onDidInitializePromise",null);class k{get connections(){const J=[];return this.f.forEach(x=>J.push(x)),J}constructor(J,x,ce){this.a=new Map,this.f=new Set,this.g=new $.$7d,this.onDidAddConnection=this.g.event,this.h=new $.$7d,this.onDidRemoveConnection=this.h.event,this.j=new w.$Tc,this.j.add(J(({protocol:te,onDidClientDisconnect:pe})=>{const ye=$.Event.once(te.onMessage);this.j.add(ye(_=>{const U=new s(_),he=g(U),Se=new E(te,he,x,ce),me=new S(te,x);this.a.forEach((se,oe)=>Se.registerChannel(oe,se));const ie={channelServer:Se,channelClient:me,ctx:he};this.f.add(ie),this.g.fire(ie),this.j.add(pe(()=>{Se.dispose(),me.dispose(),this.f.delete(ie),this.h.fire(ie)}))}))}))}getChannel(J,x){const ce=this;return{call(te,pe,ye){let _;if((0,b.$0f)(x)){const he=(0,o.$4b)(ce.connections.filter(x));_=he?Promise.resolve(he):$.Event.toPromise($.Event.filter(ce.onDidAddConnection,x))}else _=x.routeCall(ce,te,pe);const U=_.then(he=>he.channelClient.getChannel(J));return F(U).call(te,pe,ye)},listen(te,pe){if((0,b.$0f)(x))return ce.k(J,x,te,pe);const ye=x.routeEvent(ce,te,pe).then(_=>_.channelClient.getChannel(J));return F(ye).listen(te,pe)}}}k(J,x,ce,te){const pe=this;let ye;const _=new $.$7d({onWillAddFirstListener:()=>{ye=new w.$Tc;const U=new $.$ae,he=new Map,Se=ie=>{const oe=ie.channelClient.getChannel(J).listen(ce,te),G=U.add(oe);he.set(ie,G)},me=ie=>{const se=he.get(ie);se&&(se.dispose(),he.delete(ie))};pe.connections.filter(x).forEach(Se),$.Event.filter(pe.onDidAddConnection,x)(Se,void 0,ye),pe.onDidRemoveConnection(me,void 0,ye),U.event(_.fire,_,ye),ye.add(U)},onDidRemoveLastListener:()=>{ye?.dispose(),ye=void 0}});return _.event}registerChannel(J,x){this.a.set(J,x);for(const ce of this.f)ce.channelServer.registerChannel(J,x)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Yh=k;class D{constructor(J,x,ce=null){const te=new t;l(te,x),J.send(te.buffer),this.a=new S(J,ce),this.d=new E(J,x,ce)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,x){this.d.registerChannel(J,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Zh=D;function F(Z){return{call(J,x,ce){return Z.then(te=>te.call(J,x,ce))},listen(J,x){const ce=new $.$de;return Z.then(te=>ce.input=te.listen(J,x)),ce.event}}}function W(Z){let J=!1;return{call(x,ce,te){return J?Z.call(x,ce,te):(0,R.$jh)(0).then(()=>J=!0).then(()=>Z.call(x,ce,te))},listen(x,ce){if(J)return Z.listen(x,ce);const te=new $.$de;return(0,R.$jh)(0).then(()=>J=!0).then(()=>te.input=Z.listen(x,ce)),te.event}}}class B{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const x of J.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await $.Event.toPromise(J.onDidAddConnection),await this.b(J)}}e.$3h=B;var j;(function(Z){function J(pe,ye,_){const U=pe,he=_&&_.disableMarshalling,Se=new Map;for(const me in U)ce(me)&&Se.set(me,$.Event.buffer(U[me],!0,void 0,ye));return new class{listen(me,ie,se){const oe=Se.get(ie);if(oe)return oe;const G=U[ie];if(typeof G=="function"){if(te(ie))return G.call(U,se);if(ce(ie))return Se.set(ie,$.Event.buffer(U[ie],!0,void 0,ye)),Se.get(ie)}throw new p.$bb(`Event not found: ${ie}`)}call(me,ie,se){const oe=U[ie];if(typeof oe=="function"){if(!he&&Array.isArray(se))for(let ee=0;ee<se.length;ee++)se[ee]=(0,A.$Rh)(se[ee]);let G=oe.apply(U,se);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new p.$bb(`Method not found: ${ie}`)}}}Z.fromService=J;function x(pe,ye){const _=ye&&ye.disableMarshalling;return new Proxy({},{get(U,he){if(typeof he=="string")return ye?.properties?.has(he)?ye.properties.get(he):te(he)?function(Se){return pe.listen(he,Se)}:ce(he)?pe.listen(he):async function(...Se){let me;ye&&!(0,b.$5f)(ye.context)?me=[ye.context,...Se]:me=Se;const ie=await pe.call(he,me);return _?ie:(0,A.$Rh)(ie)};throw new p.$bb(`Property not found: ${String(he)}`)}})}Z.toService=x;function ce(pe){return pe[0]==="o"&&pe[1]==="n"&&P.$kf(pe.charCodeAt(2))}function te(pe){return/^onDynamic/.test(pe)&&P.$kf(pe.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(Z){if(Array.isArray(Z))return Z;if(Z&&typeof Z=="object"&&typeof Z.toString=="function"){const J=Z.toString();if(J!=="[object Object]")return J}return Z}function O(Z){return Array.isArray(Z)?Z.map(T):T(Z)}function z(Z,J,x,ce,te,pe,ye){ye=O(ye);const _=N[te],U=_[ce%_.length];let he=[`%c[${Z}]%c[${String(J).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(ce).padStart(5," ")} - ${pe}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(pe)?(he=he.concat(ye),he.push(")")):he.push(ye),console.log.apply(console,he)}class Q{constructor(J,x){this.d=J,this.f=x,this.a=0,this.b=0}logOutgoing(J,x,ce,te,pe){this.b+=J,z(this.d,this.b,J,x,ce,te,pe)}logIncoming(J,x,ce,te,pe){this.a+=J,z(this.f,this.a,J,x,ce,te,pe)}}e.$4h=Q}),define(Ee[81],Ce([1,0,21,4,3,80]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=e.$7h=e.$6h=e.ProtocolConstants=e.$5h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(u){u.Created="created",u.Read="read",u.Write="write",u.Open="open",u.Error="error",u.Close="close",u.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",u.NodeEndReceived="nodeEndReceived",u.NodeEndSent="nodeEndSent",u.NodeDrainBegin="nodeDrainBegin",u.NodeDrainEnd="nodeDrainEnd",u.zlibInflateError="zlibInflateError",u.zlibInflateData="zlibInflateData",u.zlibInflateInitialWrite="zlibInflateInitialWrite",u.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",u.zlibInflateWrite="zlibInflateWrite",u.zlibInflateFlushFired="zlibInflateFlushFired",u.zlibDeflateError="zlibDeflateError",u.zlibDeflateData="zlibDeflateData",u.zlibDeflateWrite="zlibDeflateWrite",u.zlibDeflateFlushFired="zlibDeflateFlushFired",u.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",u.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",u.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",u.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",u.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",u.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",u.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",u.ProtocolHeaderRead="protocolHeaderRead",u.ProtocolMessageRead="protocolMessageRead",u.ProtocolHeaderWrite="protocolHeaderWrite",u.ProtocolMessageWrite="protocolMessageWrite",u.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var p;(function(u){u.enableDiagnostics=!1,u.records=[];const h=new WeakMap;let l=0;function g(v,S){if(!h.has(v)){const k=String(++l);h.set(v,k)}return h.get(v)}function E(v,S,k,D){if(!u.enableDiagnostics)return;const F=g(v,S);if(D instanceof o.$ue||D instanceof Uint8Array||D instanceof ArrayBuffer||ArrayBuffer.isView(D)){const W=o.$ue.alloc(D.byteLength);W.set(D),u.records.push({timestamp:Date.now(),id:F,label:S,type:k,buff:W})}else u.records.push({timestamp:Date.now(),id:F,label:S,type:k,data:D})}u.traceSocketEvent=E})(p||(e.SocketDiagnostics=p={}));var $;(function(u){u[u.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",u[u.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let w=null;function A(){return w||(w=o.$ue.alloc(0)),w}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(h){this.a.push(h),this.b+=h.byteLength}read(h){return this.c(h,!0)}peek(h){return this.c(h,!1)}c(h,l){if(h===0)return A();if(h>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===h){const S=this.a[0];return l&&(this.a.shift(),this.b-=h),S}if(this.a[0].byteLength>h){const S=this.a[0].slice(0,h);return l&&(this.a[0]=this.a[0].slice(h),this.b-=h),S}const g=o.$ue.alloc(h);let E=0,v=0;for(;h>0;){const S=this.a[v];if(S.byteLength>h){const k=S.slice(0,h);g.set(k,E),E+=h,l&&(this.a[v]=S.slice(h),this.b-=h),h-=h}else g.set(S,E),E+=S.byteLength,l?(this.a.shift(),this.b-=S.byteLength):v++,h-=S.byteLength}return g}}e.$5h=P;var b;(function(u){u[u.None=0]="None",u[u.Regular=1]="Regular",u[u.Control=2]="Control",u[u.Ack=3]="Ack",u[u.Disconnect=5]="Disconnect",u[u.ReplayRequest=6]="ReplayRequest",u[u.Pause=7]="Pause",u[u.Resume=8]="Resume",u[u.KeepAlive=9]="KeepAlive"})(b||(b={}));function C(u){switch(u){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(u){u[u.HeaderLength=13]="HeaderLength",u[u.AcknowledgeTime=2e3]="AcknowledgeTime",u[u.TimeoutTime=2e4]="TimeoutTime",u[u.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",u[u.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",u[u.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class a{constructor(h,l,g,E){this.type=h,this.id=l,this.ack=g,this.data=E,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends I.$Uc{constructor(h){super(),this.f=this.B(new R.$7d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=h,this.b=!1,this.c=new P,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(h){if(!(!h||h.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(h);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:C(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const g=this.g.messageType,E=this.g.id,v=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new a(g,E,v,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(h){this.k=null,this.a=!1,this.b=!1,this.c=h,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(h){if(this.a)return;h.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=o.$ue.alloc(13);l.writeUInt8(h.type,0),l.writeUInt32BE(h.id,1),l.writeUInt32BE(h.ack,5),l.writeUInt32BE(h.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:C(h.type),id:h.id,ack:h.ack,messageSize:h.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",h.data),this.j(l,h.data)}g(h,l){const g=this.f===0;return this.d.push(h,l),this.f+=h.byteLength+l.byteLength,g}h(){const h=o.$ue.concat(this.d,this.f);return this.d.length=0,this.f=0,h}j(h,l){this.g(h,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const h=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:h.byteLength}),this.c.write(h)}}class i extends I.$Uc{constructor(h){super(),this.f=new R.$7d,this.onMessage=this.f.event,this.g=new R.$7d,this.onDidDispose=this.g.event,this.a=h,this.b=this.B(new c(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(h){this.b.write(new a(1,0,0,h))}}e.$6h=i;class n extends M.$Zh{static fromSocket(h,l){return new n(new i(h),l)}get onDidDispose(){return this.b.onDidDispose}constructor(h,l,g=null){super(h,l,g),this.b=h}dispose(){super.dispose();const h=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),h.end()}}e.$7h=n;class r{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new R.$7d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(h){this.b?this.d.length>0?this.d.push(h):this.a.fire(h):this.d.push(h)}flushBuffer(){this.d=[]}}e.$8h=r;class s{constructor(h){this.data=h,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let h=0,l=this.a;for(;l;)l=l.next,h++;return h}peek(){return this.a?this.a.data:null}toArray(){const h=[];let l=0,g=this.a;for(;g;)h[l++]=g.data,g=g.next;return h}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(h){const l=new s(h);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class f{static getInstance(){return f.b||(f.b=new f),f.b}constructor(){this.c=[];const h=Date.now();for(let l=0;l<f.a;l++)this.c[l]=h-1e3*l;setInterval(()=>{for(let l=f.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const h=Date.now(),l=(1+f.a)*1e3;let g=0;for(let E=0;E<f.a;E++)h-this.c[E]<=l&&g++;return 1-g/f.a}hasHighLoad(){return this.d()>=.5}}f.a=10,f.b=null;class d{get unacknowledgedCount(){return this.c-this.d}constructor(h){this.u=new r,this.onControlMessage=this.u.event,this.v=new r,this.onMessage=this.v.event,this.w=new r,this.onDidDispose=this.w.event,this.x=new r,this.onSocketClose=this.x.event,this.y=new r,this.onSocketTimeout=this.y.event,this.s=h.loadEstimator??f.getInstance(),this.t=h.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new I.$Tc,this.o=h.socket,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),h.initialChunk&&this.q.acceptChunk(h.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const h=new a(5,0,0,A());this.p.write(h),this.p.flush()}sendPause(){const h=new a(7,0,0,A());this.p.write(h)}sendResume(){const h=new a(8,0,0,A());this.p.write(h)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(h,l){this.a=!0,this.r.dispose(),this.r=new I.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=h,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(g=>this.z(g))),this.r.add(this.o.onClose(g=>this.x.fire(g))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const h=new a(3,0,this.h,A());this.p.write(h);const l=this.b.toArray();for(let g=0,E=l.length;g<E;g++)this.p.write(l[g]);this.B()}acceptDisconnect(){this.w.fire()}z(h){if(h.ack>this.d){this.d=h.ack;do{const l=this.b.peek();if(l&&l.id<=h.ack)this.b.pop();else break}while(!0)}switch(h.type){case 0:break;case 1:{if(h.id>this.g)if(h.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new a(6,0,0,A())))}else this.g=h.id,this.j=Date.now(),this.A(),this.v.fire(h.data);break}case 2:{this.u.fire(h.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let g=0,E=l.length;g<E;g++)this.p.write(l[g]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(h){const l=++this.c;this.h=this.g;const g=new a(1,l,this.h,h);this.b.push(g),this.a||(this.p.write(g),this.B())}sendControl(h){const l=new a(2,0,0,h);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const h=Date.now()-this.j;if(h>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-h+5)}B(){if(this.c<=this.d||this.f||this.a)return;const h=this.b.peek(),l=Date.now()-h.writtenTime,g=Date.now()-this.q.lastReadTime,E=Date.now()-this.n;if(l>=2e4&&g>=2e4&&E>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:g});return}const v=Math.max(2e4-l,2e4-g,2e4-E,500);this.f=setTimeout(()=>{this.f=null,this.B()},v)}C(){if(this.g<=this.h)return;this.h=this.g;const h=new a(3,0,this.h,A());this.p.write(h)}D(){this.h=this.g;const h=new a(9,0,this.h,A());this.p.write(h)}}e.$9h=d}),define(Ee[177],Ce([1,0,51,8,21,22,173,13,4,3,24,104,99,80]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=e.$Kq=void 0;class y extends C.$Wh{constructor(c){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",i=>I.$ue.wrap(Buffer.from(i,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Kq=y;class a{constructor(c,i){this.i=c,this.j=i,this.c=new Set,this.g=new Map,this.h=new $.$7d,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new R.$fh(n),this.d=null,this.f=null}getChannel(c){const i=this;return{call(n,r,s){return i.k(c,n,r,s)},listen(n,r){return i.l(c,n,r)}}}k(c,i,n,r=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(p.$6());this.b.cancel();const s=this.n(c),t=(0,R.$8g)(u=>s.call(i,n,u)),f=r.onCancellationRequested(()=>t.cancel()),d=(0,w.$Sc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{f.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(c,i,n){if(!this.b)return $.Event.None;this.b.cancel();let r;const s=new $.$7d({onWillAddFirstListener:()=>{r=this.n(c).listen(i,n)(s.fire,s),this.c.add(r)},onDidRemoveLastListener:()=>{this.c.delete(r),r.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,A.$Pn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,b.$am)(i.env),this.d=(0,o.fork)(this.i,c,i);const n=new $.$7d,s=$.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,L.$Gq)(l)){(0,L.log)(l,`IPC Library: ${this.j.serverName}`);return}n.fire(I.$ue.wrap(Buffer.from(l,"base64")))}),t=this.j.useQueue?(0,P.$cm)(this.d):this.d,f=l=>this.d&&this.d.connected&&t.send(l.buffer.toString("base64")),d=n.event,u={send:f,onMessage:d};this.f=new C.$Xh(u);const h=()=>this.o();process.once("exit",h),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,g)=>{process.removeListener("exit",h),s.dispose(),this.c.forEach(E=>(0,w.$Pc)(E)),this.c.clear(),l!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+g),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:g})})}return this.f}n(c){let i=this.g.get(c);return i||(i=this.m.getChannel(c),this.g.set(c,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Lq=a}),define(Ee[178],Ce([1,0,8,4,3,57,18]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=e.$Jp=e.StorageState=e.StorageHint=void 0,e.$Ip=$;var p;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(p||(e.StorageHint=p={}));function $(b){const C=b;return C?.changed instanceof Map||C?.deleted instanceof Set}var w;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(w||(e.StorageState=w={}));class A extends I.$Uc{constructor(C,y=Object.create(null)){super(),this.r=C,this.s=y,this.b=this.B(new R.$0d),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=this.B(new o.$gh(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(C=>this.u(C)))}u(C){this.b.pause();try{C.changed?.forEach((y,a)=>this.w(a,y)),C.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w(C,y){if(this.c===w.Closed)return;let a=!1;(0,L.$5f)(y)?a=this.f.delete(C):this.f.get(C)!==y&&(this.f.set(C,y),a=!0),a&&this.b.fire({key:C,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.s.hint!==p.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(C,y){const a=this.f.get(C);return(0,L.$5f)(a)?y:a}getBoolean(C,y){const a=this.get(C);return(0,L.$5f)(a)?y:a==="true"}getNumber(C,y){const a=this.get(C);return(0,L.$5f)(a)?y:parseInt(a,10)}getObject(C,y){const a=this.get(C);return(0,L.$5f)(a)?y:(0,M.$Qh)(a)}async set(C,y,a=!1){if(this.c===w.Closed)return;if((0,L.$5f)(y))return this.delete(C,a);const m=(0,L.$Xf)(y)||Array.isArray(y)?(0,M.$Ph)(y):String(y);if(this.f.get(C)!==m)return this.f.set(C,m),this.j.set(C,m),this.h.delete(C),this.b.fire({key:C,external:a}),this.D()}async delete(C,y=!1){if(!(this.c===w.Closed||!this.f.delete(C)))return this.h.has(C)||this.h.add(C),this.j.delete(C),this.b.fire({key:C,external:y}),this.D()}async optimize(){if(this.c!==w.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=w.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const C={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(C).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(C){if(this.z)return this.D(C)}async D(C){return this.s.hint===p.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),C)}async whenFlushed(){if(this.z)return new Promise(C=>this.n.push(C))}isInMemory(){return this.s.hint===p.STORAGE_IN_MEMORY}}e.$Jp=A,A.a=100;class P{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(C){C.insert?.forEach((y,a)=>this.a.set(a,y)),C.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$Kp=P}),define(Ee[132],Ce([1,0,130]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=e.$At=void 0;class R{constructor(p){const $=(0,o.$Se)(p);this.c=$,this.a=R.d($),this.b=new Map}static d(p){const $=new Uint8Array(256);return $.fill(p),$}set(p,$){const w=(0,o.$Se)($);p>=0&&p<256?this.a[p]=w:this.b.set(p,w)}get(p){return p>=0&&p<256?this.a[p]:this.b.get(p)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$At=R;var I;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(I||(I={}));class M{constructor(){this.a=new R(0)}add(p){this.a.set(p,1)}has(p){return this.a.get(p)===1}clear(){return this.a.clear()}}e.$Bt=M}),define(Ee[179],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Pt=R;var o;(function(I){I[I.Unknown=0]="Unknown",I[I.Invalid=3]="Invalid",I[I.LF=1]="LF",I[I.CRLF=2]="CRLF"})(o||(e.StringEOL=o={}));function R(I){let M=0,L=0,p=0,$=0;for(let w=0,A=I.length;w<A;w++){const P=I.charCodeAt(w);P===13?(M===0&&(L=w),M++,w+1<A&&I.charCodeAt(w+1)===10?($|=2,w++):$|=3,p=w+1):P===10&&($|=1,M===0&&(L=w),M++,p=w+1)}return M===0&&(L=I.length),[M,L,I.length-p,$]}}),define(Ee[52],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=void 0;class o{constructor(I,M){this.lineNumber=I,this.column=M}with(I=this.lineNumber,M=this.column){return I===this.lineNumber&&M===this.column?this:new o(I,M)}delta(I=0,M=0){return this.with(this.lineNumber+I,this.column+M)}equals(I){return o.equals(this,I)}static equals(I,M){return!I&&!M?!0:!!I&&!!M&&I.lineNumber===M.lineNumber&&I.column===M.column}isBefore(I){return o.isBefore(this,I)}static isBefore(I,M){return I.lineNumber<M.lineNumber?!0:M.lineNumber<I.lineNumber?!1:I.column<M.column}isBeforeOrEqual(I){return o.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,M){return I.lineNumber<M.lineNumber?!0:M.lineNumber<I.lineNumber?!1:I.column<=M.column}static compare(I,M){const L=I.lineNumber|0,p=M.lineNumber|0;if(L===p){const $=I.column|0,w=M.column|0;return $-w}return L-p}clone(){return new o(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new o(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$ct=o}),define(Ee[29],Ce([1,0,52]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=void 0;class R{constructor(M,L,p,$){M>p||M===p&&L>$?(this.startLineNumber=p,this.startColumn=$,this.endLineNumber=M,this.endColumn=L):(this.startLineNumber=M,this.startColumn=L,this.endLineNumber=p,this.endColumn=$)}isEmpty(){return R.isEmpty(this)}static isEmpty(M){return M.startLineNumber===M.endLineNumber&&M.startColumn===M.endColumn}containsPosition(M){return R.containsPosition(this,M)}static containsPosition(M,L){return!(L.lineNumber<M.startLineNumber||L.lineNumber>M.endLineNumber||L.lineNumber===M.startLineNumber&&L.column<M.startColumn||L.lineNumber===M.endLineNumber&&L.column>M.endColumn)}static strictContainsPosition(M,L){return!(L.lineNumber<M.startLineNumber||L.lineNumber>M.endLineNumber||L.lineNumber===M.startLineNumber&&L.column<=M.startColumn||L.lineNumber===M.endLineNumber&&L.column>=M.endColumn)}containsRange(M){return R.containsRange(this,M)}static containsRange(M,L){return!(L.startLineNumber<M.startLineNumber||L.endLineNumber<M.startLineNumber||L.startLineNumber>M.endLineNumber||L.endLineNumber>M.endLineNumber||L.startLineNumber===M.startLineNumber&&L.startColumn<M.startColumn||L.endLineNumber===M.endLineNumber&&L.endColumn>M.endColumn)}strictContainsRange(M){return R.strictContainsRange(this,M)}static strictContainsRange(M,L){return!(L.startLineNumber<M.startLineNumber||L.endLineNumber<M.startLineNumber||L.startLineNumber>M.endLineNumber||L.endLineNumber>M.endLineNumber||L.startLineNumber===M.startLineNumber&&L.startColumn<=M.startColumn||L.endLineNumber===M.endLineNumber&&L.endColumn>=M.endColumn)}plusRange(M){return R.plusRange(this,M)}static plusRange(M,L){let p,$,w,A;return L.startLineNumber<M.startLineNumber?(p=L.startLineNumber,$=L.startColumn):L.startLineNumber===M.startLineNumber?(p=L.startLineNumber,$=Math.min(L.startColumn,M.startColumn)):(p=M.startLineNumber,$=M.startColumn),L.endLineNumber>M.endLineNumber?(w=L.endLineNumber,A=L.endColumn):L.endLineNumber===M.endLineNumber?(w=L.endLineNumber,A=Math.max(L.endColumn,M.endColumn)):(w=M.endLineNumber,A=M.endColumn),new R(p,$,w,A)}intersectRanges(M){return R.intersectRanges(this,M)}static intersectRanges(M,L){let p=M.startLineNumber,$=M.startColumn,w=M.endLineNumber,A=M.endColumn;const P=L.startLineNumber,b=L.startColumn,C=L.endLineNumber,y=L.endColumn;return p<P?(p=P,$=b):p===P&&($=Math.max($,b)),w>C?(w=C,A=y):w===C&&(A=Math.min(A,y)),p>w||p===w&&$>A?null:new R(p,$,w,A)}equalsRange(M){return R.equalsRange(this,M)}static equalsRange(M,L){return!M&&!L?!0:!!M&&!!L&&M.startLineNumber===L.startLineNumber&&M.startColumn===L.startColumn&&M.endLineNumber===L.endLineNumber&&M.endColumn===L.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(M){return new o.$ct(M.endLineNumber,M.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(M){return new o.$ct(M.startLineNumber,M.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(M,L){return new R(this.startLineNumber,this.startColumn,M,L)}setStartPosition(M,L){return new R(M,L,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(M){return new R(M.startLineNumber,M.startColumn,M.startLineNumber,M.startColumn)}collapseToEnd(){return R.collapseToEnd(this)}static collapseToEnd(M){return new R(M.endLineNumber,M.endColumn,M.endLineNumber,M.endColumn)}delta(M){return new R(this.startLineNumber+M,this.startColumn,this.endLineNumber+M,this.endColumn)}static fromPositions(M,L=M){return new R(M.lineNumber,M.column,L.lineNumber,L.column)}static lift(M){return M?new R(M.startLineNumber,M.startColumn,M.endLineNumber,M.endColumn):null}static isIRange(M){return M&&typeof M.startLineNumber=="number"&&typeof M.startColumn=="number"&&typeof M.endLineNumber=="number"&&typeof M.endColumn=="number"}static areIntersectingOrTouching(M,L){return!(M.endLineNumber<L.startLineNumber||M.endLineNumber===L.startLineNumber&&M.endColumn<L.startColumn||L.endLineNumber<M.startLineNumber||L.endLineNumber===M.startLineNumber&&L.endColumn<M.startColumn)}static areIntersecting(M,L){return!(M.endLineNumber<L.startLineNumber||M.endLineNumber===L.startLineNumber&&M.endColumn<=L.startColumn||L.endLineNumber<M.startLineNumber||L.endLineNumber===M.startLineNumber&&L.endColumn<=M.startColumn)}static compareRangesUsingStarts(M,L){if(M&&L){const w=M.startLineNumber|0,A=L.startLineNumber|0;if(w===A){const P=M.startColumn|0,b=L.startColumn|0;if(P===b){const C=M.endLineNumber|0,y=L.endLineNumber|0;if(C===y){const a=M.endColumn|0,m=L.endColumn|0;return a-m}return C-y}return P-b}return w-A}return(M?1:0)-(L?1:0)}static compareRangesUsingEnds(M,L){return M.endLineNumber===L.endLineNumber?M.endColumn===L.endColumn?M.startLineNumber===L.startLineNumber?M.startColumn-L.startColumn:M.startLineNumber-L.startLineNumber:M.endColumn-L.endColumn:M.endLineNumber-L.endLineNumber}static spansMultipleLines(M){return M.endLineNumber>M.startLineNumber}toJSON(){return this}}e.$dt=R}),define(Ee[180],Ce([1,0,29]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=void 0;class R{static insert(M,L){return{range:new o.$dt(M.lineNumber,M.column,M.lineNumber,M.column),text:L,forceMoveMarkers:!0}}static delete(M){return{range:M,text:null}}static replace(M,L){return{range:M,text:L}}static replaceMove(M,L){return{range:M,text:L,forceMoveMarkers:!0}}}e.$et=R}),define(Ee[181],Ce([1,0,52,29]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.SelectionDirection=void 0;var I;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(I||(e.SelectionDirection=I={}));class M extends R.$dt{constructor(p,$,w,A){super(p,$,w,A),this.selectionStartLineNumber=p,this.selectionStartColumn=$,this.positionLineNumber=w,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(p){return M.selectionsEqual(this,p)}static selectionsEqual(p,$){return p.selectionStartLineNumber===$.selectionStartLineNumber&&p.selectionStartColumn===$.selectionStartColumn&&p.positionLineNumber===$.positionLineNumber&&p.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(p,$){return this.getDirection()===0?new M(this.startLineNumber,this.startColumn,p,$):new M(p,$,this.startLineNumber,this.startColumn)}getPosition(){return new o.$ct(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new o.$ct(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(p,$){return this.getDirection()===0?new M(p,$,this.endLineNumber,this.endColumn):new M(this.endLineNumber,this.endColumn,p,$)}static fromPositions(p,$=p){return new M(p.lineNumber,p.column,$.lineNumber,$.column)}static fromRange(p,$){return $===0?new M(p.startLineNumber,p.startColumn,p.endLineNumber,p.endColumn):new M(p.endLineNumber,p.endColumn,p.startLineNumber,p.startColumn)}static liftSelection(p){return new M(p.selectionStartLineNumber,p.selectionStartColumn,p.positionLineNumber,p.positionColumn)}static selectionsArrEqual(p,$){if(p&&!$||!p&&$)return!1;if(!p&&!$)return!0;if(p.length!==$.length)return!1;for(let w=0,A=p.length;w<A;w++)if(!this.selectionsEqual(p[w],$[w]))return!1;return!0}static isISelection(p){return p&&typeof p.selectionStartLineNumber=="number"&&typeof p.selectionStartColumn=="number"&&typeof p.positionLineNumber=="number"&&typeof p.positionColumn=="number"}static createWithDirection(p,$,w,A,P){return P===0?new M(p,$,w,A):new M(w,A,p,$)}}e.$ft=M}),define(Ee[182],Ce([1,0,14,11,21]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=void 0,e.$vt=A,e.$wt=P;let M;function L(){return M||(M=new TextDecoder("UTF-16LE")),M}let p;function $(){return p||(p=new TextDecoder("UTF-16BE")),p}let w;function A(){return w||(w=R.$x()?L():$()),w}function P(y,a,m){const c=new Uint16Array(y.buffer,a,m);return m>0&&(c[0]===65279||c[0]===65534)?b(y,a,m):L().decode(c)}function b(y,a,m){const c=[];let i=0;for(let n=0;n<m;n++){const r=I.$we(y,a);a+=2,c[i++]=String.fromCharCode(r)}return c.join("")}class C{constructor(a){this.a=a|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const a=new Uint16Array(this.b.buffer,0,this.d);return A().decode(a)}f(){const a=this.e();this.d=0,this.c===null?this.c=[a]:this.c[this.c.length]=a}appendCharCode(a){const m=this.a-this.d;m<=1&&(m===0||o.$pf(a))&&this.f(),this.b[this.d++]=a}appendASCIICharCode(a){this.d===this.a&&this.f(),this.b[this.d++]=a}appendString(a){const m=a.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=a;return}for(let c=0;c<m;c++)this.b[this.d++]=a.charCodeAt(c)}}e.$xt=C}),define(Ee[183],Ce([1,0,21,182]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yt=void 0,e.$zt=L;function I($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(w,A,P,b){this.oldPosition=w,this.oldText=A,this.newPosition=P,this.newText=b}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${I(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${I(this.oldText)}")`:`(replace@${this.oldPosition} "${I(this.oldText)}" with "${I(this.newText)}")`}static a(w){return 4+2*w.length}static c(w,A,P){const b=A.length;o.$ze(w,b,P),P+=4;for(let C=0;C<b;C++)o.$xe(w,A.charCodeAt(C),P),P+=2;return P}static d(w,A){const P=o.$ye(w,A);return A+=4,(0,R.$wt)(w,A,P)}writeSize(){return 8+M.a(this.oldText)+M.a(this.newText)}write(w,A){return o.$ze(w,this.oldPosition,A),A+=4,o.$ze(w,this.newPosition,A),A+=4,A=M.c(w,this.oldText,A),A=M.c(w,this.newText,A),A}static read(w,A,P){const b=o.$ye(w,A);A+=4;const C=o.$ye(w,A);A+=4;const y=M.d(w,A);A+=M.a(y);const a=M.d(w,A);return A+=M.a(a),P.push(new M(b,y,C,a)),A}}e.$yt=M;function L($,w){return $===null||$.length===0?w:new p($,w).compress()}class p{constructor(w,A){this.a=w,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let w=0,A=0,P=this.n(w),b=this.l(A);for(;w<this.f||A<this.h;){if(P===null){this.k(b),b=this.l(++A);continue}if(b===null){this.m(P),P=this.n(++w);continue}if(b.oldEnd<=P.newPosition){this.k(b),b=this.l(++A);continue}if(P.newEnd<=b.oldPosition){this.m(P),P=this.n(++w);continue}if(b.oldPosition<P.newPosition){const[c,i]=p.r(b,P.newPosition-b.oldPosition);this.k(c),b=i;continue}if(P.newPosition<b.oldPosition){const[c,i]=p.q(P,b.oldPosition-P.newPosition);this.m(c),P=i;continue}let a,m;if(b.oldEnd===P.newEnd)a=P,m=b,P=this.n(++w),b=this.l(++A);else if(b.oldEnd<P.newEnd){const[c,i]=p.q(P,b.oldLength);a=c,m=b,P=i,b=this.l(++A)}else{const[c,i]=p.r(b,P.newLength);a=P,m=c,P=this.n(++w),b=i}this.d[this.e++]=new M(a.oldPosition,a.oldText,m.newPosition,m.newText),this.g+=a.newLength-a.oldLength,this.j+=m.newLength-m.oldLength}const C=p.s(this.d);return p.t(C)}k(w){this.d[this.e++]=p.o(this.g,w),this.j+=w.newLength-w.oldLength}l(w){return w<this.h?this.c[w]:null}m(w){this.d[this.e++]=p.p(this.j,w),this.g+=w.newLength-w.oldLength}n(w){return w<this.f?this.a[w]:null}static o(w,A){return new M(A.oldPosition-w,A.oldText,A.newPosition,A.newText)}static p(w,A){return new M(A.oldPosition,A.oldText,A.newPosition+w,A.newText)}static q(w,A){const P=w.newText.substr(0,A),b=w.newText.substr(A);return[new M(w.oldPosition,w.oldText,w.newPosition,P),new M(w.oldEnd,"",w.newPosition+A,b)]}static r(w,A){const P=w.oldText.substr(0,A),b=w.oldText.substr(A);return[new M(w.oldPosition,P,w.newPosition,w.newText),new M(w.oldPosition+A,b,w.newEnd,"")]}static s(w){if(w.length===0)return w;const A=[];let P=0,b=w[0];for(let C=1;C<w.length;C++){const y=w[C];b.oldEnd===y.oldPosition?b=new M(b.oldPosition,b.oldText+y.oldText,b.newPosition,b.newText+y.newText):(A[P++]=b,b=y)}return A[P++]=b,A}static t(w){if(w.length===0)return w;const A=[];let P=0;for(let b=0;b<w.length;b++){const C=w[b];C.oldText!==C.newText&&(A[P++]=C)}return A}}}),define(Ee[184],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=void 0,e.$Ns={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ee[185],Ce([1,0,27,132]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.WordCharacterClass=void 0,e.$Dt=p;var I;(function($){$[$.Regular=0]="Regular",$[$.Whitespace=1]="Whitespace",$[$.WordSeparator=2]="WordSeparator"})(I||(e.WordCharacterClass=I={}));class M extends R.$At{constructor(w,A){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=A,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let P=0,b=w.length;P<b;P++)this.set(w.charCodeAt(P),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(w,A){let P=null;for(const b of this.h(w)){if(b.index>A)break;P=b}return P}findNextIntlWordAtOrAfterOffset(w,A){for(const P of this.h(w))if(!(P.index<A))return P;return null}h(w){return this.e?this.f===w?this.g:(this.f=w,this.g=this.j(this.e.segment(w)),this.g):[]}j(w){const A=[];for(const P of w)this.k(P)&&A.push(P);return A}k(w){return!!w.isWordLike}}e.$Ct=M;const L=new o.$Ec(10);function p($,w){const A=`${$}/${w.join(",")}`;let P=L.get(A);return P||(P=new M($,w),L.set(A,P)),P}}),define(Ee[133],Ce([1,0,39,3,75]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=e.$Os=void 0,e.$Qs=L,e.$Rs=$,e.$Ss=w,e.$Os="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function M(P=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.$Os)P.indexOf(C)>=0||(b+="\\"+C);return b+="\\s]+)",new RegExp(b,"g")}e.$Ps=M();function L(P){let b=e.$Ps;if(P&&P instanceof RegExp)if(P.global)b=P;else{let C="g";P.ignoreCase&&(C+="i"),P.multiline&&(C+="m"),P.unicode&&(C+="u"),b=new RegExp(P.source,C)}return b.lastIndex=0,b}const p=new I.$5c;p.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(P){const b=p.unshift(P);return(0,R.$Sc)(b)}function w(P,b,C,y,a){if(b=L(b),a||(a=o.Iterable.first(p)),C.length>a.maxLen){let r=P-a.maxLen/2;return r<0?r=0:y+=r,C=C.substring(r,P+a.maxLen/2),w(P,b,C,y,a)}const m=Date.now(),c=P-1-y;let i=-1,n=null;for(let r=1;!(Date.now()-m>=a.timeBudget);r++){const s=c-a.windowSize*r;b.lastIndex=Math.max(0,s);const t=A(b,C,c,i);if(!t&&n||(n=t,s<=0))break;i=s}if(n){const r={word:n[0],startColumn:y+1+n.index,endColumn:y+1+n.index+n[0].length};return b.lastIndex=0,r}return null}function A(P,b,C,y){let a;for(;a=P.exec(b);){const m=a.index||0;if(m<=C&&P.lastIndex>=C)return a;if(y>0&&m>y)return null}return null}}),define(Ee[186],Ce([1,0,35,17]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wt=I,e.$Xt=M;function I(L,p,$,w,A,P){if(Array.isArray(L)){let b=0;for(const C of L){const y=I(C,p,$,w,A,P);if(y===10)return y;y>b&&(b=y)}return b}else{if(typeof L=="string")return w?L==="*"?5:L===$?10:0:0;if(L){const{language:b,pattern:C,scheme:y,hasAccessToAllModels:a,notebookType:m}=L;if(!w&&!a)return 0;m&&A&&(p=A);let c=0;if(y)if(y===p.scheme)c=10;else if(y==="*")c=5;else return 0;if(b)if(b===$)c=10;else if(b==="*")c=Math.max(c,5);else return 0;if(m)if(m===P)c=10;else if(m==="*"&&P!==void 0)c=Math.max(c,5);else return 0;if(C){let i;if(typeof C=="string"?i=C:i={...C,base:(0,R.$ic)(C.base)},i===p.fsPath||(0,o.$bk)(i,p.fsPath))c=10;else return 0}return c}else return 0}}function M(L){return typeof L=="string"?!1:Array.isArray(L)?L.some(M):!!L.notebookType}}),define(Ee[187],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$du=e.$cu=e.IndentAction=void 0;var o;(function(L){L[L.None=0]="None",L[L.Indent=1]="Indent",L[L.IndentOutdent=2]="IndentOutdent",L[L.Outdent=3]="Outdent"})(o||(e.IndentAction=o={}));class R{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let $=0,w=p.notIn.length;$<w;$++)switch(p.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,$){if(p.getTokenCount()===0)return!0;const w=p.findTokenIndexAtOffset($-2),A=p.getStandardTokenType(w);return this.isOK(A)}g(p,$){for(let w=p;w<=$;w++){const A=String.fromCharCode(w);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$cu=R;class I{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of p)M(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),M(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),M(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),M(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&M(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$du=I;function M(L,p,$){L.has(p)?L.get(p).push($):L.set(p,[$])}}),define(Ee[188],Ce([1,0,132]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G2=e.$F2=e.State=void 0,e.$H2=b;var R;(function(C){C[C.Invalid=0]="Invalid",C[C.Start=1]="Start",C[C.H=2]="H",C[C.HT=3]="HT",C[C.HTT=4]="HTT",C[C.HTTP=5]="HTTP",C[C.F=6]="F",C[C.FI=7]="FI",C[C.FIL=8]="FIL",C[C.BeforeColon=9]="BeforeColon",C[C.AfterColon=10]="AfterColon",C[C.AlmostThere=11]="AlmostThere",C[C.End=12]="End",C[C.Accept=13]="Accept",C[C.LastKnownState=14]="LastKnownState"})(R||(e.State=R={}));class I{constructor(y,a,m){const c=new Uint8Array(y*a);for(let i=0,n=y*a;i<n;i++)c[i]=m;this.a=c,this.rows=y,this.cols=a}get(y,a){return this.a[y*this.cols+a]}set(y,a,m){this.a[y*this.cols+a]=m}}class M{constructor(y){let a=0,m=0;for(let i=0,n=y.length;i<n;i++){const[r,s,t]=y[i];s>a&&(a=s),r>m&&(m=r),t>m&&(m=t)}a++,m++;const c=new I(m,a,0);for(let i=0,n=y.length;i<n;i++){const[r,s,t]=y[i];c.set(r,s,t)}this.a=c,this.b=a}nextState(y,a){return a<0||a>=this.b?0:this.a.get(y,a)}}e.$F2=M;let L=null;function p(){return L===null&&(L=new M([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),L}var $;(function(C){C[C.None=0]="None",C[C.ForceTermination=1]="ForceTermination",C[C.CannotEndIn=2]="CannotEndIn"})($||($={}));let w=null;function A(){if(w===null){w=new o.$At(0);const C=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let a=0;a<C.length;a++)w.set(C.charCodeAt(a),1);const y=".,;:";for(let a=0;a<y.length;a++)w.set(y.charCodeAt(a),2)}return w}class P{static a(y,a,m,c,i){let n=i-1;do{const r=a.charCodeAt(n);if(y.get(r)!==2)break;n--}while(n>c);if(c>0){const r=a.charCodeAt(c-1),s=a.charCodeAt(n);(r===40&&s===41||r===91&&s===93||r===123&&s===125)&&n--}return{range:{startLineNumber:m,startColumn:c+1,endLineNumber:m,endColumn:n+2},url:a.substring(c,n+1)}}static computeLinks(y,a=p()){const m=A(),c=[];for(let i=1,n=y.getLineCount();i<=n;i++){const r=y.getLineContent(i),s=r.length;let t=0,f=0,d=0,u=1,h=!1,l=!1,g=!1,E=!1;for(;t<s;){let v=!1;const S=r.charCodeAt(t);if(u===13){let k;switch(S){case 40:h=!0,k=0;break;case 41:k=h?0:1;break;case 91:g=!0,l=!0,k=0;break;case 93:g=!1,k=l?0:1;break;case 123:E=!0,k=0;break;case 125:k=E?0:1;break;case 39:case 34:case 96:d===S?k=1:d===39||d===34||d===96?k=0:k=1;break;case 42:k=d===42?1:0;break;case 124:k=d===124?1:0;break;case 32:k=g?0:1;break;default:k=m.get(S)}k===1&&(c.push(P.a(m,r,i,f,t)),v=!0)}else if(u===12){let k;S===91?(l=!0,k=0):k=m.get(S),k===1?v=!0:u=13}else u=a.nextState(u,S),u===0&&(v=!0);v&&(u=1,h=!1,l=!1,E=!1,f=t+1,d=S),t++}u===13&&c.push(P.a(m,r,i,f,s))}return c}}e.$G2=P;function b(C){return!C||typeof C.getLineCount!="function"||typeof C.getLineContent!="function"?[]:P.computeLinks(C)}}),define(Ee[82],Ce([1,0,24]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bv=e.$Av=e.$zv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$xv=e.$wv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$yv=y,e.$Cv=r;var R;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(R||(e.OverviewRulerLane=R={}));var I;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(I||(e.GlyphMarginLane=I={}));var M;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(M||(e.MinimapPosition=M={}));var L;(function(s){s[s.Normal=1]="Normal",s[s.Underlined=2]="Underlined"})(L||(e.MinimapSectionHeaderStyle=L={}));var p;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(p||(e.InjectedTextCursorStops=p={}));var $;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var w;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(w||(e.DefaultEndOfLine=w={}));var A;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(A||(e.EndOfLineSequence=A={}));class P{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,o.$Tn)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$wv=P;class b{constructor(t,f){this._findMatchBrand=void 0,this.range=t,this.matches=f}}e.$xv=b;var C;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C||(e.TrackedRangeStickiness=C={}));function y(s){return s&&typeof s.read=="function"}var a;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(a||(e.PositionAffinity=a={}));var m;(function(s){s[s.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class c{constructor(t,f,d,u,h,l){this.identifier=t,this.range=f,this.text=d,this.forceMoveMarkers=u,this.isAutoWhitespaceEdit=h,this._isTracked=l}}e.$zv=c;class i{constructor(t,f,d){this.regex=t,this.wordSeparators=f,this.simpleSearch=d}}e.$Av=i;class n{constructor(t,f,d){this.reverseEdits=t,this.changes=f,this.trimAutoWhitespaceLineNumbers=d}}e.$Bv=n;function r(s){return!s.isTooLargeForSyncing()&&!s.isForSimpleWidget}}),define(Ee[189],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kC=e.NodeColor=e.$jC=void 0,e.$lC=I,e.$mC=M,e.$nC=w,e.$oC=A,e.$pC=P,e.$qC=b,e.$rC=C,e.$sC=y;class o{constructor(m,c){this.piece=m,this.color=c,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$kC)return I(this.right);let m=this;for(;m.parent!==e.$kC&&m.parent.left!==m;)m=m.parent;return m.parent===e.$kC?e.$kC:m.parent}prev(){if(this.left!==e.$kC)return M(this.left);let m=this;for(;m.parent!==e.$kC&&m.parent.right!==m;)m=m.parent;return m.parent===e.$kC?e.$kC:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$jC=o;var R;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(R||(e.NodeColor=R={})),e.$kC=new o(null,0),e.$kC.parent=e.$kC,e.$kC.left=e.$kC,e.$kC.right=e.$kC,e.$kC.color=0;function I(a){for(;a.left!==e.$kC;)a=a.left;return a}function M(a){for(;a.right!==e.$kC;)a=a.right;return a}function L(a){return a===e.$kC?0:a.size_left+a.piece.length+L(a.right)}function p(a){return a===e.$kC?0:a.lf_left+a.piece.lineFeedCnt+p(a.right)}function $(){e.$kC.parent=e.$kC}function w(a,m){const c=m.right;c.size_left+=m.size_left+(m.piece?m.piece.length:0),c.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=c.left,c.left!==e.$kC&&(c.left.parent=m),c.parent=m.parent,m.parent===e.$kC?a.root=c:m.parent.left===m?m.parent.left=c:m.parent.right=c,c.left=m,m.parent=c}function A(a,m){const c=m.left;m.left=c.right,c.right!==e.$kC&&(c.right.parent=m),c.parent=m.parent,m.size_left-=c.size_left+(c.piece?c.piece.length:0),m.lf_left-=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),m.parent===e.$kC?a.root=c:m===m.parent.right?m.parent.right=c:m.parent.left=c,c.right=m,m.parent=c}function P(a,m){let c,i;if(m.left===e.$kC?(i=m,c=i.right):m.right===e.$kC?(i=m,c=i.left):(i=I(m.right),c=i.right),i===a.root){a.root=c,c.color=0,m.detach(),$(),a.root.parent=e.$kC;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=c:i.parent.right=c,i===m?(c.parent=i.parent,y(a,c)):(i.parent===m?c.parent=i:c.parent=i.parent,y(a,c),i.left=m.left,i.right=m.right,i.parent=m.parent,i.color=m.color,m===a.root?a.root=i:m===m.parent.left?m.parent.left=i:m.parent.right=i,i.left!==e.$kC&&(i.left.parent=i),i.right!==e.$kC&&(i.right.parent=i),i.size_left=m.size_left,i.lf_left=m.lf_left,y(a,i)),m.detach(),c.parent.left===c){const s=L(c),t=p(c);if(s!==c.parent.size_left||t!==c.parent.lf_left){const f=s-c.parent.size_left,d=t-c.parent.lf_left;c.parent.size_left=s,c.parent.lf_left=t,C(a,c.parent,f,d)}}if(y(a,c.parent),n){$();return}let r;for(;c!==a.root&&c.color===0;)c===c.parent.left?(r=c.parent.right,r.color===1&&(r.color=0,c.parent.color=1,w(a,c.parent),r=c.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,c=c.parent):(r.right.color===0&&(r.left.color=0,r.color=1,A(a,r),r=c.parent.right),r.color=c.parent.color,c.parent.color=0,r.right.color=0,w(a,c.parent),c=a.root)):(r=c.parent.left,r.color===1&&(r.color=0,c.parent.color=1,A(a,c.parent),r=c.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,c=c.parent):(r.left.color===0&&(r.right.color=0,r.color=1,w(a,r),r=c.parent.left),r.color=c.parent.color,c.parent.color=0,r.left.color=0,A(a,c.parent),c=a.root));c.color=0,$()}function b(a,m){for(y(a,m);m!==a.root&&m.parent.color===1;)if(m.parent===m.parent.parent.left){const c=m.parent.parent.right;c.color===1?(m.parent.color=0,c.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,w(a,m)),m.parent.color=0,m.parent.parent.color=1,A(a,m.parent.parent))}else{const c=m.parent.parent.left;c.color===1?(m.parent.color=0,c.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,A(a,m)),m.parent.color=0,m.parent.parent.color=1,w(a,m.parent.parent))}a.root.color=0}function C(a,m,c,i){for(;m!==a.root&&m!==e.$kC;)m.parent.left===m&&(m.parent.size_left+=c,m.parent.lf_left+=i),m=m.parent}function y(a,m){let c=0,i=0;if(m!==a.root){for(;m!==a.root&&m===m.parent.right;)m=m.parent;if(m!==a.root)for(m=m.parent,c=L(m.left)-m.size_left,i=p(m.left)-m.lf_left,m.size_left+=c,m.lf_left+=i;m!==a.root&&(c!==0||i!==0);)m.parent.left===m&&(m.parent.size_left+=c,m.parent.lf_left+=i),m=m.parent}}}),define(Ee[190],Ce([1,0,19,130]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hv=e.$Gv=e.$Fv=void 0;class I{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,w){$=(0,R.$Te)($);const A=this.a,P=this.b,b=w.length;return b===0?!1:(this.a=new Uint32Array(A.length+b),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($),$+b),this.a.set(w,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue($,w){return $=(0,R.$Te)($),w=(0,R.$Te)(w),this.a[$]===w?!1:(this.a[$]=w,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,w){$=(0,R.$Te)($),w=(0,R.$Te)(w);const A=this.a,P=this.b;if($>=A.length)return!1;const b=A.length-$;return w>=b&&(w=b),w===0?!1:(this.a=new Uint32Array(A.length-w),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($+w),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,R.$Te)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let w=this.c[0]+1;w===0&&(this.b[0]=this.a[0],w++),$>=this.a.length&&($=this.a.length-1);for(let A=w;A<=$;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let w=0,A=this.a.length-1,P=0,b=0,C=0;for(;w<=A;)if(P=w+(A-w)/2|0,b=this.b[P],C=b-this.a[P],$<C)A=P-1;else if($>=b)w=P+1;else break;return new L(P,$-C)}}e.$Fv=I;class M{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const w=this.e[$],A=w>0?this.d[w-1]:0;return new L(w,$-A)}removeValues($,w){this.a.splice($,w),this.f($)}insertValues($,w){this.a=(0,o.$Wb)(this.a,$,w),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,w=this.a.length;$<w;$++){const A=this.a[$],P=$>0?this.d[$-1]:0;this.d[$]=P+A;for(let b=0;b<A;b++)this.e[P+b]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,w){this.a[$]!==w&&(this.a[$]=w,this.f($))}}e.$Gv=M;class L{constructor($,w){this.index=$,this.remainder=w,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=w}}e.$Hv=L}),define(Ee[191],Ce([1,0,14,52,190]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iv=void 0;class M{constructor(p,$,w,A){this.d=p,this.f=$,this.g=w,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(p){p.eol&&p.eol!==this.g&&(this.g=p.eol,this.j=null);const $=p.changes;for(const w of $)this.o(w.range),this.p(new R.$ct(w.range.startLineNumber,w.range.startColumn),w.text);this.h=p.versionId,this.k=null}l(){if(!this.j){const p=this.g.length,$=this.f.length,w=new Uint32Array($);for(let A=0;A<$;A++)w[A]=this.f[A].length+p;this.j=new I.$Fv(w)}}n(p,$){this.f[p]=$,this.j&&this.j.setValue(p,this.f[p].length+this.g.length)}o(p){if(p.startLineNumber===p.endLineNumber){if(p.startColumn===p.endColumn)return;this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.startLineNumber-1].substring(p.endColumn-1));return}this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.endLineNumber-1].substring(p.endColumn-1)),this.f.splice(p.startLineNumber,p.endLineNumber-p.startLineNumber),this.j&&this.j.removeValues(p.startLineNumber,p.endLineNumber-p.startLineNumber)}p(p,$){if($.length===0)return;const w=(0,o.$$e)($);if(w.length===1){this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+w[0]+this.f[p.lineNumber-1].substring(p.column-1));return}w[w.length-1]+=this.f[p.lineNumber-1].substring(p.column-1),this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+w[0]);const A=new Uint32Array(w.length-1);for(let P=1;P<w.length;P++)this.f.splice(p.lineNumber+P-1,0,w[P]),A[P-1]=w[P].length+this.g.length;this.j&&this.j.insertValues(p.lineNumber,A)}}e.$Iv=M}),define(Ee[105],Ce([1,0,14,185,52,29,82]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yC=e.$wC=e.$tC=void 0,e.$uC=w,e.$vC=A,e.$xC=a;const p=999;class ${constructor(i,n,r,s){this.searchString=i,this.isRegex=n,this.matchCase=r,this.wordSeparators=s}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=w(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=o.$9e(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let r=!this.isRegex&&!i;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new L.$Av(n,this.wordSeparators?(0,R.$Dt)(this.wordSeparators,[]):null,r?this.searchString:null)}}e.$tC=$;function w(c){if(!c||c.length===0)return!1;for(let i=0,n=c.length;i<n;i++){const r=c.charCodeAt(i);if(r===10)return!0;if(r===92){if(i++,i>=n)break;const s=c.charCodeAt(i);if(s===110||s===114||s===87)return!0}}return!1}function A(c,i,n){if(!n)return new L.$xv(c,null);const r=[];for(let s=0,t=i.length;s<t;s++)r[s]=i[s];return new L.$xv(c,r)}class P{constructor(i){const n=[];let r=0;for(let s=0,t=i.length;s<t;s++)i.charCodeAt(s)===10&&(n[r++]=s);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let r=0,s=n.length-1;if(s===-1||i<=n[0])return 0;for(;r<s;){const t=r+((s-r)/2>>0);n[t]>=i?s=t-1:n[t+1]>=i?(r=t,s=t):r=t+1}return r+1}}class b{static findMatches(i,n,r,s,t){const f=n.parseSearchRequest();return f?f.regex.multiline?this.b(i,r,new m(f.wordSeparators,f.regex),s,t):this.c(i,r,f,s,t):[]}static a(i,n,r,s,t,f){let d,u=0;s?(u=s.findLineFeedCountBeforeOffset(t),d=n+t+u):d=n+t;let h;if(s){const v=s.findLineFeedCountBeforeOffset(t+f.length)-u;h=d+f.length+v}else h=d+f.length;const l=i.getPositionAt(d),g=i.getPositionAt(h);return new M.$dt(l.lineNumber,l.column,g.lineNumber,g.column)}static b(i,n,r,s,t){const f=i.getOffsetAt(n.getStartPosition()),d=i.getValueInRange(n,1),u=i.getEOL()===`\r
`?new P(d):null,h=[];let l=0,g;for(r.reset(0);g=r.next(d);)if(h[l++]=A(this.a(i,f,d,u,g.index,g[0]),g,s),l>=t)return h;return h}static c(i,n,r,s,t){const f=[];let d=0;if(n.startLineNumber===n.endLineNumber){const h=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return d=this.d(r,h,n.startLineNumber,n.startColumn-1,d,f,s,t),f}const u=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);d=this.d(r,u,n.startLineNumber,n.startColumn-1,d,f,s,t);for(let h=n.startLineNumber+1;h<n.endLineNumber&&d<t;h++)d=this.d(r,i.getLineContent(h),h,0,d,f,s,t);if(d<t){const h=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);d=this.d(r,h,n.endLineNumber,0,d,f,s,t)}return f}static d(i,n,r,s,t,f,d,u){const h=i.wordSeparators;if(!d&&i.simpleSearch){const E=i.simpleSearch,v=E.length,S=n.length;let k=-v;for(;(k=n.indexOf(E,k+v))!==-1;)if((!h||a(h,n,S,k,v))&&(f[t++]=new L.$xv(new M.$dt(r,k+1+s,r,k+1+v+s),null),t>=u))return t;return t}const l=new m(i.wordSeparators,i.regex);let g;l.reset(0);do if(g=l.next(n),g&&(f[t++]=A(new M.$dt(r,g.index+1+s,r,g.index+1+g[0].length+s),g,d),t>=u))return t;while(g);return t}static findNextMatch(i,n,r,s){const t=n.parseSearchRequest();if(!t)return null;const f=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,r,f,s):this.f(i,r,f,s)}static e(i,n,r,s){const t=new I.$ct(n.lineNumber,1),f=i.getOffsetAt(t),d=i.getLineCount(),u=i.getValueInRange(new M.$dt(t.lineNumber,t.column,d,i.getLineMaxColumn(d)),1),h=i.getEOL()===`\r
`?new P(u):null;r.reset(n.column-1);const l=r.next(u);return l?A(this.a(i,f,u,h,l.index,l[0]),l,s):n.lineNumber!==1||n.column!==1?this.e(i,new I.$ct(1,1),r,s):null}static f(i,n,r,s){const t=i.getLineCount(),f=n.lineNumber,d=i.getLineContent(f),u=this.g(r,d,f,n.column,s);if(u)return u;for(let h=1;h<=t;h++){const l=(f+h-1)%t,g=i.getLineContent(l+1),E=this.g(r,g,l+1,1,s);if(E)return E}return null}static g(i,n,r,s,t){i.reset(s-1);const f=i.next(n);return f?A(new M.$dt(r,f.index+1,r,f.index+1+f[0].length),f,t):null}static findPreviousMatch(i,n,r,s){const t=n.parseSearchRequest();if(!t)return null;const f=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,r,f,s):this.j(i,r,f,s)}static h(i,n,r,s){const t=this.b(i,new M.$dt(1,1,n.lineNumber,n.column),r,s,10*p);if(t.length>0)return t[t.length-1];const f=i.getLineCount();return n.lineNumber!==f||n.column!==i.getLineMaxColumn(f)?this.h(i,new I.$ct(f,i.getLineMaxColumn(f)),r,s):null}static j(i,n,r,s){const t=i.getLineCount(),f=n.lineNumber,d=i.getLineContent(f).substring(0,n.column-1),u=this.k(r,d,f,s);if(u)return u;for(let h=1;h<=t;h++){const l=(t+f-h-1)%t,g=i.getLineContent(l+1),E=this.k(r,g,l+1,s);if(E)return E}return null}static k(i,n,r,s){let t=null,f;for(i.reset(0);f=i.next(n);)t=A(new M.$dt(r,f.index+1,r,f.index+1+f[0].length),f,s);return t}}e.$wC=b;function C(c,i,n,r,s){if(r===0)return!0;const t=i.charCodeAt(r-1);if(c.get(t)!==0||t===13||t===10)return!0;if(s>0){const f=i.charCodeAt(r);if(c.get(f)!==0)return!0}return!1}function y(c,i,n,r,s){if(r+s===n)return!0;const t=i.charCodeAt(r+s);if(c.get(t)!==0||t===13||t===10)return!0;if(s>0){const f=i.charCodeAt(r+s-1);if(c.get(f)!==0)return!0}return!1}function a(c,i,n,r,s){return C(c,i,n,r,s)&&y(c,i,n,r,s)}class m{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let r;do{if(this.b+this.c===n||(r=this.a.exec(i),!r))return null;const s=r.index,t=r[0].length;if(s===this.b&&t===this.c){if(t===0){o.$sf(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=s,this.c=t,!this._wordSeparators||a(this._wordSeparators,i,n,s,t))return r}while(r);return null}}e.$yC=m}),define(Ee[134],Ce([1,0,52,29,82,189,105]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DC=e.$CC=e.$BC=void 0,e.$zC=A,e.$AC=P;const p=65535;function $(c){let i;return c[c.length-1]<65536?i=new Uint16Array(c.length):i=new Uint32Array(c.length),i.set(c,0),i}class w{constructor(i,n,r,s,t){this.lineStarts=i,this.cr=n,this.lf=r,this.crlf=s,this.isBasicASCII=t}}function A(c,i=!0){const n=[0];let r=1;for(let s=0,t=c.length;s<t;s++){const f=c.charCodeAt(s);f===13?s+1<t&&c.charCodeAt(s+1)===10?(n[r++]=s+2,s++):n[r++]=s+1:f===10&&(n[r++]=s+1)}return i?$(n):n}function P(c,i){c.length=0,c[0]=0;let n=1,r=0,s=0,t=0,f=!0;for(let u=0,h=i.length;u<h;u++){const l=i.charCodeAt(u);l===13?u+1<h&&i.charCodeAt(u+1)===10?(t++,c[n++]=u+2,u++):(r++,c[n++]=u+1):l===10?(s++,c[n++]=u+1):f&&l!==9&&(l<32||l>126)&&(f=!1)}const d=new w($(c),r,s,t,f);return c.length=0,d}class b{constructor(i,n,r,s,t){this.bufferIndex=i,this.start=n,this.end=r,this.lineFeedCnt=s,this.length=t}}e.$BC=b;class C{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$CC=C;class y{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==M.$kC&&i.iterate(i.root,r=>(r!==M.$kC&&this.a.push(r.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class a{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const r=this.b[n];if(r.nodeStartOffset<=i&&r.nodeStartOffset+r.node.piece.length>=i)return r}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const r=this.b[n];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<i&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=i)return r}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const r=this.b;for(let s=0;s<r.length;s++){const t=r[s];if(t.node.parent===null||t.nodeStartOffset>=i){r[s]=null,n=!0;continue}}if(n){const s=[];for(const t of r)t!==null&&s.push(t);this.b=s}}}class m{constructor(i,n,r){this.create(i,n,r)}create(i,n,r){this.a=[new C("",[0])],this.g={line:0,column:0},this.root=M.$kC,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=r;let s=null;for(let t=0,f=i.length;t<f;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=A(i[t].buffer));const d=new b(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),s=this.S(s,d)}this.h=new a(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=p,r=n-Math.floor(n/3),s=r*2;let t="",f=0;const d=[];if(this.iterate(this.root,u=>{const h=this.R(u),l=h.length;if(f<=r||f+l<s)return t+=h,f+=l,!0;const g=t.replace(/\r\n|\r|\n/g,i);return d.push(new C(g,A(g))),t=h,f=l,!0}),f>0){const u=t.replace(/\r\n|\r|\n/g,i);d.push(new C(u,A(u)))}this.create(d,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new y(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,s=>{if(s===M.$kC)return!0;const t=this.R(s),f=t.length,d=i.G(n),u=i.G(n+f),h=i.getValueInRange2(d,u);return n+=f,t===h})}getOffsetAt(i,n){let r=0,s=this.root;for(;s!==M.$kC;)if(s.left!==M.$kC&&s.lf_left+1>=i)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt+1>=i){r+=s.size_left;const t=this.B(s,i-s.lf_left-2);return r+=t+n-1}else i-=s.lf_left+s.piece.lineFeedCnt,r+=s.size_left+s.piece.length,s=s.right;return r}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,r=0;const s=i;for(;n!==M.$kC;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(r+=n.lf_left+t.index,t.index===0){const f=this.getOffsetAt(r+1,1),d=s-f;return new o.$ct(r+1,d+1)}return new o.$ct(r+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,r+=n.lf_left+n.piece.lineFeedCnt,n.right===M.$kC){const t=this.getOffsetAt(r+1,1),f=s-i-t;return new o.$ct(r+1,f+1)}else n=n.right;return new o.$ct(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const r=this.H(i.startLineNumber,i.startColumn),s=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(r,s);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const d=i.node,u=this.a[d.piece.bufferIndex].buffer,h=this.u(d.piece.bufferIndex,d.piece.start);return u.substring(h+i.remainder,h+n.remainder)}let r=i.node;const s=this.a[r.piece.bufferIndex].buffer,t=this.u(r.piece.bufferIndex,r.piece.start);let f=s.substring(t+i.remainder,t+r.piece.length);for(r=r.next();r!==M.$kC;){const d=this.a[r.piece.bufferIndex].buffer,u=this.u(r.piece.bufferIndex,r.piece.start);if(r===n.node){f+=d.substring(u,u+n.remainder);break}else f+=d.substr(u,r.piece.length);r=r.next()}return f}getLinesContent(){const i=[];let n=0,r="",s=!1;return this.iterate(this.root,t=>{if(t===M.$kC)return!0;const f=t.piece;let d=f.length;if(d===0)return!0;const u=this.a[f.bufferIndex].buffer,h=this.a[f.bufferIndex].lineStarts,l=f.start.line,g=f.end.line;let E=h[l]+f.start.column;if(s&&(u.charCodeAt(E)===10&&(E++,d--),i[n++]=r,r="",s=!1,d===0))return!0;if(l===g)return!this.f&&u.charCodeAt(E+d-1)===13?(s=!0,r+=u.substr(E,d-1)):r+=u.substr(E,d),!0;r+=this.f?u.substring(E,Math.max(E,h[l+1]-this.e)):u.substring(E,h[l+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;for(let v=l+1;v<g;v++)r=this.f?u.substring(h[v],h[v+1]-this.e):u.substring(h[v],h[v+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;return!this.f&&u.charCodeAt(h[g]+f.end.column-1)===13?(s=!0,f.end.column===0?n--:r=u.substr(h[g],f.end.column-1)):r=u.substr(h[g],f.end.column),!0}),s&&(i[n++]=r,r=""),i[n++]=r,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const r=this.a[n.piece.bufferIndex],s=this.u(n.piece.bufferIndex,n.piece.start);return r.buffer.charCodeAt(s)}else{const n=this.a[i.node.piece.bufferIndex],s=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(s)}}getLineCharCode(i,n){const r=this.H(i,n+1);return this.l(r)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,r,s,t,f,d,u,h,l,g){const E=this.a[i.piece.bufferIndex],v=this.u(i.piece.bufferIndex,i.piece.start),S=this.u(i.piece.bufferIndex,t),k=this.u(i.piece.bufferIndex,f);let D;const F={line:0,column:0};let W,B;n._wordSeparators?(W=E.buffer.substring(S,k),B=j=>j+S,n.reset(0)):(W=E.buffer,B=j=>j,n.reset(S));do if(D=n.next(W),D){if(B(D.index)>=k)return l;this.s(i,B(D.index)-v,F);const j=this.t(i.piece.bufferIndex,t,F),N=F.line===t.line?F.column-t.column+s:F.column+1,T=N+D[0].length;if(g[l++]=(0,L.$vC)(new R.$dt(r+j,N,r+j,T),D,u),B(D.index)+D[0].length>=k||l>=h)return l}while(D);return l}findMatchesLineByLine(i,n,r,s){const t=[];let f=0;const d=new L.$yC(n.wordSeparators,n.regex);let u=this.H(i.startLineNumber,i.startColumn);if(u===null)return[];const h=this.H(i.endLineNumber,i.endColumn);if(h===null)return[];let l=this.s(u.node,u.remainder);const g=this.s(h.node,h.remainder);if(u.node===h.node)return this.findMatchesInNode(u.node,d,i.startLineNumber,i.startColumn,l,g,n,r,s,f,t),t;let E=i.startLineNumber,v=u.node;for(;v!==h.node;){const k=this.t(v.piece.bufferIndex,l,v.piece.end);if(k>=1){const F=this.a[v.piece.bufferIndex].lineStarts,W=this.u(v.piece.bufferIndex,v.piece.start),B=F[l.line+k],j=E===i.startLineNumber?i.startColumn:1;if(f=this.findMatchesInNode(v,d,E,j,l,this.s(v,B-W),n,r,s,f,t),f>=s)return t;E+=k}const D=E===i.startLineNumber?i.startColumn-1:0;if(E===i.endLineNumber){const F=this.getLineContent(E).substring(D,i.endColumn-1);return f=this.n(n,d,F,i.endLineNumber,D,f,t,r,s),t}if(f=this.n(n,d,this.getLineContent(E).substr(D),E,D,f,t,r,s),f>=s)return t;E++,u=this.H(E,1),v=u.node,l=this.s(u.node,u.remainder)}if(E===i.endLineNumber){const k=E===i.startLineNumber?i.startColumn-1:0,D=this.getLineContent(E).substring(k,i.endColumn-1);return f=this.n(n,d,D,i.endLineNumber,k,f,t,r,s),t}const S=E===i.startLineNumber?i.startColumn:1;return f=this.findMatchesInNode(h.node,d,E,S,l,g,n,r,s,f,t),t}n(i,n,r,s,t,f,d,u,h){const l=i.wordSeparators;if(!u&&i.simpleSearch){const E=i.simpleSearch,v=E.length,S=r.length;let k=-v;for(;(k=r.indexOf(E,k+v))!==-1;)if((!l||(0,L.$xC)(l,r,S,k,v))&&(d[f++]=new I.$xv(new R.$dt(s,k+1+t,s,k+1+v+t),null),f>=h))return f;return f}let g;n.reset(0);do if(g=n.next(r),g&&(d[f++]=(0,L.$vC)(new R.$dt(s,g.index+1+t,s,g.index+1+g[0].length+t),g,u),f>=h))return f;while(g);return f}insert(i,n,r=!1){if(this.f=this.f&&r,this.j.lineNumber=0,this.j.value="",this.root!==M.$kC){const{node:s,remainder:t,nodeStartOffset:f}=this.G(i),d=s.piece,u=d.bufferIndex,h=this.s(s,t);if(s.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&f+d.length===i&&n.length<p){this.F(s,n),this.y();return}if(f===i)this.o(n,s),this.h.validate(i);else if(f+s.piece.length>i){const l=[];let g=new b(d.bufferIndex,h,d.end,this.t(d.bufferIndex,h,d.end),this.u(u,d.end)-this.u(u,h));if(this.K()&&this.M(n)&&this.I(s,t)===10){const k={line:g.start.line+1,column:0};g=new b(g.bufferIndex,k,g.end,this.t(g.bufferIndex,k,g.end),g.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(s,t-1)===13){const k=this.s(s,t-1);this.C(s,k),n="\r"+n,s.piece.length===0&&l.push(s)}else this.C(s,h);else this.C(s,h);const E=this.w(n);g.length>0&&this.S(s,g);let v=s;for(let S=0;S<E.length;S++)v=this.S(v,E[S]);this.v(l)}else this.q(n,s)}else{const s=this.w(n);let t=this.T(null,s[0]);for(let f=1;f<s.length;f++)t=this.S(t,s[f])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===M.$kC)return;const r=this.G(i),s=this.G(i+n),t=r.node,f=s.node;if(t===f){const E=this.s(t,r.remainder),v=this.s(t,s.remainder);if(r.nodeStartOffset===i){if(n===t.piece.length){const S=t.next();(0,M.$pC)(this,t),this.N(S),this.y();return}this.D(t,v),this.h.validate(i),this.N(t),this.y();return}if(r.nodeStartOffset+t.piece.length===i+n){this.C(t,E),this.O(t),this.y();return}this.E(t,E,v),this.y();return}const d=[],u=this.s(t,r.remainder);this.C(t,u),this.h.validate(i),t.piece.length===0&&d.push(t);const h=this.s(f,s.remainder);this.D(f,h),f.piece.length===0&&d.push(f);const l=t.next();for(let E=l;E!==M.$kC&&E!==f;E=E.next())d.push(E);const g=t.piece.length===0?t.prev():t;this.v(d),this.O(g),this.y()}o(i,n){const r=[];if(this.K()&&this.M(i)&&this.L(n)){const f=n.piece,d={line:f.start.line+1,column:0},u=new b(f.bufferIndex,d,f.end,this.t(f.bufferIndex,d,f.end),f.length-1);n.piece=u,i+=`
`,(0,M.$rC)(this,n,-1,-1),n.piece.length===0&&r.push(n)}const s=this.w(i);let t=this.T(n,s[s.length-1]);for(let f=s.length-2;f>=0;f--)t=this.T(t,s[f]);this.N(t),this.v(r)}q(i,n){this.Q(i,n)&&(i+=`
`);const r=this.w(i),s=this.S(n,r[0]);let t=s;for(let f=1;f<r.length;f++)t=this.S(t,r[f]);this.N(s)}s(i,n,r){const s=i.piece,t=i.piece.bufferIndex,f=this.a[t].lineStarts,u=f[s.start.line]+s.start.column+n;let h=s.start.line,l=s.end.line,g=0,E=0,v=0;for(;h<=l&&(g=h+(l-h)/2|0,v=f[g],g!==l);)if(E=f[g+1],u<v)l=g-1;else if(u>=E)h=g+1;else break;return r?(r.line=g,r.column=u-v,null):{line:g,column:u-v}}t(i,n,r){if(r.column===0)return r.line-n.line;const s=this.a[i].lineStarts;if(r.line===s.length-1)return r.line-n.line;const t=s[r.line+1],f=s[r.line]+r.column;if(t>f+1)return r.line-n.line;const d=f-1;return this.a[i].buffer.charCodeAt(d)===13?r.line-n.line+1:r.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,M.$pC)(this,i[n])}w(i){if(i.length>p){const l=[];for(;i.length>p;){const E=i.charCodeAt(p-1);let v;E===13||E>=55296&&E<=56319?(v=i.substring(0,p-1),i=i.substring(p-1)):(v=i.substring(0,p),i=i.substring(p));const S=A(v);l.push(new b(this.a.length,{line:0,column:0},{line:S.length-1,column:v.length-S[S.length-1]},S.length-1,v.length)),this.a.push(new C(v,S))}const g=A(i);return l.push(new b(this.a.length,{line:0,column:0},{line:g.length-1,column:i.length-g[g.length-1]},g.length-1,i.length)),this.a.push(new C(i,g)),l}let n=this.a[0].buffer.length;const r=A(i,!1);let s=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},s=this.g;for(let l=0;l<r.length;l++)r[l]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let l=0;l<r.length;l++)r[l]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[f],u={line:f,column:d},h=new b(0,s,u,this.t(0,s,u),t-n);return this.g=u,[h]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let r=this.root,s="";const t=this.h.get2(i);if(t){r=t.node;const f=this.B(r,i-t.nodeStartLineNumber-1),d=this.a[r.piece.bufferIndex].buffer,u=this.u(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===i)s=d.substring(u+f,u+r.piece.length);else{const h=this.B(r,i-t.nodeStartLineNumber);return d.substring(u+f,u+h-n)}}else{let f=0;const d=i;for(;r!==M.$kC;)if(r.left!==M.$kC&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const u=this.B(r,i-r.lf_left-2),h=this.B(r,i-r.lf_left-1),l=this.a[r.piece.bufferIndex].buffer,g=this.u(r.piece.bufferIndex,r.piece.start);return f+=r.size_left,this.h.set({node:r,nodeStartOffset:f,nodeStartLineNumber:d-(i-1-r.lf_left)}),l.substring(g+u,g+h-n)}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const u=this.B(r,i-r.lf_left-2),h=this.a[r.piece.bufferIndex].buffer,l=this.u(r.piece.bufferIndex,r.piece.start);s=h.substring(l+u,l+r.piece.length);break}else i-=r.lf_left+r.piece.lineFeedCnt,f+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==M.$kC;){const f=this.a[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const d=this.B(r,0),u=this.u(r.piece.bufferIndex,r.piece.start);return s+=f.substring(u,u+d-n),s}else{const d=this.u(r.piece.bufferIndex,r.piece.start);s+=f.substr(d,r.piece.length)}r=r.next()}return s}y(){let i=this.root,n=1,r=0;for(;i!==M.$kC;)n+=i.lf_left+i.piece.lineFeedCnt,r+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=r,this.h.validate(this.c)}A(i,n){const r=i.piece,s=this.s(i,n),t=s.line-r.start.line;if(this.u(r.bufferIndex,r.end)-this.u(r.bufferIndex,r.start)===n){const f=this.t(i.piece.bufferIndex,r.start,s);if(f!==t)return{index:f,remainder:0}}return{index:t,remainder:s.column}}B(i,n){if(n<0)return 0;const r=i.piece,s=this.a[r.bufferIndex].lineStarts,t=r.start.line+n+1;return t>r.end.line?s[r.end.line]+r.end.column-s[r.start.line]-r.start.column:s[t]-s[r.start.line]-r.start.column}C(i,n){const r=i.piece,s=r.lineFeedCnt,t=this.u(r.bufferIndex,r.end),f=n,d=this.u(r.bufferIndex,f),u=this.t(r.bufferIndex,r.start,f),h=u-s,l=d-t,g=r.length+l;i.piece=new b(r.bufferIndex,r.start,f,u,g),(0,M.$rC)(this,i,l,h)}D(i,n){const r=i.piece,s=r.lineFeedCnt,t=this.u(r.bufferIndex,r.start),f=n,d=this.t(r.bufferIndex,f,r.end),u=this.u(r.bufferIndex,f),h=d-s,l=t-u,g=r.length+l;i.piece=new b(r.bufferIndex,f,r.end,d,g),(0,M.$rC)(this,i,l,h)}E(i,n,r){const s=i.piece,t=s.start,f=s.end,d=s.length,u=s.lineFeedCnt,h=n,l=this.t(s.bufferIndex,s.start,h),g=this.u(s.bufferIndex,n)-this.u(s.bufferIndex,t);i.piece=new b(s.bufferIndex,s.start,h,l,g),(0,M.$rC)(this,i,g-d,l-u);const E=new b(s.bufferIndex,r,f,this.t(s.bufferIndex,r,f),this.u(s.bufferIndex,f)-this.u(s.bufferIndex,r)),v=this.S(i,E);this.N(v)}F(i,n){this.Q(n,i)&&(n+=`
`);const r=this.K()&&this.L(n)&&this.M(i),s=this.a[0].buffer.length;this.a[0].buffer+=n;const t=A(n,!1);for(let v=0;v<t.length;v++)t[v]+=s;if(r){const v=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:s-v}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const f=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[f],u={line:f,column:d},h=i.piece.length+n.length,l=i.piece.lineFeedCnt,g=this.t(0,i.piece.start,u),E=g-l;i.piece=new b(i.piece.bufferIndex,i.piece.start,u,g,h),this.g=u,(0,M.$rC)(this,i,n.length,E)}G(i){let n=this.root;const r=this.h.get(i);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:i-r.nodeStartOffset};let s=0;for(;n!==M.$kC;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){s+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:s};return this.h.set(t),t}else i-=n.size_left+n.piece.length,s+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let r=this.root,s=0;for(;r!==M.$kC;)if(r.left!==M.$kC&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const t=this.B(r,i-r.lf_left-2),f=this.B(r,i-r.lf_left-1);return s+=r.size_left,{node:r,remainder:Math.min(t+n-1,f),nodeStartOffset:s}}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const t=this.B(r,i-r.lf_left-2);if(t+n-1<=r.piece.length)return{node:r,remainder:t+n-1,nodeStartOffset:s};n-=r.piece.length-t;break}else i-=r.lf_left+r.piece.lineFeedCnt,s+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==M.$kC;){if(r.piece.lineFeedCnt>0){const t=this.B(r,0),f=this.J(r);return{node:r,remainder:Math.min(n-1,t),nodeStartOffset:f}}else if(r.piece.length>=n-1){const t=this.J(r);return{node:r,remainder:n-1,nodeStartOffset:t}}else n-=r.piece.length;r=r.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const r=this.a[i.piece.bufferIndex],s=this.u(i.piece.bufferIndex,i.piece.start)+n;return r.buffer.charCodeAt(s)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===M.$kC||i.piece.lineFeedCnt===0)return!1;const n=i.piece,r=this.a[n.bufferIndex].lineStarts,s=n.start.line,t=r[s]+n.start.column;return s===r.length-1||r[s+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===M.$kC||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const r=[],s=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:s[i.piece.end.line]-s[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const f=i.piece.length-1,d=i.piece.lineFeedCnt-1;i.piece=new b(i.piece.bufferIndex,i.piece.start,t,d,f),(0,M.$rC)(this,i,-1,-1),i.piece.length===0&&r.push(i);const u={line:n.piece.start.line+1,column:0},h=n.piece.length-1,l=this.t(n.piece.bufferIndex,u,n.piece.end);n.piece=new b(n.piece.bufferIndex,u,n.piece.end,l,h),(0,M.$rC)(this,n,-1,-1),n.piece.length===0&&r.push(n);const g=this.w(`\r
`);this.S(i,g[0]);for(let E=0;E<r.length;E++)(0,M.$pC)(this,r[E])}Q(i,n){if(this.K()&&this.M(i)){const r=n.next();if(this.L(r)){if(i+=`
`,r.piece.length===1)(0,M.$pC)(this,r);else{const s=r.piece,t={line:s.start.line+1,column:0},f=s.length-1,d=this.t(s.bufferIndex,t,s.end);r.piece=new b(s.bufferIndex,t,s.end,d,f),(0,M.$rC)(this,r,-1,-1)}return!0}}return!1}iterate(i,n){if(i===M.$kC)return n(M.$kC);const r=this.iterate(i.left,n);return r&&n(i)&&this.iterate(i.right,n)}R(i){if(i===M.$kC)return"";const n=this.a[i.piece.bufferIndex],r=i.piece,s=this.u(r.bufferIndex,r.start),t=this.u(r.bufferIndex,r.end);return n.buffer.substring(s,t)}getPieceContent(i){const n=this.a[i.bufferIndex],r=this.u(i.bufferIndex,i.start),s=this.u(i.bufferIndex,i.end);return n.buffer.substring(r,s)}S(i,n){const r=new M.$jC(n,1);if(r.left=M.$kC,r.right=M.$kC,r.parent=M.$kC,r.size_left=0,r.lf_left=0,this.root===M.$kC)this.root=r,r.color=0;else if(i.right===M.$kC)i.right=r,r.parent=i;else{const t=(0,M.$lC)(i.right);t.left=r,r.parent=t}return(0,M.$qC)(this,r),r}T(i,n){const r=new M.$jC(n,1);if(r.left=M.$kC,r.right=M.$kC,r.parent=M.$kC,r.size_left=0,r.lf_left=0,this.root===M.$kC)this.root=r,r.color=0;else if(i.left===M.$kC)i.left=r,r.parent=i;else{const s=(0,M.$mC)(i.left);s.right=r,r.parent=s}return(0,M.$qC)(this,r),r}U(i){let n="";return this.iterate(i,r=>(n+=this.R(r),!0)),n}}e.$DC=m}),define(Ee[192],Ce([1,0,4,14,29,82,134,179,183,3]),function(re,e,o,R,I,M,L,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EC=void 0;class A extends w.$Uc{constructor(b,C,y,a,m,c,i){super(),this.m=this.B(new o.$7d),this.onDidChangeContent=this.m.event,this.f=C,this.j=!c,this.g=a,this.h=m,this.c=new L.$DC(b,y,i)}equals(b){return!(b instanceof A)||this.f!==b.f||this.getEOL()!==b.getEOL()?!1:this.c.equal(b.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(b){return this.c.createSnapshot(b?this.f:"")}getOffsetAt(b,C){return this.c.getOffsetAt(b,C)}getPositionAt(b){return this.c.getPositionAt(b)}getRangeAt(b,C){const y=b+C,a=this.getPositionAt(b),m=this.getPositionAt(y);return new I.$dt(a.lineNumber,a.column,m.lineNumber,m.column)}getValueInRange(b,C=0){if(b.isEmpty())return"";const y=this.n(C);return this.c.getValueInRange(b,y)}getValueLengthInRange(b,C=0){if(b.isEmpty())return 0;if(b.startLineNumber===b.endLineNumber)return b.endColumn-b.startColumn;const y=this.getOffsetAt(b.startLineNumber,b.startColumn),a=this.getOffsetAt(b.endLineNumber,b.endColumn);let m=0;const c=this.n(C),i=this.getEOL();if(c.length!==i.length){const n=c.length-i.length,r=b.endLineNumber-b.startLineNumber;m=n*r}return a-y+m}getCharacterCountInRange(b,C=0){if(this.j){let y=0;const a=b.startLineNumber,m=b.endLineNumber;for(let c=a;c<=m;c++){const i=this.getLineContent(c),n=c===a?b.startColumn-1:0,r=c===m?b.endColumn-1:i.length;for(let s=n;s<r;s++)R.$pf(i.charCodeAt(s))?(y=y+1,s=s+1):y=y+1}return y+=this.n(C).length*(m-a),y}return this.getValueLengthInRange(b,C)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(b){return this.c.getLineContent(b)}getLineCharCode(b,C){return this.c.getLineCharCode(b,C)}getCharCode(b){return this.c.getCharCode(b)}getLineLength(b){return this.c.getLineLength(b)}getLineMinColumn(b){return 1}getLineMaxColumn(b){return this.getLineLength(b)+1}getLineFirstNonWhitespaceColumn(b){const C=R.$af(this.getLineContent(b));return C===-1?0:C+1}getLineLastNonWhitespaceColumn(b){const C=R.$cf(this.getLineContent(b));return C===-1?0:C+2}n(b){switch(b){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(b){this.c.setEOL(b)}applyEdits(b,C,y){let a=this.g,m=this.h,c=this.j,i=!0,n=[];for(let h=0;h<b.length;h++){const l=b[h];i&&l._isTracked&&(i=!1);const g=l.range;if(l.text){let D=!0;c||(D=!R.$Af(l.text),c=D),!a&&D&&(a=R.$zf(l.text)),!m&&D&&(m=R.$Cf(l.text))}let E="",v=0,S=0,k=0;if(l.text){let D;[v,S,k,D]=(0,p.$Pt)(l.text);const F=this.getEOL();D===0||D===(F===`\r
`?2:1)?E=l.text:E=l.text.replace(/\r\n|\r|\n/g,F)}n[h]={sortIndex:h,identifier:l.identifier||null,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g),text:E,eolCount:v,firstLineLength:S,lastLineLength:k,forceMoveMarkers:!!l.forceMoveMarkers,isAutoWhitespaceEdit:l.isAutoWhitespaceEdit||!1}}n.sort(A.u);let r=!1;for(let h=0,l=n.length-1;h<l;h++){const g=n[h].range.getEndPosition(),E=n[h+1].range.getStartPosition();if(E.isBeforeOrEqual(g)){if(E.isBefore(g))throw new Error("Overlapping ranges are not allowed!");r=!0}}i&&(n=this.s(n));const s=y||C?A._getInverseEditRanges(n):[],t=[];if(C)for(let h=0;h<n.length;h++){const l=n[h],g=s[h];if(l.isAutoWhitespaceEdit&&l.range.isEmpty())for(let E=g.startLineNumber;E<=g.endLineNumber;E++){let v="";E===g.startLineNumber&&(v=this.getLineContent(l.range.startLineNumber),R.$af(v)!==-1)||t.push({lineNumber:E,oldContent:v})}}let f=null;if(y){let h=0;f=[];for(let l=0;l<n.length;l++){const g=n[l],E=s[l],v=this.getValueInRange(g.range),S=g.rangeOffset+h;h+=g.text.length-v.length,f[l]={sortIndex:g.sortIndex,identifier:g.identifier,range:E,text:v,textChange:new $.$yt(g.rangeOffset,v,S,g.text)}}r||f.sort((l,g)=>l.sortIndex-g.sortIndex)}this.g=a,this.h=m,this.j=c;const d=this.t(n);let u=null;if(C&&t.length>0){t.sort((h,l)=>l.lineNumber-h.lineNumber),u=[];for(let h=0,l=t.length;h<l;h++){const g=t[h].lineNumber;if(h>0&&t[h-1].lineNumber===g)continue;const E=t[h].oldContent,v=this.getLineContent(g);v.length===0||v===E||R.$af(v)!==-1||u.push(g)}}return this.m.fire(),new M.$Bv(f,d,u)}s(b){return b.length<1e3?b:[this._toSingleEditOperation(b)]}_toSingleEditOperation(b){let C=!1;const y=b[0].range,a=b[b.length-1].range,m=new I.$dt(y.startLineNumber,y.startColumn,a.endLineNumber,a.endColumn);let c=y.startLineNumber,i=y.startColumn;const n=[];for(let d=0,u=b.length;d<u;d++){const h=b[d],l=h.range;C=C||h.forceMoveMarkers,n.push(this.getValueInRange(new I.$dt(c,i,l.startLineNumber,l.startColumn))),h.text.length>0&&n.push(h.text),c=l.endLineNumber,i=l.endColumn}const r=n.join(""),[s,t,f]=(0,p.$Pt)(r);return{sortIndex:0,identifier:b[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,0),text:r,eolCount:s,firstLineLength:t,lastLineLength:f,forceMoveMarkers:C,isAutoWhitespaceEdit:!1}}t(b){b.sort(A.w);const C=[];for(let y=0;y<b.length;y++){const a=b[y],m=a.range.startLineNumber,c=a.range.startColumn,i=a.range.endLineNumber,n=a.range.endColumn;if(m===i&&c===n&&a.text.length===0)continue;a.text?(this.c.delete(a.rangeOffset,a.rangeLength),this.c.insert(a.rangeOffset,a.text,!0)):this.c.delete(a.rangeOffset,a.rangeLength);const r=new I.$dt(m,c,i,n);C.push({range:r,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return C}findMatchesLineByLine(b,C,y,a){return this.c.findMatchesLineByLine(b,C,y,a)}getPieceTree(){return this.c}static _getInverseEditRange(b,C){const y=b.startLineNumber,a=b.startColumn,[m,c,i]=(0,p.$Pt)(C);let n;if(C.length>0){const r=m+1;r===1?n=new I.$dt(y,a,y,a+c):n=new I.$dt(y,a,y+r-1,i+1)}else n=new I.$dt(y,a,y,a);return n}static _getInverseEditRanges(b){const C=[];let y=0,a=0,m=null;for(let c=0,i=b.length;c<i;c++){const n=b[c];let r,s;m?m.range.endLineNumber===n.range.startLineNumber?(r=y,s=a+(n.range.startColumn-m.range.endColumn)):(r=y+(n.range.startLineNumber-m.range.endLineNumber),s=n.range.startColumn):(r=n.range.startLineNumber,s=n.range.startColumn);let t;if(n.text.length>0){const f=n.eolCount+1;f===1?t=new I.$dt(r,s,r,s+n.firstLineLength):t=new I.$dt(r,s,r+f-1,n.lastLineLength+1)}else t=new I.$dt(r,s,r,s);y=t.endLineNumber,a=t.endColumn,C.push(t),m=n}return C}static u(b,C){const y=I.$dt.compareRangesUsingEnds(b.range,C.range);return y===0?b.sortIndex-C.sortIndex:y}static w(b,C){const y=I.$dt.compareRangesUsingEnds(b.range,C.range);return y===0?C.sortIndex-b.sortIndex:-y}}e.$EC=A}),define(Ee[193],Ce([1,0,14,134,192]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FC=void 0;class M{constructor($,w,A,P,b,C,y,a,m){this.a=$,this.b=w,this.c=A,this.d=P,this.e=b,this.f=C,this.g=y,this.h=a,this.j=m}k($){const w=this.c+this.d+this.e,A=this.c+this.e;return w===0?$===1?`
`:`\r
`:A>w/2?`\r
`:`
`}create($){const w=this.k($),A=this.a;if(this.j&&(w===`\r
`&&(this.c>0||this.d>0)||w===`
`&&(this.c>0||this.e>0)))for(let b=0,C=A.length;b<C;b++){const y=A[b].buffer.replace(/\r\n|\r|\n/g,w),a=(0,R.$zC)(y);A[b]=new R.$CC(y,a)}const P=new I.$EC(A,this.b,w,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class L{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&o.$Jf($)&&(this.b=o.$If,$=$.substr(1));const w=$.charCodeAt($.length-1);w===13||w>=55296&&w<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=w):(this.m($,!1),this.c=!1,this.d=w)}m($,w){!w&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const w=(0,R.$AC)(this.e,$);this.a.push(new R.$CC($,w.lineStarts)),this.f+=w.cr,this.g+=w.lf,this.h+=w.crlf,w.isBasicASCII||(this.l=!1,this.j||(this.j=o.$zf($)),this.k||(this.k=o.$Cf($)))}finish($=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const w=(0,R.$zC)($.buffer);$.lineStarts=w,this.d===13&&this.f++}}}e.$FC=L}),define(Ee[135],Ce([1,0,21,11]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yab=$,e.$Zab=A;var I;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(I||(I={}));function M(P){for(let b=0,C=P.length;b<C;b+=4){const y=P[b+0],a=P[b+1],m=P[b+2],c=P[b+3];P[b+0]=c,P[b+1]=m,P[b+2]=a,P[b+3]=y}}function L(P){const b=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return R.$x()||M(b),o.$ue.wrap(b)}function p(P){const b=P.buffer;if(R.$x()||M(b),b.byteOffset%4===0)return new Uint32Array(b.buffer,b.byteOffset,b.length/4);{const C=new Uint8Array(b.byteLength);return C.set(b),new Uint32Array(C.buffer,C.byteOffset,C.length/4)}}function $(P){const b=new Uint32Array(w(P));let C=0;if(b[C++]=P.id,P.type==="full")b[C++]=1,b[C++]=P.data.length,b.set(P.data,C),C+=P.data.length;else{b[C++]=2,b[C++]=P.deltas.length;for(const y of P.deltas)b[C++]=y.start,b[C++]=y.deleteCount,y.data?(b[C++]=y.data.length,b.set(y.data,C),C+=y.data.length):b[C++]=0}return L(b)}function w(P){let b=0;if(b+=2,P.type==="full")b+=1+P.data.length;else{b+=1,b+=3*P.deltas.length;for(const C of P.deltas)C.data&&(b+=C.data.length)}return b}function A(P){const b=p(P);let C=0;const y=b[C++];if(b[C++]===1){const i=b[C++],n=b.subarray(C,C+i);return C+=i,{id:y,type:"full",data:n}}const m=b[C++],c=[];for(let i=0;i<m;i++){const n=b[C++],r=b[C++],s=b[C++];let t;s>0&&(t=b.subarray(C,C+s),C+=s),c[i]={start:n,deleteCount:r,data:t}}return{id:y,type:"delta",deltas:c}}}),define(Ee[194],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s0=e.$r0=void 0;class o{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const L=this.a.get(M);return this.a.delete(M),L}}addDragOperationTransfer(M,L){this.a.set(M,L)}}e.$r0=o;class R{constructor(M){this.identifier=M}}e.$s0=R}),define(Ee[195],Ce([1,0,4,3]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ot=void 0;class I{constructor(){this.a=new Map,this.b=new Map,this.c=new o.$7d,this.onDidChange=this.c.event,this.d=null}handleChange(p){this.c.fire({changedLanguages:p,changedColorMap:!1})}register(p,$){return this.a.set(p,$),this.handleChange([p]),(0,R.$Sc)(()=>{this.a.get(p)===$&&(this.a.delete(p),this.handleChange([p]))})}get(p){return this.a.get(p)||null}registerFactory(p,$){this.b.get(p)?.dispose();const w=new M(this,p,$);return this.b.set(p,w),(0,R.$Sc)(()=>{const A=this.b.get(p);!A||A!==w||(this.b.delete(p),A.dispose())})}async getOrCreate(p){const $=this.get(p);if($)return $;const w=this.b.get(p);return!w||w.isResolved?null:(await w.resolve(),this.get(p))}isResolved(p){if(this.get(p))return!0;const w=this.b.get(p);return!!(!w||w.isResolved)}setColorMap(p){this.d=p,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Ot=I;class M extends R.$Uc{get isResolved(){return this.c}constructor(p,$,w){super(),this.f=p,this.g=$,this.h=w,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const p=await this.h.tokenizationSupport;this.c=!0,p&&!this.a&&this.B(this.f.register(this.g,p))}}}),define(Ee[196],Ce([9,10]),function(re,e){return re.create("vs/base/common/actions",e)}),define(Ee[197],Ce([1,0,4,3,196]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=void 0,e.$5i=A;class M extends R.$Uc{constructor(b,C="",y="",a=!0,m){super(),this.h=this.B(new o.$7d),this.onDidChange=this.h.event,this.w=!0,this.j=b,this.m=C,this.u=y,this.w=a,this.C=m}get id(){return this.j}get label(){return this.m}set label(b){this.D(b)}D(b){this.m!==b&&(this.m=b,this.h.fire({label:b}))}get tooltip(){return this.n||""}set tooltip(b){this.F(b)}F(b){this.n!==b&&(this.n=b,this.h.fire({tooltip:b}))}get class(){return this.u}set class(b){this.G(b)}G(b){this.u!==b&&(this.u=b,this.h.fire({class:b}))}get enabled(){return this.w}set enabled(b){this.H(b)}H(b){this.w!==b&&(this.w=b,this.h.fire({enabled:b}))}get checked(){return this.z}set checked(b){this.I(b)}I(b){this.z!==b&&(this.z=b,this.h.fire({checked:b}))}async run(b,C){this.C&&await this.C(b)}}e.$Zi=M;class L extends R.$Uc{constructor(){super(...arguments),this.f=this.B(new o.$7d),this.onWillRun=this.f.event,this.m=this.B(new o.$7d),this.onDidRun=this.m.event}async run(b,C){if(!b.enabled)return;this.f.fire({action:b});let y;try{await this.u(b,C)}catch(a){y=a}this.m.fire({action:b,error:y})}async u(b,C){await b.run(C)}}e.$1i=L;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...b){let C=[];for(const y of b)y.length&&(C.length?C=[...C,new p,...y]:C=y);return C}async run(){}}e.$2i=p,p.ID="vs.actions.separator";class ${get actions(){return this.a}constructor(b,C,y,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=b,this.label=C,this.class=a,this.a=y}async run(){}}e.$3i=$;class w extends M{constructor(){super(w.ID,I.localize(0,null),void 0,!1)}}e.$4i=w,w.ID="vs.actions.empty";function A(P){return{id:P.id,label:P.label,class:P.class,enabled:P.enabled??!0,checked:P.checked,run:async(...b)=>P.run(...b),tooltip:P.label}}}),define(Ee[198],Ce([9,10]),function(re,e){return re.create("vs/base/common/date",e)}),define(Ee[199],Ce([1,0,198]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=w,e.$Pm=A,e.$Qm=P;const R=60,I=R*60,M=I*24,L=M*7,p=M*30,$=M*365;function w(b,C,y,a){typeof b!="number"&&(b=b.getTime());const m=Math.round((new Date().getTime()-b)/1e3);if(m<-30)return(0,o.localize)(0,null,w(new Date().getTime()+m*1e3,!1));if(!a&&m<30)return(0,o.localize)(1,null);let c;return m<R?(c=m,C?c===1?y?(0,o.localize)(2,null,c):(0,o.localize)(3,null,c):y?(0,o.localize)(4,null,c):(0,o.localize)(5,null,c):c===1?y?(0,o.localize)(6,null,c):(0,o.localize)(7,null,c):y?(0,o.localize)(8,null,c):(0,o.localize)(9,null,c)):m<I?(c=Math.floor(m/R),C?c===1?y?(0,o.localize)(10,null,c):(0,o.localize)(11,null,c):y?(0,o.localize)(12,null,c):(0,o.localize)(13,null,c):c===1?y?(0,o.localize)(14,null,c):(0,o.localize)(15,null,c):y?(0,o.localize)(16,null,c):(0,o.localize)(17,null,c)):m<M?(c=Math.floor(m/I),C?c===1?y?(0,o.localize)(18,null,c):(0,o.localize)(19,null,c):y?(0,o.localize)(20,null,c):(0,o.localize)(21,null,c):c===1?y?(0,o.localize)(22,null,c):(0,o.localize)(23,null,c):y?(0,o.localize)(24,null,c):(0,o.localize)(25,null,c)):m<L?(c=Math.floor(m/M),C?c===1?(0,o.localize)(26,null,c):(0,o.localize)(27,null,c):c===1?(0,o.localize)(28,null,c):(0,o.localize)(29,null,c)):m<p?(c=Math.floor(m/L),C?c===1?y?(0,o.localize)(30,null,c):(0,o.localize)(31,null,c):y?(0,o.localize)(32,null,c):(0,o.localize)(33,null,c):c===1?y?(0,o.localize)(34,null,c):(0,o.localize)(35,null,c):y?(0,o.localize)(36,null,c):(0,o.localize)(37,null,c)):m<$?(c=Math.floor(m/p),C?c===1?y?(0,o.localize)(38,null,c):(0,o.localize)(39,null,c):y?(0,o.localize)(40,null,c):(0,o.localize)(41,null,c):c===1?y?(0,o.localize)(42,null,c):(0,o.localize)(43,null,c):y?(0,o.localize)(44,null,c):(0,o.localize)(45,null,c)):(c=Math.floor(m/$),C?c===1?y?(0,o.localize)(46,null,c):(0,o.localize)(47,null,c):y?(0,o.localize)(48,null,c):(0,o.localize)(49,null,c):c===1?y?(0,o.localize)(50,null,c):(0,o.localize)(51,null,c):y?(0,o.localize)(52,null,c):(0,o.localize)(53,null,c))}function A(b,C){const y=Math.abs(b/1e3);return y<1?C?(0,o.localize)(54,null,b):(0,o.localize)(55,null,b):y<R?C?(0,o.localize)(56,null,Math.round(b)/1e3):(0,o.localize)(57,null,Math.round(b)/1e3):y<I?C?(0,o.localize)(58,null,Math.round(b/(1e3*R))):(0,o.localize)(59,null,Math.round(b/(1e3*R))):y<M?C?(0,o.localize)(60,null,Math.round(b/(1e3*I))):(0,o.localize)(61,null,Math.round(b/(1e3*I))):(0,o.localize)(62,null,Math.round(b/(1e3*M)))}function P(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ee[200],Ce([9,10]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(Ee[47],Ce([1,0,19,18,200]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=$,e.$7i=w,e.$8i=A;function M(P,b){return b&&(P.stack||P.stacktrace)?I.localize(0,null,p(P),L(P.stack)||L(P.stacktrace)):p(P)}function L(P){return Array.isArray(P)?P.join(`
`):P}function p(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?I.localize(1,null,P.message):P.message||I.localize(2,null)}function $(P=null,b=!1){if(!P)return I.localize(3,null);if(Array.isArray(P)){const C=o.$Hb(P),y=$(C[0],b);return C.length>1?I.localize(4,null,y,C.length):y}if(R.$Vf(P))return P;if(P.detail){const C=P.detail;if(C.error)return M(C.error,b);if(C.exception)return M(C.exception,b)}return P.stack?M(P,b):P.message?P.message:I.localize(5,null)}function w(P){const b=P;return b instanceof Error&&Array.isArray(b.actions)}function A(P,b){let C;return typeof P=="string"?C=new Error(P):C=P,C.actions=b,C}}),define(Ee[201],Ce([9,10]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(Ee[136],Ce([1,0,19,24,11,184,133,201]),function(re,e,o,R,I,M,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=m,e.clampedInt=i,e.clampedFloat=r,e.stringSet=f,e.cursorStyleToString=k,e.filterValidationDecorations=de;var $;(function(ae){ae[ae.None=0]="None",ae[ae.Keep=1]="Keep",ae[ae.Brackets=2]="Brackets",ae[ae.Advanced=3]="Advanced",ae[ae.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class w{constructor(ue){this.c=ue}hasChanged(ue){return this.c[ue]}}e.ConfigurationChangedEvent=w;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class P{constructor(ue,De,Je,et){this.id=ue,this.name=De,this.defaultValue=Je,this.schema=et}applyUpdate(ue,De){return C(ue,De)}compute(ue,De,Je){return Je}}class b{constructor(ue,De){this.newValue=ue,this.didChange=De}}e.ApplyUpdateResult=b;function C(ae,ue){if(typeof ae!="object"||typeof ue!="object"||!ae||!ue)return new b(ue,ae!==ue);if(Array.isArray(ae)||Array.isArray(ue)){const Je=Array.isArray(ae)&&Array.isArray(ue)&&o.$ub(ae,ue);return new b(ue,!Je)}let De=!1;for(const Je in ue)if(ue.hasOwnProperty(Je)){const et=C(ae[Je],ue[Je]);et.didChange&&(ae[Je]=et.newValue,De=!0)}return new b(ae,De)}class y{constructor(ue){this.schema=void 0,this.id=ue,this.name="_never_",this.defaultValue=void 0}applyUpdate(ue,De){return C(ue,De)}validate(ue){return this.defaultValue}}class a{constructor(ue,De,Je,et){this.id=ue,this.name=De,this.defaultValue=Je,this.schema=et}applyUpdate(ue,De){return C(ue,De)}validate(ue){return typeof ue>"u"?this.defaultValue:ue}compute(ue,De,Je){return Je}}function m(ae,ue){return typeof ae>"u"?ue:ae==="false"?!1:!!ae}class c extends a{constructor(ue,De,Je,et=void 0){typeof et<"u"&&(et.type="boolean",et.default=Je),super(ue,De,Je,et)}validate(ue){return m(ue,this.defaultValue)}}function i(ae,ue,De,Je){if(typeof ae>"u")return ue;let et=parseInt(ae,10);return isNaN(et)?ue:(et=Math.max(De,et),et=Math.min(Je,et),et|0)}class n extends a{static clampedInt(ue,De,Je,et){return i(ue,De,Je,et)}constructor(ue,De,Je,et,Ne,ht=void 0){typeof ht<"u"&&(ht.type="integer",ht.default=Je,ht.minimum=et,ht.maximum=Ne),super(ue,De,Je,ht),this.minimum=et,this.maximum=Ne}validate(ue){return n.clampedInt(ue,this.defaultValue,this.minimum,this.maximum)}}function r(ae,ue,De,Je){if(typeof ae>"u")return ue;const et=s.float(ae,ue);return s.clamp(et,De,Je)}class s extends a{static clamp(ue,De,Je){return ue<De?De:ue>Je?Je:ue}static float(ue,De){if(typeof ue=="number")return ue;if(typeof ue>"u")return De;const Je=parseFloat(ue);return isNaN(Je)?De:Je}constructor(ue,De,Je,et,Ne){typeof Ne<"u"&&(Ne.type="number",Ne.default=Je),super(ue,De,Je,Ne),this.validationFn=et}validate(ue){return this.validationFn(s.float(ue,this.defaultValue))}}class t extends a{static string(ue,De){return typeof ue!="string"?De:ue}constructor(ue,De,Je,et=void 0){typeof et<"u"&&(et.type="string",et.default=Je),super(ue,De,Je,et)}validate(ue){return t.string(ue,this.defaultValue)}}function f(ae,ue,De,Je){return typeof ae!="string"?ue:Je&&ae in Je?Je[ae]:De.indexOf(ae)===-1?ue:ae}class d extends a{constructor(ue,De,Je,et,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.enum=et,Ne.default=Je),super(ue,De,Je,Ne),this.c=et}validate(ue){return f(ue,this.defaultValue,this.c)}}class u extends P{constructor(ue,De,Je,et,Ne,ht,vt=void 0){typeof vt<"u"&&(vt.type="string",vt.enum=Ne,vt.default=et),super(ue,De,Je,vt),this.c=Ne,this.d=ht}validate(ue){return typeof ue!="string"?this.defaultValue:this.c.indexOf(ue)===-1?this.defaultValue:this.d(ue)}}function h(ae){switch(ae){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(ue){switch(ue){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ue,De,Je){return Je===0?ue.accessibilitySupport:Je}}class g extends P{constructor(){const ue={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ue,{"editor.comments.insertSpace":{type:"boolean",default:ue.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ue.ignoreEmptyLines,description:p.localize(5,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{insertSpace:m(De.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(De.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var E;(function(ae){ae[ae.Hidden=0]="Hidden",ae[ae.Blink=1]="Blink",ae[ae.Smooth=2]="Smooth",ae[ae.Phase=3]="Phase",ae[ae.Expand=4]="Expand",ae[ae.Solid=5]="Solid"})(E||(e.TextEditorCursorBlinkingStyle=E={}));function v(ae){switch(ae){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var S;(function(ae){ae[ae.Line=1]="Line",ae[ae.Block=2]="Block",ae[ae.Underline=3]="Underline",ae[ae.LineThin=4]="LineThin",ae[ae.BlockOutline=5]="BlockOutline",ae[ae.UnderlineThin=6]="UnderlineThin"})(S||(e.TextEditorCursorStyle=S={}));function k(ae){switch(ae){case S.Line:return"line";case S.Block:return"block";case S.Underline:return"underline";case S.LineThin:return"line-thin";case S.BlockOutline:return"block-outline";case S.UnderlineThin:return"underline-thin"}}function D(ae){switch(ae){case"line":return S.Line;case"block":return S.Block;case"underline":return S.Underline;case"line-thin":return S.LineThin;case"block-outline":return S.BlockOutline;case"underline-thin":return S.UnderlineThin}}class F extends y{constructor(){super(142)}compute(ue,De,Je){const et=["monaco-editor"];return De.get(39)&&et.push(De.get(39)),ue.extraEditorClassName&&et.push(ue.extraEditorClassName),De.get(74)==="default"?et.push("mouse-default"):De.get(74)==="copy"&&et.push("mouse-copy"),De.get(111)&&et.push("showUnused"),De.get(140)&&et.push("showDeprecated"),et.join(" ")}}class W extends c{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(ue,De,Je){return Je&&ue.emptySelectionClipboard}}class B extends P{constructor(){const ue={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ue,{"editor.find.cursorMoveOnType":{type:"boolean",default:ue.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ue.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ue.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ue.globalFindClipboard,description:p.localize(16,null),included:I.$d},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ue.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:ue.loop,description:p.localize(18,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{cursorMoveOnType:m(De.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ue.seedSearchStringFromSelection=="boolean"?ue.seedSearchStringFromSelection?"always":"never":f(De.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ue.autoFindInSelection=="boolean"?ue.autoFindInSelection?"always":"never":f(De.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(De.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(De.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(De.loop,this.defaultValue.loop)}}}class j extends P{constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"||ue.length===0?j.OFF:ue==="true"?j.ON:ue:ue?j.ON:j.OFF}}e.EditorFontLigatures=j,j.OFF='"liga" off, "calt" off',j.ON='"liga" on, "calt" on';class N extends P{constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?N.OFF:ue==="true"?N.TRANSLATE:ue:ue?N.TRANSLATE:N.OFF}compute(ue,De,Je){return ue.fontInfo.fontVariationSettings}}e.EditorFontVariations=N,N.OFF="normal",N.TRANSLATE="translate";class T extends y{constructor(){super(50)}compute(ue,De,Je){return ue.fontInfo}}class O extends a{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(ue){const De=s.float(ue,this.defaultValue);return De===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(De,6,100)}compute(ue,De,Je){return ue.fontInfo.fontSize}}class z extends P{constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.d,maximum:z.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(ue){return ue==="normal"||ue==="bold"?ue:String(n.clampedInt(ue,e.EDITOR_FONT_DEFAULTS.fontWeight,z.d,z.e))}}z.c=["normal","bold","100","200","300","400","500","600","700","800","900"],z.d=1,z.e=1e3;class Q extends P{constructor(){const ue={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},De={type:"string",enum:["peek","gotoAndPeek","goto"],default:ue.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},Je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ue,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...De},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...De},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...De},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...De},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...De},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ue.alternativeDefinitionCommand,enum:Je,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ue.alternativeTypeDefinitionCommand,enum:Je,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ue.alternativeDeclarationCommand,enum:Je,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ue.alternativeImplementationCommand,enum:Je,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ue.alternativeReferenceCommand,enum:Je,description:p.localize(41,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{multiple:f(De.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:De.multipleDefinitions??f(De.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:De.multipleTypeDefinitions??f(De.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:De.multipleDeclarations??f(De.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:De.multipleImplementations??f(De.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:De.multipleReferences??f(De.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(De.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(De.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(De.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(De.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(De.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Z extends P{constructor(){const ue={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ue,{"editor.hover.enabled":{type:"boolean",default:ue.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:ue.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ue.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ue.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:ue.above,description:p.localize(46,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{enabled:m(De.enabled,this.defaultValue.enabled),delay:n.clampedInt(De.delay,this.defaultValue.delay,0,1e4),sticky:m(De.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(De.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:m(De.above,this.defaultValue.above)}}}var J;(function(ae){ae[ae.None=0]="None",ae[ae.Text=1]="Text",ae[ae.Blocks=2]="Blocks"})(J||(e.RenderMinimap=J={}));class x extends y{constructor(){super(145)}compute(ue,De,Je){return x.computeLayout(De,{memory:ue.memory,outerWidth:ue.outerWidth,outerHeight:ue.outerHeight,isDominatedByLongLines:ue.isDominatedByLongLines,lineHeight:ue.fontInfo.lineHeight,viewLineCount:ue.viewLineCount,lineNumbersDigitCount:ue.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ue.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ue.fontInfo.maxDigitWidth,pixelRatio:ue.pixelRatio,glyphMarginDecorationLaneCount:ue.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ue){const De=ue.height/ue.lineHeight,Je=Math.floor(ue.paddingTop/ue.lineHeight);let et=Math.floor(ue.paddingBottom/ue.lineHeight);ue.scrollBeyondLastLine&&(et=Math.max(et,De-1));const Ne=(Je+ue.viewLineCount+et)/(ue.pixelRatio*ue.height),ht=Math.floor(ue.viewLineCount/Ne);return{typicalViewportLineCount:De,extraLinesBeforeFirstLine:Je,extraLinesBeyondLastLine:et,desiredRatio:Ne,minimapLineCount:ht}}static c(ue,De){const Je=ue.outerWidth,et=ue.outerHeight,Ne=ue.pixelRatio;if(!ue.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ne*et),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:et};const ht=De.stableMinimapLayoutInput,vt=ht&&ue.outerHeight===ht.outerHeight&&ue.lineHeight===ht.lineHeight&&ue.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&ue.pixelRatio===ht.pixelRatio&&ue.scrollBeyondLastLine===ht.scrollBeyondLastLine&&ue.paddingTop===ht.paddingTop&&ue.paddingBottom===ht.paddingBottom&&ue.minimap.enabled===ht.minimap.enabled&&ue.minimap.side===ht.minimap.side&&ue.minimap.size===ht.minimap.size&&ue.minimap.showSlider===ht.minimap.showSlider&&ue.minimap.renderCharacters===ht.minimap.renderCharacters&&ue.minimap.maxColumn===ht.minimap.maxColumn&&ue.minimap.scale===ht.minimap.scale&&ue.verticalScrollbarWidth===ht.verticalScrollbarWidth&&ue.isViewportWrapping===ht.isViewportWrapping,Mt=ue.lineHeight,zt=ue.typicalHalfwidthCharacterWidth,Yt=ue.scrollBeyondLastLine,xt=ue.minimap.renderCharacters;let Pt=Ne>=2?Math.round(ue.minimap.scale*2):ue.minimap.scale;const sn=ue.minimap.maxColumn,_t=ue.minimap.size,dn=ue.minimap.side,tt=ue.verticalScrollbarWidth,on=ue.viewLineCount,Gt=ue.remainingWidth,Kt=ue.isViewportWrapping,gt=xt?2:3;let bt=Math.floor(Ne*et);const Xt=bt/Ne;let Bt=!1,Vt=!1,$t=gt*Pt,Rt=Pt/Ne,cn=1;if(_t==="fill"||_t==="fit"){const{typicalViewportLineCount:Ut,extraLinesBeforeFirstLine:Tt,extraLinesBeyondLastLine:Lt,desiredRatio:un,minimapLineCount:Wt}=x.computeContainedMinimapLineCount({viewLineCount:on,scrollBeyondLastLine:Yt,paddingTop:ue.paddingTop,paddingBottom:ue.paddingBottom,height:et,lineHeight:Mt,pixelRatio:Ne});if(on/Wt>1)Bt=!0,Vt=!0,Pt=1,$t=1,Rt=Pt/Ne;else{let It=!1,Ft=Pt+1;if(_t==="fit"){const rn=Math.ceil((Tt+on+Lt)*$t);Kt&&vt&&Gt<=De.stableFitRemainingWidth?(It=!0,Ft=De.stableFitMaxMinimapScale):It=rn>bt}if(_t==="fill"||It){Bt=!0;const rn=Pt;$t=Math.min(Mt*Ne,Math.max(1,Math.floor(1/un))),Kt&&vt&&Gt<=De.stableFitRemainingWidth&&(Ft=De.stableFitMaxMinimapScale),Pt=Math.min(Ft,Math.max(1,Math.floor($t/gt))),Pt>rn&&(cn=Math.min(2,Pt/rn)),Rt=Pt/Ne/cn,bt=Math.ceil(Math.max(Ut,Tt+on+Lt)*$t),Kt?(De.stableMinimapLayoutInput=ue,De.stableFitRemainingWidth=Gt,De.stableFitMaxMinimapScale=Pt):(De.stableMinimapLayoutInput=null,De.stableFitRemainingWidth=0)}}}const en=Math.floor(sn*Rt),Xe=Math.min(en,Math.max(0,Math.floor((Gt-tt-2)*Rt/(zt+Rt)))+e.MINIMAP_GUTTER_WIDTH);let Zt=Math.floor(Ne*Xe);const tn=Zt/Ne;Zt=Math.floor(Zt*cn);const nn=xt?1:2,yt=dn==="left"?0:Je-Xe-tt;return{renderMinimap:nn,minimapLeft:yt,minimapWidth:Xe,minimapHeightIsEditorHeight:Bt,minimapIsSampling:Vt,minimapScale:Pt,minimapLineHeight:$t,minimapCanvasInnerWidth:Zt,minimapCanvasInnerHeight:bt,minimapCanvasOuterWidth:tn,minimapCanvasOuterHeight:Xt}}static computeLayout(ue,De){const Je=De.outerWidth|0,et=De.outerHeight|0,Ne=De.lineHeight|0,ht=De.lineNumbersDigitCount|0,vt=De.typicalHalfwidthCharacterWidth,Mt=De.maxDigitWidth,zt=De.pixelRatio,Yt=De.viewLineCount,xt=ue.get(137),Pt=xt==="inherit"?ue.get(136):xt,sn=Pt==="inherit"?ue.get(132):Pt,_t=ue.get(135),dn=De.isDominatedByLongLines,tt=ue.get(57),on=ue.get(68).renderType!==0,Gt=ue.get(69),Kt=ue.get(105),gt=ue.get(84),bt=ue.get(73),Xt=ue.get(103),Bt=Xt.verticalScrollbarSize,Vt=Xt.verticalHasArrows,$t=Xt.arrowSize,Rt=Xt.horizontalScrollbarSize,cn=ue.get(43),en=ue.get(110)!=="never";let Xe=ue.get(66);cn&&en&&(Xe+=16);let Zt=0;if(on){const Et=Math.max(ht,Gt);Zt=Math.round(Et*Mt)}let tn=0;tt&&(tn=Ne*De.glyphMarginDecorationLaneCount);let nn=0,yt=nn+tn,Ut=yt+Zt,Tt=Ut+Xe;const Lt=Je-tn-Zt-Xe;let un=!1,Wt=!1,Ht=-1;Pt==="inherit"&&dn?(un=!0,Wt=!0):sn==="on"||sn==="bounded"?Wt=!0:sn==="wordWrapColumn"&&(Ht=_t);const It=x.c({outerWidth:Je,outerHeight:et,lineHeight:Ne,typicalHalfwidthCharacterWidth:vt,pixelRatio:zt,scrollBeyondLastLine:Kt,paddingTop:gt.top,paddingBottom:gt.bottom,minimap:bt,verticalScrollbarWidth:Bt,viewLineCount:Yt,remainingWidth:Lt,isViewportWrapping:Wt},De.memory||new A);It.renderMinimap!==0&&It.minimapLeft===0&&(nn+=It.minimapWidth,yt+=It.minimapWidth,Ut+=It.minimapWidth,Tt+=It.minimapWidth);const Ft=Lt-It.minimapWidth,rn=Math.max(1,Math.floor((Ft-Bt-2)/vt)),At=Vt?$t:0;return Wt&&(Ht=Math.max(1,rn),sn==="bounded"&&(Ht=Math.min(Ht,_t))),{width:Je,height:et,glyphMarginLeft:nn,glyphMarginWidth:tn,glyphMarginDecorationLaneCount:De.glyphMarginDecorationLaneCount,lineNumbersLeft:yt,lineNumbersWidth:Zt,decorationsLeft:Ut,decorationsWidth:Xe,contentLeft:Tt,contentWidth:Ft,minimap:It,viewportColumn:rn,isWordWrapMinified:un,isViewportWrapping:Wt,wrappingColumn:Ht,verticalScrollbarWidth:Bt,horizontalScrollbarHeight:Rt,overviewRuler:{top:At,width:Bt,height:et-2*At,right:0}}}}e.EditorLayoutInfoComputer=x;class ce extends P{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(ue){return f(ue,"simple",["simple","advanced"])}compute(ue,De,Je){return De.get(2)===2?"advanced":Je}}var te;(function(ae){ae.Off="off",ae.OnCode="onCode",ae.On="on"})(te||(e.ShowLightbulbIconMode=te={}));class pe extends P{constructor(){const ue={enabled:te.On};super(65,"lightbulb",ue,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[te.Off,te.OnCode,te.On],default:ue.enabled,enumDescriptions:[p.localize(50,null),p.localize(51,null),p.localize(52,null)],description:p.localize(53,null)}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{enabled:f(ue.enabled,this.defaultValue.enabled,[te.Off,te.OnCode,te.On])}}}class ye extends P{constructor(){const ue={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ue,{"editor.stickyScroll.enabled":{type:"boolean",default:ue.enabled,description:p.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ue.maxLineCount,minimum:1,maximum:20,description:p.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ue.defaultModel,description:p.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ue.scrollWithEditor,description:p.localize(57,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{enabled:m(De.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(De.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:f(De.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:m(De.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class _ extends P{constructor(){const ue={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",ue,{"editor.inlayHints.enabled":{type:"string",default:ue.enabled,description:p.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(59,null),p.localize(60,null,I.$d?"Ctrl+Option":"Ctrl+Alt"),p.localize(61,null,I.$d?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ue.fontSize,markdownDescription:p.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ue.fontFamily,markdownDescription:p.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ue.padding,description:p.localize(65,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return typeof De.enabled=="boolean"&&(De.enabled=De.enabled?"on":"off"),{enabled:f(De.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(De.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(De.fontFamily,this.defaultValue.fontFamily),padding:m(De.padding,this.defaultValue.padding)}}}class U extends P{constructor(){super(66,"lineDecorationsWidth",10)}validate(ue){return typeof ue=="string"&&/^\d+(\.\d+)?ch$/.test(ue)?-parseFloat(ue.substring(0,ue.length-2)):n.clampedInt(ue,this.defaultValue,0,1e3)}compute(ue,De,Je){return Je<0?n.clampedInt(-Je*ue.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Je}}class he extends s{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ue=>s.clamp(ue,0,150),{markdownDescription:p.localize(66,null)})}compute(ue,De,Je){return ue.fontInfo.lineHeight}}class Se extends P{constructor(){const ue={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",ue,{"editor.minimap.enabled":{type:"boolean",default:ue.enabled,description:p.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ue.autohide,description:p.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(69,null),p.localize(70,null),p.localize(71,null)],default:ue.size,description:p.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ue.side,description:p.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ue.showSlider,description:p.localize(74,null)},"editor.minimap.scale":{type:"number",default:ue.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ue.renderCharacters,description:p.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ue.maxColumn,description:p.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ue.showRegionSectionHeaders,description:p.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ue.showMarkSectionHeaders,description:p.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ue.sectionHeaderFontSize,description:p.localize(80,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{enabled:m(De.enabled,this.defaultValue.enabled),autohide:m(De.autohide,this.defaultValue.autohide),size:f(De.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(De.side,this.defaultValue.side,["right","left"]),showSlider:f(De.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(De.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(De.scale,1,1,3),maxColumn:n.clampedInt(De.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:m(De.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:m(De.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:s.clamp(De.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function me(ae){return ae==="ctrlCmd"?I.$d?"metaKey":"ctrlKey":"altKey"}class ie extends P{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(82,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{top:n.clampedInt(De.top,0,0,1e3),bottom:n.clampedInt(De.bottom,0,0,1e3)}}}class se extends P{constructor(){const ue={enabled:!0,cycle:!0};super(86,"parameterHints",ue,{"editor.parameterHints.enabled":{type:"boolean",default:ue.enabled,description:p.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:ue.cycle,description:p.localize(84,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{enabled:m(De.enabled,this.defaultValue.enabled),cycle:m(De.cycle,this.defaultValue.cycle)}}}class oe extends y{constructor(){super(143)}compute(ue,De,Je){return ue.pixelRatio}}class G extends P{constructor(){const ue={other:"on",comments:"off",strings:"off"},De=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(85,null),p.localize(86,null),p.localize(87,null)]}];super(89,"quickSuggestions",ue,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:De,default:ue.strings,description:p.localize(88,null)},comments:{anyOf:De,default:ue.comments,description:p.localize(89,null)},other:{anyOf:De,default:ue.other,description:p.localize(90,null)}},default:ue,markdownDescription:p.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ue}validate(ue){if(typeof ue=="boolean"){const zt=ue?"on":"off";return{comments:zt,strings:zt,other:zt}}if(!ue||typeof ue!="object")return this.defaultValue;const{other:De,comments:Je,strings:et}=ue,Ne=["on","inline","off"];let ht,vt,Mt;return typeof De=="boolean"?ht=De?"on":"off":ht=f(De,this.defaultValue.other,Ne),typeof Je=="boolean"?vt=Je?"on":"off":vt=f(Je,this.defaultValue.comments,Ne),typeof et=="boolean"?Mt=et?"on":"off":Mt=f(et,this.defaultValue.strings,Ne),{other:ht,comments:vt,strings:Mt}}}var ee;(function(ae){ae[ae.Off=0]="Off",ae[ae.On=1]="On",ae[ae.Relative=2]="Relative",ae[ae.Interval=3]="Interval",ae[ae.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class le extends P{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(92,null),p.localize(93,null),p.localize(94,null),p.localize(95,null)],default:"on",description:p.localize(96,null)})}validate(ue){let De=this.defaultValue.renderType,Je=this.defaultValue.renderFn;return typeof ue<"u"&&(typeof ue=="function"?(De=4,Je=ue):ue==="interval"?De=3:ue==="relative"?De=2:ue==="on"?De=1:De=0),{renderType:De,renderFn:Je}}}function de(ae){const ue=ae.get(98);return ue==="editable"?ae.get(91):ue!=="on"}class Me extends P{constructor(){const ue=[],De={type:"number",description:p.localize(97,null)};super(102,"rulers",ue,{type:"array",items:{anyOf:[De,{type:["object"],properties:{column:De,color:{type:"string",description:p.localize(98,null),format:"color-hex"}}}]},default:ue,description:p.localize(99,null)})}validate(ue){if(Array.isArray(ue)){const De=[];for(const Je of ue)if(typeof Je=="number")De.push({column:n.clampedInt(Je,0,0,1e4),color:null});else if(Je&&typeof Je=="object"){const et=Je;De.push({column:n.clampedInt(et.column,0,0,1e4),color:et.color})}return De.sort((Je,et)=>Je.column-et.column),De}return this.defaultValue}}class be extends P{constructor(){super(92,"readOnlyMessage",void 0)}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:ue}}function Pe(ae,ue){if(typeof ae!="string")return ue;switch(ae){case"hidden":return 2;case"visible":return 3;default:return 1}}class Re extends P{constructor(){const ue={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ue,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(100,null),p.localize(101,null),p.localize(102,null)],default:"auto",description:p.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(104,null),p.localize(105,null),p.localize(106,null)],default:"auto",description:p.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ue.verticalScrollbarSize,description:p.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ue.horizontalScrollbarSize,description:p.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ue.scrollByPage,description:p.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ue.ignoreHorizontalScrollbarInContentHeight,description:p.localize(111,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue,Je=n.clampedInt(De.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),et=n.clampedInt(De.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(De.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(De.vertical,this.defaultValue.vertical),horizontal:Pe(De.horizontal,this.defaultValue.horizontal),useShadows:m(De.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(De.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(De.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(De.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(De.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Je,horizontalSliderSize:n.clampedInt(De.horizontalSliderSize,Je,0,1e3),verticalScrollbarSize:et,verticalSliderSize:n.clampedInt(De.verticalSliderSize,et,0,1e3),scrollByPage:m(De.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:m(De.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends P{constructor(){const ue={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ue,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.nonBasicASCII,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ue.invisibleCharacters,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ue.ambiguousCharacters,description:p.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeComments,description:p.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeStrings,description:p.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ue.allowedCharacters,description:p.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ue.allowedLocales,description:p.localize(118,null)}})}applyUpdate(ue,De){let Je=!1;De.allowedCharacters&&ue&&(R.$Tn(ue.allowedCharacters,De.allowedCharacters)||(ue={...ue,allowedCharacters:De.allowedCharacters},Je=!0)),De.allowedLocales&&ue&&(R.$Tn(ue.allowedLocales,De.allowedLocales)||(ue={...ue,allowedLocales:De.allowedLocales},Je=!0));const et=super.applyUpdate(ue,De);return Je?new b(et.newValue,!0):et}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{nonBasicASCII:fe(De.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(De.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(De.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:fe(De.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:fe(De.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ue.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ue.allowedLocales,this.defaultValue.allowedLocales)}}c(ue,De){if(typeof ue!="object"||!ue)return De;const Je={};for(const[et,Ne]of Object.entries(ue))Ne===!0&&(Je[et]=!0);return Je}}class V extends P{constructor(){const ue={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",ue,{"editor.inlineSuggest.enabled":{type:"boolean",default:ue.enabled,description:p.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(120,null),p.localize(121,null),p.localize(122,null)],description:p.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ue.suppressSuggestions,description:p.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ue.fontFamily,description:p.localize(125,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{enabled:m(De.enabled,this.defaultValue.enabled),mode:f(De.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:m(De.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:m(De.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(De.fontFamily,this.defaultValue.fontFamily)}}}class H extends P{constructor(){const ue={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",ue,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ue.enabled,description:p.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(127,null),p.localize(128,null),p.localize(129,null)],description:p.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ue.fontFamily,description:p.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:ue.backgroundColoring,description:p.localize(132,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{enabled:m(De.enabled,this.defaultValue.enabled),showToolbar:f(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(De.fontFamily,this.defaultValue.fontFamily),keepOnBlur:m(De.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:m(De.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Y extends P{constructor(){const ue={enabled:M.$Ns.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$Ns.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ue,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ue.enabled,markdownDescription:p.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ue.independentColorPoolPerBracketType,description:p.localize(134,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{enabled:m(De.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(De.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class X extends P{constructor(){const ue={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ue,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null)],default:ue.bracketPairs,description:p.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(139,null),p.localize(140,null),p.localize(141,null)],default:ue.bracketPairsHorizontal,description:p.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ue.highlightActiveBracketPair,description:p.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:ue.indentation,description:p.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(145,null),p.localize(146,null),p.localize(147,null)],default:ue.highlightActiveIndentation,description:p.localize(148,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{bracketPairs:fe(De.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:fe(De.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(De.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(De.indentation,this.defaultValue.indentation),highlightActiveIndentation:fe(De.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function fe(ae,ue,De){const Je=De.indexOf(ae);return Je===-1?ue:De[Je]}class we extends P{constructor(){const ue={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ue,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(149,null),p.localize(150,null)],default:ue.insertMode,description:p.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ue.filterGraceful,description:p.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:ue.localityBonus,description:p.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ue.shareSuggestSelections,markdownDescription:p.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(155,null),p.localize(156,null),p.localize(157,null),p.localize(158,null)],default:ue.selectionMode,markdownDescription:p.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ue.snippetsPreventQuickSuggestions,description:p.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:ue.showIcons,description:p.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ue.showStatusBar,description:p.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:ue.preview,description:p.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ue.showInlineDetails,description:p.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(196,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{insertMode:f(De.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(De.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(De.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(De.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(De.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f(De.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:m(De.showIcons,this.defaultValue.showIcons),showStatusBar:m(De.showStatusBar,this.defaultValue.showStatusBar),preview:m(De.preview,this.defaultValue.preview),previewMode:f(De.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(De.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(De.showMethods,this.defaultValue.showMethods),showFunctions:m(De.showFunctions,this.defaultValue.showFunctions),showConstructors:m(De.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(De.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(De.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(De.showFields,this.defaultValue.showFields),showVariables:m(De.showVariables,this.defaultValue.showVariables),showClasses:m(De.showClasses,this.defaultValue.showClasses),showStructs:m(De.showStructs,this.defaultValue.showStructs),showInterfaces:m(De.showInterfaces,this.defaultValue.showInterfaces),showModules:m(De.showModules,this.defaultValue.showModules),showProperties:m(De.showProperties,this.defaultValue.showProperties),showEvents:m(De.showEvents,this.defaultValue.showEvents),showOperators:m(De.showOperators,this.defaultValue.showOperators),showUnits:m(De.showUnits,this.defaultValue.showUnits),showValues:m(De.showValues,this.defaultValue.showValues),showConstants:m(De.showConstants,this.defaultValue.showConstants),showEnums:m(De.showEnums,this.defaultValue.showEnums),showEnumMembers:m(De.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(De.showKeywords,this.defaultValue.showKeywords),showWords:m(De.showWords,this.defaultValue.showWords),showColors:m(De.showColors,this.defaultValue.showColors),showFiles:m(De.showFiles,this.defaultValue.showFiles),showReferences:m(De.showReferences,this.defaultValue.showReferences),showFolders:m(De.showFolders,this.defaultValue.showFolders),showTypeParameters:m(De.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(De.showSnippets,this.defaultValue.showSnippets),showUsers:m(De.showUsers,this.defaultValue.showUsers),showIssues:m(De.showIssues,this.defaultValue.showIssues)}}}class Te extends P{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(198,null),default:!0,type:"boolean"}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(ue.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:m(ue.selectSubwords,this.defaultValue.selectSubwords)}}}class Ve extends P{constructor(){const ue=[];super(130,"wordSegmenterLocales",ue,{anyOf:[{description:p.localize(199,null),type:"string"},{description:p.localize(200,null),type:"array",items:{type:"string"}}]})}validate(ue){if(typeof ue=="string"&&(ue=[ue]),Array.isArray(ue)){const De=[];for(const Je of ue)if(typeof Je=="string")try{Intl.Segmenter.supportedLocalesOf(Je).length>0&&De.push(Je)}catch{}return De}return this.defaultValue}}var Ye;(function(ae){ae[ae.None=0]="None",ae[ae.Same=1]="Same",ae[ae.Indent=2]="Indent",ae[ae.DeepIndent=3]="DeepIndent"})(Ye||(e.WrappingIndent=Ye={}));class nt extends P{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(201,null),p.localize(202,null),p.localize(203,null),p.localize(204,null)],description:p.localize(205,null),default:"same"}})}validate(ue){switch(ue){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ue,De,Je){return De.get(2)===2?0:Je}}class ot extends y{constructor(){super(146)}compute(ue,De,Je){const et=De.get(145);return{isDominatedByLongLines:ue.isDominatedByLongLines,isWordWrapMinified:et.isWordWrapMinified,isViewportWrapping:et.isViewportWrapping,wrappingColumn:et.wrappingColumn}}}class lt extends P{constructor(){const ue={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ue,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ue.enabled,markdownDescription:p.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(208,null),p.localize(209,null)],default:"afterDrop"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{enabled:m(De.enabled,this.defaultValue.enabled),showDropSelector:f(De.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class at extends P{constructor(){const ue={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ue,{"editor.pasteAs.enabled":{type:"boolean",default:ue.enabled,markdownDescription:p.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(212,null),p.localize(213,null)],default:"afterPaste"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const De=ue;return{enabled:m(De.enabled,this.defaultValue.enabled),showPasteSelector:f(De.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const st="Consolas, 'Courier New', monospace",Ie="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$d?Ie:I.$e?We:st,fontWeight:"normal",fontSize:I.$d?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ae(ae){return e.editorOptionsRegistry[ae.id]=ae,ae}var Ke;(function(ae){ae[ae.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ae[ae.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ae[ae.accessibilitySupport=2]="accessibilitySupport",ae[ae.accessibilityPageSize=3]="accessibilityPageSize",ae[ae.ariaLabel=4]="ariaLabel",ae[ae.ariaRequired=5]="ariaRequired",ae[ae.autoClosingBrackets=6]="autoClosingBrackets",ae[ae.autoClosingComments=7]="autoClosingComments",ae[ae.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ae[ae.autoClosingDelete=9]="autoClosingDelete",ae[ae.autoClosingOvertype=10]="autoClosingOvertype",ae[ae.autoClosingQuotes=11]="autoClosingQuotes",ae[ae.autoIndent=12]="autoIndent",ae[ae.automaticLayout=13]="automaticLayout",ae[ae.autoSurround=14]="autoSurround",ae[ae.bracketPairColorization=15]="bracketPairColorization",ae[ae.guides=16]="guides",ae[ae.codeLens=17]="codeLens",ae[ae.codeLensFontFamily=18]="codeLensFontFamily",ae[ae.codeLensFontSize=19]="codeLensFontSize",ae[ae.colorDecorators=20]="colorDecorators",ae[ae.colorDecoratorsLimit=21]="colorDecoratorsLimit",ae[ae.columnSelection=22]="columnSelection",ae[ae.comments=23]="comments",ae[ae.contextmenu=24]="contextmenu",ae[ae.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ae[ae.cursorBlinking=26]="cursorBlinking",ae[ae.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ae[ae.cursorStyle=28]="cursorStyle",ae[ae.cursorSurroundingLines=29]="cursorSurroundingLines",ae[ae.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ae[ae.cursorWidth=31]="cursorWidth",ae[ae.disableLayerHinting=32]="disableLayerHinting",ae[ae.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ae[ae.domReadOnly=34]="domReadOnly",ae[ae.dragAndDrop=35]="dragAndDrop",ae[ae.dropIntoEditor=36]="dropIntoEditor",ae[ae.emptySelectionClipboard=37]="emptySelectionClipboard",ae[ae.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ae[ae.extraEditorClassName=39]="extraEditorClassName",ae[ae.fastScrollSensitivity=40]="fastScrollSensitivity",ae[ae.find=41]="find",ae[ae.fixedOverflowWidgets=42]="fixedOverflowWidgets",ae[ae.folding=43]="folding",ae[ae.foldingStrategy=44]="foldingStrategy",ae[ae.foldingHighlight=45]="foldingHighlight",ae[ae.foldingImportsByDefault=46]="foldingImportsByDefault",ae[ae.foldingMaximumRegions=47]="foldingMaximumRegions",ae[ae.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ae[ae.fontFamily=49]="fontFamily",ae[ae.fontInfo=50]="fontInfo",ae[ae.fontLigatures=51]="fontLigatures",ae[ae.fontSize=52]="fontSize",ae[ae.fontWeight=53]="fontWeight",ae[ae.fontVariations=54]="fontVariations",ae[ae.formatOnPaste=55]="formatOnPaste",ae[ae.formatOnType=56]="formatOnType",ae[ae.glyphMargin=57]="glyphMargin",ae[ae.gotoLocation=58]="gotoLocation",ae[ae.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ae[ae.hover=60]="hover",ae[ae.inDiffEditor=61]="inDiffEditor",ae[ae.inlineSuggest=62]="inlineSuggest",ae[ae.inlineEdit=63]="inlineEdit",ae[ae.letterSpacing=64]="letterSpacing",ae[ae.lightbulb=65]="lightbulb",ae[ae.lineDecorationsWidth=66]="lineDecorationsWidth",ae[ae.lineHeight=67]="lineHeight",ae[ae.lineNumbers=68]="lineNumbers",ae[ae.lineNumbersMinChars=69]="lineNumbersMinChars",ae[ae.linkedEditing=70]="linkedEditing",ae[ae.links=71]="links",ae[ae.matchBrackets=72]="matchBrackets",ae[ae.minimap=73]="minimap",ae[ae.mouseStyle=74]="mouseStyle",ae[ae.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ae[ae.mouseWheelZoom=76]="mouseWheelZoom",ae[ae.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ae[ae.multiCursorModifier=78]="multiCursorModifier",ae[ae.multiCursorPaste=79]="multiCursorPaste",ae[ae.multiCursorLimit=80]="multiCursorLimit",ae[ae.occurrencesHighlight=81]="occurrencesHighlight",ae[ae.overviewRulerBorder=82]="overviewRulerBorder",ae[ae.overviewRulerLanes=83]="overviewRulerLanes",ae[ae.padding=84]="padding",ae[ae.pasteAs=85]="pasteAs",ae[ae.parameterHints=86]="parameterHints",ae[ae.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ae[ae.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ae[ae.quickSuggestions=89]="quickSuggestions",ae[ae.quickSuggestionsDelay=90]="quickSuggestionsDelay",ae[ae.readOnly=91]="readOnly",ae[ae.readOnlyMessage=92]="readOnlyMessage",ae[ae.renameOnType=93]="renameOnType",ae[ae.renderControlCharacters=94]="renderControlCharacters",ae[ae.renderFinalNewline=95]="renderFinalNewline",ae[ae.renderLineHighlight=96]="renderLineHighlight",ae[ae.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ae[ae.renderValidationDecorations=98]="renderValidationDecorations",ae[ae.renderWhitespace=99]="renderWhitespace",ae[ae.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ae[ae.roundedSelection=101]="roundedSelection",ae[ae.rulers=102]="rulers",ae[ae.scrollbar=103]="scrollbar",ae[ae.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ae[ae.scrollBeyondLastLine=105]="scrollBeyondLastLine",ae[ae.scrollPredominantAxis=106]="scrollPredominantAxis",ae[ae.selectionClipboard=107]="selectionClipboard",ae[ae.selectionHighlight=108]="selectionHighlight",ae[ae.selectOnLineNumbers=109]="selectOnLineNumbers",ae[ae.showFoldingControls=110]="showFoldingControls",ae[ae.showUnused=111]="showUnused",ae[ae.snippetSuggestions=112]="snippetSuggestions",ae[ae.smartSelect=113]="smartSelect",ae[ae.smoothScrolling=114]="smoothScrolling",ae[ae.stickyScroll=115]="stickyScroll",ae[ae.stickyTabStops=116]="stickyTabStops",ae[ae.stopRenderingLineAfter=117]="stopRenderingLineAfter",ae[ae.suggest=118]="suggest",ae[ae.suggestFontSize=119]="suggestFontSize",ae[ae.suggestLineHeight=120]="suggestLineHeight",ae[ae.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ae[ae.suggestSelection=122]="suggestSelection",ae[ae.tabCompletion=123]="tabCompletion",ae[ae.tabIndex=124]="tabIndex",ae[ae.unicodeHighlighting=125]="unicodeHighlighting",ae[ae.unusualLineTerminators=126]="unusualLineTerminators",ae[ae.useShadowDOM=127]="useShadowDOM",ae[ae.useTabStops=128]="useTabStops",ae[ae.wordBreak=129]="wordBreak",ae[ae.wordSegmenterLocales=130]="wordSegmenterLocales",ae[ae.wordSeparators=131]="wordSeparators",ae[ae.wordWrap=132]="wordWrap",ae[ae.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",ae[ae.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",ae[ae.wordWrapColumn=135]="wordWrapColumn",ae[ae.wordWrapOverride1=136]="wordWrapOverride1",ae[ae.wordWrapOverride2=137]="wordWrapOverride2",ae[ae.wrappingIndent=138]="wrappingIndent",ae[ae.wrappingStrategy=139]="wrappingStrategy",ae[ae.showDeprecated=140]="showDeprecated",ae[ae.inlayHints=141]="inlayHints",ae[ae.editorClassName=142]="editorClassName",ae[ae.pixelRatio=143]="pixelRatio",ae[ae.tabFocusMode=144]="tabFocusMode",ae[ae.layoutInfo=145]="layoutInfo",ae[ae.wrappingInfo=146]="wrappingInfo",ae[ae.defaultColorDecorators=147]="defaultColorDecorators",ae[ae.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",ae[ae.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Ke||(e.EditorOption=Ke={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ae(new c(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(214,null)})),acceptSuggestionOnEnter:Ae(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(215,null),""],markdownDescription:p.localize(216,null)})),accessibilitySupport:Ae(new l),accessibilityPageSize:Ae(new n(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(217,null),tags:["accessibility"]})),ariaLabel:Ae(new t(4,"ariaLabel",p.localize(218,null))),ariaRequired:Ae(new c(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ae(new c(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Ae(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(220,null),p.localize(221,null),""],description:p.localize(222,null)})),autoClosingComments:Ae(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(223,null),p.localize(224,null),""],description:p.localize(225,null)})),autoClosingDelete:Ae(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(226,null),""],description:p.localize(227,null)})),autoClosingOvertype:Ae(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(228,null),""],description:p.localize(229,null)})),autoClosingQuotes:Ae(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(230,null),p.localize(231,null),""],description:p.localize(232,null)})),autoIndent:Ae(new u(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],h,{enumDescriptions:[p.localize(233,null),p.localize(234,null),p.localize(235,null),p.localize(236,null),p.localize(237,null)],description:p.localize(238,null)})),automaticLayout:Ae(new c(13,"automaticLayout",!1)),autoSurround:Ae(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null),""],description:p.localize(242,null)})),bracketPairColorization:Ae(new Y),bracketPairGuides:Ae(new X),stickyTabStops:Ae(new c(116,"stickyTabStops",!1,{description:p.localize(243,null)})),codeLens:Ae(new c(17,"codeLens",!0,{description:p.localize(244,null)})),codeLensFontFamily:Ae(new t(18,"codeLensFontFamily","",{description:p.localize(245,null)})),codeLensFontSize:Ae(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(246,null)})),colorDecorators:Ae(new c(20,"colorDecorators",!0,{description:p.localize(247,null)})),colorDecoratorActivatedOn:Ae(new d(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(248,null),p.localize(249,null),p.localize(250,null)],description:p.localize(251,null)})),colorDecoratorsLimit:Ae(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(252,null)})),columnSelection:Ae(new c(22,"columnSelection",!1,{description:p.localize(253,null)})),comments:Ae(new g),contextmenu:Ae(new c(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ae(new c(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(254,null)})),cursorBlinking:Ae(new u(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:p.localize(255,null)})),cursorSmoothCaretAnimation:Ae(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(256,null),p.localize(257,null),p.localize(258,null)],description:p.localize(259,null)})),cursorStyle:Ae(new u(28,"cursorStyle",S.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],D,{description:p.localize(260,null)})),cursorSurroundingLines:Ae(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(261,null)})),cursorSurroundingLinesStyle:Ae(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(262,null),p.localize(263,null)],markdownDescription:p.localize(264,null)})),cursorWidth:Ae(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(265,null)})),disableLayerHinting:Ae(new c(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ae(new c(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ae(new c(34,"domReadOnly",!1)),dragAndDrop:Ae(new c(35,"dragAndDrop",!0,{description:p.localize(266,null)})),emptySelectionClipboard:Ae(new W),dropIntoEditor:Ae(new lt),stickyScroll:Ae(new ye),experimentalWhitespaceRendering:Ae(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(267,null),p.localize(268,null),p.localize(269,null)],description:p.localize(270,null)})),extraEditorClassName:Ae(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ae(new s(40,"fastScrollSensitivity",5,ae=>ae<=0?5:ae,{markdownDescription:p.localize(271,null)})),find:Ae(new B),fixedOverflowWidgets:Ae(new c(42,"fixedOverflowWidgets",!1)),folding:Ae(new c(43,"folding",!0,{description:p.localize(272,null)})),foldingStrategy:Ae(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(273,null),p.localize(274,null)],description:p.localize(275,null)})),foldingHighlight:Ae(new c(45,"foldingHighlight",!0,{description:p.localize(276,null)})),foldingImportsByDefault:Ae(new c(46,"foldingImportsByDefault",!1,{description:p.localize(277,null)})),foldingMaximumRegions:Ae(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(278,null)})),unfoldOnClickAfterEndOfLine:Ae(new c(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(279,null)})),fontFamily:Ae(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(280,null)})),fontInfo:Ae(new T),fontLigatures2:Ae(new j),fontSize:Ae(new O),fontWeight:Ae(new z),fontVariations:Ae(new N),formatOnPaste:Ae(new c(55,"formatOnPaste",!1,{description:p.localize(281,null)})),formatOnType:Ae(new c(56,"formatOnType",!1,{description:p.localize(282,null)})),glyphMargin:Ae(new c(57,"glyphMargin",!0,{description:p.localize(283,null)})),gotoLocation:Ae(new Q),hideCursorInOverviewRuler:Ae(new c(59,"hideCursorInOverviewRuler",!1,{description:p.localize(284,null)})),hover:Ae(new Z),inDiffEditor:Ae(new c(61,"inDiffEditor",!1)),letterSpacing:Ae(new s(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ae=>s.clamp(ae,-5,20),{description:p.localize(285,null)})),lightbulb:Ae(new pe),lineDecorationsWidth:Ae(new U),lineHeight:Ae(new he),lineNumbers:Ae(new le),lineNumbersMinChars:Ae(new n(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ae(new c(70,"linkedEditing",!1,{description:p.localize(286,null)})),links:Ae(new c(71,"links",!0,{description:p.localize(287,null)})),matchBrackets:Ae(new d(72,"matchBrackets","always",["always","near","never"],{description:p.localize(288,null)})),minimap:Ae(new Se),mouseStyle:Ae(new d(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ae(new s(75,"mouseWheelScrollSensitivity",1,ae=>ae===0?1:ae,{markdownDescription:p.localize(289,null)})),mouseWheelZoom:Ae(new c(76,"mouseWheelZoom",!1,{markdownDescription:I.$d?p.localize(290,null):p.localize(291,null)})),multiCursorMergeOverlapping:Ae(new c(77,"multiCursorMergeOverlapping",!0,{description:p.localize(292,null)})),multiCursorModifier:Ae(new u(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],me,{markdownEnumDescriptions:[p.localize(293,null),p.localize(294,null)],markdownDescription:p.localize(295,null)})),multiCursorPaste:Ae(new d(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(296,null),p.localize(297,null)],markdownDescription:p.localize(298,null)})),multiCursorLimit:Ae(new n(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(299,null)})),occurrencesHighlight:Ae(new d(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(300,null),p.localize(301,null),p.localize(302,null)],markdownDescription:p.localize(303,null)})),overviewRulerBorder:Ae(new c(82,"overviewRulerBorder",!0,{description:p.localize(304,null)})),overviewRulerLanes:Ae(new n(83,"overviewRulerLanes",3,0,3)),padding:Ae(new ie),pasteAs:Ae(new at),parameterHints:Ae(new se),peekWidgetDefaultFocus:Ae(new d(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(305,null),p.localize(306,null)],description:p.localize(307,null)})),definitionLinkOpensInPeek:Ae(new c(88,"definitionLinkOpensInPeek",!1,{description:p.localize(308,null)})),quickSuggestions:Ae(new G),quickSuggestionsDelay:Ae(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(309,null)})),readOnly:Ae(new c(91,"readOnly",!1)),readOnlyMessage:Ae(new be),renameOnType:Ae(new c(93,"renameOnType",!1,{description:p.localize(310,null),markdownDeprecationMessage:p.localize(311,null)})),renderControlCharacters:Ae(new c(94,"renderControlCharacters",!0,{description:p.localize(312,null),restricted:!0})),renderFinalNewline:Ae(new d(95,"renderFinalNewline",I.$e?"dimmed":"on",["off","on","dimmed"],{description:p.localize(313,null)})),renderLineHighlight:Ae(new d(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(314,null)],description:p.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Ae(new c(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(316,null)})),renderValidationDecorations:Ae(new d(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ae(new d(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(317,null),p.localize(318,null),p.localize(319,null),""],description:p.localize(320,null)})),revealHorizontalRightPadding:Ae(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ae(new c(101,"roundedSelection",!0,{description:p.localize(321,null)})),rulers:Ae(new Me),scrollbar:Ae(new Re),scrollBeyondLastColumn:Ae(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(322,null)})),scrollBeyondLastLine:Ae(new c(105,"scrollBeyondLastLine",!0,{description:p.localize(323,null)})),scrollPredominantAxis:Ae(new c(106,"scrollPredominantAxis",!0,{description:p.localize(324,null)})),selectionClipboard:Ae(new c(107,"selectionClipboard",!0,{description:p.localize(325,null),included:I.$e})),selectionHighlight:Ae(new c(108,"selectionHighlight",!0,{description:p.localize(326,null)})),selectOnLineNumbers:Ae(new c(109,"selectOnLineNumbers",!0)),showFoldingControls:Ae(new d(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(327,null),p.localize(328,null),p.localize(329,null)],description:p.localize(330,null)})),showUnused:Ae(new c(111,"showUnused",!0,{description:p.localize(331,null)})),showDeprecated:Ae(new c(140,"showDeprecated",!0,{description:p.localize(332,null)})),inlayHints:Ae(new _),snippetSuggestions:Ae(new d(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(333,null),p.localize(334,null),p.localize(335,null),p.localize(336,null)],description:p.localize(337,null)})),smartSelect:Ae(new Te),smoothScrolling:Ae(new c(114,"smoothScrolling",!1,{description:p.localize(338,null)})),stopRenderingLineAfter:Ae(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ae(new we),inlineSuggest:Ae(new V),inlineEdit:Ae(new H),inlineCompletionsAccessibilityVerbose:Ae(new c(149,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(339,null)})),suggestFontSize:Ae(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ae(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ae(new c(121,"suggestOnTriggerCharacters",!0,{description:p.localize(342,null)})),suggestSelection:Ae(new d(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(343,null),p.localize(344,null),p.localize(345,null)],description:p.localize(346,null)})),tabCompletion:Ae(new d(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(347,null),p.localize(348,null),p.localize(349,null)],description:p.localize(350,null)})),tabIndex:Ae(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ae(new ze),unusualLineTerminators:Ae(new d(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(351,null),p.localize(352,null),p.localize(353,null)],description:p.localize(354,null)})),useShadowDOM:Ae(new c(127,"useShadowDOM",!0)),useTabStops:Ae(new c(128,"useTabStops",!0,{description:p.localize(355,null)})),wordBreak:Ae(new d(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(356,null),p.localize(357,null)],description:p.localize(358,null)})),wordSegmenterLocales:Ae(new Ve),wordSeparators:Ae(new t(131,"wordSeparators",L.$Os,{description:p.localize(359,null)})),wordWrap:Ae(new d(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(360,null),p.localize(361,null),p.localize(362,null),p.localize(363,null)],description:p.localize(364,null)})),wordWrapBreakAfterCharacters:Ae(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ae(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ae(new n(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(365,null)})),wordWrapOverride1:Ae(new d(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ae(new d(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ae(new F),defaultColorDecorators:Ae(new c(147,"defaultColorDecorators",!1,{markdownDescription:p.localize(366,null)})),pixelRatio:Ae(new oe),tabFocusMode:Ae(new c(144,"tabFocusMode",!1,{markdownDescription:p.localize(367,null)})),layoutInfo:Ae(new x),wrappingInfo:Ae(new ot),wrappingIndent:Ae(new nt),wrappingStrategy:Ae(new ce)}}),define(Ee[202],Ce([9,10]),function(re,e){return re.create("vs/editor/common/languages",e)}),define(Ee[83],Ce([1,0,78,2,180,29,195,202]),function(re,e,o,R,I,M,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$0t=e.$9t=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$8t=e.$7t=e.SymbolKinds=e.SymbolTag=e.$5t=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$3t=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$2t=e.$1t=e.$Zt=void 0,e.$4t=f,e.$6t=u;class ${constructor(Q,Z,J){this.offset=Q,this.type=Z,this.language=J,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Zt=$;class w{constructor(Q,Z){this.tokens=Q,this.endState=Z,this._tokenizationResultBrand=void 0}}e.$1t=w;class A{constructor(Q,Z){this.tokens=Q,this.endState=Z,this._encodedTokenizationResultBrand=void 0}}e.$2t=A;var P;(function(z){z[z.Method=0]="Method",z[z.Function=1]="Function",z[z.Constructor=2]="Constructor",z[z.Field=3]="Field",z[z.Variable=4]="Variable",z[z.Class=5]="Class",z[z.Struct=6]="Struct",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Event=10]="Event",z[z.Operator=11]="Operator",z[z.Unit=12]="Unit",z[z.Value=13]="Value",z[z.Constant=14]="Constant",z[z.Enum=15]="Enum",z[z.EnumMember=16]="EnumMember",z[z.Keyword=17]="Keyword",z[z.Text=18]="Text",z[z.Color=19]="Color",z[z.File=20]="File",z[z.Reference=21]="Reference",z[z.Customcolor=22]="Customcolor",z[z.Folder=23]="Folder",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue",z[z.Snippet=27]="Snippet"})(P||(e.CompletionItemKind=P={}));var b;(function(z){const Q=new Map;Q.set(0,o.$Hj.symbolMethod),Q.set(1,o.$Hj.symbolFunction),Q.set(2,o.$Hj.symbolConstructor),Q.set(3,o.$Hj.symbolField),Q.set(4,o.$Hj.symbolVariable),Q.set(5,o.$Hj.symbolClass),Q.set(6,o.$Hj.symbolStruct),Q.set(7,o.$Hj.symbolInterface),Q.set(8,o.$Hj.symbolModule),Q.set(9,o.$Hj.symbolProperty),Q.set(10,o.$Hj.symbolEvent),Q.set(11,o.$Hj.symbolOperator),Q.set(12,o.$Hj.symbolUnit),Q.set(13,o.$Hj.symbolValue),Q.set(15,o.$Hj.symbolEnum),Q.set(14,o.$Hj.symbolConstant),Q.set(15,o.$Hj.symbolEnum),Q.set(16,o.$Hj.symbolEnumMember),Q.set(17,o.$Hj.symbolKeyword),Q.set(27,o.$Hj.symbolSnippet),Q.set(18,o.$Hj.symbolText),Q.set(19,o.$Hj.symbolColor),Q.set(20,o.$Hj.symbolFile),Q.set(21,o.$Hj.symbolReference),Q.set(22,o.$Hj.symbolCustomColor),Q.set(23,o.$Hj.symbolFolder),Q.set(24,o.$Hj.symbolTypeParameter),Q.set(25,o.$Hj.account),Q.set(26,o.$Hj.issues);function Z(ce){let te=Q.get(ce);return te||(console.info("No codicon found for CompletionItemKind "+ce),te=o.$Hj.symbolProperty),te}z.toIcon=Z;const J=new Map;J.set("method",0),J.set("function",1),J.set("constructor",2),J.set("field",3),J.set("variable",4),J.set("class",5),J.set("struct",6),J.set("interface",7),J.set("module",8),J.set("property",9),J.set("event",10),J.set("operator",11),J.set("unit",12),J.set("value",13),J.set("constant",14),J.set("enum",15),J.set("enum-member",16),J.set("enumMember",16),J.set("keyword",17),J.set("snippet",27),J.set("text",18),J.set("color",19),J.set("file",20),J.set("reference",21),J.set("customcolor",22),J.set("folder",23),J.set("type-parameter",24),J.set("typeParameter",24),J.set("account",25),J.set("issue",26);function x(ce,te){let pe=J.get(ce);return typeof pe>"u"&&!te&&(pe=9),pe}z.fromString=x})(b||(e.CompletionItemKinds=b={}));var C;(function(z){z[z.Deprecated=1]="Deprecated"})(C||(e.CompletionItemTag=C={}));var y;(function(z){z[z.None=0]="None",z[z.KeepWhitespace=1]="KeepWhitespace",z[z.InsertAsSnippet=4]="InsertAsSnippet"})(y||(e.CompletionItemInsertTextRule=y={}));var a;(function(z){z[z.Word=0]="Word",z[z.Line=1]="Line",z[z.Suggest=2]="Suggest"})(a||(e.PartialAcceptTriggerKind=a={}));var m;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m||(e.CompletionTriggerKind=m={}));var c;(function(z){z[z.Automatic=0]="Automatic",z[z.Explicit=1]="Explicit"})(c||(e.InlineCompletionTriggerKind=c={}));class i{constructor(Q,Z,J,x){this.range=Q,this.text=Z,this.completionKind=J,this.isSnippetText=x}equals(Q){return M.$dt.lift(this.range).equalsRange(Q.range)&&this.text===Q.text&&this.completionKind===Q.completionKind&&this.isSnippetText===Q.isSnippetText}}e.$3t=i;var n;(function(z){z[z.Invoke=1]="Invoke",z[z.Auto=2]="Auto"})(n||(e.CodeActionTriggerType=n={}));var r;(function(z){z[z.Automatic=0]="Automatic",z[z.PasteAs=1]="PasteAs"})(r||(e.DocumentPasteTriggerKind=r={}));var s;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(s||(e.SignatureHelpTriggerKind=s={}));var t;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(t||(e.DocumentHighlightKind=t={}));function f(z){return z&&R.URI.isUri(z.uri)&&M.$dt.isIRange(z.range)&&(M.$dt.isIRange(z.originSelectionRange)||M.$dt.isIRange(z.targetSelectionRange))}var d;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(d||(e.SymbolKind=d={})),e.$5t={17:(0,p.localize)(0,null),16:(0,p.localize)(1,null),4:(0,p.localize)(2,null),13:(0,p.localize)(3,null),8:(0,p.localize)(4,null),9:(0,p.localize)(5,null),21:(0,p.localize)(6,null),23:(0,p.localize)(7,null),7:(0,p.localize)(8,null),0:(0,p.localize)(9,null),11:(0,p.localize)(10,null),10:(0,p.localize)(11,null),19:(0,p.localize)(12,null),5:(0,p.localize)(13,null),1:(0,p.localize)(14,null),2:(0,p.localize)(15,null),20:(0,p.localize)(16,null),15:(0,p.localize)(17,null),18:(0,p.localize)(18,null),24:(0,p.localize)(19,null),3:(0,p.localize)(20,null),6:(0,p.localize)(21,null),14:(0,p.localize)(22,null),22:(0,p.localize)(23,null),25:(0,p.localize)(24,null),12:(0,p.localize)(25,null)};function u(z,Q){return(0,p.localize)(26,null,z,e.$5t[Q])}var h;(function(z){z[z.Deprecated=1]="Deprecated"})(h||(e.SymbolTag=h={}));var l;(function(z){const Q=new Map;Q.set(0,o.$Hj.symbolFile),Q.set(1,o.$Hj.symbolModule),Q.set(2,o.$Hj.symbolNamespace),Q.set(3,o.$Hj.symbolPackage),Q.set(4,o.$Hj.symbolClass),Q.set(5,o.$Hj.symbolMethod),Q.set(6,o.$Hj.symbolProperty),Q.set(7,o.$Hj.symbolField),Q.set(8,o.$Hj.symbolConstructor),Q.set(9,o.$Hj.symbolEnum),Q.set(10,o.$Hj.symbolInterface),Q.set(11,o.$Hj.symbolFunction),Q.set(12,o.$Hj.symbolVariable),Q.set(13,o.$Hj.symbolConstant),Q.set(14,o.$Hj.symbolString),Q.set(15,o.$Hj.symbolNumber),Q.set(16,o.$Hj.symbolBoolean),Q.set(17,o.$Hj.symbolArray),Q.set(18,o.$Hj.symbolObject),Q.set(19,o.$Hj.symbolKey),Q.set(20,o.$Hj.symbolNull),Q.set(21,o.$Hj.symbolEnumMember),Q.set(22,o.$Hj.symbolStruct),Q.set(23,o.$Hj.symbolEvent),Q.set(24,o.$Hj.symbolOperator),Q.set(25,o.$Hj.symbolTypeParameter);function Z(J){let x=Q.get(J);return x||(console.info("No codicon found for SymbolKind "+J),x=o.$Hj.symbolProperty),x}z.toIcon=Z})(l||(e.SymbolKinds=l={}));class g{static asEditOperation(Q){return I.$et.replace(M.$dt.lift(Q.range),Q.text)}}e.$7t=g;class E{static fromValue(Q){switch(Q){case"comment":return E.Comment;case"imports":return E.Imports;case"region":return E.Region}return new E(Q)}constructor(Q){this.value=Q}}e.$8t=E,E.Comment=new E("comment"),E.Imports=new E("imports"),E.Region=new E("region");var v;(function(z){z[z.AIGenerated=1]="AIGenerated"})(v||(e.NewSymbolNameTag=v={}));var S;(function(z){function Q(Z){return!Z||typeof Z!="object"?!1:typeof Z.id=="string"&&typeof Z.title=="string"}z.is=Q})(S||(e.Command=S={}));var k;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(k||(e.CommentThreadCollapsibleState=k={}));var D;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(D||(e.CommentThreadState=D={}));var F;(function(z){z[z.Current=0]="Current",z[z.Outdated=1]="Outdated"})(F||(e.CommentThreadApplicability=F={}));var W;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(W||(e.CommentMode=W={}));var B;(function(z){z[z.Published=0]="Published",z[z.Draft=1]="Draft"})(B||(e.CommentState=B={}));var j;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(j||(e.InlayHintKind=j={}));class N{constructor(Q){this.b=Q,this.a=null}dispose(){this.a&&this.a.then(Q=>{Q&&Q.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$9t=N,e.$0t=new L.$Ot;var T;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(T||(e.ExternalUriOpenerPriority=T={}));var O;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(O||(e.InlineEditTriggerKind=O={}))}),define(Ee[203],Ce([9,10]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[204],Ce([9,10]),function(re,e){return re.create("vs/platform/contextkey/common/contextkey",e)}),define(Ee[205],Ce([9,10]),function(re,e){return re.create("vs/platform/contextkey/common/scanner",e)}),define(Ee[206],Ce([9,10]),function(re,e){return re.create("vs/platform/dialogs/common/dialogs",e)}),define(Ee[207],Ce([9,10]),function(re,e){return re.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ee[208],Ce([9,10]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[209],Ce([9,10]),function(re,e){return re.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ee[210],Ce([9,10]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(Ee[211],Ce([9,10]),function(re,e){return re.create("vs/platform/files/common/io",e)}),define(Ee[212],Ce([9,10]),function(re,e){return re.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ee[213],Ce([9,10]),function(re,e){return re.create("vs/platform/log/common/log",e)}),define(Ee[214],Ce([9,10]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(Ee[215],Ce([9,10]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(Ee[216],Ce([9,10]),function(re,e){return re.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ee[217],Ce([9,10]),function(re,e){return re.create("vs/platform/workspace/common/workspace",e)}),define(Ee[218],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ee[219],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[220],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[221],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ee[222],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ee[223],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostLogService",e)}),define(Ee[224],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ee[225],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[226],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ee[227],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[228],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[229],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ee[230],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[231],Ce([9,10]),function(re,e){return re.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ee[232],Ce([9,10]),function(re,e){return re.create("vs/workbench/common/configuration",e)}),define(Ee[233],Ce([9,10]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(Ee[234],Ce([9,10]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(Ee[235],Ce([9,10]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[236],Ce([9,10]),function(re,e){return re.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ee[237],Ce([9,10]),function(re,e){return re.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ee[238],Ce([9,10]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ee[239],Ce([9,10]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ee[240],Ce([9,10]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[241],Ce([9,10]),function(re,e){return re.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ee[242],Ce([9,10]),function(re,e){return re.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ee[243],Ce([9,10]),function(re,e){return re.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Ee[244],Ce([9,10]),function(re,e){return re.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ee[245],Ce([1,0,13,205]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dj=e.TokenType=void 0;var I;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(I||(e.TokenType=I={}));function M(...w){switch(w.length){case 1:return(0,R.localize)(0,null,w[0]);case 2:return(0,R.localize)(1,null,w[0],w[1]);case 3:return(0,R.localize)(2,null,w[0],w[1],w[2]);default:return}}const L=(0,R.localize)(3,null),p=(0,R.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,o.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const P=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:P})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const P=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:P})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const P=this.d,b=this.c.substring(this.d,this.e),C={type:19,offset:this.d,lexeme:b};this.g.push({offset:P,lexeme:b,additionalInfo:A}),this.f.push(C)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const P=this.c.substring(this.d,this.e),b=$.b.get(P);b?this.k(b):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,P=!1,b=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(p);return}const y=this.c.charCodeAt(A);if(P)P=!1;else if(y===47&&!b){A++;break}else y===91?b=!0:y===92?P=!0:y===93&&(b=!1);A++}for(;A<this.c.length&&$.a.has(this.c.charCodeAt(A));)A++;this.e=A;const C=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:C,offset:this.d})}r(){return this.e>=this.c.length}}e.$dj=$,$.a=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0))),$.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Ee[246],Ce([1,0,23,41,208,395]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=$,e.$up=w,e.$vp=A,e.$wp=P,e.$xp=b,e.$yp=C,e.$zp=y;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function $(c){return c=c.trim(),c==="*"||L.test(c)}function w(c){if(!$(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=c.match(L);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function A(c){if(!c)return null;const i=c.majorBase,n=c.majorMustEqual,r=c.minorBase;let s=c.minorMustEqual;const t=c.patchBase;let f=c.patchMustEqual;c.hasCaret&&(i===0||(s=!1),f=!1);let d=0;if(c.preRelease){const u=p.exec(c.preRelease);if(u){const[,h,l,g]=u;d=Date.UTC(Number(h),Number(l)-1,Number(g))}}return{majorBase:i,majorMustEqual:n,minorBase:r,minorMustEqual:s,patchBase:t,patchMustEqual:f,isMinimum:c.hasGreaterEquals,notBefore:d}}function P(c,i,n){let r;typeof c=="string"?r=A(w(c)):r=c;let s;i instanceof Date?s=i.getTime():typeof i=="string"&&(s=new Date(i).getTime());let t;if(typeof n=="string"?t=A(w(n)):t=n,!r||!t)return!1;const f=r.majorBase,d=r.minorBase,u=r.patchBase;let h=t.majorBase,l=t.minorBase,g=t.patchBase;const E=t.notBefore;let v=t.majorMustEqual,S=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?f>h?!0:f<h?!1:d>l?!0:d<l||s&&s<E?!1:u>=g:(f===1&&h===0&&(!v||!S||!k)&&(h=1,l=0,g=0,v=!0,S=!1,k=!1),f<h?!1:f>h?!v:d<l?!1:d>l?!S:u<g?!1:u>g?!k:!(s&&s<E))}function b(c,i,n,r,s){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([R.default.Error,I.localize(0,null)]),t;if(typeof r.name!="string")return t.push([R.default.Error,I.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([R.default.Error,I.localize(2,null,"version")]),t;if(!r.engines)return t.push([R.default.Error,I.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([R.default.Error,I.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!m(r.extensionDependencies))return t.push([R.default.Error,I.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!m(r.activationEvents))return t.push([R.default.Error,I.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([R.default.Error,I.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([R.default.Warning,I.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([R.default.Error,I.localize(9,null,"main")]),t;{const u=(0,o.$Vg)(n,r.main);(0,o.$Pg)(u,n)||t.push([R.default.Warning,I.localize(10,null,u.path,n.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([R.default.Error,I.localize(11,null,"browser")]),t;{const u=(0,o.$Vg)(n,r.browser);(0,o.$Pg)(u,n)||t.push([R.default.Warning,I.localize(12,null,u.path,n.path)])}}if(!M.valid(r.version))return t.push([R.default.Error,I.localize(13,null)]),t;const f=[];if(!C(c,i,r,s,f))for(const u of f)t.push([R.default.Error,u]);return t}function C(c,i,n,r,s){return r||typeof n.main>"u"&&typeof n.browser>"u"?!0:a(c,i,n.engines.vscode,s)}function y(c,i,n){return c==="*"||a(i,n,c)}function a(c,i,n,r=[]){const s=A(w(n));if(!s)return r.push(I.localize(14,null,n)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return r.push(I.localize(15,null,n)),!1}else if(!s.majorMustEqual)return r.push(I.localize(16,null,n)),!1;return P(c,i,s)?!0:(r.push(I.localize(17,null,c,n)),!1)}function m(c){if(!Array.isArray(c))return!1;for(let i=0,n=c.length;i<n;i++)if(typeof c[i]!="string")return!1;return!0}}),define(Ee[106],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class o{constructor(I,M=[],L=!1){this.ctor=I,this.staticArguments=M,this.supportsDelayedInstantiation=L}}e.$fi=o}),define(Ee[84],Ce([1,0,106]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$hs=M,e.$is=L;const R=[];var I;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function M(p,$,w){$ instanceof o.$fi||($=new o.$fi($,[],!!w)),R.push([p,$])}function L(){return R}}),define(Ee[247],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=e.$Xq=void 0;class o{constructor(M,L){this.key=M,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$Xq=o;class R{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const L of this.a.values())L.outgoing.size===0&&M.push(L);return M}insertEdge(M,L){const p=this.lookupOrInsertNode(M),$=this.lookupOrInsertNode(L);p.outgoing.set($.key,$),$.incoming.set(p.key,p)}removeNode(M){const L=this.b(M);this.a.delete(L);for(const p of this.a.values())p.outgoing.delete(L),p.incoming.delete(L)}lookupOrInsertNode(M){const L=this.b(M);let p=this.a.get(L);return p||(p=new o(L,M),this.a.set(L,p)),p}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[L,p]of this.a)M.push(`${L}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,L]of this.a){const p=new Set([M]),$=this.c(L,p);if($)return $}}c(M,L){for(const[p,$]of M.outgoing){if(L.has(p))return[...L,p].join(" -> ");L.add(p);const w=this.c($,L);if(w)return w;L.delete(p)}}}e.$Yq=R}),define(Ee[5],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e._util=void 0,e.$ii=I,e.$ji=M;var o;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function p($){return $[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=p})(o||(e._util=o={})),e.$hi=I("instantiationService");function R(L,p,$){p[o.DI_TARGET]===p?p[o.DI_DEPENDENCIES].push({id:L,index:$}):(p[o.DI_DEPENDENCIES]=[{id:L,index:$}],p[o.DI_TARGET]=p)}function I(L){if(o.serviceIds.has(L))return o.serviceIds.get(L);const p=function($,w,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(p,$,A)};return p.toString=()=>L,o.serviceIds.set(L,p),p}function M(L){return L}}),define(Ee[53],Ce([1,0,18,2,5]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Oi=void 0,e.$Pi=M,e.$Qi=L,e.$Ri=$,e.$Si=w,e.$Ti=A,e.$Ui=P,e.$Vi=b,e.$Wi=y,e.$Xi=a,e.$Yi=m,e.$Oi=(0,I.$ii)("configurationService");function M(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof R.URI)}function L(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof R.URI)}var p;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function $(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function w(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function A(c,i){const n=Object.create(null);for(const r in c)P(n,r,c[r],i);return n}function P(c,i,n,r){const s=i.split("."),t=s.pop();let f=c;for(let d=0;d<s.length;d++){const u=s[d];let h=f[u];switch(typeof h){case"undefined":h=f[u]=Object.create(null);break;case"object":break;default:r(`Ignoring ${i} as ${s.slice(0,d+1).join(".")} is ${JSON.stringify(h)}`);return}f=h}if(typeof f=="object"&&f!==null)try{f[t]=n}catch{r(`Ignoring ${i} as ${s.join(".")} is ${JSON.stringify(f)}`)}else r(`Ignoring ${i} as ${s.join(".")} is ${JSON.stringify(f)}`)}function b(c,i){const n=i.split(".");C(c,n)}function C(c,i){const n=i.shift();if(i.length===0){delete c[n];return}if(Object.keys(c).indexOf(n)!==-1){const r=c[n];typeof r=="object"&&!Array.isArray(r)&&(C(r,i),Object.keys(r).length===0&&delete c[n])}}function y(c,i,n){function r(f,d){let u=f;for(const h of d){if(typeof u!="object"||u===null)return;u=u[h]}return u}const s=i.split("."),t=r(c,s);return typeof t>"u"?n:t}function a(c,i,n){Object.keys(i).forEach(r=>{r!=="__proto__"&&(r in c?o.$Xf(c[r])&&o.$Xf(i[r])?a(c[r],i[r],n):n&&(c[r]=i[r]):c[r]=i[r])})}function m(c){return c.replace(/[\[\]]/g,"")}}),define(Ee[42],Ce([1,0,11,14,245,5,204,13]),function(re,e,o,R,I,M,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$gj=e.$fj=e.ContextKeyExprType=void 0,e.$ej=w,e.$hj=f,e.$ij=d,e.$Bj=te;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",o.$d),$.set("isLinux",o.$e),$.set("isWindows",o.$c),$.set("isWeb",o.$i),$.set("isMacNative",o.$d&&!o.$i),$.set("isEdge",o.$B),$.set("isFirefox",o.$z),$.set("isChrome",o.$y),$.set("isSafari",o.$A);function w(_,U){if($.get(_)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(_,U)}const A=Object.prototype.hasOwnProperty;var P;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const b={regexParsingWithErrorRecovery:!0},C=(0,L.localize)(0,null),y=(0,L.localize)(1,null),a=(0,L.localize)(2,null),m=(0,L.localize)(3,null),c=(0,L.localize)(4,null),i=(0,L.localize)(5,null),n=(0,L.localize)(6,null),r=(0,L.localize)(7,null);class s{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=b){this.k=U,this.d=new I.$dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:C,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const he=this.l();if(!this.E()){const Se=this.D(),me=Se.type===17?i:void 0;throw this.h.push({message:c,offset:Se.offset,lexeme:I.$dj.getLexeme(Se),additionalInfo:me}),s.c}return he}catch(he){if(he!==s.c)throw he;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const he=this.o();U.push(he)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const he=this.s();U.push(he)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),h.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const he=this.l();return this.A(1,m),he?.negate()}case 17:return this.z(),D.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const he=this.l();return this.A(1,m),he}case 17:{const he=U.lexeme;if(this.z(),this.y(9)){const me=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),me.type!==10)throw this.B("REGEX",me);const ie=me.lexeme,se=ie.lastIndexOf("/"),oe=se===ie.length-1?void 0:this.w(ie.substring(se+1));let G;try{G=new RegExp(ie.substring(1,se),oe)}catch{throw this.B("REGEX",me)}return T.create(he,G)}switch(me.type){case 10:case 19:{const ie=[me.lexeme];this.z();let se=this.D(),oe=0;for(let Me=0;Me<me.lexeme.length;Me++)me.lexeme.charCodeAt(Me)===40?oe++:me.lexeme.charCodeAt(Me)===41&&oe--;for(;!this.E()&&se.type!==15&&se.type!==16;){switch(se.type){case 0:oe++;break;case 1:oe--;break;case 10:case 18:for(let Me=0;Me<se.lexeme.length;Me++)se.lexeme.charCodeAt(Me)===40?oe++:me.lexeme.charCodeAt(Me)===41&&oe--}if(oe<0)break;ie.push(I.$dj.getLexeme(se)),this.z(),se=this.D()}const G=ie.join(""),ee=G.lastIndexOf("/"),le=ee===G.length-1?void 0:this.w(G.substring(ee+1));let de;try{de=new RegExp(G.substring(1,ee),le)}catch{throw this.B("REGEX",me)}return t.regex(he,de)}case 18:{const ie=me.lexeme;this.z();let se=null;if(!(0,R.$Ue)(ie)){const oe=ie.indexOf("/"),G=ie.lastIndexOf("/");if(oe!==G&&oe>=0){const ee=ie.slice(oe+1,G),le=ie[G+1]==="i"?"i":"";try{se=new RegExp(ee,le)}catch{throw this.B("REGEX",me)}}}if(se===null)throw this.B("REGEX",me);return T.create(he,se)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,a);const me=this.u();return t.notIn(he,me)}switch(this.D().type){case 3:{this.z();const me=this.u();if(this.x().type===18)return t.equals(he,me);switch(me){case"true":return t.has(he);case"false":return t.not(he);default:return t.equals(he,me)}}case 4:{this.z();const me=this.u();if(this.x().type===18)return t.notEquals(he,me);switch(me){case"true":return t.not(he);case"false":return t.has(he);default:return t.notEquals(he,me)}}case 5:return this.z(),j.create(he,this.u());case 6:return this.z(),N.create(he,this.u());case 7:return this.z(),W.create(he,this.u());case 8:return this.z(),B.create(he,this.u());case 13:return this.z(),t.in(he,this.u());default:return t.has(he)}}case 20:throw this.h.push({message:n,offset:U.offset,lexeme:"",additionalInfo:r}),s.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,he){if(this.C(U))return this.z();throw this.B(he,this.D())}B(U,he,Se){const me=(0,L.localize)(8,null,U,I.$dj.getLexeme(he)),ie=he.offset,se=I.$dj.getLexeme(he);return this.h.push({message:me,offset:ie,lexeme:se,additionalInfo:Se}),s.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$fj=s,s.c=new Error;class t{static false(){return h.INSTANCE}static true(){return l.INSTANCE}static has(U){return g.create(U)}static equals(U,he){return E.create(U,he)}static notEquals(U,he){return k.create(U,he)}static regex(U,he){return T.create(U,he)}static in(U,he){return v.create(U,he)}static notIn(U,he){return S.create(U,he)}static not(U){return D.create(U)}static and(...U){return Q.create(U,null,!0)}static or(...U){return Z.create(U,null,!0)}static greater(U,he){return W.create(U,he)}static greaterEquals(U,he){return B.create(U,he)}static smaller(U,he){return j.create(U,he)}static smallerEquals(U,he){return N.create(U,he)}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$gj=t,t.c=new s({regexParsingWithErrorRecovery:!1});function f(_){const U=new s({regexParsingWithErrorRecovery:!1});return _.map(he=>(U.parse(he),U.lexingErrors.length>0?U.lexingErrors.map(Se=>({errorMessage:Se.additionalInfo?(0,L.localize)(9,null,Se.additionalInfo):(0,L.localize)(10,null),offset:Se.offset,length:Se.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(Se=>({errorMessage:Se.additionalInfo?`${Se.message}. ${Se.additionalInfo}`:Se.message,offset:Se.offset,length:Se.lexeme.length})):[]))}function d(_,U){const he=_?_.substituteConstants():void 0,Se=U?U.substituteConstants():void 0;return!he&&!Se?!0:!he||!Se?!1:he.equals(Se)}function u(_,U){return _.cmp(U)}class h{constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return l.INSTANCE}}e.$jj=h,h.INSTANCE=new h;class l{constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return h.INSTANCE}}e.$kj=l,l.INSTANCE=new l;class g{static create(U,he=null){const Se=$.get(U);return typeof Se=="boolean"?Se?l.INSTANCE:h.INSTANCE:new g(U,he)}constructor(U,he){this.key=U,this.c=he,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:x(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=$.get(this.key);return typeof U=="boolean"?U?l.INSTANCE:h.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=D.create(this.key,this)),this.c}}e.$lj=g;class E{static create(U,he,Se=null){if(typeof he=="boolean")return he?g.create(U,Se):D.create(U,Se);const me=$.get(U);return typeof me=="boolean"?he===(me?"true":"false")?l.INSTANCE:h.INSTANCE:new E(U,he,Se)}constructor(U,he,Se){this.c=U,this.d=he,this.f=Se,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const he=U?"true":"false";return this.d===he?l.INSTANCE:h.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$mj=E;class v{static create(U,he){return new v(U,he)}constructor(U,he){this.d=U,this.f=he,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const he=U.getValue(this.f),Se=U.getValue(this.d);return Array.isArray(he)?he.includes(Se):typeof Se=="string"&&typeof he=="object"&&he!==null?A.call(he,Se):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$nj=v;class S{static create(U,he){return new S(U,he)}constructor(U,he){this.d=U,this.f=he,this.type=11,this.c=v.create(U,he)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$oj=S;class k{static create(U,he,Se=null){if(typeof he=="boolean")return he?D.create(U,Se):g.create(U,Se);const me=$.get(U);return typeof me=="boolean"?he===(me?"true":"false")?h.INSTANCE:l.INSTANCE:new k(U,he,Se)}constructor(U,he,Se){this.c=U,this.d=he,this.f=Se,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const he=U?"true":"false";return this.d===he?h.INSTANCE:l.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$pj=k;class D{static create(U,he=null){const Se=$.get(U);return typeof Se=="boolean"?Se?h.INSTANCE:l.INSTANCE:new D(U,he)}constructor(U,he){this.c=U,this.d=he,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=$.get(this.c);return typeof U=="boolean"?U?h.INSTANCE:l.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=g.create(this.c,this)),this.d}}e.$qj=D;function F(_,U){if(typeof _=="string"){const he=parseFloat(_);isNaN(he)||(_=he)}return typeof _=="string"||typeof _=="number"?U(_):h.INSTANCE}class W{static create(U,he,Se=null){return F(he,me=>new W(U,me,Se))}constructor(U,he,Se){this.c=U,this.d=he,this.f=Se,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$rj=W;class B{static create(U,he,Se=null){return F(he,me=>new B(U,me,Se))}constructor(U,he,Se){this.c=U,this.d=he,this.f=Se,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$sj=B;class j{static create(U,he,Se=null){return F(he,me=>new j(U,me,Se))}constructor(U,he,Se){this.c=U,this.d=he,this.f=Se,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$tj=j;class N{static create(U,he,Se=null){return F(he,me=>new N(U,me,Se))}constructor(U,he,Se){this.c=U,this.d=he,this.f=Se,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$uj=N;class T{static create(U,he){return new T(U,he)}constructor(U,he){this.d=U,this.f=he,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const he=this.f?this.f.source:"",Se=U.f?U.f.source:"";return he<Se?-1:he>Se?1:0}equals(U){if(U.type===this.type){const he=this.f?this.f.source:"",Se=U.f?U.f.source:"";return this.d===U.d&&he===Se}return!1}substituteConstants(){return this}evaluate(U){const he=U.getValue(this.d);return this.f?this.f.test(he):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=O.create(this)),this.c}}e.$vj=T;class O{static create(U){return new O(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new O(this.c.map(U))}negate(){return this.c}}e.$wj=O;function z(_){let U=null;for(let he=0,Se=_.length;he<Se;he++){const me=_[he].substituteConstants();if(_[he]!==me&&U===null){U=[];for(let ie=0;ie<he;ie++)U[ie]=_[ie]}U!==null&&(U[he]=me)}return U===null?_:U}class Q{static create(U,he,Se){return Q.d(U,he,Se)}constructor(U,he){this.expr=U,this.c=he,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let he=0,Se=this.expr.length;he<Se;he++){const me=u(this.expr[he],U.expr[he]);if(me!==0)return me}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let he=0,Se=this.expr.length;he<Se;he++)if(!this.expr[he].equals(U.expr[he]))return!1;return!0}return!1}substituteConstants(){const U=z(this.expr);return U===this.expr?this:Q.create(U,this.c,!1)}evaluate(U){for(let he=0,Se=this.expr.length;he<Se;he++)if(!this.expr[he].evaluate(U))return!1;return!0}static d(U,he,Se){const me=[];let ie=!1;for(const se of U)if(se){if(se.type===1){ie=!0;continue}if(se.type===0)return h.INSTANCE;if(se.type===6){me.push(...se.expr);continue}me.push(se)}if(me.length===0&&ie)return l.INSTANCE;if(me.length!==0){if(me.length===1)return me[0];me.sort(u);for(let se=1;se<me.length;se++)me[se-1].equals(me[se])&&(me.splice(se,1),se--);if(me.length===1)return me[0];for(;me.length>1;){const se=me[me.length-1];if(se.type!==9)break;me.pop();const oe=me.pop(),G=me.length===0,ee=Z.create(se.expr.map(le=>Q.create([le,oe],null,Se)),null,G);ee&&(me.push(ee),me.sort(u))}if(me.length===1)return me[0];if(Se){for(let se=0;se<me.length;se++)for(let oe=se+1;oe<me.length;oe++)if(me[se].negate().equals(me[oe]))return h.INSTANCE;if(me.length===1)return me[0]}return new Q(me,he)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const he of this.expr)U.push(...he.keys());return U}map(U){return new Q(this.expr.map(he=>he.map(U)),null)}negate(){if(!this.c){const U=[];for(const he of this.expr)U.push(he.negate());this.c=Z.create(U,this,!0)}return this.c}}e.$xj=Q;class Z{static create(U,he,Se){return Z.d(U,he,Se)}constructor(U,he){this.expr=U,this.c=he,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let he=0,Se=this.expr.length;he<Se;he++){const me=u(this.expr[he],U.expr[he]);if(me!==0)return me}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let he=0,Se=this.expr.length;he<Se;he++)if(!this.expr[he].equals(U.expr[he]))return!1;return!0}return!1}substituteConstants(){const U=z(this.expr);return U===this.expr?this:Z.create(U,this.c,!1)}evaluate(U){for(let he=0,Se=this.expr.length;he<Se;he++)if(this.expr[he].evaluate(U))return!0;return!1}static d(U,he,Se){let me=[],ie=!1;if(U){for(let se=0,oe=U.length;se<oe;se++){const G=U[se];if(G){if(G.type===0){ie=!0;continue}if(G.type===1)return l.INSTANCE;if(G.type===9){me=me.concat(G.expr);continue}me.push(G)}}if(me.length===0&&ie)return h.INSTANCE;me.sort(u)}if(me.length!==0){if(me.length===1)return me[0];for(let se=1;se<me.length;se++)me[se-1].equals(me[se])&&(me.splice(se,1),se--);if(me.length===1)return me[0];if(Se){for(let se=0;se<me.length;se++)for(let oe=se+1;oe<me.length;oe++)if(me[se].negate().equals(me[oe]))return l.INSTANCE;if(me.length===1)return me[0]}return new Z(me,he)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const he of this.expr)U.push(...he.keys());return U}map(U){return new Z(this.expr.map(he=>he.map(U)),null)}negate(){if(!this.c){const U=[];for(const he of this.expr)U.push(he.negate());for(;U.length>1;){const he=U.shift(),Se=U.shift(),me=[];for(const ie of ye(he))for(const se of ye(Se))me.push(Q.create([ie,se],null,!1));U.unshift(Z.create(me,null,!1))}this.c=Z.create(U,this,!0)}return this.c}}e.$yj=Z;class J extends g{static all(){return J.d.values()}constructor(U,he,Se){super(U,null),this.f=he,typeof Se=="object"?J.d.push({...Se,key:U}):Se!==!0&&J.d.push({key:U,description:Se,type:he!=null?typeof he:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return E.create(this.key,U)}notEqualsTo(U){return k.create(this.key,U)}}e.$zj=J,J.d=[],e.$Aj=(0,M.$ii)("contextKeyService");function x(_,U){return _<U?-1:_>U?1:0}function ce(_,U,he,Se){return _<he?-1:_>he?1:U<Se?-1:U>Se?1:0}function te(_,U){if(_.type===0||U.type===1)return!0;if(_.type===9)return U.type===9?pe(_.expr,U.expr):!1;if(U.type===9){for(const he of U.expr)if(te(_,he))return!0;return!1}if(_.type===6){if(U.type===6)return pe(U.expr,_.expr);for(const he of _.expr)if(te(he,U))return!0;return!1}return _.equals(U)}function pe(_,U){let he=0,Se=0;for(;he<_.length&&Se<U.length;){const me=_[he].cmp(U[Se]);if(me<0)return!1;me===0&&he++,Se++}return he===_.length}function ye(_){return _.type===9?_.expr:[_]}}),define(Ee[248],Ce([1,0,23,41,206,5,102,11,24]),function(re,e,o,R,I,M,L,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$tw=e.$sw=e.$rw=void 0,e.$uw=C,e.$vw=y,e.$rw=(0,M.$ii)("dialogService");var w;(function(a){a[a.Confirmation=1]="Confirmation",a[a.Prompt=2]="Prompt",a[a.Input=3]="Input"})(w||(w={}));class A{a(m){return this.d(m,w.Confirmation)}b(m){return this.d(m,w.Prompt)}c(m){return this.d(m,w.Input)}d(m,c){const i=[];switch(c){case w.Confirmation:{const n=m;n.primaryButton?i.push(n.primaryButton):i.push((0,I.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,I.localize)(1,null));break}case w.Prompt:{const n=m;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(r=>r.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,I.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,I.localize)(3,null))),i.length===0&&i.push((0,I.localize)(4,null));break}case w.Input:{const n=m;n.primaryButton?i.push(n.primaryButton):i.push((0,I.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,I.localize)(6,null));break}}return i}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===R.default.Info?"info":m===R.default.Error?"error":m===R.default.Warning?"warning":"none"}f(m,c,i){const n=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&n.push(m.cancelButton);let r=n[c]?.run({checkboxChecked:i});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:i}}}e.$sw=A,e.$tw=(0,M.$ii)("fileDialogService");var P;(function(a){a[a.SAVE=0]="SAVE",a[a.DONT_SAVE=1]="DONT_SAVE",a[a.CANCEL=2]="CANCEL"})(P||(e.ConfirmResult=P={}));const b=10;function C(a){const m=[];return m.push(...a.slice(0,b).map(c=>typeof c=="string"?c:(0,o.$Sg)(c))),a.length>b&&(a.length-b===1?m.push((0,I.localize)(7,null)):m.push((0,I.localize)(8,null,a.length-b))),m.push(""),m.join(`
`)}function y(a,m){const c=(0,$.$Pn)(a);let i=(c.buttons??[]).map(t=>(0,L.$ow)(t)),n=(a.buttons||[]).map((t,f)=>f),r=0,s=c.cancelId??i.length-1;if(i.length>1){const t=typeof s=="number"?i[s]:void 0;if(p.$e||p.$d){if(typeof t=="string"&&i.length>1&&s!==1){i.splice(s,1),i.splice(1,0,t);const f=n[s];n.splice(s,1),n.splice(1,0,f),s=1}p.$e&&i.length>1&&(i=i.reverse(),n=n.reverse(),r=i.length-1,typeof t=="string"&&(s=r-1))}else if(p.$c&&typeof t=="string"&&i.length>1&&s!==i.length-1){i.splice(s,1),i.push(t);const f=n[s];n.splice(s,1),n.push(f),s=i.length-1}}return c.buttons=i,c.defaultId=r,c.cancelId=s,c.noLink=!0,c.title=c.title||m.nameLong,{options:c,buttonIndeces:n}}}),define(Ee[137],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=void 0,e.$pi=(0,o.$ii)("environmentService"),e.$qi=(0,o.$ji)(e.$pi)}),define(Ee[138],Ce([1,0,207,5]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.ExtensionGalleryErrorCode=e.$To=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$So=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=void 0,e.$Mo=I,e.$No=M,e.$Oo=L,e.$Po=p,e.$Qo=$,e.$Ro=w,e.$Go="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Ho=new RegExp(e.$Go),e.$Io="__web_extension",e.$Jo="skipWalkthrough",e.$Ko="extensionsSync",e.$Lo="dependecyOrPackExtensionInstall";function I(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function M(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function L(n,r){switch(n){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function p(n,r){return r==="web"&&!n.includes("web")}function $(n,r,s){return p(r,s)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===s}function w(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var A;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var P;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(P||(e.SortOrder=P={}));var b;(function(n){n.Install="install",n.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var C;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(C||(e.InstallOperation=C={})),e.$So=(0,R.$ii)("extensionGalleryService");var y;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Unknown="Unknown",n.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var a;(function(n){n.UnknownError="UnknownError",n.PackageIsInvalidZip="PackageIsInvalidZip",n.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(a||(e.ExtensionSignaturetErrorCode=a={}));class m extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.$To=m;var c;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(c||(e.ExtensionGalleryErrorCode=c={}));class i extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.$Uo=i,e.$Vo=(0,R.$ii)("extensionManagementService"),e.$Wo="extensionsIdentifiers/disabled",e.$Xo="extensionsIdentifiers/enabled",e.$Yo=(0,R.$ii)("IGlobalExtensionEnablementService"),e.$Zo=(0,R.$ii)("IExtensionTipsService"),e.$1o=(0,o.localize2)(0,"Extensions"),e.$2o=(0,o.localize2)(1,"Preferences")}),define(Ee[249],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$05b=e.$95b=void 0,e.$95b=(0,o.$ii)("externalTerminal"),e.$05b="Terminal.app"}),define(Ee[250],Ce([1,0,51,54,15,17,11,99,31,104,209,249]),function(re,e,o,R,I,M,L,p,$,w,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ac=e.$$ac=e.$0ac=void 0;const b=A.localize(0,null);class C{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends C{openTerminal(s,t){return this.spawnTerminal(o,s,w.$bm(),t)}spawnTerminal(s,t,f,d){const u=t.windowsExec||y.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const h=M.$oc(u,".exe").toLowerCase();if(h==="cmder")return s.spawn(u,d?[d]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return u.indexOf(" ")>=0&&l.push('""'),l.push(u),h==="wt"&&l.push("-d ."),new Promise((g,E)=>{const v=c(process),S=s.spawn(f,l,{cwd:d,env:v,detached:!0});S.on("error",E),S.on("exit",()=>g())})}async runInTerminal(s,t,f,d,u){const h="windowsExec"in u&&u.windowsExec?u.windowsExec:y.getDefaultTerminalWindows(),l=await y.f();return new Promise((g,E)=>{const v=`"${t} - ${b}"`,S=`"${f.join('" "')}" & pause`,k=Object.assign({},c(process),d);Object.keys(k).filter(j=>k[j]===null).forEach(j=>delete k[j]);const D={cwd:t,env:k,windowsVerbatimArguments:!0};let F,W;M.$oc(h,".exe")==="wt"?(F=h,W=["-d",".",y.b,"/c",S]):l?(F=l,W=["-d",".",h,"/c",S]):(F=y.b,W=["/c","start",v,"/wait",h,"/c",`"${S}"`]),o.spawn(F,W,D).on("error",j=>{E(i(j))}),g(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return y.d}static async f(){try{const s=await w.win32.findExecutable("wt");return await $.Promises.exists(s)?s:void 0}catch{return}}}e.$0ac=y,y.b="cmd.exe",Qe([R.$Mh],y,"f",null);class a extends C{openTerminal(s,t){return this.spawnTerminal(o,s,t)}runInTerminal(s,t,f,d,u){const h=u.osxExec||P.$05b;return new Promise((l,g)=>{if(h===P.$05b||h==="iTerm.app"){const E=h===P.$05b?"TerminalHelper":"iTermHelper",S=[I.$Cg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${E}.scpt`).fsPath,"-t",s||b,"-w",t];for(const F of f)S.push("-a"),S.push(F);if(d){const F=Object.assign({},c(process),d);for(const W in F){const B=F[W];B===null?(S.push("-u"),S.push(W)):(S.push("-e"),S.push(`${W}=${B}`))}}let k="";const D=o.spawn(a.b,S);D.on("error",F=>{g(i(F))}),D.stderr.on("data",F=>{k+=F.toString()}),D.on("exit",F=>{if(F===0)l(void 0);else if(k){const W=k.split(`
`,1);g(new Error(W[0]))}else g(new Error(A.localize(1,null,E,F)))})}else g(new Error(A.localize(2,null,h)))})}spawnTerminal(s,t,f){const d=t.osxExec||P.$05b;return new Promise((u,h)=>{const l=["-a",d];f&&l.push(f);const g=c(process),E=s.spawn("/usr/bin/open",l,{cwd:f,env:g});E.on("error",h),E.on("exit",()=>u())})}}e.$$ac=a,a.b="/usr/bin/osascript";class m extends C{openTerminal(s,t){return this.spawnTerminal(o,s,t)}runInTerminal(s,t,f,d,u){const h=u.linuxExec?Promise.resolve(u.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((l,g)=>{const E=[];h.then(v=>{v.indexOf("gnome-terminal")>=0?E.push("-x"):E.push("-e"),E.push("bash"),E.push("-c");const S=`${n(f)}; echo; read -p "${m.b}" -n1;`;E.push(`''${S}''`);const k=Object.assign({},c(process),d);Object.keys(k).filter(B=>k[B]===null).forEach(B=>delete k[B]);const D={cwd:t,env:k};let F="";const W=o.spawn(v,E,D);W.on("error",B=>{g(i(B))}),W.stderr.on("data",B=>{F+=B.toString()}),W.on("exit",B=>{if(B===0)l(void 0);else if(F){const j=F.split(`
`,1);g(new Error(j[0]))}else g(new Error(A.localize(4,null,v,B)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!L.$e)m.d=Promise.resolve("xterm");else{const s=await $.Promises.exists("/etc/debian_version");m.d=new Promise(t=>{s?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return m.d}spawnTerminal(s,t,f){const d=t.linuxExec?Promise.resolve(t.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((u,h)=>{d.then(l=>{const g=c(process),E=s.spawn(l,[],{cwd:f,env:g});E.on("error",h),E.on("exit",()=>u())})})}}e.$_ac=m,m.b=A.localize(3,null);function c(r){const s={...r.env};return(0,p.$_l)(s),s}function i(r){return"errno"in r&&r.errno==="ENOENT"&&"path"in r&&typeof r.path=="string"?new Error(A.localize(5,null,r.path)):r}function n(r){let s="";for(const t of r)t.indexOf(" ")>=0?s+='"'+t+'"':s+=t,s+=" ";return s}}),define(Ee[32],Ce([1,0,77,17,14,18,2,210,5,11,15,46]),function(re,e,o,R,I,M,L,p,$,w,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$hl=e.FileKind=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.FileOperationResult=e.$_k=e.$$k=e.$0k=e.$8k=e.FileChangeType=e.$7k=e.FileOperation=e.$1k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Ok=void 0,e.$Pk=b,e.$Qk=a,e.$Rk=c,e.$Sk=i,e.$Tk=n,e.$Uk=r,e.$Vk=s,e.$Wk=t,e.$Xk=f,e.$Yk=d,e.$Zk=u,e.$2k=g,e.$3k=E,e.$4k=v,e.$5k=S,e.$6k=k,e.$9k=j,e.$il=Z,e.$jl=J,e.$ll=ce,e.$Ok=(0,$.$ii)("fileService");function b(te){return te.create===!0}var C;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(C||(e.FileType=C={}));var y;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(y||(e.FilePermission=y={}));function a(te){const pe=te;return!!pe&&typeof pe.onDidChange=="function"}var m;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function c(te){return!!(te.capabilities&2)}function i(te){return!!(te.capabilities&8)}function n(te){return!!(te.capabilities&131072)}function r(te){return!!(te.capabilities&4)}function s(te){return!!(te.capabilities&16)}function t(te){return c(te)?!!(te.capabilities&16384):!1}function f(te){return c(te)?!!(te.capabilities&32768):!1}function d(te){return!!(te.capabilities&65536)}function u(te){return!!(te.capabilities&2048)}var h;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(h||(e.FileSystemProviderErrorCode=h={}));class l extends Error{static create(pe,ye){const _=new l(pe.toString(),ye);return v(_,ye),_}constructor(pe,ye){super(pe),this.code=ye}}e.$1k=l;function g(te,pe){return l.create(te,pe)}function E(te){return te||g((0,p.localize)(0,null),h.Unknown)}function v(te,pe){return te.name=pe?`${pe} (FileSystemError)`:"FileSystemError",te}function S(te){if(!te)return h.Unknown;if(te instanceof l)return te.code;const pe=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!pe)return h.Unknown;switch(pe[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileTooLarge:return h.FileTooLarge;case h.FileWriteLocked:return h.FileWriteLocked;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}function k(te){if(te instanceof N)return te.fileOperationResult;switch(S(te)){case h.FileNotFound:return 1;case h.FileIsADirectory:return 0;case h.FileNotADirectory:return 9;case h.FileWriteLocked:return 5;case h.NoPermissions:return 6;case h.FileExists:return 4;case h.FileTooLarge:return 7;default:return 10}}var D;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(D||(e.FileOperation=D={}));class F{constructor(pe,ye,_){this.resource=pe,this.operation=ye,this.target=_}isOperation(pe){return this.operation===pe}}e.$7k=F;var W;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(W||(e.FileChangeType=W={}));class B{constructor(pe,ye){this.c=ye,this.b=void 0,this.d=new P.$V(()=>{const _=o.$oi.forUris(()=>this.c);return _.fill(this.rawAdded.map(U=>[U,!0])),_}),this.f=new P.$V(()=>{const _=o.$oi.forUris(()=>this.c);return _.fill(this.rawUpdated.map(U=>[U,!0])),_}),this.g=new P.$V(()=>{const _=o.$oi.forUris(()=>this.c);return _.fill(this.rawDeleted.map(U=>[U,!0])),_}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const _ of pe){switch(_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}this.b!==B.a&&(typeof _.cId=="number"?this.b===void 0?this.b=_.cId:this.b!==_.cId&&(this.b=B.a):this.b!==void 0&&(this.b=B.a))}}contains(pe,...ye){return this.h(pe,{includeChildren:!1},...ye)}affects(pe,...ye){return this.h(pe,{includeChildren:!0},...ye)}h(pe,ye,..._){if(!pe)return!1;const U=_.length>0;return!!((!U||_.includes(1))&&(this.d.value.get(pe)||ye.includeChildren&&this.d.value.findSuperstr(pe))||(!U||_.includes(0))&&(this.f.value.get(pe)||ye.includeChildren&&this.f.value.findSuperstr(pe))||(!U||_.includes(2))&&(this.g.value.findSubstr(pe)||ye.includeChildren&&this.g.value.findSuperstr(pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(pe){return this.b===pe}hasCorrelation(){return typeof this.b=="number"}}e.$8k=B,B.a=null;function j(te,pe,ye){return!te||!pe||te===pe||pe.length>te.length?!1:(pe.charAt(pe.length-1)!==R.sep&&(pe+=R.sep),ye?(0,I.$mf)(te,pe):te.indexOf(pe)===0)}class N extends Error{constructor(pe,ye,_){super(pe),this.fileOperationResult=ye,this.options=_}}e.$0k=N;class T extends N{constructor(pe,ye,_,U){super(pe,ye,U),this.fileOperationResult=ye,this.size=_}}e.$$k=T;class O extends N{constructor(pe,ye,_){super(pe,2,_),this.stat=ye}}e.$_k=O;var z;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(z||(e.FileOperationResult=z={})),e.$al={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$bl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$cl="files.associations",e.$dl="files.exclude",e.$el="files.readonlyInclude",e.$fl="files.readonlyExclude",e.$gl="files.readonlyFromPermissions";var Q;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$hl="";function Z(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function J(te,pe){if(!pe.hasProvider(L.URI.from({scheme:te.scheme})))return new Promise(ye=>{const _=pe.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===te.scheme&&U.added&&(_.dispose(),ye())})})}class x{static formatSize(pe){return(0,M.$Zf)(pe)||(pe=0),pe<x.KB?(0,p.localize)(1,null,pe.toFixed(0)):pe<x.MB?(0,p.localize)(2,null,(pe/x.KB).toFixed(2)):pe<x.GB?(0,p.localize)(3,null,(pe/x.MB).toFixed(2)):pe<x.TB?(0,p.localize)(4,null,(pe/x.GB).toFixed(2)):(0,p.localize)(5,null,(pe/x.TB).toFixed(2))}}e.$kl=x,x.KB=1024,x.MB=x.KB*x.KB,x.GB=x.MB*x.KB,x.TB=x.GB*x.KB;function ce(te){const pe=typeof te=="string"||te?.scheme===A.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===A.Schemas.file?1024*x.MB:pe?10*x.MB:w.$i?50*x.MB:1024*x.MB}}),define(Ee[251],Ce([1,0,21,13,211,32]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=L;async function L(A,P,b,C,y,a){let m;try{await p(A,P,b,C,y,a)}catch(c){m=c}finally{m&&y.errorTransformer&&(m=y.errorTransformer(m)),typeof m<"u"&&b.error(m),b.end()}}async function p(A,P,b,C,y,a){$(a);const m=await A.open(P,{create:!1});try{$(a);let c=0,i=0,n=y&&typeof y.length=="number"?y.length:void 0,r=o.$ue.alloc(Math.min(y.bufferSize,typeof n=="number"?n:y.bufferSize)),s=y&&typeof y.position=="number"?y.position:0,t=0;do i=await A.read(m,s,r.buffer,t,r.byteLength-t),s+=i,t+=i,c+=i,typeof n=="number"&&(n-=i),t===r.byteLength&&(await b.write(C(r)),r=o.$ue.alloc(Math.min(y.bufferSize,typeof n=="number"?n:y.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&$(a)&&w(c,y));if(t>0){let f=t;typeof n=="number"&&(f=Math.min(t,n)),b.write(C(r.slice(0,f)))}}catch(c){throw(0,M.$3k)(c)}finally{await A.close(m)}}function $(A){if(A.isCancellationRequested)throw(0,R.$6)();return!0}function w(A,P){if(typeof P?.limits?.size=="number"&&A>P.limits.size)throw(0,M.$2k)((0,I.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ee[64],Ce([1,0,35,3,17,11,2,32]),function(re,e,o,R,I,M,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=e.$yq=void 0,e.$wq=$,e.$xq=w,e.$Bq=C,e.$Cq=y,e.$Dq=a,e.$Eq=m;function $(i){return typeof i.correlationId=="number"}function w(i){return i.recursive===!0}class A extends R.$Uc{constructor(n,r,s,t){super(),this.h=n,this.j=r,this.m=s,this.n=t,this.c=this.B(new R.$Vc),this.f=void 0,this.g=0}s(){const n=new R.$Tc;this.c.value=n,this.b=this.r(n),this.b.setVerboseLogging(this.m),n.add(this.b.onDidChangeFile(r=>this.h(r))),n.add(this.b.onDidLogMessage(r=>this.j(r))),n.add(this.b.onDidError(r=>this.t(r)))}t(n){this.n.restartOnError?this.g<A.a&&this.f?(this.w(`restarting watcher after error: ${n}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${n}`):this.w(n)}u(n){this.g++,this.s(),this.watch(n)}async watch(n){this.f=n,await this.b?.watch(n)}async setVerboseLogging(n){this.m=n,await this.b?.setVerboseLogging(n)}w(n){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${n}`})}y(n){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${n}`})}dispose(){return this.b=void 0,super.dispose()}}e.$yq=A,A.a=5;class P extends A{constructor(n,r,s){super(n,r,s,{type:"node.js",restartOnError:!1})}}e.$zq=P;class b extends A{constructor(n,r,s){super(n,r,s,{type:"universal",restartOnError:!0})}}e.$Aq=b;function C(i){return i.map(n=>({type:n.type,resource:L.URI.revive(n.resource),cId:n.cId}))}function y(i){const n=new c;for(const r of i)n.processEvent(r);return n.coalesce()}function a(i,n){return typeof n=="string"&&!n.startsWith(o.$$j)&&!(0,I.$jc)(n)?{base:i,pattern:n}:n}function m(i,n){const r=[];for(const s of n)r.push((0,o.$ck)(a(i,s)));return r}class c{constructor(){this.a=new Set,this.b=new Map}c(n){return M.$e?n.resource.fsPath:n.resource.fsPath.toLowerCase()}processEvent(n){const r=this.b.get(this.c(n));let s=!1;if(r){const t=r.type,f=n.type;r.resource.fsPath!==n.resource.fsPath&&(n.type===2||n.type===1)?s=!0:t===1&&f===2?(this.b.delete(this.c(n)),this.a.delete(r)):t===2&&f===1?r.type=0:t===1&&f===0||(r.type=f)}else s=!0;s&&(this.a.add(n),this.b.set(this.c(n),n))}coalesce(){const n=[],r=[];return Array.from(this.a).filter(s=>s.type!==2?(n.push(s),!1):!0).sort((s,t)=>s.resource.fsPath.length-t.resource.fsPath.length).filter(s=>r.some(t=>(0,p.$9k)(s.resource.fsPath,t,!M.$e))?!1:(r.push(s.resource.fsPath),!0)).concat(n)}}}),define(Ee[252],Ce([1,0,50,3,64,4,2]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0;class p extends R.$Uc{constructor(){super(),this.a=this.B(new M.$7d),this.onDidChangeFile=this.a.event,this.b=this.B(new M.$7d),this.onDidLogMessage=this.b.event,this.c=this.B(new M.$7d),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new R.$4c),this.m=5007,this.B(this.f(w=>this.n(w)))}n(w){this.r(w)&&this.t(w)}r(w){return(0,I.$wq)(w)}async watch(w){this.h.clear(),this.g.clear();for(const A of w)this.r(A)?this.h.set(A.correlationId,A):this.g.add(A);for(const[A]of this.j)this.h.has(A)||this.j.deleteAndDispose(A);return this.s()}s(){return this.D([...this.g,...Array.from(this.h.values()).filter(w=>!this.j.has(w.correlationId))])}t(w){if(this.j.has(w.correlationId))return;const A=new R.$Tc;this.j.set(w.correlationId,A),this.w(w,A),this.s()}u(w){this.j.deleteAndDispose(w.correlationId),this.s()}w(w,A){const P=L.URI.file(w.path),b=this;let C=!1;const y=(a,m)=>{if(A.isDisposed)return;const c=this.y(a),i=this.y(m),n=C;if(C=c,!c&&(i||n)){this.F(`fs.watchFile() detected ${w.path} exists again, resuming watcher (correlationId: ${w.correlationId})`);const r={resource:P,type:1,cId:w.correlationId};b.a.fire([r]),this.z(r,w),this.u(w)}};this.F(`starting fs.watchFile() on ${w.path} (correlationId: ${w.correlationId})`);try{(0,o.watchFile)(w.path,{persistent:!1,interval:this.m},y)}catch(a){this.G(`fs.watchFile() failed with error ${a} on path ${w.path} (correlationId: ${w.correlationId})`)}A.add((0,R.$Sc)(()=>{this.F(`stopping fs.watchFile() on ${w.path} (correlationId: ${w.correlationId})`);try{(0,o.unwatchFile)(w.path,y)}catch(a){this.G(`fs.unwatchFile() failed with error ${a} on path ${w.path} (correlationId: ${w.correlationId})`)}}))}y(w){return w.ctimeMs===0&&w.ino===0}async stop(){this.j.clearAndDisposeAll()}z(w,A){const P=` >> normalized ${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.resource.fsPath}`;this.F(typeof A.correlationId=="number"?`${P} (correlationId: ${A.correlationId})`:P)}C(w){return`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"}, includes: ${w.includes&&w.includes.length>0?JSON.stringify(w.includes):"<all>"}, correlationId: ${typeof w.correlationId=="number"?w.correlationId:"<none>"})`}}e.$Nq=p}),define(Ee[253],Ce([1,0,50,8,22,34,3,76,17,11,23,2,103,31,64]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0,e.$Tq=m;class a extends L.$Uc{constructor(i,n,r,s,t){super(),this.m=i,this.n=n,this.r=r,this.s=s,this.t=t,this.c=this.B(new R.$xh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.n(f))),this.f=this.B(new R.$wh(f=>this.D(f),a.b)),this.g=(0,y.$Eq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,y.$Eq)(this.m.path,this.m.includes):void 0,this.j=new I.$ee,this.ready=this.u()}async u(){try{const i=await this.w(this.m);if(this.j.token.isCancellationRequested)return;const n=await C.Promises.stat(i);if(this.j.token.isCancellationRequested)return;this.B(await this.y(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.G(i):this.I(`ignoring a path for watching who's stat info failed to resolve: ${this.m.path} (error: ${i})`),this.r?.()}}async w(i){let n=i.path;try{n=await C.Promises.realpath(i.path),i.path===n&&(n=await(0,b.$Pq)(i.path,this.j.token)??i.path),i.path!==n&&this.I(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async y(i,n){if(w.$d&&(0,M.$ig)(i,"/Volumes/",!0))return this.G(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.$Uc.None;const r=new I.$ee(this.j.token),s=new L.$Tc;try{const t=P.URI.file(this.m.path),f=(0,$.$oc)(i),d=(0,o.watch)(i);s.add((0,L.$Sc)(()=>{d.removeAllListeners(),d.close()})),this.I(`Started watching: '${i}'`);const u=new Set;if(n)try{for(const l of await C.Promises.readdir(i))u.add(l)}catch(l){this.G(l)}const h=new Map;s.add((0,L.$Sc)(()=>{for(const[,l]of h)l.dispose();h.clear()})),d.on("error",(l,g)=>{this.G(`Failed to watch ${i} for changes using fs.watch() (${l}, ${g})`),this.r?.()}),d.on("change",(l,g)=>{if(r.token.isCancellationRequested)return;this.I(`[raw] ["${l}"] ${g}`);let E="";if(g&&(E=g.toString(),w.$d&&(E=(0,p.$1l)(E))),!(!E||l!=="change"&&l!=="rename"))if(n)if(l==="rename"){h.get(E)?.dispose();const v=setTimeout(async()=>{if(h.delete(E),E===f&&!await C.Promises.exists(i)){this.z(t);return}const S=await this.F((0,$.$kc)(i,E));if(r.token.isCancellationRequested)return;let k;S?u.has(E)?k=0:(k=1,u.add(E)):(u.delete(E),k=2),this.C({resource:(0,A.$Vg)(t,E),type:k,cId:this.m.correlationId})},a.a);h.set(E,(0,L.$Sc)(()=>clearTimeout(v)))}else{let v;u.has(E)?v=0:(v=1,u.add(E)),this.C({resource:(0,A.$Vg)(t,E),type:v,cId:this.m.correlationId})}else if(l==="rename"||E!==f){const v=setTimeout(async()=>{const S=await C.Promises.exists(i);r.token.isCancellationRequested||(S?(this.C({resource:t,type:0,cId:this.m.correlationId},!0),s.add(await this.y(i,!1))):this.z(t))},a.a);s.clear(),s.add((0,L.$Sc)(()=>clearTimeout(v)))}else this.C({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){r.token.isCancellationRequested||this.G(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`),this.r?.()}return(0,L.$Sc)(()=>{r.dispose(!0),s.dispose()})}z(i){this.H("Watcher shutdown because watched path got deleted"),this.C({resource:i,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.r?.()}C(i,n=!1){this.j.token.isCancellationRequested||(this.t&&this.I(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(r=>r(i.resource.fsPath))?this.t&&this.I(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(r=>r(i.resource.fsPath))?this.t&&this.I(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}D(i){const n=(0,y.$Cq)(i);if(n.length>0){if(this.t)for(const s of n)this.I(` >> normalized ${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.I(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.H(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async F(i){if(w.$e)return C.Promises.exists(i);try{const n=(0,$.$oc)(i);return(await C.Promises.readdir((0,$.$nc)(i))).some(s=>s===n)}catch(n){return this.I(n),!1}}setVerboseLogging(i){this.t=i}G(i){this.j.token.isCancellationRequested||this.s?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}H(i){this.j.token.isCancellationRequested||this.s?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}I(i){!this.j.token.isCancellationRequested&&this.t&&this.s?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.j.dispose(!0),super.dispose()}}e.$Sq=a,a.a=100,a.b=75;async function m(c,i,n,r,s=512){const t=await C.Promises.open(c,"r"),f=Buffer.allocUnsafe(s),d=new I.$ee(r);let u,h=!1;const l={path:c,excludes:[],recursive:!1},g=new a(l,E=>{(async()=>{for(const{type:v}of E)if(v===0){if(h)return;h=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:S}=await C.Promises.read(t,f,0,s,null);if(!S||d.token.isCancellationRequested)break;i(f.slice(0,S))}}catch(S){u=new Error(S),d.dispose(!0)}finally{h=!1}}})()});return await g.ready,n(),new Promise((E,v)=>{d.token.onCancellationRequested(async()=>{g.dispose();try{await C.Promises.close(t)}catch(S){u=new Error(S)}u?v(u):E()})})}}),define(Ee[254],Ce([1,0,4,35,252,11,253,34]),function(re,e,o,R,I,M,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class $ extends I.$Nq{constructor(){super(...arguments),this.onDidError=o.Event.None,this.H=new Set,this.I=!1}async D(A){A=this.O(A);const P=[],b=new Set(Array.from(this.H));for(const C of A){const y=this.L(C);y&&(0,R.$gk)(y.request.excludes,C.excludes)&&(0,R.$gk)(y.request.includes,C.includes)?b.delete(y):P.push(C)}P.length&&this.F(`Request to start watching: ${P.map(C=>this.C(C)).join(",")}`),b.size&&this.F(`Request to stop watching: ${Array.from(b).map(C=>this.C(C.request)).join(",")}`);for(const C of b)this.N(C);for(const C of P)this.M(C)}L(A){for(const P of this.H)if(typeof A.correlationId=="number"||typeof P.request.correlationId=="number"){if(P.request.correlationId===A.correlationId)return P}else if((0,p.$hg)(P.request.path,A.path,!M.$e))return P}M(A){const P=new L.$Sq(A,C=>this.a.fire(C),()=>this.c.fire(A),C=>this.b.fire(C),this.I),b={request:A,instance:P};this.H.add(b)}async stop(){await super.stop();for(const A of this.H)this.N(A)}N(A){this.F("stopping file watcher",A),this.H.delete(A),A.instance.dispose()}O(A){const P=new Map;for(const b of A){const C=M.$e?b.path:b.path.toLowerCase();let y=P.get(b.correlationId);y||(y=new Map,P.set(b.correlationId,y)),y.has(C)&&this.F(`ignoring a request for watching who's path is already watched: ${this.C(b)}`),y.set(C,b)}return Array.from(P.values()).map(b=>Array.from(b.values())).flat()}async setVerboseLogging(A){this.I=A;for(const P of this.H)P.instance.setVerboseLogging(A)}F(A,P){this.I&&this.b.fire({type:"trace",message:this.R(A,P)})}G(A){this.b.fire({type:"warn",message:this.R(A)})}R(A,P){return P?`[File Watcher (node.js)] ${A} (${this.C(P.request)})`:`[File Watcher (node.js)] ${A}`}}e.$Uq=$}),define(Ee[255],Ce([1,0,64,254]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;class I extends o.$zq{constructor(L,p,$){super(L,p,$),this.s()}r(L){return L.add(new R.$Uq)}}e.$Vq=I}),define(Ee[256],Ce([1,0,15,80,177,64]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;class L extends M.$Aq{constructor($,w,A){super($,w,A),this.s()}r($){const w=$.add(new I.$Lq(o.$Cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(w.onDidProcessExit(({code:A,signal:P})=>this.t(`terminated by itself with code ${A}, signal: ${P}`))),R.ProxyChannel.toService((0,R.$2h)(w.getChannel("watcher")))}}e.$Mq=L}),define(Ee[107],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=void 0;class o{constructor(...I){this.a=new Map;for(const[M,L]of I)this.set(M,L)}set(I,M){const L=this.a.get(I);return this.a.set(I,M),L}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$gi=o}),define(Ee[257],Ce([1,0,8,13,3,106,247,5,107,75]),function(re,e,o,R,I,M,L,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;const A=!1;class P extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class b{constructor(m=new $.$gi,c=!1,i,n=A){this.f=m,this.g=c,this.h=i,this.i=n,this.o=new Set,this.f.set(p.$hi,this),this._globalGraph=n?i?._globalGraph??new L.$Yq(r=>r):void 0}createChild(m){return new b(m,this.g,this,this.i)}invokeFunction(m,...c){const i=y.traceInvocation(this.i,m);let n=!1;try{return m({get:s=>{if(n)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(s,i);if(!t)throw new Error(`[invokeFunction] unknown service '${s}'`);return t}},...c)}finally{n=!0,i.stop()}}createInstance(m,...c){let i,n;return m instanceof M.$fi?(i=y.traceCreation(this.i,m.ctor),n=this.j(m.ctor,m.staticArguments.concat(c),i)):(i=y.traceCreation(this.i,m),n=this.j(m,c,i)),i.stop(),n}j(m,c=[],i){const n=p._util.getServiceDependencies(m).sort((t,f)=>t.index-f.index),r=[];for(const t of n){const f=this.m(t.id,i);f||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(f)}const s=n.length>0?n[0].index:c.length;if(c.length!==s){console.trace(`[createInstance] First service dependency of ${m.name} at position ${s+1} conflicts with ${c.length} static arguments`);const t=s-c.length;t>0?c=c.concat(new Array(t)):c=c.slice(0,s)}return Reflect.construct(m,c.concat(r))}k(m,c){if(this.f.get(m)instanceof M.$fi)this.f.set(m,c);else if(this.h)this.h.k(m,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const c=this.f.get(m);return!c&&this.h?this.h.l(m):c}m(m,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const i=this.l(m);return i instanceof M.$fi?this.q(m,i,c.branch(m,!0)):(c.branch(m,!1),i)}q(m,c,i){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,c,i)}finally{this.o.delete(m)}}r(m,c,i){const n=new L.$Yq(t=>t.id.toString());let r=0;const s=[{id:m,desc:c,_trace:i}];for(;s.length;){const t=s.pop();if(n.lookupOrInsertNode(t),r++>1e3)throw new P(n);for(const f of p._util.getServiceDependencies(t.desc.ctor)){const d=this.l(f.id);if(d||this.u(`[createInstance] ${m} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(f.id)),d instanceof M.$fi){const u={id:f.id,desc:d,_trace:t._trace.branch(f.id,!0)};n.insertEdge(t,u),s.push(u)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new P(n);break}for(const{data:f}of t){if(this.l(f.id)instanceof M.$fi){const u=this.s(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this.k(f.id,u)}n.removeNode(f)}}return this.l(m)}s(m,c,i=[],n,r){if(this.f.get(m)instanceof M.$fi)return this.t(m,c,i,n,r);if(this.h)return this.h.s(m,c,i,n,r);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(m,c,i=[],n,r){if(n){const s=new b(void 0,this.g,this,this.i);s.c=String(m);const t=new Map,f=new o.$Bh(()=>{const d=s.j(c,i,r);for(const[u,h]of t){const l=d[u];if(typeof l=="function")for(const g of h)g.disposable=l.apply(d,g.listener)}return t.clear(),d});return new Proxy(Object.create(null),{get(d,u){if(!f.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let g=t.get(u);return g||(g=new w.$5c,t.set(u,g)),(v,S,k)=>{if(f.isInitialized)return f.value[u](v,S,k);{const D={listener:[v,S,k],disposable:void 0},F=g.push(D);return(0,I.$Sc)(()=>{F(),D.disposable?.dispose()})}}}if(u in d)return d[u];const h=f.value;let l=h[u];return typeof l!="function"||(l=l.bind(h),d[u]=l),l},set(d,u,h){return f.value[u]=h,!0},getPrototypeOf(d){return c.prototype}})}else return this.j(c,i,r)}u(m,c){if(c&&console.warn(m),this.g)throw new Error(m)}}e.$Zq=b;var C;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(C||(C={}));class y{static traceInvocation(m,c){return m?new y(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(m,c){return m?new y(1,c.name):y.c}constructor(m,c){this.type=m,this.name=c,this.g=Date.now(),this.h=[]}branch(m,c){const i=new y(3,m.toString());return this.h.push([m,c,i]),i}stop(){const m=Date.now()-this.g;y.f+=m;let c=!1;function i(r,s){const t=[],f=new Array(r+1).join("	");for(const[d,u,h]of s.h)if(u&&h){c=!0,t.push(`${f}CREATES -> ${d}`);const l=i(r+1,h);l&&t.push(l)}else t.push(`${f}uses -> ${d}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(m>2||c)&&y.all.add(n.join(`
`))}}e.$1q=y,y.all=new Set,y.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}},y.f=0}),define(Ee[12],Ce([1,0,213,47,4,55,3,27,11,23,18,2,42,5]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Rj=e.LogLevel=e.$Pj=e.$Oj=void 0,e.$Qj=a,e.log=c,e.$3j=g,e.$4j=E,e.$5j=v,e.$6j=S,e.$Oj=(0,C.$ii)("logService"),e.$Pj=(0,C.$ii)("loggerService");function y(){return new Date().toISOString()}function a(k){return(0,A.$Zf)(k)}var m;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$Rj=m.Info;function c(k,D,F){switch(D){case m.Trace:k.trace(F);break;case m.Debug:k.debug(F);break;case m.Info:k.info(F);break;case m.Warning:k.warn(F);break;case m.Error:k.error(F);break;case m.Off:break;default:throw new Error(`Invalid log level ${D}`)}}function i(k,D=!1){let F="";for(let W=0;W<k.length;W++){let B=k[W];if(B instanceof Error&&(B=(0,R.$6i)(B,D)),typeof B=="object")try{B=JSON.stringify(B)}catch{}F+=(W>0?" ":"")+B}return F}class n extends L.$Uc{constructor(){super(...arguments),this.b=e.$Rj,this.c=this.B(new I.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(D){this.b!==D&&(this.b=D,this.c.fire(this.b))}getLevel(){return this.b}f(D){return this.b!==m.Off&&this.b<=D}}e.$Tj=n;class r extends n{constructor(D){super(),this.h=D}f(D){return this.h||super.f(D)}trace(D,...F){this.f(m.Trace)&&this.g(m.Trace,i([D,...F],!0))}debug(D,...F){this.f(m.Debug)&&this.g(m.Debug,i([D,...F]))}info(D,...F){this.f(m.Info)&&this.g(m.Info,i([D,...F]))}warn(D,...F){this.f(m.Warning)&&this.g(m.Warning,i([D,...F]))}error(D,...F){if(this.f(m.Error))if(D instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=D.stack,this.g(m.Error,i(W))}else this.g(m.Error,i([D,...F]))}flush(){}}e.$Uj=r;class s extends n{constructor(D=e.$Rj){super(),this.setLevel(D),this.g=!$.$c}trace(D,...F){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,D,...F):console.log(`[main ${y()}]`,D,...F))}debug(D,...F){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,D,...F):console.log(`[main ${y()}]`,D,...F))}info(D,...F){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,D,...F):console.log(`[main ${y()}]`,D,...F))}warn(D,...F){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,D,...F):console.warn(`[main ${y()}]`,D,...F))}error(D,...F){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,D,...F):console.error(`[main ${y()}]`,D,...F))}flush(){}}e.$Vj=s;class t extends n{constructor(D=e.$Rj,F=!0){super(),this.g=F,this.setLevel(D)}trace(D,...F){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",D,...F):console.log(D,...F))}debug(D,...F){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",D,...F):console.log(D,...F))}info(D,...F){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",D,...F):console.log(D,...F))}warn(D,...F){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",D,...F):console.log(D,...F))}error(D,...F){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",D,...F):console.error(D,...F))}flush(){}}e.$Wj=t;class f extends n{constructor(D,F=e.$Rj){super(),this.g=D,this.setLevel(F)}trace(D,...F){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(D),...F])}debug(D,...F){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(D),...F])}info(D,...F){this.f(m.Info)&&this.g.log(m.Info,[this.h(D),...F])}warn(D,...F){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(D),...F])}error(D,...F){this.f(m.Error)&&this.g.log(m.Error,[this.h(D),...F])}h(D){return typeof D=="string"?D:(0,R.$6i)(D,this.f(m.Trace))}flush(){}}e.$Xj=f;class d extends n{constructor(D){super(),this.g=D,D.length&&this.setLevel(D[0].getLevel())}setLevel(D){for(const F of this.g)F.setLevel(D);super.setLevel(D)}trace(D,...F){for(const W of this.g)W.trace(D,...F)}debug(D,...F){for(const W of this.g)W.debug(D,...F)}info(D,...F){for(const W of this.g)W.info(D,...F)}warn(D,...F){for(const W of this.g)W.warn(D,...F)}error(D,...F){for(const W of this.g)W.error(D,...F)}flush(){for(const D of this.g)D.flush()}dispose(){for(const D of this.g)D.dispose();super.dispose()}}e.$Yj=d;class u extends L.$Uc{constructor(D,F,W){if(super(),this.h=D,this.j=F,this.b=new p.$Bc,this.c=this.B(new I.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new I.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new I.$7d),this.onDidChangeVisibility=this.g.event,W)for(const B of W)this.b.set(B.resource,{logger:void 0,info:B})}m(D){return(0,A.$Vf)(D)?[...this.b.values()].find(F=>F.info.id===D):this.b.get(D)}getLogger(D){return this.m(D)?.logger}createLogger(D,F){const W=this.n(D),B=(0,A.$Vf)(D)?D:F?.id??(0,M.$9i)(W.toString()).toString(16);let j=this.b.get(W)?.logger;const N=F?.logLevel==="always"?m.Trace:F?.logLevel;j||(j=this.s(W,N??this.getLogLevel(W)??this.h,{...F,id:B}));const T={logger:j,info:{resource:W,id:B,logLevel:N,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(T.info),this.b.set(W,T),j}n(D){return(0,A.$Vf)(D)?(0,w.$Vg)(this.j,`${D}.log`):D}setLogLevel(D,F){if(P.URI.isUri(D)){const W=D,B=F,j=this.b.get(W);j&&B!==j.info.logLevel&&(j.info.logLevel=B===this.h?void 0:B,j.logger?.setLevel(B),this.b.set(j.info.resource,j),this.f.fire([W,B]))}else{this.h=D;for(const[W,B]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&B.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(D,F){const W=this.m(D);W&&F!==!W.info.hidden&&(W.info.hidden=!F,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,F]))}getLogLevel(D){let F;return D&&(F=this.b.get(D)?.info.logLevel),F??this.h}registerLogger(D){const F=this.b.get(D.resource);F?F.info.hidden!==D.hidden&&this.setVisibility(D.resource,!D.hidden):(this.b.set(D.resource,{info:D,logger:void 0}),this.c.fire({added:[D],removed:[]}))}deregisterLogger(D){const F=this.b.get(D);F&&(F.logger&&F.logger.dispose(),this.b.delete(D),this.c.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const D of this.b.values())yield D.info}getRegisteredLogger(D){return this.b.get(D)?.info}dispose(){this.b.forEach(D=>D.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Zj=u;class h{constructor(){this.onDidChangeLogLevel=new I.$7d().event}setLevel(D){}getLevel(){return m.Info}trace(D,...F){}debug(D,...F){}info(D,...F){}warn(D,...F){}error(D,...F){}critical(D,...F){}dispose(){}flush(){}}e.$1j=h;class l extends h{}e.$2j=l;function g(k){if(k.verbose)return m.Trace;if(typeof k.logLevel=="string"){const D=S(k.logLevel.toLowerCase());if(D!==void 0)return D}return e.$Rj}function E(k){switch(k){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function v(k){switch(k){case m.Trace:return{original:"Trace",value:o.localize(0,null)};case m.Debug:return{original:"Debug",value:o.localize(1,null)};case m.Info:return{original:"Info",value:o.localize(2,null)};case m.Warning:return{original:"Warning",value:o.localize(3,null)};case m.Error:return{original:"Error",value:o.localize(4,null)};case m.Off:return{original:"Off",value:o.localize(5,null)}}}function S(k){switch(k){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$7j=new b.$zj("logLevel",E(m.Info))}),define(Ee[258],Ce([1,0,19,8,13,4,3,17,64,12]),function(re,e,o,R,I,M,L,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=void 0;class A extends L.$Uc{constructor(b,C){super(),this.a=b,this.b=C,this.c=this.B(new M.$7d),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$7d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$gh(0)),this.w=[],this.y=this.B(new R.$gh(0))}watch(b,C){return C.recursive||this.b?.watcher?.forceUniversal?this.n(b,C):this.z(b,C)}n(b,C){const y={path:this.H(b),excludes:C.excludes,includes:C.includes,recursive:C.recursive,correlationId:C.correlationId},a=(0,o.$Ub)(this.j,y);return this.r(),(0,L.$Sc)(()=>{a(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(b=>(0,I.$1)(b))}s(){this.h||(this.h=this.B(this.t(C=>this.c.fire((0,$.$Bq)(C)),C=>this.G(C),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const C of this.j)(0,$.$xq)(C)&&(C.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const C of this.j)(0,$.$xq)(C)&&b.includes(C.path)&&(C.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(b,C){const y={path:this.H(b),excludes:C.excludes,includes:C.includes,recursive:!1,correlationId:C.correlationId},a=(0,o.$Ub)(this.w,y);return this.C(),(0,L.$Sc)(()=>{a(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(b=>(0,I.$1)(b))}D(){return this.u||(this.u=this.B(this.F(b=>this.c.fire((0,$.$Bq)(b)),b=>this.G(b),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)}))),this.u.watch(this.w)}G(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}H(b){return(0,p.$ic)(b.fsPath)}}e.$Fq=A}),define(Ee[259],Ce([1,0,50,396,8,27,21,4,34,3,17,11,23,100,31,212,32,251,258,47,256,255]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i,n,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=void 0,(()=>{try{(0,R.gracefulify)(o)}catch(f){console.error(`Error enabling graceful-fs: ${(0,n.$6i)(f)}`)}})();class t extends i.$Fq{constructor(d,u){super(d,u),this.onDidChangeCapabilities=p.Event.None,this.N=new M.$Bc(h=>b.$Mg.getComparisonKey(h)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,P.$e&&(this.J|=1024)),this.J}async stat(d){try{const{stat:u,symbolicLink:h}=await y.SymlinkSupport.stat(this.H(d));return{type:this.M(u,h),ctime:u.birthtime.getTime(),mtime:u.mtime.getTime(),size:u.size,permissions:u.mode&128?void 0:m.FilePermission.Locked}}catch(u){throw this.fb(u)}}async L(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const u=await y.Promises.readdir(this.H(d),{withFileTypes:!0}),h=[];return await Promise.all(u.map(async l=>{try{let g;l.isSymbolicLink()?g=(await this.stat((0,b.$Vg)(d,l.name))).type:g=this.M(l),h.push([l.name,g])}catch(g){this.a.trace(g)}})),h}catch(u){throw this.fb(u)}}M(d,u){let h;return u?.dangling?h=m.FileType.Unknown:d.isFile()?h=m.FileType.File:d.isDirectory()?h=m.FileType.Directory:h=m.FileType.Unknown,u&&(h|=m.FileType.SymbolicLink),h}async O(d){const u=this.H(d);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${u})`);let h;for(;h=this.N.get(d);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${u})`),await h.wait();const l=new I.$hh;return this.N.set(d,l),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${u})`),(0,w.$Sc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${u})`),this.N.get(d)===l&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${u})`),this.N.delete(d)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${u})`),l.open()})}async readFile(d,u){let h;try{u?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(d)})`),h=await this.O(d));const l=this.H(d);return await y.Promises.readFile(l)}catch(l){throw this.fb(l)}finally{h?.dispose()}}P(d){t.I&&this.a.trace(d)}readFileStream(d,u,h){const l=(0,C.$ie)(g=>L.$ue.concat(g.map(E=>L.$ue.wrap(E))).buffer);return(0,c.$uq)(this,d,l,g=>g.buffer,{...u,bufferSize:256*1024},h),l}async writeFile(d,u,h){return h?.atomic!==!1&&h?.atomic?.postfix&&await this.Q(d)?this.R(d,(0,b.$Vg)((0,b.$Ug)(d),`${(0,b.$Sg)(d)}${h.atomic.postfix}`),u,h):this.S(d,u,h)}async Q(d){try{const u=this.H(d),{symbolicLink:h}=await y.SymlinkSupport.stat(u);if(h)return!1}catch{}return!0}async R(d,u,h,l){const g=new w.$Tc;try{g.add(await this.O(d)),g.add(await this.O(u)),await this.S(u,h,l,!0);try{await this.rename(u,d,{overwrite:!0})}catch(E){try{await this.delete(u,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw E}}finally{g.dispose()}}async S(d,u,h,l){let g;try{const E=this.H(d);if(!h.create||!h.overwrite){if(await y.Promises.exists(E)){if(!h.overwrite)throw(0,m.$2k)((0,a.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!h.create)throw(0,m.$2k)((0,a.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(d,{create:!0,unlock:h.unlock},l),await this.write(g,0,u,0,u.byteLength)}catch(E){throw await this.gb(d,E)}finally{typeof g=="number"&&await this.close(g)}}static configureFlushOnWrite(d){t.Y=d}async open(d,u,h){const l=this.H(d);let g;(0,m.$Pk)(u)&&!h&&(g=await this.O(d));let E;try{if((0,m.$Pk)(u)&&u.unlock)try{const{stat:S}=await y.SymlinkSupport.stat(l);S.mode&128||await y.Promises.chmod(l,S.mode|128)}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}let v;if((0,m.$Pk)(u)){if(P.$c)try{await y.Promises.truncate(l,0),v="r+"}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}v||(v="w")}else v="r";E=await y.Promises.open(l,v)}catch(v){throw g?.dispose(),(0,m.$Pk)(u)?await this.gb(d,v):this.fb(v)}if(this.U.set(E,0),(0,m.$Pk)(u)&&this.X.set(E,d),g){const v=this.W.get(E);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${E} (${l})`),this.W.set(E,g),v&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${E} (${l})`),v.dispose())}return E}async close(d){const u=this.W.get(d);try{if(this.U.delete(d),this.X.delete(d)&&t.Y)try{await y.Promises.fdatasync(d)}catch(h){t.configureFlushOnWrite(!1),this.a.error(h)}return await y.Promises.close(d)}catch(h){throw this.fb(h)}finally{u&&(this.W.get(d)===u&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.W.delete(d)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),u.dispose())}}async read(d,u,h,l,g){const E=this.Z(d,u);let v=null;try{v=(await y.Promises.read(d,h,l,g,E)).bytesRead}catch(S){throw this.fb(S)}finally{this.$(d,E,v)}return v}Z(d,u){return u===this.U.get(d)?null:u}$(d,u,h){const l=this.U.get(d);typeof l=="number"&&(typeof u=="number"||(typeof h=="number"?this.U.set(d,l+h):this.U.delete(d)))}async write(d,u,h,l,g){return(0,I.$Ch)(()=>this.ab(d,u,h,l,g),100,3)}async ab(d,u,h,l,g){const E=this.Z(d,u);let v=null;try{v=(await y.Promises.write(d,h,l,g,E)).bytesWritten}catch(S){throw await this.gb(this.X.get(d),S)}finally{this.$(d,E,v)}return v}async mkdir(d){try{await y.Promises.mkdir(this.H(d))}catch(u){throw this.fb(u)}}async delete(d,u){try{const h=this.H(d);if(u.recursive){let l;u?.atomic!==!1&&u.atomic.postfix&&(l=(0,A.$kc)((0,A.$nc)(h),`${(0,A.$oc)(h)}${u.atomic.postfix}`)),await y.Promises.rm(h,y.RimRafMode.MOVE,l)}else try{await y.Promises.unlink(h)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let g=!1;try{const{stat:E,symbolicLink:v}=await y.SymlinkSupport.stat(h);g=E.isDirectory()&&!v}catch{}if(g)await y.Promises.rmdir(h);else throw l}else throw l}}catch(h){throw this.fb(h)}}async rename(d,u,h){const l=this.H(d),g=this.H(u);if(l!==g)try{await this.bb(d,u,"move",h.overwrite),await y.Promises.rename(l,g)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,a.localize)(2,null,(0,A.$oc)(l),(0,A.$oc)((0,A.$nc)(g)),E.toString()))),this.fb(E)}}async copy(d,u,h){const l=this.H(d),g=this.H(u);if(l!==g)try{await this.bb(d,u,"copy",h.overwrite),await y.Promises.copy(l,g,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,a.localize)(3,null,(0,A.$oc)(l),(0,A.$oc)((0,A.$nc)(g)),E.toString()))),this.fb(E)}}async bb(d,u,h,l){const g=this.H(d),E=this.H(u);let v=!1;if(!!(this.capabilities&1024)||(v=(0,$.$hg)(g,E,!0)),v){if(h==="copy")throw(0,m.$2k)((0,a.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(h==="move")return}const k=await this.L(d);if(!k)throw(0,m.$2k)((0,a.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const D=await this.L(u);if(D){if(!l)throw(0,m.$2k)((0,a.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);k.type&m.FileType.File&&D.type&m.FileType.File||await this.delete(u,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,u){return this.cb(d,u,!1)}async cb(d,u,h){const l=this.H(d),g=this.H(u),E=!!(this.capabilities&1024);if((0,$.$hg)(l,g,!E))return;const v=new w.$Tc;try{v.add(await this.O(d)),v.add(await this.O(u)),h&&await y.Promises.mkdir((0,A.$nc)(g),{recursive:!0}),await y.Promises.copyFile(l,g)}catch(S){if(S.code==="ENOENT"&&!h)return this.cb(d,u,!0);throw this.fb(S)}finally{v.dispose()}}t(d,u,h){return new r.$Mq(l=>d(l),l=>u(l),h)}F(d,u,h){return new s.$Vq(l=>d(l),l=>u(l),h)}fb(d){if(d instanceof m.$1k)return d;let u=d,h;switch(d.code){case"ENOENT":h=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":h=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":h=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":h=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":h=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":u=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,h=m.FileSystemProviderErrorCode.Unknown;break;default:h=m.FileSystemProviderErrorCode.Unknown}return(0,m.$2k)(u,h)}async gb(d,u){let h=this.fb(u);if(d&&h.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await y.SymlinkSupport.stat(this.H(d));l.mode&128||(h=(0,m.$2k)(u,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return h}}e.$Wq=t,t.I=!1,t.Y=!0}),define(Ee[260],Ce([1,0,3,12]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=void 0;class I extends o.$Uc{constructor(L,p=[]){super(),this.a=new R.$Yj([L,...p]),this.B(L.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...p){this.a.trace(L,...p)}debug(L,...p){this.a.debug(L,...p)}info(L,...p){this.a.info(L,...p)}warn(L,...p){this.a.warn(L,...p)}error(L,...p){this.a.error(L,...p)}flush(){this.a.flush()}}e.$bQ=I}),define(Ee[261],Ce([1,0,32,12]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=void 0;var I;(function(w){w[w.Trace=0]="Trace",w[w.Debug=1]="Debug",w[w.Info=2]="Info",w[w.Warning=3]="Warning",w[w.Error=4]="Error",w[w.Critical=5]="Critical",w[w.Off=6]="Off"})(I||(I={}));async function M(w,A,P,b,C){try{const y=await new Promise((m,c)=>{re(["@vscode/spdlog"],m,c)});y.setFlushOn(I.Trace);const a=await y.createAsyncRotatingLogger(w,A,P,b);return C?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(y){console.error(y)}return null}function L(w,A,P){switch(A){case R.LogLevel.Trace:w.trace(P);break;case R.LogLevel.Debug:w.debug(P);break;case R.LogLevel.Info:w.info(P);break;case R.LogLevel.Warning:w.warn(P);break;case R.LogLevel.Error:w.error(P);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function p(w,A){switch(A){case R.LogLevel.Trace:w.setLevel(I.Trace);break;case R.LogLevel.Debug:w.setLevel(I.Debug);break;case R.LogLevel.Info:w.setLevel(I.Info);break;case R.LogLevel.Warning:w.setLevel(I.Warning);break;case R.LogLevel.Error:w.setLevel(I.Error);break;case R.LogLevel.Off:w.setLevel(I.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class $ extends R.$Uj{constructor(A,P,b,C,y){super(),this.m=[],this.setLevel(y),this.n=this.s(A,P,b,C),this.B(this.onDidChangeLogLevel(a=>{this.r&&p(this.r,a)}))}async s(A,P,b,C){const y=b?6:1,a=30/y*o.$kl.MB,m=await M(A,P,a,y,C);if(m){this.r=m,p(this.r,this.getLevel());for(const{level:c,message:i}of this.m)L(this.r,c,i);this.m=[]}}g(A,P){this.r?L(this.r,A,P):this.getLevel()<=A&&this.m.push({level:A,message:P})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$3P=$}),define(Ee[139],Ce([1,0,41,214,5]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var L;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function($){function w(y,a){return a-y}$.compare=w;const A=Object.create(null);A[$.Error]=(0,R.localize)(0,null),A[$.Warning]=(0,R.localize)(1,null),A[$.Info]=(0,R.localize)(2,null);function P(y){return A[y]||""}$.toString=P;function b(y){switch(y){case o.default.Error:return $.Error;case o.default.Warning:return $.Warning;case o.default.Info:return $.Info;case o.default.Ignore:return $.Hint}}$.fromSeverity=b;function C(y){switch(y){case $.Error:return o.default.Error;case $.Warning:return o.default.Warning;case $.Info:return o.default.Info;case $.Hint:return o.default.Ignore}}$.toSeverity=C}(L||(e.MarkerSeverity=L={}));var p;(function($){const w="";function A(b){return P(b,!0)}$.makeKey=A;function P(b,C){const y=[w];return b.source?y.push(b.source.replace("\xA6","\\\xA6")):y.push(w),b.code?typeof b.code=="string"?y.push(b.code.replace("\xA6","\\\xA6")):y.push(b.code.value.replace("\xA6","\\\xA6")):y.push(w),b.severity!==void 0&&b.severity!==null?y.push(L.toString(b.severity)):y.push(w),b.message&&C?y.push(b.message.replace("\xA6","\\\xA6")):y.push(w),b.startLineNumber!==void 0&&b.startLineNumber!==null?y.push(b.startLineNumber.toString()):y.push(w),b.startColumn!==void 0&&b.startColumn!==null?y.push(b.startColumn.toString()):y.push(w),b.endLineNumber!==void 0&&b.endLineNumber!==null?y.push(b.endLineNumber.toString()):y.push(w),b.endColumn!==void 0&&b.endColumn!==null?y.push(b.endColumn.toString()):y.push(w),y.push(w),y.join("\xA6")}$.makeKeyOptionalMessage=P})(p||(e.IMarkerData=p={})),e.$Vt=(0,I.$ii)("markerService")}),define(Ee[262],Ce([1,0,4,41,5]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pv=e.$Ov=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Mv=e.Severity=void 0,e.$Nv=p,e.Severity=R.default,e.$Mv=(0,I.$ii)("notificationService");var M;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var L;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));function p(P){if(P){const b=P;return typeof b.id=="string"&&typeof b.label=="string"}return!1}var $;(function(P){P[P.OFF=0]="OFF",P[P.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class w{constructor(){this.progress=new A,this.onDidClose=o.Event.None,this.onDidChangeVisibility=o.Event.None}updateSeverity(b){}updateMessage(b){}updateActions(b){}close(){}}e.$Ov=w;class A{infinite(){}done(){}total(b){}worked(b){}}e.$Pv=A}),define(Ee[263],Ce([1,0,49]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;const I=globalThis.vscode;if(typeof I<"u"&&typeof I.context<"u"){const M=I.context.configuration();if(M)R=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(R=globalThis._VSCODE_PRODUCT_JSON,o.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`,serverDataFolderName:R.serverDataFolderName?`${R.serverDataFolderName}-dev`:void 0}),!R.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(R,{version:M.version})}Object.assign(R,{extensionsGallery:o.env.EXTENSIONS_GALLERY?JSON.parse(o.env.EXTENSIONS_GALLERY):R.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else R={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.88.0",sha256:"3a048d87c0fac116fce9190ff6042ec7691e66fc17211a058faf0db91bb6605e",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.8",sha256:"ca30069e21fbf576b49638ff8ff7c316b028c2faca924c23526737c65b8762bf",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.88.1",commit:"9a28bc29dbddb6886dfe03dc1c31320249a901ce",date:"2024-04-15T23:01:57.805Z"},Object.keys(R).length===0&&Object.assign(R,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=R}),define(Ee[140],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=void 0,e.$8j=(0,o.$ii)("productService"),e.$9j="vscode://schemas/vscode-product"});var He=this&&this.__param||function(re,e){return function(o,R){e(o,R,re)}};define(Ee[108],Ce([1,0,8,22,3,5]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wv=e.$Vv=e.$Uv=e.$Tv=e.$Sv=e.$Rv=e.ProgressLocation=e.$Qv=void 0,e.$Qv=(0,M.$ii)("progressService");var L;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.$Rv=Object.freeze({total(){},worked(){},done(){}});class p{get value(){return this.a}constructor(b){this.b=b}report(b){this.a=b,this.b(this.a)}}e.$Sv=p,p.None=Object.freeze({report(){}});class ${get value(){return this.a}constructor(b){this.e=b}report(b){this.b?this.b.push(b):this.b=[b],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const b=this.b.shift();this.a=b,await this.e(this.a)}}finally{this.c=!1;const b=this.d;this.d=void 0,b?.()}}drain(){return this.c?new Promise(b=>{const C=this.d;this.d=()=>{C?.(),b()}}):Promise.resolve()}}e.$Tv=$;let w=class extends I.$Uc{constructor(b,C){super(),this.a=new o.$Fh,C.withProgress(b,y=>(this.b=y,this.c&&y.report(this.c),this.a.p)),this.B((0,I.$Sc)(()=>this.a.complete()))}report(b){this.b?this.b.report(b):this.c=b}};e.$Uv=w,e.$Uv=w=Qe([He(1,e.$Qv)],w);class A extends I.$Uc{constructor(b){super(),this.g=b,this.a=0,this.b=this.B(new I.$Tc)}start(b){this.stop();const C=++this.a,y=new R.$ee;return this.f=setTimeout(()=>{C===this.a&&(this.c=this.g.show(!0))},b),this.b.add((0,I.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,I.$Sc)(()=>y.cancel())),this.b.add((0,I.$Sc)(()=>this.c?this.c.done():void 0)),{id:C,token:y.token,stop:()=>this.h(C),isCurrent:()=>this.a===C}}stop(){this.h(this.a)}h(b){this.a===b&&this.b.clear()}}e.$Vv=A,e.$Wv=(0,M.$ii)("editorProgressService")}),define(Ee[37],Ce([1,0,61,18]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=void 0;class I{constructor(){this.a=new Map}add(L,p){o.ok(R.$Vf(L)),o.ok(R.$Xf(p)),o.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,p)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$2n=new I}),define(Ee[109],Ce([1,0,4,37]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=void 0,e.$3n={JSONContribution:"base.contributions.json"};function I(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class M{constructor(){this.b=new o.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,w){this.a[I($)]=w,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const L=new M;R.$2n.add(e.$3n.JSONContribution,L)}),define(Ee[85],Ce([1,0,19,4,18,203,53,109,37]),function(re,e,o,R,I,M,L,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.ConfigurationScope=e.$7n=e.EditPresentationTypes=void 0,e.$fo=a,e.$go=m,e.$ho=c,e.$io=n,e.$jo=r;var w;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$7n={Configuration:"base.contributions.configuration"};var A;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n={properties:{},patternProperties:{}},e.$ao={properties:{},patternProperties:{}},e.$bo="vscode://schemas/settings/resourceLanguage",e.$co="vscode://schemas/settings/configurationDefaults";const P=$.$2n.as(p.$3n.JSONContribution);class b{constructor(){this.h=new Set,this.i=new R.$7d,this.onDidSchemaChange=this.i.event,this.j=new R.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.$bo,this.g),this.v()}registerConfiguration(t,f=!0){this.registerConfigurations([t],f)}registerConfigurations(t,f=!0){const d=new Set;this.n(t,f,d),P.registerSchema(e.$bo,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const f=new Set;this.o(t,f),P.registerSchema(e.$bo,this.g),this.i.fire(),this.j.fire({properties:f})}updateConfigurations({add:t,remove:f}){const d=new Set;this.o(f,d),this.n(t,!1,d),P.registerSchema(e.$bo,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const f=new Set;this.k(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}k(t,f){const d=[];for(const{overrides:u,source:h}of t)for(const l in u)if(f.add(l),e.$eo.test(l)){const g=this.a.get(l),E=g?.valuesSources??new Map;if(h)for(const D of Object.keys(u[l]))E.set(D,h);const v={...g?.value||{},...u[l]};this.a.set(l,{source:h,value:v,valuesSources:E});const S=(0,L.$Yi)(l),k={type:"object",default:v,description:M.localize(1,null,S),$ref:e.$bo,defaultDefaultValue:v,source:I.$Vf(h)?void 0:h,defaultValueSource:h};d.push(...a(l)),this.d[l]=k,this.b.properties[l]=k}else{this.a.set(l,{value:u[l],source:h});const g=this.d[l];g&&(this.w(l,g),this.r(l,g))}this.m(d)}deregisterDefaultConfigurations(t){const f=new Set;this.l(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}l(t,f){for(const{overrides:d,source:u}of t)for(const h in d){const l=this.a.get(h),g=I.$Vf(u)?u:u?.id,E=I.$Vf(l?.source)?l?.source:l?.source?.id;if(g===E)if(f.add(h),this.a.delete(h),e.$eo.test(h))delete this.d[h],delete this.b.properties[h];else{const v=this.d[h];v&&(this.w(h,v),this.r(h,v))}}this.u()}deltaConfiguration(t){let f=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),f=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),f=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const f of t)this.h.add(f);this.u()}n(t,f,d){t.forEach(u=>{this.p(u,f,u.extensionInfo,u.restrictedProperties,void 0,d),this.c.push(u),this.q(u)})}o(t,f){const d=u=>{if(u.properties)for(const h in u.properties){f.add(h);const l=this.d[h];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[h],this.s(h,u.properties[h])}u.allOf?.forEach(h=>d(h))};for(const u of t){d(u);const h=this.c.indexOf(u);h!==-1&&this.c.splice(h,1)}}p(t,f=!0,d,u,h=3,l){h=I.$5f(t.scope)?h:t.scope;const g=t.properties;if(g)for(const v in g){const S=g[v];if(f&&n(v,S)){delete g[v];continue}if(S.source=d,S.defaultDefaultValue=g[v].default,this.w(v,S),e.$eo.test(v)?S.scope=void 0:(S.scope=I.$5f(S.scope)?h:S.scope,S.restricted=I.$5f(S.restricted)?!!u?.includes(v):S.restricted),g[v].hasOwnProperty("included")&&!g[v].included){this.f[v]=g[v],delete g[v];continue}else this.d[v]=g[v],g[v].policy?.name&&this.e.set(g[v].policy.name,v);!g[v].deprecationMessage&&g[v].markdownDeprecationMessage&&(g[v].deprecationMessage=g[v].markdownDeprecationMessage),l.add(v)}const E=t.allOf;if(E)for(const v of E)this.p(v,f,d,u,h,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const f=d=>{const u=d.properties;if(u)for(const l in u)this.r(l,u[l]);d.allOf?.forEach(f)};f(t)}r(t,f){switch(e.$8n.properties[t]=f,f.scope){case 1:e.$9n.properties[t]=f;break;case 2:e.$0n.properties[t]=f;break;case 6:e.$$n.properties[t]=f;break;case 3:e.$_n.properties[t]=f;break;case 4:e.$ao.properties[t]=f;break;case 5:e.$ao.properties[t]=f,this.g.properties[t]=f;break}}s(t,f){switch(delete e.$8n.properties[t],f.scope){case 1:delete e.$9n.properties[t];break;case 2:delete e.$0n.properties[t];break;case 6:delete e.$$n.properties[t];break;case 3:delete e.$_n.properties[t];break;case 4:case 5:delete e.$ao.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const f=`[${t}]`,d={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$bo};this.w(f,d),e.$8n.properties[f]=d,e.$9n.properties[f]=d,e.$0n.properties[f]=d,e.$$n.properties[f]=d,e.$_n.properties[f]=d,e.$ao.properties[f]=d}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$bo};e.$8n.patternProperties[e.$do]=t,e.$9n.patternProperties[e.$do]=t,e.$0n.patternProperties[e.$do]=t,e.$$n.patternProperties[e.$do]=t,e.$_n.patternProperties[e.$do]=t,e.$ao.patternProperties[e.$do]=t,this.i.fire()}w(t,f){const d=this.a.get(t);let u=d?.value,h=d?.source;I.$3f(u)&&(u=f.defaultDefaultValue,h=void 0),I.$3f(u)&&(u=c(f.type)),f.default=u,f.defaultValueSource=h}}const C="\\[([^\\]]+)\\]",y=new RegExp(C,"g");e.$do=`^(${C})+$`,e.$eo=new RegExp(e.$do);function a(s){const t=[];if(e.$eo.test(s)){let f=y.exec(s);for(;f?.length;){const d=f[1].trim();d&&t.push(d),f=y.exec(s)}}return(0,o.$Mb)(t)}function m(s){return s.reduce((t,f)=>`${t}[${f}]`,"")}function c(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const i=new b;$.$2n.add(e.$7n.Configuration,i);function n(s,t){return s.trim()?e.$eo.test(s)?M.localize(7,null,s):i.getConfigurationProperties()[s]!==void 0?M.localize(8,null,s):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,s,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}function r(){const s=[],t=i.getConfigurationProperties();for(const f of Object.keys(t))s.push([f,t[f].scope]);return s.push(["launch",4]),s.push(["task",4]),s}}),define(Ee[264],Ce([1,0,19,4,165,3,27,24,18,2,53,85,37]),function(re,e,o,R,I,M,L,p,$,w,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=e.$no=e.$mo=e.$lo=e.$ko=void 0,e.$oo=n;function C(f){return Object.isFrozen(f)?f:p.$Qn(f)}class y{constructor(d={},u=[],h=[],l){this.b=d,this.c=u,this.d=h,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const d=this.raw.map(u=>{if(u instanceof y)return u;const h=new a("");return h.parseRaw(u),h.configurationModel});this.f=d.reduce((u,h)=>h===u?h:u.merge(h),d[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,A.$Wi)(this.contents,d):this.contents}inspect(d,u){const h=this;return{get value(){return C(h.rawConfiguration.getValue(d))},get override(){return u?C(h.rawConfiguration.getOverrideValue(d,u)):void 0},get merged(){return C(u?h.rawConfiguration.override(u).getValue(d):h.rawConfiguration.getValue(d))},get overrides(){const l=[];for(const{contents:g,identifiers:E,keys:v}of h.rawConfiguration.overrides){const S=new y(g,v).getValue(d);S!==void 0&&l.push({identifiers:E,value:S})}return l.length?C(l):void 0}}}getOverrideValue(d,u){const h=this.i(u);return h?d?(0,A.$Wi)(h,d):h:void 0}getKeysForOverrideIdentifier(d){const u=[];for(const h of this.overrides)h.identifiers.includes(d)&&u.push(...h.keys);return o.$Mb(u)}getAllOverrideIdentifiers(){const d=[];for(const u of this.overrides)d.push(...u.identifiers);return o.$Mb(d)}override(d){let u=this.a.get(d);return u||(u=this.g(d),this.a.set(d,u)),u}merge(...d){const u=p.$Pn(this.contents),h=p.$Pn(this.overrides),l=[...this.keys],g=this.raw?.length?[...this.raw]:[this];for(const E of d)if(g.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.h(u,E.contents);for(const v of E.overrides){const[S]=h.filter(k=>o.$ub(k.identifiers,v.identifiers));S?(this.h(S.contents,v.contents),S.keys.push(...v.keys),S.keys=o.$Mb(S.keys)):h.push(p.$Pn(v))}for(const v of E.keys)l.indexOf(v)===-1&&l.push(v)}return new y(u,l,h,g.every(E=>E instanceof y)?void 0:g)}g(d){const u=this.i(d);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const h={};for(const l of o.$Mb([...Object.keys(this.contents),...Object.keys(u)])){let g=this.contents[l];const E=u[l];E&&(typeof g=="object"&&typeof E=="object"?(g=p.$Pn(g),this.h(g,E)):g=E),h[l]=g}return new y(h,this.keys,this.overrides)}h(d,u){for(const h of Object.keys(u)){if(h in d&&$.$Xf(d[h])&&$.$Xf(u[h])){this.h(d[h],u[h]);continue}d[h]=p.$Pn(u[h])}}i(d){let u=null,h=null;const l=g=>{g&&(h?this.h(h,g):h=p.$Pn(g))};for(const g of this.overrides)g.identifiers.length===1&&g.identifiers[0]===d?u=g.contents:g.identifiers.includes(d)&&l(g.contents);return l(u),h}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,u){this.j(d,u,!0)}setValue(d,u){this.j(d,u,!1)}removeValue(d){const u=this.keys.indexOf(d);u!==-1&&(this.keys.splice(u,1),(0,A.$Vi)(this.contents,d),P.$eo.test(d)&&this.overrides.splice(this.overrides.findIndex(h=>o.$ub(h.identifiers,(0,P.$fo)(d))),1))}j(d,u,h){(0,A.$Ui)(this.contents,d,u,l=>console.error(l)),h=h||this.keys.indexOf(d)===-1,h&&this.keys.push(d),P.$eo.test(d)&&this.overrides.push({identifiers:(0,P.$fo)(d),keys:Object.keys(this.contents[d]),contents:(0,A.$Ti)(this.contents[d],l=>console.error(l))})}}e.$ko=y;class a{constructor(d){this.f=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,u){if(!$.$5f(d)){const h=this.g(d);this.parseRaw(h,u)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,u){this.a=d;const{contents:h,keys:l,overrides:g,restricted:E,hasExcludedProperties:v}=this.h(d,u);this.b=new y(h,l,g,v?[d]:void 0),this.c=E||[]}g(d){let u={},h=null,l=[];const g=[],E=[];function v(k){Array.isArray(l)?l.push(k):h!==null&&(l[h]=k)}const S={onObjectBegin:()=>{const k={};v(k),g.push(l),l=k,h=null},onObjectProperty:k=>{h=k},onObjectEnd:()=>{l=g.pop()},onArrayBegin:()=>{const k=[];v(k),g.push(l),l=k,h=null},onArrayEnd:()=>{l=g.pop()},onLiteralValue:v,onError:(k,D,F)=>{E.push({error:k,offset:D,length:F})}};if(d)try{I.$Dn(d,S),u=l[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return u}h(d,u){const h=b.$2n.as(P.$7n.Configuration).getConfigurationProperties(),l=this.i(d,h,!0,u);d=l.raw;const g=(0,A.$Ti)(d,S=>console.error(`Conflict in settings file ${this.f}: ${S}`)),E=Object.keys(d),v=this.j(d,S=>console.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:g,keys:E,overrides:v,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(d,u,h,l){let g=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:g};const E={},v=[];for(const S in d)if(P.$eo.test(S)&&h){const k=this.i(d[S],u,!1,l);E[S]=k.raw,g=g||k.hasExcludedProperties,v.push(...k.restricted)}else{const k=u[S],D=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&v.push(S),!l.exclude?.includes(S)&&(l.include?.includes(S)||(D===void 0||l.scopes===void 0||l.scopes.includes(D))&&!(l.skipRestricted&&k?.restricted))?E[S]=d[S]:g=!0}return{raw:E,restricted:v,hasExcludedProperties:g}}j(d,u){const h=[];for(const l of Object.keys(d))if(P.$eo.test(l)){const g={};for(const E in d[l])g[E]=d[l][E];h.push({identifiers:(0,P.$fo)(l),keys:Object.keys(g),contents:(0,A.$Ti)(g,u)})}return h}}e.$lo=a;class m extends M.$Uc{constructor(d,u,h,l){super(),this.c=d,this.f=u,this.g=l,this.b=this.B(new R.$7d),this.onDidChange=this.b.event,this.a=new a(this.c.toString()),this.B(this.g.watch(h.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,g=>g.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,g=>(g.isOperation(0)||g.isOperation(3)||g.isOperation(1)||g.isOperation(4))&&h.isEqual(g.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$mo=m;class c{constructor(d,u,h,l,g,E,v,S,k,D,F,W,B){this.a=d,this.b=u,this.c=h,this.overrideIdentifiers=l,this.d=g,this.f=E,this.g=v,this.h=S,this.i=k,this.j=D,this.k=F,this.l=W,this.m=B}get value(){return C(this.c)}n(d){return d?.value!==void 0||d?.override!==void 0||d?.overrides!==void 0?d:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(d,u,h,l,g=new y,E=new y,v=new L.$Bc,S=new y,k=new L.$Bc){this.c=d,this.d=u,this.f=h,this.g=l,this.h=g,this.i=E,this.j=v,this.l=S,this.m=k,this.a=null,this.b=new L.$Bc,this.n=null}getValue(d,u,h){return this.p(d,u,h).getValue(d)}updateValue(d,u,h={}){let l;h.resource?(l=this.m.get(h.resource),l||(l=new y,this.m.set(h.resource,l))):l=this.l,u===void 0?l.removeValue(d):l.setValue(d,u),h.resource||(this.a=null)}inspect(d,u,h){const l=this.p(d,u,h),g=this.t(u.resource,h),E=u.resource?this.m.get(u.resource)||this.l:this.l,v=new Set;for(const S of l.overrides)for(const k of S.identifiers)l.getOverrideValue(d,k)!==void 0&&v.add(k);return new c(d,u,l.getValue(d),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,h?this.i:void 0,g||void 0,E)}keys(d){const u=this.t(void 0,d);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:u?u.keys.slice(0):[]}}updateDefaultConfiguration(d){this.c=d,this.a=null,this.b.clear()}updatePolicyConfiguration(d){this.d=d}updateApplicationConfiguration(d){this.f=d,this.a=null,this.b.clear()}updateLocalUserConfiguration(d){this.g=d,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(d){this.h=d,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(d){this.i=d,this.a=null,this.b.clear()}updateFolderConfiguration(d,u){this.j.set(d,u),this.b.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this.b.delete(d)}compareAndUpdateDefaultConfiguration(d,u){const h=[];if(!u){const{added:l,updated:g,removed:E}=s(this.c,d);u=[...l,...g,...E]}for(const l of u)for(const g of(0,P.$fo)(l)){const E=this.c.getKeysForOverrideIdentifier(g),v=d.getKeysForOverrideIdentifier(g),S=[...v.filter(k=>E.indexOf(k)===-1),...E.filter(k=>v.indexOf(k)===-1),...E.filter(k=>!p.$Tn(this.c.override(g).getValue(k),d.override(g).getValue(k)))];h.push([g,S])}return this.updateDefaultConfiguration(d),{keys:u,overrides:h}}compareAndUpdatePolicyConfiguration(d){const{added:u,updated:h,removed:l}=s(this.d,d),g=[...u,...h,...l];return g.length&&this.updatePolicyConfiguration(d),{keys:g,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:u,updated:h,removed:l,overrides:g}=s(this.applicationConfiguration,d),E=[...u,...h,...l];return E.length&&this.updateApplicationConfiguration(d),{keys:E,overrides:g}}compareAndUpdateLocalUserConfiguration(d){const{added:u,updated:h,removed:l,overrides:g}=s(this.localUserConfiguration,d),E=[...u,...h,...l];return E.length&&this.updateLocalUserConfiguration(d),{keys:E,overrides:g}}compareAndUpdateRemoteUserConfiguration(d){const{added:u,updated:h,removed:l,overrides:g}=s(this.remoteUserConfiguration,d),E=[...u,...h,...l];return E.length&&this.updateRemoteUserConfiguration(d),{keys:E,overrides:g}}compareAndUpdateWorkspaceConfiguration(d){const{added:u,updated:h,removed:l,overrides:g}=s(this.workspaceConfiguration,d),E=[...u,...h,...l];return E.length&&this.updateWorkspaceConfiguration(d),{keys:E,overrides:g}}compareAndUpdateFolderConfiguration(d,u){const h=this.folderConfigurations.get(d),{added:l,updated:g,removed:E,overrides:v}=s(h,u),S=[...l,...g,...E];return(S.length||!h)&&this.updateFolderConfiguration(d,u),{keys:S,overrides:v}}compareAndDeleteFolderConfiguration(d){const u=this.folderConfigurations.get(d);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:h,updated:l,removed:g,overrides:E}=s(u,void 0);return{keys:[...h,...l,...g],overrides:E}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(d,u,h){let l=this.q(u,h);return u.overrideIdentifier&&(l=l.override(u.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(d)!==void 0&&(l=l.merge(this.d)),l}q({resource:d},u){let h=this.r();if(u&&d){const l=u.getFolder(d);l&&(h=this.s(l.uri)||h);const g=this.m.get(d);g&&(h=h.merge(g))}return h}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(d){let u=this.b.get(d);if(!u){const h=this.r(),l=this.j.get(d);l?(u=h.merge(l),this.b.set(d,u)):u=h}return u}t(d,u){if(u&&d){const h=u.getFolder(d);if(h)return this.j.get(h.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((d,u)=>{const{contents:h,overrides:l,keys:g}=this.j.get(u);return d.push([u,{contents:h,overrides:l,keys:g}]),d},[])}}allKeys(){const d=new Set;return this.c.keys.forEach(u=>d.add(u)),this.userConfiguration.keys.forEach(u=>d.add(u)),this.i.keys.forEach(u=>d.add(u)),this.j.forEach(u=>u.keys.forEach(h=>d.add(h))),[...d.values()]}u(){const d=new Set;return this.c.getAllOverrideIdentifiers().forEach(u=>d.add(u)),this.userConfiguration.getAllOverrideIdentifiers().forEach(u=>d.add(u)),this.i.getAllOverrideIdentifiers().forEach(u=>d.add(u)),this.j.forEach(u=>u.getAllOverrideIdentifiers().forEach(h=>d.add(h))),[...d.values()]}v(d){const u=new Set;return this.c.getKeysForOverrideIdentifier(d).forEach(h=>u.add(h)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(h=>u.add(h)),this.i.getKeysForOverrideIdentifier(d).forEach(h=>u.add(h)),this.j.forEach(h=>h.getKeysForOverrideIdentifier(d).forEach(l=>u.add(l))),[...u.values()]}static parse(d){const u=this.w(d.defaults),h=this.w(d.policy),l=this.w(d.application),g=this.w(d.user),E=this.w(d.workspace),v=d.folders.reduce((S,k)=>(S.set(w.URI.revive(k[0]),this.w(k[1])),S),new L.$Bc);return new i(u,h,l,g,new y,E,v,new y,new L.$Bc)}static w(d){return new y(d.contents,d.keys,d.overrides)}}e.$no=i;function n(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const d=new Set,u=new Map;for(const l of f)l.keys.forEach(g=>d.add(g)),l.overrides.forEach(([g,E])=>{const v=(0,L.$yc)(u,g,new Set);E.forEach(S=>v.add(S))});const h=[];return u.forEach((l,g)=>h.push([g,[...l.values()]])),{keys:[...d.values()],overrides:h}}class r{constructor(d,u,h,l){this.change=d,this.f=u,this.g=h,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const g of d.keys)this.affectedKeys.add(g);for(const[,g]of d.overrides)for(const E of g)this.affectedKeys.add(E);this.d=this.a;for(const g of this.affectedKeys)this.d+=g+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(d,u){const h=this.a+d,l=this.d.indexOf(h);if(l<0)return!1;const g=l+h.length;if(g>=this.d.length)return!1;const E=this.d.charCodeAt(g);if(E!==this.b&&E!==this.c)return!1;if(u){const v=this.previousConfiguration?this.previousConfiguration.getValue(d,u,this.f?.workspace):void 0,S=this.g.getValue(d,u,this.h);return!p.$Tn(v,S)}return!0}}e.$po=r;function s(f,d){const{added:u,removed:h,updated:l}=t(d?.rawConfiguration,f?.rawConfiguration),g=[],E=f?.getAllOverrideIdentifiers()||[],v=d?.getAllOverrideIdentifiers()||[];if(d){const S=v.filter(k=>!E.includes(k));for(const k of S)g.push([k,d.getKeysForOverrideIdentifier(k)])}if(f){const S=E.filter(k=>!v.includes(k));for(const k of S)g.push([k,f.getKeysForOverrideIdentifier(k)])}if(d&&f){for(const S of E)if(v.includes(S)){const k=t({contents:f.getOverrideValue(void 0,S)||{},keys:f.getKeysForOverrideIdentifier(S)},{contents:d.getOverrideValue(void 0,S)||{},keys:d.getKeysForOverrideIdentifier(S)});g.push([S,[...k.added,...k.removed,...k.updated]])}}return{added:u,removed:h,updated:l,overrides:g}}function t(f,d){const u=f?d?f.keys.filter(g=>d.keys.indexOf(g)===-1):[...f.keys]:[],h=d?f?d.keys.filter(g=>f.keys.indexOf(g)===-1):[...d.keys]:[],l=[];if(f&&d){for(const g of d.keys)if(f.keys.indexOf(g)!==-1){const E=(0,A.$Wi)(d.contents,g),v=(0,A.$Wi)(f.contents,g);p.$Tn(E,v)||l.push(g)}}return{added:u,removed:h,updated:l}}}),define(Ee[265],Ce([1,0,21,4,3,81]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gub=e.$eub=e.$dub=void 0,e.$fub=p;const L=(w,A,P)=>{const b=new Uint8Array(16);for(let a=0;a<16;a++)b[a]=Math.round(Math.random()*256);const C=(0,o.$Oe)(o.$ue.wrap(b));return[`GET ws://localhost${w}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${C}`].join(`\r
`)+`\r
\r
`};e.$dub=L,e.$eub=o.$ue.fromString(`\r
\r
`);async function p(w,A,P,b,C){w.write(o.$ue.fromString((0,e.$dub)(A,P,b)));const y=new I.$Tc;try{return await new Promise((a,m)=>{let c;y.add(w.onData(i=>{c?c=o.$ue.concat([c,i],c.byteLength+i.byteLength):c=i;const n=c.indexOf(e.$eub);if(n===-1)return;a(w),w.pauseData();const r=c.slice(n+e.$eub.byteLength);r.byteLength&&C.onData.fire(r)})),y.add(w.onClose(i=>m(i??new Error("socket closed")))),y.add(w.onEnd(()=>m(new Error("socket ended"))))})}catch(a){throw w.dispose(),a}finally{y.dispose()}}class $ extends I.$Uc{constructor(A,P){super(),this.g=A,this.a=this.B(new R.$0d),this.onData=(...b)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...b)),this.b=this.B(new R.$7d),this.onDidDispose=this.b.event,this.f=!1,this.B(P.onData),this.B(P.onData.event(b=>this.a.fire(b))),this.onClose=this.B(P.onClose).event,this.onEnd=this.B(P.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,P){M.SocketDiagnostics.traceSocketEvent(this,this.g,A,P)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$gub=$}),define(Ee[65],Ce([1,0,13,5]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.RemoteAuthorityResolverErrorCode=e.$vl=e.$ul=e.RemoteConnectionType=e.$tl=void 0,e.$xl=w,e.$tl=(0,R.$ii)("remoteAuthorityResolverService");var I;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class M{constructor(P){this.id=P,this.type=1}toString(){return`Managed(${this.id})`}}e.$ul=M;class L{constructor(P,b){this.host=P,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$vl=L;var p;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class $ extends o.$bb{static isNotAvailable(P){return P instanceof $&&P._code===p.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof $&&P._code===p.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof $&&P._code===p.NoResolverFound}static isInvalidAuthority(P){return P instanceof $&&P._code===p.InvalidAuthority}static isHandled(P){return P instanceof $&&P.isHandled}constructor(P,b=p.Unknown,C){super(P),this._message=P,this._code=b,this._detail=C,this.isHandled=b===p.NotAvailable&&C===!0,Object.setPrototypeOf(this,$.prototype)}}e.$wl=$;function w(A){const P=A.indexOf("+");return P===-1?A:A.substring(0,P)}}),define(Ee[266],Ce([1,0,8,21,22,13,4,3,15,58,40,30,81,65]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Cl=E,e.$Dl=v,e.$El=k;const y=30*1e3;var a;(function(_){_[_.Management=1]="Management",_[_.ExtensionHost=2]="ExtensionHost",_[_.Tunnel=3]="Tunnel"})(a||(e.ConnectionType=a={}));function m(_){switch(_){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function c(_){const U=new I.$ee;return setTimeout(()=>U.cancel(),_),U.token}function i(_,U){if(_.isCancellationRequested||U.isCancellationRequested)return I.CancellationToken.Cancelled;const he=new I.$ee;return _.onCancellationRequested(()=>he.cancel()),U.onCancellationRequested(()=>he.cancel()),he.token}class n{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new p.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,o.$bh)(),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function r(_,U){const he=new n(U);return he.registerDisposable(_.onControlMessage(Se=>{const me=JSON.parse(Se.toString()),ie=J(me);ie?he.reject(ie):he.resolve(me)})),he.promise}function s(_,U,he,Se,me,ie,se,oe){const G=new n(oe),ee=A.$3d.create(!1);return _.info(`Creating a socket (${se})...`),w.mark(`code/willCreateSocket/${ie}`),U.connect(he,Se,me,se).then(le=>{G.didTimeout?(w.mark(`code/didCreateSocketError/${ie}`),_.info(`Creating a socket (${se}) finished after ${ee.elapsed()} ms, but this is too late and has timed out already.`),le?.dispose()):(w.mark(`code/didCreateSocketOK/${ie}`),_.info(`Creating a socket (${se}) was successful after ${ee.elapsed()} ms.`),G.resolve(le))},le=>{w.mark(`code/didCreateSocketError/${ie}`),_.info(`Creating a socket (${se}) returned an error after ${ee.elapsed()} ms.`),_.error(le),G.reject(le)}),G.promise}function t(_,U){const he=new n(U);return _.then(Se=>{he.didTimeout||he.resolve(Se)},Se=>{he.didTimeout||he.reject(Se)}),he.promise}async function f(_,U,he,Se){const me=pe(_,U);_.logService.trace(`${me} 1/6. invoking socketFactory.connect().`);let ie;try{ie=await s(_.logService,_.remoteSocketFactoryService,_.connectTo,$.$vg.getServerRootPath(),`reconnectionToken=${_.reconnectionToken}&reconnection=${_.reconnectionProtocol?"true":"false"}`,m(U),`renderer-${m(U)}-${_.reconnectionToken}`,Se)}catch(le){throw _.logService.error(`${me} socketFactory.connect() failed or timed out. Error:`),_.logService.error(le),le}_.logService.trace(`${me} 2/6. socketFactory.connect() was successful.`);let se,oe;_.reconnectionProtocol?(_.reconnectionProtocol.beginAcceptReconnection(ie,null),se=_.reconnectionProtocol,oe=!1):(se=new b.$9h({socket:ie}),oe=!0),_.logService.trace(`${me} 3/6. sending AuthRequest control message.`);const G=await t(_.signService.createNewMessage((0,P.$Eg)()),Se),ee={type:"auth",auth:_.connectionToken||"00000000000000000000",data:G.data};se.sendControl(R.$ue.fromString(JSON.stringify(ee)));try{const le=await r(se,i(Se,c(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(_.logService.trace(`${me} 4/6. received SignRequest control message.`),!await t(_.signService.validate(G,le.signedData),Se)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const Me=await t(_.signService.sign(le.data),Se),be={type:"connectionType",commit:_.commit,signedData:Me,desiredConnectionType:U};return he&&(be.args=he),_.logService.trace(`${me} 5/6. sending ConnectionTypeRequest control message.`),se.sendControl(R.$ue.fromString(JSON.stringify(be))),{protocol:se,ownsProtocol:oe}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(_.logService.error(`${me} the handshake timed out. Error:`),_.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(_.logService.error(`${me} received error control message when negotiating connection. Error:`),_.logService.error(le)),oe&&Z(se),le}}async function d(_,U,he,Se){const me=Date.now(),ie=pe(_,U),{protocol:se,ownsProtocol:oe}=await f(_,U,he,Se),G=new n(Se);return G.registerDisposable(se.onControlMessage(ee=>{const le=JSON.parse(ee.toString()),de=J(le);de?(_.logService.error(`${ie} received error control message when negotiating connection. Error:`),_.logService.error(de),oe&&Z(se),G.reject(de)):(_.reconnectionProtocol?.endAcceptReconnection(),_.logService.trace(`${ie} 6/6. handshake finished, connection is up and running after ${ye(me)}!`),G.resolve({protocol:se,firstMessage:le}))})),G.promise}async function u(_,U){const{protocol:he}=await d(_,1,void 0,U);return{protocol:he}}async function h(_,U,he){const{protocol:Se,firstMessage:me}=await d(_,2,U,he),ie=me&&me.debugPort;return{protocol:Se,debugPort:ie}}async function l(_,U,he){const Se=Date.now(),me=pe(_,3),{protocol:ie}=await f(_,3,U,he);return _.logService.trace(`${me} 6/6. handshake finished, connection is up and running after ${ye(Se)}!`),ie}async function g(_,U,he){const{connectTo:Se,connectionToken:me}=await _.addressProvider.getAddress();return{commit:_.commit,quality:_.quality,connectTo:Se,connectionToken:me,reconnectionToken:U,reconnectionProtocol:he,remoteSocketFactoryService:_.remoteSocketFactoryService,signService:_.signService,logService:_.logService}}async function E(_,U,he){return S(_,async Se=>{const{protocol:me}=await u(Se,I.CancellationToken.None);return new z(_,U,he,Se.reconnectionToken,me)})}async function v(_,U){return S(_,async he=>{const{protocol:Se,debugPort:me}=await h(he,U,I.CancellationToken.None);return new Q(_,U,he.reconnectionToken,Se,me)})}async function S(_,U){for(let Se=1;;Se++)try{const me=(0,P.$Eg)(),ie=await g(_,me,null);return await U(ie)}catch(me){if(Se<5)_.logService.error(`[remote-connection][attempt ${Se}] An error occurred in initial connection! Will retry... Error:`),_.logService.error(me);else throw _.logService.error(`[remote-connection][attempt ${Se}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),_.logService.error(me),O.triggerPermanentFailure(0,0,C.$wl.isHandled(me)),me}}async function k(_,U,he){const Se=await g(_,(0,P.$Eg)(),null);return await l(Se,{host:U,port:he},I.CancellationToken.None)}function D(_){return(0,o.$8g)(U=>new Promise((he,Se)=>{const me=setTimeout(he,_*1e3);U.onCancellationRequested(()=>{clearTimeout(me),he()})}))}var F;(function(_){_[_.ConnectionLost=0]="ConnectionLost",_[_.ReconnectionWait=1]="ReconnectionWait",_[_.ReconnectionRunning=2]="ReconnectionRunning",_[_.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",_[_.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class W{constructor(U,he){this.reconnectionToken=U,this.millisSinceLastIncomingData=he,this.type=0}}e.$Fl=W;class B{constructor(U,he,Se,me){this.reconnectionToken=U,this.millisSinceLastIncomingData=he,this.durationSeconds=Se,this.c=me,this.type=1}skipWait(){this.c.cancel()}}e.$Gl=B;class j{constructor(U,he,Se){this.reconnectionToken=U,this.millisSinceLastIncomingData=he,this.attempt=Se,this.type=2}}e.$Hl=j;class N{constructor(U,he,Se){this.reconnectionToken=U,this.millisSinceLastIncomingData=he,this.attempt=Se,this.type=4}}e.$Il=N;class T{constructor(U,he,Se,me){this.reconnectionToken=U,this.millisSinceLastIncomingData=he,this.attempt=Se,this.handled=me,this.type=3}}e.$Jl=T;class O extends p.$Uc{static triggerPermanentFailure(U,he,Se){this._permanentFailure=!0,this.f=U,this.g=he,this.h=Se,this.j.forEach(me=>me.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}get n(){return this.c||O._permanentFailure}constructor(U,he,Se,me,ie){super(),this.t=U,this.u=he,this.reconnectionToken=Se,this.protocol=me,this.w=ie,this.m=this.B(new L.$7d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new N(this.reconnectionToken,0,0)),this.B(me.onSocketClose(se=>{const oe=te(this.t,this.reconnectionToken,!0);se?se.type===0?(this.u.logService.info(`${oe} received socket close event (hadError: ${se.hadError}).`),se.error&&this.u.logService.error(se.error)):(this.u.logService.info(`${oe} received socket close event (wasClean: ${se.wasClean}, code: ${se.code}, reason: ${se.reason}).`),se.event&&this.u.logService.error(se.event)):this.u.logService.info(`${oe} received socket close event.`),this.y()})),this.B(me.onSocketTimeout(se=>{const oe=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${se.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${se.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${se.timeSinceLastReceivedSomeData}).`),this.y()})),O.j.push(this),this.B((0,p.$Sc)(()=>{const se=O.j.indexOf(this);se>=0&&O.j.splice(se,1)})),this.n&&this.D(O.f,O.g,O.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const he=[0,5,5,10,10,10,10,10,30];let Se=-1;do{Se++;const me=Se<he.length?he[Se]:he[he.length-1];try{if(me>0){const se=D(me);this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),me,se)),this.u.logService.info(`${U} waiting for ${me} seconds before reconnecting...`);try{await se}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Se+1)),this.u.logService.info(`${U} resolving connection...`);const ie=await g(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${ie.connectTo}...`),await this.G(ie,c(y)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Se+1));break}catch(ie){if(ie.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),Se+1,!1);break}if(Se>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),Se+1,!1);break}if(C.$wl.isTemporarilyNotAvailable(ie)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if((ie.code==="ETIMEDOUT"||ie.code==="ENETUNREACH"||ie.code==="ECONNREFUSED"||ie.code==="ECONNRESET")&&ie.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if((0,M.$4)(ie)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if(ie instanceof C.$wl){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),Se+1,C.$wl.isHandled(ie));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),Se+1,!1);break}}while(!this.n&&!this.s)}C(U,he,Se){this.w?O.triggerPermanentFailure(U,he,Se):this.D(U,he,Se)}D(U,he,Se){this.m.fire(new T(this.reconnectionToken,U,he,Se)),Z(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Kl=O,O._permanentFailure=!1,O.f=0,O.g=0,O.h=!1,O.j=[];class z extends O{constructor(U,he,Se,me,ie){super(1,U,me,ie,!0),this.client=this.B(new b.$7h(ie,{remoteAuthority:he,clientId:Se},U.ipcLogger))}async G(U,he){await u(U,he)}}e.$Ll=z;class Q extends O{constructor(U,he,Se,me,ie){super(2,U,Se,me,!1),this.H=he,this.debugPort=ie}async G(U,he){await h(U,this.H,he)}}e.$Ml=Q;function Z(_){try{_.acceptDisconnect();const U=_.getSocket();_.dispose(),U.dispose()}catch(U){(0,M.$1)(U)}}function J(_){if(_&&_.type==="error"){const U=new Error(`Connection error: ${_.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function x(_,U){for(;_.length<U;)_+=" ";return _}function ce(_,U){return`[remote-connection][${x(m(_),13)}][${U.substr(0,5)}\u2026]`}function te(_,U,he){return`${ce(_,U)}[${he?"reconnect":"initial"}]`}function pe(_,U){return`${te(U,_.reconnectionToken,!!_.reconnectionProtocol)}[${_.connectTo}]`}function ye(_){return`${Date.now()-_} ms`}}),define(Ee[86],Ce([1,0,15]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=R,e.$vm=I,e.$wm=M,e.$xm=L;function R($){return $.scheme===o.Schemas.vscodeRemote?$.authority:void 0}function I($){if(!$)return;const w=$.indexOf("+");return w<0?$:$.substr(0,w)}function M($){const{host:w,port:A}=p($);if(typeof A>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:w,port:A}}function L($,w){let{host:A,port:P}=p($);return typeof P>"u"&&(P=w),{host:A,port:P}}function p($){const w=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(w)return{host:w[1],port:parseInt(w[2],10)};const A=$.match(/^(\[[0-9a-z:]+\])$/);if(A)return{host:A[1],port:void 0};const P=$.match(/(.*):(\d+)$/);return P?{host:P[1],port:parseInt(P[2],10)}:{host:$,port:void 0}}}),define(Ee[25],Ce([1,0,14,5,86]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Gm=e.$Fm=e.$Em=e.TargetPlatform=e.ExtensionType=e.$Dm=e.$Bm=e.$Am=e.$zm=e.$ym=void 0,e.$Cm=M,e.$Hm=P,e.$Im=b,e.$Jm=C,e.$Km=y,e.$ym="extensions.user.cache",e.$zm="extensions.builtin.cache",e.$Am="undefined_publisher",e.$Bm=["ui","workspace","web"];function M(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.$Dm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var L;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(L||(e.ExtensionType=L={}));var p;(function(a){a.WIN32_X64="win32-x64",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class ${constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,c){if(typeof m>"u"||m===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof m=="string"||typeof c=="string"){const i=typeof m=="string"?m:m.value,n=typeof c=="string"?c:c.value;return o.$lf(i,n)}return m._lower===c._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$Em=$;class w{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const c of m)this.add(c)}add(m){this.c.add($.toKey(m))}delete(m){return this.c.delete($.toKey(m))}has(m){return this.c.has($.toKey(m))}}e.$Fm=w;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete($.toKey(m))}get(m){return this.c.get($.toKey(m))}has(m){return this.c.has($.toKey(m))}set(m,c){this.c.set($.toKey(m),c)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Gm=A;function P(a){return b(a)}function b(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}function C(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}function y(a,m){if(m){const c=`onResolveRemoteAuthority:${(0,I.$vm)(m)}`;return!!a.activationEvents?.includes(c)}return!1}e.$Lm=(0,R.$ii)("IBuiltinExtensionsScannerService")}),define(Ee[141],Ce([1,0,13,25]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UF=e.$TF=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(L,p){this.a.set(L,p)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const p=Object.create(null);for(const $ of L){const w=this.readActivationEvents($);w.length>0&&(p[R.$Em.toKey($.identifier)]=w)}return p}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const p=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let $=0;$<p.length;$++)p[$]==="onUri"&&(p[$]=`onUri:${R.$Em.toKey(L.identifier)}`);if(!L.contributes)return p;for(const $ in L.contributes){const w=this.a.get($);if(!w)continue;const A=L.contributes[$],P=Array.isArray(A)?A:[A];try{w(P,p)}catch(b){(0,o.$1)(b)}}return p}}e.$TF=I,e.$UF=new I}),define(Ee[267],Ce([1,0,3,5]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=e.$yl=void 0,e.$yl=(0,R.$ii)("remoteSocketFactoryService");class I{constructor(){this.a={}}register(L,p){var $;return($=this.a)[L]??($[L]=[]),this.a[L].push(p),(0,o.$Sc)(()=>{const w=this.a[L]?.indexOf(p);typeof w=="number"&&w>=0&&this.a[L]?.splice(w,1)})}b(L){return(this.a[L.type]||[]).find($=>$.supports(L))}connect(L,p,$,w){const A=this.b(L);if(!A)throw new Error(`No socket factory found for ${L}`);return A.connect(L,p,$,w)}}e.$zl=I}),define(Ee[268],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q0b=void 0;class o{constructor(){this.b=new Map}async createNewMessage(I){try{const M=await this.c();if(M){const L=String(o.a++);return this.b.set(L,M),{id:L,data:M.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,M){if(!I.id)return!0;const L=this.b.get(I.id);if(!L)return!1;this.b.delete(I.id);try{return L.validate(M)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(I){try{return await this.d(I)}catch{}return I}}e.$q0b=o,o.a=1}),define(Ee[110],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.$Al=void 0,e.$Al="signService",e.$Bl=(0,o.$ii)(e.$Al)}),define(Ee[142],Ce([1,0,268]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=void 0;class R extends o.$q0b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(L=>new L.signer().sign(M))}h(){return new Promise((M,L)=>re(["vsda"],M,L))}}e.$mcc=R}),define(Ee[269],Ce([1,0,11,49,30]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=L,e.$4o=p;function M($){if(o.$o===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function L($,w,A,P,b,C,y,a,m){const c=Object.create(null);c["common.machineId"]=C,c["common.sqmId"]=y,c.sessionID=(0,I.$Eg)()+Date.now(),c.commitHash=P,c.version=b,c["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,o.$b)(o.$o),c["common.nodePlatform"]=R.$ec,c["common.nodeArch"]=A,c["common.product"]=m||"desktop",a&&(c["common.msftInternal"]=a);let i=0;const n=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),o.$f&&(c["common.snap"]="true");const r=M(w);return r&&(c["common.platformDetail"]=r),c}function p($){const w=R.env.USERDNSDOMAIN;if(!w)return!1;const A=w.toLowerCase();return $.some(P=>A===P)}}),define(Ee[270],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=void 0,e.$Nl=(0,o.$ii)("telemetryService"),e.$Ol=(0,o.$ii)("customEndpointTelemetryService"),e.$Pl="telemetry.currentSessionDate",e.$Ql="telemetry.firstSessionDate",e.$Rl="telemetry.lastSessionDate",e.$Sl="telemetry.machineId",e.$Tl="telemetry.sqmId",e.$Ul="telemetry",e.$Vl="telemetry.telemetryLevel",e.$Wl="telemetry.enableCrashReporter",e.$Xl="telemetry.enableTelemetry";var R;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var I;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Ee[87],Ce([1,0,24,18,86,269,270]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=void 0,e.$_o=A,e.$ap=P,e.$bp=b,e.$cp=C,e.$dp=a,e.$ep=c,e.$fp=i,e.$gp=s;class p{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.$5o=p;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$6o=$,e.$7o=new $;class w{async publicLog(f,d,u){}async publicLogError(f,d,u){}}e.$8o=w,e.$9o="telemetry",e.$0o="extensionTelemetryLog",e.$$o={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!t.enableTelemetry)}function P(t,f){return f.extensionTestsLocationURI?!0:!(f.isBuilt||f.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function b(t){const f=t.getValue(L.$Vl),d=t.getValue(L.$Wl);if(t.getValue(L.$Xl)===!1||d===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function C(t){const f={},d={},u={};m(t,u);for(let h in u){h=h.length>150?h.substr(h.length-149):h;const l=u[h];typeof l=="number"?d[h]=l:typeof l=="boolean"?d[h]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${h} has been trimmed to 8192, the original length is ${l.length}`),f[h]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(f[h]=l)}return{properties:f,measurements:d}}const y=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(t){if(!t)return"none";const f=(0,I.$vm)(t);return y.has(f)?f:"other"}function m(t,f,d=0,u){if(t)for(const h of Object.getOwnPropertyNames(t)){const l=t[h],g=u?u+h:h;Array.isArray(l)?f[g]=(0,o.$Un)(l):l instanceof Date?f[g]=l.toISOString():(0,R.$Xf)(l)?d<2?m(l,f,d+1,g+"."):f[g]=(0,o.$Un)(l):f[g]=l}}function c(t,f){const d=t.msftInternalDomains||[],u=f.getValue("telemetry.internalTesting");return(0,M.$4o)(d)||u}function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function n(t,f){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let d=t;const u=[];for(const E of f)for(;;){const v=E.exec(t);if(!v)break;u.push([v.index,E.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(d="";;){const E=l.exec(t);if(!E)break;const v=u.some(([S,k])=>E.index<k&&S<l.lastIndex);!h.test(E[0])&&!v&&(d+=t.substring(g,E.index)+"<REDACTED: user-file-path>",g=l.lastIndex)}return g<t.length&&(d+=t.substr(g)),d}function r(t){if(!t)return t;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of f)if(d.regex.test(t))return`<REDACTED: ${d.label}>`;return t}function s(t,f){return(0,o.$Rn)(t,d=>{if(d instanceof p||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let u=d.replaceAll("%20"," ");u=n(u,f);for(const h of f)u=u.replace(h,"");return u=r(u),u}})}}),define(Ee[271],Ce([1,0,14,138,25,11,2,13,49,87]),function(re,e,o,R,I,M,L,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$ip=void 0,e.$hp=A,e.$jp=y,e.$kp=a,e.$lp=m,e.$mp=c,e.$np=i,e.$op=n,e.$pp=r,e.$rp=s,e.$sp=f;function A(d,u){return d.uuid&&u.uuid?d.uuid===u.uuid:d.id===u.id?!0:(0,o.$gf)(d.id,u.id)===0}const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(u){const h=u.manifest?u.manifest.version:u.version,l=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new b(u.identifier,h,l)}static parse(u){const h=P.exec(u);return h&&h[1]&&h[2]?new b({id:h[1]},h[2],h[4]||void 0):null}constructor(u,h,l="undefined"){this.version=h,this.targetPlatform=l,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof b?A(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.$ip=b;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(d){const u=C.exec(d);return u&&u[1]?[m(u[1]),u[2]]:[m(d),void 0]}function a(d,u){return`${d}.${u}`}function m(d){return d.toLowerCase()}function c(d,u){return m(a(d??I.$Am,u))}function i(d,u){const h=[],l=g=>{for(const E of h)if(E.some(v=>A(u(v),u(g))))return E;return null};for(const g of d){const E=l(g);E?E.push(g):h.push([g])}return h}function n(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function r(d){return{id:new w.$5o(d.identifier.id),name:new w.$5o(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$qp=new I.$Em("pprice.better-merge");function s(d,u){const h=[],l=u.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const g=l.shift();if(g&&h.every(E=>!A(E.identifier,{id:g}))){const E=d.filter(v=>A(v.identifier,{id:g}));E.length===1&&(h.push(E[0]),l.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}async function t(d,u){if(!M.$e)return!1;let h;try{h=(await d.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{h=(await d.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(g){u.debug("Error while getting the os-release file.",(0,p.$0)(g))}}return!!h&&(h.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function f(d,u){const h=await t(d,u),l=(0,R.$Oo)(h?"alpine":M.$o,$.$fc);return u.debug("ComputeTargetPlatform:",l),l}}),define(Ee[272],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=o,e.$9r=R,e.$0r=I,e.$$r=M,e.$_r=L,e.$as=p;function o($){return[...$.entries()]}function R($){return $?[...$.entries()]:[]}function I($){return new Map($)}function M($){return new Map($??[])}function L($){return Array.from($.entries()).map(w=>[w[0],o(w[1].map),R(w[1].descriptionMap)])}function p($){return new Map($.map(w=>[w[0],{map:I(w[1]),descriptionMap:M(w[2])}]))}}),define(Ee[273],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yub=void 0;class o{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,M,L=5){const p=M($=>{const w=typeof $=="string"?$:$.data;let A=this.a.get(I);if(A){A.data.push(w);return}const P=setTimeout(()=>this.flushBuffer(I),L);A={data:[w],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(I),p.dispose()}},this.a.set(I,A)});return p}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const M=this.a.get(I);M&&(this.a.delete(I),this.b(I,M.data.join("")))}}e.$yub=o}),define(Ee[274],Ce([1,0,8,78,101,56,4,18,2,215,109,37]),function(re,e,o,R,I,M,L,p,$,w,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3w=e.$2w=e.$1w=e.$Zw=e.$Yw=e.$Xw=e.IconFontDefinition=e.IconContribution=e.$Uw=void 0,e.$Vw=m,e.$Ww=c,e.$Uw={IconContribution:"base.contributions.icons"};var b;(function(s){function t(f,d){let u=f.defaults;for(;M.ThemeIcon.isThemeIcon(u);){const h=a.getIcon(u.id);if(!h)return;u=h.defaults}return u}s.getDefinition=t})(b||(e.IconContribution=b={}));var C;(function(s){function t(d){return{weight:d.weight,style:d.style,src:d.src.map(u=>({format:u.format,location:u.location.toString()}))}}s.toJSONObject=t;function f(d){const u=h=>(0,p.$Vf)(h)?h:void 0;if(d&&Array.isArray(d.src)&&d.src.every(h=>(0,p.$Vf)(h.format)&&(0,p.$Vf)(h.location)))return{weight:u(d.weight),style:u(d.style),src:d.src.map(h=>({format:h.format,location:$.URI.parse(h.location)}))}}s.fromJSONObject=f})(C||(e.IconFontDefinition=C={}));class y{constructor(){this.a=new L.$7d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,w.localize)(0,null)},fontCharacter:{type:"string",description:(0,w.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${M.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,f,d,u){const h=this.b[t];if(h){if(d&&!h.description){h.description=d,this.d.properties[t].markdownDescription=`${d} $(${t})`;const E=this.e.enum.indexOf(t);E!==-1&&(this.e.enumDescriptions[E]=d),this.a.fire()}return h}const l={id:t,description:d,defaults:f,deprecationMessage:u};this.b[t]=l;const g={$ref:"#/definitions/icons"};return u&&(g.deprecationMessage=u),d&&(g.markdownDescription=`${d}: $(${t})`),this.d.properties[t]=g,this.e.enum.push(t),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const f=this.e.enum.indexOf(t);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,f){const d=this.f[t];return d||(this.f[t]=f,this.a.fire(),f)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(h,l)=>h.id.localeCompare(l.id),f=h=>{for(;M.ThemeIcon.isThemeIcon(h.defaults);)h=this.b[h.defaults.id];return`codicon codicon-${h?h.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.b).map(h=>this.b[h]);for(const h of u.filter(l=>!!l.description).sort(t))d.push(`|<i class="${f(h)}"></i>|${h.id}|${M.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const h of u.filter(l=>!M.ThemeIcon.isThemeIcon(l.defaults)).sort(t))d.push(`|<i class="${f(h)}"></i>|${h.id}|`);return d.join(`
`)}}const a=new y;P.$2n.add(e.$Uw.IconContribution,a);function m(s,t,f,d){return a.registerIcon(s,t,f,d)}function c(){return a}function i(){const s=(0,I.$Dj)();for(const t in s){const f="\\"+s[t].toString(16);a.registerIcon(t,{fontCharacter:f})}}i(),e.$Xw="vscode://schemas/icons";const n=P.$2n.as(A.$3n.JSONContribution);n.registerSchema(e.$Xw,a.getIconSchema());const r=new o.$uh(()=>n.notifySchemaChanged(e.$Xw),200);a.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Yw=m("widget-close",R.$Hj.close,(0,w.localize)(2,null)),e.$Zw=m("goto-previous-location",R.$Hj.arrowUp,(0,w.localize)(3,null)),e.$1w=m("goto-next-location",R.$Hj.arrowDown,(0,w.localize)(4,null)),e.$2w=M.ThemeIcon.modify(R.$Hj.sync,"spin"),e.$3w=M.ThemeIcon.modify(R.$Hj.loading,"spin")}),define(Ee[88],Ce([1,0,4,2,53,5,12]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9v=e.$8v=e.$5v=e.$3v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Yv=e.$Xv=void 0,e.$Zv=w,e.$1v=P,e.$2v=b,e.$4v=C,e.$6v=y,e.$7v=a,e.$Xv=(0,M.$ii)("tunnelService"),e.$Yv=(0,M.$ii)("sharedTunnelsService");var p;(function(i){i.Http="http",i.Https="https"})(p||(e.TunnelProtocol=p={}));var $;(function(i){i.ConstantPrivate="constantPrivate",i.Private="private",i.Public="public"})($||(e.TunnelPrivacyId=$={}));function w(i){return!!i.forwardPort}var A;(function(i){i[i.Notify=1]="Notify",i[i.OpenBrowser=2]="OpenBrowser",i[i.OpenPreview=3]="OpenPreview",i[i.Silent=4]="Silent",i[i.Ignore=5]="Ignore",i[i.OpenBrowserOnce=6]="OpenBrowserOnce"})(A||(e.ProvidedOnAutoForward=A={}));function P(i){if(i.scheme!=="http"&&i.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(i.authority);if(n)return{address:n[1],port:+n[2]}}function b(i){if(i.scheme!=="http"&&i.scheme!=="https"||!i.query)return;const n=i.query.split("&");for(const r of n){const s=r.split("=")[1];if(/^https?:/.exec(s)){const t=P(R.URI.parse(s));if(t)return t}}}e.$3v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(i){return e.$3v.indexOf(i)>=0}e.$5v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(i){return e.$5v.indexOf(i)>=0}function a(i,n,r,s){if(r===1)return!1;if(r===2&&y(n)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(t?.length===4&&parseInt(t[1])>=18)return!1}return i<1024}class m{constructor(n,r,s){this.remoteAddress=n,this.localAddress=r,this.b=s,this.a=new o.$7d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$8v=m;let c=class{constructor(n,r){this.k=n,this.l=r,this.a=new o.$7d,this.onTunnelOpened=this.a.event,this.b=new o.$7d,this.onTunnelClosed=this.b.event,this.c=new o.$7d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const n=this.l.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this.f=n,n?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this.g=n.elevation,this.i=n.privacyOptions,this.h=n.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const n=[],r=Array.from(this.e.values());for(const s of r){const t=Array.from(s.values());for(const f of t){const d=await f.value;d&&typeof d!="string"&&n.push(d)}}return n}async dispose(){for(const n of this.e.values()){for(const{value:r}of n.values())await r.then(s=>typeof s!="string"?s?.dispose():void 0);n.clear()}this.e.clear()}setEnvironmentTunnel(n,r,s,t,f){this.q(n,r,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:r,localAddress:s,privacy:t,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,r){(y(n)||C(n))&&(n=e.$3v[0]);const s=this.s(n,r);if(s)return++s.refcount,s.value}openTunnel(n,r,s,t,f,d=!1,u,h){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${s} on local port ${f}.`);const l=this.f??n;if(!l)return;if(r||(r="localhost"),t||(t=this.m),this.f&&this.j.has(s)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const g=this.t(l,r,s,t,f,d,u,h);return g?g.then(E=>{if(E){if(typeof E=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(r,s),E}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(r,s);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.o(E);return(E.tunnelRemoteHost!==r||E.tunnelRemotePort!==s)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),u&&E.privacy!==u&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(v),v}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),g)}o(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const r=this.e.get(n.tunnelRemoteHost);if(r){const s=r.get(n.tunnelRemotePort);s&&(s.refcount--,await this.p(n.tunnelRemoteHost,n.tunnelRemotePort,s))}}}}async p(n,r,s){if(s.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${r}.`);const t=s.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.e.has(n)&&this.e.get(n).delete(r),t}}async closeTunnel(n,r){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${r} `);const s=this.e.get(n);if(s&&s.has(r)){const t=s.get(r);t.refcount=0,await this.p(n,r,t)}}q(n,r,s){this.e.has(n)||this.e.set(n,new Map),this.e.get(n).set(r,{refcount:1,value:s})}async r(n,r){const s=this.e.get(n);if(s){const t=s.get(r),f=t?await t.value:void 0;(!f||typeof f=="string")&&s.delete(r),s.size===0&&this.e.delete(n)}}s(n,r){const s=[n];C(n)?(s.push(...e.$3v),s.push(...e.$5v)):y(n)&&s.push(...e.$5v);const t=s.map(f=>this.e.get(f));for(const f of t){const d=f?.get(r);if(d)return d}}canTunnel(n){return!!P(n)}u(n,r,s,t,f,d,u){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${s} on local port ${t}.`);const h=s;this.j.add(h);const l=t===void 0?s:t,g={elevationRequired:f?this.isPortPrivileged(l):!1},E={remoteAddress:{host:r,port:s},localAddressPort:t,privacy:d,public:d?d!==$.Private:void 0,protocol:u},v=n.forwardPort(E,g);return v?(this.q(r,s,v),v.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(h)})):this.j.delete(h),v}};e.$9v=c,e.$9v=c=Qe([He(0,L.$Oj),He(1,I.$Oi)],c)}),define(Ee[275],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ml=void 0,e.$ml=(0,o.$ii)("IUriIdentityService")}),define(Ee[276],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$0v=void 0,e.$0v=(0,o.$ii)("editSessionIdentityService");var R;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(R||(e.EditSessionIdentityMatch=R={}))}),define(Ee[277],Ce([1,0,15]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=R,e.$3L=I,e.$4L=M,e.$5L=L,e.$6L=p;function R($){return $.scheme!==o.Schemas.file&&$.scheme!==o.Schemas.vscodeRemote}function I($){if($.folders.length)return $.folders.every(w=>R(w.uri))?$.folders[0].uri:void 0;if($.configuration&&R($.configuration))return $.configuration}function M($){return I($)?.scheme}function L($){return I($)?.authority}function p($){return I($)!==void 0}}),define(Ee[43],Ce([1,0,217,17,77,23,2,5,15]),function(re,e,o,R,I,M,L,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Ci=e.$Bi=e.WorkbenchState=e.$vi=e.$ui=e.$ri=void 0,e.$si=w,e.$ti=A,e.$wi=P,e.$xi=b,e.$yi=C,e.$zi=a,e.$Ai=m,e.$Di=n,e.$Ii=r,e.$Ji=s,e.$Li=t,e.$Mi=f,e.$Ni=d,e.$ri=(0,p.$ii)("contextService");function w(u){const h=u;return typeof h?.id=="string"&&L.URI.isUri(h.uri)}function A(u){return typeof u?.id=="string"&&!w(u)&&!b(u)}e.$ui={id:"ext-dev"},e.$vi={id:"empty-window"};function P(u,h){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,R.$oc)(u)}:h?e.$ui:e.$vi;const l=u;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}function b(u){const h=u;return typeof h?.id=="string"&&L.URI.isUri(h.configPath)}function C(u){const h=u;if(h?.uri)return{id:h.id,uri:L.URI.revive(h.uri)};const l=u;if(l?.configPath)return{id:l.id,configPath:L.URI.revive(l.configPath)};if(u?.id)return{id:u.id}}var y;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function a(u){const h=u;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}function m(u){const h=u;return!!(h&&typeof h=="object"&&L.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}class c{constructor(h,l,g,E,v){this.h=h,this.j=g,this.k=E,this.l=v,this.c=I.$oi.forUris(this.l,()=>!0),this.folders=l}update(h){this.h=h.id,this.k=h.configuration,this.j=h.transient,this.l=h.l,this.folders=h.folders}get folders(){return this.g}set folders(h){this.g=h,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(h){this.k=h}getFolder(h){return h&&this.c.findSubstr(h)||null}n(){this.c=I.$oi.forUris(this.l,()=>!0);for(const h of this.folders)this.c.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Bi=c;class i{constructor(h,l){this.raw=l,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,M.$Vg)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ci=i;function n(u){return new i({uri:u,index:0,name:(0,M.$Rg)(u)},{uri:u.toString()})}e.$Ei="code-workspace",e.$Fi=`.${e.$Ei}`,e.$Gi=[{name:(0,o.localize)(0,null),extensions:[e.$Ei]}],e.$Hi="workspace.json";function r(u,h){return M.$Mg.isEqualOrParent(u,h.untitledWorkspacesHome)}function s(u){let h;return L.URI.isUri(u)?h=u:h=u.configuration,h?.scheme===$.Schemas.tmp}e.$Ki="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(u){return u.id===e.$Ki}function f(u,h){return!r(u,h)&&!s(u)}function d(u){return(typeof u=="string"?(0,R.$pc)(u):(0,M.$Tg)(u))===e.$Fi}}),define(Ee[278],Ce([1,0,55,4,3,23,2,216,137,32,5,12,43,27,275,8,30,14,18]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.$ol=e.ProfileResourceType=void 0,e.$nl=r,e.$pl=s,e.$ql=t;var n;(function(u){u.Settings="settings",u.Keybindings="keybindings",u.Snippets="snippets",u.Tasks="tasks",u.Extensions="extensions",u.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function r(u){const h=u;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&typeof h.isDefault=="boolean"&&typeof h.name=="string"&&L.URI.isUri(h.location)&&L.URI.isUri(h.globalStorageHome)&&L.URI.isUri(h.settingsResource)&&L.URI.isUri(h.keybindingsResource)&&L.URI.isUri(h.tasksResource)&&L.URI.isUri(h.snippetsHome)&&L.URI.isUri(h.extensionsResource))}e.$ol=(0,A.$ii)("IUserDataProfilesService");function s(u,h){return{id:u.id,isDefault:u.isDefault,name:u.name,shortName:u.shortName,icon:u.icon,location:L.URI.revive(u.location).with({scheme:h}),globalStorageHome:L.URI.revive(u.globalStorageHome).with({scheme:h}),settingsResource:L.URI.revive(u.settingsResource).with({scheme:h}),keybindingsResource:L.URI.revive(u.keybindingsResource).with({scheme:h}),tasksResource:L.URI.revive(u.tasksResource).with({scheme:h}),snippetsHome:L.URI.revive(u.snippetsHome).with({scheme:h}),extensionsResource:L.URI.revive(u.extensionsResource).with({scheme:h}),cacheHome:L.URI.revive(u.cacheHome).with({scheme:h}),useDefaultFlags:u.useDefaultFlags,isTransient:u.isTransient}}function t(u,h,l,g,E,v){return{id:u,name:h,location:l,isDefault:!1,shortName:E?.shortName,icon:E?.icon,globalStorageHome:v&&E?.useDefaultFlags?.globalState?v.globalStorageHome:(0,M.$Vg)(l,"globalStorage"),settingsResource:v&&E?.useDefaultFlags?.settings?v.settingsResource:(0,M.$Vg)(l,"settings.json"),keybindingsResource:v&&E?.useDefaultFlags?.keybindings?v.keybindingsResource:(0,M.$Vg)(l,"keybindings.json"),tasksResource:v&&E?.useDefaultFlags?.tasks?v.tasksResource:(0,M.$Vg)(l,"tasks.json"),snippetsHome:v&&E?.useDefaultFlags?.snippets?v.snippetsHome:(0,M.$Vg)(l,"snippets"),extensionsResource:v&&E?.useDefaultFlags?.extensions?v.extensionsResource:(0,M.$Vg)(l,"extensions.json"),cacheHome:(0,M.$Vg)(g,u),useDefaultFlags:E?.useDefaultFlags,isTransient:E?.transient}}let f=class extends I.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(h,l,g,E){super(),this.t=h,this.u=l,this.w=g,this.y=E,this.f=!0,this.h=this.B(new R.$7d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$7d),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$7d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$7d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new C.$Bc,emptyWindows:new Map},this.profilesHome=(0,M.$Vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$Vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(h){this.f!==h&&(this.z=void 0,this.f=h)}isEnabled(){return this.f}get C(){if(!this.z){const h=this.D(),l=[h];if(this.f)try{for(const v of this.O()){if(!v.name||!(0,i.$Vf)(v.name)||!v.location){this.y.warn("Skipping the invalid stored profile",v.location||v.name);continue}l.push(t((0,M.$Sg)(v.location),v.name,v.location,this.g,{shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags},h))}}catch(v){this.y.error(v)}const g=new C.$Bc,E=new Map;if(l.length)try{const v=this.Q();if(v.workspaces)for(const[S,k]of Object.entries(v.workspaces)){const D=L.URI.parse(S),F=l.find(W=>W.id===k);F&&g.set(D,F)}if(v.emptyWindows)for(const[S,k]of Object.entries(v.emptyWindows)){const D=l.find(F=>F.id===k);D&&E.set(S,D)}}catch(v){this.y.error(v)}this.z={profiles:l,workspaces:g,emptyWindows:E}}return this.z}D(){const h=t("__default__profile__",(0,p.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...h,extensionsResource:this.S()??h.extensionsResource,isDefault:!0}}async createTransientProfile(h){const l="Temp",g=new RegExp(`${(0,c.$Ze)(l)}\\s(\\d+)`);let E=0;for(const S of this.profiles){const k=g.exec(S.name),D=k?parseInt(k[1]):0;E=D>E?D:E}const v=`${l} ${E+1}`;return this.createProfile((0,o.$9i)((0,m.$Eg)()).toString(16),v,{transient:!0},h)}async createNamedProfile(h,l,g){return this.createProfile((0,o.$9i)((0,m.$Eg)()).toString(16),h,l,g)}async createProfile(h,l,g,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=await this.F(h,l,g);return E&&await this.setProfileForWorkspace(E,v),v}async F(h,l,g){if(!(0,i.$Vf)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let E=this.r.get(l);return E||(E=(async()=>{try{const v=this.profiles.find(D=>D.name===l||D.id===h);if(v)return v;const S=t(h,l,(0,M.$Vg)(this.profilesHome,h),this.g,g,this.defaultProfile);await this.u.createFolder(S.location);const k=[];return this.j.fire({profile:S,join(D){k.push(D)}}),await a.Promises.settled(k),this.I([S],[],[]),S}finally{this.r.delete(l)}})(),this.r.set(l,E)),E}async updateProfile(h,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let g=this.profiles.find(E=>E.id===h.id);if(!g)throw new Error(`Profile '${h.name}' does not exist`);return g=t(g.id,l.name??g.name,g.location,this.g,{shortName:l.shortName??g.shortName,icon:l.icon===null?void 0:l.icon??g.icon,transient:l.transient??g.isTransient,useDefaultFlags:l.useDefaultFlags??g.useDefaultFlags},this.defaultProfile),this.I([],[],[g]),g}async removeProfile(h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(h.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(E=>E.id===h.id);if(!l)throw new Error(`Profile '${h.name}' does not exist`);const g=[];this.m.fire({profile:l,join(E){g.push(E)}});try{await Promise.allSettled(g)}catch(E){this.y.error(E)}for(const E of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(E)?.id&&this.C.emptyWindows.delete(E);for(const E of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(E)?.id&&this.C.workspaces.delete(E);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(E){(0,w.$6k)(E)!==1&&this.y.error(E)}}async setProfileForWorkspace(h,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const g=this.profiles.find(E=>E.id===l.id);if(!g)throw new Error(`Profile '${l.name}' does not exist`);this.L(h,g)}unsetWorkspace(h,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(h,void 0,l)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const h=await this.u.resolve(this.profilesHome);await Promise.all((h.children||[]).filter(l=>l.isDirectory&&this.profiles.every(g=>!this.w.extUri.isEqual(g.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const h=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(h.map(l=>this.removeProfile(l)))}getProfileForWorkspace(h){const l=this.G(h);return L.URI.isUri(l)?this.s.workspaces.get(l)??this.C.workspaces.get(l):this.s.emptyWindows.get(l)??this.C.emptyWindows.get(l)}G(h){return(0,b.$si)(h)?h.uri:(0,b.$xi)(h)?h.configPath:h.id}H(h){return!!([...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,h.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,h.location))||[...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,h.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,h.location)))}I(h,l,g){const E=[...this.profiles,...h],v=[];this.s.profiles=[];for(let S of E)S.isDefault||l.some(k=>S.id===k.id)||(S=g.find(k=>S.id===k.id)??S,S.isTransient?this.s.profiles.push(S):v.push({location:S.location,name:S.name,shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags}));this.P(v),this.z=void 0,this.J(h,l,g)}J(h,l,g){this.h.fire({added:h,removed:l,updated:g,all:this.profiles})}L(h,l,g){g=l?.isTransient?!0:g,g||this.L(h,void 0,!0);const E=this.G(h),v=g?this.s:this.C;L.URI.isUri(E)?(v.workspaces.delete(E),l&&v.workspaces.set(E,l)):(v.emptyWindows.delete(E),l&&v.emptyWindows.set(E,l)),g||this.M()}M(){const h={};for(const[g,E]of this.C.workspaces.entries())h[g.toString()]=E.id;const l={};for(const[g,E]of this.C.emptyWindows.entries())l[g.toString()]=E.id;this.R({workspaces:h,emptyWindows:l}),this.z=void 0}N(h){const l={},g=this.D();if(h.workspaces)for(const[v,S]of Object.entries(h.workspaces)){const k=L.URI.parse(S);l[v]=this.w.extUri.isEqual(k,g.location)?g.id:this.w.extUri.basename(k)}const E={};if(h.emptyWindows)for(const[v,S]of Object.entries(h.emptyWindows)){const k=L.URI.parse(S);E[v]=this.w.extUri.isEqual(k,g.location)?g.id:this.w.extUri.basename(k)}return{workspaces:l,emptyWindows:E}}O(){return[]}P(h){throw new Error("not implemented")}Q(){return{}}R(h){throw new Error("not implemented")}S(){}};e.$rl=f,f.b="userDataProfiles",f.c="profileAssociations",e.$rl=f=Qe([He(0,$.$pi),He(1,w.$Ok),He(2,y.$ml),He(3,P.$Oj)],f);class d extends f{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(h){this.a=h}Q(){return this.X}R(h){this.X=h}}e.$sl=d}),define(Ee[279],Ce([1,0,8,4,3,58,18,178,5,278]),function(re,e,o,R,I,M,L,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Pp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Np=e.$Mp=e.$Lp=void 0,e.$Op=C,e.$Qp=a,e.$Sp=c,e.$Lp="__$__isNewStorageMarker",e.$Mp="__$__targetStorageMarker",e.$Np=(0,$.$ii)("storageService");var A;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var P;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(P||(e.StorageScope=P={}));var b;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function C(i){const n=i.get(e.$Mp);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class y extends I.$Uc{constructor(n={flushInterval:y.a}){super(),this.m=n,this.b=this.B(new R.$0d),this.c=this.B(new R.$0d),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$7d),this.onWillSaveState=this.f.event,this.h=this.B(new o.$uh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new I.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,r,s){return R.Event.filter(this.b.event,t=>t.scope===n&&(r===void 0||t.key===r),s)}n(){this.j.value=(0,o.$yh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,I.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,r){const{key:s,external:t}=r;if(s===e.$Mp){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:s,target:this.J(n)[s],external:t})}w(n){this.f.fire({reason:n})}get(n,r,s){return this.P(r)?.get(n,s)}getBoolean(n,r,s){return this.P(r)?.getBoolean(n,s)}getNumber(n,r,s){return this.P(r)?.getNumber(n,s)}getObject(n,r,s){return this.P(r)?.getObject(n,s)}storeAll(n,r){this.y(()=>{for(const s of n)this.store(s.key,s.value,s.scope,s.target,r)})}store(n,r,s,t,f=!1){if((0,L.$5f)(r)){this.remove(n,s,f);return}this.y(()=>{this.z(n,s,t),this.P(s)?.set(n,r,f)})}remove(n,r,s=!1){this.y(()=>{this.z(n,r,void 0),this.P(r)?.delete(n,s)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,r){const s=[],t=this.J(n);for(const f of Object.keys(t))t[f]===r&&s.push(f);return s}z(n,r,s,t=!1){const f=this.J(r);typeof s=="number"?f[n]!==s&&(f[n]=s,this.P(r)?.set(e.$Mp,JSON.stringify(f),t)):typeof f[n]=="number"&&(delete f[n],this.P(r)?.set(e.$Mp,JSON.stringify(f),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const r=this.P(n);return r?C(r):Object.create(null)}isNew(n){return this.getBoolean(e.$Lp,n)===!0}async flush(n=A.NONE){this.f.fire({reason:n});const r=this.P(-1),s=this.P(0),t=this.P(1);switch(n){case A.NONE:await o.Promises.settled([r?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await o.Promises.settled([r?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,r=this.P(0)?.items??new Map,s=this.P(1)?.items??new Map;return c(n,r,s,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,r){return this.w(A.NONE),(0,w.$nl)(n)?this.R(n,r):this.S(n,r)}M(n,r){return!(n.id===r.id||a(r)&&a(n))}N(n,r,s){this.y(()=>{const t=new Set;for(const[f,d]of n)t.add(f),r.get(f)!==d&&this.u(s,{key:f,external:!0});for(const[f]of r.items)t.has(f)||this.u(s,{key:f,external:!0})})}}e.$Pp=y,y.a=60*1e3;function a(i){return i.isDefault||!!i.useDefaultFlags?.globalState}class m extends y{constructor(){super(),this.U=this.B(new p.$Jp(new p.$Kp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new p.$Jp(new p.$Kp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new p.$Jp(new p.$Kp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$Rp=m;async function c(i,n,r,s,t,f){const d=D=>{try{return JSON.parse(D)}catch{return D}},u=new Map,h=new Map;i.forEach((D,F)=>{u.set(F,D),h.set(F,d(D))});const l=new Map,g=new Map;n.forEach((D,F)=>{l.set(F,D),g.set(F,d(D))});const E=new Map,v=new Map;r.forEach((D,F)=>{E.set(F,D),v.set(F,d(D))}),console.group(s!==t?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const S=[];if(u.forEach((D,F)=>{S.push({key:F,value:D})}),console.table(S),console.groupEnd(),console.log(h),s!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const D=[];l.forEach((F,W)=>{D.push({key:W,value:F})}),console.table(D),console.groupEnd(),console.log(g)}console.group(`Storage: Workspace (path: ${f})`);const k=[];E.forEach((D,F)=>{k.push({key:F,value:D})}),console.table(k),console.groupEnd(),console.log(v)}}),define(Ee[111],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yjc=void 0;class o{constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const M=this.c++;return this.b.set(M,I),this.e(),M}get(I,M){return this.b.has(I)?this.b.get(I)[M]:void 0}delete(I){this.b.delete(I),this.e()}e(){o.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$yjc=o,o.a=!1}),define(Ee[59],Ce([1,0,15,23,5]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ejc=e.$Djc=void 0;class M{constructor(){this.a=new Set(Object.keys(o.Schemas)),this.b=new Map,this.extUri=new R.$Kg(p=>{const $=this.b.get(p.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(p,$){$===null?this.b.delete(p.scheme):this.b.set(p.scheme,$)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$Djc=M,e.$Ejc=(0,I.$ii)("IExtHostFileSystemInfo")}),define(Ee[28],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5O=void 0,e.$5O=(0,o.$ii)("IExtHostInitDataService")}),define(Ee[280],Ce([1,0,223,12,260,28]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=void 0;let L=class extends I.$bQ{constructor($,w,A){const P=A.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",b=A.remote.isRemote?(0,o.localize)(0,null):$?(0,o.localize)(1,null):(0,o.localize)(2,null);super(w.createLogger(P,{name:b}))}};e.$Mlc=L,e.$Mlc=L=Qe([He(1,R.$Pj),He(2,M.$5O)],L)}),define(Ee[281],Ce([1,0,8]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nkc=e.$mkc=void 0;class R{constructor(L,p,$){this.h=new Map,this.a=L,this.b=p,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(w=>(this.f=w,this)),this.g=this.c.onDidChangeStorage(w=>{w.shared===this.b&&w.key===this.a&&(this.f=w.value)}),this.i=new o.$uh(()=>{const w=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of w.values())A.complete()}catch(A){for(const P of w.values())P.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,p){let $=this.f[L];return typeof $>"u"&&($=p),$}update(L,p){this.f[L]=p;const $=this.h.get(L);if($!==void 0)return $.p;const w=new o.$Fh;return this.h.set(L,w),this.i.isScheduled()||this.i.schedule(),w.p}dispose(){this.g.dispose()}}e.$mkc=R;class I extends R{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,p){super(L.identifier.value,!0,p),this.j=L}}e.$nkc=I}),define(Ee[282],Ce([1,0,4,2]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=void 0;class I{constructor(L){this.c=L,this.a=new o.$7d,this.onDidSaveNotebookDocument=this.a.event,this.b=new o.$7d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,p,$,w){const P=this.c.getNotebookDocument(R.URI.revive(L)).acceptModelChanged(p.value,$,w);this.b.fire(P)}$acceptDirtyStateChanged(L,p){this.c.getNotebookDocument(R.URI.revive(L)).acceptDirty(p)}$acceptModelSaved(L){const p=this.c.getNotebookDocument(R.URI.revive(L));this.a.fire(p.apiNotebook)}}e.$alc=I}),define(Ee[20],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PO=e.$OO=void 0,e.$OO=(0,o.$ii)("IExtHostRpcService");class R{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$PO=R});var it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o},qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Ee[283],Ce([1,0,25,4]),function(re,e,o,R){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$ukc=void 0;class M{constructor(p,$){I.set(this,void 0),this.b=new R.$7d,this.onDidChange=this.b.event,this.a=o.$Em.toKey(p.identifier),it(this,I,$,"f"),qe(this,I,"f").onDidChangePassword(w=>{w.extensionId===this.a&&this.b.fire({key:w.key})})}get(p){return qe(this,I,"f").get(this.a,p)}store(p,$){return qe(this,I,"f").store(this.a,p,$)}delete(p){return qe(this,I,"f").delete(this.a,p)}}e.$ukc=M,I=new WeakMap}),define(Ee[66],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xjc=e.$Wjc=void 0,e.$Wjc=(0,o.$ii)("IURITransformerService");class R{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.$Xjc=R}),define(Ee[284],Ce([1,0,21]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pnb=I,e.$Qnb=L;class R{constructor(){this.buffers=[]}add($){let w=this.buffers.indexOf($);return w<0&&(w=this.buffers.length,this.buffers.push($)),w}}function I(p,$){if($.serializeBuffersForPostMessage){const w=new R,P=JSON.stringify(p,(C,y)=>{if(y instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:w.add(y)};if(ArrayBuffer.isView(y)){const a=M(y);if(a)return{$$vscode_array_buffer_reference$$:!0,index:w.add(y.buffer),view:{type:a,byteLength:y.byteLength,byteOffset:y.byteOffset}}}return y}),b=w.buffers.map(C=>{const y=new Uint8Array(C);return o.$ue.wrap(y)});return{message:P,buffers:b}}else return{message:JSON.stringify(p),buffers:[]}}function M(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function L(p,$){const w=$.map(b=>{const C=new ArrayBuffer(b.byteLength);return new Uint8Array(C).set(b.buffer),C}),A=$.length?(b,C)=>{if(C&&typeof C=="object"&&C.$$vscode_array_buffer_reference$$){const y=C,{index:a}=y,m=w[a];if(y.view)switch(y.view.type){case 1:return new Int8Array(m,y.view.byteOffset,y.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,y.view.byteOffset,y.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,y.view.byteOffset,y.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,y.view.byteOffset,y.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,y.view.byteOffset,y.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,y.view.byteOffset,y.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,y.view.byteOffset,y.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,y.view.byteOffset,y.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,y.view.byteOffset,y.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,y.view.byteOffset,y.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,y.view.byteOffset,y.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return C}:void 0;return{message:JSON.parse(p,A),arrayBuffers:w}}}),define(Ee[285],Ce([1,0,112,397,398,63,2,12,399]),function(re,e,o,R,I,M,L,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$imc=A;const w=!1;function A(n,r,s,t,f,d){const u=d.environment.useHostProxy,h=typeof u=="boolean"?u:!d.remote.isRemote,l={resolveProxy:v=>n.resolveProxy(v),lookupProxyAuthorization:m.bind(void 0,t,f,r,{},d.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>b(r),addCertificatesV2:()=>C(r),log:t,getLogLevel:()=>{const v=t.getLevel();switch(v){case p.LogLevel.Trace:return $.LogLevel.Trace;case p.LogLevel.Debug:return $.LogLevel.Debug;case p.LogLevel.Info:return $.LogLevel.Info;case p.LogLevel.Warning:return $.LogLevel.Warning;case p.LogLevel.Error:return $.LogLevel.Error;case p.LogLevel.Off:return $.LogLevel.Off;default:return S(v)}function S(k){return t.error("Unknown log level",k),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:h,loadAdditionalCertificates:async()=>{const v=[];if(d.remote.isRemote&&v.push((0,$.loadSystemCertificates)({log:t})),h){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const S=n.loadCertificates();S.then(k=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",k.length)),v.push(S)}return(await Promise.all(v)).flat()},env:process.env},g=(0,$.createProxyResolver)(l),E=P(l,g);return a(s,E)}function P(n,r){return{http:Object.assign(o,(0,$.createHttpPatch)(n,o,r)),https:Object.assign(R,(0,$.createHttpPatch)(n,R,r)),net:Object.assign(M,(0,$.createNetPatch)(n,M)),tls:Object.assign(I,(0,$.createTlsPatch)(n,I))}}function b(n){const r=n.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",w)&&!!r.get("systemCertificates")}function C(n){const r=n.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",w)&&!!r.get("systemCertificates")}const y=new Map;function a(n,r){return n.getExtensionPathIndex().then(s=>{const t=globalThis._VSCODE_NODE_MODULES.module,f=t._load;t._load=function(u,h,l){if(u==="net")return r.net;if(u==="tls")return r.tls;if(u!=="http"&&u!=="https")return f.apply(this,arguments);const g=s.findSubstr(L.URI.file(h.filename));let E=y.get(g);if(E||y.set(g,E={}),!E[u]){const v=r[u];E[u]={...v}}return E[u]}})}async function m(n,r,s,t,f,d,u,h){const l=t[d];u&&(t[d]=u),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${u}`,`proxyAuthenticateCache:${l}`);const g=u||l,E=Array.isArray(g)?g:typeof g=="string"?[g]:[];if(i(r,E,f),E.some(v=>/^(Negotiate|Kerberos)( |$)/i.test(v))&&!h.kerberosRequested)try{h.kerberosRequested=!0;const v=await new Promise((W,B)=>{re(["kerberos"],W,B)}),S=new URL(d),k=s.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${S.hostname}`:`HTTP@${S.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${k}`),"Negotiate "+await(await v.initializeClient(k)).step("")}catch(v){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",v)}}let c=!1;function i(n,r,s){c||!r.length||(c=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:s?"remote":"local"}))}}),define(Ee[286],Ce([1,0,131]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=I;function R(M){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:M,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function I(M){return new o.$ln(R(M))}}),define(Ee[143],Ce([1,0,233,18,2,3,5,37,32,15,47,197,41]),function(re,e,o,R,I,M,L,p,$,w,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$uF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$lF=e.EditorInputCapabilities=e.$kF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=void 0,e.$bF=a,e.$cF=m,e.$dF=c,e.$eF=i,e.$fF=n,e.$gF=r,e.$hF=s,e.$iF=t,e.$jF=f,e.$mF=E,e.$nF=S,e.$oF=k,e.$pF=D,e.$qF=F,e.$rF=W,e.$sF=B,e.$tF=Q,e.$vF=x,e.$wF=te,e.$xF=pe,e.$yF=ye,e.$9E={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$0E={id:"default",displayName:(0,o.localize)(0,null),providerDisplayName:(0,o.localize)(1,null)},e.$$E="workbench.editor.sidebysideEditor",e.$_E="workbench.editors.textDiffEditor",e.$aF="workbench.editors.binaryResourceDiffEditor";var C;(function(_){_[_.PROGRAMMATIC=1]="PROGRAMMATIC",_[_.USER=2]="USER",_[_.EDIT=3]="EDIT",_[_.NAVIGATION=4]="NAVIGATION",_[_.JUMP=5]="JUMP"})(C||(e.EditorPaneSelectionChangeReason=C={}));var y;(function(_){_[_.IDENTICAL=1]="IDENTICAL",_[_.SIMILAR=2]="SIMILAR",_[_.DIFFERENT=3]="DIFFERENT"})(y||(e.EditorPaneSelectionCompareResult=y={}));function a(_){const U=_;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function m(_){const U=_;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function c(_,U,he){for(const Se of he.visibleEditorPanes)if(Se.group.id===U&&_.matches(Se.input))return Se.getViewState()}function i(_){if(E(_))return!1;const U=_;return I.URI.isUri(U?.resource)}function n(_){if(E(_))return!1;const U=_;return U?.original!==void 0&&U.modified!==void 0}function r(_){if(E(_))return!1;const U=_;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function s(_){if(E(_)||n(_))return!1;const U=_;return U?.primary!==void 0&&U.secondary!==void 0}function t(_){if(E(_))return!1;const U=_;return U?U.resource===void 0||U.resource.scheme===w.Schemas.untitled||U.forceUntitled===!0:!1}function f(_){if(E(_))return!1;const U=_;return I.URI.isUri(U?.base?.resource)&&I.URI.isUri(U?.input1?.resource)&&I.URI.isUri(U?.input2?.resource)&&I.URI.isUri(U?.result?.resource)}var d;(function(_){_[_.SHORT=0]="SHORT",_[_.MEDIUM=1]="MEDIUM",_[_.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var u;(function(_){_[_.EXPLICIT=1]="EXPLICIT",_[_.AUTO=2]="AUTO",_[_.FOCUS_CHANGE=3]="FOCUS_CHANGE",_[_.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class h{constructor(){this.a=new Map}registerSource(U,he){let Se=this.a.get(U);return Se||(Se={source:U,label:he},this.a.set(U,Se)),Se.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$kF=new h;var l;(function(_){_[_.None=0]="None",_[_.Readonly=2]="Readonly",_[_.Untitled=4]="Untitled",_[_.Singleton=8]="Singleton",_[_.RequiresTrust=16]="RequiresTrust",_[_.CanSplitInGroup=32]="CanSplitInGroup",_[_.ForceDescription=64]="ForceDescription",_[_.CanDropIntoEditor=128]="CanDropIntoEditor",_[_.MultipleEditors=256]="MultipleEditors",_[_.Scratchpad=512]="Scratchpad"})(l||(e.EditorInputCapabilities=l={}));class g extends M.$Uc{}e.$lF=g;function E(_){return _ instanceof g}function v(_){const U=_;return I.URI.isUri(U?.preferredResource)}function S(_){const U=_;return E(U?.primary)&&E(U?.secondary)}function k(_){const U=_;return E(U?.modified)&&E(U?.original)}function D(_,U,he,Se,me){return ye(Se,[(0,P.$5i)({id:"workbench.action.openLargeFile",label:(0,o.localize)(2,null),run:()=>{const ie={...he,limits:{size:Number.MAX_VALUE}};_.openEditor(U,ie)}}),(0,P.$5i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,o.localize)(3,null),run:()=>me.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:b.default.Warning})}function F(_){return E(_?.editor)}function W(_){const U=_;return F(_)&&U?.group!==void 0}function B(_){const U=_;return typeof U?.groupId=="number"&&E(U.editor)}var j;(function(_){_[_.UNKNOWN=0]="UNKNOWN",_[_.REPLACE=1]="REPLACE",_[_.MOVE=2]="MOVE",_[_.UNPIN=3]="UNPIN"})(j||(e.EditorCloseContext=j={}));var N;(function(_){_[_.GROUP_ACTIVE=0]="GROUP_ACTIVE",_[_.GROUP_INDEX=1]="GROUP_INDEX",_[_.GROUP_LABEL=2]="GROUP_LABEL",_[_.GROUP_LOCKED=3]="GROUP_LOCKED",_[_.EDITOR_OPEN=4]="EDITOR_OPEN",_[_.EDITOR_CLOSE=5]="EDITOR_CLOSE",_[_.EDITOR_MOVE=6]="EDITOR_MOVE",_[_.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",_[_.EDITOR_LABEL=8]="EDITOR_LABEL",_[_.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",_[_.EDITOR_PIN=10]="EDITOR_PIN",_[_.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",_[_.EDITOR_STICKY=12]="EDITOR_STICKY",_[_.EDITOR_DIRTY=13]="EDITOR_DIRTY",_[_.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(N||(e.GroupModelChangeKind=N={}));var T;(function(_){_[_.PRIMARY=1]="PRIMARY",_[_.SECONDARY=2]="SECONDARY",_[_.BOTH=3]="BOTH",_[_.ANY=4]="ANY"})(T||(e.SideBySideEditor=T={}));class O{getOriginalUri(U,he){if(!U)return;if(f(U))return e.$uF.getOriginalUri(U.result,he);if(he?.supportSideBySide){const{primary:me,secondary:ie}=this.a(U);if(me&&ie){if(he?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(me,{filterByScheme:he.filterByScheme}),secondary:this.getOriginalUri(ie,{filterByScheme:he.filterByScheme})};if(he?.supportSideBySide===T.ANY)return this.getOriginalUri(me,{filterByScheme:he.filterByScheme})??this.getOriginalUri(ie,{filterByScheme:he.filterByScheme});U=he.supportSideBySide===T.PRIMARY?me:ie}}if(n(U)||r(U)||s(U)||f(U))return;const Se=v(U)?U.preferredResource:U.resource;return!Se||!he||!he.filterByScheme?Se:this.b(Se,he.filterByScheme)}a(U){return S(U)||s(U)?{primary:U.primary,secondary:U.secondary}:k(U)||n(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,he){if(!U)return;if(f(U))return e.$uF.getCanonicalUri(U.result,he);if(he?.supportSideBySide){const{primary:me,secondary:ie}=this.a(U);if(me&&ie){if(he?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(me,{filterByScheme:he.filterByScheme}),secondary:this.getCanonicalUri(ie,{filterByScheme:he.filterByScheme})};if(he?.supportSideBySide===T.ANY)return this.getCanonicalUri(me,{filterByScheme:he.filterByScheme})??this.getCanonicalUri(ie,{filterByScheme:he.filterByScheme});U=he.supportSideBySide===T.PRIMARY?me:ie}}if(n(U)||r(U)||s(U)||f(U))return;const Se=U.resource;return!Se||!he||!he.filterByScheme?Se:this.b(Se,he.filterByScheme)}b(U,he){if(Array.isArray(he)){if(he.some(Se=>U.scheme===Se))return U}else if(he===U.scheme)return U}}var z;(function(_){_[_.UNKNOWN=0]="UNKNOWN",_[_.KEYBOARD=1]="KEYBOARD",_[_.MOUSE=2]="MOUSE"})(z||(e.EditorCloseMethod=z={}));function Q(_,U,he,Se){if(!_.isSticky(U))return!1;switch(Se.preventPinnedEditorClose){case"keyboardAndMouse":return he===z.MOUSE||he===z.KEYBOARD;case"mouse":return he===z.MOUSE;case"keyboard":return he===z.KEYBOARD}return!1}e.$uF=new O;var Z;(function(_){_[_.LEFT=0]="LEFT",_[_.RIGHT=1]="RIGHT"})(Z||(e.CloseDirection=Z={}));class J{constructor(){this.c=new Map,this.d=new Map}start(U){const he=this.a=U.get(L.$hi);for(const[Se,me]of this.c)this.e(Se,me,he);this.c.clear()}e(U,he,Se){const me=Se.createInstance(he);this.d.set(U,me)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,R.$7f)(this.b)}registerEditorSerializer(U,he){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,he,this.a):this.c.set(U,he),(0,M.$Sc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}p.$2n.add(e.$9E.EditorFactory,new J);async function x(_,U,he){return!_||!_.length?[]:await Promise.all(_.map(async Se=>{const me=I.URI.revive(Se.fileUri);if(!me){he.info("Cannot resolve the path because it is not valid.",Se);return}if(!await U.canHandleResource(me)){he.info("Cannot resolve the path because it cannot be handled",Se);return}let se=Se.exists,oe=Se.type;if(typeof se!="boolean"||typeof oe!="number")try{oe=(await U.stat(me)).isDirectory?$.FileType.Directory:$.FileType.Unknown,se=!0}catch(ee){he.error(ee),se=!1}if(!se&&Se.openOnlyIfExists){he.info("Cannot resolve the path because it does not exist",Se);return}if(oe===$.FileType.Directory){he.info("Cannot resolve the path because it is a directory",Se);return}const G={...Se.options,pinned:!0};return se?{resource:me,options:G}:{resource:me,options:G,forceUntitled:!0}}))}var ce;(function(_){_[_.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",_[_.SEQUENTIAL=1]="SEQUENTIAL"})(ce||(e.EditorsOrder=ce={}));function te(_){const U=_;if(!U)return!1;const he=U;if(he.modified)return te(he.modified);const Se=U;return!!(Se.contributionsState&&Se.viewState&&Array.isArray(Se.cursorState))}function pe(_){return(0,A.$7i)(_)}function ye(_,U,he){const Se=(0,A.$8i)(_,U);return Se.forceMessage=he?.forceMessage,Se.forceSeverity=he?.forceSeverity,Se.allowDialog=he?.allowDialog,Se}}),define(Ee[287],Ce([1,0,4,234,5,3,27,37,19,24,78,274]),function(re,e,o,R,I,M,L,p,$,w,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GF=e.$FF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$EF=e.ViewContentGroups=e.$CF=e.ViewContainerLocation=e.Extensions=e.$BF=e.$AF=e.$zF=void 0,e.$DF=y,e.$zF="views",e.$AF=(0,R.localize)(0,null),e.$BF=(0,P.$Vw)("default-view-icon",A.$Hj.window,(0,R.localize)(1,null));var b;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})(b||(e.Extensions=b={}));var C;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel",f[f.AuxiliaryBar=2]="AuxiliaryBar"})(C||(e.ViewContainerLocation=C={})),e.$CF=[0,1,2];function y(f){switch(f){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class a extends M.$Uc{constructor(){super(...arguments),this.c=this.B(new o.$7d),this.onDidRegister=this.c.event,this.f=this.B(new o.$7d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(d,u,h){const l=this.get(d.id);if(l)return l;const g=d;return g.openCommandActionDescriptor=h?.doNotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,L.$yc)(this.g,u,[]).push(g),h?.isDefault&&this.h.push(g),this.c.fire({viewContainer:g,viewContainerLocation:u}),g}deregisterViewContainer(d){for(const u of this.g.keys()){const h=this.g.get(u),l=h?.indexOf(d);if(l!==-1){h?.splice(l,1),h.length===0&&this.g.delete(u),this.f.fire({viewContainer:d,viewContainerLocation:u});return}}}get(d){return this.all.filter(u=>u.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(u=>this.getViewContainers(u).filter(h=>h?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(u=>this.getViewContainerLocation(u)===d)}}p.$2n.add(b.ViewContainersRegistry,new a);var m;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(m||(e.ViewContentGroups=m={}));function c(f,d){const u=f.group??m.More,h=d.group??m.More;return u!==h?u.localeCompare(h):(f.order??5)-(d.order??5)}class i extends M.$Uc{constructor(){super(...arguments),this.c=this.B(new o.$7d),this.onViewsRegistered=this.c.event,this.f=this.B(new o.$7d),this.onViewsDeregistered=this.f.event,this.g=this.B(new o.$7d),this.onDidChangeContainer=this.g.event,this.h=this.B(new o.$7d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new L.$Hc}registerViews(d,u){this.registerViews2([{views:d,viewContainer:u}])}registerViews2(d){d.forEach(({views:u,viewContainer:h})=>this.r(u,h)),this.c.fire(d)}deregisterViews(d,u){const h=this.s(d,u);h.length&&this.f.fire({views:h,viewContainer:u})}moveViews(d,u){for(const h of this.m.keys())if(h!==u){const l=this.s(d,h);l.length&&(this.r(l,u),this.g.fire({views:l,from:h,to:u}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const u of this.j){const h=(this.m.get(u)||[]).filter(l=>l.id===d)[0];if(h)return h}return null}getViewContainer(d){for(const u of this.j)if((this.m.get(u)||[]).filter(l=>l.id===d)[0])return u;return null}registerViewWelcomeContent(d,u){return this.n.add(d,u),this.h.fire(d),(0,M.$Sc)(()=>{this.n.delete(d,u),this.h.fire(d)})}registerViewWelcomeContent2(d,u){const h=new Map;for(const[l,g]of u)this.n.add(d,g),h.set(l,(0,M.$Sc)(()=>{this.n.delete(d,g),this.h.fire(d)}));return this.h.fire(d),h}getViewWelcomeContent(d){const u=[];return this.n.forEach(d,h=>u.push(h)),u.sort(c)}r(d,u){let h=this.m.get(u);h||(h=[],this.m.set(u,h),this.j.push(u));for(const l of d){if(this.getView(l.id)!==null)throw new Error((0,R.localize)(2,null,l.id));h.push(l)}}s(d,u){const h=this.m.get(u);if(!h)return[];const l=[],g=[];for(const E of h)d.includes(E)?l.push(E):g.push(E);return l.length&&(g.length?this.m.set(u,g):(this.m.delete(u),this.j.splice(this.j.indexOf(u),1))),l}}p.$2n.add(b.ViewsRegistry,new i),e.$EF=(0,I.$ii)("viewDescriptorService");var n;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var r;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class s{constructor(d,u){this.c=!1,this.d=!1,(0,w.$Sn)(this,d),this.d=!!u,this.resolve=async h=>{if(u&&!this.c){const l=await u(h);l&&(this.tooltip=this.tooltip??l.tooltip,this.command=this.command??l.command)}h.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$FF=s;class t extends Error{constructor(d){super((0,R.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$GF=t}),define(Ee[288],Ce([1,0,4,39,3,42,5]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IG=e.$HG=e.$GG=e.ChatAgentLocation=void 0;var p;(function(A){A.Panel="panel",A.Terminal="terminal",A.Notebook="notebook",A.Editor="editor"})(p||(e.ChatAgentLocation=p={})),function(A){function P(b){switch(b){case"panel":return A.Panel;case"terminal":return A.Terminal;case"notebook":return A.Notebook}return A.Panel}A.fromRaw=P}(p||(e.ChatAgentLocation=p={})),e.$GG=(0,L.$ii)("chatAgentService");let $=class{constructor(P){this.e=P,this.b=[],this.d=new o.$7d,this.onDidChangeAgents=this.d.event}registerAgent(P,b){if(this.getAgent(P))throw new Error(`Agent already registered: ${JSON.stringify(P)}`);const y=this,a=b.slashCommands;b={...b,get slashCommands(){return a.filter(c=>!c.when||y.e.contextMatchesRules(M.$gj.deserialize(c.when)))}};const m={data:b};return this.b.push(m),(0,I.$Sc)(()=>{this.b=this.b.filter(c=>c!==m),this.d.fire(void 0)})}registerAgentImplementation(P,b){const C=this.f(P);if(!C)throw new Error(`Unknown agent: ${JSON.stringify(P)}`);if(C.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(P)}`);return C.impl=b,this.d.fire(new w(C.data,b)),(0,I.$Sc)(()=>{C.impl=void 0,this.d.fire(void 0)})}registerDynamicAgent(P,b){const C={data:P,impl:b};return this.b.push(C),this.d.fire(new w(P,b)),(0,I.$Sc)(()=>{this.b=this.b.filter(y=>y!==C),this.d.fire(void 0)})}updateAgent(P,b){const C=this.f(P);if(!C?.impl)throw new Error(`No activated agent with id ${JSON.stringify(P)} registered`);C.data.metadata={...C.data.metadata,...b},this.d.fire(new w(C.data,C.impl))}getDefaultAgent(P){return this.getActivatedAgents().find(b=>!!b.isDefault&&b.locations.includes(P))}getSecondaryAgent(){return R.Iterable.find(this.b.values(),P=>!!P.data.metadata.isSecondary)?.data}f(P){return this.b.find(b=>b.data.id===P)}getAgent(P){return this.f(P)?.data}getAgents(){return this.b.map(P=>P.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(P=>!!P.impl).map(P=>new w(P.data,P.impl))}getAgentsByName(P){return this.getAgents().filter(b=>b.name===P)}async invokeAgent(P,b,C,y,a){const m=this.f(P);if(!m?.impl)throw new Error(`No activated agent with id ${P}`);return await m.impl.invoke(b,C,y,a)}async getFollowups(P,b,C,y,a){const m=this.f(P);if(!m?.impl)throw new Error(`No activated agent with id ${P}`);return m.impl?.provideFollowups?m.impl.provideFollowups(b,C,y,a):[]}};e.$HG=$,$.AGENT_LEADER="@",e.$HG=$=Qe([He(0,M.$Aj)],$);class w{constructor(P,b){this.b=P,this.d=b}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(P,b,C,y){return this.d.invoke(P,b,C,y)}async provideFollowups(P,b,C,y){return this.d.provideFollowups?this.d.provideFollowups(P,b,C,y):[]}provideWelcomeMessage(P){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(P)}provideSampleQuestions(P){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(P)}}e.$IG=w}),define(Ee[289],Ce([1,0,2,29,5]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SF=e.$RF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$PF=M,e.$QF=L;function M(w){return!!w&&typeof w=="object"&&"uri"in w&&w.uri instanceof o.URI&&"version"in w&&typeof w.version=="number"&&"ranges"in w&&Array.isArray(w.ranges)&&w.ranges.every(R.$dt.isIRange)}function L(w){return!!w&&typeof w=="object"&&"documents"in w&&Array.isArray(w.documents)&&w.documents.every(M)}var p;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var $;(function(w){w[w.Action=1]="Action",w[w.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$RF=(0,I.$ii)("IChatService"),e.$SF="accessibility.voice.keywordActivation"}),define(Ee[144],Ce([1,0,4,8,235]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kob=void 0;class M{constructor(){this.f=new Map,this.m=[],this.n=new o.$7d,this.o=new o.$7d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(p){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=p}onEvent(p){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=p}onRequest(p){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.u("response",p)}sendRequest(p,$,w,A){const P={command:p};if($&&Object.keys($).length>0&&(P.arguments=$),this.u("request",P),typeof A=="number"){const b=setTimeout(()=>{clearTimeout(b);const C=this.f.get(P.seq);if(C){this.f.delete(P.seq);const y={type:"response",seq:0,request_seq:P.seq,success:!1,command:p,message:(0,I.localize)(0,null,A,p)};C(y)}},A)}return w&&this.f.set(P.seq,w),P.seq}acceptMessage(p){this.k?this.k(p):(this.m.push(p),this.m.length===1&&this.s())}q(p,$){return p.type!=="event"||$.type!=="event"}async s(){let p;for(;this.m.length;){if((!p||this.q(this.m[0],p))&&await(0,R.$jh)(0),p=this.m.shift(),!p)return;switch(p.type){case"event":this.j?.(p);break;case"request":this.g?.(p);break;case"response":{const $=p,w=this.f.get($.request_seq);w&&(this.f.delete($.request_seq),w($));break}}}}u(p,$){$.type=p,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach(($,w)=>p.set(w,$)),await(0,R.$jh)(500),p.forEach(($,w)=>{$({type:"response",seq:0,request_seq:w,success:!1,command:"canceled",message:"canceled"}),this.f.delete(w)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$kob=M}),define(Ee[290],Ce([1,0,2,236,42,5]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$XI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$WI=e.MemoryRangeType=e.State=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=void 0,e.$VI=$,e.$JH="workbench.view.debug",e.$KH="workbench.debug.variablesView",e.$LH="workbench.debug.watchExpressionsView",e.$MH="workbench.debug.callStackView",e.$NH="workbench.debug.loadedScriptsView",e.$OH="workbench.debug.breakPointsView",e.$PH="workbench.debug.disassemblyView",e.$QH="workbench.panel.repl",e.$RH="workbench.panel.repl.view",e.$SH=new I.$zj("debugType",void 0,{type:"string",description:R.localize(0,null)}),e.$TH=new I.$zj("debugConfigurationType",void 0,{type:"string",description:R.localize(1,null)}),e.$UH=new I.$zj("debugState","inactive",{type:"string",description:R.localize(2,null)}),e.$VH="debugUx",e.$WH=new I.$zj(e.$VH,"default",{type:"string",description:R.localize(3,null)}),e.$XH=new I.$zj("hasDebugged",!1,{type:"boolean",description:R.localize(4,null)}),e.$YH=new I.$zj("inDebugMode",!1,{type:"boolean",description:R.localize(5,null)}),e.$ZH=new I.$zj("inDebugRepl",!1,{type:"boolean",description:R.localize(6,null)}),e.$1H=new I.$zj("breakpointWidgetVisible",!1,{type:"boolean",description:R.localize(7,null)}),e.$2H=new I.$zj("inBreakpointWidget",!1,{type:"boolean",description:R.localize(8,null)}),e.$3H=new I.$zj("breakpointsFocused",!0,{type:"boolean",description:R.localize(9,null)}),e.$4H=new I.$zj("watchExpressionsFocused",!0,{type:"boolean",description:R.localize(10,null)}),e.$5H=new I.$zj("watchExpressionsExist",!1,{type:"boolean",description:R.localize(11,null)}),e.$6H=new I.$zj("variablesFocused",!0,{type:"boolean",description:R.localize(12,null)}),e.$7H=new I.$zj("expressionSelected",!1,{type:"boolean",description:R.localize(13,null)}),e.$8H=new I.$zj("breakpointInputFocused",!1,{type:"boolean",description:R.localize(14,null)}),e.$9H=new I.$zj("callStackItemType",void 0,{type:"string",description:R.localize(15,null)}),e.$0H=new I.$zj("callStackSessionIsAttach",!1,{type:"boolean",description:R.localize(16,null)}),e.$$H=new I.$zj("callStackItemStopped",!1,{type:"boolean",description:R.localize(17,null)}),e.$_H=new I.$zj("callStackSessionHasOneThread",!1,{type:"boolean",description:R.localize(18,null)}),e.$aI=new I.$zj("watchItemType",void 0,{type:"string",description:R.localize(19,null)}),e.$bI=new I.$zj("canViewMemory",void 0,{type:"boolean",description:R.localize(20,null)}),e.$cI=new I.$zj("breakpointItemType",void 0,{type:"string",description:R.localize(21,null)}),e.$dI=new I.$zj("breakpointItemBytes",void 0,{type:"boolean",description:R.localize(22,null)}),e.$eI=new I.$zj("breakpointHasModes",!1,{type:"boolean",description:R.localize(23,null)}),e.$fI=new I.$zj("breakpointSupportsCondition",!1,{type:"boolean",description:R.localize(24,null)}),e.$gI=new I.$zj("loadedScriptsSupported",!1,{type:"boolean",description:R.localize(25,null)}),e.$hI=new I.$zj("loadedScriptsItemType",void 0,{type:"string",description:R.localize(26,null)}),e.$iI=new I.$zj("focusedSessionIsAttach",!1,{type:"boolean",description:R.localize(27,null)}),e.$jI=new I.$zj("focusedSessionIsNoDebug",!1,{type:"boolean",description:R.localize(28,null)}),e.$kI=new I.$zj("stepBackSupported",!1,{type:"boolean",description:R.localize(29,null)}),e.$lI=new I.$zj("restartFrameSupported",!1,{type:"boolean",description:R.localize(30,null)}),e.$mI=new I.$zj("stackFrameSupportsRestart",!1,{type:"boolean",description:R.localize(31,null)}),e.$nI=new I.$zj("jumpToCursorSupported",!1,{type:"boolean",description:R.localize(32,null)}),e.$oI=new I.$zj("stepIntoTargetsSupported",!1,{type:"boolean",description:R.localize(33,null)}),e.$pI=new I.$zj("breakpointsExist",!1,{type:"boolean",description:R.localize(34,null)}),e.$qI=new I.$zj("debuggersAvailable",!1,{type:"boolean",description:R.localize(35,null)}),e.$rI=new I.$zj("debugExtensionAvailable",!0,{type:"boolean",description:R.localize(36,null)}),e.$sI=new I.$zj("debugProtocolVariableMenuContext",void 0,{type:"string",description:R.localize(37,null)}),e.$tI=new I.$zj("debugSetVariableSupported",!1,{type:"boolean",description:R.localize(38,null)}),e.$uI=new I.$zj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:R.localize(39,null)}),e.$vI=new I.$zj("debugSetExpressionSupported",!1,{type:"boolean",description:R.localize(40,null)}),e.$wI=new I.$zj("breakWhenValueChangesSupported",!1,{type:"boolean",description:R.localize(41,null)}),e.$xI=new I.$zj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:R.localize(42,null)}),e.$yI=new I.$zj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:R.localize(43,null)}),e.$zI=new I.$zj("terminateDebuggeeSupported",!1,{type:"boolean",description:R.localize(44,null)}),e.$AI=new I.$zj("suspendDebuggeeSupported",!1,{type:"boolean",description:R.localize(45,null)}),e.$BI=new I.$zj("variableEvaluateNamePresent",!1,{type:"boolean",description:R.localize(46,null)}),e.$CI=new I.$zj("variableIsReadonly",!1,{type:"boolean",description:R.localize(47,null)}),e.$DI=new I.$zj("variableValue",!1,{type:"string",description:R.localize(48,null)}),e.$EI=new I.$zj("variableType",!1,{type:"string",description:R.localize(49,null)}),e.$FI=new I.$zj("variableInterfaces",!1,{type:"array",description:R.localize(50,null)}),e.$GI=new I.$zj("variableName",!1,{type:"string",description:R.localize(51,null)}),e.$HI=new I.$zj("variableLanguage",!1,{type:"string",description:R.localize(52,null)}),e.$II=new I.$zj("variableExtensionId",!1,{type:"string",description:R.localize(53,null)}),e.$JI=new I.$zj("exceptionWidgetVisible",!1,{type:"boolean",description:R.localize(54,null)}),e.$KI=new I.$zj("multiSessionRepl",!1,{type:"boolean",description:R.localize(55,null)}),e.$LI=new I.$zj("multiSessionDebug",!1,{type:"boolean",description:R.localize(56,null)}),e.$MI=new I.$zj("disassembleRequestSupported",!1,{type:"boolean",description:R.localize(57,null)}),e.$NI=new I.$zj("disassemblyViewFocus",!1,{type:"boolean",description:R.localize(58,null)}),e.$OI=new I.$zj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:R.localize(59,null)}),e.$PI=new I.$zj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:R.localize(60,null)});const L=i=>R.localize(61,null,i);e.$QI=L,e.$RI="editor.contrib.debug",e.$SI="editor.contrib.breakpoint",e.$TI="debug",e.$UI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:R.localize(62,null)};var p;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(p||(e.State=p={}));function $(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var w;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(w||(e.MemoryRangeType=w={})),e.$WI="vscode-debug-memory";var A;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(A||(e.DataBreakpointSetType=A={}));var P;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(P||(e.DebugConfigurationProviderTriggerKind=P={}));var b;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(b||(e.DebuggerString=b={})),e.$XI=(0,M.$ii)("debugService");var C;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(C||(e.BreakpointWidgetContext=C={}));var y;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(y||(e.DebugVisualizationType=y={}));var a;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(a||(e.DebugTreeItemCollapsibleState=a={}));var m;(function(i){i.deserialize=n=>n,i.serialize=n=>n})(m||(e.IDebugVisualizationTreeItem=m={}));var c;(function(i){i.deserialize=n=>({id:n.id,name:n.name,iconPath:n.iconPath&&{light:o.URI.revive(n.iconPath.light),dark:o.URI.revive(n.iconPath.dark)},iconClass:n.iconClass,visualization:n.visualization}),i.serialize=n=>n})(c||(e.IDebugVisualization=c={}))}),define(Ee[291],Ce([1,0,14,2,17,24,15,29,22,19]),function(re,e,o,R,I,M,L,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XG=void 0,e.$LG=P,e.$MG=b,e.$NG=C,e.$OG=y,e.$PG=a,e.$QG=m,e.$RG=c,e.$SG=n,e.$TG=t,e.$UG=f,e.$VG=u,e.$WG=l;const A=/{([^}]+)}/g;function P(E,v,S){return E.replace(A,function(k,D){return v&&D.length>0&&D[0]!=="_"?k:S&&S.hasOwnProperty(D)?S[D]:k})}function b(E){const v={};for(const S of Object.keys(E))S.startsWith("!")||(v[S]=E[S]);return v}function C(E){return E.configuration.request==="attach"&&!y(E)&&(!E.parentSession||C(E.parentSession))}function y(E){let v=E.configuration.type;if(v)return v==="vslsShare"&&(v=E.configuration.adapterProxy.configuration.type),(0,o.$lf)(v,"extensionhost")||(0,o.$lf)(v,"pwa-extensionhost")?E:E.parentSession?y(E.parentSession):void 0}function a(E){return E.type&&(E.label||E.program||E.runtime)}function m(E,v,S){let k,D=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=F.exec(E);){const B=W.index+1,j=B+W[0].length;if(B<=v&&j>=S){k=W[0],D=B;break}}if(k){const B=/\w+/g;let j=null;for(;(j=B.exec(k))&&!(j.index+1+D+j[0].length>=S););j&&(k=k.substring(0,B.lastIndex))}return k?{start:D,end:D+k.length-1}:{start:0,end:0}}async function c(E,v,S,k){if(E.evaluatableExpressionProvider.has(v)){const D=E.evaluatableExpressionProvider.ordered(v),F=(0,w.$Hb)(await Promise.all(D.map(async W=>{try{return await W.provideEvaluatableExpression(v,S,k??$.CancellationToken.None)}catch{return}})));if(F.length>0){let W=F[0].expression;const B=F[0].range;return W||(W=v.getLineContent(S.lineNumber).substring(B.startColumn-1,B.endColumn-1)),{range:B,matchingExpression:W}}}else{const D=v.getLineContent(S.lineNumber),{start:F,end:W}=m(D,S.column,S.column),B=D.substring(F-1,W);return{matchingExpression:B,range:new p.$dt(S.lineNumber,F,S.lineNumber,F+B.length)}}return null}const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(E){return!!(E&&E.match(i))}function r(E){if(typeof E.path=="string"&&!(typeof E.sourceReference=="number"&&E.sourceReference>0)){if(n(E.path))return R.URI.parse(E.path);if((0,I.$jc)(E.path))return R.URI.file(E.path)}return E.path}function s(E){if(typeof E.path=="object"){const v=R.URI.revive(E.path);if(v)return v.scheme===L.Schemas.file?v.fsPath:v.toString()}return E.path}function t(E,v){const S=v?r:s,k=(0,M.$Pn)(E);return d(k,(D,F)=>{D&&F&&(F.path=S(F))}),k}function f(E,v){const S=v?r:s,k=(0,M.$Pn)(E);return d(k,(D,F)=>{!D&&F&&(F.path=S(F))}),k}function d(E,v){switch(E.type){case"event":{const S=E;switch(S.event){case"output":v(!1,S.body.source);break;case"loadedSource":v(!1,S.body.source);break;case"breakpoint":v(!1,S.body.breakpoint.source);break;default:break}break}case"request":{const S=E;switch(S.command){case"setBreakpoints":v(!0,S.arguments.source);break;case"breakpointLocations":v(!0,S.arguments.source);break;case"source":v(!0,S.arguments.source);break;case"gotoTargets":v(!0,S.arguments.source);break;case"launchVSCode":S.arguments.args.forEach(k=>v(!1,k));break;default:break}break}case"response":{const S=E;if(S.success&&S.body)switch(S.command){case"stackTrace":S.body.stackFrames.forEach(k=>v(!1,k.source));break;case"loadedSources":S.body.sources.forEach(k=>v(!1,k));break;case"scopes":S.body.scopes.forEach(k=>v(!1,k.source));break;case"setFunctionBreakpoints":S.body.breakpoints.forEach(k=>v(!1,k.source));break;case"setBreakpoints":S.body.breakpoints.forEach(k=>v(!1,k.source));break;case"disassemble":S.body?.instructions.forEach(D=>v(!1,D.location));break;default:break}break}}}function u(E){return E.filter(v=>!v.presentation?.hidden).sort((v,S)=>v.presentation?S.presentation?v.presentation.group?S.presentation.group?v.presentation.group!==S.presentation.group?v.presentation.group.localeCompare(S.presentation.group):h(v.presentation.order,S.presentation.order):-1:S.presentation.group?1:h(v.presentation.order,S.presentation.order):-1:S.presentation?1:0)}function h(E,v){return typeof E!="number"?typeof v!="number"?0:1:typeof v!="number"?-1:E-v}async function l(E,v){const S=E.getValue("debug.saveBeforeStart",{overrideIdentifier:v.activeTextEditorLanguageId});if(S!=="none"&&(await v.saveAll(),S==="allEditorsInActiveGroup")){const k=v.activeEditorPane;k&&k.input.resource?.scheme===L.Schemas.untitled&&await v.save({editor:k.input,groupId:k.group.id})}await E.reloadConfiguration()}const g=(E,v)=>!E||!v?E===v:E.name===v.name&&E.path===v.path&&E.sourceReference===v.sourceReference;e.$XG=g}),define(Ee[292],Ce([1,0,51,63,24,17,11,14,31,237,144]),function(re,e,o,R,I,M,L,p,$,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wlc=e.$Vlc=e.$Ulc=e.$Tlc=e.$Slc=void 0;class P extends A.$kob{constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(c,i){this.l=i,this.p=Buffer.allocUnsafe(0),this.r=-1,c.on("data",n=>this.v(n))}sendMessage(c){if(this.l){const i=JSON.stringify(c);this.l.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${P.a}${i}`,"utf8")}}v(c){for(this.p=Buffer.concat([this.p,c]);;){if(this.r>=0){if(this.p.length>=this.r){const i=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.n.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.p.indexOf(P.a);if(i!==-1){const r=this.p.toString("utf8",0,i).split(P.b);for(const s of r){const t=s.split(P.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(i+P.a.length);continue}}break}}}e.$Slc=P,P.a=`\r
\r
`,P.b=/\r?\n/,P.i=/: */;class b extends P{startSession(){return new Promise((c,i)=>{let n=!1;this.x=this.y(()=>{this.t(this.x,this.x),c(),n=!0}),this.x.on("close",()=>{n?this.n.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",r=>{n?this.n.fire(r):i(r)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$Tlc=b;class C extends b{constructor(c){super(),this.z=c}y(c){return R.createConnection(this.z.port,this.z.host||"127.0.0.1",c)}}e.$Ulc=C;class y extends b{constructor(c){super(),this.z=c}y(c){return R.createConnection(this.z.path,c)}}e.$Vlc=y;class a extends P{constructor(c,i){super(),this.y=c,this.z=i}async startSession(){const c=this.y.command,i=this.y.args,n=this.y.options||{};try{if(c)if(M.$jc(c)){if(!await $.Promises.exists(c))throw new Error(w.localize(0,null,c))}else c.indexOf("/")<0&&c.indexOf("\\")<0;else throw new Error(w.localize(1,null,this.z));let r=process.env;if(n.env&&Object.keys(n.env).length>0&&(r=I.$Sn(I.$Pn(process.env),n.env)),c==="node")if(Array.isArray(i)&&i.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const f=o.fork(i[0],i.slice(1),t);if(!f.pid)throw new Error(w.localize(2,null,i[0]));this.x=f}else throw new Error(w.localize(3,null));else{const s={env:r};n.cwd&&(s.cwd=n.cwd),this.x=o.spawn(c,i,s)}this.x.on("error",s=>{this.n.fire(s)}),this.x.on("exit",(s,t)=>{this.o.fire(s)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",s=>{this.n.fire(s)}),this.x.stdin.on("error",s=>{this.n.fire(s)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(r){this.n.fire(r)}}async stopSession(){return this.x?(await this.w(),L.$c?new Promise((c,i)=>{const n=o.exec(`taskkill /F /T /PID ${this.x.pid}`,function(r,s,t){if(r)return i(r)});n.on("exit",c),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(c,i){if(!c)return;const n=Object.create(null);c.runtime&&(c.runtime.indexOf("./")===0?n.runtime=M.$kc(i,c.runtime):n.runtime=c.runtime),c.runtimeArgs&&(n.runtimeArgs=c.runtimeArgs),c.program&&(M.$jc(c.program)?n.program=c.program:n.program=M.$kc(i,c.program)),c.args&&(n.args=c.args);const r=c;return r.win&&(n.win=a.A(r.win,i)),r.winx86&&(n.winx86=a.A(r.winx86,i)),r.windows&&(n.windows=a.A(r.windows,i)),r.osx&&(n.osx=a.A(r.osx,i)),r.linux&&(n.linux=a.A(r.linux,i)),n}static platformAdapterExecutable(c,i){let n=Object.create(null);i=i.toLowerCase();for(const u of c)if(u.contributes){const h=u.contributes.debuggers;h&&h.length>0&&h.filter(l=>typeof l.type=="string"&&p.$lf(l.type,i)).forEach(l=>{const g=a.A(l,u.extensionLocation.fsPath);n=I.$Sn(n,g,u.isBuiltin)})}let r;L.$c&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=n.winx86||n.win||n.windows:L.$c?r=n.win||n.windows:L.$d?r=n.osx:L.$e&&(r=n.linux),r=r||n;const s=r.program||n.program,t=r.args||n.args,f=r.runtime||n.runtime,d=r.runtimeArgs||n.runtimeArgs;if(f)return{type:"executable",command:f,args:(d||[]).concat(typeof s=="string"?[s]:[]).concat(t||[])};if(s)return{type:"executable",command:s,args:t||[]}}}e.$Wlc=a}),define(Ee[293],Ce([1,0,51,34,11]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=L,e.$Ylc=$;function M(w,A){return new Promise((P,b)=>{let C="";const y=o.spawn(w,A);y.pid&&y.stdout.on("data",a=>{C+=a.toString()}),y.on("error",a=>{b(a)}),y.on("close",a=>{P(C)})})}async function L(w){if(w)if(I.$c){const A=await new Promise((P,b)=>{re(["@vscode/windows-process-tree"],P,b)});return new Promise(P=>{A.getProcessTree(w,b=>{P(!!b&&b.children.length>0)})})}else return M("/usr/bin/pgrep",["-lP",String(w)]).then(A=>{const P=A.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}var p;(function(w){w[w.cmd=0]="cmd",w[w.powershell=1]="powershell",w[w.bash=2]="bash"})(p||(p={}));function $(w,A,P,b,C){w=w.trim().toLowerCase();let y;w.indexOf("powershell")>=0||w.indexOf("pwsh")>=0?y=1:w.indexOf("cmd.exe")>=0?y=0:w.indexOf("bash")>=0?y=2:I.$c?y=0:y=2;let a,m=" ";switch(y){case 1:if(a=c=>(c=c.replace(/\'/g,"''"),c.length>0&&c.charAt(c.length-1)==="\\"?`'${c}\\'`:`'${c}'`),b){const c=(0,R.$ng)(b);c&&(m+=`${c}:; `),m+=`cd ${a(b)}; `}if(C)for(const c in C){const i=C[c];i===null?m+=`Remove-Item env:${c}; `:m+=`\${env:${c}}='${i}'; `}if(A.length>0){const c=A.shift(),i=P?c:a(c);m+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of A)m+=n==="<"||n===">"||P?n:a(n),m+=" "}break;case 0:if(a=c=>(c=c.replace(/\"/g,'""'),c=c.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>c.includes(i))||c.length===0?`"${c}"`:c),b){const c=(0,R.$ng)(b);c&&(m+=`${c}: && `),m+=`cd ${a(b)} && `}if(C){m+='cmd /C "';for(const c in C){let i=C[c];i===null?m+=`set "${c}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),m+=`set "${c}=${i}" && `)}}for(const c of A)m+=c==="<"||c===">"||P?c:a(c),m+=" ";C&&(m+='"');break;case 2:{a=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),i.length===0?'""':i);const c=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(b&&(m+=`cd ${a(b)} ; `),C){m+="/usr/bin/env";for(const i in C){const n=C[i];n===null?m+=` -u ${c(i)}`:m+=` ${c(`${i}=${n}`)}`}m+=" "}for(const i of A)m+=i==="<"||i===">"||P?i:a(i),m+=" ";break}}return m}}),define(Ee[294],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=e.CellExecutionUpdateType=void 0;var R;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(R||(e.CellExecutionUpdateType=R={})),e.$$J=(0,o.$ii)("INotebookExecutionService")}),define(Ee[295],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhb=e.$Xhb=e.ProxyKernelState=e.$Whb=void 0,e.$Whb=100;var R;(function(I){I[I.Disconnected=1]="Disconnected",I[I.Connected=2]="Connected",I[I.Initializing=3]="Initializing"})(R||(e.ProxyKernelState=R={})),e.$Xhb=(0,o.$ii)("INotebookKernelService"),e.$Yhb=(0,o.$ii)("INotebookKernelHistoryService")}),define(Ee[296],Ce([1,0,3,29,193,105]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Ub=void 0;class L extends o.$Uc{constructor($,w,A){super(),this._source=$,this.b=w,this.c=A,this.a=void 0}f($){const w=$.getLineCount();return new R.$dt(1,1,w,this.g($,w))}g($,w){if(w<1||w>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(w)+1}get inputTextBuffer(){if(!this.b){const $=new I.$FC;$.acceptChunk(this._source);const w=$.finish(!0),{textBuffer:A,disposable:P}=w.create(1);this.b=A,this.B(P)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const w=new I.$FC;w.acceptChunk($);const A=w.finish(!0),{textBuffer:P,disposable:b}=A.create(1);return this.B(b),P})),this.a}findInInputs($){const A=new M.$tC($,!1,!1,null).parseSearchRequest();if(!A)return[];const P=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(P,A,!0,5e3)}findInOutputs($){const A=new M.$tC($,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(P=>{const b=P.findMatchesLineByLine(this.f(P),A,!0,5e3);if(b.length!==0)return{textBuffer:P,matches:b}}).filter(P=>!!P):[]}}e.$7Ub=L}),define(Ee[67],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eL=e.TestPosition=e.TestIdPathParts=void 0;var o;(function(M){M.Delimiter="\0"})(o||(e.TestIdPathParts=o={}));var R;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(R||(e.TestPosition=R={}));class I{static fromExtHostTestItem(L,p,$=L.parent){if(L._isRoot)return new I([p]);const w=[L.id];for(let A=$;A&&A.id!==p;A=A.parent)w.push(A.id);return w.push(p),new I(w.reverse())}static isRoot(L){return!L.includes("\0")}static root(L){const p=L.indexOf("\0");return p===-1?L:L.slice(0,p)}static fromString(L){return new I(L.split("\0"))}static join(L,p){return new I([...L.path,p])}static joinToString(L,p){return L.toString()+"\0"+p}static parentId(L){const p=L.lastIndexOf("\0");return p===-1?void 0:L.slice(0,p)}static localId(L){const p=L.lastIndexOf("\0");return p===-1?L:L.slice(p+1)}static isChild(L,p){return p.startsWith(L)&&p[L.length]==="\0"}static compare(L,p){return L===p?0:I.isChild(L,p)?2:I.isChild(p,L)?3:1}constructor(L,p=L.length){if(this.path=L,this.d=p,L.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new I(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new I(this.path,L)}compare(L){if(typeof L=="string")return I.compare(this.toString(),L);for(let p=0;p<L.d&&p<this.d;p++)if(L.path[p]!==this.path[p])return 1;return L.d>this.d?2:L.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+="\0",this.c+=this.path[L]}return this.c}}e.$eL=I}),define(Ee[89],Ce([1,0,2,52,29,67]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$mL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$lL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$kL=e.$jL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$iL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$hL=e.$gL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$fL=e.TestResultState=void 0;var L;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(L||(e.TestResultState=L={})),e.$fL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var p;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var $;(function(N){N[N.Run=2]="Run",N[N.Debug=4]="Debug",N[N.Coverage=8]="Coverage",N[N.HasNonDefaultProfile=16]="HasNonDefaultProfile",N[N.HasConfigurable=32]="HasConfigurable",N[N.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$gL=[2,4,8,16,32,64];const w=N=>"runId"in N;e.$hL=w;var A;(function(N){N.serialize=T=>({range:T.range.toJSON(),uri:T.uri.toJSON()}),N.deserialize=(T,O)=>({range:I.$dt.lift(O.range),uri:T.asCanonicalUri(o.URI.revive(O.uri))})})(A||(e.IRichLocation=A={}));var P;(function(N){N[N.Error=0]="Error",N[N.Output=1]="Output"})(P||(e.TestMessageType=P={}));var b;(function(N){N.serialize=T=>({message:T.message,type:0,expected:T.expected,actual:T.actual,contextValue:T.contextValue,location:T.location&&A.serialize(T.location)}),N.deserialize=(T,O)=>({message:O.message,type:0,expected:O.expected,actual:O.actual,contextValue:O.contextValue,location:O.location&&A.deserialize(T,O.location)})})(b||(e.ITestErrorMessage=b={}));const C=(N,T)=>`${T?"s":"e"}${N}`;e.$iL=C;var y;(function(N){N.serialize=T=>({message:T.message,type:1,offset:T.offset,length:T.length,location:T.location&&A.serialize(T.location)}),N.deserialize=(T,O)=>({message:O.message,type:1,offset:O.offset,length:O.length,location:O.location&&A.deserialize(T,O.location)})})(y||(e.ITestOutputMessage=y={}));var a;(function(N){N.serialize=T=>T.type===0?b.serialize(T):y.serialize(T),N.deserialize=(T,O)=>O.type===0?b.deserialize(T,O):y.deserialize(T,O)})(a||(e.ITestMessage=a={}));var m;(function(N){N.serializeWithoutMessages=T=>({state:T.state,duration:T.duration,messages:[]}),N.serialize=T=>({state:T.state,duration:T.duration,messages:T.messages.map(a.serialize)}),N.deserialize=(T,O)=>({state:O.state,duration:O.duration,messages:O.messages.map(z=>a.deserialize(T,z))})})(m||(e.ITestTaskState=m={}));const c="\0",i=(N,T)=>N+c+T;e.$jL=i;const n=N=>{const T=N.indexOf(c);return{ctrlId:N.slice(0,T),tagId:N.slice(T+1)}};e.$kL=n;var r;(function(N){N.serialize=T=>({extId:T.extId,label:T.label,tags:T.tags,busy:T.busy,children:void 0,uri:T.uri?.toJSON(),range:T.range?.toJSON()||null,description:T.description,error:T.error,sortText:T.sortText}),N.deserialize=(T,O)=>({extId:O.extId,label:O.label,tags:O.tags,busy:O.busy,children:void 0,uri:O.uri?T.asCanonicalUri(o.URI.revive(O.uri)):void 0,range:O.range?I.$dt.lift(O.range):null,description:O.description,error:O.error,sortText:O.sortText})})(r||(e.ITestItem=r={}));var s;(function(N){N[N.NotExpandable=0]="NotExpandable",N[N.Expandable=1]="Expandable",N[N.BusyExpanding=2]="BusyExpanding",N[N.Expanded=3]="Expanded"})(s||(e.TestItemExpandState=s={}));var t;(function(N){N.serialize=T=>({expand:T.expand,item:r.serialize(T.item)}),N.deserialize=(T,O)=>({controllerId:M.$eL.root(O.item.extId),expand:O.expand,item:r.deserialize(T,O.item)})})(t||(e.InternalTestItem=t={}));var f;(function(N){N.serialize=T=>{let O;return T.item&&(O={},T.item.label!==void 0&&(O.label=T.item.label),T.item.tags!==void 0&&(O.tags=T.item.tags),T.item.busy!==void 0&&(O.busy=T.item.busy),T.item.uri!==void 0&&(O.uri=T.item.uri?.toJSON()),T.item.range!==void 0&&(O.range=T.item.range?.toJSON()),T.item.description!==void 0&&(O.description=T.item.description),T.item.error!==void 0&&(O.error=T.item.error),T.item.sortText!==void 0&&(O.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:O}},N.deserialize=T=>{let O;return T.item&&(O={},T.item.label!==void 0&&(O.label=T.item.label),T.item.tags!==void 0&&(O.tags=T.item.tags),T.item.busy!==void 0&&(O.busy=T.item.busy),T.item.range!==void 0&&(O.range=T.item.range?I.$dt.lift(T.item.range):null),T.item.description!==void 0&&(O.description=T.item.description),T.item.error!==void 0&&(O.error=T.item.error),T.item.sortText!==void 0&&(O.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:O}}})(f||(e.ITestItemUpdate=f={}));const d=(N,T)=>{T.expand!==void 0&&(N.expand=T.expand),T.item!==void 0&&(N.item=N.item?Object.assign(N.item,T.item):T.item)};e.$lL=d;var u;(function(N){N.serializeWithoutMessages=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(m.serializeWithoutMessages)}),N.serialize=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(m.serialize)}),N.deserialize=(T,O)=>({...t.deserialize(T,O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(z=>m.deserialize(T,z)),retired:!0})})(u||(e.TestResultItem=u={}));var h;(function(N){N.empty=()=>({covered:0,total:0}),N.sum=(T,O)=>{T.covered+=O.covered,T.total+=O.total}})(h||(e.ICoverageCount=h={}));var l;(function(N){N.serialize=T=>({id:T.id,statement:T.statement,branch:T.branch,declaration:T.declaration,uri:T.uri.toJSON()}),N.deserialize=(T,O)=>({id:O.id,statement:O.statement,branch:O.branch,declaration:O.declaration,uri:T.asCanonicalUri(o.URI.revive(O.uri))})})(l||(e.IFileCoverage=l={}));function g(N){return{...N,location:N.location?.toJSON()}}function E(N){return N.location=N.location?R.$ct.isIPosition(N.location)?R.$ct.lift(N.location):I.$dt.lift(N.location):void 0,N}e.$mL=3;var v;(function(N){N[N.Declaration=0]="Declaration",N[N.Statement=1]="Statement",N[N.Branch=2]="Branch"})(v||(e.DetailType=v={}));var S;(function(N){N.serialize=T=>T.type===0?D.serialize(T):F.serialize(T),N.deserialize=T=>T.type===0?D.deserialize(T):F.deserialize(T)})(S||(e.CoverageDetails=S={}));var k;(function(N){N.serialize=g,N.deserialize=E})(k||(e.IBranchCoverage=k={}));var D;(function(N){N.serialize=g,N.deserialize=E})(D||(e.IDeclarationCoverage=D={}));var F;(function(N){N.serialize=T=>({...g(T),branches:T.branches?.map(k.serialize)}),N.deserialize=T=>({...E(T),branches:T.branches?.map(k.deserialize)})})(F||(e.IStatementCoverage=F={}));var W;(function(N){N[N.Add=0]="Add",N[N.Update=1]="Update",N[N.DocumentSynced=2]="DocumentSynced",N[N.Remove=3]="Remove",N[N.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",N[N.Retire=5]="Retire",N[N.AddTag=6]="AddTag",N[N.RemoveTag=7]="RemoveTag"})(W||(e.TestDiffOpType=W={}));var B;(function(N){N.deserialize=(T,O)=>O.op===0?{op:O.op,item:t.deserialize(T,O.item)}:O.op===1?{op:O.op,item:f.deserialize(O.item)}:O.op===2?{op:O.op,uri:T.asCanonicalUri(o.URI.revive(O.uri)),docv:O.docv}:O,N.serialize=T=>T.op===0?{op:T.op,item:t.serialize(T.item)}:T.op===1?{op:T.op,item:f.serialize(T.item)}:T})(B||(e.TestsDiffOp=B={}));class j{constructor(T){this.l=T,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(T){const O=this.w();for(const z of T)switch(z.op){case 0:this.o(t.deserialize(this.l,z.item),O);break;case 1:this.p(f.deserialize(z.item),O);break;case 3:this.q(z.itemId,O);break;case 5:this.v(z.itemId);break;case 4:this.updatePendingRoots(z.amount);break;case 6:this.f.set(z.tag.id,z.tag);break;case 7:this.f.delete(z.id);break}O.complete?.()}o(T,O){const z=M.$eL.parentId(T.item.extId)?.toString();let Q;if(!z)Q=this.x(T),this.h.add(Q),this.g.set(T.item.extId,Q);else if(this.g.has(z)){const Z=this.g.get(z);Z.children.add(T.item.extId),Q=this.x(T,Z),this.g.set(T.item.extId,Q)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(T)}`);return}return O.add?.(Q),T.expand===2&&this.j++,Q}p(T,O){const z=this.g.get(T.extId);if(z)return T.expand!==void 0&&(z.expand===2&&this.j--,T.expand===2&&this.j++),(0,e.$lL)(z,T),O.update?.(z),z}q(T,O){const z=this.g.get(T);if(!z)return;const Q=M.$eL.parentId(z.item.extId)?.toString();Q?this.g.get(Q).children.delete(z.item.extId):this.h.delete(z);const Z=[[T]];for(;Z.length;)for(const J of Z.pop()){const x=this.g.get(J);x&&(Z.push(x.children),this.g.delete(J),O.remove?.(x,x!==z),x.expand===2&&this.j--)}}v(T){}updatePendingRoots(T){this.k+=T}w(){return{}}}e.$nL=j}),define(Ee[113],Ce([1,0,8,4,3,61,89,67]),function(re,e,o,R,I,M,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.TestItemEventOp=void 0;var $;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const w=(i,n)=>i===n,P=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:w,label:w,description:w,error:w,sortText:w,tags:(i,n)=>!(i.length!==n.length||i.some(r=>!n.includes(r)))}),b=(i,n)=>{let r;for(const[s,t]of P)t(i[s],n[s])||(r?r[s]=n[s]:r={[s]:n[s]});return r};class C extends I.$Uc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new o.$uh(()=>this.flushDiff(),200)),this.g=this.B(new R.$7d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const r of this.m)if(r.op===2&&r.uri===n.uri){r.docv=n.docv;return}break}case 1:{const r=this.m[this.m.length-1];if(r){if(r.op===1&&r.item.extId===n.item.extId){(0,L.$lL)(r.item,n.item);return}if(r.op===0&&r.item.item.extId===n.item.extId){(0,L.$lL)(r.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,r){const s=this.tree.get(n);if(s){if((s.expandLevels===void 0||r>s.expandLevels)&&(s.expandLevels=r),s.expand===1){const t=this.M(s);return t.isOpen()?this.L(s,r-1):t.wait().then(()=>this.L(s,r-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.L(s,r-1)):this.L(s,r-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,r){switch(r.op){case 3:this.O(p.$eL.joinToString(n.fullId,r.id));break;case 0:this.z(r.item,n);break;case 5:for(const s of r.ops)this.w(n,s);break;case 1:this.C(r.new,r.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:r.update}});break;case 6:this.y(n.actual.uri);break;default:(0,M.$0c)(r)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,r){const s=p.$eL.fromExtHostTestItem(n,this.root.id,r?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==r?.actual&&this.s.getChildren(t.parent).delete(n.id);let f=this.tree.get(s.toString());if(!f){f={fullId:s,actual:n,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(f.fullId.toString(),f),this.G(n,r),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:f.expand,item:this.s.toITestItem(n)}}),this.I(n,f,r);return}if(f.actual===n){this.H(n,f,r);return}if(f.actual.uri?.toString()!==n.uri?.toString())return this.O(s.toString()),this.z(n,r);const d=this.s.getChildren(f.actual),u=f.actual,h=b(this.s.toITestItem(u),this.s.toITestItem(n));this.s.getApiFor(u).listener=void 0,f.actual=n,f.expand=0,h&&(h.hasOwnProperty("tags")&&(this.C(n.tags,u.tags,s.toString()),delete h.tags),this.w(f,{op:4,update:h})),this.I(n,f,r);for(const[l,g]of d)this.s.getChildren(n).get(g.id)||this.O(p.$eL.joinToString(s,g.id));this.y(f.actual.uri)}C(n,r,s){const t=new Set(r.map(f=>f.id));for(const f of n)t.delete(f.id)||this.D(f);this.pushDiff({op:1,item:{extId:s,item:{tags:n.map(f=>(0,L.$jL)(this.s.controllerId,f.id))}}}),t.forEach(this.F,this)}D(n){const r=this.j.get(n.id);r?r.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,L.$jL)(this.s.controllerId,n.id)}}))}F(n){const r=this.j.get(n);r&&!--r.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,L.$jL)(this.s.controllerId,n)}))}G(n,r){this.s.getApiFor(n).parent=r&&r.actual!==this.root?r.actual:void 0}H(n,r,s){this.G(n,s);const t=this.s.getApiFor(n);t.parent=s?.actual,t.listener=f=>this.w(r,f),this.J(r)}I(n,r,s){this.H(n,r,s);for(const[t,f]of this.s.getChildren(n))this.z(f,r)}J(n){let r;this.h?n.resolveBarrier?r=n.resolveBarrier.isOpen()?3:2:r=n.actual.canResolveChildren?1:0:r=0,r!==n.expand&&(n.expand=r,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:r}}),r===1&&n.expandLevels!==void 0&&this.M(n))}L(n,r){if(r<0)return;const s=[];for(const[t,f]of this.s.getChildren(n.actual)){const d=this.expand(p.$eL.joinToString(n.fullId,f.id),r);(0,o.$7g)(d)&&s.push(d)}if(s.length)return Promise.all(s).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const f=new o.$hh;return f.open(),f}n.expand=2,this.N(n);const r=n.resolveBarrier=new o.$hh,s=f=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,f)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(f){s(f)}return(0,o.$7g)(t)?t.catch(s).then(()=>{r.open(),this.J(n)}):(r.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const r=this.tree.get(n);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const s=[r];for(;s.length;){const t=s.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const f of t.actual.tags)this.F(f.id);this.tree.delete(t.fullId.toString());for(const[f,d]of this.s.getChildren(t.actual))s.push(this.tree.get(p.$eL.joinToString(t.fullId,d.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$EO=C;class y extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$FO=y;class a extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$GO=a;class m extends Error{constructor(n,r,s){super(`TestItem with ID "${n}" is from controller "${r}" and cannot be added as a child of an item from controller "${s}".`)}}e.$HO=m;const c=(i,n,r)=>{let s=new Map;return{get size(){return s.size},forEach(t,f){for(const d of s.values())t.call(f,d,this)},[Symbol.iterator](){return s.entries()},replace(t){const f=new Map,d=new Set(s.keys()),u={op:5,ops:[]};for(const h of t){if(!(h instanceof r))throw new a(h.id);const l=n(h).controllerId;if(l!==i.controllerId)throw new m(h.id,l,i.controllerId);if(f.has(h.id))throw new y(h.id);f.set(h.id,h),d.delete(h.id),u.ops.push({op:0,item:h})}for(const h of d.keys())u.ops.push({op:3,id:h});i.listener?.(u),s=f},add(t){if(!(t instanceof r))throw new a(t.id);s.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){s.delete(t)&&i.listener?.({op:3,id:t})},get(t){return s.get(t)},toJSON(){return Array.from(s.values())}}};e.$IO=c}),define(Ee[145],Ce([1,0,113]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KO=e.$JO=void 0;const R=new WeakMap,I=(L,p)=>{const $={controllerId:p};return R.set(L,$),$};e.$JO=I;const M=L=>{const p=R.get(L);if(!p)throw new o.$GO(L?.id||"<unknown>");return p};e.$KO=M}),define(Ee[114],Ce([1,0,15,2]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Azb=e.$zzb=e.$yzb=void 0,e.$Bzb=I,e.$Czb=L,e.$yzb="vscode-cdn.net",e.$zzb=`vscode-resource.${e.$yzb}`,e.$Azb=`'self' https://*.${e.$yzb}`;function I(p,$){return p.scheme===o.Schemas.http||p.scheme===o.Schemas.https?p:($&&$.authority&&$.isRemote&&p.scheme===o.Schemas.file&&(p=R.URI.from({scheme:o.Schemas.vscodeRemote,authority:$.authority,path:p.path})),R.URI.from({scheme:o.Schemas.https,authority:`${p.scheme}+${M(p.authority)}.${e.$zzb}`,path:p.path,fragment:p.fragment,query:p.query}))}function M(p){return p.replace(/./g,$=>{const w=$.charCodeAt(0);return w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57?$:"-"+w.toString(16).padStart(4,"0")})}function L(p){return p.replace(/-([0-9a-f]{4})/g,($,w)=>String.fromCharCode(parseInt(w,16)))}}),define(Ee[297],Ce([1,0,4,3,114]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ujc=void 0;class M{constructor(p,$,w){this.d=p,this.e=$,this.f=w,this.a=0,this.b=new R.$Tc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const A=$.getVisibleTextEditors();for(const P of this.c.values())A.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,$,w,A,P){let b;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===p){b=n;break}if(!b)throw new Error("not a visible editor");const C=this,y=this.a++,a=new o.$7d,m=new o.$7d,c=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,I.$Bzb)(n,C.f)}get cspSource(){return I.$Azb}set options(n){this.b=n,C.d.$setOptions(y,n)}get options(){return this.b}set html(n){this.a=n,C.d.$setHtml(y,n)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(n){return C.d.$postMessage(y,n)}},i=new class{constructor(){this.editor=p,this.line=$,this.height=w,this.webview=c,this.onDidDispose=m.event}dispose(){C.c.has(y)&&(C.c.delete(y),C.d.$disposeEditorInset(y),m.fire(),m.dispose(),a.dispose())}};return this.d.$createEditorInset(y,b.id,b.value.document.uri,$+1,w,A||{},P.identifier,P.extensionLocation),this.c.set(y,{editor:p,inset:i,onDidReceiveMessage:a}),i}$onDidDispose(p){const $=this.c.get(p);$&&$.inset.dispose()}$onDidReceiveMessage(p,$){this.c.get(p)?.onDidReceiveMessage.fire($)}}e.$Ujc=M}),define(Ee[146],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wL=e.$vL=e.$uL=void 0,e.$uL="__",e.$vL=(0,o.$ii)("IAuthenticationService"),e.$wL=(0,o.$ii)("IAuthenticationExtensionsService")}),define(Ee[298],Ce([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BP=e.VariableKind=e.$AP=void 0,e.$AP=(0,o.$ii)("configurationResolverService");var R;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator",M.PathSeparatorAlias="/"})(R||(e.VariableKind=R={}));class I extends Error{constructor(L,p){super(p),this.variable=L}}e.$BP=I}),define(Ee[299],Ce([1,0,17,49,18,24,11,102,240,298,14]),function(re,e,o,R,I,M,L,p,$,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QP=void 0;class P{constructor(C,y,a,m){this.h=new Map,this.a=C,this.b=y,this.g=a,m&&(this.c=m.then(c=>this.i(c)))}i(C){if(L.$c){const y=Object.create(null);return Object.keys(C).forEach(a=>{y[a.toLowerCase()]=C[a]}),y}return C}resolveWithEnvironment(C,y,a){return this.l({env:this.i(C),userHome:void 0},y?y.uri:void 0,a)}async resolveAsync(C,y){const a={env:await this.c,userHome:await this.g};return this.l(a,C?C.uri:void 0,y)}async j(C,y,a,m){const c=M.$Pn(y);L.$c&&c.windows?Object.keys(c.windows).forEach(n=>c[n]=c.windows[n]):L.$d&&c.osx?Object.keys(c.osx).forEach(n=>c[n]=c.osx[n]):L.$e&&c.linux&&Object.keys(c.linux).forEach(n=>c[n]=c.linux[n]),delete c.windows,delete c.osx,delete c.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,C?C.uri:void 0,c,a,m)}async resolveAnyAsync(C,y,a){return this.j(C,y,a)}async resolveAnyMap(C,y,a){const m=new Map;return{newConfig:await this.j(C,y,a,m),resolvedVariables:m}}resolveWithInteractionReplace(C,y,a,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,y,a,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,y){if(this.h.has(C))throw new Error("Variable "+C+" is contributed twice.");this.h.set(C,y)}async l(C,y,a,m,c){if(I.$Vf(a))return this.m(C,y,a,m,c);if(Array.isArray(a))return Promise.all(a.map(i=>this.l(C,y,i,m,c)));if(I.$Xf(a)){const i=Object.create(null),n=await Promise.all(Object.keys(a).map(async r=>[await this.m(C,y,r,m,c),await this.l(C,y,a[r],m,c)]));for(const[r,s]of n)i[r]=s;return i}return a}m(C,y,a,m,c){return(0,A.$df)(a,P.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(P.VARIABLE_LHS))return i;let r=await this.o(C,i,n,y,m);return c?.set(n,r),r!==i&&I.$Vf(r)&&r.match(P.VARIABLE_REGEXP)&&(r=await this.m(C,y,r,m,c)),r})}n(C){return this.b?this.b.getUriLabel(C,{noPrefix:!0}):C.fsPath}async o(C,y,a,m,c){let i;const n=a.split(":");n.length>1&&(a=n[0],i=n[1]);const r=f=>{const d=this.a.getFilePath();if(d)return(0,p.$iw)(d);throw new w.$BP(f,(0,$.localize)(0,null,y))},s=f=>{const d=r(f);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,p.$iw)(u)}throw new w.$BP(f,(0,$.localize)(1,null,y,o.$oc(d)))},t=f=>{if(i){const d=this.a.getFolderUri(i);if(d)return d;throw new w.$BP(f,(0,$.localize)(2,null,y,i))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new w.$BP(f,(0,$.localize)(3,null,y)):new w.$BP(f,(0,$.localize)(4,null,y))};switch(a){case"env":if(i){if(C.env){const f=C.env[L.$c?i.toLowerCase():i];if(I.$Vf(f))return f}return""}throw new w.$BP(w.VariableKind.Env,(0,$.localize)(5,null,y));case"config":if(i){const f=this.a.getConfigurationValue(m,i);if(I.$5f(f))throw new w.$BP(w.VariableKind.Config,(0,$.localize)(6,null,y,i));if(I.$Xf(f))throw new w.$BP(w.VariableKind.Config,(0,$.localize)(7,null,y,i));return f}throw new w.$BP(w.VariableKind.Config,(0,$.localize)(8,null,y));case"command":return this.p(w.VariableKind.Command,y,i,c,"command");case"input":return this.p(w.VariableKind.Input,y,i,c,"input");case"extensionInstallFolder":if(i){const f=await this.a.getExtension(i);if(!f)throw new w.$BP(w.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,y,i));return this.n(f.extensionLocation)}throw new w.$BP(w.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,y));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,p.$iw)(this.n(t(w.VariableKind.WorkspaceFolder)));case"cwd":return m||i?(0,p.$iw)(this.n(t(w.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$iw)(o.$oc(this.n(t(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(C.userHome)return C.userHome;throw new w.$BP(w.VariableKind.UserHome,(0,$.localize)(11,null,y))}case"lineNumber":{const f=this.a.getLineNumber();if(f)return f;throw new w.$BP(w.VariableKind.LineNumber,(0,$.localize)(12,null,y))}case"selectedText":{const f=this.a.getSelectedText();if(f)return f;throw new w.$BP(w.VariableKind.SelectedText,(0,$.localize)(13,null,y))}case"file":return r(w.VariableKind.File);case"fileWorkspaceFolder":return s(w.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return o.$oc(s(w.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||i?o.$mc(this.n(t(w.VariableKind.RelativeFile)),r(w.VariableKind.RelativeFile)):r(w.VariableKind.RelativeFile);case"relativeFileDirname":{const f=o.$nc(r(w.VariableKind.RelativeFileDirname));if(m||i){const d=o.$mc(this.n(t(w.VariableKind.RelativeFileDirname)),f);return d.length===0?".":d}return f}case"fileDirname":return o.$nc(r(w.VariableKind.FileDirname));case"fileExtname":return o.$pc(r(w.VariableKind.FileExtname));case"fileBasename":return o.$oc(r(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const f=o.$oc(r(w.VariableKind.FileBasenameNoExtension));return f.slice(0,f.length-o.$pc(f).length)}case"fileDirnameBasename":return o.$oc(o.$nc(r(w.VariableKind.FileDirnameBasename)));case"execPath":{const f=this.a.getExecPath();return f||y}case"execInstallFolder":{const f=this.a.getAppRoot();return f||y}case"pathSeparator":case"/":return o.sep;default:try{const f=i?`${a}:${i}`:a;return this.p(w.VariableKind.Unknown,y,f,c,void 0)}catch{return y}}}}p(C,y,a,m,c){if(a&&m){const i=c===void 0?m[a]:m[c+":"+a];if(typeof i=="string")return i;throw new w.$BP(C,(0,$.localize)(14,null,y))}return y}}e.$QP=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[147],Ce([1,0,5,143]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$BD=void 0,e.$CD=w,e.$DD=b,e.$ED=C,e.$BD=(0,o.$ii)("editorGroupsService");var I;(function(y){y[y.UP=0]="UP",y[y.DOWN=1]="DOWN",y[y.LEFT=2]="LEFT",y[y.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var M;(function(y){y[y.HORIZONTAL=0]="HORIZONTAL",y[y.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var L;(function(y){y[y.FIRST=0]="FIRST",y[y.LAST=1]="LAST",y[y.NEXT=2]="NEXT",y[y.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var p;(function(y){y[y.MAXIMIZE=0]="MAXIMIZE",y[y.EXPAND=1]="EXPAND",y[y.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var $;(function(y){y[y.COPY_EDITORS=0]="COPY_EDITORS",y[y.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function w(y){const a=y;return(0,R.$mF)(a?.editor)&&(0,R.$mF)(a?.replacement)}var A;(function(y){y[y.CREATION_TIME=0]="CREATION_TIME",y[y.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",y[y.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var P;(function(y){y[y.NEW_EDITOR=1]="NEW_EDITOR",y[y.MOVE_EDITOR=2]="MOVE_EDITOR",y[y.COPY_EDITOR=3]="COPY_EDITOR"})(P||(e.OpenEditorContext=P={}));function b(y){const a=y;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function C(y){return y.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Ee[300],Ce([1,0,5,147]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ID=e.$HD=e.$GD=e.$FD=void 0,e.$JD=I,e.$FD=(0,o.$ii)("editorService"),e.$GD=-1,e.$HD=-2,e.$ID=-3;function I(M){const L=M;return typeof M=="number"||(0,R.$DD)(L)}}),define(Ee[148],Ce([1,0,5,137]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PL=void 0,e.$PL=(0,o.$ji)(R.$pi)}),define(Ee[149],Ce([1,0,25,4,17,3,8]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u$b=e.$t$b=e.$s$b=e.$r$b=e.$q$b=void 0;class p{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$q$b=p;class ${static isHostExtension(i,n,r){if(n.getExtensionDescription(i))return!1;const s=r.getExtensionDescription(i);return s?!!((s.main||s.browser)&&s.api==="none"):!1}constructor(i,n){this.j=i,this.c=new R.$7d,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(a),this.f=new o.$Gm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const r of n)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=m(this.e,n),this.e=this.e.concat(i);const r=$.l(this.e);return this.e=m(this.e,r.map(s=>s.identifier)),this.k(),this.d++,this.c.fire(void 0),new p(this.d,r)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,u){this.addNode(d),this.addNode(u),this.c.has(d)?this.c.get(d).push(u):this.c.set(d,[u])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,u){const h=n.getArcs(d);for(let l=0;l<h.length;l++)if(!u.has(h[l]))return!1;return!0}getNodes(){return this.e}},r=new o.$Gm;for(const d of i)if(r.set(d.identifier,d),d.extensionDependencies)for(const u of d.extensionDependencies)n.addArc(o.$Em.toKey(d.identifier),o.$Em.toKey(u));const s=new Set;n.getNodes().filter(d=>n.getArcs(d).length===0).forEach(d=>s.add(d));const t=n.getNodes().filter(d=>!s.has(d));let f;do{f=!1;for(let d=0;d<t.length;d++){const u=t[d];n.hasOnlyGoodArcs(u,s)&&(t.splice(d,1),d--,s.add(u),f=!0)}}while(f);return t.map(d=>r.get(d))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new w(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$r$b=$;class w{constructor(i,n){this.versionId=i,this.extensions=n}}e.$s$b=w;class A{constructor(i){this.d=new C,this.c=new $(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new P(this,n)}deltaExtensions(i,n,r){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,r)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$t$b=A;class P extends M.$Uc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$u$b=P;class b{constructor(i){this.name=i;const n=(0,L.$bh)();this.promise=n.promise,this.c=n.resolve}resolve(i){this.c(i)}}class C{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new b(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const r=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),s=()=>{n&&(clearTimeout(r),n=!1,this.d=!1,this.e())};i.resolve((0,M.$Sc)(s))}}var y;(function(c){c[c.Builtin=0]="Builtin",c[c.User=1]="User",c[c.Dev=2]="Dev"})(y||(y={}));function a(c,i){const n=c.isBuiltin?0:c.isUnderDevelopment?2:1,r=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==r)return n-r;const s=I.$hc.basename(c.extensionLocation.path),t=I.$hc.basename(i.extensionLocation.path);return s<t?-1:s>t?1:0}function m(c,i){const n=new o.$Fm(i);return c.filter(r=>!n.has(r.identifier))}}),define(Ee[301],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=e.ExtHostConnectionType=void 0,e.$an=p,e.$bn=$;var o;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(o||(e.ExtHostConnectionType=o={}));class R{constructor(P){this.pipeName=P,this.type=1}serialize(P){P[R.ENV_KEY]=this.pipeName}}e.$0m=R,R.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class I{constructor(){this.type=2}serialize(P){P[I.ENV_KEY]="1"}}e.$$m=I,I.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class M{constructor(){this.type=3}serialize(P){P[M.ENV_KEY]="1"}}e.$_m=M,M.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function L(A){delete A[R.ENV_KEY],delete A[I.ENV_KEY],delete A[M.ENV_KEY]}function p(A,P){L(P),A.serialize(P)}function $(A){if(A[R.ENV_KEY])return w(A,new R(A[R.ENV_KEY]));if(A[I.ENV_KEY])return w(A,new I);if(A[M.ENV_KEY])return w(A,new M);throw new Error("No connection information defined in environment!")}function w(A,P){return L(A),P}}),define(Ee[115],Ce([1,0,21]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Mm=L,e.$Nm=p;var R;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(R||(e.UIKind=R={}));var I;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var M;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function L(w){const A=o.$ue.alloc(1);switch(w){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}function p(w,A){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}var $;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Ee[90],Ce([1,0,5,4,12,28,115,86,87,24,2,3,226]),function(re,e,o,R,I,M,L,p,$,w,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9O=e.$7O=e.$6O=void 0,e.$8O=a;let C=class extends P.$Uc{constructor(c,i){super(),this.s=c,this.t=i,this.a=this.B(new R.$7d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new R.$7d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:$.$0o,name:(0,b.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,I.$Qj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(c,i,n){const r=this.getTelemetryDetails(),s=new y(i,n,c,this.n,this.j,this.getBuiltInCommonProperties(c),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this.r.get(c.identifier.value)??[];return this.r.set(c.identifier.value,[...t,s]),s.apiTelemetryLogger}$initializeTelemetryLevel(c,i,n){this.f=c,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(c){const i=Object.create(null);switch(i["common.extname"]=`${c.publisher}.${c.name}`,i["common.extversion"]=c.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=a(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case L.UIKind.Web:i["common.uikind"]="web";break;case L.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$vm)((0,$.$dp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(c){this.h=this.getTelemetryConfiguration(),this.f=c;const i=this.getTelemetryDetails();this.r.forEach((n,r)=>{const s=n.filter(t=>!t.isDisposed);s.length===0?this.r.delete(r):this.r.set(r,s)}),this.r.forEach(n=>{for(const r of n)r.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(c,i){const r=this.r.get(c.value)?.filter(t=>!t.isDisposed);if(!r)return this.r.delete(c.value),!1;let s=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(i),s=!0);return s}};e.$6O=C,e.$6O=C=Qe([He(0,M.$5O),He(1,I.$Pj)],C);class y{static validateSender(c){if(typeof c!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof c.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof c.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof c.flush<"u"&&typeof c.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(c,i,n,r,s,t,f){this.g=n,this.h=r,this.i=s,this.j=t,this.a=new R.$7d,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=c,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(c,i){this.e&&(this.d={isUsageEnabled:c,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(c){let i="properties"in c?c.properties??{}:c;return i=(0,$.$gp)(i,[]),this.c&&(i=(0,w.$Sn)(i,this.c)),this.b||(i=(0,w.$Sn)(i,this.j)),"properties"in c?c.properties=i:c=i,c}k(c,i){this.f&&(this.g.publisher==="vscode"?c=this.g.name+"/"+c:c=this.g.identifier.value+"/"+c,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(c,i),this.h.trace(c,i))}logUsage(c,i){this.d.isUsageEnabled&&this.k(c,i)}logError(c,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof c=="string")this.k(c,i);else{const n={name:c.name,message:c.message,stack:c.stack,cause:c.cause},r=(0,$.$gp)(n,[]),s=new Error(r.message,{cause:r.cause});s.stack=r.stack,s.name=r.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(s,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const c=this,i={logUsage:c.logUsage.bind(c),get isUsageEnabled(){return c.d.isUsageEnabled},get isErrorsEnabled(){return c.d.isErrorsEnabled},logError:c.logError.bind(c),dispose:c.dispose.bind(c),onDidChangeEnableStates:c.a.event.bind(c)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let c=this.f;this.f=void 0,Promise.resolve(c.flush()).then(c=void 0),this.e=void 0}else this.f=void 0}}e.$7O=y;function a(m){const c=Date.now()-new Date(m).getTime();return isNaN(c)?!1:c<1e3*60*60*24}e.$9O=(0,o.$ii)("IExtHostTelemetry")}),define(Ee[26],Ce([1,0,4,2,271,141,25,5]),function(re,e,o,R,I,M,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iG=e.ActivationKind=e.$fG=e.$eG=e.$bG=e.ExtensionHostStartup=e.$aG=e.$_F=e.$$F=e.$0F=void 0,e.$cG=b,e.$dG=C,e.$gG=c,e.$hG=i,e.$0F=Object.freeze({identifier:new L.$Em("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$$F="extensions.webWorker",e.$_F=(0,p.$ii)("extensionService");class ${constructor(s){this.dependency=s}}e.$aG=$;var w;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(s,t,f){this.c=s,this.d=t.slice(0),this.e=f.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$UF.createActivationEventsMap(this.d)}}set(s,t,f){if(this.c>s)throw new Error(`ExtensionHostExtensions: invalid versionId ${s} (current: ${this.c})`);const d=[],u=[],h=[],l=[],g=P(this.d),E=P(t),v=(W,B)=>W.extensionLocation.toString()===B.extensionLocation.toString()||W.isBuiltin===B.isBuiltin||W.isUserBuiltin===B.isUserBuiltin||W.isUnderDevelopment===B.isUnderDevelopment;for(const W of this.d){const B=E.get(W.identifier);if(!B){d.push(W.identifier),g.delete(W.identifier);continue}if(!v(W,B)){d.push(W.identifier),g.delete(W.identifier);continue}}for(const W of t){const B=g.get(W.identifier);if(!B){u.push(W);continue}if(!v(B,W)){d.push(B.identifier),g.delete(B.identifier);continue}}const S=new L.$Fm(this.e),k=new L.$Fm(f);for(const W of this.e)k.has(W)||h.push(W);for(const W of f)S.has(W)||l.push(W);const D=M.$UF.createActivationEventsMap(u),F={versionId:s,toRemove:d,toAdd:u,addActivationEvents:D,myToRemove:h,myToAdd:l};return this.delta(F),F}delta(s){if(this.c>=s.versionId)return null;const{toRemove:t,toAdd:f,myToRemove:d,myToAdd:u}=s,h=new L.$Fm(t),l=new L.$Fm(d);for(let g=0;g<this.d.length;g++)h.has(this.d[g].identifier)&&(this.d.splice(g,1),g--);for(let g=0;g<this.e.length;g++)l.has(this.e[g])&&(this.e.splice(g,1),g--);for(const g of f)this.d.push(g);for(const g of u)this.e.push(g);return this.f=null,s}containsExtension(s){for(const t of this.e)if(L.$Em.equals(t,s))return!0;return!1}containsActivationEvent(s){return this.f||(this.f=this.g()),this.f.has(s)}g(){const s=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const f=M.$UF.readActivationEvents(t);for(const d of f)s.add(d)}return s}}e.$bG=A;function P(r){const s=new L.$Gm;for(const t of r)s.set(t.identifier,t);return s}function b(r,s){return!0}function C(r,s){if(!b(r,s))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${s}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${s}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class y{constructor(s,t,f,d){this.codeLoadingTime=s,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=d}}e.$eG=y;class a{constructor(s,t){this.description=s,this.value=t}}e.$fG=a;var m;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function c(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,I.$mp)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function i(r,s){return{identifier:new L.$Em((0,I.$kp)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!s,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}class n{constructor(){this.onDidRegisterExtensions=o.Event.None,this.onDidChangeExtensionsStatus=o.Event.None,this.onDidChangeExtensions=o.Event.None,this.onWillActivateByEvent=o.Event.None,this.onDidChangeResponsiveChange=o.Event.None,this.onWillStop=o.Event.None,this.extensions=[]}activateByEvent(s){return Promise.resolve(void 0)}activateById(s,t){return Promise.resolve(void 0)}activationEventIsDone(s){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(s){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(s,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(s){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$iG=n}),define(Ee[302],Ce([1,0,13,149,25,26,12,8]),function(re,e,o,R,I,M,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=e.$ikc=e.$hkc=e.$gkc=e.$fkc=e.$ekc=void 0;class ${constructor(c,i,n,r){this.startup=c,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=r}}e.$ekc=$,$.NONE=new $(!1,-1,-1,-1);class w{constructor(c){this.a=c,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(c,i){return c===-1||i===-1?-1:i-c}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$fkc=w;class A{constructor(c,i,n,r,s,t){this.activationFailed=c,this.activationFailedError=i,this.activationTimes=n,this.module=r,this.exports=s,this.subscriptions=t}}e.$gkc=A;class P extends A{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.$hkc=P;class b extends A{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$ikc=b;class C extends A{constructor(c){super(!0,c,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let y=class{constructor(c,i,n,r){this.g=r,this.a=c,this.b=i,this.c=n,this.d=new I.$Gm,this.f=Object.create(null)}dispose(){for(const[c,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const c=[];for(const[i,n]of this.d)c.push(n.wait());await Promise.all(c)}isActivated(c){const i=this.d.get(c);return!!(i&&i.value)}getActivatedExtension(c){const i=this.d.get(c);if(!i||!i.value)throw new Error(`Extension '${c.value}' is not known or not activated`);return i.value}async activateByEvent(c,i){if(this.f[c])return;const n=this.a.getExtensionDescriptionsForActivationEvent(c);await this.h(n.map(r=>({id:r.identifier,reason:{startup:i,extensionId:r.identifier,activationEvent:c}}))),this.f[c]=!0}activateById(c,i){const n=this.a.getExtensionDescription(c);if(!n)throw new Error(`Extension '${c.value}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(c){const i=c.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(c){if(this.d.has(c.id))return this.d.get(c.id);if(this.l(c.id))return this.k(c,null,[],null);const i=this.a.getExtensionDescription(c.id);if(!i){const s=new Error(`Cannot activate unknown extension '${c.id.value}'`),t=this.k(c,null,[],new C(s));return this.c.onExtensionActivationError(c.id,s,new M.$aG(c.id.value)),t}const n=[],r=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const s of r){if(this.m(s))continue;const t=this.d.get(s);if(t){n.push(t);continue}if(this.l(s)){n.push(this.j({id:this.b.getExtensionDescription(s).identifier,reason:c.reason}));continue}const f=this.a.getExtensionDescription(s);if(f){if(!f.main&&!f.browser)continue;n.push(this.j({id:f.identifier,reason:c.reason}));continue}const d=i.displayName||i.identifier.value,u=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${s}'`),h=this.k(c,i.displayName,[],new C(u));return this.c.onExtensionActivationError(i.identifier,u,new M.$aG(s)),h}return this.k(c,i.displayName,n,null)}k(c,i,n,r){const s=new a(c.id,i,c.reason,n,r,this.c,this.g);return this.d.set(c.id,s),s}l(c){return R.$r$b.isHostExtension(c,this.a,this.b)}m(c){const i=this.b.getExtensionDescription(c);return i?!i.main&&!i.browser:!1}};e.$jkc=y,e.$jkc=y=Qe([He(3,L.$Oj)],y);let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(c,i,n,r,s,t,f){this.c=c,this.d=i,this.f=n,this.g=r,this.h=s,this.j=t,this.k=f,this.a=new p.$hh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let c=0;c<this.g.length;c++){const i=this.g[c];if(i.value&&!i.value.activationFailed){this.g.splice(c,1),c--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new C(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(c=>c.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(c){const i=new Error;if(c&&c.name&&(i.name=c.name),c&&c.message?i.message=`Activating extension '${this.c.value}' failed: ${c.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${c}.`,c&&c.stack&&(i.stack=c.stack),this.h=new C(i),this.b&&o.$4(c))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(c)}}};a=Qe([He(6,L.$Oj)],a)}),define(Ee[303],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ee[304],Ce([1,0,242,13,41,138,109,37,25,303,140,141]),function(re,e,o,R,I,M,L,p,$,w,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=void 0;const b=p.$2n.as(L.$3n.JSONContribution);class C{constructor(s,t,f){this.a=s,this.b=t,this.c=f}d(s,t){this.a({type:s,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(s){this.d(I.default.Error,s)}warn(s){this.d(I.default.Warning,s)}info(s){this.d(I.default.Info,s)}}e.$4F=C;class y{static a(s){const t=new $.$Fm;for(let f=0,d=s.length;f<d;f++)t.add(s[f].description.identifier);return t}static compute(s,t){if(!s||!s.length)return new y(t,[]);if(!t||!t.length)return new y([],s);const f=this.a(s),d=this.a(t),u=t.filter(l=>!f.has(l.description.identifier)),h=s.filter(l=>!d.has(l.description.identifier));return new y(u,h)}constructor(s,t){this.added=s,this.removed=t}}e.$5F=y;class a{constructor(s,t){this.name=s,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(s){if(this.a!==null)throw new Error("Handler already set!");this.a=s,this.d()}acceptUsers(s){this.c=y.compute(this.b,s),this.b=s,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(s){(0,R.$1)(s)}}}e.$6F=a;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[o.localize(0,null),o.localize(1,null)]},c="vscode://schemas/vscode-extensions";e.$7F={properties:{engines:{type:"object",description:o.localize(2,null),properties:{vscode:{type:"string",description:o.localize(3,null),default:"^1.22.0"}}},publisher:{description:o.localize(4,null),type:"string"},displayName:{description:o.localize(5,null),type:"string"},categories:{description:o.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$Dm},{type:"string",const:"Languages",deprecationMessage:o.localize(7,null)}]}},galleryBanner:{type:"object",description:o.localize(8,null),properties:{color:{description:o.localize(9,null),type:"string"},theme:{description:o.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:o.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:o.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:o.localize(13,null)},enabledApiProposals:{markdownDescription:o.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}},api:{markdownDescription:o.localize(15,null),type:"string",enum:["none"],enumDescriptions:[o.localize(16,null)]},activationEvents:{description:o.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:o.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:o.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:o.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:o.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:o.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:o.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:o.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:o.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:o.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:o.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:o.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:o.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:o.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:o.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:o.localize(32,null)},{label:"onUri",body:"onUri",description:o.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:o.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:o.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:o.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:o.localize(37,null)},{label:"onRenderer",description:o.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:o.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:o.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:o.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:o.localize(42,null)},{label:"*",description:o.localize(43,null),body:"*"}]}},badges:{type:"array",description:o.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:o.localize(45,null)},href:{type:"string",description:o.localize(46,null)},description:{type:"string",description:o.localize(47,null)}}}},markdown:{type:"string",description:o.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:o.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:o.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$Go}},extensionPack:{description:o.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$Go}},extensionKind:{description:o.localize(52,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:o.localize(53,null)},{body:["workspace"],description:o.localize(54,null)},{body:["ui","workspace"],description:o.localize(55,null)},{body:["workspace","ui"],description:o.localize(56,null)},{body:[],description:o.localize(57,null)}]},capabilities:{description:o.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:o.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:o.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(61,null),o.localize(62,null),o.localize(63,null)]},description:{type:"string",markdownDescription:o.localize(64,null)}}},untrustedWorkspaces:{description:o.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:o.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(67,null),o.localize(68,null),o.localize(69,null)]},restrictedConfigurations:{description:o.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:o.localize(71,null)}}}}},sponsor:{description:o.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:o.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:o.localize(74,null),type:"string"},"vscode:uninstall":{description:o.localize(75,null),type:"string"}}},icon:{type:"string",description:o.localize(76,null)},l10n:{type:"string",description:o.localize(77,null)},pricing:{type:"string",markdownDescription:o.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(s){if(this.a.has(s.extensionPoint))throw new Error("Duplicate extension point: "+s.extensionPoint);const t=new a(s.extensionPoint,s.defaultExtensionKind);return this.a.set(s.extensionPoint,t),s.activationEventsGenerator&&P.$UF.register(s.extensionPoint,s.activationEventsGenerator),e.$7F.properties.contributes.properties[s.extensionPoint]=s.jsonSchema,b.registerSchema(c,e.$7F),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$8F=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};p.$2n.add(n.ExtensionsRegistry,new i),e.$9F=p.$2n.as(n.ExtensionsRegistry),b.registerSchema(c,e.$7F),b.registerSchema(A.$9j,{properties:{extensionEnabledApiProposals:{description:o.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}}]}}}})}),define(Ee[305],Ce([1,0,238,18,24,304,42,4]),function(re,e,o,R,I,M,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yH=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:o.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:o.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:o.localize(2,null),default:""}}};var w;(function(b){function C(y,a,m){if(!y)return;const c=R.$Vf(y.type)?y.type:void 0;if(!c||c.length===0){m.error(o.localize(3,null));return}const i=[];if(Array.isArray(y.required))for(const n of y.required)R.$Vf(n)&&i.push(n);return{extensionId:a.value,taskType:c,required:i,properties:y.properties?I.$Pn(y.properties):{},when:y.when?L.$gj.deserialize(y.when):void 0}}b.from=C})(w||(w={}));const A=M.$9F.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(b,C)=>{for(const y of b)y.type&&C.push(`onTaskType:${y.type}`)},jsonSchema:{description:o.localize(4,null),type:"array",items:$}});class P{constructor(){this.d=new p.$7d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((C,y)=>{A.setHandler((a,m)=>{this.c=void 0;try{for(const c of m.removed){const i=c.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const c of m.added){const i=c.value;for(const n of i){const r=w.from(n,c.description.identifier,c.collector);r&&(this.a[r.taskType]=r)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}C(void 0)})})}onReady(){return this.b}get(C){return this.a[C]}all(){return Object.keys(this.a).map(C=>this.a[C])}getJsonSchema(){if(this.c===void 0){const C=[];for(const y of this.all()){const a={type:"object",additionalProperties:!1};y.required.length>0&&(a.required=y.required.slice(0)),y.properties!==void 0?a.properties=I.$Pn(y.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[y.taskType]},C.push(a)}this.c={oneOf:C}}return this.c}}e.$yH=new P}),define(Ee[306],Ce([1,0,239,18,23,24,42,305]),function(re,e,o,R,I,M,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$IH=e.JsonSchemaVersion=e.ExecutionEngine=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$CH=e.ShellQuoting=e.$BH=e.$AH=e.$zH=void 0,e.$zH="settings",e.$AH=new L.$zj("taskRunning",!1,o.localize(0,null)),e.$BH=o.localize2(2,"Tasks");var $;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$CH="$customized",function(N){function T(O){if(!O)return N.Strong;switch(O.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=T}($||(e.ShellQuoting=$={}));var w;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(w||(e.CommandOptions=w={}));var A;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(A||(e.RevealKind=A={})),function(N){function T(O){switch(O.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=T}(A||(e.RevealKind=A={}));var P;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(P||(e.RevealProblemKind=P={})),function(N){function T(O){switch(O.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=T}(P||(e.RevealProblemKind=P={}));var b;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(b||(e.PanelKind=b={})),function(N){function T(O){switch(O.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=T}(b||(e.PanelKind=b={}));var C;(function(N){N.defaults={echo:!0,reveal:A.Always,revealProblems:P.Never,focus:!1,panel:b.Shared,showReuseMessage:!0,clear:!1}})(C||(e.PresentationOptions=C={}));var y;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(y||(e.RuntimeType=y={})),function(N){function T(z){switch(z.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=T;function O(z){switch(z){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=O}(y||(e.RuntimeType=y={}));var a;(function(N){function T(O){return R.$Vf(O)?O:O.value}N.value=T})(a||(e.CommandString=a={}));var m;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function T(z){return z===N.Clean._id||z===N.Build._id||z===N.Rebuild._id||z===N.Test._id}N.is=T;function O(z){if(z!==void 0)return R.$Vf(z)?T(z)?{_id:z,isDefault:!1}:void 0:z}N.from=O})(m||(e.TaskGroup=m={}));var c;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(c||(e.TaskScope=c={}));var i;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function T(O){switch(O){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=T})(i||(e.TaskSourceKind=i={}));var n;(function(N){N.parallel="parallel",N.sequence="sequence"})(n||(e.DependsOrder=n={}));var r;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var s;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(s||(e.RunOptions=s={}));class t{constructor(T,O,z,Q,Z,J){this._label="",this._id=T,O&&(this._label=O),z&&(this.type=z),this.runOptions=Q,this.configurationProperties=Z,this._source=J}getDefinition(T){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,O=!1){if(T===void 0)return!1;if(R.$Vf(T))return T===this._label||T===this.configurationProperties.identifier||O&&T===this._id;const z=this.getDefinition(!0);return z!==void 0&&z._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.$DH=t;class f extends t{constructor(T,O,z,Q,Z,J,x,ce){super(T,z,void 0,x,ce,O),this.command={},this._source=O,this.hasDefinedMatchers=J,Z&&(this.command=Z)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let O;switch(this.command?this.command.runtime:void 0){case y.Shell:O="shell";break;case y.Process:O="process";break;case y.CustomExecution:O="customExecution";break;case void 0:O="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:O,_key:this._id,id:this._id}}}static is(T){return T instanceof f}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$zH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const T=this.d();if(!T)return;let O=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(O+=this._source.kind);const z={type:e.$CH,folder:T,id:O};return JSON.stringify(z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Sg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new f(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$EH=f;class d extends t{constructor(T,O,z,Q,Z,J,x){super(T,z,Q,J,x,O),this._source=O,this.configures=Z}static is(T){return T instanceof d}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Sg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$zH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const T=this.d();if(!T)return;let O=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(O+=this._source.kind);const z={type:e.$CH,folder:T,id:O};return JSON.stringify(z)}}e.$FH=d;class u extends t{constructor(T,O,z,Q,Z,J,x,ce,te){super(T,z,Q,ce,te,O),this.defines=Z,this.hasDefinedMatchers=x,this.command=J,this.icon=te.icon,this.hide=te.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof u}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new u(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$GH=u;class h extends t{constructor(T,O,z,Q,Z,J){super(T,z,Q,Z,J,O),this._source=O}clone(){return new h(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof h}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new h(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.$HH=h;var l;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(l||(e.ExecutionEngine=l={})),function(N){N._default=N.Terminal}(l||(e.ExecutionEngine=l={}));var g;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(g||(e.JsonSchemaVersion=g={}));class E{constructor(T){this.c=new Map;for(let O=0;O<T.length;O++)this.c.set(T[O].uri.toString(),O)}compare(T,O){const z=T.getWorkspaceFolder(),Q=O.getWorkspaceFolder();if(z&&Q){let Z=this.c.get(z.uri.toString());Z=Z===void 0?0:Z+1;let J=this.c.get(Q.uri.toString());return J=J===void 0?0:J+1,Z===J?T._label.localeCompare(O._label):Z-J}else return!z&&Q?-1:z&&!Q?1:0}}e.$IH=E;var v;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(v||(e.TaskEventKind=v={}));var S;(function(N){N.SingleRun="singleRun",N.Background="background"})(S||(e.TaskRunType=S={}));var k;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var D;(function(N){function T(ce){return{taskId:ce._id,taskName:ce.configurationProperties.name,runType:ce.configurationProperties.isBackground?"background":"singleRun",group:ce.configurationProperties.group,__task:ce}}function O(ce,te,pe){return{...T(ce),kind:"start",terminalId:te,resolvedVariables:pe}}N.start=O;function z(ce,te,pe){return{...T(ce),kind:"processStarted",terminalId:te,processId:pe}}N.processStarted=z;function Q(ce,te,pe){return{...T(ce),kind:"processEnded",terminalId:te,exitCode:pe}}N.processEnded=Q;function Z(ce,te,pe){return{...T(ce),kind:"terminated",exitReason:pe,terminalId:te}}N.terminated=Z;function J(ce,te,pe){return{...T(te),kind:ce,terminalId:pe}}N.general=J;function x(){return{kind:"changed"}}N.changed=x})(D||(e.TaskEvent=D={}));var F;(function(N){function T(z){const Q=Object.keys(z).sort();let Z="";for(const J of Q){let x=z[J];x instanceof Object?x=T(x):typeof x=="string"&&(x=x.replace(/,/g,",,")),Z+=J+","+x+","}return Z}function O(z){const Z={_key:T(z),type:z.taskType};return Object.assign(Z,z),Z}N.create=O})(F||(e.KeyedTaskIdentifier=F={}));var W;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(W||(e.TaskSettingId=W={}));var B;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(B||(e.TasksSchemaProperties=B={}));var j;(function(N){function T(O,z){const Q=p.$yH.get(O.type);if(Q===void 0){const ce=M.$Pn(O);return delete ce._key,F.create(ce)}const Z=Object.create(null);Z.type=Q.taskType;const J=new Set;Q.required.forEach(ce=>J.add(ce));const x=Q.properties;for(const ce of Object.keys(x)){const te=O[ce];if(te!=null)Z[ce]=te;else if(J.has(ce)){const pe=x[ce];if(pe.default!==void 0)Z[ce]=M.$Pn(pe.default);else switch(pe.type){case"boolean":Z[ce]=!1;break;case"number":case"integer":Z[ce]=0;break;case"string":Z[ce]="";break;default:z.error(o.localize(1,null,JSON.stringify(O,void 0,0),ce));return}}}return F.create(Z)}N.createTaskIdentifier=T})(j||(e.TaskDefinition=j={}))}),define(Ee[307],Ce([1,0,13]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w$b=e.$v$b=void 0;class R{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,p)=>{this.b=L,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,o.$1)(L))}then(L,p){return this.j().then(L,p)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.$v$b=R;class I extends R{constructor(){super(),this.h=!0,this.i=new o.$5}}e.$w$b=I}),define(Ee[68],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fw=e.$cw=void 0,e.$dw=I,e.$ew=M;class o{constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++o.count}}e.$cw=o,o.count=0;const R=[];function I(p){const $=new o(p);return R[$.nid]=$,$}function M(p){return R[p].sid}class L{constructor($){this.value=$}}e.$fw=L}),define(Ee[6],Ce([1,0,68]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=e.$sM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$rM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(R||(e.TextEditorRevealType=R={}));var I;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(I||(e.TabInputKind=I={}));var M;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var L;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var p;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var $;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var w;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var A;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class P{static mixin(m){return m._id=P.a++,m}}e.$rM=P,P.a=0;var b;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(b||(e.ISuggestDataDtoField=b={}));var C;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(C||(e.ISuggestResultDtoField=C={}));var y;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(y||(e.ExtHostTestingResource=y={})),e.$sM={MainThreadAuthentication:(0,o.$dw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,o.$dw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,o.$dw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,o.$dw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,o.$dw)("MainThreadChatVariables"),MainThreadClipboard:(0,o.$dw)("MainThreadClipboard"),MainThreadCommands:(0,o.$dw)("MainThreadCommands"),MainThreadComments:(0,o.$dw)("MainThreadComments"),MainThreadConfiguration:(0,o.$dw)("MainThreadConfiguration"),MainThreadConsole:(0,o.$dw)("MainThreadConsole"),MainThreadDebugService:(0,o.$dw)("MainThreadDebugService"),MainThreadDecorations:(0,o.$dw)("MainThreadDecorations"),MainThreadDiagnostics:(0,o.$dw)("MainThreadDiagnostics"),MainThreadDialogs:(0,o.$dw)("MainThreadDiaglogs"),MainThreadDocuments:(0,o.$dw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,o.$dw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,o.$dw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,o.$dw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,o.$dw)("MainThreadEditorTabs"),MainThreadErrors:(0,o.$dw)("MainThreadErrors"),MainThreadTreeViews:(0,o.$dw)("MainThreadTreeViews"),MainThreadDownloadService:(0,o.$dw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,o.$dw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,o.$dw)("MainThreadLanguages"),MainThreadLogger:(0,o.$dw)("MainThreadLogger"),MainThreadMessageService:(0,o.$dw)("MainThreadMessageService"),MainThreadOutputService:(0,o.$dw)("MainThreadOutputService"),MainThreadProgress:(0,o.$dw)("MainThreadProgress"),MainThreadQuickDiff:(0,o.$dw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,o.$dw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,o.$dw)("MainThreadStatusBar"),MainThreadSecretState:(0,o.$dw)("MainThreadSecretState"),MainThreadStorage:(0,o.$dw)("MainThreadStorage"),MainThreadSpeech:(0,o.$dw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,o.$dw)("MainThreadTelemetry"),MainThreadTerminalService:(0,o.$dw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,o.$dw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,o.$dw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,o.$dw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,o.$dw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,o.$dw)("MainThreadCustomEditors"),MainThreadUrls:(0,o.$dw)("MainThreadUrls"),MainThreadUriOpeners:(0,o.$dw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,o.$dw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,o.$dw)("MainThreadWorkspace"),MainThreadFileSystem:(0,o.$dw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,o.$dw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,o.$dw)("MainThreadExtensionService"),MainThreadSCM:(0,o.$dw)("MainThreadSCM"),MainThreadSearch:(0,o.$dw)("MainThreadSearch"),MainThreadShare:(0,o.$dw)("MainThreadShare"),MainThreadTask:(0,o.$dw)("MainThreadTask"),MainThreadWindow:(0,o.$dw)("MainThreadWindow"),MainThreadLabelService:(0,o.$dw)("MainThreadLabelService"),MainThreadNotebook:(0,o.$dw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,o.$dw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,o.$dw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,o.$dw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,o.$dw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,o.$dw)("MainThreadInteractive"),MainThreadChat:(0,o.$dw)("MainThreadChat"),MainThreadInlineChat:(0,o.$dw)("MainThreadInlineChatShape"),MainThreadTheming:(0,o.$dw)("MainThreadTheming"),MainThreadTunnelService:(0,o.$dw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,o.$dw)("MainThreadManagedSockets"),MainThreadTimeline:(0,o.$dw)("MainThreadTimeline"),MainThreadTesting:(0,o.$dw)("MainThreadTesting"),MainThreadLocalization:(0,o.$dw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,o.$dw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,o.$dw)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,o.$dw)("MainThreadIssueReporter")},e.$tM={ExtHostCommands:(0,o.$dw)("ExtHostCommands"),ExtHostConfiguration:(0,o.$dw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,o.$dw)("ExtHostDiagnostics"),ExtHostDebugService:(0,o.$dw)("ExtHostDebugService"),ExtHostDecorations:(0,o.$dw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,o.$dw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,o.$dw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,o.$dw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,o.$dw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,o.$dw)("ExtHostEditors"),ExtHostTreeViews:(0,o.$dw)("ExtHostTreeViews"),ExtHostFileSystem:(0,o.$dw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,o.$dw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,o.$dw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,o.$dw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,o.$dw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,o.$dw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,o.$dw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,o.$dw)("ExtHostStatusBar"),ExtHostShare:(0,o.$dw)("ExtHostShare"),ExtHostExtensionService:(0,o.$dw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,o.$dw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,o.$dw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,o.$dw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,o.$dw)("ExtHostSCM"),ExtHostSearch:(0,o.$dw)("ExtHostSearch"),ExtHostTask:(0,o.$dw)("ExtHostTask"),ExtHostWorkspace:(0,o.$dw)("ExtHostWorkspace"),ExtHostWindow:(0,o.$dw)("ExtHostWindow"),ExtHostWebviews:(0,o.$dw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,o.$dw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,o.$dw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,o.$dw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,o.$dw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,o.$dw)("ExtHostEditorTabs"),ExtHostProgress:(0,o.$dw)("ExtHostProgress"),ExtHostComments:(0,o.$dw)("ExtHostComments"),ExtHostSecretState:(0,o.$dw)("ExtHostSecretState"),ExtHostStorage:(0,o.$dw)("ExtHostStorage"),ExtHostUrls:(0,o.$dw)("ExtHostUrls"),ExtHostUriOpeners:(0,o.$dw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,o.$dw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,o.$dw)("ExtHostOutputService"),ExtHostLabelService:(0,o.$dw)("ExtHostLabelService"),ExtHostNotebook:(0,o.$dw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,o.$dw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,o.$dw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,o.$dw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,o.$dw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,o.$dw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,o.$dw)("ExtHostInteractive"),ExtHostInlineChat:(0,o.$dw)("ExtHostInlineChatShape"),ExtHostChat:(0,o.$dw)("ExtHostChat"),ExtHostChatAgents2:(0,o.$dw)("ExtHostChatAgents"),ExtHostChatVariables:(0,o.$dw)("ExtHostChatVariables"),ExtHostChatProvider:(0,o.$dw)("ExtHostChatProvider"),ExtHostSpeech:(0,o.$dw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,o.$dw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,o.$dw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,o.$dw)("ExtHostTheming"),ExtHostTunnelService:(0,o.$dw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,o.$dw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,o.$dw)("ExtHostAuthentication"),ExtHostTimeline:(0,o.$dw)("ExtHostTimeline"),ExtHostTesting:(0,o.$dw)("ExtHostTesting"),ExtHostTelemetry:(0,o.$dw)("ExtHostTelemetry"),ExtHostLocalization:(0,o.$dw)("ExtHostLocalization"),ExtHostIssueReporter:(0,o.$dw)("ExtHostIssueReporter")}}),define(Ee[91],Ce([1,0,5,12,6,20]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cjc=e.$Bjc=e.$Ajc=void 0,e.$Ajc=(0,o.$ii)("IExtHostApiDeprecationService");let L=class{constructor($,w){this.c=w,this.a=new Set,this.b=$.getProxy(I.$sM.MainThreadTelemetry)}report($,w,A){const P=this.d($,w);this.a.has(P)||(this.a.add(P),w.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:w.identifier.value,apiId:$}))}d($,w){return`${$}-${w.identifier.value}`}};e.$Bjc=L,e.$Bjc=L=Qe([He(0,M.$OO),He(1,R.$Oj)],L),e.$Cjc=Object.freeze(new class{report(p,$,w){}})}),define(Ee[308],Ce([1,0,39,3,6]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Njc=void 0;class M{constructor($,w){this.extension=$,this.provider=w,this.handle=M.a++}}M.a=0;class L{constructor($){this.b=new Map,this.c=new Map,this.d=$.getProxy(I.$sM.MainThreadChat)}registerChatProvider($,w,A){const P=new M($,A);return this.b.set(P.handle,P),this.d.$registerChatProvider(P.handle,w),(0,R.$Sc)(()=>{this.d.$unregisterChatProvider(P.handle),this.b.delete(P.handle)})}transferChatSession($,w){const A=o.Iterable.find(this.c.keys(),P=>this.c.get(P)===$)??0;typeof A=="number"&&this.d.$transferChatSession(A,w)}async $prepareChat($,w){const A=this.b.get($);if(!A)return;const P=await A.provider.prepareSession(w);if(!P)return;const b=L.a++;return this.c.set(b,P),{id:b}}$releaseSession($){this.c.delete($)}}e.$Njc=L,L.a=0}),define(Ee[309],Ce([1,0,6]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sjc=void 0;class R{constructor(M){const L=M.getProxy(o.$sM.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(p){return L.$writeText(p)}})}}e.$Sjc=R}),define(Ee[310],Ce([1,0,24,6,28,20]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Llc=void 0;let L=class{constructor(A,P){this.a=A.getProxy(R.$sM.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,P){const b=this,C=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){b.e(A,P,C,arguments)}})}e(A,P,b,C){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:$(C,this.b)}),this.c&&this.f(A,b,C)}};e.$Llc=L,e.$Llc=L=Qe([He(0,M.$OO),He(1,I.$5O)],L);const p=1e5;function $(w,A){const P=[];if(w.length)for(let b=0;b<w.length;b++){let C=w[b];if(typeof C>"u")C="undefined";else if(C instanceof Error){const y=C;y.stack?C=y.stack:C=y.toString()}P.push(C)}if(A){const b=new Error().stack;b&&P.push({__$stack:b.split(`
`).slice(3).join(`
`)})}try{const b=(0,o.$Un)(P);return b.length>p?"Output omitted for a large object that exceeds the limits":b}catch(b){return`Output omitted for an object that cannot be inspected ('${b.toString()}')`}}}),define(Ee[311],Ce([1,0,2,6,26]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nkc=void 0;class M{constructor(p){this.a=p.getProxy(R.$sM.MainThreadDialogs)}showOpenDialog(p,$){return $?.allowUIResources&&(0,I.$dG)(p,"showLocal"),this.a.$showOpenDialog($).then(w=>w?w.map(A=>o.URI.revive(A)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then($=>$?o.URI.revive($):void 0)}}e.$Nkc=M}),define(Ee[312],Ce([1,0,3,6]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9kc=void 0;class I{constructor(L){this.b=0,this.a=L.getProxy(R.$sM.MainThreadLabelService)}$registerResourceLabelFormatter(L){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,L),(0,o.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$9kc=I}),define(Ee[116],Ce([1,0,11,14,2,5,12,6,28,20]),function(re,e,o,R,I,M,L,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wkc=e.$vkc=void 0;let A=class{constructor(b,C,y){this.f=y,this.d=new Map,this.a=C.getProxy(p.$sM.MainThreadLocalization),this.b=b.environment.appLanguage,this.c=this.b===o.$a}getMessage(b,C){const{message:y,args:a,comment:m}=C;if(this.c)return(0,R.$We)(y,a??{});let c=y;m&&m.length>0&&(c+=`/${Array.isArray(m)?m.join(""):m}`);const i=this.d.get(b)?.contents[c];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${c}`),(0,R.$We)(i??y,a??{})}getBundle(b){return this.d.get(b)?.contents}getBundleUri(b){return this.d.get(b)?.uri}async initializeLocalizedMessages(b){if(this.c||!b.l10n&&!b.isBuiltin||this.d.has(b.identifier.value))return;let C;const y=await this.g(b);if(!y){this.f.error(`No bundle location found for extension ${b.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(y),m=JSON.parse(a);C=b.isBuiltin?m.contents?.bundle:m}catch(a){this.f.error(`Failed to load translations for ${b.identifier.value} from ${y}: ${a.message}`);return}C&&this.d.set(b.identifier.value,{contents:C,uri:y})}async g(b){if(b.isBuiltin){const C=await this.a.$fetchBuiltInBundleUri(b.identifier.value,this.b);return I.URI.revive(C)}return b.l10n?I.URI.joinPath(b.extensionLocation,b.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$vkc=A,e.$vkc=A=Qe([He(0,$.$5O),He(1,w.$OO),He(2,L.$Oj)],A),e.$wkc=(0,M.$ii)("IExtHostLocalizationService")}),define(Ee[150],Ce([1,0,12,6,28,20,2,57]),function(re,e,o,R,I,M,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=void 0;let $=class extends o.$Zj{constructor(P,b){super(b.logLevel,b.logsLocation,b.loggers.map(C=>(0,p.$Rh)(C))),this.r=P.getProxy(R.$sM.MainThreadLogger)}$setLogLevel(P,b){b?this.setLogLevel(L.URI.revive(b),P):this.setLogLevel(P)}setVisibility(P,b){super.setVisibility(P,b),this.r.$setVisibility(P,b)}s(P,b,C){return new w(this.r,P,b,C)}};e.$Klc=$,e.$Klc=$=Qe([He(0,M.$OO),He(1,I.$5O)],$);class w extends o.$Uj{constructor(P,b,C,y){super(y?.logLevel==="always"),this.r=P,this.s=b,this.m=!1,this.n=[],this.setLevel(C),this.r.$createLogger(b,y).then(()=>{this.u(this.n),this.m=!0})}g(P,b){const C=[[P,b]];this.m?this.u(C):this.n.push(...C)}u(P){this.r.$log(this.s,P)}flush(){this.r.$flush(this.s)}}}),define(Ee[117],Ce([1,0,6,5,3,20,21]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ykc=e.$xkc=void 0,e.$xkc=(0,R.$ii)("IExtHostManagedSockets");let p=class{constructor(P){this.b=0,this.c=null,this.d=new Map,this.a=P.getProxy(o.$sM.MainThreadManagedSockets)}setFactory(P,b){for(const C of this.d.values())C.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(P,b),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(P){if(!this.c||this.c.socketFactoryId!==P)throw new Error(`No socket factory with id ${P}`);const b=++this.b,C=await this.c.makeConnection(),y=new I.$Tc;return this.d.set(b,new w(b,C,y)),y.add((0,I.$Sc)(()=>this.d.delete(b))),y.add(C.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(b),y.dispose()})),y.add(C.onDidClose(a=>{this.a.$onDidManagedSocketClose(b,a?.stack??a?.message),y.dispose()})),y.add(C.onDidReceiveMessage(a=>this.a.$onDidManagedSocketHaveData(b,L.$ue.wrap(a)))),b}$remoteSocketWrite(P,b){this.d.get(P)?.actual.send(b.buffer)}$remoteSocketEnd(P){const b=this.d.get(P);b&&(b.actual.end(),b.dispose())}async $remoteSocketDrain(P){await this.d.get(P)?.actual.drain?.()}};e.$ykc=p,e.$ykc=p=Qe([He(0,M.$OO)],p);class ${constructor(P,b){this.socketFactoryId=P,this.makeConnection=b}}class w extends I.$Uc{constructor(P,b,C){super(),this.socketId=P,this.actual=b,this.B(C)}}}),define(Ee[313],Ce([1,0,6,12,26]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=void 0;function M(p){return p&&p.title}let L=class{constructor($,w){this.b=w,this.a=$.getProxy(o.$sM.MainThreadMessageService)}showMessage($,w,A,P,b){const C={source:{identifier:$.identifier,label:$.displayName||$.name}};let y;typeof P=="string"||M(P)?y=[P,...b]:(C.modal=P?.modal,C.useCustom=P?.useCustom,C.detail=P?.detail,y=b),C.useCustom&&(0,I.$dG)($,"resolvers");const a=[];let m=!1;for(let c=0;c<y.length;c++){const i=y[c];if(typeof i=="string")a.push({title:i,handle:c,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:r}=i;a.push({title:n,isCloseAffordance:!!r,handle:c}),r&&(m?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,i):m=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,i)}return this.a.$showMessage(w,A,C,a).then(c=>{if(typeof c=="number")return y[c]})}};e.$$kc=L,e.$$kc=L=Qe([He(1,R.$Oj)],L)}),define(Ee[314],Ce([1,0,3,18,2,26,6]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=void 0;class p{constructor(w){this.b=new Map,this.a=w.getProxy(L.$sM.MainThreadProfileContentHandlers)}registerProfileContentHandler(w,A,P){if((0,M.$dG)(w,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,P),this.a.$registerProfileContentHandler(A,P.name,P.description,w.identifier.value),(0,o.$Sc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(w,A,P,b){const C=this.b.get(w);if(!C)throw new Error(`Unknown handler with id: ${w}`);return C.saveProfile(A,P,b)}async $readProfile(w,A,P){const b=this.b.get(w);if(!b)throw new Error(`Unknown handler with id: ${w}`);return b.readProfile((0,R.$Vf)(A)?A:I.URI.revive(A),P)}}e.$hlc=p}),define(Ee[118],Ce([1,0,6,4,5]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=e.$skc=void 0;class M{constructor(p){this.b=new R.$7d,this.onDidChangePassword=this.b.event,this.a=p.getProxy(o.$sM.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,$){return this.a.$getPassword(p,$)}store(p,$,w){return this.a.$setPassword(p,$,w)}delete(p,$){return this.a.$deletePassword(p,$)}}e.$skc=M,e.$tkc=(0,I.$ii)("IExtHostSecretState")}),define(Ee[315],Ce([1,0,22,3,6]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$olc=void 0;class M{constructor(p){this.c=new Map,this.d=new Map,this.b=p.getProxy(I.$sM.MainThreadSpeech)}async $createSpeechToTextSession(p,$,w){const A=this.c.get(p);if(!A)return;const P=new R.$Tc,b=new o.$ee;this.d.set($,b);const C=P.add(A.provideSpeechToTextSession(b.token,w?{language:w}:void 0));P.add(C.onDidChange(y=>{b.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,y)})),P.add(b.token.onCancellationRequested(()=>P.dispose()))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}async $createKeywordRecognitionSession(p,$){const w=this.c.get(p);if(!w)return;const A=new R.$Tc,P=new o.$ee;this.d.set($,P);const b=A.add(w.provideKeywordRecognitionSession(P.token));A.add(b.onDidChange(C=>{P.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,C)})),A.add(P.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,$,w){const A=M.a++;return this.c.set(A,w),this.b.$registerProvider(A,$,{extension:p,displayName:p.value}),(0,R.$Sc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$olc=M,M.a=1}),define(Ee[119],Ce([1,0,6,4,5]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lkc=e.$kkc=void 0;class M{constructor(p,$){this.c=$,this.b=new R.$7d,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(o.$sM.MainThreadStorage)}registerExtensionStorageKeysToSync(p,$){this.a.$registerExtensionStorageKeysToSync(p,$)}async initializeExtensionStorage(p,$,w){const A=await this.a.$initializeExtensionStorage(p,$);let P;return A&&(P=this.d(p,$,A)),P||w}setValue(p,$,w){return this.a.$setValue(p,$,w)}$acceptValue(p,$,w){const A=this.d(p,$,w);A&&this.b.fire({shared:p,key:$,value:A})}d(p,$,w){try{return JSON.parse(w)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${p}): ${A}`)}}}e.$kkc=M,e.$lkc=(0,I.$ii)("IExtHostStorage")}),define(Ee[316],Ce([1,0,3,15,2,6]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Clc=void 0;class L{constructor($){this.c=new Map,this.b=$.getProxy(M.$sM.MainThreadUriOpeners)}registerExternalUriOpener($,w,A,P){if(this.c.has(w))throw new Error(`Opener with id '${w}' already registered`);const b=P.schemes.find(C=>!L.a.has(C));if(b)throw new Error(`Scheme '${b}' is not supported. Only http and https are currently supported.`);return this.c.set(w,A),this.b.$registerUriOpener(w,P.schemes,$,P.label),(0,o.$Sc)(()=>{this.c.delete(w),this.b.$unregisterUriOpener(w)})}async $canOpenUri($,w,A){const P=this.c.get($);if(!P)throw new Error(`Unknown opener with id: ${$}`);const b=I.URI.revive(w);return P.canOpenExternalUri(b,A)}async $openUri($,w,A){const P=this.c.get($);if(!P)throw new Error(`Unknown opener id: '${$}'`);return P.openExternalUri(I.URI.revive(w.resolvedUri),{sourceUri:I.URI.revive(w.sourceUri)},A)}}e.$Clc=L,L.a=new Set([R.Schemas.http,R.Schemas.https])}),define(Ee[317],Ce([1,0,6,2,3,13,25]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=void 0;class p{constructor(w){this.c=new L.$Fm,this.d=new Map,this.b=w.getProxy(o.$sM.MainThreadUrls)}registerUriHandler(w,A){const P=w.identifier;if(this.c.has(P))throw new Error(`Protocol handler already registered for extension ${P}`);const b=p.a++;return this.c.add(P),this.d.set(b,A),this.b.$registerUriHandler(b,P,w.displayName||w.name),(0,I.$Sc)(()=>{this.c.delete(P),this.d.delete(b),this.b.$unregisterUriHandler(b)})}$handleExternalUri(w,A){const P=this.d.get(w);if(!P)return Promise.resolve(void 0);try{P.handleUri(R.URI.revive(A))}catch(b){(0,M.$1)(b)}return Promise.resolve(void 0)}async createAppUri(w){return R.URI.revive(await this.b.$createAppUri(w))}}e.$Dlc=p,p.a=0});var it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o},qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Ee[92],Ce([1,0,4,3,15,24,2,246,284,114,6]),function(re,e,o,R,I,M,L,p,$,w,A){"use strict";var P,b,C,y,a,m,c,i,n,r,s,t,f;Object.defineProperty(e,"__esModule",{value:!0}),e.$0jc=e.$8jc=void 0,e.$9jc=u,e.$$jc=g,e.$_jc=E;class d{constructor(D,F,W,B,j,N,T){P.set(this,void 0),b.set(this,void 0),C.set(this,void 0),y.set(this,void 0),a.set(this,void 0),m.set(this,void 0),c.set(this,""),i.set(this,void 0),n.set(this,!1),r.set(this,!1),s.set(this,void 0),t.set(this,void 0),this._onMessageEmitter=new o.$7d,this.onDidReceiveMessage=this._onMessageEmitter.event,f.set(this,new o.$7d),this._onDidDispose=qe(this,f,"f").event,it(this,P,D,"f"),it(this,b,F,"f"),it(this,i,W,"f"),it(this,y,B,"f"),it(this,a,j,"f"),it(this,m,N,"f"),it(this,s,u(N),"f"),it(this,t,h(N),"f"),it(this,C,T,"f")}dispose(){it(this,n,!0,"f"),qe(this,f,"f").fire(),qe(this,f,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(D){return it(this,r,!0,"f"),(0,w.$Bzb)(D,qe(this,y,"f"))}get cspSource(){const D=qe(this,m,"f").extensionLocation;if(D.scheme===I.Schemas.https||D.scheme===I.Schemas.http){let F=D.toString();return F.endsWith("/")||(F+="/"),F+" "+w.$Azb}return w.$Azb}get html(){return this.a(),qe(this,c,"f")}set html(D){this.a(),qe(this,c,"f")!==D&&(it(this,c,D,"f"),qe(this,t,"f")&&!qe(this,r,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(D)&&(it(this,r,!0,"f"),qe(this,C,"f").report("Webview vscode-resource: uris",qe(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),qe(this,b,"f").$setHtml(qe(this,P,"f"),this.b(D)))}get options(){return this.a(),qe(this,i,"f")}set options(D){this.a(),M.$Tn(qe(this,i,"f"),D)||qe(this,b,"f").$setOptions(qe(this,P,"f"),E(qe(this,m,"f"),qe(this,a,"f"),D)),it(this,i,D,"f")}async postMessage(D){if(qe(this,n,"f"))return!1;const F=(0,$.$Pnb)(D,{serializeBuffersForPostMessage:qe(this,s,"f")});return qe(this,b,"f").$postMessage(qe(this,P,"f"),F.message,...F.buffers)}a(){if(qe(this,n,"f"))throw new Error("Webview is disposed")}b(D){if(!qe(this,t,"f"))return D;const F=qe(this,m,"f").extensionLocation?.scheme===I.Schemas.vscodeRemote,W=qe(this,m,"f").extensionLocation.scheme===I.Schemas.vscodeRemote?qe(this,m,"f").extensionLocation.authority:void 0;return D.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(B,j,N,T,O,z)=>{const Q=L.URI.from({scheme:T||"file",path:decodeURIComponent(O)}),Z=(0,w.$Bzb)(Q,{isRemote:F,authority:W}).toString();return`${j}${Z}${z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(B,j,N,T,O,z)=>{const Q=L.URI.from({scheme:T||"file",path:decodeURIComponent(O)}),Z=(0,w.$Bzb)(Q,{isRemote:F,authority:W}).toString();return`${j}${Z}${z}`})}}e.$8jc=d,P=new WeakMap,b=new WeakMap,C=new WeakMap,y=new WeakMap,a=new WeakMap,m=new WeakMap,c=new WeakMap,i=new WeakMap,n=new WeakMap,r=new WeakMap,s=new WeakMap,t=new WeakMap,f=new WeakMap;function u(k){try{const D=(0,p.$vp)((0,p.$up)(k.engines.vscode));return!!D&&D.majorBase>=1&&D.minorBase>=57}catch{return!1}}function h(k){try{const D=(0,p.$vp)((0,p.$up)(k.engines.vscode));return D?D.majorBase<1||D.majorBase===1&&D.minorBase<60:!1}catch{return!1}}class l extends R.$Uc{constructor(D,F,W,B,j){super(),this.c=F,this.f=W,this.g=B,this.h=j,this.b=new Map,this.a=D.getProxy(A.$sM.MainThreadWebviews)}dispose(){super.dispose();for(const D of this.b.values())D.dispose();this.b.clear()}$onMessage(D,F,W){const B=this.j(D);if(B){const{message:j}=(0,$.$Qnb)(F,W.value);B._onMessageEmitter.fire(j)}}$onMissingCsp(D,F){this.g.warn(`${F} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(D,F,W){const B=new d(D,this.a,v(F),this.c,this.f,W,this.h);this.b.set(D,B);const j=B._onDidDispose(()=>{j.dispose(),this.deleteWebview(D)});return B}deleteWebview(D){this.b.delete(D)}j(D){return this.b.get(D)}}e.$0jc=l;function g(k){return{id:k.identifier,location:k.extensionLocation}}function E(k,D,F){return{enableCommandUris:F.enableCommandUris,enableScripts:F.enableScripts,enableForms:F.enableForms,portMapping:F.portMapping,localResourceRoots:F.localResourceRoots||S(k,D)}}function v(k){return{enableCommandUris:k.enableCommandUris,enableScripts:k.enableScripts,enableForms:k.enableForms,portMapping:k.portMapping,localResourceRoots:k.localResourceRoots?.map(D=>L.URI.from(D))}}function S(k,D){return[...(D?.getWorkspaceFolders()||[]).map(F=>F.uri),k.extensionLocation]}}),define(Ee[151],Ce([1,0,4,6,2,15,14,5,20,26]),function(re,e,o,R,I,M,L,p,$,w){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=e.$Flc=void 0;let P=A=class{getState(C){const y=this.d;return{get focused(){return y.focused},get active(){return(0,w.$dG)(C,"windowActivity"),y.active}}}constructor(C){this.c=new o.$7d,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=C.getProxy(R.$sM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:y,isActive:a})=>{this.onDidChangeWindowProperty("focused",y),this.onDidChangeWindowProperty("active",a)})}$onDidChangeWindowFocus(C){this.onDidChangeWindowProperty("focused",C)}$onDidChangeWindowActive(C){this.onDidChangeWindowProperty("active",C)}onDidChangeWindowProperty(C,y){y!==this.d[C]&&(this.d={...this.d,[C]:y},this.c.fire(this.d))}openUri(C,y){let a;if(typeof C=="string"){a=C;try{C=I.URI.parse(C)}catch{return Promise.reject(`Invalid uri - '${C}'`)}}return(0,L.$Ue)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this.b.$openUri(C,a,y)}async asExternalUri(C,y){if((0,L.$Ue)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");const a=await this.b.$asExternalUri(C,y);return I.URI.from(a)}};e.$Flc=P,P.a={focused:!0,active:!0},e.$Flc=P=A=Qe([He(0,$.$OO)],P),e.$Glc=(0,p.$ii)("IExtHostWindow")}),define(Ee[318],Ce([1,0,310,28,20]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kmc=void 0;const M=1024*1024;let L=class extends o.$Llc{constructor($,w){super($,w),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,w,A){const P=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),w.apply(console,A),P.write(`
END_NATIVE_LOG
`),this.g=!1}j($,w){const A=process[$],P=A.write;let b="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(C,y,a)=>{if(!this.g){b+=C.toString(y);const m=b.length>M?b.length:b.lastIndexOf(`
`);m!==-1&&(console[w](b.slice(0,m)),b=b.slice(m+1))}P.call(A,C,y,a)}})}};e.$kmc=L,e.$kmc=L=Qe([He(0,I.$OO),He(1,R.$5O)],L)}),define(Ee[319],Ce([1,0,150,15,261,30]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=void 0;class L extends o.$Klc{s($,w,A){return $.scheme===R.Schemas.file?new I.$3P(A?.name||(0,M.$Eg)(),$.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,w):super.s($,w,A)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$wmc=L}),define(Ee[320],Ce([1,0,8,21,22,13,4,3,131,307,68]),function(re,e,o,R,I,M,L,p,$,w,A){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$z$b=e.ResponsiveState=e.RequestInitiator=void 0,e.$x$b=m,e.$y$b=c;function b(k,D){try{return JSON.stringify(k,D)}catch{return"null"}}const C="$$ref$$",y={[C]:-1};class a{constructor(D,F){this.jsonString=D,this.referencedBuffers=F}}function m(k,D=null,F=!1){const W=[];return{jsonString:(F?b:JSON.stringify)(k,(j,N)=>{if(typeof N>"u")return y;if(typeof N=="object"){if(N instanceof R.$ue){const T=W.push(N)-1;return{[C]:T}}if(D)return D(j,N)}return N}),referencedBuffers:W}}function c(k,D,F){return JSON.parse(k,(W,B)=>{if(B){const j=B[C];if(typeof j=="number")return D[j];if(F&&B.$mid===1)return F.transformIncoming(B)}return B})}function i(k,D){return JSON.stringify(k,D)}function n(k){return k?(D,F)=>F&&F.$mid===1?k.transformOutgoing(F):F:null}var r;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var s;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(s||(e.ResponsiveState=s={}));const t=()=>{},f=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class u extends p.$Uc{constructor(D,F=null,W=null){super(),this[P]=!0,this.b=this.B(new L.$7d),this.onDidChangeResponsiveState=this.b.event,this.c=D,this.f=F,this.g=W,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let B=0,j=A.$cw.count;B<j;B++)this.m[B]=null,this.s[B]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new o.$uh(()=>this.H(),1e3)),this.c.onMessage(B=>this.L(B))}dispose(){this.j=!0,Object.keys(this.w).forEach(D=>{const F=this.w[D];delete this.w[D],F.resolveErr(M.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(D){this.z===0&&(this.C=Date.now()+u.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(D){this.C=Date.now()+u.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(D){this.y!==D&&(this.y=D,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(D){return this.g?(0,$.$on)(D,this.g):D}getProxy(D){const{nid:F,sid:W}=D;return this.s[F]||(this.s[F]=this.J(F,W)),this.s[F]}J(D,F){const W={get:(B,j)=>(typeof j=="string"&&!B[j]&&j.charCodeAt(0)===36&&(B[j]=(...N)=>this.U(D,j,N)),j===d?F:B[j])};return new Proxy(Object.create(null),W)}set(D,F){return this.m[D.nid]=F,F}assertRegistered(D){for(let F=0,W=D.length;F<W;F++){const B=D[F];if(!this.m[B.nid])throw new Error(`Missing proxy instance ${B.sid}`)}}L(D){if(this.j)return;const F=D.byteLength,W=l.read(D,0),B=W.readUInt8(),j=W.readUInt32();switch(B){case 1:case 2:{let{rpcId:N,method:T,args:O}=E.deserializeRequestJSONArgs(W);this.g&&(O=(0,$.$on)(O,this.g)),this.M(F,j,N,T,O,B===2);break}case 3:case 4:{let{rpcId:N,method:T,args:O}=E.deserializeRequestMixedArgs(W);this.g&&(O=(0,$.$on)(O,this.g)),this.M(F,j,N,T,O,B===4);break}case 5:{this.f?.logIncoming(F,j,0,"ack"),this.G(j);break}case 6:{this.N(F,j);break}case 7:{this.O(F,j,void 0);break}case 9:{let N=E.deserializeReplyOKJSON(W);this.g&&(N=(0,$.$on)(N,this.g)),this.O(F,j,N);break}case 10:{const N=E.deserializeReplyOKJSONWithBuffers(W,this.g);this.O(F,j,N);break}case 8:{const N=E.deserializeReplyOKVSBuffer(W);this.O(F,j,N);break}case 11:{let N=E.deserializeReplyErrError(W);this.g&&(N=(0,$.$on)(N,this.g)),this.P(F,j,N);break}case 12:{this.P(F,j,void 0);break}default:console.error("received unexpected message"),console.error(D)}}M(D,F,W,B,j,N){this.f?.logIncoming(D,F,1,`receiveRequest ${(0,A.$ew)(W)}.${B}(`,j);const T=String(F);let O,z;if(N){const Z=new I.$ee;j.push(Z.token),O=this.Q(W,B,j),z=()=>Z.cancel()}else O=this.Q(W,B,j),z=t;this.u[T]=z;const Q=E.serializeAcknowledged(F);this.f?.logOutgoing(Q.byteLength,F,1,"ack"),this.c.send(Q),O.then(Z=>{delete this.u[T];const J=E.serializeReplyOK(F,Z,this.h);this.f?.logOutgoing(J.byteLength,F,1,"reply:",Z),this.c.send(J)},Z=>{delete this.u[T];const J=E.serializeReplyErr(F,Z);this.f?.logOutgoing(J.byteLength,F,1,"replyErr:",Z),this.c.send(J)})}N(D,F){this.f?.logIncoming(D,F,1,"receiveCancel");const W=String(F);this.u[W]?.()}O(D,F,W){this.f?.logIncoming(D,F,0,"receiveReply:",W);const B=String(F);if(!this.w.hasOwnProperty(B))return;const j=this.w[B];delete this.w[B],j.resolveOk(W)}P(D,F,W){this.f?.logIncoming(D,F,0,"receiveReplyErr:",W);const B=String(F);if(!this.w.hasOwnProperty(B))return;const j=this.w[B];delete this.w[B];let N;W&&(W.$isError?(N=new Error,N.name=W.name,N.message=W.message,N.stack=W.stack):N=W),j.resolveErr(N)}Q(D,F,W){try{return Promise.resolve(this.S(D,F,W))}catch(B){return Promise.reject(B)}}S(D,F,W){const B=this.m[D];if(!B)throw new Error("Unknown actor "+(0,A.$ew)(D));const j=B[F];if(typeof j!="function")throw new Error("Unknown method "+F+" on actor "+(0,A.$ew)(D));return j.apply(B,W)}U(D,F,W){if(this.j)return new w.$w$b;let B=null;if(W.length>0&&I.CancellationToken.isCancellationToken(W[W.length-1])&&(B=W.pop()),B&&B.isCancellationRequested)return Promise.reject(M.$6());const j=E.serializeRequestArguments(W,this.h),N=++this.t,T=String(N),O=new w.$v$b,z=new p.$Tc;B&&z.add(B.onCancellationRequested(()=>{const Z=E.serializeCancel(N);this.f?.logOutgoing(Z.byteLength,N,0,"cancel"),this.c.send(E.serializeCancel(N))})),this.w[T]=new h(O,z),this.F(N);const Q=E.serializeRequest(N,D,F,j,!!B);return this.f?.logOutgoing(Q.byteLength,N,0,`request: ${(0,A.$ew)(D)}.${F}(`,W),this.c.send(Q),O}}e.$z$b=u,P=f,u.a=3*1e3;class h{constructor(D,F){this.a=D,this.b=F}resolveOk(D){this.a.resolveOk(D),this.b.dispose()}resolveErr(D){this.a.resolveErr(D),this.b.dispose()}}class l{static alloc(D,F,W){const B=new l(R.$ue.alloc(W+1+4),0);return B.writeUInt8(D),B.writeUInt32(F),B}static read(D,F){return new l(D,F)}get buffer(){return this.a}constructor(D,F){this.a=D,this.b=F}static sizeUInt8(){return 1}writeUInt8(D){this.a.writeUInt8(D,this.b),this.b+=1}readUInt8(){const D=this.a.readUInt8(this.b);return this.b+=1,D}writeUInt32(D){this.a.writeUInt32BE(D,this.b),this.b+=4}readUInt32(){const D=this.a.readUInt32BE(this.b);return this.b+=4,D}static sizeShortString(D){return 1+D.byteLength}writeShortString(D){this.a.writeUInt8(D.byteLength,this.b),this.b+=1,this.a.set(D,this.b),this.b+=D.byteLength}readShortString(){const D=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+D).toString();return this.b+=D,W}static sizeLongString(D){return 4+D.byteLength}writeLongString(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}readLongString(){const D=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+D).toString();return this.b+=D,W}writeBuffer(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}static sizeVSBuffer(D){return 4+D.byteLength}writeVSBuffer(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}readVSBuffer(){const D=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+D);return this.b+=D,F}static sizeMixedArray(D){let F=0;F+=1;for(let W=0,B=D.length;W<B;W++){const j=D[W];switch(F+=1,j.type){case 1:F+=this.sizeLongString(j.value);break;case 2:F+=this.sizeVSBuffer(j.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString(j.value);for(let N=0;N<j.buffers.length;++N)F+=this.sizeVSBuffer(j.buffers[N]);break;case 4:break}}return F}writeMixedArray(D){this.a.writeUInt8(D.length,this.b),this.b+=1;for(let F=0,W=D.length;F<W;F++){const B=D[F];switch(B.type){case 1:this.writeUInt8(1),this.writeLongString(B.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(B.value);break;case 3:this.writeUInt8(3),this.writeUInt32(B.buffers.length),this.writeLongString(B.value);for(let j=0;j<B.buffers.length;++j)this.writeBuffer(B.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const D=this.a.readUInt8(this.b);this.b+=1;const F=new Array(D);for(let W=0;W<D;W++)switch(this.readUInt8()){case 1:F[W]=this.readLongString();break;case 2:F[W]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),N=this.readLongString(),T=[];for(let O=0;O<j;++O)T.push(this.readVSBuffer());F[W]=new A.$fw(c(N,T,null));break}case 4:F[W]=void 0;break}return F}}l.sizeUInt32=4;var g;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(g||(g={}));class E{static a(D){for(let F=0,W=D.length;F<W;F++)if(D[F]instanceof R.$ue||D[F]instanceof A.$fw||typeof D[F]>"u")return!0;return!1}static serializeRequestArguments(D,F){if(this.a(D)){const W=[];for(let B=0,j=D.length;B<j;B++){const N=D[B];if(N instanceof R.$ue)W[B]={type:2,value:N};else if(typeof N>"u")W[B]={type:4};else if(N instanceof A.$fw){const{jsonString:T,referencedBuffers:O}=m(N.value,F);W[B]={type:3,value:R.$ue.fromString(T),buffers:O}}else W[B]={type:1,value:R.$ue.fromString(i(N,F))}}return{type:1,args:W}}return{type:0,args:i(D,F)}}static serializeRequest(D,F,W,B,j){switch(B.type){case 0:return this.b(D,F,W,B.args,j);case 1:return this.c(D,F,W,B.args,j)}}static b(D,F,W,B,j){const N=R.$ue.fromString(W),T=R.$ue.fromString(B);let O=0;O+=l.sizeUInt8(),O+=l.sizeShortString(N),O+=l.sizeLongString(T);const z=l.alloc(j?2:1,D,O);return z.writeUInt8(F),z.writeShortString(N),z.writeLongString(T),z.buffer}static deserializeRequestJSONArgs(D){const F=D.readUInt8(),W=D.readShortString(),B=D.readLongString();return{rpcId:F,method:W,args:JSON.parse(B)}}static c(D,F,W,B,j){const N=R.$ue.fromString(W);let T=0;T+=l.sizeUInt8(),T+=l.sizeShortString(N),T+=l.sizeMixedArray(B);const O=l.alloc(j?4:3,D,T);return O.writeUInt8(F),O.writeShortString(N),O.writeMixedArray(B),O.buffer}static deserializeRequestMixedArgs(D){const F=D.readUInt8(),W=D.readShortString(),B=D.readMixedArray(),j=new Array(B.length);for(let N=0,T=B.length;N<T;N++){const O=B[N];typeof O=="string"?j[N]=JSON.parse(O):j[N]=O}return{rpcId:F,method:W,args:j}}static serializeAcknowledged(D){return l.alloc(5,D,0).buffer}static serializeCancel(D){return l.alloc(6,D,0).buffer}static serializeReplyOK(D,F,W){if(typeof F>"u")return this.d(D);if(F instanceof R.$ue)return this.e(D,F);if(F instanceof A.$fw){const{jsonString:B,referencedBuffers:j}=m(F.value,W,!0);return this.g(D,B,j)}else return this.f(D,b(F,W))}static d(D){return l.alloc(7,D,0).buffer}static e(D,F){let W=0;W+=l.sizeVSBuffer(F);const B=l.alloc(8,D,W);return B.writeVSBuffer(F),B.buffer}static deserializeReplyOKVSBuffer(D){return D.readVSBuffer()}static f(D,F){const W=R.$ue.fromString(F);let B=0;B+=l.sizeLongString(W);const j=l.alloc(9,D,B);return j.writeLongString(W),j.buffer}static g(D,F,W){const B=R.$ue.fromString(F);let j=0;j+=l.sizeUInt32,j+=l.sizeLongString(B);for(const T of W)j+=l.sizeVSBuffer(T);const N=l.alloc(10,D,j);N.writeUInt32(W.length),N.writeLongString(B);for(const T of W)N.writeBuffer(T);return N.buffer}static deserializeReplyOKJSON(D){const F=D.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(D,F){const W=D.readUInt32(),B=D.readLongString(),j=[];for(let N=0;N<W;++N)j.push(D.readVSBuffer());return new A.$fw(c(B,j,F))}static serializeReplyErr(D,F){const W=F?b(M.$3(F),null):void 0;if(typeof W!="string")return this.h(D);const B=R.$ue.fromString(W);let j=0;j+=l.sizeLongString(B);const N=l.alloc(11,D,j);return N.writeLongString(B),N.buffer}static deserializeReplyErrError(D){const F=D.readLongString();return JSON.parse(F)}static h(D){return l.alloc(12,D,0).buffer}}var v;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var S;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(S||(S={}))}),define(Ee[321],Ce([1,0,21,27,15,84,5]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.$7J=void 0,e.$8J=A,e.$9J=P,e.$7J=(0,L.$ii)("notebookDocumentService");const p=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${p.join("")}]+`),w=7;function A(C){if(C.scheme!==I.Schemas.vscodeNotebookCell)return;const y=C.fragment.indexOf("s");if(y<0)return;const a=parseInt(C.fragment.substring(0,y).replace($,""),w),m=(0,o.$Ne)(C.fragment.substring(y+1)).toString();if(!isNaN(a))return{handle:a,notebook:C.with({scheme:m,fragment:null})}}function P(C,y){const a=y.toString(w),c=`${a.length<p.length?p[a.length-1]:"z"}${a}s${(0,o.$Oe)(o.$ue.fromString(C.scheme),!0,!0)}`;return C.with({scheme:I.Schemas.vscodeNotebookCell,fragment:c})}class b{constructor(){this.a=new R.$Bc}getNotebook(y){if(y.scheme===I.Schemas.vscodeNotebookCell){const a=A(y);if(a){const m=this.a.get(a.notebook);if(m)return m}}return this.a.get(y)}addNotebookDocument(y){this.a.set(y.uri,y)}removeNotebookDocument(y){this.a.delete(y.uri)}}e.$0J=b,(0,M.$hs)(e.$7J,b,1)}),define(Ee[120],Ce([1,0,21,35,39,98,15,17,11,42,321]),function(re,e,o,R,I,M,L,p,$,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rK=e.$oK=e.CellStatusbarAlignment=e.$nK=e.NotebookEditorPriority=e.$kK=e.$jK=e.$hK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$gK=e.$fK=e.$eK=e.$dK=e.CellKind=e.$cK=e.$bK=e.$aK=void 0,e.$iK=f,e.$lK=u,e.$mK=h,e.$pK=E,e.$qK=S,e.$aK="workbench.editor.notebook",e.$bK="workbench.editor.notebookTextDiffEditor",e.$cK="workbench.editor.interactive";var P;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(P||(e.CellKind=P={})),e.$dK=["application/json","application/javascript","text/html","image/svg+xml",M.$As.latex,M.$As.markdown,"image/png","image/jpeg",M.$As.text],e.$eK=[M.$As.latex,M.$As.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$As.text],e.$fK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$gK="_notAvailable";var b;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(b||(e.NotebookRunState=b={}));var C;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(C||(e.NotebookCellExecutionState=C={}));var y;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(y||(e.NotebookExecutionState=y={}));var a;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var m;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var c;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(c||(e.NotebookCellsChangeType=c={}));var i;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var r;(function(O){O.scheme=L.Schemas.vscodeNotebookCell;function z(te,pe){return(0,A.$9J)(te,pe)}O.generate=z;function Q(te){return(0,A.$8J)(te)}O.parse=Q;function Z(te,pe){return te.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${pe??""},${te.scheme!==L.Schemas.file?te.scheme:""}`})}O.generateCellOutputUri=Z;function J(te){if(te.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const pe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(te.fragment);if(!pe)return;const ye=pe[1]&&pe[1]!==""?pe[1]:void 0,_=pe[2];return{outputId:ye,notebook:te.with({scheme:_||L.Schemas.file,fragment:null})}}O.parseCellOutputUri=J;function x(te,pe,ye){return O.generate(te,pe).with({scheme:ye})}O.generateCellPropertyUri=x;function ce(te,pe){if(te.scheme===pe)return O.parse(te.with({scheme:O.scheme}))}O.parseCellPropertyUri=ce})(r||(e.CellUri=r={}));const s=O=>$.$c?O.replace(/\//g,"\\"):O;class t{constructor(z=[],Q=e.$dK){this.e=Q,this.d=[...new Set(z)].map(Z=>({pattern:Z,matches:R.$ck(s(Z))}))}sort(z){const Q=new Map(I.Iterable.map(z,J=>[J,s(J)]));let Z=[];for(const{matches:J}of this.d)for(const[x,ce]of Q)if(J(ce)){Z.push(x),Q.delete(x);break}return Q.size&&(Z=Z.concat([...Q.keys()].sort((J,x)=>this.e.indexOf(J)-this.e.indexOf(x)))),Z}prioritize(z,Q){const Z=this.f(z);if(Z===-1){this.d.unshift({pattern:z,matches:R.$ck(s(z))});return}const J=new Set(Q.map(ce=>this.f(ce,Z)));J.delete(-1);const x=Array.from(J).sort();this.d.splice(Z+1,0,...x.map(ce=>this.d[ce]));for(let ce=x.length-1;ce>=0;ce--)this.d.splice(x[ce],1)}toArray(){return this.d.map(z=>z.pattern)}f(z,Q=this.d.length){const Z=s(z);for(let J=0;J<Q;J++)if(this.d[J].matches(Z))return J;return-1}}e.$hK=t;function f(O,z,Q,Z=(J,x)=>J===x){const J=[];function x(pe,ye,_){if(ye===0&&_.length===0)return;const U=J[J.length-1];U&&U.start+U.deleteCount===pe?(U.deleteCount+=ye,U.toInsert.push(..._)):J.push({start:pe,deleteCount:ye,toInsert:_})}let ce=0,te=0;for(;;){if(ce===O.length){x(ce,0,z.slice(te));break}if(te===z.length){x(ce,O.length-ce,[]);break}const pe=O[ce],ye=z[te];if(Z(pe,ye)){ce+=1,te+=1;continue}Q(ye)?(x(ce,1,[]),ce+=1):(x(ce,0,[ye]),te+=1)}return J}e.$jK=new w.$zj("notebookEditorCursorAtBoundary","none"),e.$kK=new w.$zj("notebookEditorCursorAtLineBoundary","none");var d;(function(O){O.default="default",O.option="option"})(d||(e.NotebookEditorPriority=d={}));function u(O){const z=O;return!!((typeof z.include=="string"||R.$dk(z.include))&&(typeof z.exclude=="string"||R.$dk(z.exclude)))}function h(O,z,Q){if(Array.isArray(O.viewType)&&O.viewType.indexOf(z)>=0||O.viewType===z)return!0;if(O.filenamePattern){const Z=u(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,J=u(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(R.$bk(Z,(0,p.$oc)(Q.fsPath).toLowerCase()))return!(J&&R.$bk(J,(0,p.$oc)(Q.fsPath).toLowerCase()))}return!1}e.$nK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var l;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(l||(e.CellStatusbarAlignment=l={}));class g{static create(z){return`${g.d}${z}`}static parse(z){if(z.startsWith(g.d))return z.substring(g.d.length)}}e.$oK=g,g.d="notebook/";function E(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}const v=new TextDecoder;function S(O){const z=[];let Q=!1;for(const ce of O)(z.length===0||Q)&&(z.push(ce),Q=!0);let Z=F(z);const J=o.$ue.concat(z.map(ce=>o.$ue.wrap(ce))),x=T(J);return Z=Z||x.byteLength!==J.byteLength,{data:x,didCompression:Z}}e.$rK="\x1B[A";const k=e.$rK.split("").map(O=>O.charCodeAt(0)),D=10;function F(O){let z=!1;return O.forEach((Q,Z)=>{if(Z===0||Q.length<e.$rK.length)return;const J=O[Z-1],x=Q.subarray(0,e.$rK.length);if(x[0]===k[0]&&x[1]===k[1]&&x[2]===k[2]){const ce=J.lastIndexOf(D);if(ce===-1)return;z=!0,O[Z-1]=J.subarray(0,ce),O[Z]=Q.subarray(e.$rK.length)}}),z}function W(O){let z=O;do O=z,z=O.replace(/[^\n]\x08/gm,"");while(z.length<O.length);return O}function B(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const z=O.match(/^(.*)\r+/m)[1];let Q=O.match(/\r+(.*)$/m)[1];Q=Q+z.slice(Q.length,z.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Q)}return O}const j=8,N=13;function T(O){return!O.buffer.includes(j)&&!O.buffer.includes(N)?O:o.$ue.fromString(B(W(v.decode(O.buffer))))}});var it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o},qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Ee[7],Ce([1,0,19,13,79,27,98,14,18,2,30,25,32,65,120]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y){"use strict";var a,m,c,i,n,r,s,t,f,d,u,h,l,g,E,v,S,k,D,F,W,B,j,N,T;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$CO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$BO=e.$AO=e.$zO=e.$yO=e.ChatLocation=e.$xO=e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$pO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$cO=e.$bO=e.$aO=e.$_N=e.$0N=e.$9N=e.$8N=e.$7N=e.TestRunProfileKind=e.TestResultState=e.$6N=e.$5N=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$4N=e.NotebookVariablesRequestKind=e.$3N=e.$2N=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$1N=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.ColorThemeKind=e.$UN=e.$TN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$SN=e.$RN=e.DebugConsoleMode=e.$QN=e.$PN=e.$ON=e.$NN=e.$MN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$LN=e.$KN=e.FileChangeType=e.$JN=e.NewSymbolNameTag=e.$IN=e.$HN=e.$GN=e.$FN=e.InlineCompletionTriggerKind=e.$EN=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.$sN=e.ConfigurationTarget=e.$rN=e.$qN=e.$pN=e.$oN=e.DocumentPasteTriggerKind=e.$nN=e.$mN=e.$lN=e.$kN=e.$jN=e.$iN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$hN=e.ViewBadge=e.ProgressLocation=e.$gN=e.$fN=e.TaskScope=e.ShellQuoting=e.$eN=e.$dN=e.$cN=e.TaskPanelKind=e.TaskRevealKind=e.$bN=e.TerminalLocation=e.$aN=e.$_M=e.$$M=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$0M=e.$9M=e.$8M=e.$7M=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$5M=e.$4M=e.$3M=e.$2M=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$1M=e.$ZM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.LanguageStatusSeverity=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.CodeActionTriggerKind=e.$NM=e.$MM=e.SymbolTag=e.SymbolKind=e.$LM=e.$KM=e.DocumentHighlightKind=e.$JM=e.$IM=e.$HM=e.$GM=e.DiagnosticSeverity=e.DiagnosticTag=e.$FM=e.$EM=e.FileEditType=e.$DM=e.$CM=e.$BM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$6M=_t,e.$tN=an,e.$$N=Di;function O(K){return Object.assign(K,{apply:function(...$e){if($e.length===0)return Reflect.construct(K,[]);{const je=$e.length===1?[]:$e[1];return Reflect.construct(K,je,$e[0].constructor)}},call:function(...$e){if($e.length===0)return Reflect.construct(K,[]);{const[je,...xe]=$e;return Reflect.construct(K,xe,je.constructor)}}})}var z;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(z||(e.TerminalOutputAnchor=z={}));var Q;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(Q||(e.TerminalQuickFixType=Q={}));let Z=f=class{static from(...q){let $e=q;return new f(function(){if($e){for(const je of $e)je&&typeof je.dispose=="function"&&je.dispose();$e=void 0}})}constructor(q){a.set(this,void 0),it(this,a,q,"f")}dispose(){typeof qe(this,a,"f")=="function"&&(qe(this,a,"f").call(this),it(this,a,void 0,"f"))}};e.$uM=Z,a=new WeakMap,e.$uM=Z=f=Qe([O],Z);let J=d=class{static Min(...q){if(q.length===0)throw new TypeError;let $e=q[0];for(let je=1;je<q.length;je++){const xe=q[je];xe.isBefore($e)&&($e=xe)}return $e}static Max(...q){if(q.length===0)throw new TypeError;let $e=q[0];for(let je=1;je<q.length;je++){const xe=q[je];xe.isAfter($e)&&($e=xe)}return $e}static isPosition(q){if(!q)return!1;if(q instanceof d)return!0;const{line:$e,character:je}=q;return typeof $e=="number"&&typeof je=="number"}static of(q){if(q instanceof d)return q;if(this.isPosition(q))return new d(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,$e){if(q<0)throw(0,R.$7)("line must be non-negative");if($e<0)throw(0,R.$7)("character must be non-negative");this.c=q,this.e=$e}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,$e=0){if(q===null||$e===null)throw(0,R.$7)();let je;return typeof q>"u"?je=0:typeof q=="number"?je=q:(je=typeof q.lineDelta=="number"?q.lineDelta:0,$e=typeof q.characterDelta=="number"?q.characterDelta:0),je===0&&$e===0?this:new d(this.line+je,this.character+$e)}with(q,$e=this.character){if(q===null||$e===null)throw(0,R.$7)();let je;return typeof q>"u"?je=this.line:typeof q=="number"?je=q:(je=typeof q.line=="number"?q.line:this.line,$e=typeof q.character=="number"?q.character:this.character),je===this.line&&$e===this.character?this:new d(je,$e)}toJSON(){return{line:this.line,character:this.character}}};e.$vM=J,e.$vM=J=d=Qe([O],J);let x=u=class{static isRange(q){return q instanceof u?!0:q?J.isPosition(q.start)&&J.isPosition(q.end):!1}static of(q){if(q instanceof u)return q;if(this.isRange(q))return new u(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,$e,je,xe){let rt,ft;if(typeof q=="number"&&typeof $e=="number"&&typeof je=="number"&&typeof xe=="number"?(rt=new J(q,$e),ft=new J(je,xe)):J.isPosition(q)&&J.isPosition($e)&&(rt=J.of(q),ft=J.of($e)),!rt||!ft)throw new Error("Invalid arguments");rt.isBefore(ft)?(this.c=rt,this.e=ft):(this.c=ft,this.e=rt)}contains(q){return u.isRange(q)?this.contains(q.start)&&this.contains(q.end):J.isPosition(q)?!(J.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const $e=J.Max(q.start,this.c),je=J.Min(q.end,this.e);if(!$e.isAfter(je))return new u($e,je)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const $e=J.Min(q.start,this.c),je=J.Max(q.end,this.end);return new u($e,je)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,$e=this.end){if(q===null||$e===null)throw(0,R.$7)();let je;return q?J.isPosition(q)?je=q:(je=q.start||this.start,$e=q.end||this.end):je=this.start,je.isEqual(this.c)&&$e.isEqual(this.end)?this:new u(je,$e)}toJSON(){return[this.start,this.end]}};e.$wM=x,e.$wM=x=u=Qe([O],x);let ce=h=class extends x{static isSelection(q){return q instanceof h?!0:q?x.isRange(q)&&J.isPosition(q.anchor)&&J.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,$e,je,xe){let rt,ft;if(typeof q=="number"&&typeof $e=="number"&&typeof je=="number"&&typeof xe=="number"?(rt=new J(q,$e),ft=new J(je,xe)):J.isPosition(q)&&J.isPosition($e)&&(rt=J.of(q),ft=J.of($e)),!rt||!ft)throw new Error("Invalid arguments");super(rt,ft),this.f=rt,this.g=ft}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$xM=ce,e.$xM=ce=h=Qe([O],ce);const te=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,R.$7)("connectionToken")};class pe{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,$e,je){if(typeof q!="string"||q.length===0)throw(0,R.$7)("host");if(typeof $e!="number"||$e===0||Math.round($e)!==$e)throw(0,R.$7)("port");typeof je<"u"&&te(je),this.host=q,this.port=Math.round($e),this.connectionToken=je}}e.$yM=pe;class ye{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,$e){this.makeConnection=q,this.connectionToken=$e,typeof $e<"u"&&te($e)}}e.$zM=ye;class _ extends Error{static NotAvailable(q,$e){return new _(q,C.RemoteAuthorityResolverErrorCode.NotAvailable,$e)}static TemporarilyNotAvailable(q){return new _(q,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,$e=C.RemoteAuthorityResolverErrorCode.Unknown,je){super(q),this._message=q,this._code=$e,this._detail=je,Object.setPrototypeOf(this,_.prototype)}}e.$AM=_;var U;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(U||(e.EndOfLine=U={}));var he;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(he||(e.EnvironmentVariableMutatorType=he={}));let Se=l=class{static isTextEdit(q){return q instanceof l?!0:q?x.isRange(q)&&typeof q.newText=="string":!1}static replace(q,$e){return new l(q,$e)}static insert(q,$e){return l.replace(new x(q,q),$e)}static delete(q){return l.replace(q,"")}static setEndOfLine(q){const $e=new l(new x(new J(0,0),new J(0,0)),"");return $e.newEol=q,$e}get range(){return this.c}set range(q){if(q&&!x.isRange(q))throw(0,R.$7)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,R.$7)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,R.$7)("newEol");this.f=q}constructor(q,$e){this.c=q,this.e=$e}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$BM=Se,e.$BM=Se=l=Qe([O],Se);let me=g=class{static isNotebookCellEdit(q){return q instanceof g?!0:q?pn.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,$e){return new g(q,$e)}static insertCells(q,$e){return new g(new pn(q,q),$e)}static deleteCells(q){return new g(q,[])}static updateCellMetadata(q,$e){const je=new g(new pn(q,q),[]);return je.newCellMetadata=$e,je}static updateNotebookMetadata(q){const $e=new g(new pn(0,0),[]);return $e.newNotebookMetadata=q,$e}constructor(q,$e){this.range=q,this.newCells=$e}};e.$CM=me,e.$CM=me=g=Qe([O],me);class ie{static isSnippetTextEdit(q){return q instanceof ie?!0:q?x.isRange(q.range)&&G.isSnippetString(q.snippet):!1}static replace(q,$e){return new ie(q,$e)}static insert(q,$e){return ie.replace(new x(q,q),$e)}constructor(q,$e){this.range=q,this.snippet=$e}}e.$DM=ie;var se;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(se||(e.FileEditType=se={}));let oe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,$e,je,xe){this.c.push({_type:1,from:q,to:$e,options:je,metadata:xe})}createFile(q,$e,je){this.c.push({_type:1,from:void 0,to:q,options:$e,metadata:je})}deleteFile(q,$e,je){this.c.push({_type:1,from:q,to:void 0,options:$e,metadata:je})}e(q,$e,je){this.c.push({_type:3,metadata:je,uri:q,edit:{editType:5,metadata:$e},notebookMetadata:$e})}f(q,$e,je,xe){const rt=$e.start,ft=$e.end;(rt!==ft||je.length>0)&&this.c.push({_type:5,uri:q,index:rt,count:ft-rt,cells:je,metadata:xe})}g(q,$e,je,xe){this.c.push({_type:3,metadata:xe,uri:q,edit:{editType:3,index:$e,metadata:je}})}replace(q,$e,je,xe){this.c.push({_type:2,uri:q,edit:new Se($e,je),metadata:xe})}insert(q,$e,je,xe){this.replace(q,new x($e,$e),je,xe)}delete(q,$e,je){this.replace(q,$e,"",je)}has(q){return this.c.some($e=>$e._type===2&&$e.uri.toString()===q.toString())}set(q,$e){if($e)for(const je of $e){if(!je)continue;let xe,rt;Array.isArray(je)?(xe=je[0],rt=je[1]):xe=je,me.isNotebookCellEdit(xe)?xe.newCellMetadata?this.g(q,xe.range.start,xe.newCellMetadata,rt):xe.newNotebookMetadata?this.e(q,xe.newNotebookMetadata,rt):this.f(q,xe.range,xe.newCells,rt):ie.isSnippetTextEdit(xe)?this.c.push({_type:6,uri:q,range:xe.range,edit:xe.snippet,metadata:rt}):this.c.push({_type:2,uri:q,edit:xe,metadata:rt})}else{for(let je=0;je<this.c.length;je++){const xe=this.c[je];switch(xe._type){case 2:case 6:case 3:case 5:xe.uri.toString()===q.toString()&&(this.c[je]=void 0);break}}(0,o.$Ib)(this.c)}}get(q){const $e=[];for(const je of this.c)je._type===2&&je.uri.toString()===q.toString()&&$e.push(je.edit);return $e}entries(){const q=new M.$Bc;for(const $e of this.c)if($e._type===2){let je=q.get($e.uri);je||(je=[$e.uri,[]],q.set($e.uri,je)),je[1].push($e.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$EM=oe,e.$EM=oe=Qe([O],oe);let G=E=class{static isSnippetString(q){return q instanceof E?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=E.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,$e=this.e++){if(typeof q=="function"){const je=new E;je.e=this.e,q(je),this.e=je.e,q=je.value}else q=E.c(q);return this.value+="${",this.value+=$e,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,$e=this.e++){const je=q.map(xe=>xe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=$e,this.value+="|",this.value+=je,this.value+="|}",this}appendVariable(q,$e){if(typeof $e=="function"){const je=new E;je.e=this.e,$e(je),this.e=je.e,$e=je.value}else typeof $e=="string"&&($e=$e.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,$e&&(this.value+=":",this.value+=$e),this.value+="}",this}};e.$FM=G,e.$FM=G=E=Qe([O],G);var ee;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(ee||(e.DiagnosticTag=ee={}));var le;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(le||(e.DiagnosticSeverity=le={}));let de=v=class{static isLocation(q){return q instanceof v?!0:q?x.isRange(q.range)&&w.URI.isUri(q.uri):!1}constructor(q,$e){if(this.uri=q,$e)if(x.isRange($e))this.range=x.of($e);else if(J.isPosition($e))this.range=new x($e,$e);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$GM=de,e.$GM=de=v=Qe([O],de);let Me=class{static is(q){return q?typeof q.message=="string"&&q.location&&x.isRange(q.location.range)&&w.URI.isUri(q.location.uri):!1}constructor(q,$e){this.location=q,this.message=$e}static isEqual(q,$e){return q===$e?!0:!q||!$e?!1:q.message===$e.message&&q.location.range.isEqual($e.location.range)&&q.location.uri.toString()===$e.location.uri.toString()}};e.$HM=Me,e.$HM=Me=Qe([O],Me);let be=class{constructor(q,$e,je=le.Error){if(!x.isRange(q))throw new TypeError("range must be set");if(!$e)throw new TypeError("message must be set");this.range=q,this.message=$e,this.severity=je}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,$e){return q===$e?!0:!q||!$e?!1:q.message===$e.message&&q.severity===$e.severity&&q.code===$e.code&&q.severity===$e.severity&&q.source===$e.source&&q.range.isEqual($e.range)&&(0,o.$ub)(q.tags,$e.tags)&&(0,o.$ub)(q.relatedInformation,$e.relatedInformation,Me.isEqual)}};e.$IM=be,e.$IM=be=Qe([O],be);let Pe=class{constructor(q,$e){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=$e}};e.$JM=Pe,e.$JM=Pe=Qe([O],Pe);var Re;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(Re||(e.DocumentHighlightKind=Re={}));let ze=class{constructor(q,$e=Re.Text){this.range=q,this.kind=$e}toJSON(){return{range:this.range,kind:Re[this.kind]}}};e.$KM=ze,e.$KM=ze=Qe([O],ze);let V=class{constructor(q,$e){this.uri=q,this.highlights=$e}toJSON(){return{uri:this.uri,highlights:this.highlights.map(q=>q.toJSON())}}};e.$LM=V,e.$LM=V=Qe([O],V);var H;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(H||(e.SymbolKind=H={}));var Y;(function(K){K[K.Deprecated=1]="Deprecated"})(Y||(e.SymbolTag=Y={}));let X=S=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,$e,je,xe,rt){this.name=q,this.kind=$e,this.containerName=rt,typeof je=="string"&&(this.containerName=je),xe instanceof de?this.location=xe:je instanceof x&&(this.location=new de(xe,je)),S.validate(this)}toJSON(){return{name:this.name,kind:H[this.kind],location:this.location,containerName:this.containerName}}};e.$MM=X,e.$MM=X=S=Qe([O],X);let fe=k=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(k.validate)}constructor(q,$e,je,xe,rt){this.name=q,this.detail=$e,this.kind=je,this.range=xe,this.selectionRange=rt,this.children=[],k.validate(this)}};e.$NM=fe,e.$NM=fe=k=Qe([O],fe);var we;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(we||(e.CodeActionTriggerKind=we={}));let Te=class{constructor(q,$e){this.title=q,this.kind=$e}};e.$OM=Te,e.$OM=Te=Qe([O],Te);let Ve=D=class{constructor(q){this.value=q}append(q){return new D(this.value?this.value+D.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+D.c)}};e.$PM=Ve,Ve.c=".",e.$PM=Ve=D=Qe([O],Ve),Ve.Empty=new Ve(""),Ve.QuickFix=Ve.Empty.append("quickfix"),Ve.Refactor=Ve.Empty.append("refactor"),Ve.RefactorExtract=Ve.Refactor.append("extract"),Ve.RefactorInline=Ve.Refactor.append("inline"),Ve.RefactorMove=Ve.Refactor.append("move"),Ve.RefactorRewrite=Ve.Refactor.append("rewrite"),Ve.Source=Ve.Empty.append("source"),Ve.SourceOrganizeImports=Ve.Source.append("organizeImports"),Ve.SourceFixAll=Ve.Source.append("fixAll"),Ve.Notebook=Ve.Empty.append("notebook");let Ye=class{constructor(q,$e){if(this.range=q,this.parent=$e,$e&&!$e.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$QM=Ye,e.$QM=Ye=Qe([O],Ye);class nt{constructor(q,$e,je,xe,rt,ft){this.kind=q,this.name=$e,this.detail=je,this.uri=xe,this.range=rt,this.selectionRange=ft}}e.$RM=nt;class ot{constructor(q,$e){this.fromRanges=$e,this.from=q}}e.$SM=ot;class lt{constructor(q,$e){this.fromRanges=$e,this.to=q}}e.$TM=lt;var at;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(at||(e.LanguageStatusSeverity=at={}));let st=class{constructor(q,$e){this.range=q,this.command=$e}get isResolved(){return!!this.command}};e.$UM=st,e.$UM=st=Qe([O],st);let Ie=F=class{static isMarkdownString(q){return q instanceof F?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,$e=!1){m.set(this,void 0),it(this,m,new I.$Fk(q,{supportThemeIcons:$e}),"f")}get value(){return qe(this,m,"f").value}set value(q){qe(this,m,"f").value=q}get isTrusted(){return qe(this,m,"f").isTrusted}set isTrusted(q){qe(this,m,"f").isTrusted=q}get supportThemeIcons(){return qe(this,m,"f").supportThemeIcons}set supportThemeIcons(q){qe(this,m,"f").supportThemeIcons=q}get supportHtml(){return qe(this,m,"f").supportHtml}set supportHtml(q){qe(this,m,"f").supportHtml=q}get baseUri(){return qe(this,m,"f").baseUri}set baseUri(q){qe(this,m,"f").baseUri=q}appendText(q){return qe(this,m,"f").appendText(q),this}appendMarkdown(q){return qe(this,m,"f").appendMarkdown(q),this}appendCodeblock(q,$e){return qe(this,m,"f").appendCodeblock($e??"",q),this}};e.$VM=Ie,m=new WeakMap,e.$VM=Ie=F=Qe([O],Ie);let We=class{constructor(q,$e){this.label=q,this.documentation=$e}};e.$WM=We,e.$WM=We=Qe([O],We);let Ae=class{constructor(q,$e){this.label=q,this.documentation=$e,this.parameters=[]}};e.$XM=Ae,e.$XM=Ae=Qe([O],Ae);let Ke=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$YM=Ke,e.$YM=Ke=Qe([O],Ke);var ae;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(ae||(e.SignatureHelpTriggerKind=ae={}));var ue;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(ue||(e.InlayHintKind=ue={}));let De=class{constructor(q){this.value=q}};e.$ZM=De,e.$ZM=De=Qe([O],De);let Je=class{constructor(q,$e,je){this.position=q,this.label=$e,this.kind=je}};e.$1M=Je,e.$1M=Je=Qe([O],Je);var et;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(et||(e.CompletionTriggerKind=et={}));var Ne;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(Ne||(e.CompletionItemKind=Ne={}));var ht;(function(K){K[K.Deprecated=1]="Deprecated"})(ht||(e.CompletionItemTag=ht={}));let vt=class{constructor(q,$e){this.label=q,this.kind=$e}toJSON(){return{label:this.label,kind:this.kind&&Ne[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$2M=vt,e.$2M=vt=Qe([O],vt);let Mt=class{constructor(q=[],$e=!1){this.items=q,this.isIncomplete=$e}};e.$3M=Mt,e.$3M=Mt=Qe([O],Mt);let zt=class{constructor(q,$e,je){this.insertText=q,this.range=$e,this.command=je}};e.$4M=zt,e.$4M=zt=Qe([O],zt);let Yt=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$5M=Yt,e.$5M=Yt=Qe([O],Yt);var xt;(function(K){K[K.Unknown=0]="Unknown",K[K.Word=1]="Word",K[K.Line=2]="Line",K[K.Suggest=3]="Suggest"})(xt||(e.PartialAcceptTriggerKind=xt={}));var Pt;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(Pt||(e.ViewColumn=Pt={}));var sn;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(sn||(e.StatusBarAlignment=sn={}));function _t(K,q){return`${P.$Em.toKey(K)}.${q}`}var dn;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval"})(dn||(e.TextEditorLineNumbersStyle=dn={}));var tt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(tt||(e.TextDocumentSaveReason=tt={}));var on;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(on||(e.TextEditorRevealType=on={}));var Gt;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(Gt||(e.TextEditorSelectionChangeKind=Gt={}));var Kt;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(Kt||(e.TextDocumentChangeReason=Kt={}));var gt;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(gt||(e.DecorationRangeBehavior=gt={})),function(K){function q($e){switch($e){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=q}(Gt||(e.TextEditorSelectionChangeKind=Gt={}));var bt;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(bt||(e.SyntaxTokenType=bt={})),function(K){function q($e){switch($e){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=q}(bt||(e.SyntaxTokenType=bt={}));let Xt=class{constructor(q,$e){if($e&&!w.URI.isUri($e))throw(0,R.$7)("target");if(!x.isRange(q)||q.isEmpty)throw(0,R.$7)("range");this.range=q,this.target=$e}};e.$7M=Xt,e.$7M=Xt=Qe([O],Xt);let Bt=class{constructor(q,$e,je,xe){this.red=q,this.green=$e,this.blue=je,this.alpha=xe}};e.$8M=Bt,e.$8M=Bt=Qe([O],Bt);let Vt=class{constructor(q,$e){if($e&&!($e instanceof Bt))throw(0,R.$7)("color");if(!x.isRange(q)||q.isEmpty)throw(0,R.$7)("range");this.range=q,this.color=$e}};e.$9M=Vt,e.$9M=Vt=Qe([O],Vt);let $t=class{constructor(q){if(!q||typeof q!="string")throw(0,R.$7)("label");this.label=q}};e.$0M=$t,e.$0M=$t=Qe([O],$t);var Rt;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(Rt||(e.ColorFormat=Rt={}));var cn;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(cn||(e.SourceControlInputBoxValidationType=cn={}));var en;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(en||(e.TerminalExitReason=en={}));class Xe{constructor(q,$e,je){if(this.startIndex=q,this.length=$e,this.tooltip=je,typeof q!="number"||q<0)throw(0,R.$7)("startIndex");if(typeof $e!="number"||$e<1)throw(0,R.$7)("length");if(je!==void 0&&typeof je!="string")throw(0,R.$7)("tooltip")}}e.$$M=Xe;class Zt{constructor(q){this.uri=q}}e.$_M=Zt;class tn{constructor(q){this.terminalCommand=q}}e.$aN=tn;var nn;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(nn||(e.TerminalLocation=nn={}));class yt{constructor(q){if(this.options=q,typeof q!="object")throw(0,R.$7)("options")}}e.$bN=yt;var Ut;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(Ut||(e.TaskRevealKind=Ut={}));var Tt;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(Tt||(e.TaskPanelKind=Tt={}));let Lt=W=class{static from(q){switch(q){case"clean":return W.Clean;case"build":return W.Build;case"rebuild":return W.Rebuild;case"test":return W.Test;default:return}}constructor(q,$e){if(this.label=$e,typeof q!="string"||typeof $e!="string")throw(0,R.$7)("name");this.c=q}get id(){return this.c}};e.$cN=Lt,Lt.Clean=new W("clean","Clean"),Lt.Build=new W("build","Build"),Lt.Rebuild=new W("rebuild","Rebuild"),Lt.Test=new W("test","Test"),e.$cN=Lt=W=Qe([O],Lt);function un(K){let q="";for(let $e=0;$e<K.length;$e++)q+=K[$e].replace(/,/g,",,")+",";return q}let Wt=class{constructor(q,$e,je){if(typeof q!="string")throw(0,R.$7)("process");this.e=[],this.c=q,$e!==void 0&&(Array.isArray($e)?(this.e=$e,this.f=je):this.f=$e)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,R.$7)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const $e of this.e)q.push($e);return un(q)}};e.$dN=Wt,e.$dN=Wt=Qe([O],Wt);let Ht=class{constructor(q,$e,je){if(this.f=[],Array.isArray($e)){if(!q)throw(0,R.$7)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,R.$7)("command");this.e=q,this.f=$e,this.g=je}else{if(typeof q!="string")throw(0,R.$7)("commandLine");this.c=q,this.g=$e}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,R.$7)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,R.$7)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const $e of this.f)q.push(typeof $e=="string"?$e:$e.value);return un(q)}};e.$eN=Ht,e.$eN=Ht=Qe([O],Ht);var It;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(It||(e.ShellQuoting=It={}));var Ft;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(Ft||(e.TaskScope=Ft={}));class rn{constructor(q){this.c=q}computeId(){return"customExecution"+(0,A.$Eg)()}set callback(q){this.c=q}get callback(){return this.c}}e.$fN=rn;let At=B=class{constructor(q,$e,je,xe,rt,ft){this.k=!1,this.l=this.definition=q;let pt;typeof $e=="string"?(this.o=this.name=$e,this.w=this.source=je,this.execution=xe,pt=rt,this.k=!0):$e===Ft.Global||$e===Ft.Workspace?(this.target=$e,this.o=this.name=je,this.w=this.source=xe,this.execution=rt,pt=ft):(this.target=$e,this.o=this.name=je,this.w=this.source=xe,this.execution=rt,pt=ft),typeof pt=="string"?(this.r=[pt],this.t=!0):Array.isArray(pt)?(this.r=pt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(q){this.j=q}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Wt?this.l={type:B.e,id:this.q.computeId()}:this.q instanceof Ht?this.l={type:B.f,id:this.q.computeId()}:this.q instanceof rn?this.l={type:B.c,id:this.q.computeId()}:this.l={type:B.g,id:(0,A.$Eg)()}}get definition(){return this.l}set definition(q){if(q==null)throw(0,R.$7)("Kind can't be undefined or null");this.B(),this.l=q}get scope(){return this.m}set target(q){this.B(),this.m=q}get name(){return this.o}set name(q){if(typeof q!="string")throw(0,R.$7)("name");this.B(),this.o=q}get execution(){return this.q}set execution(q){q===null&&(q=void 0),this.B(),this.q=q;const $e=this.l.type;(B.g===$e||B.e===$e||B.f===$e||B.c===$e)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(q){if(Array.isArray(q))this.B(),this.r=q,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.B(),this.u=q}get source(){return this.w}set source(q){if(typeof q!="string"||q.length===0)throw(0,R.$7)("source must be a string of length > 0");this.B(),this.w=q}get group(){return this.x}set group(q){q===null&&(q=void 0),this.B(),this.x=q}get detail(){return this.A}set detail(q){q===null&&(q=void 0),this.A=q}get presentationOptions(){return this.y}set presentationOptions(q){q==null&&(q=Object.create(null)),this.B(),this.y=q}get runOptions(){return this.z}set runOptions(q){q==null&&(q=Object.create(null)),this.B(),this.z=q}};e.$gN=At,At.c="customExecution",At.e="process",At.f="shell",At.g="$empty",e.$gN=At=B=Qe([O],At);var Et;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(Et||(e.ProgressLocation=Et={}));var Nt;(function(K){function q($e){const je=$e;return(0,$.$Zf)(je.value)?je.tooltip&&!(0,$.$Vf)(je.tooltip)?(console.log("INVALID view badge, invalid tooltip",je.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",je.value),!1)}K.isViewBadge=q})(Nt||(e.ViewBadge=Nt={}));let fn=j=class{static isTreeItem(q,$e){const je=q;if(je.checkboxState!==void 0){const xe=(0,$.$Zf)(je.checkboxState)?je.checkboxState:(0,$.$Xf)(je.checkboxState)&&(0,$.$Zf)(je.checkboxState.state)?je.checkboxState.state:void 0,rt=!(0,$.$Zf)(je.checkboxState)&&(0,$.$Xf)(je.checkboxState)?je.checkboxState.tooltip:void 0;if(xe===void 0||xe!==ln.Checked&&xe!==ln.Unchecked||rt!==void 0&&!(0,$.$Vf)(rt))return console.log("INVALID tree item, invalid checkboxState",je.checkboxState),!1}if(q instanceof j)return!0;if(je.label!==void 0&&!(0,$.$Vf)(je.label)&&!je.label?.label)return console.log("INVALID tree item, invalid label",je.label),!1;if(je.id!==void 0&&!(0,$.$Vf)(je.id))return console.log("INVALID tree item, invalid id",je.id),!1;if(je.iconPath!==void 0&&!(0,$.$Vf)(je.iconPath)&&!w.URI.isUri(je.iconPath)&&(!je.iconPath||!(0,$.$Vf)(je.iconPath.id))){const xe=je.iconPath;if(!xe||!(0,$.$Vf)(xe.light)&&!w.URI.isUri(xe.light)&&!(0,$.$Vf)(xe.dark)&&!w.URI.isUri(xe.dark))return console.log("INVALID tree item, invalid iconPath",je.iconPath),!1}return je.description!==void 0&&!(0,$.$Vf)(je.description)&&typeof je.description!="boolean"?(console.log("INVALID tree item, invalid description",je.description),!1):je.resourceUri!==void 0&&!w.URI.isUri(je.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",je.resourceUri),!1):je.tooltip!==void 0&&!(0,$.$Vf)(je.tooltip)&&!(je.tooltip instanceof Ie)?(console.log("INVALID tree item, invalid tooltip",je.tooltip),!1):je.command!==void 0&&!je.command.command?(console.log("INVALID tree item, invalid command",je.command),!1):je.collapsibleState!==void 0&&je.collapsibleState<Ct.None&&je.collapsibleState>Ct.Expanded?(console.log("INVALID tree item, invalid collapsibleState",je.collapsibleState),!1):je.contextValue!==void 0&&!(0,$.$Vf)(je.contextValue)?(console.log("INVALID tree item, invalid contextValue",je.contextValue),!1):je.accessibilityInformation!==void 0&&!je.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",je.accessibilityInformation),!1):!0}constructor(q,$e=Ct.None){this.collapsibleState=$e,w.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$hN=fn,e.$hN=fn=j=Qe([O],fn);var Ct;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(Ct||(e.TreeItemCollapsibleState=Ct={}));var ln;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(ln||(e.TreeItemCheckboxState=ln={}));let Jt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$iN=Jt,e.$iN=Jt=Qe([O],Jt);class En extends Jt{}e.$jN=En;class wn extends En{constructor(q){super(""),c.set(this,void 0),it(this,c,q,"f")}asFile(){return qe(this,c,"f")}}e.$kN=wn,c=new WeakMap;class Oe{constructor(q,$e,je,xe){this.name=q,this.uri=$e,this._itemId=je,this.c=xe}data(){return this.c()}}e.$lN=Oe;let Fe=class{constructor(q){i.add(this),n.set(this,new Map);for(const[$e,je]of q??[]){const xe=qe(this,n,"f").get(qe(this,i,"m",r).call(this,$e));xe?xe.push(je):qe(this,n,"f").set(qe(this,i,"m",r).call(this,$e),[je])}}get(q){return qe(this,n,"f").get(qe(this,i,"m",r).call(this,q))?.[0]}set(q,$e){qe(this,n,"f").set(qe(this,i,"m",r).call(this,q),[$e])}forEach(q,$e){for(const[je,xe]of qe(this,n,"f"))for(const rt of xe)q.call($e,rt,je,this)}*[(n=new WeakMap,i=new WeakSet,Symbol.iterator)](){for(const[q,$e]of qe(this,n,"f"))for(const je of $e)yield[q,je]}};e.$mN=Fe,r=function(q){return q.toLowerCase()},e.$mN=Fe=Qe([O],Fe);let ke=class{constructor(q,$e,je){this.insertText=q,this.title=$e,this.kind=je}};e.$nN=ke,e.$nN=ke=Qe([O],ke);var ne;(function(K){K[K.Automatic=0]="Automatic",K[K.PasteAs=1]="PasteAs"})(ne||(e.DocumentPasteTriggerKind=ne={}));class Le{constructor(q){this.value=q}append(...q){return new Le((this.value?[this.value,...q]:q).join(Le.c))}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+Le.c)}}e.$oN=Le,Le.c=".",Le.Empty=new Le("");let Ge=class{constructor(q,$e,je){this.title=$e,this.insertText=q,this.kind=je}};e.$pN=Ge,e.$pN=Ge=Qe([O],Ge);let _e=class{constructor(q,$e){this.id=q,this.color=$e}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$qN=_e,e.$qN=_e=Qe([O],_e),_e.File=new _e("file"),_e.Folder=new _e("folder");let Ze=class{constructor(q){this.id=q}};e.$rN=Ze,e.$rN=Ze=Qe([O],Ze);var dt;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(dt||(e.ConfigurationTarget=dt={}));let St=class{get base(){return this.c}set base(q){this.c=q,this.e=w.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,$e){if(typeof q!="string"&&(!q||!w.URI.isUri(q)&&!w.URI.isUri(q.uri)))throw(0,R.$7)("base");if(typeof $e!="string")throw(0,R.$7)("pattern");typeof q=="string"?this.baseUri=w.URI.file(q):w.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=$e}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$sN=St,e.$sN=St=Qe([O],St);const Dt=new WeakMap;function an(K,q){Dt.set(K,q)}let Ot=class{constructor(q,$e,je,xe,rt){this.enabled=typeof q=="boolean"?q:!0,typeof $e=="string"&&(this.condition=$e),typeof je=="string"&&(this.hitCondition=je),typeof xe=="string"&&(this.logMessage=xe),typeof rt=="string"&&(this.mode=rt)}get id(){return this.c||(this.c=Dt.get(this)??(0,A.$Eg)()),this.c}};e.$uN=Ot,e.$uN=Ot=Qe([O],Ot);let qt=class extends Ot{constructor(q,$e,je,xe,rt,ft){if(super($e,je,xe,rt,ft),q===null)throw(0,R.$7)("location");this.location=q}};e.$vN=qt,e.$vN=qt=Qe([O],qt);let Cn=class extends Ot{constructor(q,$e,je,xe,rt,ft){super($e,je,xe,rt,ft),this.functionName=q}};e.$wN=Cn,e.$wN=Cn=Qe([O],Cn);let mt=class extends Ot{constructor(q,$e,je,xe,rt,ft,pt,Qt){if(super(xe,rt,ft,pt,Qt),!$e)throw(0,R.$7)("dataId");this.label=q,this.dataId=$e,this.canPersist=je}};e.$xN=mt,e.$xN=mt=Qe([O],mt);let Tn=class{constructor(q,$e,je){this.command=q,this.args=$e||[],this.options=je}};e.$yN=Tn,e.$yN=Tn=Qe([O],Tn);let gn=class{constructor(q,$e){this.port=q,this.host=$e}};e.$zN=gn,e.$zN=gn=Qe([O],gn);let vn=class{constructor(q){this.path=q}};e.$AN=vn,e.$AN=vn=Qe([O],vn);let Mn=class{constructor(q){this.implementation=q}};e.$BN=Mn,e.$BN=Mn=Qe([O],Mn);class mi{constructor(q,$e,je){this.session=q,this.threadId=$e,this.frameId=je}}e.$CN=mi;class $i{constructor(q,$e){this.session=q,this.threadId=$e}}e.$DN=$i;let Fn=class{constructor(q,$e){this.range=q,this.expression=$e}};e.$EN=Fn,e.$EN=Fn=Qe([O],Fn);var zn;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(zn||(e.InlineCompletionTriggerKind=zn={}));let Bn=class{constructor(q,$e){this.range=q,this.text=$e}};e.$FN=Bn,e.$FN=Bn=Qe([O],Bn);let Rn=class{constructor(q,$e,je=!0){this.range=q,this.variableName=$e,this.caseSensitiveLookup=je}};e.$GN=Rn,e.$GN=Rn=Qe([O],Rn);let Un=class{constructor(q,$e){this.range=q,this.expression=$e}};e.$HN=Un,e.$HN=Un=Qe([O],Un);let Sn=class{constructor(q,$e){this.frameId=q,this.stoppedLocation=$e}};e.$IN=Sn,e.$IN=Sn=Qe([O],Sn);var Ln;(function(K){K[K.AIGenerated=1]="AIGenerated"})(Ln||(e.NewSymbolNameTag=Ln={}));class pi{constructor(q,$e){this.newSymbolName=q,this.tags=$e}}e.$JN=pi;var xn;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(xn||(e.FileChangeType=xn={}));let yn=N=class extends Error{static FileExists(q){return new N(q,b.FileSystemProviderErrorCode.FileExists,N.FileExists)}static FileNotFound(q){return new N(q,b.FileSystemProviderErrorCode.FileNotFound,N.FileNotFound)}static FileNotADirectory(q){return new N(q,b.FileSystemProviderErrorCode.FileNotADirectory,N.FileNotADirectory)}static FileIsADirectory(q){return new N(q,b.FileSystemProviderErrorCode.FileIsADirectory,N.FileIsADirectory)}static NoPermissions(q){return new N(q,b.FileSystemProviderErrorCode.NoPermissions,N.NoPermissions)}static Unavailable(q){return new N(q,b.FileSystemProviderErrorCode.Unavailable,N.Unavailable)}constructor(q,$e=b.FileSystemProviderErrorCode.Unknown,je){super(w.URI.isUri(q)?q.toString(!0):q),this.code=je?.name??"Unknown",(0,b.$4k)(this,$e),Object.setPrototypeOf(this,N.prototype),typeof Error.captureStackTrace=="function"&&typeof je=="function"&&Error.captureStackTrace(this,je)}};e.$KN=yn,e.$KN=yn=N=Qe([O],yn);let Wn=class{constructor(q,$e,je){this.start=q,this.end=$e,this.kind=je}};e.$LN=Wn,e.$LN=Wn=Qe([O],Wn);var _n;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(_n||(e.FoldingRangeKind=_n={}));var ei;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(ei||(e.CommentThreadCollapsibleState=ei={}));var Vn;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(Vn||(e.CommentMode=Vn={}));var ti;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(ti||(e.CommentState=ti={}));var qn;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(qn||(e.CommentThreadState=qn={}));var Hn;(function(K){K[K.Current=0]="Current",K[K.Outdated=1]="Outdated"})(Hn||(e.CommentThreadApplicability=Hn={}));class bi{constructor(q,$e=[]){this.tokenTypes=q,this.tokenModifiers=$e}}e.$MN=bi;function ni(K){return typeof K>"u"||(0,$.$Wf)(K)}class On{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,q){this.m=!0;for(let $e=0,je=q.tokenTypes.length;$e<je;$e++)this.k.set(q.tokenTypes[$e],$e);for(let $e=0,je=q.tokenModifiers.length;$e<je;$e++)this.l.set(q.tokenModifiers[$e],$e)}}push(q,$e,je,xe,rt){if(typeof q=="number"&&typeof $e=="number"&&typeof je=="number"&&typeof xe=="number"&&(typeof rt=="number"||typeof rt>"u"))return typeof rt>"u"&&(rt=0),this.q(q,$e,je,xe,rt);if(x.isRange(q)&&typeof $e=="string"&&ni(je))return this.o(q,$e,je);throw(0,R.$7)()}o(q,$e,je){if(!this.m)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has($e))throw new Error("`tokenType` is not in the provided legend");const xe=q.start.line,rt=q.start.character,ft=q.end.character-q.start.character,pt=this.k.get($e);let Qt=0;if(je)for(const hn of je){if(!this.l.has(hn))throw new Error("`tokenModifier` is not in the provided legend");const $n=this.l.get(hn);Qt|=1<<$n>>>0}this.q(xe,rt,ft,pt,Qt)}q(q,$e,je,xe,rt){if(this.f&&(q<this.c||q===this.c&&$e<this.e)){this.f=!1;const Qt=this.g.length/5|0;let hn=0,$n=0;for(let bn=0;bn<Qt;bn++){let kn=this.g[5*bn],Zn=this.g[5*bn+1];kn===0?(kn=hn,Zn+=$n):kn+=hn,this.g[5*bn]=kn,this.g[5*bn+1]=Zn,hn=kn,$n=Zn}}let ft=q,pt=$e;this.f&&this.j>0&&(ft-=this.c,ft===0&&(pt-=this.e)),this.g[this.j++]=ft,this.g[this.j++]=pt,this.g[this.j++]=je,this.g[this.j++]=xe,this.g[this.j++]=rt,this.c=q,this.e=$e}static r(q){const $e=[],je=q.length/5|0;for(let pt=0;pt<je;pt++)$e[pt]=pt;$e.sort((pt,Qt)=>{const hn=q[5*pt],$n=q[5*Qt];if(hn===$n){const bn=q[5*pt+1],kn=q[5*Qt+1];return bn-kn}return hn-$n});const xe=new Uint32Array(q.length);let rt=0,ft=0;for(let pt=0;pt<je;pt++){const Qt=5*$e[pt],hn=q[Qt+0],$n=q[Qt+1],bn=q[Qt+2],kn=q[Qt+3],Zn=q[Qt+4],Ui=hn-rt,mr=Ui===0?$n-ft:$n,Yn=5*pt;xe[Yn+0]=Ui,xe[Yn+1]=mr,xe[Yn+2]=bn,xe[Yn+3]=kn,xe[Yn+4]=Zn,rt=hn,ft=$n}return xe}build(q){return this.f?new Gn(new Uint32Array(this.g),q):new Gn(On.r(this.g),q)}}e.$NN=On;class Gn{constructor(q,$e){this.resultId=$e,this.data=q}}e.$ON=Gn;class wi{constructor(q,$e,je){this.start=q,this.deleteCount=$e,this.data=je}}e.$PN=wi;class vi{constructor(q,$e){this.resultId=$e,this.edits=q}}e.$QN=vi;var ii;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(ii||(e.DebugConsoleMode=ii={}));class Kn{constructor(q){this.name=q}}e.$RN=Kn;let Dn=class{constructor(){}};e.$SN=Dn,Dn.Back={iconPath:new _e("arrow-left")},e.$SN=Dn=Qe([O],Dn);var Ue;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(Ue||(e.QuickPickItemKind=Ue={}));var mn;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(mn||(e.InputBoxValidationSeverity=mn={}));var Jn;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(Jn||(e.ExtensionKind=Jn={}));class ct{static validate(q){if(typeof q.badge=="string"){let $e=(0,p.$vf)(q.badge,0);if($e<q.badge.length&&($e+=(0,p.$vf)(q.badge,$e)),q.badge.length>$e)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!_e.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,$e,je){this.badge=q,this.tooltip=$e,this.color=je}}e.$TN=ct;let wt=class{constructor(q){this.kind=q}};e.$UN=wt,e.$UN=wt=Qe([O],wt);var ri;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(ri||(e.ColorThemeKind=ri={}));class pn{static isNotebookRange(q){return q instanceof pn?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,$e){if(q<0)throw(0,R.$7)("start must be positive");if($e<0)throw(0,R.$7)("end must be positive");q<=$e?(this.c=q,this.e=$e):(this.c=$e,this.e=q)}with(q){let $e=this.c,je=this.e;return q.start!==void 0&&($e=q.start),q.end!==void 0&&(je=q.end),$e===this.c&&je===this.e?this:new pn($e,je)}}e.$VN=pn;class Pn{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every($e=>Pn.isNotebookCellData($e))}static isNotebookCellData(q){return!0}constructor(q,$e,je,xe,rt,ft,pt){this.kind=q,this.value=$e,this.languageId=je,this.mime=xe,this.outputs=rt??[],this.metadata=ft,this.executionSummary=pt,Pn.validate(this)}}e.$WN=Pn;class yi{constructor(q){this.cells=q}}e.$XN=yi;class In{static isNotebookCellOutputItem(q){return q instanceof s?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const $e={name:q.name,message:q.message,stack:q.stack};return s.json($e,"application/vnd.code.notebook.error")}static stdout(q){return s.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return s.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,$e="application/octet-stream"){return new s(q,$e)}static text(q,$e=L.$As.text){const je=qe(s,s,"f",t).encode(String(q));return new s(je,$e)}static json(q,$e="text/x-json"){const je=JSON.stringify(q,void 0,"	");return s.text(je,$e)}constructor(q,$e){this.data=q,this.mime=$e;const je=(0,L.$Es)($e,!0);if(!je)throw new Error(`INVALID mime type: ${$e}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=je}}e.$YN=In,s=In,t={value:new TextEncoder};class Nn{static isNotebookCellOutput(q){return q instanceof Nn?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,$e=!1){const je=new Set,xe=new Set;for(let rt=0;rt<q.length;rt++){const ft=q[rt],pt=(0,L.$Es)(ft.mime);if(!je.has(pt)||(0,y.$pK)(pt)){je.add(pt);continue}xe.add(rt),$e&&console.warn(`DUPLICATED mime type '${ft.mime}' will be dropped`)}return xe.size===0?q:q.filter((rt,ft)=>!xe.has(ft))}constructor(q,$e,je){this.items=Nn.ensureUniqueMimeTypes(q,!0),typeof $e=="string"?(this.id=$e,this.metadata=je):(this.id=(0,A.$Eg)(),this.metadata=$e??je)}}e.$ZN=Nn;var si;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(si||(e.NotebookCellKind=si={}));var oi;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(oi||(e.NotebookCellExecutionState=oi={}));var Qn;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(Qn||(e.NotebookCellStatusBarAlignment=Qn={}));var ai;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(ai||(e.NotebookEditorRevealType=ai={}));class ki{constructor(q,$e){this.text=q,this.alignment=$e}}e.$1N=ki;var ci;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(ci||(e.NotebookControllerAffinity=ci={}));var ui;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(ui||(e.NotebookControllerAffinity2=ui={}));class Ei{constructor(q,$e=[]){this.uri=q,this.provides=(0,o.$3b)($e)}}e.$2N=Ei;class Ci{constructor(q){this.label=q}}e.$3N=Ci;var li;(function(K){K[K.Named=1]="Named",K[K.Indexed=2]="Indexed"})(li||(e.NotebookVariablesRequestKind=li={}));let Xn=class{constructor(q,$e){this.label=q,this.timestamp=$e}};e.$4N=Xn,e.$4N=Xn=Qe([O],Xn);var hi;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(hi||(e.ExtensionMode=hi={}));var di;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(di||(e.ExtensionRuntime=di={}));var fi;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(fi||(e.StandardTokenType=fi={}));class ge{constructor(q,$e){this.ranges=q,this.wordPattern=$e}}e.$5N=ge;class ve{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$6N=ve;var Be;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(Be||(e.TestResultState=Be={}));var ut;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(ut||(e.TestRunProfileKind=ut={}));let kt=class{constructor(q=void 0,$e=void 0,je=void 0,xe=!1){this.include=q,this.exclude=$e,this.profile=je,this.continuous=xe}};e.$7N=kt,e.$7N=kt=Qe([O],kt);let jt=T=class{static diff(q,$e,je){const xe=new T(q);return xe.expectedOutput=$e,xe.actualOutput=je,xe}constructor(q){this.message=q}};e.$8N=jt,e.$8N=jt=T=Qe([O],jt);let An=class{constructor(q){this.id=q}};e.$9N=An,e.$9N=An=Qe([O],An);class gi{constructor(q,$e){this.covered=q,this.total=$e,Di(this)}}e.$0N=gi;function Di(K){if(K){if(K.covered>K.total)throw new Error(`The total number of covered items (${K.covered}) cannot be greater than the total (${K.total})`);if(K.total<0)throw new Error(`The number of covered items (${K.total}) cannot be negative`)}}class Si{static fromDetails(q,$e){const je=new gi(0,0),xe=new gi(0,0),rt=new gi(0,0);for(const pt of $e)if("branches"in pt){je.total+=1,je.covered+=pt.executed?1:0;for(const Qt of pt.branches)xe.total+=1,xe.covered+=Qt.executed?1:0}else rt.total+=1,rt.covered+=pt.executed?1:0;const ft=new Si(q,je,xe.total>0?xe:void 0,rt.total>0?rt:void 0);return ft.detailedCoverage=$e,ft}constructor(q,$e,je,xe){this.uri=q,this.statementCoverage=$e,this.branchCoverage=je,this.declarationCoverage=xe}}e.$_N=Si;class Wi{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,$e,je=[]){this.executed=q,this.location=$e,this.branches=je}}e.$aO=Wi;class Vi{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,$e,je){this.executed=q,this.location=$e,this.label=je}}e.$bO=Vi;class qi{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,$e,je){this.name=q,this.executed=$e,this.location=je}}e.$cO=qi;var Pi;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(Pi||(e.ExternalUriOpenerPriority=Pi={}));var Ii;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(Ii||(e.WorkspaceTrustState=Ii={}));var Ai;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ai||(e.PortAutoForwardAction=Ai={}));class Hi{constructor(q,$e,je,xe,rt,ft){this.kind=q,this.name=$e,this.detail=je,this.uri=xe,this.range=rt,this.selectionRange=ft}}e.$dO=Hi;class Gi{constructor(q){this.uri=q}}e.$eO=Gi;class Ki{constructor(q,$e){this.original=q,this.modified=$e}}e.$fO=Ki;class Ji{constructor(q,$e,je,xe){this.base=q,this.input1=$e,this.input2=je,this.result=xe}}e.$gO=Ji;class Qi{constructor(q,$e){this.uri=q,this.viewType=$e}}e.$hO=Qi;class Xi{constructor(q){this.viewType=q}}e.$iO=Xi;class Zi{constructor(q,$e){this.uri=q,this.notebookType=$e}}e.$jO=Zi;class Yi{constructor(q,$e,je){this.original=q,this.modified=$e,this.notebookType=je}}e.$kO=Yi;class xi{constructor(){}}e.$lO=xi;class _i{constructor(q,$e){this.uri=q,this.inputBoxUri=$e}}e.$mO=_i;class er{constructor(q){this.providerId=q}}e.$nO=er;class tr{constructor(q){this.textDiffs=q}}e.$oO=tr;var Mi;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})(Mi||(e.InteractiveSessionVoteDirection=Mi={}));var Ri;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(Ri||(e.ChatCopyKind=Ri={}));var Li;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(Li||(e.ChatVariableLevel=Li={}));class nr{constructor(q,$e){this.label=q,this.values=$e}}e.$pO=nr;var Oi;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted",K[K.Bug=4]="Bug"})(Oi||(e.InteractiveEditorResponseFeedbackKind=Oi={}));var Ni;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(Ni||(e.ChatResultFeedbackKind=Ni={}));class ir{constructor(q){this.value=typeof q=="string"?new Ie(q):q}}e.$qO=ir;class rr{constructor(q,$e){this.value=q,this.baseUri=$e}}e.$rO=rr;class sr{constructor(q,$e){this.value=q,this.title=$e}}e.$sO=sr;class or{constructor(q){this.value=q}}e.$tO=or;class ar{constructor(q){this.value=q}}e.$uO=ar;class cr{constructor(q){this.value=q}}e.$vO=cr;class ur{constructor(q,$e,je,xe){this.prompt=q,this.command=$e,this.variables=je,this.participant=xe}}e.$wO=ur;class lr{constructor(q,$e,je,xe){this.response=q,this.result=$e,this.participant=je,this.command=xe}}e.$xO=lr;var ji;(function(K){K[K.Panel=1]="Panel",K[K.Terminal=2]="Terminal",K[K.Notebook=3]="Notebook",K[K.Editor=4]="Editor"})(ji||(e.ChatLocation=ji={}));class hr{constructor(q){this.content=q}}e.$yO=hr;class dr{constructor(q,$e){this.content=q,this.name=$e}}e.$zO=dr;class fr{constructor(q,$e){this.content=q,this.name=$e}}e.$AO=fr;class jn extends Error{static NotFound(q){return new jn(q,jn.NotFound.name)}static NoPermissions(q){return new jn(q,jn.NoPermissions.name)}constructor(q,$e,je){super(q,{cause:je}),this.name="LanguageModelError",this.code=$e??""}}e.$BO=jn;var Ti;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(Ti||(e.RelatedInformationType=Ti={}));var Fi;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped"})(Fi||(e.SpeechToTextStatus=Fi={}));var zi;(function(K){K[K.Recognized=1]="Recognized",K[K.Stopped=2]="Stopped"})(zi||(e.KeywordRecognitionStatus=zi={}));class gr{constructor(q,$e){this.text=q,this.range=$e}}e.$CO=gr;var Bi;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Bi||(e.InlineEditTriggerKind=Bi={}))}),define(Ee[322],Ce([1,0,6,7]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zjc=void 0;class I{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(o.$sM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,p,$){if(this.a.size===0)throw new Error("No related information providers registered");const w=this.a.get(L);if(!w)throw new Error("related information provider not found");return await w.provideRelatedInformation(p,$)??[]}getRelatedInformation(L,p,$){return this.c.$getAiRelatedInformation(p,$)}registerRelatedInformationProvider(L,p,$){const w=this.b;return this.b++,this.a.set(w,$),this.c.$registerAiRelatedInformationProvider(w,p),new R.$uM(()=>{this.c.$unregisterAiRelatedInformationProvider(w),this.a.delete(w)})}}e.$zjc=I}),define(Ee[121],Ce([1,0,4,6,7,25,146,5,20]),function(re,e,o,R,I,M,L,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ljc=e.$Kjc=void 0,e.$Kjc=(0,p.$ii)("IExtHostAuthentication");let w=class{constructor(b){this.b=new Map,this.c=new o.$7d,this.onDidChangeSessions=this.c.event,this.d=new A,this.f=new A,this.a=b.getProxy(R.$sM.MainThreadAuthentication)}async getSession(b,C,y,a={}){const m=M.$Em.toKey(b.identifier),c=[...y].sort().join(" ");return await this.d.getOrCreate(`${m} ${C} ${c}`,async()=>{await this.a.$ensureProvider(C);const i=b.displayName||b.name;return this.a.$getSession(C,y,m,i,a)})}async getSessions(b,C,y){const a=M.$Em.toKey(b.identifier),m=[...y].sort().join(" ");return await this.f.getOrCreate(`${a} ${m}`,async()=>{await this.a.$ensureProvider(C);const c=b.displayName||b.name;return this.a.$getSessions(C,y,a,c)})}async removeSession(b,C){const y=this.b.get(b);return y?y.provider.removeSession(C):this.a.$removeSession(b,C)}registerAuthenticationProvider(b,C,y,a){if(this.b.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this.b.set(b,{label:C,provider:y,options:a??{supportsMultipleAccounts:!1}});const m=y.onDidChangeSessions(c=>this.a.$sendDidChangeSessions(b,c));return this.a.$registerAuthenticationProvider(b,C,a?.supportsMultipleAccounts??!1),new I.$uM(()=>{m.dispose(),this.b.delete(b),this.a.$unregisterAuthenticationProvider(b)})}$createSession(b,C,y){const a=this.b.get(b);if(a)return Promise.resolve(a.provider.createSession(C,y));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,C){const y=this.b.get(b);if(y)return Promise.resolve(y.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,C){const y=this.b.get(b);if(y)return Promise.resolve(y.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,C){return b.startsWith(L.$uL)||this.c.fire({provider:{id:b,label:C}}),Promise.resolve()}};e.$Ljc=w,e.$Ljc=w=Qe([He(0,$.$OO)],w);class A{constructor(){this.a=new Map}getOrCreate(b,C){const y=this.a.get(b);if(y)return y;const a=C().finally(()=>this.a.delete(b));return this.a.set(b,a),a}}}),define(Ee[152],Ce([1,0,2,6,7,5,20,12,19,14,17,26]),function(re,e,o,R,I,M,L,p,$,w,A,P){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mkc=e.$Lkc=void 0;let C=b=class{constructor(a,m){this.h=m,this.f=new Map,this.g=a.getProxy(R.$sM.MainThreadDecorations)}registerFileDecorationProvider(a,m){const c=b.c++;this.f.set(c,{provider:a,extensionDescription:m}),this.g.$registerDecorationProvider(c,m.identifier.value);const i=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(c,null);return}const r=(0,$.$3b)(n);if(r.length<=b.d){this.g.$onDidChange(c,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,r.length);const s=r.map(d=>({uri:d,rank:(0,w.$1e)(d.path,"/")})),t=(0,$.$zb)(s,(d,u)=>d.rank-u.rank||(0,w.$ef)(d.uri.path,u.uri.path)),f=[];e:for(const d of t){let u;for(const h of d){const l=(0,A.$nc)(h.uri.path);if(u!==l&&(u=l,f.push(h.uri)>=b.d))break e}}this.g.$onDidChange(c,f)});return new I.$uM(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(c),this.f.delete(c)})}async $provideDecorations(a,m,c){if(!this.f.has(a))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:r}=this.f.get(a);return await Promise.all(m.map(async s=>{try{const{uri:t,id:f}=s,d=await Promise.resolve(n.provideFileDecoration(o.URI.revive(t),c));if(!d)return;try{I.$TN.validate(d),d.badge&&typeof d.badge!="string"&&(0,P.$dG)(r,"codiconDecoration"),i[f]=[d.propagate,d.tooltip,d.badge,d.color]}catch(u){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${u}`)}}catch(t){this.h.error(t)}})),i}};e.$Lkc=C,C.c=0,C.d=250,e.$Lkc=C=b=Qe([He(0,L.$OO),He(1,p.$Oj)],C),e.$Mkc=(0,M.$ii)("IExtHostDecorations")}),define(Ee[323],Ce([1,0,13,2,7,6,15,22,14]),function(re,e,o,R,I,M,L,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Okc=void 0;class w{constructor(P,b,C){this.d=b,this.e=C,this.b=new Map,this.c=P.getProxy(M.$sM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,b){if(Object.keys(L.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const C=w.a++;this.b.set(C,b),this.c.$registerTextContentProvider(C,P);let y;if(typeof b.onDidChange=="function"){let a;y=b.onDidChange(async m=>{if(m.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;a&&await a;const c=this.$provideTextDocumentContent(C,m).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(m);if(!n)return;const r=(0,$.$$e)(i);if(!n.equalLines(r))return this.c.$onVirtualDocumentChange(m,i)}).catch(o.$1).finally(()=>{a===c&&(a=void 0)});a=c})}return new I.$uM(()=>{this.b.delete(C)&&this.c.$unregisterTextContentProvider(C),y&&(y.dispose(),y=void 0)})}$provideTextDocumentContent(P,b){const C=this.b.get(P);return C?Promise.resolve(C.provideTextDocumentContent(R.URI.revive(b),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${b.scheme}`))}}e.$Okc=w,w.a=0}),define(Ee[153],Ce([1,0,61,15,14,191,133,7,19]),function(re,e,o,R,I,M,L,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SO=e.$RO=void 0,e.$QO=A;const w=new Map;function A(y,a){a?w.set(y,a):w.delete(y)}function P(y){return w.get(y)}class b extends M.$Iv{constructor(a,m,c,i,n,r,s){super(m,c,i,n),this.c=a,this.m=r,this.q=s,this.b=!1}dispose(){(0,o.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,$.$ub)(this.f,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.d},get fileName(){return a.d.fsPath},get isUntitled(){return a.d.scheme===R.Schemas.untitled},get languageId(){return a.m},get version(){return a.h},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(m){return m?a.s(m):a.getText()},get eol(){return a.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return a.f.length},lineAt(m){return a.t(m)},offsetAt(m){return a.u(m)},positionAt(m){return a.v(m)},validateRange(m){return a.w(m)},validatePosition(m){return a.x(m)},getWordRangeAtPosition(m,c){return a.y(m,c)}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,o.ok)(!this.b),this.m=a}_acceptIsDirty(a){(0,o.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(a){const m=this.w(a);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const c=this.g,i=m.start.line,n=m.end.line,r=[];r.push(this.f[i].substring(m.start.character));for(let s=i+1;s<n;s++)r.push(this.f[s]);return r.push(this.f[n].substring(0,m.end.character)),r.join(c)}t(a){let m;if(a instanceof p.$vM?m=a.line:typeof a=="number"&&(m=a),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new C(m,this.f[m],m===this.f.length-1)}u(a){return a=this.x(a),this.l(),this.j.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.l();const m=this.j.getIndexOf(a),c=this.f[m.index].length;return new p.$vM(m.index,Math.min(m.remainder,c))}w(a){if(!(a instanceof p.$wM))throw new Error("Invalid argument");const m=this.x(a.start),c=this.x(a.end);return m===a.start&&c===a.end?a:new p.$wM(m.line,m.character,c.line,c.character)}x(a){if(!(a instanceof p.$vM))throw new Error("Invalid argument");if(this.f.length===0)return a.with(0,0);let{line:m,character:c}=a,i=!1;if(m<0)m=0,c=0,i=!0;else if(m>=this.f.length)m=this.f.length-1,c=this.f[m].length,i=!0;else{const n=this.f[m].length;c<0?(c=0,i=!0):c>n&&(c=n,i=!0)}return i?new p.$vM(m,c):a}y(a,m){const c=this.x(a);if(!m)m=P(this.m);else if((0,I.$0e)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const i=(0,L.$Ss)(c.character+1,(0,L.$Qs)(m),this.f[c.line],0);if(i)return new p.$wM(c.line,i.startColumn-1,c.line,i.endColumn-1)}}e.$RO=b;class C{constructor(a,m,c){this.a=a,this.b=m,this.c=c}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$wM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$wM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$SO=C}),define(Ee[324],Ce([1,0,6,7]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qkc=void 0;class I{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(o.$sM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,p,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const w=this.a.get(L);if(!w)throw new Error("Embedding vector provider not found");const A=await w.provideEmbeddingVector(p,$);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(L,p,$){const w=this.b;return this.b++,this.a.set(w,$),this.c.$registerAiEmbeddingVectorProvider(p,w),new R.$uM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(w),this.a.delete(w)})}}e.$Qkc=I}),define(Ee[69],Ce([1,0,6,32,7,21,5,20,59,3,8,23,15]),function(re,e,o,R,I,M,L,p,$,w,A,P,b){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$5jc=e.$4jc=void 0;let y=C=class{constructor(m,c){this.b=new Map,this.c=new A.$rh,this.a=m.getProxy(o.$sM.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let r;const s=i.b.get(n.scheme);return s?(await i.a.$ensureActivation(n.scheme),r=await s.impl.stat(n)):r=await i.a.$stat(n),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===R.FilePermission.Readonly?1:void 0}}catch(r){C.e(r)}},async readDirectory(n){try{const r=i.b.get(n.scheme);return r?(await i.a.$ensureActivation(n.scheme),(await r.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(r){return C.e(r)}},async createDirectory(n){try{const r=i.b.get(n.scheme);return r&&!r.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(r.impl,r.extUri,n)):await i.a.$mkdir(n)}catch(r){return C.e(r)}},async readFile(n){try{const r=i.b.get(n.scheme);return r?(await i.a.$ensureActivation(n.scheme),(await r.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(r){return C.e(r)}},async writeFile(n,r){try{const s=i.b.get(n.scheme);return s&&!s.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(s.impl,s.extUri,s.extUri.dirname(n)),await i.c.queueFor(n,()=>Promise.resolve(s.impl.writeFile(n,r,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,M.$ue.wrap(r))}catch(s){return C.e(s)}},async delete(n,r){try{const s=i.b.get(n.scheme);return s&&!s.isReadonly&&!r?.useTrash?(await i.a.$ensureActivation(n.scheme),await s.impl.delete(n,{recursive:!1,...r})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(s){return C.e(s)}},async rename(n,r,s){try{return await i.a.$rename(n,r,{overwrite:!1,...s})}catch(t){return C.e(t)}},async copy(n,r,s){try{return await i.a.$copy(n,r,{overwrite:!1,...s})}catch(t){return C.e(t)}},isWritableFileSystem(n){const r=c.getCapabilities(n);if(typeof r=="number")return!(r&2048)}})}async d(m,c,i){const n=[];for(;!c.isEqual(i,c.dirname(i));)try{if(!((await m.stat(i)).type&R.FileType.Directory))throw I.$KN.FileExists(`Unable to create folder '${i.scheme===b.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(R.$5k(r)!==R.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(c.basename(i)),i=c.dirname(i)}for(let r=n.length-1;r>=0;r--){i=c.joinPath(i,n[r]);try{await m.createDirectory(i)}catch(s){if(R.$5k(s)!==R.FileSystemProviderErrorCode.FileExists)throw s}}}static e(m){if(m instanceof I.$KN)throw m;if(m instanceof R.$1k)switch(m.code){case R.FileSystemProviderErrorCode.FileExists:throw I.$KN.FileExists(m.message);case R.FileSystemProviderErrorCode.FileNotFound:throw I.$KN.FileNotFound(m.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw I.$KN.FileNotADirectory(m.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw I.$KN.FileIsADirectory(m.message);case R.FileSystemProviderErrorCode.NoPermissions:throw I.$KN.NoPermissions(m.message);case R.FileSystemProviderErrorCode.Unavailable:throw I.$KN.Unavailable(m.message);default:throw new I.$KN(m.message,m.name)}if(!(m instanceof Error))throw new I.$KN(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw I.$KN.Unavailable(m.message);switch(m.name){case R.FileSystemProviderErrorCode.FileExists:throw I.$KN.FileExists(m.message);case R.FileSystemProviderErrorCode.FileNotFound:throw I.$KN.FileNotFound(m.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw I.$KN.FileNotADirectory(m.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw I.$KN.FileIsADirectory(m.message);case R.FileSystemProviderErrorCode.NoPermissions:throw I.$KN.NoPermissions(m.message);case R.FileSystemProviderErrorCode.Unavailable:throw I.$KN.Unavailable(m.message);default:throw new I.$KN(m.message,m.name)}}addFileSystemProvider(m,c,i){return this.b.set(m,{impl:c,extUri:i?.isCaseSensitive?P.$Lg:P.$Ng,isReadonly:!!i?.isReadonly}),(0,w.$Sc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??P.$Lg}};e.$4jc=y,e.$4jc=y=C=Qe([He(0,p.$OO),He(1,$.$Ejc)],y),e.$5jc=(0,L.$ii)("IExtHostConsumerFileSystem")}),define(Ee[325],Ce([1,0,6,7]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8kc=void 0;class I{constructor(L){this.a=new Map,this.b=new Map,this.c=L.getProxy(o.$sM.MainThreadIssueReporter)}async $getIssueReporterUri(L,p){if(this.a.size===0)throw new Error("No issue request handlers registered");const $=this.a.get(L);if(!$)throw new Error("Issue request handler not found");const w=await $.handleIssueUrlRequest();if(!w)throw new Error("Issue request handler returned no result");return w}async $getIssueReporterData(L,p){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(L);if(!$)throw new Error("Issue data provider not found");const w=await $.provideIssueData(p);if(!w)throw new Error("Issue data provider returned no result");return w}async $getIssueReporterTemplate(L,p){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(L);if(!$)throw new Error("Issue data provider not found");const w=await $.provideIssueTemplate(p);if(!w)throw new Error("Issue template provider returned no result");return w}registerIssueUriRequestHandler(L,p){const $=L.identifier.value;return this.a.set($,p),this.c.$registerIssueUriRequestHandler($),new R.$uM(()=>{this.c.$unregisterIssueUriRequestHandler($),this.a.delete($)})}registerIssueDataProvider(L,p){const $=L.identifier.value;return this.b.set($,p),this.c.$registerIssueDataProvider($),new R.$uM(()=>{this.c.$unregisterIssueDataProvider($),this.b.delete($)})}}e.$8kc=I}),define(Ee[93],Ce([1,0,5,28,12,69,2]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7jc=e.$6jc=void 0,e.$6jc=(0,o.$ii)("IExtensionStoragePaths");let p=class{constructor(w,A,P){this.d=A,this.f=P,this.a=w.workspace??void 0,this.b=w.environment,this.whenReady=this.h().then(b=>this.c=b)}async g(w){return L.URI.joinPath(this.b.workspaceStorageHome,w)}async h(){if(!this.a)return Promise.resolve(void 0);const w=this.a.id,A=await this.g(w);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(L.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(w){if(this.c)return L.URI.joinPath(this.c,w.identifier.value)}globalValue(w){return L.URI.joinPath(this.b.globalStorageHome,w.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$7jc=p,e.$7jc=p=Qe([He(0,R.$5O),He(1,I.$Oj),He(2,M.$5jc)],p)}),define(Ee[326],Ce([1,0,7,20,4]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ylc=void 0;let M=class{constructor(p){this.a=new o.$UN(o.ColorThemeKind.Dark),this.b=new I.$7d}get activeColorTheme(){return this.a}$onColorThemeChange(p){let $;switch(p){case"light":$=o.ColorThemeKind.Light;break;case"hcDark":$=o.ColorThemeKind.HighContrast;break;case"hcLight":$=o.ColorThemeKind.HighContrastLight;break;default:$=o.ColorThemeKind.Dark}this.a=new o.$UN($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$ylc=M,e.$ylc=M=Qe([He(0,R.$OO)],M)}),define(Ee[70],Ce([1,0,22,4,3,229,5,12,88,6,28,20,7]),function(re,e,o,R,I,M,L,p,$,w,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mCb=e.$lCb=e.TunnelDtoConverter=void 0;class C extends $.$8v{}var y;(function(m){function c(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:n.protocol}}m.fromApiTunnel=c;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==$.TunnelPrivacyId.ConstantPrivate&&n.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}m.fromServiceTunnel=i})(y||(e.TunnelDtoConverter=y={})),e.$lCb=(0,L.$ii)("IExtHostTunnelService");let a=class extends I.$Uc{constructor(c,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new R.$7d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=c.getProxy(w.$sM.MainThreadTunnelService)}async openTunnel(c,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${c.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,c.displayName);if(n){const r=new C(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(c,i){c.portRange===void 0&&c.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:c,provider:i}),this.a.$registerPortsAttributesProvider(c,n),new b.$uM(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(c,i,n,r,s){const t=[];for(const d of c){const u=this.r.get(d);if(!u)return[];t.push(...await Promise.all(i.map(async h=>{let l;try{l=await u.provider.providePortAttributes({port:h,pid:n,commandLine:r},s)}catch{l=await u.provider.providePortAttributes(h,n,r,s)}return{providedAttributes:l,port:h}})))}const f=t.filter(d=>!!d.providedAttributes);return f.length>0?f.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(c){}registerTunnelProvider(c,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,s)=>await c.provideTunnel(r,s,o.CancellationToken.None)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,I.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(c,i){if(c){c.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(c.candidatePortSource),c.showCandidatePort&&(this.f=c.showCandidatePort,this.a.$setCandidateFilter());const n=c.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let r=c.tunnelFeatures?.privacyOptions??[];c.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const s=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,public:!!c.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(s)}}else this.b=void 0;return(0,I.$Sc)(()=>{this.b=void 0})}w(c){}async $closeTunnel(c,i){if(this.g.has(c.host)){const n=this.g.get(c.host);n.has(c.port)&&(i&&n.get(c.port).disposeListener.dispose(),await n.get(c.port).tunnel.dispose(),n.delete(c.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(c,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(c,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const r=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(c.remoteAddress.host)||this.g.set(c.remoteAddress.host,new Map);const s=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(c.remoteAddress.host).set(c.remoteAddress.port,{tunnel:r,disposeListener:s}),y.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(c){const i=await Promise.all(c.map(r=>this.f(r.host,r.port,r.detail??""))),n=c.filter((r,s)=>i[s]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${c.map(r=>r.port).join(", ")} to ${n.map(r=>r.port).join(", ")}`),n}};e.$mCb=a,e.$mCb=a=Qe([He(0,P.$OO),He(1,A.$5O),He(2,p.$Oj)],a)}),define(Ee[16],Ce([1,0,19,21,175,74,79,27,166,57,98,24,168,23,18,2,29,83,139,145,143,288,120,67,89,300,26,7]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i,n,r,s,t,f,d,u,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$LO=O,e.$MO=Q,e.$NO=Z;var g;(function(Oe){function Fe(ne){const{selectionStartLineNumber:Le,selectionStartColumn:Ge,positionLineNumber:_e,positionColumn:Ze}=ne,dt=new l.$vM(Le-1,Ge-1),St=new l.$vM(_e-1,Ze-1);return new l.$xM(dt,St)}Oe.to=Fe;function ke(ne){const{anchor:Le,active:Ge}=ne;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:Ge.line+1,positionColumn:Ge.character+1}}Oe.from=ke})(g||(e.Selection=g={}));var E;(function(Oe){function Fe(ne){if(!ne)return;const{start:Le,end:Ge}=ne;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:Ge.line+1,endColumn:Ge.character+1}}Oe.from=Fe;function ke(ne){if(!ne)return;const{startLineNumber:Le,startColumn:Ge,endLineNumber:_e,endColumn:Ze}=ne;return new l.$wM(Le-1,Ge-1,_e-1,Ze-1)}Oe.to=ke})(E||(e.Range=E={}));var v;(function(Oe){function Fe(ne){return{uri:ne.uri,range:E.from(ne.range)}}Oe.from=Fe;function ke(ne){return new l.$GM(a.URI.revive(ne.uri),E.to(ne.range))}Oe.to=ke})(v||(e.Location=v={}));var S;(function(Oe){function Fe(ke){switch(ke){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Oe.to=Fe})(S||(e.TokenType=S={}));var k;(function(Oe){function Fe(ne){return new l.$vM(ne.lineNumber-1,ne.column-1)}Oe.to=Fe;function ke(ne){return{lineNumber:ne.line+1,column:ne.character+1}}Oe.from=ke})(k||(e.Position=k={}));var D;(function(Oe){function Fe(Le,Ge,_e){return(0,o.$Hb)((0,o.$3b)(Le).map(Ze=>ke(Ze,Ge,_e)))}Oe.from=Fe;function ke(Le,Ge,_e){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:_e?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:ne(Le.scheme,Ge),pattern:De.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:_e?.isBuiltin}}function ne(Le,Ge){return Ge&&typeof Le=="string"?Ge.transformOutgoingScheme(Le):Le}})(D||(e.DocumentSelector=D={}));var F;(function(Oe){function Fe(ne){switch(ne){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Oe.from=Fe;function ke(ne){switch(ne){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Oe.to=ke})(F||(e.DiagnosticTag=F={}));var W;(function(Oe){function Fe(ne){let Le;return ne.code&&((0,y.$Vf)(ne.code)||(0,y.$Zf)(ne.code)?Le=String(ne.code):Le={value:String(ne.code.value),target:ne.code.target}),{...E.from(ne.range),message:ne.message,source:ne.source,code:Le,severity:j.from(ne.severity),relatedInformation:ne.relatedInformation&&ne.relatedInformation.map(B.from),tags:Array.isArray(ne.tags)?(0,o.$Hb)(ne.tags.map(F.from)):void 0}}Oe.from=Fe;function ke(ne){const Le=new l.$IM(E.to(ne),ne.message,j.to(ne.severity));return Le.source=ne.source,Le.code=(0,y.$Vf)(ne.code)?ne.code:ne.code?.value,Le.relatedInformation=ne.relatedInformation&&ne.relatedInformation.map(B.to),Le.tags=ne.tags&&(0,o.$Hb)(ne.tags.map(F.to)),Le}Oe.to=ke})(W||(e.Diagnostic=W={}));var B;(function(Oe){function Fe(ne){return{...E.from(ne.location.range),message:ne.message,resource:ne.location.uri}}Oe.from=Fe;function ke(ne){return new l.$HM(new l.$GM(ne.resource,E.to(ne)),ne.message)}Oe.to=ke})(B||(e.DiagnosticRelatedInformation=B={}));var j;(function(Oe){function Fe(ne){switch(ne){case l.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}Oe.from=Fe;function ke(ne){switch(ne){case i.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Oe.to=ke})(j||(e.DiagnosticSeverity=j={}));var N;(function(Oe){function Fe(ne){return typeof ne=="number"&&ne>=l.ViewColumn.One?ne-1:ne===l.ViewColumn.Beside?u.$HD:u.$GD}Oe.from=Fe;function ke(ne){if(typeof ne=="number"&&ne>=0)return ne+1;throw new Error("invalid 'EditorGroupColumn'")}Oe.to=ke})(N||(e.ViewColumn=N={}));function T(Oe){return typeof Oe.range<"u"}function O(Oe){return Oe.length===0?!0:!!T(Oe[0])}var z;(function(Oe){function Fe(Ze){return Ze.map(Oe.from)}Oe.fromMany=Fe;function ke(Ze){return Ze&&typeof Ze=="object"&&typeof Ze.language=="string"&&typeof Ze.value=="string"}function ne(Ze){let dt;if(ke(Ze)){const{language:Ot,value:qt}=Ze;dt={value:"```"+Ot+`
`+qt+"\n```\n"}}else l.$VM.isMarkdownString(Ze)?dt={value:Ze.value,isTrusted:Ze.isTrusted,supportThemeIcons:Ze.supportThemeIcons,supportHtml:Ze.supportHtml,baseUri:Ze.baseUri}:typeof Ze=="string"?dt={value:Ze}:dt={value:""};const St=Object.create(null);dt.uris=St;const Dt=Ot=>{try{let qt=a.URI.parse(Ot,!0);qt=qt.with({query:Le(qt.query,St)}),St[Ot]=qt}catch{}return""},an=new $.marked.Renderer;return an.link=Dt,an.image=Ot=>typeof Ot=="string"?Dt(L.$Nk(Ot).href):"",(0,$.marked)(dt.value,{renderer:an}),dt}Oe.from=ne;function Le(Ze,dt){if(!Ze)return Ze;let St;try{St=(0,w.$Qh)(Ze)}catch{}if(!St)return Ze;let Dt=!1;return St=(0,P.$Rn)(St,an=>{if(a.URI.isUri(an)){const Ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return dt[Ot]=an,Dt=!0,Ot}else return}),Dt?JSON.stringify(St):Ze}function Ge(Ze){const dt=new l.$VM(Ze.value,Ze.supportThemeIcons);return dt.isTrusted=Ze.isTrusted,dt.supportHtml=Ze.supportHtml,dt.baseUri=Ze.baseUri?a.URI.from(Ze.baseUri):void 0,dt}Oe.to=Ge;function _e(Ze){if(Ze)return typeof Ze=="string"?Ze:Oe.from(Ze)}Oe.fromStrict=_e})(z||(e.MarkdownString=z={}));function Q(Oe){return O(Oe)?Oe.map(Fe=>({range:E.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?z.fromMany(Fe.hoverMessage):Fe.hoverMessage?z.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Oe.map(Fe=>({range:E.from(Fe)}))}function Z(Oe){return typeof Oe>"u"?Oe:typeof Oe=="string"?a.URI.file(Oe):Oe}var J;(function(Oe){function Fe(ke){return typeof ke>"u"?ke:{contentText:ke.contentText,contentIconPath:ke.contentIconPath?Z(ke.contentIconPath):void 0,border:ke.border,borderColor:ke.borderColor,fontStyle:ke.fontStyle,fontWeight:ke.fontWeight,textDecoration:ke.textDecoration,color:ke.color,backgroundColor:ke.backgroundColor,margin:ke.margin,width:ke.width,height:ke.height}}Oe.from=Fe})(J||(e.ThemableDecorationAttachmentRenderOptions=J={}));var x;(function(Oe){function Fe(ke){return typeof ke>"u"?ke:{backgroundColor:ke.backgroundColor,outline:ke.outline,outlineColor:ke.outlineColor,outlineStyle:ke.outlineStyle,outlineWidth:ke.outlineWidth,border:ke.border,borderColor:ke.borderColor,borderRadius:ke.borderRadius,borderSpacing:ke.borderSpacing,borderStyle:ke.borderStyle,borderWidth:ke.borderWidth,fontStyle:ke.fontStyle,fontWeight:ke.fontWeight,textDecoration:ke.textDecoration,cursor:ke.cursor,color:ke.color,opacity:ke.opacity,letterSpacing:ke.letterSpacing,gutterIconPath:ke.gutterIconPath?Z(ke.gutterIconPath):void 0,gutterIconSize:ke.gutterIconSize,overviewRulerColor:ke.overviewRulerColor,before:ke.before?J.from(ke.before):void 0,after:ke.after?J.from(ke.after):void 0}}Oe.from=Fe})(x||(e.ThemableDecorationRenderOptions=x={}));var ce;(function(Oe){function Fe(ke){if(typeof ke>"u")return ke;switch(ke){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Oe.from=Fe})(ce||(e.DecorationRangeBehavior=ce={}));var te;(function(Oe){function Fe(ke){return{isWholeLine:ke.isWholeLine,rangeBehavior:ke.rangeBehavior?ce.from(ke.rangeBehavior):void 0,overviewRulerLane:ke.overviewRulerLane,light:ke.light?x.from(ke.light):void 0,dark:ke.dark?x.from(ke.dark):void 0,backgroundColor:ke.backgroundColor,outline:ke.outline,outlineColor:ke.outlineColor,outlineStyle:ke.outlineStyle,outlineWidth:ke.outlineWidth,border:ke.border,borderColor:ke.borderColor,borderRadius:ke.borderRadius,borderSpacing:ke.borderSpacing,borderStyle:ke.borderStyle,borderWidth:ke.borderWidth,fontStyle:ke.fontStyle,fontWeight:ke.fontWeight,textDecoration:ke.textDecoration,cursor:ke.cursor,color:ke.color,opacity:ke.opacity,letterSpacing:ke.letterSpacing,gutterIconPath:ke.gutterIconPath?Z(ke.gutterIconPath):void 0,gutterIconSize:ke.gutterIconSize,overviewRulerColor:ke.overviewRulerColor,before:ke.before?J.from(ke.before):void 0,after:ke.after?J.from(ke.after):void 0}}Oe.from=Fe})(te||(e.DecorationRenderOptions=te={}));var pe;(function(Oe){function Fe(ne){return{text:ne.newText,eol:ne.newEol&&We.from(ne.newEol),range:E.from(ne.range)}}Oe.from=Fe;function ke(ne){const Le=new l.$BM(E.to(ne.range),ne.text);return Le.newEol=typeof ne.eol>"u"?void 0:We.to(ne.eol),Le}Oe.to=ke})(pe||(e.TextEdit=pe={}));var ye;(function(Oe){function Fe(ne,Le){const Ge={edits:[]};if(ne instanceof l.$EM){const _e=new p.$Cc;for(const Ze of ne._allEntries())Ze._type===1&&a.URI.isUri(Ze.to)&&Ze.from===void 0&&_e.add(Ze.to);for(const Ze of ne._allEntries())if(Ze._type===1){let dt;Ze.options?.contents&&(ArrayBuffer.isView(Ze.options.contents)?dt={type:"base64",value:(0,R.$Oe)(R.$ue.wrap(Ze.options.contents))}:dt={type:"dataTransferItem",id:Ze.options.contents._itemId}),Ge.edits.push({oldResource:Ze.from,newResource:Ze.to,options:{...Ze.options,contents:dt},metadata:Ze.metadata})}else Ze._type===2?Ge.edits.push({resource:Ze.uri,textEdit:pe.from(Ze.edit),versionId:_e.has(Ze.uri)?void 0:Le?.getTextDocumentVersion(Ze.uri),metadata:Ze.metadata}):Ze._type===6?Ge.edits.push({resource:Ze.uri,textEdit:{range:E.from(Ze.range),text:Ze.edit.value,insertAsSnippet:!0},versionId:_e.has(Ze.uri)?void 0:Le?.getTextDocumentVersion(Ze.uri),metadata:Ze.metadata}):Ze._type===3?Ge.edits.push({metadata:Ze.metadata,resource:Ze.uri,cellEdit:Ze.edit,notebookMetadata:Ze.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(Ze.uri)}):Ze._type===5&&Ge.edits.push({metadata:Ze.metadata,resource:Ze.uri,notebookVersionId:Le?.getNotebookDocumentVersion(Ze.uri),cellEdit:{editType:1,index:Ze.index,count:Ze.count,cells:Ze.cells.map(Yt.from)}})}return Ge}Oe.from=Fe;function ke(ne){const Le=new l.$EM,Ge=new p.$Bc;for(const _e of ne.edits)if(_e.textEdit){const Ze=_e,dt=a.URI.revive(Ze.resource),St=E.to(Ze.textEdit.range),Dt=Ze.textEdit.text,an=Ze.textEdit.insertAsSnippet;let Ot;an?Ot=l.$DM.replace(St,new l.$FM(Dt)):Ot=l.$BM.replace(St,Dt);const qt=Ge.get(dt);qt?qt.push(Ot):Ge.set(dt,[Ot])}else Le.renameFile(a.URI.revive(_e.oldResource),a.URI.revive(_e.newResource),_e.options);for(const[_e,Ze]of Ge)Le.set(_e,Ze);return Le}Oe.to=ke})(ye||(e.WorkspaceEdit=ye={}));var _;(function(Oe){const Fe=Object.create(null);Fe[l.SymbolKind.File]=0,Fe[l.SymbolKind.Module]=1,Fe[l.SymbolKind.Namespace]=2,Fe[l.SymbolKind.Package]=3,Fe[l.SymbolKind.Class]=4,Fe[l.SymbolKind.Method]=5,Fe[l.SymbolKind.Property]=6,Fe[l.SymbolKind.Field]=7,Fe[l.SymbolKind.Constructor]=8,Fe[l.SymbolKind.Enum]=9,Fe[l.SymbolKind.Interface]=10,Fe[l.SymbolKind.Function]=11,Fe[l.SymbolKind.Variable]=12,Fe[l.SymbolKind.Constant]=13,Fe[l.SymbolKind.String]=14,Fe[l.SymbolKind.Number]=15,Fe[l.SymbolKind.Boolean]=16,Fe[l.SymbolKind.Array]=17,Fe[l.SymbolKind.Object]=18,Fe[l.SymbolKind.Key]=19,Fe[l.SymbolKind.Null]=20,Fe[l.SymbolKind.EnumMember]=21,Fe[l.SymbolKind.Struct]=22,Fe[l.SymbolKind.Event]=23,Fe[l.SymbolKind.Operator]=24,Fe[l.SymbolKind.TypeParameter]=25;function ke(Le){return typeof Fe[Le]=="number"?Fe[Le]:6}Oe.from=ke;function ne(Le){for(const Ge in Fe)if(Fe[Ge]===Le)return Number(Ge);return l.SymbolKind.Property}Oe.to=ne})(_||(e.SymbolKind=_={}));var U;(function(Oe){function Fe(ne){switch(ne){case l.SymbolTag.Deprecated:return 1}}Oe.from=Fe;function ke(ne){switch(ne){case 1:return l.SymbolTag.Deprecated}}Oe.to=ke})(U||(e.SymbolTag=U={}));var he;(function(Oe){function Fe(ne){return{name:ne.name,kind:_.from(ne.kind),tags:ne.tags&&ne.tags.map(U.from),containerName:ne.containerName,location:oe.from(ne.location)}}Oe.from=Fe;function ke(ne){const Le=new l.$MM(ne.name,_.to(ne.kind),ne.containerName,oe.to(ne.location));return Le.tags=ne.tags&&ne.tags.map(U.to),Le}Oe.to=ke})(he||(e.WorkspaceSymbol=he={}));var Se;(function(Oe){function Fe(ne){const Le={name:ne.name||"!!MISSING: name!!",detail:ne.detail,range:E.from(ne.range),selectionRange:E.from(ne.selectionRange),kind:_.from(ne.kind),tags:ne.tags?.map(U.from)??[]};return ne.children&&(Le.children=ne.children.map(Fe)),Le}Oe.from=Fe;function ke(ne){const Le=new l.$NM(ne.name,ne.detail,_.to(ne.kind),E.to(ne.range),E.to(ne.selectionRange));return(0,o.$Lb)(ne.tags)&&(Le.tags=ne.tags.map(U.to)),ne.children&&(Le.children=ne.children.map(ke)),Le}Oe.to=ke})(Se||(e.DocumentSymbol=Se={}));var me;(function(Oe){function Fe(ne){const Le=new l.$RM(_.to(ne.kind),ne.name,ne.detail||"",a.URI.revive(ne.uri),E.to(ne.range),E.to(ne.selectionRange));return Le._sessionId=ne._sessionId,Le._itemId=ne._itemId,Le}Oe.to=Fe;function ke(ne,Le,Ge){if(Le=Le??ne._sessionId,Ge=Ge??ne._itemId,Le===void 0||Ge===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ge,name:ne.name,detail:ne.detail,kind:_.from(ne.kind),uri:ne.uri,range:E.from(ne.range),selectionRange:E.from(ne.selectionRange),tags:ne.tags?.map(U.from)}}Oe.from=ke})(me||(e.CallHierarchyItem=me={}));var ie;(function(Oe){function Fe(ke){return new l.$SM(me.to(ke.from),ke.fromRanges.map(ne=>E.to(ne)))}Oe.to=Fe})(ie||(e.CallHierarchyIncomingCall=ie={}));var se;(function(Oe){function Fe(ke){return new l.$TM(me.to(ke.to),ke.fromRanges.map(ne=>E.to(ne)))}Oe.to=Fe})(se||(e.CallHierarchyOutgoingCall=se={}));var oe;(function(Oe){function Fe(ne){return{range:ne.range&&E.from(ne.range),uri:ne.uri}}Oe.from=Fe;function ke(ne){return new l.$GM(a.URI.revive(ne.uri),E.to(ne.range))}Oe.to=ke})(oe||(e.location=oe={}));var G;(function(Oe){function Fe(ne){const Le=ne,Ge=ne;return{originSelectionRange:Le.originSelectionRange?E.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:Ge.uri,range:E.from(Le.targetRange?Le.targetRange:Ge.range),targetSelectionRange:Le.targetSelectionRange?E.from(Le.targetSelectionRange):void 0}}Oe.from=Fe;function ke(ne){return{targetUri:a.URI.revive(ne.uri),targetRange:E.to(ne.range),targetSelectionRange:ne.targetSelectionRange?E.to(ne.targetSelectionRange):void 0,originSelectionRange:ne.originSelectionRange?E.to(ne.originSelectionRange):void 0}}Oe.to=ke})(G||(e.DefinitionLink=G={}));var ee;(function(Oe){function Fe(ne){return{range:E.from(ne.range),contents:z.fromMany(ne.contents)}}Oe.from=Fe;function ke(ne){return new l.$JM(ne.contents.map(z.to),E.to(ne.range))}Oe.to=ke})(ee||(e.Hover=ee={}));var le;(function(Oe){function Fe(ne){return{range:E.from(ne.range),expression:ne.expression}}Oe.from=Fe;function ke(ne){return new l.$EN(E.to(ne.range),ne.expression)}Oe.to=ke})(le||(e.EvaluatableExpression=le={}));var de;(function(Oe){function Fe(ne){if(ne instanceof l.$FN)return{type:"text",range:E.from(ne.range),text:ne.text};if(ne instanceof l.$GN)return{type:"variable",range:E.from(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};if(ne instanceof l.$HN)return{type:"expression",range:E.from(ne.range),expression:ne.expression};throw new Error("Unknown 'InlineValue' type")}Oe.from=Fe;function ke(ne){switch(ne.type){case"text":return{range:E.to(ne.range),text:ne.text};case"variable":return{range:E.to(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};case"expression":return{range:E.to(ne.range),expression:ne.expression}}}Oe.to=ke})(de||(e.InlineValue=de={}));var Me;(function(Oe){function Fe(ne){return{frameId:ne.frameId,stoppedLocation:E.from(ne.stoppedLocation)}}Oe.from=Fe;function ke(ne){return new l.$IN(ne.frameId,E.to(ne.stoppedLocation))}Oe.to=ke})(Me||(e.InlineValueContext=Me={}));var be;(function(Oe){function Fe(ne){return{range:E.from(ne.range),kind:ne.kind}}Oe.from=Fe;function ke(ne){return new l.$KM(E.to(ne.range),ne.kind)}Oe.to=ke})(be||(e.DocumentHighlight=be={}));var Pe;(function(Oe){function Fe(ne){return{uri:ne.uri,highlights:ne.highlights.map(be.from)}}Oe.from=Fe;function ke(ne){return new l.$LM(a.URI.revive(ne.uri),ne.highlights.map(be.to))}Oe.to=ke})(Pe||(e.MultiDocumentHighlight=Pe={}));var Re;(function(Oe){function Fe(ke){switch(ke){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Oe.to=Fe})(Re||(e.CompletionTriggerKind=Re={}));var ze;(function(Oe){function Fe(ke){return{triggerKind:Re.to(ke.triggerKind),triggerCharacter:ke.triggerCharacter}}Oe.to=Fe})(ze||(e.CompletionContext=ze={}));var V;(function(Oe){function Fe(ne){switch(ne){case l.CompletionItemTag.Deprecated:return 1}}Oe.from=Fe;function ke(ne){switch(ne){case 1:return l.CompletionItemTag.Deprecated}}Oe.to=ke})(V||(e.CompletionItemTag=V={}));var H;(function(Oe){const Fe=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function ke(Ge){return Fe.get(Ge)??9}Oe.from=ke;const ne=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Le(Ge){return ne.get(Ge)??l.CompletionItemKind.Property}Oe.to=Le})(H||(e.CompletionItemKind=H={}));var Y;(function(Oe){function Fe(ke,ne){const Le=new l.$2M(ke.label);return Le.insertText=ke.insertText,Le.kind=H.to(ke.kind),Le.tags=ke.tags?.map(V.to),Le.detail=ke.detail,Le.documentation=L.$Hk(ke.documentation)?z.to(ke.documentation):ke.documentation,Le.sortText=ke.sortText,Le.filterText=ke.filterText,Le.preselect=ke.preselect,Le.commitCharacters=ke.commitCharacters,m.$dt.isIRange(ke.range)?Le.range=E.to(ke.range):typeof ke.range=="object"&&(Le.range={inserting:E.to(ke.range.insert),replacing:E.to(ke.range.replace)}),Le.keepWhitespace=typeof ke.insertTextRules>"u"?!1:!!(ke.insertTextRules&1),typeof ke.insertTextRules<"u"&&ke.insertTextRules&4?Le.insertText=new l.$FM(ke.insertText):(Le.insertText=ke.insertText,Le.textEdit=Le.range instanceof l.$wM?new l.$BM(Le.range,Le.insertText):void 0),ke.additionalTextEdits&&ke.additionalTextEdits.length>0&&(Le.additionalTextEdits=ke.additionalTextEdits.map(Ge=>pe.to(Ge))),Le.command=ne&&ke.command?ne.fromInternal(ke.command):void 0,Le}Oe.to=Fe})(Y||(e.CompletionItem=Y={}));var X;(function(Oe){function Fe(ne){if(typeof ne.label!="string"&&!Array.isArray(ne.label))throw new TypeError("Invalid label");return{label:ne.label,documentation:z.fromStrict(ne.documentation)}}Oe.from=Fe;function ke(ne){return{label:ne.label,documentation:L.$Hk(ne.documentation)?z.to(ne.documentation):ne.documentation}}Oe.to=ke})(X||(e.ParameterInformation=X={}));var fe;(function(Oe){function Fe(ne){return{label:ne.label,documentation:z.fromStrict(ne.documentation),parameters:Array.isArray(ne.parameters)?ne.parameters.map(X.from):[],activeParameter:ne.activeParameter}}Oe.from=Fe;function ke(ne){return{label:ne.label,documentation:L.$Hk(ne.documentation)?z.to(ne.documentation):ne.documentation,parameters:Array.isArray(ne.parameters)?ne.parameters.map(X.to):[],activeParameter:ne.activeParameter}}Oe.to=ke})(fe||(e.SignatureInformation=fe={}));var we;(function(Oe){function Fe(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(fe.from):[]}}Oe.from=Fe;function ke(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(fe.to):[]}}Oe.to=ke})(we||(e.SignatureHelp=we={}));var Te;(function(Oe){function Fe(ke,ne){const Le=new l.$1M(k.to(ne.position),typeof ne.label=="string"?ne.label:ne.label.map(Ve.to.bind(void 0,ke)),ne.kind&&Ye.to(ne.kind));return Le.textEdits=ne.textEdits&&ne.textEdits.map(pe.to),Le.tooltip=L.$Hk(ne.tooltip)?z.to(ne.tooltip):ne.tooltip,Le.paddingLeft=ne.paddingLeft,Le.paddingRight=ne.paddingRight,Le}Oe.to=Fe})(Te||(e.InlayHint=Te={}));var Ve;(function(Oe){function Fe(ke,ne){const Le=new l.$ZM(ne.label);return Le.tooltip=L.$Hk(ne.tooltip)?z.to(ne.tooltip):ne.tooltip,c.Command.is(ne.command)&&(Le.command=ke.fromInternal(ne.command)),ne.location&&(Le.location=oe.to(ne.location)),Le}Oe.to=Fe})(Ve||(e.InlayHintLabelPart=Ve={}));var Ye;(function(Oe){function Fe(ne){return ne}Oe.from=Fe;function ke(ne){return ne}Oe.to=ke})(Ye||(e.InlayHintKind=Ye={}));var nt;(function(Oe){function Fe(ne){return{range:E.from(ne.range),url:ne.target,tooltip:ne.tooltip}}Oe.from=Fe;function ke(ne){let Le;if(ne.url)try{Le=typeof ne.url=="string"?a.URI.parse(ne.url,!0):a.URI.revive(ne.url)}catch{}return new l.$7M(E.to(ne.range),Le)}Oe.to=ke})(nt||(e.DocumentLink=nt={}));var ot;(function(Oe){function Fe(ne){const Le=new l.$0M(ne.label);return ne.textEdit&&(Le.textEdit=pe.to(ne.textEdit)),ne.additionalTextEdits&&(Le.additionalTextEdits=ne.additionalTextEdits.map(Ge=>pe.to(Ge))),Le}Oe.to=Fe;function ke(ne){return{label:ne.label,textEdit:ne.textEdit?pe.from(ne.textEdit):void 0,additionalTextEdits:ne.additionalTextEdits?ne.additionalTextEdits.map(Le=>pe.from(Le)):void 0}}Oe.from=ke})(ot||(e.ColorPresentation=ot={}));var lt;(function(Oe){function Fe(ne){return new l.$8M(ne[0],ne[1],ne[2],ne[3])}Oe.to=Fe;function ke(ne){return[ne.red,ne.green,ne.blue,ne.alpha]}Oe.from=ke})(lt||(e.Color=lt={}));var at;(function(Oe){function Fe(ne){return{range:E.from(ne.range)}}Oe.from=Fe;function ke(ne){return new l.$QM(E.to(ne.range))}Oe.to=ke})(at||(e.SelectionRange=at={}));var st;(function(Oe){function Fe(ke){switch(ke){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Oe.to=Fe})(st||(e.TextDocumentSaveReason=st={}));var Ie;(function(Oe){function Fe(ne){switch(ne){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.Interval:return 3;case l.TextEditorLineNumbersStyle.On:default:return 1}}Oe.from=Fe;function ke(ne){switch(ne){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 3:return l.TextEditorLineNumbersStyle.Interval;case 1:default:return l.TextEditorLineNumbersStyle.On}}Oe.to=ke})(Ie||(e.TextEditorLineNumbersStyle=Ie={}));var We;(function(Oe){function Fe(ne){if(ne===l.EndOfLine.CRLF)return 1;if(ne===l.EndOfLine.LF)return 0}Oe.from=Fe;function ke(ne){if(ne===1)return l.EndOfLine.CRLF;if(ne===0)return l.EndOfLine.LF}Oe.to=ke})(We||(e.EndOfLine=We={}));var Ae;(function(Oe){function Fe(ke){if(typeof ke=="object")return ke.viewId;switch(ke){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Oe.from=Fe})(Ae||(e.ProgressLocation=Ae={}));var Ke;(function(Oe){function Fe(ne){const Le={start:ne.start+1,end:ne.end+1};return ne.kind&&(Le.kind=ae.from(ne.kind)),Le}Oe.from=Fe;function ke(ne){const Le={start:ne.start-1,end:ne.end-1};return ne.kind&&(Le.kind=ae.to(ne.kind)),Le}Oe.to=ke})(Ke||(e.FoldingRange=Ke={}));var ae;(function(Oe){function Fe(ne){if(ne)switch(ne){case l.FoldingRangeKind.Comment:return c.$8t.Comment;case l.FoldingRangeKind.Imports:return c.$8t.Imports;case l.FoldingRangeKind.Region:return c.$8t.Region}}Oe.from=Fe;function ke(ne){if(ne)switch(ne.value){case c.$8t.Comment.value:return l.FoldingRangeKind.Comment;case c.$8t.Imports.value:return l.FoldingRangeKind.Imports;case c.$8t.Region.value:return l.FoldingRangeKind.Region}}Oe.to=ke})(ae||(e.FoldingRangeKind=ae={}));var ue;(function(Oe){function Fe(ke){if(ke)return{pinned:typeof ke.preview=="boolean"?!ke.preview:void 0,inactive:ke.background,preserveFocus:ke.preserveFocus,selection:typeof ke.selection=="object"?E.from(ke.selection):void 0,override:typeof ke.override=="boolean"?r.$0E.id:void 0}}Oe.from=Fe})(ue||(e.TextEditorOpenOptions=ue={}));var De;(function(Oe){function Fe(Ge){return Ge instanceof l.$sN?Ge.toJSON():typeof Ge=="string"?Ge:ke(Ge)||ne(Ge)?new l.$sN(Ge.baseUri??Ge.base,Ge.pattern).toJSON():Ge}Oe.from=Fe;function ke(Ge){const _e=Ge;return _e?a.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function ne(Ge){const _e=Ge;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Le(Ge){return typeof Ge=="string"?Ge:new l.$sN(a.URI.revive(Ge.baseUri),Ge.pattern)}Oe.to=Le})(De||(e.GlobPattern=De={}));var Je;(function(Oe){function Fe(ke){if(ke){if(Array.isArray(ke))return ke.map(Fe);if(typeof ke=="string")return ke;{const ne=ke;return{language:ne.language,scheme:ne.scheme,pattern:De.from(ne.pattern),exclusive:ne.exclusive,notebookType:ne.notebookType}}}else return}Oe.from=Fe})(Je||(e.LanguageSelector=Je={}));var et;(function(Oe){function Fe(ne){return!!ne&&typeof ne=="object"&&"documents"in ne&&Array.isArray(ne.documents)&&ne.documents.every(Le=>Array.isArray(Le)&&Le.every(Ge=>Ge&&typeof Ge=="object"&&"uri"in Ge&&a.URI.isUri(Ge.uri)&&"version"in Ge&&typeof Ge.version=="number"&&"ranges"in Ge&&Array.isArray(Ge.ranges)&&Ge.ranges.every(_e=>_e instanceof l.$wM)))}Oe.is=Fe;function ke(ne){return{documents:ne.documents.map(Le=>Le.map(Ge=>({uri:a.URI.from(Ge.uri),version:Ge.version,ranges:Ge.ranges.map(_e=>E.from(_e))})))}}Oe.from=ke})(et||(e.MappedEditsContext=et={}));var Ne;(function(Oe){function Fe(ne){return{start:ne.start,end:ne.end}}Oe.from=Fe;function ke(ne){return new l.$VN(ne.start,ne.end)}Oe.to=ke})(Ne||(e.NotebookRange=Ne={}));var ht;(function(Oe){function Fe(ne){return{timing:typeof ne.runStartTime=="number"&&typeof ne.runEndTime=="number"?{startTime:ne.runStartTime,endTime:ne.runEndTime}:void 0,executionOrder:ne.executionOrder,success:ne.lastRunSuccess}}Oe.to=Fe;function ke(ne){return{lastRunSuccess:ne.success,runStartTime:ne.timing?.startTime,runEndTime:ne.timing?.endTime,executionOrder:ne.executionOrder}}Oe.from=ke})(ht||(e.NotebookCellExecutionSummary=ht={}));var vt;(function(Oe){function Fe(ke){if(ke===t.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(ke===t.NotebookCellExecutionState.Pending)return;if(ke===t.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ke}`)}Oe.to=Fe})(vt||(e.NotebookCellExecutionState=vt={}));var Mt;(function(Oe){function Fe(ne){switch(ne){case l.NotebookCellKind.Markup:return t.CellKind.Markup;case l.NotebookCellKind.Code:default:return t.CellKind.Code}}Oe.from=Fe;function ke(ne){switch(ne){case t.CellKind.Markup:return l.NotebookCellKind.Markup;case t.CellKind.Code:default:return l.NotebookCellKind.Code}}Oe.to=ke})(Mt||(e.NotebookCellKind=Mt={}));var zt;(function(Oe){function Fe(ne){const Le={metadata:ne.metadata??Object.create(null),cells:[]};for(const Ge of ne.cells)l.$WN.validate(Ge),Le.cells.push(Yt.from(Ge));return Le}Oe.from=Fe;function ke(ne){const Le=new l.$XN(ne.cells.map(Yt.to));return(0,y.$9f)(ne.metadata)||(Le.metadata=ne.metadata),Le}Oe.to=ke})(zt||(e.NotebookData=zt={}));var Yt;(function(Oe){function Fe(ne){return{cellKind:Mt.from(ne.kind),language:ne.languageId,mime:ne.mime,source:ne.value,metadata:ne.metadata,internalMetadata:ht.from(ne.executionSummary??{}),outputs:ne.outputs?ne.outputs.map(Pt.from):[]}}Oe.from=Fe;function ke(ne){return new l.$WN(Mt.to(ne.cellKind),ne.source,ne.language,ne.mime,ne.outputs?ne.outputs.map(Pt.to):void 0,ne.metadata,ne.internalMetadata?ht.to(ne.internalMetadata):void 0)}Oe.to=ke})(Yt||(e.NotebookCellData=Yt={}));var xt;(function(Oe){function Fe(ne){return{mime:ne.mime,valueBytes:R.$ue.wrap(ne.data)}}Oe.from=Fe;function ke(ne){return new l.$YN(ne.valueBytes.buffer,ne.mime)}Oe.to=ke})(xt||(e.NotebookCellOutputItem=xt={}));var Pt;(function(Oe){function Fe(ne){return{outputId:ne.id,items:ne.items.map(xt.from),metadata:ne.metadata}}Oe.from=Fe;function ke(ne){const Le=ne.items.map(xt.to);return new l.$ZN(Le,ne.outputId,ne.metadata)}Oe.to=ke})(Pt||(e.NotebookCellOutput=Pt={}));var sn;(function(Oe){function Fe(Le){return ne(Le)?{include:De.from(Le.include)??void 0,exclude:De.from(Le.exclude)??void 0}:De.from(Le)??void 0}Oe.from=Fe;function ke(Le){return ne(Le)?{include:De.to(Le.include),exclude:De.to(Le.exclude)}:De.to(Le)}Oe.to=ke;function ne(Le){const Ge=Le;return Ge?!(0,y.$5f)(Ge.include)&&!(0,y.$5f)(Ge.exclude):!1}})(sn||(e.NotebookExclusiveDocumentPattern=sn={}));var _t;(function(Oe){function Fe(ke,ne,Le){const Ge=typeof ke.command=="string"?{title:"",command:ke.command}:ke.command;return{alignment:ke.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:ne.toInternal(Ge,Le),text:ke.text,tooltip:ke.tooltip,accessibilityInformation:ke.accessibilityInformation,priority:ke.priority}}Oe.from=Fe})(_t||(e.NotebookStatusBarItem=_t={}));var dn;(function(Oe){function Fe(ke,ne,Le){const Ge=typeof ke.command=="string"?{title:"",command:ke.command}:ke.command;return{command:ne.toInternal(Ge,Le),label:ke.label,description:ke.description,detail:ke.detail,documentation:ke.documentation}}Oe.from=Fe})(dn||(e.NotebookKernelSourceAction=dn={}));var tt;(function(Oe){function Fe(ke){return{transientOutputs:ke?.transientOutputs??!1,transientCellMetadata:ke?.transientCellMetadata??{},transientDocumentMetadata:ke?.transientDocumentMetadata??{},cellContentMetadata:ke?.cellContentMetadata??{}}}Oe.from=Fe})(tt||(e.NotebookDocumentContentOptions=tt={}));var on;(function(Oe){function Fe(ne){return{uri:ne.uri,provides:ne.provides}}Oe.from=Fe;function ke(ne){return new l.$2N(a.URI.revive(ne.uri),ne.provides)}Oe.to=ke})(on||(e.NotebookRendererScript=on={}));var Gt;(function(Oe){function Fe(ne){return{message:z.fromStrict(ne.message)||"",type:0,expected:ne.expectedOutput,actual:ne.actualOutput,contextValue:ne.contextValue,location:ne.location&&{range:E.from(ne.location.range),uri:ne.location.uri}}}Oe.from=Fe;function ke(ne){const Le=new l.$8N(typeof ne.message=="string"?ne.message:z.to(ne.message));return Le.actualOutput=ne.actual,Le.expectedOutput=ne.expected,Le.contextValue=ne.contextValue,Le.location=ne.location?oe.to(ne.location):void 0,Le}Oe.to=ke})(Gt||(e.TestMessage=Gt={}));var Kt;(function(Oe){Oe.namespace=d.$jL,Oe.denamespace=d.$kL})(Kt||(e.TestTag=Kt={}));var gt;(function(Oe){function Fe(ne){const Le=(0,n.$KO)(ne).controllerId;return{extId:f.$eL.fromExtHostTestItem(ne,Le).toString(),label:ne.label,uri:a.URI.revive(ne.uri),busy:ne.busy,tags:ne.tags.map(Ge=>Kt.namespace(Le,Ge.id)),range:m.$dt.lift(E.from(ne.range)),description:ne.description||null,sortText:ne.sortText||null,error:ne.error&&z.fromStrict(ne.error)||null}}Oe.from=Fe;function ke(ne){return{parent:void 0,error:void 0,id:f.$eL.fromString(ne.extId).localId,label:ne.label,uri:a.URI.revive(ne.uri),tags:(ne.tags||[]).map(Le=>{const{tagId:Ge}=Kt.denamespace(Le);return new l.$9N(Ge)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:E.to(ne.range||void 0),canResolveChildren:!1,busy:ne.busy,description:ne.description||void 0,sortText:ne.sortText||void 0}}Oe.toPlain=ke})(gt||(e.TestItem=gt={})),function(Oe){function Fe(ne){return{id:ne.id}}Oe.from=Fe;function ke(ne){return new l.$9N(ne.id)}Oe.to=ke}(Kt||(e.TestTag=Kt={}));var bt;(function(Oe){const Fe=(ne,Le)=>{const Ge=ne.value;if(!Ge)return;const _e={...gt.toPlain(Ge.item),parent:Le,taskStates:Ge.tasks.map(Ze=>({state:Ze.state,duration:Ze.duration,messages:Ze.messages.filter(dt=>dt.type===0).map(Gt.to)})),children:[]};if(ne.children)for(const Ze of ne.children.values()){const dt=Fe(Ze,_e);dt&&_e.children.push(dt)}return _e};function ke(ne){const Le=new b.$DO;for(const Ze of ne.items)Le.insert(f.$eL.fromString(Ze.item.extId).path,Ze);const Ge=[Le.nodes],_e=[];for(;Ge.length;)for(const Ze of Ge.pop())Ze.value?_e.push(Ze):Ze.children&&Ge.push(Ze.children.values());return{completedAt:ne.completedAt,results:_e.map(Ze=>Fe(Ze)).filter(y.$4f)}}Oe.to=ke})(bt||(e.TestResults=bt={}));var Xt;(function(Oe){function Fe(Ge){return{covered:Ge.covered,total:Ge.total}}function ke(Ge){return"line"in Ge?k.from(Ge):E.from(Ge)}function ne(Ge){if(typeof Ge.executed=="number"&&Ge.executed<0)throw new Error(`Invalid coverage count ${Ge.executed}`);return"branches"in Ge?{count:Ge.executed,location:ke(Ge.location),type:1,branches:Ge.branches.length?Ge.branches.map(_e=>({count:_e.executed,location:_e.location&&ke(_e.location),label:_e.label})):void 0}:{type:0,name:Ge.name,count:Ge.executed,location:ke(Ge.location)}}Oe.fromDetails=ne;function Le(Ge,_e){return l.$$N(_e.statementCoverage),l.$$N(_e.branchCoverage),l.$$N(_e.declarationCoverage),{id:Ge,uri:_e.uri,statement:Fe(_e.statementCoverage),branch:_e.branchCoverage&&Fe(_e.branchCoverage),declaration:_e.declarationCoverage&&Fe(_e.declarationCoverage)}}Oe.fromFile=Le})(Xt||(e.TestCoverage=Xt={}));var Bt;(function(Oe){function Fe(ke){switch(ke){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Oe.to=Fe})(Bt||(e.CodeActionTriggerKind=Bt={}));var Vt;(function(Oe){function Fe(ne){const Le=new l.$dO(_.to(ne.kind),ne.name,ne.detail||"",a.URI.revive(ne.uri),E.to(ne.range),E.to(ne.selectionRange));return Le._sessionId=ne._sessionId,Le._itemId=ne._itemId,Le}Oe.to=Fe;function ke(ne,Le,Ge){if(Le=Le??ne._sessionId,Ge=Ge??ne._itemId,Le===void 0||Ge===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ge,kind:_.from(ne.kind),name:ne.name,detail:ne.detail??"",uri:ne.uri,range:E.from(ne.range),selectionRange:E.from(ne.selectionRange),tags:ne.tags?.map(U.from)}}Oe.from=ke})(Vt||(e.TypeHierarchyItem=Vt={}));var $t;(function(Oe){function Fe(ke){if(ke)return{value:ke.value,tooltip:ke.tooltip}}Oe.from=Fe})($t||(e.ViewBadge=$t={}));var Rt;(function(Oe){function Fe(Ge,_e,Ze){const dt=_e.fileData;return dt?new l.$kN(new l.$lN(dt.name,a.URI.revive(dt.uri),dt.id,(0,M.$db)(()=>Ze(dt.id)))):Ge===A.$As.uriList&&_e.uriListData?new l.$jN(Le(_e.uriListData)):new l.$jN(_e.asString)}Oe.to=Fe;async function ke(Ge,_e){const Ze=await _e.asString();if(Ge===A.$As.uriList)return{asString:Ze,fileData:void 0,uriListData:ne(Ze)};const dt=_e.asFile();return{asString:Ze,fileData:dt?{name:dt.name,uri:dt.uri,id:dt._itemId??dt.id}:void 0}}Oe.from=ke;function ne(Ge){return I.$Mt.split(Ge).map(_e=>{if(_e.startsWith("#"))return _e;try{return a.URI.parse(_e)}catch{}return _e})}function Le(Ge){return I.$Mt.create(Ge.map(_e=>typeof _e=="string"?_e:a.URI.revive(_e)))}})(Rt||(e.DataTransferItem=Rt={}));var cn;(function(Oe){function Fe(ne,Le){const Ge=ne.items.map(([_e,Ze])=>[_e,Rt.to(_e,Ze,Le)]);return new l.$mN(Ge)}Oe.toDataTransfer=Fe;async function ke(ne){const Le={items:[]},Ge=[];for(const[_e,Ze]of ne)Ge.push((async()=>{Le.items.push([_e,await Rt.from(_e,Ze)])})());return await Promise.all(Ge),Le}Oe.from=ke})(cn||(e.DataTransfer=cn={}));var en;(function(Oe){function Fe(ne,Le){return{kind:"reply",agentId:ne.participant??Le?.agentId??"",subCommand:ne.command??Le?.command,message:ne.prompt,title:ne.label}}Oe.from=Fe;function ke(ne){return{prompt:ne.message,label:ne.title,participant:ne.agentId,command:ne.subCommand}}Oe.to=ke})(en||(e.ChatFollowup=en={}));var Xe;(function(Oe){function Fe(ke){return"commandId"in ke?{kind:"command",title:ke.title??"",commandId:ke.commandId??"",when:ke.when??"",args:ke.args}:{kind:"reply",message:ke.message,title:ke.title,tooltip:ke.tooltip}}Oe.from=Fe})(Xe||(e.ChatInlineFollowup=Xe={}));var Zt;(function(Oe){function Fe(ne){switch(ne.role){case 0:return new l.$yO(ne.content);case 1:return new l.$zO(ne.content);case 2:return new l.$AO(ne.content)}}Oe.to=Fe;function ke(ne){if(ne instanceof l.$yO)return{role:0,content:ne.content};if(ne instanceof l.$zO)return{role:1,content:ne.content};if(ne instanceof l.$AO)return{role:2,content:ne.content};throw new Error("Invalid LanguageModelMessage")}Oe.from=ke})(Zt||(e.LanguageModelMessage=Zt={}));var tn;(function(Oe){function Fe(Le){const Ge={};for(const _e of Object.keys(Le))Ge[_e]=Le[_e].map(Oe.to);return Ge}Oe.objectTo=Fe;function ke(Le){return{level:nn.to(Le.level),kind:Le.kind,value:(0,a.$wc)(Le.value)?a.URI.revive(Le.value):Le.value,description:Le.description}}Oe.to=ke;function ne(Le){return{level:nn.from(Le.level),kind:Le.kind,value:Le.value,description:Le.description}}Oe.from=ne})(tn||(e.ChatVariable=tn={}));var nn;(function(Oe){function Fe(ne){switch(ne){case"short":return l.ChatVariableLevel.Short;case"medium":return l.ChatVariableLevel.Medium;case"full":default:return l.ChatVariableLevel.Full}}Oe.to=Fe;function ke(ne){switch(ne){case l.ChatVariableLevel.Short:return"short";case l.ChatVariableLevel.Medium:return"medium";case l.ChatVariableLevel.Full:default:return"full"}}Oe.from=ke})(nn||(e.ChatVariableLevel=nn={}));var yt;(function(Oe){function Fe(ke){switch(ke){case 1:return l.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return l.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return l.InteractiveEditorResponseFeedbackKind.Undone;case 3:return l.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return l.InteractiveEditorResponseFeedbackKind.Bug}}Oe.to=Fe})(yt||(e.InteractiveEditorResponseFeedbackKind=yt={}));var Ut;(function(Oe){function Fe(ne){return{kind:"markdownContent",content:z.from(ne.value)}}Oe.to=Fe;function ke(ne){return new l.$qO(z.to(ne.content))}Oe.from=ke})(Ut||(e.ChatResponseMarkdownPart=Ut={}));var Tt;(function(Oe){function Fe(ne){const{value:Le,baseUri:Ge}=ne;function _e(Ze,dt){return Ze.map(St=>{const Dt=a.URI.joinPath(dt,St.name);return{label:St.name,uri:Dt,children:St.children&&_e(St.children,Dt)}})}return{kind:"treeData",treeData:{label:(0,C.$Sg)(Ge),uri:Ge,children:_e(Le,Ge)}}}Oe.to=Fe;function ke(ne){const Le=(0,w.$Rh)(ne.treeData);function Ge(dt){return dt.map(St=>({name:St.label,children:St.children&&Ge(St.children)}))}const _e=Le.uri,Ze=Le.children?Ge(Le.children):[];return new l.$rO(Ze,_e)}Oe.from=ke})(Tt||(e.ChatResponseFilesPart=Tt={}));var Lt;(function(Oe){function Fe(ne){return{kind:"inlineReference",name:ne.title,inlineReference:a.URI.isUri(ne.value)?ne.value:v.from(ne.value)}}Oe.to=Fe;function ke(ne){const Le=(0,w.$Rh)(ne);return new l.$sO(a.URI.isUri(Le.inlineReference)?Le.inlineReference:v.to(Le.inlineReference),ne.name)}Oe.from=ke})(Lt||(e.ChatResponseAnchorPart=Lt={}));var un;(function(Oe){function Fe(ne){return{kind:"progressMessage",content:z.from(ne.value)}}Oe.to=Fe;function ke(ne){return new l.$tO(ne.content.value)}Oe.from=ke})(un||(e.ChatResponseProgressPart=un={}));var Wt;(function(Oe){function Fe(ne,Le,Ge){return{kind:"command",command:Le.toInternal(ne.value,Ge)??{command:ne.value.command,title:ne.value.title}}}Oe.to=Fe;function ke(ne,Le){return new l.$uO(Le.fromInternal(ne.command)??{command:ne.command.id,title:ne.command.title})}Oe.from=ke})(Wt||(e.ChatResponseCommandButtonPart=Wt={}));var Ht;(function(Oe){function Fe(ne){return"variableName"in ne.value?{kind:"reference",reference:{variableName:ne.value.variableName,value:a.URI.isUri(ne.value.value)||!ne.value.value?ne.value.value:v.from(ne.value.value)}}:{kind:"reference",reference:a.URI.isUri(ne.value)?ne.value:v.from(ne.value)}}Oe.to=Fe;function ke(ne){const Le=(0,w.$Rh)(ne),Ge=_e=>a.URI.isUri(_e)?_e:v.to(_e);return new l.$vO("variableName"in Le.reference?{variableName:Le.reference.variableName,value:Le.reference.value&&Ge(Le.reference.value)}:Ge(Le.reference))}Oe.from=ke})(Ht||(e.ChatResponseReferencePart=Ht={}));var It;(function(Oe){function Fe(Le,Ge,_e){return Le instanceof l.$qO?Ut.to(Le):Le instanceof l.$sO?Lt.to(Le):Le instanceof l.$vO?Ht.to(Le):Le instanceof l.$tO?un.to(Le):Le instanceof l.$rO?Tt.to(Le):Le instanceof l.$uO?Wt.to(Le,Ge,_e):{kind:"content",content:""}}Oe.to=Fe;function ke(Le,Ge){switch(Le.kind){case"reference":return Ht.from(Le);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ne(Le,Ge)}}Oe.from=ke;function ne(Le,Ge){switch(Le.kind){case"markdownContent":return Ut.from(Le);case"inlineReference":return Lt.from(Le);case"progressMessage":return;case"treeData":return Tt.from(Le);case"command":return Wt.from(Le,Ge)}}Oe.fromContent=ne})(It||(e.ChatResponsePart=It={}));var Ft;(function(Oe){function Fe(ne,Le){return"markdownContent"in Le?((0,h.$dG)(ne,"chatParticipantAdditions"),{content:z.from(Le.markdownContent),kind:"markdownContent"}):"content"in Le?"vulnerabilities"in Le&&Le.vulnerabilities?((0,h.$dG)(ne,"chatParticipantAdditions"),{content:Le.content,vulnerabilities:Le.vulnerabilities,kind:"vulnerability"}):typeof Le.content=="string"?{content:Le.content,kind:"content"}:((0,h.$dG)(ne,"chatParticipantAdditions"),{content:z.from(Le.content),kind:"markdownContent"}):"documents"in Le?{documents:Le.documents.map(Ge=>({uri:Ge.uri,version:Ge.version,ranges:Ge.ranges.map(_e=>E.from(_e))})),kind:"usedContext"}:"reference"in Le?{reference:"uri"in Le.reference?{uri:Le.reference.uri,range:E.from(Le.reference.range)}:Le.reference,kind:"reference"}:"inlineReference"in Le?{inlineReference:"uri"in Le.inlineReference?{uri:Le.inlineReference.uri,range:E.from(Le.inlineReference.range)}:Le.inlineReference,name:Le.title,kind:"inlineReference"}:"participant"in Le?((0,h.$dG)(ne,"chatParticipantAdditions"),{agentId:Le.participant,command:Le.command,kind:"agentDetection"}):"message"in Le?{content:z.from(Le.message),kind:"progressMessage"}:void 0}Oe.from=Fe;function ke(ne,Le){switch(ne.kind){case"markdownContent":return{content:ne.content.value};case"inlineReference":return{inlineReference:(0,a.$wc)(ne.inlineReference)?a.URI.revive(ne.inlineReference):v.to(ne.inlineReference),title:ne.name};case"command":return{command:Le.fromInternal(ne.command)??{command:ne.command.id,title:ne.command.title}};default:return}}Oe.toProgressContent=ke})(Ft||(e.ChatResponseProgress=Ft={}));var rn;(function(Oe){function Fe(ke){return{prompt:ke.message,command:ke.command,variables:ke.variables.variables.map(Et.to),location:At.to(ke.location)}}Oe.to=Fe})(rn||(e.ChatAgentRequest=rn={}));var At;(function(Oe){function Fe(ke){switch(ke){case s.ChatAgentLocation.Notebook:return l.ChatLocation.Notebook;case s.ChatAgentLocation.Terminal:return l.ChatLocation.Terminal;case s.ChatAgentLocation.Panel:return l.ChatLocation.Panel;case s.ChatAgentLocation.Editor:return l.ChatLocation.Editor}}Oe.to=Fe})(At||(e.ChatLocation=At={}));var Et;(function(Oe){function Fe(ke){return{name:ke.name,range:ke.range&&[ke.range.start,ke.range.endExclusive],values:ke.values.map(tn.to)}}Oe.to=Fe})(Et||(e.ChatAgentResolvedVariable=Et={}));var Nt;(function(Oe){function Fe(ke){return{label:ke.label,values:ke.values.map(tn.from),insertText:ke.insertText,detail:ke.detail,documentation:ke.documentation}}Oe.from=Fe})(Nt||(e.ChatAgentCompletionItem=Nt={}));var fn;(function(Oe){function Fe(ke){return{errorDetails:ke.errorDetails,metadata:ke.metadata}}Oe.to=Fe})(fn||(e.ChatAgentResult=fn={}));var Ct;(function(Oe){function Fe(ke,ne,Le){if(ne.action.kind==="vote")return;const Ge=fn.to(ke);return ne.action.kind==="command"?{action:{kind:"command",commandButton:Ft.toProgressContent(ne.action.commandButton,Le)},result:Ge}:ne.action.kind==="followUp"?{action:{kind:"followUp",followup:en.to(ne.action.followup)},result:Ge}:{action:ne.action,result:Ge}}Oe.to=Fe})(Ct||(e.ChatAgentUserActionEvent=Ct={}));var ln;(function(Oe){function Fe(ke,ne,Le){return"terminalCommand"in ke?{terminalCommand:ke.terminalCommand,shouldExecute:ke.shouldExecute}:"uri"in ke?{uri:ke.uri}:ne.toInternal(ke,Le)}Oe.from=Fe})(ln||(e.TerminalQuickFix=ln={}));var Jt;(function(Oe){function Fe(ke){return{kind:En.to(ke.kind)}}Oe.to=Fe})(Jt||(e.PartialAcceptInfo=Jt={}));var En;(function(Oe){function Fe(ke){switch(ke){case 0:return l.PartialAcceptTriggerKind.Word;case 1:return l.PartialAcceptTriggerKind.Line;case 2:return l.PartialAcceptTriggerKind.Suggest;default:return l.PartialAcceptTriggerKind.Unknown}}Oe.to=Fe})(En||(e.PartialAcceptTriggerKind=En={}));var wn;(function(Oe){function Fe(ke,ne){return{id:ne,label:ke.label,description:ke.description,canEdit:ke.canEdit,collapsibleState:ke.collapsibleState||0,contextValue:ke.contextValue}}Oe.from=Fe})(wn||(e.DebugTreeItem=wn={}))}),define(Ee[327],Ce([1,0,6,20,16]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mjc=void 0;let M=class{constructor(p,$){this.a=p.getProxy(o.$sM.MainThreadBulkEdits),this.b={getTextDocumentVersion:w=>$.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,$,w){const A=I.WorkspaceEdit.from(p,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,w?.isRefactoring??!1)}};e.$Mjc=M,e.$Mjc=M=Qe([He(0,R.$OO)],M)}),define(Ee[328],Ce([1,0,19,8,47,4,39,3,40,18,2,218,25,6,16,7,289,26]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ojc=void 0;class i{constructor(t,f,d,u,h,l){this.i=t,this.j=f,this.k=d,this.l=u,this.m=h,this.n=l,this.b=$.$3d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let f=function(u){if(t.c){const h=new Error("Response stream has been closed");throw Error.captureStackTrace(h,u),h}};const t=this;this.b.reset();const d=u=>{typeof this.d>"u"&&"content"in u&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,u)};this.g={markdown(u){f(this.markdown);const h=new a.$qO(u),l=y.ChatResponseMarkdownPart.to(h);return d(l),this},filetree(u,h){f(this.filetree);const l=new a.$rO(u,h),g=y.ChatResponseFilesPart.to(l);return d(g),this},anchor(u,h){f(this.anchor);const l=new a.$sO(u,h),g=y.ChatResponseAnchorPart.to(l);return d(g),this},button(u){f(this.anchor);const h=new a.$uO(u),l=y.ChatResponseCommandButtonPart.to(h,t.m,t.n);return d(l),this},progress(u){f(this.progress);const h=new a.$tO(u),l=y.ChatResponseProgressPart.to(h);return d(l),this},reference(u){if(f(this.reference),"variableName"in u&&!u.value){const h=t.j.variables.variables.find(l=>l.name===u.variableName);if(h){let l;if(h.references?.length)l=h.references.map(g=>({kind:"reference",reference:{variableName:u.variableName,value:g.reference}}));else{const g=new a.$vO(u);l=[y.ChatResponseReferencePart.to(g)]}return l.forEach(g=>d(g)),this}}else{const h=new a.$vO(u),l=y.ChatResponseReferencePart.to(h);d(l)}return this},push(u){if(f(this.push),u instanceof a.$vO)this.reference(u.value);else{const h=y.ChatResponsePart.to(u,t.m,t.n);d(h)}return this},report(u){if(f(this.report),"placeholder"in u&&"resolvedContent"in u)return;const h=y.ChatResponseProgress.from(t.i,u);if(!h){t.l.error("Unknown progress type: "+JSON.stringify(u));return}return d(h),this}}}return this.g}}class n{constructor(t,f,d){this.i=f,this.j=d,this.c=new Map,this.g=new p.$4c,this.d=t.getProxy(C.$sM.MainThreadChatAgents2)}createChatAgent(t,f,d){const u=n.b++,h=new r(t,f,this.d,u,d);return this.c.set(u,h),this.d.$registerAgent(u,t.identifier,f,{},void 0),h.apiAgent}createDynamicChatAgent(t,f,d,u,h){const l=n.b++,g=new r(t,f,this.d,l,h);return this.c.set(l,g),this.d.$registerAgent(l,t.identifier,f,{},{name:d,description:u}),g.apiAgent}async $invokeAgent(t,f,d,u){const h=this.c.get(t);if(!h)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let l=this.g.get(f.sessionId);l||(l=new p.$Tc,this.g.set(f.sessionId,l));const g=new i(h.extension,f,this.d,this.i,this.j.converter,l);try{const E=await this.k(f.agentId,d),v=h.invoke(y.ChatAgentRequest.to(f),{history:E},g.apiObject,u);return await(0,R.$9g)(Promise.resolve(v).then(S=>{if(S?.metadata)try{JSON.stringify(S.metadata)}catch(k){const D=`result.metadata MUST be JSON.stringify-able. Got error: ${k.message}`;return this.i.error(`[${h.extension.identifier.value}] [@${h.id}] ${D}`,h.extension),{errorDetails:{message:D},timings:g.timings}}return{errorDetails:S?.errorDetails,timings:g.timings,metadata:S?.metadata}}),u)}catch(E){return this.i.error(E,h.extension),{errorDetails:{message:(0,P.localize)(0,null,(0,I.$6i)(E)),responseIsIncomplete:!0}}}finally{g.close()}}async k(t,f){const d=[];for(const u of f.history){const h=y.ChatAgentResult.to(u.result),l=t===u.request.agentId?h:{...h,metadata:void 0};d.push(new a.$wO(u.request.message,u.request.command,u.request.variables.variables.map(y.ChatAgentResolvedVariable.to),u.request.agentId));const g=(0,o.$Hb)(u.response.map(E=>y.ChatResponsePart.fromContent(E,this.j.converter)));d.push(new a.$xO(g,l,u.request.agentId,u.request.command))}return d}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,f,d,u,h){const l=this.c.get(f);if(!l)return Promise.resolve([]);const g=await this.k(l.id,u),E=y.ChatAgentResult.to(d);return(await l.provideFollowups(E,{history:g},h)).filter(v=>{const S=!v.participant||L.Iterable.some(this.c.values(),k=>k.id===v.participant&&b.$Em.equals(k.extension.identifier,l.extension.identifier));return S||this.i.warn(`[@${l.id}] ChatFollowup refers to an unknown participant: ${v.participant}`),S}).map(v=>y.ChatFollowup.from(v,t))}$acceptFeedback(t,f,d,u){const h=this.c.get(t);if(!h)return;const l=y.ChatAgentResult.to(f);let g;switch(d){case m.InteractiveSessionVoteDirection.Down:g=a.ChatResultFeedbackKind.Unhelpful;break;case m.InteractiveSessionVoteDirection.Up:g=a.ChatResultFeedbackKind.Helpful;break}h.acceptFeedback(Object.freeze(u?{result:l,kind:g,reportIssue:u}:{result:l,kind:g}))}$acceptAction(t,f,d){const u=this.c.get(t);if(!u||d.action.kind==="vote")return;const h=y.ChatAgentUserActionEvent.to(f,d,this.j.converter);h&&u.acceptAction(Object.freeze(h))}async $invokeCompletionProvider(t,f,d){const u=this.c.get(t);return u?(await u.invokeCompletionProvider(f,d)).map(y.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,f){const d=this.c.get(t);if(d)return await d.provideWelcomeMessage(f)}async $provideSampleQuestions(t,f){const d=this.c.get(t);if(d)return(await d.provideSampleQuestions(f)).map(u=>y.ChatFollowup.from(u,void 0))}}e.$Ojc=n,n.b=0;class r{constructor(t,f,d,u,h){this.extension=t,this.id=f,this.u=d,this.w=u,this.x=h,this.n=new M.$7d,this.o=new M.$7d}acceptFeedback(t){this.n.fire(t)}acceptAction(t){this.o.fire(t)}async invokeCompletionProvider(t,f){return this.q?await this.q.provider.provideCompletionItems(t,f)??[]:[]}async provideFollowups(t,f,d){if(!this.b)return[];const u=await this.b.provideFollowups(t,f,d);return u?u.filter(h=>!(h&&"commandId"in h)).filter(h=>!(h&&"message"in h)):[]}async provideWelcomeMessage(t){if(!this.s)return[];const f=await this.s.provideWelcomeMessage(t);return f?f.map(d=>typeof d=="string"?d:y.MarkdownString.from(d)):[]}async provideSampleQuestions(t){if(!this.s||!this.s.provideSampleQuestions)return[];const f=await this.s.provideSampleQuestions(t);return f||[]}get apiAgent(){let t=!1,f=!1;const d=()=>{t||f||(f=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof A.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof a.$qN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.i||typeof this.i=="string"?this.i:y.MarkdownString.from(this.i),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:y.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:y.MarkdownString.from(this.k),sampleRequest:this.l,supportIssueReporting:this.p,requester:this.t}),f=!1}))},u=this;return{get id(){return u.id},get fullName(){return(0,c.$dG)(u.extension,"defaultChatParticipant"),u.c??u.extension.displayName??u.extension.name},set fullName(h){(0,c.$dG)(u.extension,"defaultChatParticipant"),u.c=h,d()},get iconPath(){return u.d},set iconPath(h){u.d=h,d()},get requestHandler(){return u.x},set requestHandler(h){(0,w.$6f)(typeof h=="function","Invalid request handler"),u.x=h},get followupProvider(){return u.b},set followupProvider(h){u.b=h,d()},get isDefault(){return(0,c.$dG)(u.extension,"defaultChatParticipant"),u.g},set isDefault(h){(0,c.$dG)(u.extension,"defaultChatParticipant"),u.g=h,d()},get helpTextPrefix(){return(0,c.$dG)(u.extension,"defaultChatParticipant"),u.i},set helpTextPrefix(h){(0,c.$dG)(u.extension,"defaultChatParticipant"),u.i=h,d()},get helpTextVariablesPrefix(){return(0,c.$dG)(u.extension,"defaultChatParticipant"),u.j},set helpTextVariablesPrefix(h){(0,c.$dG)(u.extension,"defaultChatParticipant"),u.j=h,d()},get helpTextPostfix(){return(0,c.$dG)(u.extension,"defaultChatParticipant"),u.k},set helpTextPostfix(h){(0,c.$dG)(u.extension,"defaultChatParticipant"),u.k=h,d()},get isSecondary(){return(0,c.$dG)(u.extension,"defaultChatParticipant"),u.m},set isSecondary(h){(0,c.$dG)(u.extension,"defaultChatParticipant"),u.m=h,d()},get sampleRequest(){return u.l},set sampleRequest(h){u.l=h,d()},get supportIssueReporting(){return(0,c.$dG)(u.extension,"chatParticipantAdditions"),u.p},set supportIssueReporting(h){(0,c.$dG)(u.extension,"chatParticipantAdditions"),u.p=h,d()},get onDidReceiveFeedback(){return u.n.event},set participantVariableProvider(h){if((0,c.$dG)(u.extension,"chatParticipantAdditions"),u.q=h,h){if(!h.triggerCharacters.length)throw new Error("triggerCharacters are required");u.u.$registerAgentCompletionsProvider(u.w,h.triggerCharacters)}else u.u.$unregisterAgentCompletionsProvider(u.w)},get participantVariableProvider(){return(0,c.$dG)(u.extension,"chatParticipantAdditions"),u.q},set welcomeMessageProvider(h){(0,c.$dG)(u.extension,"defaultChatParticipant"),u.s=h,d()},get welcomeMessageProvider(){return(0,c.$dG)(u.extension,"defaultChatParticipant"),u.s},onDidPerformAction:(0,c.$cG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(h){u.t=h,d()},get requester(){return u.t},dispose(){t=!0,u.b=void 0,u.n.dispose(),u.u.$unregisterAgent(u.w)}}}invoke(t,f,d,u){return this.x(t,f,d,u)}}}),define(Ee[329],Ce([1,0,13,3,6,16,7,26]),function(re,e,o,R,I,M,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rjc=void 0;class ${constructor(P){this.b=new Map,this.c=P.getProxy(I.$sM.MainThreadChatVariables)}async $resolveVariable(P,b,C,y){const a=this.b.get(P);if(a)try{if(a.resolver.resolve2){(0,p.$dG)(a.extension,"chatParticipantAdditions");const m=new w(b,this.c),c=await a.resolver.resolve2(a.data.name,{prompt:C},m.apiObject,y);if(c)return c.map(M.ChatVariable.from)}else{const m=await a.resolver.resolve(a.data.name,{prompt:C},y);if(m)return m.map(M.ChatVariable.from)}}catch(m){(0,o.$2)(m)}}registerVariableResolver(P,b,C,y){const a=$.a++;return this.b.set(a,{extension:P,data:{name:b,description:C},resolver:y}),this.c.$registerVariable(a,{name:b,description:C}),(0,R.$Sc)(()=>{this.b.delete(a),this.c.$unregisterVariable(a)})}}e.$Rjc=$,$.a=0;class w{constructor(P,b){this.c=P,this.d=b,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let b=function(y){if(P.a){const a=new Error("Response stream has been closed");throw Error.captureStackTrace(a,y),a}};const P=this,C=y=>{this.d.$handleProgressChunk(this.c,y)};this.b={progress(y){b(this.progress);const a=new L.$tO(y),m=M.ChatResponseProgressPart.to(a);return C(m),this},reference(y){b(this.reference);const a=new L.$vO(y),m=M.ChatResponseReferencePart.to(a);return C(m),this},push(y){return b(this.push),y instanceof L.$vO?C(M.ChatResponseReferencePart.to(y)):y instanceof L.$tO&&C(M.ChatResponseProgressPart.to(y)),this}}}return this.b}}}),define(Ee[330],Ce([1,0,8,54,4,3,2,83,25,16,7,6,26]),function(re,e,o,R,I,M,L,p,$,w,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vjc=C;function C(y,a,m){const c=y.getProxy(P.$sM.MainThreadComments);class i{constructor(){this.b=new Map,this.c=new $.$Gm,a.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===6){const E=this.b.get(g.handle);return E?E.value:g}else if(g&&g.$mid===7){const E=g,v=this.b.get(E.commentControlHandle);if(!v)return E;const S=v.getCommentThread(E.commentThreadHandle);return S?S.value:E}else if(g&&(g.$mid===9||g.$mid===8)){const E=this.b.get(g.thread.commentControlHandle);if(!E)return g;const v=E.getCommentThread(g.thread.commentThreadHandle);return v?g.$mid===8?v.value:{thread:v.value,text:g.text}:g}else if(g&&g.$mid===10){const E=this.b.get(g.thread.commentControlHandle);if(!E)return g;const v=E.getCommentThread(g.thread.commentThreadHandle);if(!v)return g;const S=g.commentUniqueId,k=v.getCommentByUniqueId(S);return k||g}else if(g&&g.$mid===11){const E=this.b.get(g.thread.commentControlHandle);if(!E)return g;const v=E.getCommentThread(g.thread.commentThreadHandle);if(!v)return g;const S=g.text,k=g.commentUniqueId,D=v.getCommentByUniqueId(k);return D?(typeof D.body=="string"?D.body=S:D.body=new A.$VM(S),D):g}return g}})}createCommentController(g,E,v){const S=i.a++,k=new r(g,S,E,v);this.b.set(k.handle,k);const D=this.c.get(g.identifier)||[];return D.push(k),this.c.set(g.identifier,D),k.value}async $createCommentThreadTemplate(g,E,v){const S=this.b.get(g);S&&S.$createCommentThreadTemplate(E,v)}async $setActiveComment(g,E){const v=this.b.get(g);v&&v.$setActiveComment(E??void 0)}async $updateCommentThreadTemplate(g,E,v){const S=this.b.get(g);S&&S.$updateCommentThreadTemplate(E,v)}$deleteCommentThread(g,E){this.b.get(g)?.$deleteCommentThread(E)}async $provideCommentingRanges(g,E,v){const S=this.b.get(g);if(!S||!S.commentingRangeProvider)return Promise.resolve(void 0);const k=await m.ensureDocumentData(L.URI.revive(E));return(0,o.$ah)(async()=>{const D=await S.commentingRangeProvider.provideCommentingRanges(k.document,v);let F;return Array.isArray(D)?F={ranges:D,fileComments:!1}:D?F={ranges:D.ranges||[],fileComments:D.fileComments||!1}:F=D??void 0,F}).then(D=>{let F;return D&&(F={ranges:D.ranges.map(W=>w.Range.from(W)),fileComments:D.fileComments}),F})}$toggleReaction(g,E,v,S,k){const D=this.b.get(g);return!D||!D.reactionHandler?Promise.resolve(void 0):(0,o.$ah)(()=>{const F=D.getCommentThread(E);if(F){const W=F.getCommentByUniqueId(S.uniqueIdInThread);if(D!==void 0&&W&&D.reactionHandler)return D.reactionHandler(W,f(k))}return Promise.resolve(void 0)})}}i.a=0;class n{set threadId(g){this.n=g}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(g){(g===void 0!=(this.p===void 0)||!g||!this.p||!g.isEqual(this.p))&&(this.p=g,this.b.range=g,this.c.fire())}get range(){return this.p}set canReply(g){this.d!==g&&(this.d=g,this.b.canReply=g,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(g){this.e=g,this.b.label=g,this.c.fire()}get contextValue(){return this.f}set contextValue(g){this.f=g,this.b.contextValue=g,this.c.fire()}get comments(){return this.q}set comments(g){this.q=g,this.b.comments=g,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(g){this.g=g,this.b.collapsibleState=g,this.c.fire()}get state(){return this.h}set state(g){this.h=g,typeof g=="object"?((0,b.$dG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=g.resolved,this.b.applicability=g.applicability):this.b.state=g,this.c.fire()}get isDisposed(){return this.j}constructor(g,E,v,S,k,D,F,W){this.m=E,this.n=v,this.o=S,this.p=k,this.q=D,this.extensionDescription=F,this.r=W,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$7d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Vc,this.l.value=new M.$Tc,this.n===void 0&&(this.n=`${g}.${this.handle}`),c.$createCommentThread(E,this.handle,this.n,this.o,w.Range.from(this.p),F.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=D,this.i.push({dispose:()=>{c.$deleteCommentThread(E,this.handle)}});const B=this;this.value={get uri(){return B.uri},get range(){return B.range},set range(j){B.range=j},get comments(){return B.comments},set comments(j){B.comments=j},get collapsibleState(){return B.collapsibleState},set collapsibleState(j){B.collapsibleState=j},get canReply(){return B.canReply},set canReply(j){B.canReply=j},get contextValue(){return B.contextValue},set contextValue(j){B.contextValue=j},get label(){return B.label},set label(j){B.label=j},get state(){return B.state},set state(j){B.state=j},dispose:()=>{B.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Tc);const g=v=>Object.prototype.hasOwnProperty.call(this.b,v),E={};g("range")&&(E.range=w.Range.from(this.p)),g("label")&&(E.label=this.label),g("contextValue")&&(E.contextValue=this.contextValue??null),g("comments")&&(E.comments=this.q.map(v=>s(this,v,this.k,this.extensionDescription))),g("collapsibleState")&&(E.collapseState=d(this.g)),g("canReply")&&(E.canReply=this.canReply),g("state")&&(E.state=u(this.h)),g("applicability")&&(E.applicability=h(this.h)),g("isTemplate")&&(E.isTemplate=this.r),this.b={},c.$updateCommentThread(this.m,this.handle,this.n,this.o,E)}getCommentByUniqueId(g){for(const E of this.k){const v=E[0],S=E[1];if(g===S)return v}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(g=>g.dispose())}}n.a=0,Qe([(0,R.$Nh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(g){this.b=g,g?.resourceHints&&(0,b.$dG)(this.h,"commentingRangeHint"),c.$updateCommentingRanges(this.handle,g?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(g){this.c=g,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!g})}get options(){return this.d}set options(g){this.d=g,c.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,b.$dG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,b.$dG)(this.h,"activeComment"),this.f}constructor(g,E,v,S){this.h=g,this.i=E,this.j=v,this.k=S,this.a=new Map,c.$registerCommentController(this.handle,v,S,this.h.identifier.value);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(D){k.options=D},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(D){k.commentingRangeProvider=D},get reactionHandler(){return k.reactionHandler},set reactionHandler(D){k.reactionHandler=D},get activeCommentThread(){return k.activeCommentThread},createCommentThread(D,F,W){return k.createCommentThread(D,F,W).value},dispose:()=>{k.dispose()}}),this.g=[],this.g.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}createCommentThread(g,E,v){E===void 0&&(0,b.$dG)(this.h,"fileComments");const S=new n(this.id,this.handle,void 0,g,E,v,this.h,!1);return this.a.set(S.handle,S),S}$setActiveComment(g){if(!g){this.e=void 0,this.f=void 0;return}const E=this.a.get(g.commentThreadHandle);E&&(this.e=g.uniqueIdInThread?E.getCommentByUniqueId(g.uniqueIdInThread):void 0,this.f=E)}$createCommentThreadTemplate(g,E){const v=new n(this.id,this.handle,void 0,L.URI.revive(g),w.Range.to(E),[],this.h,!0);return v.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(v.handle,v),v}$updateCommentThreadTemplate(g,E){const v=this.a.get(g);v&&(v.range=w.Range.to(E))}$deleteCommentThread(g){this.a.get(g)?.dispose(),this.a.delete(g)}getCommentThread(g){return this.a.get(g)}dispose(){this.a.forEach(g=>{g.dispose()}),this.g.forEach(g=>g.dispose())}}function s(l,g,E,v){let S=E.get(g);return S||(S=++l.commentHandle,E.set(g,S)),g.state!==void 0&&(0,b.$dG)(v,"commentsDraftState"),g.reactions?.some(k=>k.reactors!==void 0)&&(0,b.$dG)(v,"commentReactor"),{mode:g.mode,contextValue:g.contextValue,uniqueIdInThread:S,body:typeof g.body=="string"?g.body:w.MarkdownString.from(g.body),userName:g.author.name,userIconPath:g.author.iconPath,label:g.label,commentReactions:g.reactions?g.reactions.map(k=>t(k)):void 0,state:g.state,timestamp:g.timestamp?.toJSON()}}function t(l){return{label:l.label,iconPath:l.iconPath?w.$NO(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted,reactors:l.reactors&&l.reactors.length>0&&typeof l.reactors[0]!="string"?l.reactors.map(g=>g.name):l.reactors}}function f(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?L.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1,reactors:l.reactors?.map(g=>({name:g}))}}function d(l){if(l!==void 0)switch(l){case A.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function u(l){let g;if(typeof l=="object"?g=l.resolved:g=l,g!==void 0)switch(g){case A.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function h(l){let g;if(typeof l=="object"&&(g=l.applicability),g!==void 0)switch(g){case A.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case A.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new i}}),define(Ee[331],Ce([1,0,22,55,3,15,23,2,16,92,111,6,7]),function(re,e,o,R,I,M,L,p,$,w,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bkc=void 0;class C{constructor(f,d){this.document=f,this.b=d,this.a=1,this.c=new A.$yjc("custom documents")}addEdit(f){return this.c.add([f])}async undo(f,d){await this.f(f).undo(),d||this.disposeBackup()}async redo(f,d){await this.f(f).redo(),d||this.disposeBackup()}disposeEdits(f){for(const d of f)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const f=s(this.document.uri)+this.a++;return(0,L.$Vg)(this.b,f)}updateBackup(f){this.d?.delete(),this.d=f}disposeBackup(){this.d?.delete(),this.d=void 0}f(f){const d=this.c.get(f,0);if(!d)throw new Error("No edit found");return d}}class y{constructor(){this.a=new Map}get(f,d){return this.a.get(this.b(f,d))}add(f,d,u){const h=this.b(f,d.uri);if(this.a.has(h))throw new Error(`Document already exists for viewType:${f} resource:${d.uri}`);const l=new C(d,u);return this.a.set(h,l),l}delete(f,d){const u=this.b(f,d.uri);this.a.delete(u)}b(f,d){return`${f}@@@${d}`}}var a;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(a||(a={}));class m{constructor(){this.a=new Map}addTextProvider(f,d,u){return this.b(0,f,d,u)}addCustomProvider(f,d,u){return this.b(1,f,d,u)}get(f){return this.a.get(f)}b(f,d,u,h){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:f,extension:u,provider:h}),new b.$uM(()=>this.a.delete(d))}}class c{constructor(f,d,u,h,l){this.d=d,this.f=u,this.g=h,this.h=l,this.b=new m,this.c=new y,this.a=f.getProxy(P.$sM.MainThreadCustomEditors)}registerCustomEditorProvider(f,d,u,h){const l=new I.$Tc;return n(u)?(l.add(this.b.addTextProvider(d,f,u)),this.a.$registerTextEditorProvider((0,w.$$jc)(f),d,h.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,w.$9jc)(f))):(l.add(this.b.addCustomProvider(d,f,u)),i(u)&&l.add(u.onDidChangeCustomDocument(g=>{const E=this.i(d,g.document.uri);if(r(g)){const v=E.addEdit(g);this.a.$onDidEdit(g.document.uri,d,v,g.label)}else this.a.$onContentChange(g.document.uri,d)})),this.a.$registerCustomEditorProvider((0,w.$$jc)(f),d,h.webviewOptions||{},!!h.supportsMultipleEditorsPerDocument,(0,w.$9jc)(f))),b.$uM.from(l,new b.$uM(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(f,d,u,h,l){const g=this.b.get(d);if(!g)throw new Error(`No provider found for '${d}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${d}'`);const E=p.URI.revive(f),v=await g.provider.openCustomDocument(E,{backupId:u,untitledDocumentData:h?.buffer},l);let S;return i(g.provider)&&this.f&&(S=this.f.workspaceValue(g.extension)??this.f.globalValue(g.extension)),this.c.add(d,v,S),{editable:i(g.provider)}}async $disposeCustomDocument(f,d){const u=this.b.get(d);if(!u)throw new Error(`No provider found for '${d}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${d}'`);const h=p.URI.revive(f),{document:l}=this.i(d,h);this.c.delete(d,l),l.dispose()}async $resolveCustomEditor(f,d,u,h,l,g){const E=this.b.get(u);if(!E)throw new Error(`No provider found for '${u}'`);const v=$.ViewColumn.to(l),S=this.g.createNewWebview(d,h.contentOptions,E.extension),k=this.h.createNewWebviewPanel(d,u,h.title,v,h.options,S,h.active),D=p.URI.revive(f);switch(E.type){case 1:{const{document:F}=this.i(u,D);return E.provider.resolveCustomEditor(F,k,g)}case 0:{const F=this.d.getDocument(D);return E.provider.resolveCustomTextEditor(F,k,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(f,d,u){this.i(d,f).disposeEdits(u)}async $onMoveCustomEditor(f,d,u){const h=this.b.get(u);if(!h)throw new Error(`No provider found for '${u}'`);if(!h.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const l=this.h.getWebviewPanel(f);if(!l)throw new Error("No webview found");const g=p.URI.revive(d),E=this.d.getDocument(g);await h.provider.moveCustomTextEditor(E,l,o.CancellationToken.None)}async $undo(f,d,u,h){return this.i(d,f).undo(u,h)}async $redo(f,d,u,h){return this.i(d,f).redo(u,h)}async $revert(f,d,u){const h=this.i(d,f);await this.j(d).revertCustomDocument(h.document,u),h.disposeBackup()}async $onSave(f,d,u){const h=this.i(d,f);await this.j(d).saveCustomDocument(h.document,u),h.disposeBackup()}async $onSaveAs(f,d,u,h){const l=this.i(d,f);return this.j(d).saveCustomDocumentAs(l.document,p.URI.revive(u),h)}async $backup(f,d,u){const h=this.i(d,f),g=await this.j(d).backupCustomDocument(h.document,{destination:h.getNewBackupUri()},u);return h.updateBackup(g),g.id}i(f,d){const u=this.c.get(f,p.URI.revive(d));if(!u)throw new Error("No custom document found");return u}j(f){const u=this.b.get(f)?.provider;if(!u||!i(u))throw new Error("Custom document is not editable");return u}}e.$bkc=c;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function s(t){const f=t.scheme===M.Schemas.file||t.scheme===M.Schemas.untitled?t.fsPath:t.toString();return(0,R.$9i)(f)+""}});var it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o},qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Ee[332],Ce([1,0,219,139,2,6,7,16,4,12,27,59]),function(re,e,o,R,I,M,L,p,$,w,A,P){"use strict";var b,C,y,a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gjc=e.$Fjc=void 0;class m{constructor(n,r,s,t,f,d,u,h){this.d=n,this.e=r,this.f=s,this.g=t,this.h=f,b.set(this,void 0),C.set(this,void 0),y.set(this,void 0),this.c=!1,this.f=Math.max(t,s),it(this,y,new A.$Bc(l=>d.getComparisonKey(l)),"f"),it(this,b,u,"f"),it(this,C,h,"f")}dispose(){this.c||(qe(this,C,"f").fire([...qe(this,y,"f").keys()]),qe(this,b,"f")?.$clear(this.e),qe(this,y,"f").clear(),this.c=!0)}get name(){return this.j(),this.d}set(n,r){if(!n){this.clear();return}this.j();let s=[];if(I.URI.isUri(n)){if(!r){this.delete(n);return}qe(this,y,"f").set(n,r.slice()),s=[n]}else if(Array.isArray(n)){s=[];let d;n=[...n].sort(m.k);for(const u of n){const[h,l]=u;if((!d||h.toString()!==d.toString())&&(d&&qe(this,y,"f").get(d).length===0&&qe(this,y,"f").delete(d),d=h,s.push(h),qe(this,y,"f").set(h,[])),l)qe(this,y,"f").get(h)?.push(...l);else{const g=qe(this,y,"f").get(h);g&&(g.length=0)}}}if(qe(this,C,"f").fire(s),!qe(this,b,"f"))return;const t=[];let f=0;for(const d of s){let u=[];const h=qe(this,y,"f").get(d);if(h)if(h.length>this.g){u=[];const l=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let g=0;g<4;g++)for(const E of h)if(E.severity===l[g]&&u.push({...p.Diagnostic.from(E),modelVersionId:this.h(d)})===this.g)break e;u.push({severity:R.MarkerSeverity.Info,message:(0,o.localize)(0,null,h.length-this.g),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=h.map(l=>({...p.Diagnostic.from(l),modelVersionId:this.h(d)}));if(t.push([d,u]),f+=u.length,f>this.f)break}qe(this,b,"f").$changeMany(this.e,t)}delete(n){this.j(),qe(this,C,"f").fire([n]),qe(this,y,"f").delete(n),qe(this,b,"f")?.$changeMany(this.e,[[n,void 0]])}clear(){this.j(),qe(this,C,"f").fire([...qe(this,y,"f").keys()]),qe(this,y,"f").clear(),qe(this,b,"f")?.$clear(this.e)}forEach(n,r){this.j();for(const[s,t]of this)n.call(r,s,t,this)}*[(b=new WeakMap,C=new WeakMap,y=new WeakMap,Symbol.iterator)](){this.j();for(const n of qe(this,y,"f").keys())yield[n,this.get(n)]}get(n){this.j();const r=qe(this,y,"f").get(n);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(n){return this.j(),Array.isArray(qe(this,y,"f").get(n))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(n,r){return n[0].toString()<r[0].toString()?-1:n[0].toString()>r[0].toString()?1:0}}e.$Fjc=m;let c=a=class{static _mapper(n){const r=new A.$Bc;for(const s of n)r.set(s,s);return{uris:Object.freeze(Array.from(r.values()))}}constructor(n,r,s,t){this.j=r,this.k=s,this.l=t,this.g=new Map,this.h=new $.$$d({merge:f=>f.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,a._mapper),this.f=n.getProxy(M.$sM.MainThreadDiagnostics)}createDiagnosticCollection(n,r){const{g:s,f:t,h:f,j:d,k:u,l:h}=this,l=new class{$changeMany(v,S){t.$changeMany(v,S),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",n.value,v,S.length===0?"CLEARING":S)}$clear(v){t.$clear(v),d.trace("[DiagnosticCollection] remove all (extension, owner)",n.value,v)}dispose(){t.dispose()}};let g;if(!r)r="_generated_diagnostic_collection_name_#"+a.c++,g=r;else if(!s.has(r))g=r;else{this.j.warn(`DiagnosticCollection with name '${r}' does already exist.`);do g=r+a.c++;while(s.has(g))}return new class extends m{constructor(){super(r,g,a.e,a.d,v=>h.getDocument(v)?.version,u.extUri,l,f),s.set(g,this)}dispose(){super.dispose(),s.delete(g)}}}getDiagnostics(n){if(n)return this.m(n);{const r=new Map,s=[];for(const t of this.g.values())t.forEach((f,d)=>{let u=r.get(f.toString());typeof u>"u"&&(u=s.length,r.set(f.toString(),u),s.push([f,[]])),s[u][1]=s[u][1].concat(...d)});return s}}m(n){let r=[];for(const s of this.g.values())s.has(n)&&(r=r.concat(s.get(n)));return r}$acceptMarkersChange(n){if(!this.n){const r="_generated_mirror",s=new m(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(r,s),this.n=s}for(const[r,s]of n)this.n.set(I.URI.revive(r),s.map(p.Diagnostic.to))}};e.$Gjc=c,c.c=0,c.d=1e3,c.e=1.1*a.d,e.$Gjc=c=a=Qe([He(1,w.$Oj),He(2,P.$Ejc)],c)}),define(Ee[333],Ce([1,0,2,13,7,16,75]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=void 0;class p{constructor(w,A,P,b={timeout:1500,errors:3}){this.c=w,this.d=A,this.f=P,this.g=b,this.a=new L.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(w){return(A,P,b)=>{const y={dispose:this.a.push([A,P,w])};return Array.isArray(b)&&b.push(y),y}}async $participateInSave(w,A){const P=o.URI.revive(w);let b=!1;const C=setTimeout(()=>b=!0,this.g.timeout),y=[];try{for(const a of[...this.a]){if(b)break;const m=this.d.getDocument(P),c=await this.h(a,{document:m,reason:M.TextDocumentSaveReason.to(A)});y.push(c)}}finally{clearTimeout(C)}return y}h([w,A,P],b){const C=this.b.get(w);return typeof C=="number"&&C>this.g.errors?Promise.resolve(!1):this.i(P,w,A,b).then(()=>!0,y=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(y),!(y instanceof Error)||y.message!=="concurrent_edits"){const a=this.b.get(w);this.b.set(w,a?a+1:1),typeof a=="number"&&a>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(w,A,P,b){const C=[],y=Date.now(),{document:a,reason:m}=b,{version:c}=a,i=Object.freeze({document:a,reason:m,waitUntil(n){if(Object.isFrozen(C))throw(0,R.$8)("waitUntil can not be called async");C.push(Promise.resolve(n))}});try{A.apply(P,[i])}catch(n){return Promise.reject(n)}return Object.freeze(C),new Promise((n,r)=>{const s=setTimeout(()=>r(new Error("timeout")),this.g.timeout);return Promise.all(C).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' finished after ${Date.now()-y}ms`),clearTimeout(s),n(t)}).catch(t=>{clearTimeout(s),r(t)})}).then(n=>{const r={edits:[]};for(const s of n)if(Array.isArray(s)&&s.every(t=>t instanceof I.$BM))for(const{newText:t,newEol:f,range:d}of s)r.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:d&&M.Range.from(d),text:t,eol:f&&M.EndOfLine.from(f)}});if(r.edits.length!==0)return c===a.version?this.f.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.$Pkc=p}),define(Ee[334],Ce([1,0,4,3,2,6,153,16,18,24,7]),function(re,e,o,R,I,M,L,p,$,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hjc=void 0;class P{constructor(C,y){this.a=new o.$7d,this.b=new o.$7d,this.c=new o.$7d,this.d=new o.$7d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new R.$Tc,this.h=new Map,this.f=C.getProxy(M.$sM.MainThreadDocuments),this.g=y,this.g.onDidRemoveDocuments(a=>{for(const m of a)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(a=>{for(const m of a)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(C){if(!C)return;const y=this.g.getDocument(C);if(y)return y}getDocument(C){const y=this.getDocumentData(C);if(!y?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return y.document}ensureDocumentData(C){const y=this.g.getDocument(C);if(y)return Promise.resolve(y);let a=this.h.get(C.toString());return a||(a=this.f.$tryOpenDocument(C).then(m=>{this.h.delete(C.toString());const c=I.URI.revive(m);return(0,$.$7f)(this.g.getDocument(c))},m=>(this.h.delete(C.toString()),Promise.reject(m))),this.h.set(C.toString(),a)),a}createDocumentData(C){return this.f.$tryCreateDocument(C).then(y=>I.URI.revive(y))}$acceptModelLanguageChanged(C,y){const a=I.URI.revive(C),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(y),this.a.fire(m.document)}$acceptModelSaved(C){const y=I.URI.revive(C),a=this.g.getDocument(y);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this.d.fire(a.document)}$acceptDirtyStateChanged(C,y){const a=I.URI.revive(C),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");m._acceptIsDirty(y),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,y,a){const m=I.URI.revive(C),c=this.g.getDocument(m);if(!c)throw new Error("unknown document");c._acceptIsDirty(a),c.onEvents(y);let i;y.isUndoing?i=A.TextDocumentChangeReason.Undo:y.isRedoing&&(i=A.TextDocumentChangeReason.Redo),this.c.fire((0,w.$Qn)({document:c.document,contentChanges:y.changes.map(n=>({range:p.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(C,y){(0,L.$QO)(C,y)}}e.$Hjc=P}),define(Ee[71],Ce([1,0,73,4,18,2,5,6,20,16,7]),function(re,e,o,R,I,M,L,p,$,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkc=e.$ckc=void 0,e.$ckc=(0,L.$ii)("IExtHostEditorTabs");class P{constructor(m,c,i){this.e=i,this.d=c,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,c={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(c)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$eO(M.URI.revive(this.b.input.uri));case 2:return new A.$fO(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case 3:return new A.$gO(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case 6:return new A.$hO(M.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$iO(this.b.input.viewType);case 4:return new A.$jO(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$kO(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$lO;case 9:return new A.$mO(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$nO(this.b.input.providerId);case 11:return new A.$oO(this.b.input.diffEditors.map(m=>new A.$fO(M.URI.revive(m.original),M.URI.revive(m.modified))));default:return}}}class b{constructor(m,c){this.c=[],this.d="",this.b=m,this.e=c;for(const i of m.tabs)i.isActive&&(this.d=i.id),this.c.push(new P(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,c={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return w.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(i=>i.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(i=>i.apiObject))}};this.a=Object.freeze(c)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===0){const i=new P(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,i),m.tabDto.isActive&&(this.d=i.tabId),i}else if(m.kind===1){const i=this.c.splice(m.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(m.kind===3){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(m.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,i),i}const c=this.c.find(i=>i.tabId===m.tabDto.id);if(!c)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),c.acceptDtoUpdate(m.tabDto),c}activeTabId(){return this.d}}let C=class{constructor(m){this.b=new R.$7d,this.c=new R.$7d,this.e=[],this.a=m.getProxy(p.$sM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,c={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(i=>i.apiObject))},get activeTabGroup(){const i=m.d;return(0,I.$7f)(m.e.find(r=>r.groupId===i)?.apiObject)},close:async(i,n)=>{const r=Array.isArray(i)?i:[i];return r.length?y(r[0])?this.j(r,n):this.i(r,n):!0}};this.f=Object.freeze(c)}return this.f}$acceptEditorTabModel(m){const c=new Set(this.e.map(d=>d.groupId)),i=new Set(m.map(d=>d.groupId)),n=(0,o.$F)(c,i),r=this.e.filter(d=>n.removed.includes(d.groupId)).map(d=>d.apiObject),s=[],t=[];this.e=m.map(d=>{const u=new b(d,()=>this.d);return n.added.includes(u.groupId)?s.push(u.apiObject):t.push(u.apiObject),u});const f=(0,I.$7f)(m.find(d=>d.isActive===!0)?.groupId);f!==void 0&&this.d!==f&&(this.d=f),this.c.fire(Object.freeze({opened:s,closed:r,changed:t}))}$acceptTabGroupUpdate(m){const c=this.e.find(i=>i.groupId===m.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const c=this.e.find(n=>n.groupId===m.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const i=c.acceptTabOperation(m);switch(m.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(m){for(const c of this.e)for(const i of c.tabs)if(i.apiObject===m)return i}h(m){return this.e.find(c=>c.apiObject===m)}async i(m,c){const i=[];for(const n of m){const r=this.g(n);if(!r)throw new Error("Tab close: Invalid tab not found!");i.push(r.tabId)}return this.a.$closeTab(i,c)}async j(m,c){const i=[];for(const n of m){const r=this.h(n);if(!r)throw new Error("Group close: Invalid group not found!");i.push(r.groupId)}return this.a.$closeGroup(i,c)}};e.$dkc=C,e.$dkc=C=Qe([He(0,$.$OO)],C);function y(a){return a.tabs!==void 0}}),define(Ee[335],Ce([1,0,2,6,3,7,16,188,14,21,26,79]),function(re,e,o,R,I,M,L,p,$,w,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=void 0;class b{constructor(){this.a=[]}add(a){this.b=void 0,this.a.push(a)}delete(a){const m=this.a.indexOf(a);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const a=this.a.sort(),m=[];let c,i,n=14,r=14;for(const s of a){let t=c?(0,$.$nf)(c,s):0;for(t===0?i=1:i=r;t<s.length;t++)t+1===s.length?(n=r,r=9):r+=1,m.push([i,s.toUpperCase().charCodeAt(t),r]),m.push([i,s.toLowerCase().charCodeAt(t),r]),i=r;c=s,r=n}m.push([9,58,10]),m.push([10,47,12]),this.b=new p.$F2(m)}}provideDocumentLinks(a){this.c();const m=[],c=p.$G2.computeLinks({getLineContent(i){return a.lineAt(i-1).text},getLineCount(){return a.lineCount}},this.b);for(const i of c){const n=L.DocumentLink.to(i);n.target&&m.push(n)}return m}}class C{constructor(a,m){this.i=m,this.b=new b,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=a.getProxy(R.$sM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(a,m,c,i={}){if(C.j(c),this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(a,"*",this.b));const n=this.h++;this.b.add(m),this.d.add(m),this.c.set(n,c);let r=2;i.isCaseSensitive&&(r+=1024),i.isReadonly&&(r+=2048),typeof c.copy=="function"&&(r+=8),typeof c.open=="function"&&typeof c.close=="function"&&typeof c.read=="function"&&typeof c.write=="function"&&((0,A.$dG)(a,"fsChunks"),r+=4);let s;i.isReadonly&&(0,P.$Hk)(i.isReadonly)&&i.isReadonly.value!==""&&(s={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,m,r,s).catch(f=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${m}`),console.error(f)});const t=c.onDidChangeFile(f=>{const d=[];for(const u of f){const{uri:h,type:l}=u;if(h.scheme!==m)continue;let g;switch(l){case M.FileChangeType.Changed:g=0;break;case M.FileChangeType.Created:g=1;break;case M.FileChangeType.Deleted:g=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:h,type:g})}this.a.$onFileSystemChange(n,d)});return(0,I.$Sc)(()=>{t.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(a){if(!a)throw new Error("MISSING provider");if(typeof a.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof a.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof a.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof a.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof a.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof a.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof a.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof a.rename!="function")throw new Error("Provider does NOT implement rename")}static k(a){const{type:m,ctime:c,mtime:i,size:n,permissions:r}=a;return{type:m,ctime:c,mtime:i,size:n,permissions:r}}$stat(a,m){return Promise.resolve(this.l(a).stat(o.URI.revive(m))).then(c=>C.k(c))}$readdir(a,m){return Promise.resolve(this.l(a).readDirectory(o.URI.revive(m)))}$readFile(a,m){return Promise.resolve(this.l(a).readFile(o.URI.revive(m))).then(c=>w.$ue.wrap(c))}$writeFile(a,m,c,i){return Promise.resolve(this.l(a).writeFile(o.URI.revive(m),c.buffer,i))}$delete(a,m,c){return Promise.resolve(this.l(a).delete(o.URI.revive(m),c))}$rename(a,m,c,i){return Promise.resolve(this.l(a).rename(o.URI.revive(m),o.URI.revive(c),i))}$copy(a,m,c,i){const n=this.l(a);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(o.URI.revive(m),o.URI.revive(c),i))}$mkdir(a,m){return Promise.resolve(this.l(a).createDirectory(o.URI.revive(m)))}$watch(a,m,c,i){const n=this.l(a).watch(o.URI.revive(c),i);this.f.set(m,n)}$unwatch(a,m){const c=this.f.get(m);c&&(c.dispose(),this.f.delete(m))}$open(a,m,c){const i=this.l(a);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(o.URI.revive(m),c))}$close(a,m){const c=this.l(a);if(!c.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(c.close(m))}$read(a,m,c,i){const n=this.l(a);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const r=w.$ue.alloc(i);return Promise.resolve(n.read(m,c,r.buffer,0,i)).then(s=>r.slice(0,s))}$write(a,m,c,i){const n=this.l(a);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(m,c,i.buffer,0,i.byteLength))}l(a){const m=this.c.get(a);if(!m){const c=new Error;throw c.name="ENOPRO",c.message="no provider",c}return m}}e.$Rkc=C}),define(Ee[336],Ce([1,0,4,35,2,6,16,7,46]),function(re,e,o,R,I,M,L,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skc=void 0;class w{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(C,y,a,m,c,i){this.a=Math.random(),this.b=new o.$7d,this.c=new o.$7d,this.d=new o.$7d,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,R.$ck)(c),r=typeof c=="string",s=i?.correlate,t=m(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(s&&typeof f.session>"u")){if(!i?.ignoreCreateEvents)for(const d of f.created){const u=I.URI.revive(d);n(u.fsPath)&&(!r||y.getWorkspaceFolder(u))&&this.b.fire(u)}if(!i?.ignoreChangeEvents)for(const d of f.changed){const u=I.URI.revive(d);n(u.fsPath)&&(!r||y.getWorkspaceFolder(u))&&this.c.fire(u)}if(!i?.ignoreDeleteEvents)for(const d of f.deleted){const u=I.URI.revive(d);n(u.fsPath)&&(!r||y.getWorkspaceFolder(u))&&this.d.fire(u)}}});this.g=p.$uM.from(this.i(C,a,c,i,i?.correlate),this.b,this.c,this.d,t)}i(C,y,a,m,c){const i=p.$uM.from();if(typeof a=="string")return i;const n=C.getProxy(M.$sM.MainThreadFileSystemEventService);let r=!1;return(a.pattern.includes(R.$$j)||a.pattern.includes(R.$_j))&&(r=!0),n.$watch(y.identifier.value,this.a,a.baseUri,{recursive:r,excludes:m?.excludes??[]},!!c),p.$uM.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(C){this.a=C,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(I.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(I.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(I.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class P{constructor(C,y,a){this.j=C,this.k=y,this.l=a,this.a=new o.$7d,this.b=new o.$7d,this.c=new o.$7d,this.d=new o.$7d,this.g=new o.$9d,this.h=new o.$9d,this.i=new o.$9d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(C,y,a,m){return new w(this.j,C,y,this.a.event,L.GlobPattern.from(a),m)}$onFileEvent(C){this.a.fire(new A(C))}$onDidRunFileOperation(C,y){switch(C){case 2:this.b.fire(Object.freeze({files:y.map(a=>({oldUri:I.URI.revive(a.source),newUri:I.URI.revive(a.target)}))}));break;case 1:this.d.fire(Object.freeze({files:y.map(a=>I.URI.revive(a.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:y.map(a=>I.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent(C){return this.m(C,this.g)}getOnWillCreateFileEvent(C){return this.m(C,this.h)}getOnWillDeleteFileEvent(C){return this.m(C,this.i)}m(C,y){return(a,m,c)=>{const i=function(r){a.call(m,r)};return i.extension=C,y.event(i,void 0,c)}}async $onWillRunFileOperation(C,y,a,m){switch(C){case 2:return await this.n(this.g,{files:y.map(c=>({oldUri:I.URI.revive(c.source),newUri:I.URI.revive(c.target)}))},a,m);case 1:return await this.n(this.i,{files:y.map(c=>I.URI.revive(c.target))},a,m);case 0:case 3:return await this.n(this.h,{files:y.map(c=>I.URI.revive(c.target))},a,m)}}async n(C,y,a,m){const c=new Set,i=[];if(await C.fireAsync(y,m,async(r,s)=>{const t=Date.now(),f=await Promise.resolve(r);f instanceof p.$EM&&(i.push([s.extension,f]),c.add(s.extension.displayName??s.extension.identifier.value)),Date.now()-t>a&&this.k.warn("SLOW file-participant",s.extension.identifier)}),m.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,r]of i){const{edits:s}=L.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(s)}return{edit:n,extensionNames:Array.from(c)}}}e.$Skc=P}),define(Ee[337],Ce([1,0,19,8,22,13,125,3,24,40,14,18,2,29,181,83,135,221,25,16,7,26,111,6]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i,n,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ijc=void 0;class d{constructor(V,H){this.d=V,this.e=H}async provideDocumentSymbols(V,H){const Y=this.d.getDocument(V),X=await this.e.provideDocumentSymbols(Y,H);if(!(0,o.$Kb)(X))return X[0]instanceof r.$NM?X.map(n.DocumentSymbol.from):d.f(X)}static f(V){V=V.slice(0).sort((X,fe)=>{let we=X.location.range.start.compareTo(fe.location.range.start);return we===0&&(we=fe.location.range.end.compareTo(X.location.range.end)),we});const H=[],Y=[];for(const X of V){const fe={name:X.name||"!!MISSING: name!!",kind:n.SymbolKind.from(X.kind),tags:X.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:n.Range.from(X.location.range),selectionRange:n.Range.from(X.location.range),children:[]};for(;;){if(Y.length===0){Y.push(fe),H.push(fe);break}const we=Y[Y.length-1];if(C.$dt.containsRange(we.range,fe.range)&&!C.$dt.equalsRange(we.range,fe.range)){we.children?.push(fe),Y.push(fe);break}Y.pop()}}return H}}class u{constructor(V,H,Y,X,fe,we){this.f=V,this.g=H,this.h=Y,this.j=X,this.k=fe,this.l=we,this.d=new t.$yjc("CodeLens"),this.e=new Map}async provideCodeLenses(V,H){const Y=this.f.getDocument(V),X=await this.h.provideCodeLenses(Y,H);if(!X||H.isCancellationRequested)return;const fe=this.d.add(X),we=new p.$Tc;this.e.set(fe,we);const Te={cacheId:fe,lenses:[]};for(let Ve=0;Ve<X.length;Ve++)Te.lenses.push({cacheId:[fe,Ve],range:n.Range.from(X[Ve].range),command:this.g.toInternal(X[Ve].command,we)});return Te}async resolveCodeLens(V,H){const Y=V.cacheId&&this.d.get(...V.cacheId);if(!Y)return;let X;if(typeof this.h.resolveCodeLens!="function"||Y.isResolved?X=Y:X=await this.h.resolveCodeLens(Y,H),X||(X=Y),H.isCancellationRequested)return;const fe=V.cacheId&&this.e.get(V.cacheId[0]);if(fe){if(!X.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return V.command=this.g.toInternal(X.command,fe),V}}releaseCodeLenses(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}}function h(ze){return Array.isArray(ze)?ze.map(n.DefinitionLink.from):ze?[n.DefinitionLink.from(ze)]:[]}class l{constructor(V,H){this.d=V,this.e=H}async provideDefinition(V,H,Y){const X=this.d.getDocument(V),fe=n.Position.to(H),we=await this.e.provideDefinition(X,fe,Y);return h(we)}}class g{constructor(V,H){this.d=V,this.e=H}async provideDeclaration(V,H,Y){const X=this.d.getDocument(V),fe=n.Position.to(H),we=await this.e.provideDeclaration(X,fe,Y);return h(we)}}class E{constructor(V,H){this.d=V,this.e=H}async provideImplementation(V,H,Y){const X=this.d.getDocument(V),fe=n.Position.to(H),we=await this.e.provideImplementation(X,fe,Y);return h(we)}}class v{constructor(V,H){this.d=V,this.e=H}async provideTypeDefinition(V,H,Y){const X=this.d.getDocument(V),fe=n.Position.to(H),we=await this.e.provideTypeDefinition(X,fe,Y);return h(we)}}class S{constructor(V,H){this.d=V,this.e=H}async provideHover(V,H,Y){const X=this.d.getDocument(V),fe=n.Position.to(H),we=await this.e.provideHover(X,fe,Y);if(!(!we||(0,o.$Kb)(we.contents)))return we.range||(we.range=X.getWordRangeAtPosition(fe)),we.range||(we.range=new r.$wM(fe,fe)),n.Hover.from(we)}}class k{constructor(V,H){this.d=V,this.e=H}async provideEvaluatableExpression(V,H,Y){const X=this.d.getDocument(V),fe=n.Position.to(H),we=await this.e.provideEvaluatableExpression(X,fe,Y);if(we)return n.EvaluatableExpression.from(we)}}class D{constructor(V,H){this.d=V,this.e=H}async provideInlineValues(V,H,Y,X){const fe=this.d.getDocument(V),we=await this.e.provideInlineValues(fe,n.Range.to(H),n.InlineValueContext.to(Y),X);if(Array.isArray(we))return we.map(Te=>n.InlineValue.from(Te))}}class F{constructor(V,H){this.d=V,this.e=H}async provideDocumentHighlights(V,H,Y){const X=this.d.getDocument(V),fe=n.Position.to(H),we=await this.e.provideDocumentHighlights(X,fe,Y);if(Array.isArray(we))return we.map(n.DocumentHighlight.from)}}class W{constructor(V,H){this.d=V,this.e=H}async provideMultiDocumentHighlights(V,H,Y,X){const fe=this.d.getDocument(V),we=Y.map(Ye=>this.d.getDocument(Ye)),Te=n.Position.to(H),Ve=await this.e.provideMultiDocumentHighlights(fe,Te,we,X);if(Array.isArray(Ve))return Ve.map(n.MultiDocumentHighlight.from)}}class B{constructor(V,H){this.d=V,this.e=H}async provideLinkedEditingRanges(V,H,Y){const X=this.d.getDocument(V),fe=n.Position.to(H),we=await this.e.provideLinkedEditingRanges(X,fe,Y);if(we&&Array.isArray(we.ranges))return{ranges:(0,o.$Hb)(we.ranges.map(n.Range.from)),wordPattern:we.wordPattern}}}class j{constructor(V,H){this.d=V,this.e=H}async provideReferences(V,H,Y,X){const fe=this.d.getDocument(V),we=n.Position.to(H),Te=await this.e.provideReferences(fe,we,Y,X);if(Array.isArray(Te))return Te.map(n.location.from)}}class N{constructor(V,H,Y,X,fe,we,Te){this.g=V,this.h=H,this.j=Y,this.k=X,this.l=fe,this.m=we,this.n=Te,this.e=new t.$yjc("CodeAction"),this.f=new Map}async provideCodeActions(V,H,Y,X){const fe=this.g.getDocument(V),we=y.$ft.isISelection(H)?n.Selection.to(H):n.Range.to(H),Te=[];for(const at of this.j.getDiagnostics(V))if(we.intersection(at.range)&&Te.push(at)>N.d)break;const Ve={diagnostics:Te,only:Y.only?new r.$PM(Y.only):void 0,triggerKind:n.CodeActionTriggerKind.to(Y.trigger)},Ye=await this.k.provideCodeActions(fe,we,Ve,X);if(!(0,o.$Lb)(Ye)||X.isCancellationRequested)return;const nt=this.e.add(Ye),ot=new p.$Tc;this.f.set(nt,ot);const lt=[];for(let at=0;at<Ye.length;at++){const st=Ye[at];if(st)if(N.o(st))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),lt.push({_isSynthetic:!0,title:st.title,command:this.h.toInternal(st,ot)});else{Ve.only&&(st.kind?Ve.only.contains(st.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${st.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Ie=st.ranges??[];lt.push({cacheId:[nt,at],title:st.title,command:st.command&&this.h.toInternal(st.command,ot),diagnostics:st.diagnostics&&st.diagnostics.map(n.Diagnostic.from),edit:st.edit&&n.WorkspaceEdit.from(st.edit,void 0),kind:st.kind&&st.kind.value,isPreferred:st.isPreferred,isAI:(0,s.$cG)(this.m,"codeActionAI")?st.isAI:!1,ranges:(0,s.$cG)(this.m,"codeActionRanges")?(0,o.$Hb)(Ie.map(n.Range.from)):void 0,disabled:st.disabled?.reason})}}return{cacheId:nt,actions:lt}}async resolveCodeAction(V,H){const[Y,X]=V,fe=this.e.get(Y,X);if(!fe||N.o(fe))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(fe,H)??fe;let Te;we.edit&&(Te=n.WorkspaceEdit.from(we.edit,void 0));let Ve;if(we.command){const Ye=this.f.get(Y);Ye&&(Ve=this.h.toInternal(we.command,Ye))}return{edit:Te,command:Ve}}releaseCodeActions(V){this.f.get(V)?.dispose(),this.f.delete(V),this.e.delete(V)}static o(V){return typeof V.command=="string"&&typeof V.title=="string"}}N.d=1e3;class T{constructor(V,H,Y,X,fe){this.e=V,this.f=H,this.g=Y,this.h=X,this.j=fe,this.d=new t.$yjc("DocumentPasteEdit")}async prepareDocumentPaste(V,H,Y,X){if(!this.g.prepareDocumentPaste)return;const fe=this.f.getDocument(V),we=H.map(Ye=>n.Range.to(Ye)),Te=n.DataTransfer.toDataTransfer(Y,()=>{throw new M.$$});if(await this.g.prepareDocumentPaste(fe,we,Te,X),X.isCancellationRequested)return;const Ve=Array.from(Te).filter(([,Ye])=>!(Ye instanceof r.$jN));return n.DataTransfer.from(Ve)}async providePasteEdits(V,H,Y,X,fe,we){if(!this.g.provideDocumentPasteEdits)return[];const Te=this.f.getDocument(H),Ve=Y.map(lt=>n.Range.to(lt)),Ye=n.DataTransfer.toDataTransfer(X,async lt=>(await this.e.$resolvePasteFileData(this.h,V,lt)).buffer),nt=await this.g.provideDocumentPasteEdits(Te,Ve,Ye,{only:fe.only?new r.$oN(fe.only):void 0,triggerKind:fe.triggerKind},we);if(!nt||we.isCancellationRequested)return[];const ot=this.d.add(nt);return nt.map((lt,at)=>({_cacheId:[ot,at],title:lt.title??(0,c.localize)(0,null,this.j.displayName||this.j.name),kind:lt.kind,yieldTo:lt.yieldTo?.map(st=>st.value),insertText:typeof lt.insertText=="string"?lt.insertText:{snippet:lt.insertText.value},additionalEdit:lt.additionalEdit?n.WorkspaceEdit.from(lt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(V,H){const[Y,X]=V,fe=this.d.get(Y,X);if(!fe||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(fe,H)??fe;return{additionalEdit:we.additionalEdit?n.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(V){this.d.delete(V)}}class O{constructor(V,H){this.d=V,this.e=H}async provideDocumentFormattingEdits(V,H,Y){const X=this.d.getDocument(V),fe=await this.e.provideDocumentFormattingEdits(X,H,Y);if(Array.isArray(fe))return fe.map(n.TextEdit.from)}}class z{constructor(V,H){this.d=V,this.e=H}async provideDocumentRangeFormattingEdits(V,H,Y,X){const fe=this.d.getDocument(V),we=n.Range.to(H),Te=await this.e.provideDocumentRangeFormattingEdits(fe,we,Y,X);if(Array.isArray(Te))return Te.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(V,H,Y,X){(0,P.$6f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const fe=this.d.getDocument(V),we=H.map(n.Range.to),Te=await this.e.provideDocumentRangesFormattingEdits(fe,we,Y,X);if(Array.isArray(Te))return Te.map(n.TextEdit.from)}}class Q{constructor(V,H){this.d=V,this.e=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,H,Y,X,fe){const we=this.d.getDocument(V),Te=n.Position.to(H),Ve=await this.e.provideOnTypeFormattingEdits(we,Te,Y,X,fe);if(Array.isArray(Ve))return Ve.map(n.TextEdit.from)}}class Z{constructor(V,H){this.e=V,this.f=H,this.d=new t.$yjc("WorkspaceSymbols")}async provideWorkspaceSymbols(V,H){const Y=await this.e.provideWorkspaceSymbols(V,H);if(!(0,o.$Lb)(Y))return{symbols:[]};const X=this.d.add(Y),fe={cacheId:X,symbols:[]};for(let we=0;we<Y.length;we++){const Te=Y[we];if(!Te||!Te.name){this.f.warn("INVALID SymbolInformation",Te);continue}fe.symbols.push({...n.WorkspaceSymbol.from(Te),cacheId:[X,we]})}return fe}async resolveWorkspaceSymbol(V,H){if(typeof this.e.resolveWorkspaceSymbol!="function"||!V.cacheId)return V;const Y=this.d.get(...V.cacheId);if(Y){const X=await this.e.resolveWorkspaceSymbol(Y,H);return X&&(0,$.$Sn)(V,n.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(V){this.d.delete(V)}}class J{static supportsResolving(V){return typeof V.prepareRename=="function"}constructor(V,H,Y){this.d=V,this.e=H,this.f=Y}async provideRenameEdits(V,H,Y,X){const fe=this.d.getDocument(V),we=n.Position.to(H);try{const Te=await this.e.provideRenameEdits(fe,we,Y,X);return Te?n.WorkspaceEdit.from(Te):void 0}catch(Te){const Ve=J.g(Te);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(V,H,Y){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const X=this.d.getDocument(V),fe=n.Position.to(H);try{const we=await this.e.prepareRename(X,fe,Y);let Te,Ve;if(r.$wM.isRange(we)?(Te=we,Ve=X.getText(we)):(0,P.$Xf)(we)&&(Te=we.range,Ve=we.placeholder),!Te||!Ve)return;if(Te.start.line>fe.line||Te.end.line<fe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Te),text:Ve}}catch(we){const Te=J.g(we);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(we)}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class x{constructor(V,H,Y){this.d=V,this.e=H,this.f=Y}async provideNewSymbolNames(V,H,Y){const X=this.d.getDocument(V),fe=n.Range.to(H);try{const we=await this.e.provideNewSymbolNames(X,fe,Y);return we?we.map(Te=>typeof Te=="string"?{newSymbolName:Te}:{newSymbolName:Te.newSymbolName,tags:Te.tags}):void 0}catch(we){this.f.error(x.g(we)??JSON.stringify(we,null,"	"));return}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class ce{constructor(V,H){this.resultId=V,this.tokens=H}}class te{constructor(V,H){this.f=V,this.g=H,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(V,H,Y){const X=this.f.getDocument(V),fe=H!==0?this.d.get(H):null;let we=typeof fe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(X,fe.resultId,Y):await this.g.provideDocumentSemanticTokens(X,Y);return fe&&this.d.delete(H),we?(we=te.h(we),this.o(te.n(fe,we),we)):null}async releaseDocumentSemanticColoring(V){this.d.delete(V)}static h(V){return te.j(V)?te.k(V)?V:new r.$ON(new Uint32Array(V.data),V.resultId):te.l(V)?te.m(V)?V:new r.$QN(V.edits.map(H=>new r.$PN(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),V.resultId):V}static j(V){return V&&!!V.data}static k(V){return V.data instanceof Uint32Array}static l(V){return V&&Array.isArray(V.edits)}static m(V){for(const H of V.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static n(V,H){if(!te.j(H)||!V||!V.tokens)return H;const Y=V.tokens,X=Y.length,fe=H.data,we=fe.length;let Te=0;const Ve=Math.min(X,we);for(;Te<Ve&&Y[Te]===fe[Te];)Te++;if(Te===X&&Te===we)return new r.$QN([],H.resultId);let Ye=0;const nt=Ve-Te;for(;Ye<nt&&Y[X-Ye-1]===fe[we-Ye-1];)Ye++;return new r.$QN([{start:Te,deleteCount:X-Te-Ye,data:fe.subarray(Te,we-Ye)}],H.resultId)}o(V,H){if(te.j(V)){const Y=this.e++;return this.d.set(Y,new ce(V.resultId,V.data)),(0,m.$Yab)({id:Y,type:"full",data:V.data})}if(te.l(V)){const Y=this.e++;return te.j(H)?this.d.set(Y,new ce(H.resultId,H.data)):this.d.set(Y,new ce(V.resultId)),(0,m.$Yab)({id:Y,type:"delta",deltas:(V.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}class pe{constructor(V,H){this.d=V,this.e=H}async provideDocumentRangeSemanticTokens(V,H,Y){const X=this.d.getDocument(V),fe=await this.e.provideDocumentRangeSemanticTokens(X,n.Range.to(H),Y);return fe?this.f(fe):null}f(V){return(0,m.$Yab)({id:0,type:"full",data:V.data})}}class ye{static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}constructor(V,H,Y,X,fe){this.f=V,this.g=H,this.h=Y,this.j=X,this.k=fe,this.d=new t.$yjc("CompletionItem"),this.e=new Map}async provideCompletionItems(V,H,Y,X){const fe=this.f.getDocument(V),we=n.Position.to(H),Te=fe.getWordRangeAtPosition(we)||new r.$wM(we,we),Ve=Te.with({end:we}),Ye=new w.$3d,nt=await this.h.provideCompletionItems(fe,we,X,n.CompletionContext.to(Y));if(!nt||X.isCancellationRequested)return;const ot=Array.isArray(nt)?new r.$3M(nt):nt,lt=ye.supportsResolving(this.h)?this.d.add(ot.items):this.d.add([]),at=new p.$Tc;this.e.set(lt,at);const st=[],Ie={x:lt,b:st,a:{replace:n.Range.from(Te),insert:n.Range.from(Ve)},c:ot.isIncomplete||void 0,d:Ye.elapsed()};for(let We=0;We<ot.items.length;We++){const Ae=ot.items[We],Ke=this.l(Ae,[lt,We],Ve,Te);st.push(Ke)}return Ie}async resolveCompletionItem(V,H){if(typeof this.h.resolveCompletionItem!="function")return;const Y=this.d.get(...V);if(!Y)return;const X=this.l(Y,V),fe=await this.h.resolveCompletionItem(Y,H);if(!fe)return;const we=this.l(fe,V);return(X.h!==we.h||X.i!==we.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(X.n!==we.n||X.o!==we.o||!(0,$.$Tn)(X.p,we.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...X,d:we.d,c:we.c,l:we.l,h:we.h,i:we.i,n:we.n,o:we.o,p:we.p}}releaseCompletionItems(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,H,Y,X){const fe=this.e.get(H[0]);if(!fe)throw Error("DisposableStore is missing...");const we=this.g.toInternal(V.command,fe),Te={x:H,a:V.label,b:V.kind!==void 0?n.CompletionItemKind.from(V.kind):void 0,m:V.tags&&V.tags.map(n.CompletionItemTag.from),c:V.detail,d:typeof V.documentation>"u"?void 0:n.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters?.join(""),l:V.additionalTextEdits&&V.additionalTextEdits.map(n.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};V.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te.h=V.textEdit.newText):typeof V.insertText=="string"?Te.h=V.insertText:V.insertText instanceof r.$FM&&(Te.h=V.insertText.value,Te.i|=4);let Ve;return V.textEdit?Ve=V.textEdit.range:V.range&&(Ve=V.range),r.$wM.isRange(Ve)?Te.j=n.Range.from(Ve):Ve&&(!Y?.isEqual(Ve.inserting)||!X?.isEqual(Ve.replacing))&&(Te.j={insert:n.Range.from(Ve.inserting),replace:n.Range.from(Ve.replacing)}),Te}}class _{async provideInlineCompletions(V,H,Y,X){}disposeCompletions(V){}handleDidShowCompletionItem(V,H,Y){}handlePartialAccept(V,H,Y,X){}}class U extends _{constructor(V,H,Y,X){super(),this.f=V,this.g=H,this.h=Y,this.j=X,this.d=new Se,this.e=(0,s.$cG)(this.f,"inlineCompletionsAdditions"),this.k={[a.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[a.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,s.$cG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(V,H,Y,X){const fe=this.g.getDocument(V),we=n.Position.to(H),Te=await this.h.provideInlineCompletionItems(fe,we,{selectedCompletionInfo:Y.selectedSuggestionInfo?{range:n.Range.to(Y.selectedSuggestionInfo.range),text:Y.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Y.triggerKind]},X);if(!Te||X.isCancellationRequested)return;const Ve=Array.isArray(Te)?Te:Te.items,Ye=this.e?Array.isArray(Te)?[]:Te.commands||[]:[],nt=this.e&&!Array.isArray(Te)?Te.enableForwardStability:void 0;let ot;return{pid:this.d.createReferenceId({dispose(){ot?.dispose()},items:Ve}),items:Ve.map((at,st)=>{let Ie;at.command&&(ot||(ot=new p.$Tc),Ie=this.j.toInternal(at.command,ot));const We=at.insertText;return{insertText:typeof We=="string"?We:{snippet:We.value},filterText:at.filterText,range:at.range?n.Range.from(at.range):void 0,command:Ie,idx:st,completeBracketPairs:this.e?at.completeBracketPairs:!1}}),commands:Ye.map(at=>(ot||(ot=new p.$Tc),this.j.toInternal(at,ot))),suppressSuggestions:!1,enableForwardStability:nt}}disposeCompletions(V){this.d.disposeReferenceId(V)?.dispose()}handleDidShowCompletionItem(V,H,Y){const X=this.d.get(V)?.items[H];X&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(X,Y)}handlePartialAccept(V,H,Y,X){const fe=this.d.get(V)?.items[H];fe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(fe,Y),this.h.handleDidPartiallyAcceptCompletionItem(fe,n.PartialAcceptInfo.to(X)))}}class he{async provideInlineEdits(V,H,Y){const X=this.f.getDocument(V),fe=await this.g.provideInlineEdit(X,{triggerKind:this.e[H.triggerKind]},Y);if(!fe||Y.isCancellationRequested)return;let we;const Te=this.d.createReferenceId({dispose(){we?.dispose()},item:fe});let Ve;fe.accepted&&(we||(we=new p.$Tc),Ve=this.h.toInternal(fe.accepted,we));let Ye;return fe.rejected&&(we||(we=new p.$Tc),Ye=this.h.toInternal(fe.rejected,we)),{pid:Te,text:fe.text,range:n.Range.from(fe.range),accepted:Ve,rejected:Ye}}disposeEdit(V){this.d.disposeReferenceId(V)?.dispose()}constructor(V,H,Y,X){this.f=H,this.g=Y,this.h=X,this.d=new Se,this.e={[a.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[a.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class Se{constructor(){this.d=new Map,this.e=1}createReferenceId(V){const H=this.e++;return this.d.set(H,V),H}disposeReferenceId(V){const H=this.d.get(V);return this.d.delete(V),H}get(V){return this.d.get(V)}}class me{constructor(V,H){this.e=V,this.f=H,this.d=new t.$yjc("SignatureHelp")}async provideSignatureHelp(V,H,Y,X){const fe=this.e.getDocument(V),we=n.Position.to(H),Te=this.g(Y),Ve=await this.f.provideSignatureHelp(fe,we,X,Te);if(Ve){const Ye=this.d.add([Ve]);return{...n.SignatureHelp.from(Ve),id:Ye}}}g(V){let H;if(V.activeSignatureHelp){const Y=n.SignatureHelp.to(V.activeSignatureHelp),X=this.d.get(V.activeSignatureHelp.id,0);X?(H=X,H.activeSignature=Y.activeSignature,H.activeParameter=Y.activeParameter):H=Y}return{...V,activeSignatureHelp:H}}releaseSignatureHelp(V){this.d.delete(V)}}class ie{constructor(V,H,Y,X,fe){this.f=V,this.g=H,this.h=Y,this.j=X,this.k=fe,this.d=new t.$yjc("InlayHints"),this.e=new Map}async provideInlayHints(V,H,Y){const X=this.f.getDocument(V),fe=n.Range.to(H),we=await this.h.provideInlayHints(X,fe,Y);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(H)}`);return}if(Y.isCancellationRequested)return;const Te=this.d.add(we);this.e.set(Te,new p.$Tc);const Ve={hints:[],cacheId:Te};for(let Ye=0;Ye<we.length;Ye++)this.l(we[Ye],fe)&&Ve.hints.push(this.m(we[Ye],[Te,Ye]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(H)}`),Ve}async resolveInlayHint(V,H){if(typeof this.h.resolveInlayHint!="function")return;const Y=this.d.get(...V);if(!Y)return;const X=await this.h.resolveInlayHint(Y,H);if(X&&this.l(X))return this.m(X,V)}releaseHints(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,H){return V.label.length===0||Array.isArray(V.label)&&V.label.every(Y=>Y.value.length===0)?(console.log("INVALID inlay hint, empty label",V),!1):!(H&&!H.contains(V.position))}m(V,H){const Y=this.e.get(H[0]);if(!Y)throw Error("DisposableStore is missing...");const X={label:"",cacheId:H,tooltip:n.MarkdownString.fromStrict(V.tooltip),position:n.Position.from(V.position),textEdits:V.textEdits&&V.textEdits.map(n.TextEdit.from),kind:V.kind&&n.InlayHintKind.from(V.kind),paddingLeft:V.paddingLeft,paddingRight:V.paddingRight};if(typeof V.label=="string")X.label=V.label;else{const fe=[];X.label=fe;for(const we of V.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Te={label:we.value,tooltip:n.MarkdownString.fromStrict(we.tooltip)};r.$GM.isLocation(we.location)&&(Te.location=n.location.from(we.location)),we.command&&(Te.command=this.g.toInternal(we.command,Y)),fe.push(Te)}}return X}}class se{constructor(V,H){this.e=V,this.f=H,this.d=new t.$yjc("DocumentLink")}async provideLinks(V,H){const Y=this.e.getDocument(V),X=await this.f.provideDocumentLinks(Y,H);if(!(!Array.isArray(X)||X.length===0)&&!H.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:X.filter(se.g).map(n.DocumentLink.from)};{const fe=this.d.add(X),we={links:[],cacheId:fe};for(let Te=0;Te<X.length;Te++){if(!se.g(X[Te]))continue;const Ve=n.DocumentLink.from(X[Te]);Ve.cacheId=[fe,Te],we.links.push(Ve)}return we}}}static g(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,H){if(typeof this.f.resolveDocumentLink!="function")return;const Y=this.d.get(...V);if(!Y)return;const X=await this.f.resolveDocumentLink(Y,H);if(!(!X||!se.g(X)))return n.DocumentLink.from(X)}releaseLinks(V){this.d.delete(V)}}class oe{constructor(V,H){this.d=V,this.e=H}async provideColors(V,H){const Y=this.d.getDocument(V),X=await this.e.provideDocumentColors(Y,H);return Array.isArray(X)?X.map(we=>({color:n.Color.from(we.color),range:n.Range.from(we.range)})):[]}async provideColorPresentations(V,H,Y){const X=this.d.getDocument(V),fe=n.Range.to(H.range),we=n.Color.to(H.color),Te=await this.e.provideColorPresentations(we,{document:X,range:fe},Y);if(Array.isArray(Te))return Te.map(n.ColorPresentation.from)}}class G{constructor(V,H){this.d=V,this.e=H}async provideFoldingRanges(V,H,Y){const X=this.d.getDocument(V),fe=await this.e.provideFoldingRanges(X,H,Y);if(Array.isArray(fe))return fe.map(n.FoldingRange.from)}}class ee{constructor(V,H,Y){this.d=V,this.e=H,this.f=Y}async provideSelectionRanges(V,H,Y){const X=this.d.getDocument(V),fe=H.map(n.Position.to),we=await this.e.provideSelectionRanges(X,fe,Y);if(!(0,o.$Lb)(we))return[];if(we.length!==fe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let Ve=0;Ve<fe.length;Ve++){const Ye=[];Te.push(Ye);let nt=fe[Ve],ot=we[Ve];for(;;){if(!ot.range.contains(nt))throw new Error("INVALID selection range, must contain the previous range");if(Ye.push(n.SelectionRange.from(ot)),!ot.parent)break;nt=ot.range,ot=ot.parent}}return Te}}class le{constructor(V,H){this.f=V,this.g=H,this.d=new L.$TO(""),this.e=new Map}async prepareSession(V,H,Y){const X=this.f.getDocument(V),fe=n.Position.to(H),we=await this.g.prepareCallHierarchy(X,fe,Y);if(!we)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(we)?we.map(Ve=>this.h(Te,Ve)):[this.h(Te,we)]}async provideCallsTo(V,H,Y){const X=this.j(V,H);if(!X)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyIncomingCalls(X,Y);if(fe)return fe.map(we=>({from:this.h(V,we.from),fromRanges:we.fromRanges.map(Te=>n.Range.from(Te))}))}async provideCallsFrom(V,H,Y){const X=this.j(V,H);if(!X)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyOutgoingCalls(X,Y);if(fe)return fe.map(we=>({to:this.h(V,we.to),fromRanges:we.fromRanges.map(Te=>n.Range.from(Te))}))}releaseSession(V){this.e.delete(V)}h(V,H){const Y=this.e.get(V),X=n.CallHierarchyItem.from(H,V,Y.size.toString(36));return Y.set(X._itemId,H),X}j(V,H){return this.e.get(V)?.get(H)}}class de{constructor(V,H){this.f=V,this.g=H,this.d=new L.$TO(""),this.e=new Map}async prepareSession(V,H,Y){const X=this.f.getDocument(V),fe=n.Position.to(H),we=await this.g.prepareTypeHierarchy(X,fe,Y);if(!we)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(we)?we.map(Ve=>this.h(Te,Ve)):[this.h(Te,we)]}async provideSupertypes(V,H,Y){const X=this.j(V,H);if(!X)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySupertypes(X,Y);if(fe)return fe.map(we=>this.h(V,we))}async provideSubtypes(V,H,Y){const X=this.j(V,H);if(!X)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySubtypes(X,Y);if(fe)return fe.map(we=>this.h(V,we))}releaseSession(V){this.e.delete(V)}h(V,H){const Y=this.e.get(V),X=n.TypeHierarchyItem.from(H,V,Y.size.toString(36));return Y.set(X._itemId,H),X}j(V,H){return this.e.get(V)?.get(H)}}class Me{constructor(V,H,Y,X,fe){this.d=V,this.e=H,this.f=Y,this.g=X,this.h=fe}async provideDocumentOnDropEdits(V,H,Y,X,fe){const we=this.e.getDocument(H),Te=n.Position.to(Y),Ve=n.DataTransfer.toDataTransfer(X,async nt=>(await this.d.$resolveDocumentOnDropFileData(this.g,V,nt)).buffer),Ye=await this.f.provideDocumentDropEdits(we,Te,Ve,fe);if(Ye)return(0,o.$3b)(Ye).map(nt=>({title:nt.title??(0,c.localize)(1,null,this.h.displayName||this.h.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(ot=>ot.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?n.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}}class be{constructor(V,H){this.d=V,this.e=H}async provideMappedEdits(V,H,Y,X){const fe=b.URI.revive(V),we=this.d.getDocument(fe),Te=Y.documents.map(nt=>nt.map(ot=>({uri:b.URI.revive(ot.uri),version:ot.version,ranges:ot.ranges.map(lt=>n.Range.to(lt))}))),Ve={documents:Te,selections:Te[0]?.[0]?.ranges??[]},Ye=await this.e.provideMappedEdits(we,H,Ve,X);return Ye?n.WorkspaceEdit.from(Ye):null}}class Pe{constructor(V,H){this.adapter=V,this.extension=H}}class Re{constructor(V,H,Y,X,fe,we,Te,Ve){this.g=H,this.h=Y,this.j=X,this.k=fe,this.l=we,this.m=Te,this.n=Ve,this.f=new Map,this.e=V.getProxy(f.$sM.MainThreadLanguageFeatures)}o(V,H){return n.DocumentSelector.from(V,this.g,H)}p(V){return new r.$uM(()=>{this.f.delete(V),this.e.$unregister(V)})}q(){return Re.d++}async s(V,H,Y,X,fe,we=!1){const Te=this.f.get(V);if(!Te||!(Te.adapter instanceof H))return X;const Ve=Date.now();we||this.l.trace(`[${Te.extension.identifier.value}] INVOKE provider '${Y.toString().replace(/[\r\n]/g,"")}'`);const Ye=Y(Te.adapter,Te.extension);return Promise.resolve(Ye).catch(nt=>{(0,M.$4)(nt)||(this.l.error(`[${Te.extension.identifier.value}] provider FAILED`),this.l.error(nt),this.n.onExtensionError(Te.extension.identifier,nt))}).finally(()=>{we||this.l.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),I.CancellationToken.isCancellationToken(fe)?(0,R.$0g)(Ye,fe):Ye}t(V,H){const Y=this.q();return this.f.set(Y,new Pe(V,H)),Y}static u(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,H,Y,X){const fe=this.t(new d(this.h,Y),V),we=X&&X.label||Re.u(V);return this.e.$registerDocumentSymbolProvider(fe,this.o(H,V),we),this.p(fe)}$provideDocumentSymbols(V,H,Y){return this.s(V,d,X=>X.provideDocumentSymbols(b.URI.revive(H),Y),void 0,Y)}registerCodeLensProvider(V,H,Y){const X=this.q(),fe=typeof Y.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(X,new Pe(new u(this.h,this.j.converter,Y,V,this.n,this.l),V)),this.e.$registerCodeLensSupport(X,this.o(H,V),fe);let we=this.p(X);if(fe!==void 0){const Te=Y.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(fe));we=r.$uM.from(we,Te)}return we}$provideCodeLenses(V,H,Y){return this.s(V,u,X=>X.provideCodeLenses(b.URI.revive(H),Y),void 0,Y)}$resolveCodeLens(V,H,Y){return this.s(V,u,X=>X.resolveCodeLens(H,Y),void 0,void 0)}$releaseCodeLenses(V,H){this.s(V,u,Y=>Promise.resolve(Y.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(V,H,Y){const X=this.t(new l(this.h,Y),V);return this.e.$registerDefinitionSupport(X,this.o(H,V)),this.p(X)}$provideDefinition(V,H,Y,X){return this.s(V,l,fe=>fe.provideDefinition(b.URI.revive(H),Y,X),[],X)}registerDeclarationProvider(V,H,Y){const X=this.t(new g(this.h,Y),V);return this.e.$registerDeclarationSupport(X,this.o(H,V)),this.p(X)}$provideDeclaration(V,H,Y,X){return this.s(V,g,fe=>fe.provideDeclaration(b.URI.revive(H),Y,X),[],X)}registerImplementationProvider(V,H,Y){const X=this.t(new E(this.h,Y),V);return this.e.$registerImplementationSupport(X,this.o(H,V)),this.p(X)}$provideImplementation(V,H,Y,X){return this.s(V,E,fe=>fe.provideImplementation(b.URI.revive(H),Y,X),[],X)}registerTypeDefinitionProvider(V,H,Y){const X=this.t(new v(this.h,Y),V);return this.e.$registerTypeDefinitionSupport(X,this.o(H,V)),this.p(X)}$provideTypeDefinition(V,H,Y,X){return this.s(V,v,fe=>fe.provideTypeDefinition(b.URI.revive(H),Y,X),[],X)}registerHoverProvider(V,H,Y,X){const fe=this.t(new S(this.h,Y),V);return this.e.$registerHoverProvider(fe,this.o(H,V)),this.p(fe)}$provideHover(V,H,Y,X){return this.s(V,S,fe=>fe.provideHover(b.URI.revive(H),Y,X),void 0,X)}registerEvaluatableExpressionProvider(V,H,Y,X){const fe=this.t(new k(this.h,Y),V);return this.e.$registerEvaluatableExpressionProvider(fe,this.o(H,V)),this.p(fe)}$provideEvaluatableExpression(V,H,Y,X){return this.s(V,k,fe=>fe.provideEvaluatableExpression(b.URI.revive(H),Y,X),void 0,X)}registerInlineValuesProvider(V,H,Y,X){const fe=typeof Y.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new D(this.h,Y),V);this.e.$registerInlineValuesProvider(we,this.o(H,V),fe);let Te=this.p(we);if(fe!==void 0){const Ve=Y.onDidChangeInlineValues(Ye=>this.e.$emitInlineValuesEvent(fe));Te=r.$uM.from(Te,Ve)}return Te}$provideInlineValues(V,H,Y,X,fe){return this.s(V,D,we=>we.provideInlineValues(b.URI.revive(H),Y,X,fe),void 0,fe)}registerDocumentHighlightProvider(V,H,Y){const X=this.t(new F(this.h,Y),V);return this.e.$registerDocumentHighlightProvider(X,this.o(H,V)),this.p(X)}registerMultiDocumentHighlightProvider(V,H,Y){const X=this.t(new W(this.h,Y),V);return this.e.$registerMultiDocumentHighlightProvider(X,this.o(H,V)),this.p(X)}$provideDocumentHighlights(V,H,Y,X){return this.s(V,F,fe=>fe.provideDocumentHighlights(b.URI.revive(H),Y,X),void 0,X)}$provideMultiDocumentHighlights(V,H,Y,X,fe){return this.s(V,W,we=>we.provideMultiDocumentHighlights(b.URI.revive(H),Y,X.map(Te=>b.URI.revive(Te)),fe),void 0,fe)}registerLinkedEditingRangeProvider(V,H,Y){const X=this.t(new B(this.h,Y),V);return this.e.$registerLinkedEditingRangeProvider(X,this.o(H,V)),this.p(X)}$provideLinkedEditingRanges(V,H,Y,X){return this.s(V,B,async fe=>{const we=await fe.provideLinkedEditingRanges(b.URI.revive(H),Y,X);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Re.w(we.wordPattern):void 0}},void 0,X)}registerReferenceProvider(V,H,Y){const X=this.t(new j(this.h,Y),V);return this.e.$registerReferenceSupport(X,this.o(H,V)),this.p(X)}$provideReferences(V,H,Y,X,fe){return this.s(V,j,we=>we.provideReferences(b.URI.revive(H),Y,X,fe),void 0,fe)}registerCodeActionProvider(V,H,Y,X){const fe=new p.$Tc,we=this.t(new N(this.h,this.j.converter,this.k,Y,this.l,V,this.m),V);return this.e.$registerQuickFixSupport(we,this.o(H,V),{providedKinds:X?.providedCodeActionKinds?.map(Te=>Te.value),documentation:X?.documentation?.map(Te=>({kind:Te.kind.value,command:this.j.converter.toInternal(Te.command,fe)}))},Re.u(V),!!Y.resolveCodeAction),fe.add(this.p(we)),fe}$provideCodeActions(V,H,Y,X,fe){return this.s(V,N,we=>we.provideCodeActions(b.URI.revive(H),Y,X,fe),void 0,fe)}$resolveCodeAction(V,H,Y){return this.s(V,N,X=>X.resolveCodeAction(H,Y),{},void 0)}$releaseCodeActions(V,H){this.s(V,N,Y=>Promise.resolve(Y.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(V,H,Y){const X=this.t(new O(this.h,Y),V);return this.e.$registerDocumentFormattingSupport(X,this.o(H,V),V.identifier,V.displayName||V.name),this.p(X)}$provideDocumentFormattingEdits(V,H,Y,X){return this.s(V,O,fe=>fe.provideDocumentFormattingEdits(b.URI.revive(H),Y,X),void 0,X)}registerDocumentRangeFormattingEditProvider(V,H,Y){const X=typeof Y.provideDocumentRangesFormattingEdits=="function",fe=this.t(new z(this.h,Y),V);return this.e.$registerRangeFormattingSupport(fe,this.o(H,V),V.identifier,V.displayName||V.name,X),this.p(fe)}$provideDocumentRangeFormattingEdits(V,H,Y,X,fe){return this.s(V,z,we=>we.provideDocumentRangeFormattingEdits(b.URI.revive(H),Y,X,fe),void 0,fe)}$provideDocumentRangesFormattingEdits(V,H,Y,X,fe){return this.s(V,z,we=>we.provideDocumentRangesFormattingEdits(b.URI.revive(H),Y,X,fe),void 0,fe)}registerOnTypeFormattingEditProvider(V,H,Y,X){const fe=this.t(new Q(this.h,Y),V);return this.e.$registerOnTypeFormattingSupport(fe,this.o(H,V),X,V.identifier),this.p(fe)}$provideOnTypeFormattingEdits(V,H,Y,X,fe,we){return this.s(V,Q,Te=>Te.provideOnTypeFormattingEdits(b.URI.revive(H),Y,X,fe,we),void 0,we)}registerWorkspaceSymbolProvider(V,H){const Y=this.t(new Z(H,this.l),V);return this.e.$registerNavigateTypeSupport(Y,typeof H.resolveWorkspaceSymbol=="function"),this.p(Y)}$provideWorkspaceSymbols(V,H,Y){return this.s(V,Z,X=>X.provideWorkspaceSymbols(H,Y),{symbols:[]},Y)}$resolveWorkspaceSymbol(V,H,Y){return this.s(V,Z,X=>X.resolveWorkspaceSymbol(H,Y),void 0,void 0)}$releaseWorkspaceSymbols(V,H){this.s(V,Z,Y=>Y.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(V,H,Y){const X=this.t(new J(this.h,Y,this.l),V);return this.e.$registerRenameSupport(X,this.o(H,V),J.supportsResolving(Y)),this.p(X)}$provideRenameEdits(V,H,Y,X,fe){return this.s(V,J,we=>we.provideRenameEdits(b.URI.revive(H),Y,X,fe),void 0,fe)}$resolveRenameLocation(V,H,Y,X){return this.s(V,J,fe=>fe.resolveRenameLocation(b.URI.revive(H),Y,X),void 0,X)}registerNewSymbolNamesProvider(V,H,Y){const X=this.t(new x(this.h,Y,this.l),V);return this.e.$registerNewSymbolNamesProvider(X,this.o(H,V)),this.p(X)}$provideNewSymbolNames(V,H,Y,X){return this.s(V,x,fe=>fe.provideNewSymbolNames(b.URI.revive(H),Y,X),void 0,X)}registerDocumentSemanticTokensProvider(V,H,Y,X){const fe=this.t(new te(this.h,Y),V),we=typeof Y.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(fe,this.o(H,V),X,we);let Te=this.p(fe);if(we){const Ve=Y.onDidChangeSemanticTokens(Ye=>this.e.$emitDocumentSemanticTokensEvent(we));Te=r.$uM.from(Te,Ve)}return Te}$provideDocumentSemanticTokens(V,H,Y,X){return this.s(V,te,fe=>fe.provideDocumentSemanticTokens(b.URI.revive(H),Y,X),null,X)}$releaseDocumentSemanticTokens(V,H){this.s(V,te,Y=>Y.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(V,H,Y,X){const fe=this.t(new pe(this.h,Y),V);return this.e.$registerDocumentRangeSemanticTokensProvider(fe,this.o(H,V),X),this.p(fe)}$provideDocumentRangeSemanticTokens(V,H,Y,X){return this.s(V,pe,fe=>fe.provideDocumentRangeSemanticTokens(b.URI.revive(H),Y,X),null,X)}registerCompletionItemProvider(V,H,Y,X){const fe=this.t(new ye(this.h,this.j.converter,Y,this.m,V),V);return this.e.$registerCompletionsProvider(fe,this.o(H,V),X,ye.supportsResolving(Y),V.identifier),this.p(fe)}$provideCompletionItems(V,H,Y,X,fe){return this.s(V,ye,we=>we.provideCompletionItems(b.URI.revive(H),Y,X,fe),void 0,fe)}$resolveCompletionItem(V,H,Y){return this.s(V,ye,X=>X.resolveCompletionItem(H,Y),void 0,Y)}$releaseCompletionItems(V,H){this.s(V,ye,Y=>Y.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(V,H,Y,X){const fe=new U(V,this.h,Y,this.j.converter),we=this.t(fe,V);return this.e.$registerInlineCompletionsSupport(we,this.o(H,V),fe.supportsHandleEvents,i.$Em.toKey(V.identifier.value),X?.yieldTo?.map(Te=>i.$Em.toKey(Te))||[]),this.p(we)}$provideInlineCompletions(V,H,Y,X,fe){return this.s(V,_,we=>we.provideInlineCompletions(b.URI.revive(H),Y,X,fe),void 0,fe)}$handleInlineCompletionDidShow(V,H,Y,X){this.s(V,_,async fe=>{fe.handleDidShowCompletionItem(H,Y,X)},void 0,void 0)}$handleInlineCompletionPartialAccept(V,H,Y,X,fe){this.s(V,_,async we=>{we.handlePartialAccept(H,Y,X,fe)},void 0,void 0)}$freeInlineCompletionsList(V,H){this.s(V,_,async Y=>{Y.disposeCompletions(H)},void 0,void 0)}registerInlineEditProvider(V,H,Y){const X=new he(V,this.h,Y,this.j.converter),fe=this.t(X,V);return this.e.$registerInlineEditProvider(fe,this.o(H,V),V.identifier),this.p(fe)}$provideInlineEdit(V,H,Y,X){return this.s(V,he,fe=>fe.provideInlineEdits(b.URI.revive(H),Y,X),void 0,X)}$freeInlineEdit(V,H){this.s(V,he,async Y=>{Y.disposeEdit(H)},void 0,void 0)}registerSignatureHelpProvider(V,H,Y,X){const fe=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,we=this.t(new me(this.h,Y),V);return this.e.$registerSignatureHelpProvider(we,this.o(H,V),fe),this.p(we)}$provideSignatureHelp(V,H,Y,X,fe){return this.s(V,me,we=>we.provideSignatureHelp(b.URI.revive(H),Y,X,fe),void 0,fe)}$releaseSignatureHelp(V,H){this.s(V,me,Y=>Y.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(V,H,Y){const X=typeof Y.onDidChangeInlayHints=="function"?this.q():void 0,fe=this.t(new ie(this.h,this.j.converter,Y,this.l,V),V);this.e.$registerInlayHintsProvider(fe,this.o(H,V),typeof Y.resolveInlayHint=="function",X,Re.u(V));let we=this.p(fe);if(X!==void 0){const Te=Y.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(X));we=r.$uM.from(we,Te)}return we}$provideInlayHints(V,H,Y,X){return this.s(V,ie,fe=>fe.provideInlayHints(b.URI.revive(H),Y,X),void 0,X)}$resolveInlayHint(V,H,Y){return this.s(V,ie,X=>X.resolveInlayHint(H,Y),void 0,Y)}$releaseInlayHints(V,H){this.s(V,ie,Y=>Y.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(V,H,Y){const X=this.t(new se(this.h,Y),V);return this.e.$registerDocumentLinkProvider(X,this.o(H,V),typeof Y.resolveDocumentLink=="function"),this.p(X)}$provideDocumentLinks(V,H,Y){return this.s(V,se,X=>X.provideLinks(b.URI.revive(H),Y),void 0,Y,H.scheme==="output")}$resolveDocumentLink(V,H,Y){return this.s(V,se,X=>X.resolveLink(H,Y),void 0,void 0,!0)}$releaseDocumentLinks(V,H){this.s(V,se,Y=>Y.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(V,H,Y){const X=this.t(new oe(this.h,Y),V);return this.e.$registerDocumentColorProvider(X,this.o(H,V)),this.p(X)}$provideDocumentColors(V,H,Y){return this.s(V,oe,X=>X.provideColors(b.URI.revive(H),Y),[],Y)}$provideColorPresentations(V,H,Y,X){return this.s(V,oe,fe=>fe.provideColorPresentations(b.URI.revive(H),Y,X),void 0,X)}registerFoldingRangeProvider(V,H,Y){const X=this.q(),fe=typeof Y.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(X,new Pe(new G(this.h,Y),V)),this.e.$registerFoldingRangeProvider(X,this.o(H,V),V.identifier,fe);let we=this.p(X);if(fe!==void 0){const Te=Y.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(fe));we=r.$uM.from(we,Te)}return we}$provideFoldingRanges(V,H,Y,X){return this.s(V,G,fe=>fe.provideFoldingRanges(b.URI.revive(H),Y,X),void 0,X)}registerSelectionRangeProvider(V,H,Y){const X=this.t(new ee(this.h,Y,this.l),V);return this.e.$registerSelectionRangeProvider(X,this.o(H,V)),this.p(X)}$provideSelectionRanges(V,H,Y,X){return this.s(V,ee,fe=>fe.provideSelectionRanges(b.URI.revive(H),Y,X),[],X)}registerCallHierarchyProvider(V,H,Y){const X=this.t(new le(this.h,Y),V);return this.e.$registerCallHierarchyProvider(X,this.o(H,V)),this.p(X)}$prepareCallHierarchy(V,H,Y,X){return this.s(V,le,fe=>Promise.resolve(fe.prepareSession(b.URI.revive(H),Y,X)),void 0,X)}$provideCallHierarchyIncomingCalls(V,H,Y,X){return this.s(V,le,fe=>fe.provideCallsTo(H,Y,X),void 0,X)}$provideCallHierarchyOutgoingCalls(V,H,Y,X){return this.s(V,le,fe=>fe.provideCallsFrom(H,Y,X),void 0,X)}$releaseCallHierarchy(V,H){this.s(V,le,Y=>Promise.resolve(Y.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(V,H,Y){const X=this.t(new de(this.h,Y),V);return this.e.$registerTypeHierarchyProvider(X,this.o(H,V)),this.p(X)}$prepareTypeHierarchy(V,H,Y,X){return this.s(V,de,fe=>Promise.resolve(fe.prepareSession(b.URI.revive(H),Y,X)),void 0,X)}$provideTypeHierarchySupertypes(V,H,Y,X){return this.s(V,de,fe=>fe.provideSupertypes(H,Y,X),void 0,X)}$provideTypeHierarchySubtypes(V,H,Y,X){return this.s(V,de,fe=>fe.provideSubtypes(H,Y,X),void 0,X)}$releaseTypeHierarchy(V,H){this.s(V,de,Y=>Promise.resolve(Y.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(V,H,Y,X){const fe=this.q();return this.f.set(fe,new Pe(new Me(this.e,this.h,Y,fe,V),V)),this.e.$registerDocumentOnDropEditProvider(fe,this.o(H,V),(0,s.$cG)(V,"dropMetadata")?X:void 0),this.p(fe)}$provideDocumentOnDropEdits(V,H,Y,X,fe,we){return this.s(V,Me,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(H,b.URI.revive(Y),X,fe,we)),void 0,void 0)}registerMappedEditsProvider(V,H,Y){const X=this.t(new be(this.h,Y),V);return this.e.$registerMappedEditsProvider(X,this.o(H,V)),this.p(X)}$provideMappedEdits(V,H,Y,X,fe){return this.s(V,be,we=>Promise.resolve(we.provideMappedEdits(H,Y,X,fe)),null,fe)}registerDocumentPasteEditProvider(V,H,Y,X){const fe=this.q();return this.f.set(fe,new Pe(new T(this.e,this.h,Y,fe,V),V)),this.e.$registerPasteEditProvider(fe,this.o(H,V),{supportsCopy:!!Y.prepareDocumentPaste,supportsPaste:!!Y.provideDocumentPasteEdits,supportsResolve:!!Y.resolveDocumentPasteEdit,providedPasteEditKinds:X.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:X.copyMimeTypes,pasteMimeTypes:X.pasteMimeTypes}),this.p(fe)}$prepareDocumentPaste(V,H,Y,X,fe){return this.s(V,T,we=>we.prepareDocumentPaste(b.URI.revive(H),Y,X,fe),void 0,fe)}$providePasteEdits(V,H,Y,X,fe,we,Te){return this.s(V,T,Ve=>Ve.providePasteEdits(H,b.URI.revive(Y),X,fe,we,Te),void 0,Te)}$resolvePasteEdit(V,H,Y){return this.s(V,T,X=>X.resolvePasteEdit(H,Y),{},void 0)}$releasePasteEdits(V,H){this.s(V,T,Y=>Promise.resolve(Y.releasePasteEdits(H)),void 0,void 0)}static w(V){return{pattern:V.source,flags:V.flags}}static y(V){return{decreaseIndentPattern:Re.w(V.decreaseIndentPattern),increaseIndentPattern:Re.w(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Re.w(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Re.w(V.unIndentedLinePattern):void 0}}static z(V){return{beforeText:Re.w(V.beforeText),afterText:V.afterText?Re.w(V.afterText):void 0,previousLineText:V.previousLineText?Re.w(V.previousLineText):void 0,action:V.action}}static B(V){return V.map(Re.z)}static C(V){return{open:V.open,close:V.close,notIn:V.notIn?V.notIn.map(H=>r.SyntaxTokenType.toString(H)):void 0}}static D(V){return V.map(Re.C)}setLanguageConfiguration(V,H,Y){const{wordPattern:X}=Y;if(X&&(0,A.$0e)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this.h.setWordDefinitionFor(H,X):this.h.setWordDefinitionFor(H,void 0),Y.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),Y.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const fe=this.q(),we={comments:Y.comments,brackets:Y.brackets,wordPattern:Y.wordPattern?Re.w(Y.wordPattern):void 0,indentationRules:Y.indentationRules?Re.y(Y.indentationRules):void 0,onEnterRules:Y.onEnterRules?Re.B(Y.onEnterRules):void 0,__electricCharacterSupport:Y.__electricCharacterSupport,__characterPairSupport:Y.__characterPairSupport,autoClosingPairs:Y.autoClosingPairs?Re.D(Y.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(fe,H,we),this.p(fe)}$setWordDefinitions(V){for(const H of V)this.h.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.$Ijc=Re,Re.d=0}),define(Ee[122],Ce([1,0,3,6,16,7,108,25,8,4,222,146,13,5,20,121,12]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qjc=e.$Pjc=void 0,e.$Pjc=(0,C.$ii)("IExtHostLanguageModels");class i{constructor(t,f){this.option=t,this.stream=new $.$Lh,this.stream=f??new $.$Lh}}class n{constructor(){this.a=new Map,this.b=new $.$Lh,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let f=this.a.get(t.index);f||(this.a.size===0?f=new i(t.index,this.b):f=new i(t.index),this.a.set(t.index,f)),f.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const f of this.f())f.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let r=c=class{constructor(t,f,d){this.j=f,this.k=d,this.c=new w.$7d,this.d=new w.$7d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new p.$Gm,this.i=new Map,this.o=new Set,this.b=t.getProxy(R.$sM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,f,d,u){const h=c.a++;this.f.set(h,{extension:t.identifier,provider:d,languageModelId:f});let l;return u.auth&&(l={providerLabel:t.displayName||t.name,accountLabel:typeof u.auth=="object"?u.auth.label:void 0}),this.b.$registerLanguageModelProvider(h,f,{extension:t.identifier,identifier:f,model:u.name??"",auth:l}),(0,o.$Sc)(()=>{this.f.delete(h),this.b.$unregisterProvider(h)})}async $provideLanguageModelResponse(t,f,d,u,h,l){const g=this.f.get(t);if(!g)return;const E=new L.$Sv(async v=>{if(l.isCancellationRequested){this.j.warn(`[CHAT](${g.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(f,{index:v.index,part:v.part})});return g.provider.provideLanguageModelResponse2(u.map(I.LanguageModelMessage.to),h,p.$Em.toKey(d),E,l)}$updateLanguageModels(t){const f=[],d=[];if(t.added)for(const u of t.added)this.g.set(u.identifier,u),f.push(u.model);if(t.removed)for(const u of t.removed){this.g.delete(u),d.push(u);for(const[h,l]of this.i)l.languageModelId===u&&(l.res.reject(new b.$5),this.i.delete(h))}this.d.fire(Object.freeze({added:Object.freeze(f),removed:Object.freeze(d)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const f=new Array;for(const{from:d,to:u,enabled:h}of t){const l=this.h.get(d)??new p.$Fm;if(l.has(u)!==h){h?l.add(u):l.delete(u),this.h.set(d,l);const E={from:d,to:u};f.push(E),this.c.fire(E)}}}async sendChatRequest(t,f,d,u,h){const l=t.identifier,g=await this.b.$prepareChatAccess(l,f,u.justification);if(!g||!this.g.has(f))throw M.$BO.NotFound(`Language model '${f}' is unknown.`);if(this.m(l,g)&&(!await this.l(t,{identifier:g.extension,displayName:g.auth.providerLabel},u.justification,u.silent)||!this.h.get(l)?.has(g.extension)))throw M.$BO.NoPermissions(`Language model '${f}' cannot be used by '${l.value}'.`);const E=Math.random()*1e6|0,v=this.b.$fetchResponse(l,f,E,d.map(I.LanguageModelMessage.from),u.modelOptions??{},h),S=new $.$hh,k=new n;this.i.set(E,{languageModelId:f,res:k});let D;if(v.catch(F=>{S.isOpen()?k.reject(F):D=F}).finally(()=>{this.i.delete(E),k.resolve(),S.open()}),await S.wait(),D)throw new M.$BO(`Language model '${f}' errored, check cause for more details`,"Unknown",D);return k.apiObject}async $handleResponseFragment(t,f){const d=this.i.get(t);d&&d.res.handleFragment(f)}async l(t,f,d,u){const h=P.$uL+f.identifier.value;if(await this.k.getSession(t,h,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0;if(u)return!1;try{const g=d?(0,A.localize)(0,null,f.displayName,d):(0,A.localize)(1,null,f.displayName);return await this.k.getSession(t,h,[],{forceNewSession:{detail:g}}),this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0}catch{return!1}}m(t,f){return!!f.auth&&!p.$Em.equals(f.extension,t)}async n(t){for(const f of this.o)try{await this.l(f,{identifier:t.extension,displayName:""},void 0,!0)}catch(d){this.j.error("Fake Auth request failed"),this.j.error(d)}}createLanguageModelAccessInformation(t){this.o.add(t);const f=this,d=w.Event.signal(w.Event.filter(this.c.event,h=>p.$Em.equals(h.from,t.identifier))),u=w.Event.signal(this.d.event);return{get onDidChange(){return w.Event.any(d,u)},canSendRequest(h){const l=f.g.get(h);if(!l)return;if(!f.m(t.identifier,l))return!0;const g=f.h.get(t.identifier);if(g)return g.has(l.extension)}}}};e.$Qjc=r,r.a=1,e.$Qjc=r=c=Qe([He(0,y.$OO),He(1,m.$Oj),He(2,a.$Kjc)],r)}),define(Ee[338],Ce([1,0,6,16,7,41,8,3,26]),function(re,e,o,R,I,M,L,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0kc=void 0;class w{constructor(P,b,C,y){this.c=b,this.d=C,this.e=y,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(o.$sM.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,b){await this.a.$changeLanguage(P,b);const C=this.c.getDocumentData(P);if(!C)throw new Error(`document '${P.toString()}' NOT found`);return C.document}async tokenAtPosition(P,b){const C=P.version,y=R.Position.from(b),a=await this.a.$tokensAtPosition(P.uri,y),m={type:I.StandardTokenType.Other,range:P.getWordRangeAtPosition(b)??new I.$wM(b.line,b.character,b.line,b.character)};if(!a)return m;const c={range:R.Range.to(a.range),type:R.TokenType.to(a.type)};return!c.range.contains(b)||C!==P.version?m:c}createLanguageStatusItem(P,b,C){const y=this.f++,a=this.a,m=this.g,c=`${P.identifier.value}/${b}`;if(m.has(c))throw new Error(`LanguageStatusItem with id '${b}' ALREADY exists`);m.add(c);const i={selector:C,id:b,name:P.displayName??P.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const r=new p.$Tc,s=()=>{if(n?.dispose(),!m.has(c)){console.warn(`LanguageStatusItem (${b}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,L.$kh)(()=>{r.clear(),this.a.$setLanguageStatus(y,{id:c,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:R.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===I.LanguageStatusSeverity.Error?M.default.Error:i.severity===I.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:i.command&&this.d.toInternal(i.command,r),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){r.dispose(),n?.dispose(),a.$removeLanguageStatus(y),m.delete(c)},get id(){return i.id},get name(){return i.name},set name(f){i.name=f,s()},get selector(){return i.selector},set selector(f){i.selector=f,s()},get text(){return i.text},set text(f){i.text=f,s()},set text2(f){(0,$.$dG)(P,"languageStatusText"),i.text=f,s()},get text2(){return(0,$.$dG)(P,"languageStatusText"),i.text},get detail(){return i.detail},set detail(f){i.detail=f,s()},get severity(){return i.severity},set severity(f){i.severity=f,s()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(f){i.accessibilityInformation=f,s()},get command(){return i.command},set command(f){i.command=f,s()},get busy(){return i.busy},set busy(f){i.busy=f,s()}};return s(),t}}e.$0kc=w}),define(Ee[339],Ce([1,0,15,2,16,7,120]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkc=e.$Ukc=void 0;class p{constructor(P,b,C,y){this.start=P,this.deletedCount=b,this.deletedItems=C,this.items=y}asApiEvent(){return{range:new M.$VN(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(P){return{EOL:P.eol,lines:P.source,languageId:P.language,uri:P.uri,isDirty:!1,versionId:1}}constructor(P,b,C){this.notebook=P,this.h=b,this.j=C,this.handle=C.handle,this.uri=R.URI.revive(C.uri),this.cellKind=C.cellKind,this.a=C.outputs.map(I.NotebookCellOutput.to),this.e=C.internalMetadata??{},this.b=Object.freeze(C.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(C.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,b=this.h.getDocument(this.uri);if(!b)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const C={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:b.document,get mime(){return P.g},set mime(y){P.g=y},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(C)}return this.f}setOutputs(P){this.a=P.map(I.NotebookCellOutput.to)}setOutputItems(P,b,C){const y=C.map(I.NotebookCellOutputItem.to),a=this.a.find(m=>m.id===P);if(a&&(b||(a.items.length=0),a.items.push(...y),a.items.length>1&&a.items.every(m=>L.$pK(m.mime)))){const m=new Map,c=[];a.items.forEach(i=>{let n;m.has(i.mime)?n=m.get(i.mime):(n=[],m.set(i.mime,n),c.push(i.mime)),n.push(i.data)}),a.items.length=0,c.forEach(i=>{const n=L.$qK(m.get(i));a.items.push({mime:i,data:n.data.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.$Ukc=$;class w{constructor(P,b,C,y,a){this.k=P,this.l=b,this.m=C,this.uri=y,this.handle=w.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const P=this,b={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===o.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(C){return C=P.n(C),P.b[C].apiCell},getCells(C){return(C?P.p(C):P.b).map(a=>a.apiCell)},save(){return P.q()}};this.e=Object.freeze(b)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,b,C){this.g=P.versionId,this.h=b,this.acceptDocumentPropertiesChanged({metadata:C});const y={notebook:this.apiNotebook,metadata:C,cellChanges:[],contentChanges:[]},a=[];for(const c of P.rawEvents)c.kind===L.NotebookCellsChangeType.ModelChange?this.r(c.changes,!1,y.contentChanges):c.kind===L.NotebookCellsChangeType.Move?this.s(c.index,c.length,c.newIdx,y.contentChanges):c.kind===L.NotebookCellsChangeType.Output?(this.t(c.index,c.outputs),a.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===L.NotebookCellsChangeType.OutputItem?(this.u(c.index,c.outputId,c.append,c.outputItems),a.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v(c.index,c.language),a.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document})):c.kind===L.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document}):c.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w(c.index,c.mime):c.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x(c.index,c.metadata),a.push({cell:this.b[c.index].apiCell,metadata:this.b[c.index].apiCell.metadata})):c.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(c.index,c.internalMetadata),a.push({cell:this.b[c.index].apiCell,executionSummary:this.b[c.index].apiCell.executionSummary}));const m=new Map;for(let c=0;c<a.length;c++){const i=a[c],n=m.get(i.cell);if(n===void 0){const r=y.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});m.set(i.cell,r-1)}else y.cellChanges[n]={...y.cellChanges[n],...i}}return Object.freeze(y),Object.freeze(y.cellChanges),Object.freeze(y.contentChanges),y}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let b=P.start|0,C=P.end|0;return b<0&&(b=0),C>this.b.length&&(C=this.b.length),P.with({start:b,end:C})}p(P){P=this.o(P);const b=[];for(let C=P.start;C<P.end;C++)b.push(this.b[C]);return b}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,b,C){if(this.j)return;const y=[],a=[],m=[];if(P.reverse().forEach(c=>{const n=c[2].map(t=>{const f=new $(this,this.l,t);return b||a.push($.asModelAddData(t)),f}),r=new p(c[0],c[1],[],n),s=this.b.splice(c[0],c[1],...n);for(const t of s)m.push(t.uri),r.deletedItems.push(t.apiCell);y.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:m}),C)for(const c of y)C.push(c.asApiEvent())}s(P,b,C,y){const a=this.b.splice(P,b);this.b.splice(C,0,...a);const m=[new p(P,b,a.map(c=>c.apiCell),[]),new p(C,0,[],a)];for(const c of m)y.push(c.asApiEvent())}t(P,b){this.b[P].setOutputs(b)}u(P,b,C,y){this.b[P].setOutputItems(b,C,y)}v(P,b){const C=this.b[P];C.apiCell.document.languageId!==b&&this.m.$acceptModelLanguageChanged(C.uri,b)}w(P,b){const C=this.b[P];C.apiCell.mime=b}x(P,b){this.b[P].setMetadata(b)}y(P,b){this.b[P].setInternalMetadata(b)}getCellFromApiCell(P){return this.b.find(b=>b.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(b=>b.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.$Vkc=w,w.a=0}),define(Ee[340],Ce([1,0,4,2,16,7]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=void 0;class L{constructor($,w,A,P={timeout:1500,errors:3}){this.b=$,this.c=w,this.d=A,this.f=P,this.a=new o.$9d}dispose(){}getOnWillSaveNotebookDocumentEvent($){return(w,A,P)=>{const b=function(y){w.call(A,y)};return b.extension=$,this.a.event(b,void 0,P)}}async $participateInSave($,w,A){const P=R.URI.revive($),b=this.c.getNotebookDocument(P);if(!b)throw new Error("Unable to resolve notebook document");const C=[];if(await this.a.fireAsync({notebook:b.apiNotebook,reason:I.TextDocumentSaveReason.to(w)},A,async(a,m)=>{const c=Date.now(),i=await await Promise.resolve(a);Date.now()-c>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier),!A.isCancellationRequested&&i&&(i instanceof M.$EM?C.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(C.length===0)return!0;const y={edits:[]};for(const a of C){const{edits:m}=I.WorkspaceEdit.from(a);y.edits=y.edits.concat(m)}return this.d.$tryApplyWorkspaceEdit(y)}}e.$_kc=L}),define(Ee[154],Ce([1,0,13,16,7]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wkc=void 0;class M{constructor(p,$,w,A,P,b){this.id=p,this.f=$,this.notebookData=w,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=A,this.c=b}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection($){this.selections=[$]},get selections(){return p.a},set selections($){if(!Array.isArray($)||!$.every(I.$VN.isNotebookRange))throw(0,o.$7)("selections");p.a=$,p.g($)},get visibleRanges(){return p.b},revealRange($,w){p.f.$tryRevealRange(p.id,R.NotebookRange.from($),w??I.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(R.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$Wkc=M,M.apiEditorsToExtHost=new WeakMap}),define(Ee[341],Ce([1,0,4,12,16]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=void 0;let M=class{constructor(p,$){this.c=p,this.d=$,this.a=new o.$7d,this.b=new o.$7d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(p,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,$);const w=this.d.getEditorById(p);$.visibleRanges&&w._acceptVisibleRanges($.visibleRanges.ranges.map(I.NotebookRange.to)),$.selections&&w._acceptSelections($.selections.selections.map(I.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:w.apiEditor,visibleRanges:w.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:w.apiEditor,selections:w.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const $ in p)this.d.getEditorById($)._acceptViewColumn(I.ViewColumn.to(p[$]))}};e.$blc=M,e.$blc=M=Qe([He(0,R.$Oj)],M)}),define(Ee[342],Ce([1,0,4,6,154]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=void 0;class M{constructor(p,$){this.c=$,this.a=new Map,this.b=p.getProxy(R.$sM.MainThreadNotebookRenderers)}$postRendererMessage(p,$,w){const A=this.c.getEditorById(p);this.a.get($)?.fire({editor:A.apiEditor,message:w})}createRendererMessaging(p,$){if(!p.contributes?.notebookRenderer?.some(A=>A.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(A,P,b)=>this.d($).event(A,P,b),postMessage:(A,P)=>{I.$Wkc.apiEditorsToExtHost.has(A)&&([A,P]=[P,A]);const b=P&&I.$Wkc.apiEditorsToExtHost.get(P);return this.b.$postMessage(b?.id,$,A)}}}d(p){let $=this.a.get(p);return $||($=new o.$7d({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(p)}}),this.a.set(p,$),$)}}e.$elc=M}),define(Ee[343],Ce([1,0,16,108,22,54,13]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilc=void 0;class p{constructor(P){this.b=0,this.c=new Map,this.a=P}async withProgress(P,b,C){const y=this.b++,{title:a,location:m,cancellable:c}=b,i={label:P.displayName||P.name,id:P.identifier.value};return this.a.$startProgress(y,{location:o.ProgressLocation.from(m),title:a,source:i,cancellable:c},P.isUnderDevelopment?void 0:P.identifier.value).catch(L.$2),this.d(y,C,!!c)}d(P,b,C){let y;C&&(y=new I.$ee,this.c.set(P,y));const a=c=>{this.a.$progressEnd(c),this.c.delete(c),y?.dispose()};let m;try{m=b(new w(this.a,P),C&&y?y.token:I.CancellationToken.None)}catch(c){throw a(P),c}return m.then(c=>a(P),c=>a(P)),m}$acceptProgressCanceled(P){const b=this.c.get(P);b&&(b.cancel(),this.c.delete(P))}}e.$ilc=p;function $(A,P){return A.message=P.message,typeof P.increment=="number"&&(typeof A.increment=="number"?A.increment+=P.increment:A.increment=P.increment),A}class w extends R.$Sv{constructor(P,b){super(C=>this.throttledReport(C)),this.c=P,this.d=b}throttledReport(P){this.c.$progressReport(this.d,P)}}Qe([(0,M.$Oh)(100,(A,P)=>$(A,P),()=>Object.create(null))],w.prototype,"throttledReport",null)}),define(Ee[344],Ce([1,0,2,6,8,16]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=void 0;class L{constructor($,w){this.d=w,this.c=new Map,this.b=$.getProxy(R.$sM.MainThreadQuickDiff)}$provideOriginalResource($,w,A){const P=o.URI.revive(w),b=this.c.get($);return b?(0,I.$ah)(()=>b.provideOriginalResource(P,A)).then(C=>C||null):Promise.resolve(null)}registerQuickDiffProvider($,w,A,P){const b=L.a++;return this.c.set(b,w),this.b.$registerQuickDiffProvider(b,M.DocumentSelector.from($,this.d),A,P),{dispose:()=>{this.b.$unregisterQuickDiffProvider(b),this.c.delete(b)}}}}e.$jlc=L,L.a=0}),define(Ee[345],Ce([1,0,22,4,3,6,2,7,13,19,41,56,26,16]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$klc=y;function y(a,m,c){const i=a.getProxy(M.$sM.MainThreadQuickOpen);class n{constructor(g,E){this.e=new Map,this.f=0,this.a=g,this.b=E}showQuickPick(g,E,v,S=o.CancellationToken.None){this.c=void 0;const k=Promise.resolve(E),D=++this.f,F=i.$show(D,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},S),W={},B=F.then(()=>W);return Promise.race([B,k]).then(j=>{if(j===W)return;const N=(0,b.$cG)(g,"quickPickItemTooltip");return k.then(T=>{const O=[];for(let z=0;z<T.length;z++){const Q=T[z];if(typeof Q=="string")O.push({label:Q,handle:z});else if(Q.kind===p.QuickPickItemKind.Separator)O.push({type:"separator",label:Q.label});else{Q.tooltip&&!N&&console.warn(`Extension '${g.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${g.identifier.value}`);const Z=Q.iconPath?d(Q.iconPath):void 0;O.push({label:Q.label,iconPath:Z?.iconPath,iconClass:Z?.iconClass,description:Q.description,detail:Q.detail,picked:Q.picked,alwaysShow:Q.alwaysShow,tooltip:N?C.MarkdownString.fromStrict(Q.tooltip):void 0,handle:z})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=z=>{v.onDidSelectItem(T[z])}),i.$setItems(D,O),F.then(z=>{if(typeof z=="number")return T[z];if(Array.isArray(z))return z.map(Q=>T[Q])})})}).then(void 0,j=>{if(!(0,$.$4)(j))return i.$setError(D,j),Promise.reject(j)})}$onItemSelected(g){this.c?.(g)}showInput(g,E=o.CancellationToken.None){return this.d=g?.validateInput,i.$input(g,typeof this.d=="function",E).then(void 0,v=>{if(!(0,$.$4)(v))return Promise.reject(v)})}async $validateInput(g){if(!this.d)return;const E=await this.d(g);if(!E||typeof E=="string")return E;let v;switch(E.severity){case p.InputBoxValidationSeverity.Info:v=A.default.Info;break;case p.InputBoxValidationSeverity.Warning:v=A.default.Warning;break;case p.InputBoxValidationSeverity.Error:v=A.default.Error;break;default:v=E.message?A.default.Error:A.default.Ignore;break}return{content:E.message,severity:v}}async showWorkspaceFolderPick(g,E=o.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[g]);if(!v)return;const S=await this.a.getWorkspaceFolders2();if(S)return S.find(k=>k.uri.toString()===v.uri.toString())}createQuickPick(g){const E=new u(g,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}createInputBox(g){const E=new h(g,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}$onDidChangeValue(g,E){this.e.get(g)?._fireDidChangeValue(E)}$onDidAccept(g){this.e.get(g)?._fireDidAccept()}$onDidChangeActive(g,E){const v=this.e.get(g);v instanceof u&&v._fireDidChangeActive(E)}$onDidChangeSelection(g,E){const v=this.e.get(g);v instanceof u&&v._fireDidChangeSelection(E)}$onDidTriggerButton(g,E){this.e.get(g)?._fireDidTriggerButton(E)}$onDidTriggerItemButton(g,E,v){const S=this.e.get(g);S instanceof u&&S._fireDidTriggerItemButton(E,v)}$onDidHide(g){this.e.get(g)?._fireDidHide()}}class r{constructor(g,E){this.x=g,this.y=E,this._id=u.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new R.$7d,this.q=new R.$7d,this.r=new R.$7d,this.s=new R.$7d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(g){this.b=g,this.z({title:g})}get step(){return this.c}set step(g){this.c=g,this.z({step:g})}get totalSteps(){return this.d}set totalSteps(g){this.d=g,this.z({totalSteps:g})}get enabled(){return this.g}set enabled(g){this.g=g,this.z({enabled:g})}get busy(){return this.j}set busy(g){this.j=g,this.z({busy:g})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(g){this.k=g,this.z({ignoreFocusOut:g})}get value(){return this.l}set value(g){this.l=g,this.z({value:g})}get placeholder(){return this.m}set placeholder(g){this.m=g,this.z({placeholder:g})}get buttons(){return this.n}set buttons(g){this.n=g.slice(),this.o.clear(),g.forEach((E,v)=>{const S=E===p.$SN.Back?-1:v;this.o.set(S,E)}),this.z({buttons:g.map((E,v)=>({...d(E.iconPath),tooltip:E.tooltip,handle:E===p.$SN.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(g){this.l=g,this.q.fire(g)}_fireDidTriggerButton(g){const E=this.o.get(g);E&&this.r.fire(E)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(g){if(!this.v){for(const E of Object.keys(g)){const v=g[E];this.u[E]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}r.a=1;function s(l){if(l instanceof p.$qN)return{id:l.id};const g=f(l),E=t(l);return{dark:typeof g=="string"?L.URI.file(g):g,light:typeof E=="string"?L.URI.file(E):E}}function t(l){return typeof l=="object"&&"light"in l?l.light:l}function f(l){return typeof l=="object"&&"dark"in l?l.dark:l}function d(l){const g=s(l);let E,v;return"id"in g?v=P.ThemeIcon.asClassName(g):E=g,{iconPath:E,iconClass:v}}class u extends r{constructor(g,E){super(g.identifier,E),this.O=g,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new R.$7d,this.L=[],this.M=new R.$7d,this.N=new R.$7d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(g){this.B=g.slice(),this.C.clear(),this.D.clear(),g.forEach((S,k)=>{this.C.set(k,S),this.D.set(S,k)});const E=(0,b.$cG)(this.O,"quickPickItemTooltip"),v=[];for(let S=0;S<g.length;S++){const k=g[S];if(k.kind===p.QuickPickItemKind.Separator)v.push({type:"separator",label:k.label});else{k.tooltip&&!E&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const D=k.iconPath?d(k.iconPath):void 0;v.push({handle:S,label:k.label,iconPath:D?.iconPath,iconClass:D?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:E?C.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((F,W)=>({...d(F.iconPath),tooltip:F.tooltip,handle:W}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(g){this.E=g,this.z({canSelectMany:g})}get matchOnDescription(){return this.F}set matchOnDescription(g){this.F=g,this.z({matchOnDescription:g})}get matchOnDetail(){return this.G}set matchOnDetail(g){this.G=g,this.z({matchOnDetail:g})}get sortByLabel(){return this.H}set sortByLabel(g){this.H=g,this.z({sortByLabel:g})}get keepScrollPosition(){return this.I}set keepScrollPosition(g){this.I=g,this.z({keepScrollPosition:g})}get activeItems(){return this.J}set activeItems(g){this.J=g.filter(E=>this.D.has(E)),this.z({activeItems:this.J.map(E=>this.D.get(E))})}get selectedItems(){return this.L}set selectedItems(g){this.L=g.filter(E=>this.D.has(E)),this.z({selectedItems:this.L.map(E=>this.D.get(E))})}_fireDidChangeActive(g){const E=(0,w.$Hb)(g.map(v=>this.C.get(v)));this.J=E,this.K.fire(E)}_fireDidChangeSelection(g){const E=(0,w.$Hb)(g.map(v=>this.C.get(v)));this.L=E,this.M.fire(E)}_fireDidTriggerItemButton(g,E){const v=this.C.get(g);if(!v||!v.buttons||!v.buttons.length)return;const S=v.buttons[E];S&&this.N.fire({button:S,item:v})}}class h extends r{constructor(g,E){super(g.identifier,E),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(g){this.B=g,this.z({password:g})}get prompt(){return this.C}set prompt(g){this.C=g,this.z({prompt:g})}get valueSelection(){return this.D}set valueSelection(g){this.D=g,this.z({valueSelection:g})}get validationMessage(){return this.E}set validationMessage(g){this.E=g,g?typeof g=="string"?this.z({validationMessage:g,severity:A.default.Error}):this.z({validationMessage:g.message,severity:g.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new n(m,c)}});var qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)},it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o};define(Ee[346],Ce([1,0,2,4,54,3,8,6,19,127,12,25,56,16,26,15,11]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m){"use strict";var c,i,n,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$mlc=e.$llc=void 0;function s(B){return B instanceof o.URI}function t(B,j){return B.scheme===a.Schemas.file&&j.scheme===a.Schemas.file&&m.$e?B.toString()===j.toString():B.toString().toLowerCase()===j.toString().toLowerCase()}function f(B){if(B)return typeof B.iconPath=="string"?o.URI.file(B.iconPath):o.URI.isUri(B.iconPath)||b.ThemeIcon.isThemeIcon(B.iconPath)?B.iconPath:void 0}function d(B){if(B.icon){if(o.URI.isUri(B.icon))return B.icon;if(b.ThemeIcon.isThemeIcon(B.icon))return B.icon;{const j=B.icon;return{light:j.light,dark:j.dark}}}else return}function u(B,j){if(!B.iconPath&&!j.iconPath)return 0;if(B.iconPath){if(!j.iconPath)return 1}else return-1;const N=typeof B.iconPath=="string"?B.iconPath:o.URI.isUri(B.iconPath)?B.iconPath.fsPath:B.iconPath.id,T=typeof j.iconPath=="string"?j.iconPath:o.URI.isUri(j.iconPath)?j.iconPath.fsPath:j.iconPath.id;return(0,w.$br)(N,T)}function h(B,j){let N=0;if(B.strikeThrough!==j.strikeThrough)return B.strikeThrough?1:-1;if(B.faded!==j.faded)return B.faded?1:-1;if(B.tooltip!==j.tooltip)return(B.tooltip||"").localeCompare(j.tooltip||"");if(N=u(B,j),N!==0)return N;if(B.light&&j.light)N=u(B.light,j.light);else{if(B.light)return 1;if(j.light)return-1}if(N!==0)return N;if(B.dark&&j.dark)N=u(B.dark,j.dark);else{if(B.dark)return 1;if(j.dark)return-1}return N}function l(B,j){if(B.command!==j.command)return B.command<j.command?-1:1;if(B.title!==j.title)return B.title<j.title?-1:1;if(B.tooltip!==j.tooltip){if(B.tooltip!==void 0&&j.tooltip!==void 0)return B.tooltip<j.tooltip?-1:1;if(B.tooltip!==void 0)return 1;if(j.tooltip!==void 0)return-1}if(B.arguments===j.arguments)return 0;if(B.arguments)if(j.arguments){if(B.arguments.length!==j.arguments.length)return B.arguments.length-j.arguments.length}else return 1;else return-1;for(let N=0;N<B.arguments.length;N++){const T=B.arguments[N],O=j.arguments[N];if(T!==O&&!(s(T)&&s(O)&&t(T,O)))return T<O?-1:1}return 0}function g(B,j){let N=(0,w.$br)(B.resourceUri.fsPath,j.resourceUri.fsPath,!0);if(N!==0)return N;if(B.command&&j.command)N=l(B.command,j.command);else{if(B.command)return 1;if(j.command)return-1}if(N!==0)return N;if(B.decorations&&j.decorations)N=h(B.decorations,j.decorations);else{if(B.decorations)return 1;if(j.decorations)return-1}if(B.multiFileDiffEditorModifiedUri&&j.multiFileDiffEditorModifiedUri)N=(0,w.$br)(B.multiFileDiffEditorModifiedUri.fsPath,j.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(B.multiFileDiffEditorModifiedUri)return 1;if(j.multiFileDiffEditorModifiedUri)return-1}if(B.multiDiffEditorOriginalUri&&j.multiDiffEditorOriginalUri)N=(0,w.$br)(B.multiDiffEditorOriginalUri.fsPath,j.multiDiffEditorOriginalUri.fsPath,!0);else{if(B.multiDiffEditorOriginalUri)return 1;if(j.multiDiffEditorOriginalUri)return-1}return N}function E(B,j){for(let N=0;N<B.length;N++)if(B[N]!==j[N])return!1;return!0}function v(B,j){return B.command===j.command&&B.title===j.title&&B.tooltip===j.tooltip&&(B.arguments&&j.arguments?E(B.arguments,j.arguments):B.arguments===j.arguments)}function S(B,j){return(0,$.$ub)(B,j,v)}class k{get value(){return this.d}set value(j){j=j??"",qe(this,c,"f").$setInputBoxValue(this.l,j),this.n(j)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(j){qe(this,c,"f").$setInputBoxPlaceholder(this.l,j),this.f=j}get validateInput(){return(0,y.$dG)(this.k,"scmValidation"),this.g}set validateInput(j){if((0,y.$dG)(this.k,"scmValidation"),j&&typeof j!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=j,qe(this,c,"f").$setValidationProviderIsEnabled(this.l,!!j)}get enabled(){return this.h}set enabled(j){j=!!j,this.h!==j&&(this.h=j,qe(this,c,"f").$setInputBoxEnablement(this.l,j))}get visible(){return this.j}set visible(j){j=!!j,this.j!==j&&(this.j=j,qe(this,c,"f").$setInputBoxVisibility(this.l,j))}get document(){return(0,y.$dG)(this.k,"scmTextDocument"),qe(this,i,"f").getDocument(this.m)}constructor(j,N,T,O,z){this.k=j,this.l=O,this.m=z,c.set(this,void 0),i.set(this,void 0),this.d="",this.e=new R.$7d,this.f="",this.h=!0,this.j=!0,it(this,i,N,"f"),it(this,c,T,"f")}showValidationMessage(j,N){(0,y.$dG)(this.k,"scmValidation"),qe(this,c,"f").$showValidationMessage(this.l,j,N)}$onInputBoxValueChange(j){this.n(j)}n(j){this.d=j,this.e.fire(j)}}e.$llc=k,c=new WeakMap,i=new WeakMap;class D{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(j){this.v=j,this.q.$updateGroupLabel(this.t,this.handle,j)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(j){this.p=j,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(j){this.f=[...j],this.k.fire()}constructor(j,N,T,O,z,Q,Z){this.q=j,this.s=N,this.t=T,this.u=O,this.v=z,this.multiDiffEditorEnableViewChanges=Q,this.w=Z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new R.$7d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new R.$7d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=D.d++}getResourceState(j){return this.g.get(j)}$executeResourceCommand(j,N){const T=this.h.get(j);return T?(0,L.$ah)(()=>this.s.executeCommand(T.command,...T.arguments||[],N)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const j=[...this.f].sort(g),T=(0,$.$Db)(this.o,j,g).map(Q=>{const Z=Q.toInsert.map(J=>{const x=this.e++;this.g.set(x,J);const ce=J.resourceUri;let te;if(J.command)if(J.command.command==="vscode.open"||J.command.command==="vscode.diff"||J.command.command==="vscode.changes"){const le=new M.$Tc;te=this.s.converter.toInternal(J.command,le),this.j.set(x,le)}else this.h.set(x,J.command);const pe=(0,y.$cG)(this.w,"scmMultiDiffEditor"),ye=pe?J.multiDiffEditorOriginalUri:void 0,_=pe?J.multiFileDiffEditorModifiedUri:void 0,U=f(J.decorations),he=J.decorations&&f(J.decorations.light)||U,Se=J.decorations&&f(J.decorations.dark)||U,me=[he,Se],ie=J.decorations&&J.decorations.tooltip||"",se=J.decorations&&!!J.decorations.strikeThrough,oe=J.decorations&&!!J.decorations.faded,G=J.contextValue||"";return{rawResource:[x,ce,me,ie,se,oe,G,te,ye,_],handle:x}});return{start:Q.start,deleteCount:Q.deleteCount,toInsert:Z}}),O=T.map(({start:Q,deleteCount:Z,toInsert:J})=>[Q,Z,J.map(x=>x.rawResource)]),z=T.reverse();for(const{start:Q,deleteCount:Z,toInsert:J}of z){const x=J.map(te=>te.handle),ce=this.n.splice(Q,Z,...x);for(const te of ce)this.g.delete(te),this.h.delete(te),this.j.get(te)?.dispose(),this.j.delete(te)}return this.o=j,O}dispose(){this.l=!0,this.m.fire()}}D.d=0;class F{get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(j){this.g!==j&&(this.g=j,qe(this,n,"f").$updateSourceControl(this.w,{count:j}))}get quickDiffProvider(){return this.h}set quickDiffProvider(j){this.h=j;let N;(0,y.$cG)(this.x,"quickDiffProvider")&&(N=j?.label),qe(this,n,"f").$updateSourceControl(this.w,{hasQuickDiffProvider:!!j,quickDiffLabel:N})}get historyProvider(){return(0,y.$dG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(j){(0,y.$dG)(this.x,"scmHistoryProvider"),this.j=j,this.k.value=new M.$Tc,qe(this,n,"f").$updateSourceControl(this.w,{hasHistoryProvider:!!j}),j&&this.k.value.add(j.onDidChangeCurrentHistoryItemGroup(()=>{this.l=j?.currentHistoryItemGroup,qe(this,n,"f").$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(j){j!==this.m&&(this.m=j,qe(this,n,"f").$updateSourceControl(this.w,{commitTemplate:j}))}get acceptInputCommand(){return this.o}set acceptInputCommand(j){this.n.value=new M.$Tc,this.o=j;const N=this.y.converter.toInternal(j,this.n.value);qe(this,n,"f").$updateSourceControl(this.w,{acceptInputCommand:N})}get actionButton(){return(0,y.$dG)(this.x,"scmActionButton"),this.q}set actionButton(j){(0,y.$dG)(this.x,"scmActionButton"),this.p.value=new M.$Tc,this.q=j;const N=j!==void 0?{command:this.y.converter.toInternal(j.command,this.p.value),secondaryCommands:j.secondaryCommands?.map(T=>T.map(O=>this.y.converter.toInternal(O,this.p.value))),description:j.description,enabled:j.enabled}:void 0;qe(this,n,"f").$updateSourceControl(this.w,{actionButton:N??null})}get statusBarCommands(){return this.t}set statusBarCommands(j){if(this.t&&j&&S(this.t,j))return;this.s.value=new M.$Tc,this.t=j;const N=(j||[]).map(T=>this.y.converter.toInternal(T,this.s.value));qe(this,n,"f").$updateSourceControl(this.w,{statusBarCommands:N})}get selected(){return this.u}constructor(j,N,T,O,z,Q,Z){this.x=j,this.y=O,this.z=z,this.A=Q,this.B=Z,n.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Vc,this.m=void 0,this.n=new M.$Vc,this.o=void 0,this.p=new M.$Vc,this.s=new M.$Vc,this.t=void 0,this.u=!1,this.v=new R.$7d,this.onDidChangeSelection=this.v.event,this.w=F.d++,this.C=new Map,this.D=new Set,it(this,n,T,"f");const J=o.URI.from({scheme:a.Schemas.vscodeSourceControl,path:`${z}/scm${this.w}/input`,query:Z?`rootUri=${encodeURIComponent(Z.toString())}`:void 0});this.f=new k(j,N,qe(this,n,"f"),this.w,J),qe(this,n,"f").$registerSourceControl(this.w,z,Q,Z,J)}createResourceGroup(j,N,T){const O=(0,y.$cG)(this.x,"scmMultiDiffEditor")&&T?.multiDiffEditorEnableViewChanges===!0,z=new D(qe(this,n,"f"),this.y,this.w,j,N,O,this.x),Q=R.Event.once(z.onDidDispose)(()=>this.C.delete(z));return this.C.set(z,Q),this.eventuallyAddResourceGroups(),z}eventuallyAddResourceGroups(){const j=[],N=[];for(const[T,O]of this.C){O.dispose();const z=T.onDidUpdateResourceStates(()=>{this.D.add(T),this.eventuallyUpdateResourceStates()});R.Event.once(T.onDidDispose)(()=>{this.D.delete(T),z.dispose(),this.e.delete(T.handle),qe(this,n,"f").$unregisterGroup(this.w,T.handle)}),j.push([T.handle,T.id,T.label,T.features,T.multiDiffEditorEnableViewChanges]);const Q=T._takeResourceStateSnapshot();Q.length>0&&N.push([T.handle,Q]),this.e.set(T.handle,T)}qe(this,n,"f").$registerGroups(this.w,j,N),this.C.clear()}eventuallyUpdateResourceStates(){const j=[];this.D.forEach(N=>{const T=N._takeResourceStateSnapshot();T.length!==0&&j.push([N.handle,T])}),j.length>0&&qe(this,n,"f").$spliceResourceStates(this.w,j),this.D.clear()}getResourceGroup(j){return this.e.get(j)}setSelectionState(j){this.u=j,this.v.fire(j)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(j=>j.dispose()),qe(this,n,"f").$unregisterSourceControl(this.w)}}n=new WeakMap,F.d=0,Qe([(0,I.$Nh)(100)],F.prototype,"eventuallyAddResourceGroups",null),Qe([(0,I.$Nh)(100)],F.prototype,"eventuallyUpdateResourceStates",null);let W=r=class{get onDidChangeActiveProvider(){return this.j.event}constructor(j,N,T,O){this.l=N,this.m=T,this.n=O,this.g=new Map,this.h=new P.$Gm,this.j=new R.$7d,this.e=j.getProxy(p.$sM.MainThreadSCM),this.f=j.getProxy(p.$sM.MainThreadTelemetry),N.registerArgumentProcessor({processArgument:z=>{if(z&&z.$mid===3){const Q=this.g.get(z.sourceControlHandle);if(!Q)return z;const Z=Q.getResourceGroup(z.groupHandle);return Z?Z.getResourceState(z.handle):z}else if(z&&z.$mid===4){const Q=this.g.get(z.sourceControlHandle);return Q?Q.getResourceGroup(z.groupHandle):z}else if(z&&z.$mid===5){const Q=this.g.get(z.handle);return Q||z}return z}})}createSourceControl(j,N,T,O){this.n.trace("ExtHostSCM#createSourceControl",j.identifier.value,N,T,O),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:j.identifier.value});const z=r.d++,Q=new F(j,this.m,this.e,this.l,N,T,O);this.g.set(z,Q);const Z=this.h.get(j.identifier)||[];return Z.push(Q),this.h.set(j.identifier,Z),Q}getLastInputBox(j){this.n.trace("ExtHostSCM#getLastInputBox",j.identifier.value);const N=this.h.get(j.identifier),T=N&&N[N.length-1];return T&&T.inputBox}$provideOriginalResource(j,N,T){const O=o.URI.revive(N);this.n.trace("ExtHostSCM#$provideOriginalResource",j,O.toString());const z=this.g.get(j);return!z||!z.quickDiffProvider||!z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.$ah)(()=>z.quickDiffProvider.provideOriginalResource(O,T)).then(Q=>Q||null)}$onInputBoxValueChange(j,N){this.n.trace("ExtHostSCM#$onInputBoxValueChange",j);const T=this.g.get(j);return T&&T.inputBox.$onInputBoxValueChange(N),Promise.resolve(void 0)}$executeResourceCommand(j,N,T,O){this.n.trace("ExtHostSCM#$executeResourceCommand",j,N,T);const z=this.g.get(j);if(!z)return Promise.resolve(void 0);const Q=z.getResourceGroup(N);return Q?Q.$executeResourceCommand(T,O):Promise.resolve(void 0)}$validateInput(j,N,T){this.n.trace("ExtHostSCM#$validateInput",j);const O=this.g.get(j);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,L.$ah)(()=>O.inputBox.validateInput(N,T)).then(z=>{if(!z)return Promise.resolve(void 0);const Q=C.MarkdownString.fromStrict(z.message);return Q?Promise.resolve([Q,z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(j){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",j),j!==void 0&&this.g.get(j)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=j,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(j,N,T,O){return await this.g.get(j)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(N,T,O)??void 0}async $provideHistoryItems(j,N,T,O){return(await this.g.get(j)?.historyProvider?.provideHistoryItems(N,T,O))?.map(Z=>({...Z,icon:d(Z)}))??void 0}async $provideHistoryItemSummary(j,N,T,O){const z=this.g.get(j)?.historyProvider;if(typeof z?.provideHistoryItemSummary!="function")return;const Q=await z.provideHistoryItemSummary(N,T,O);return Q?{...Q,icon:d(Q)}:void 0}async $provideHistoryItemChanges(j,N,T,O){return await this.g.get(j)?.historyProvider?.provideHistoryItemChanges(N,T,O)??void 0}};e.$mlc=W,W.d=0,e.$mlc=W=r=Qe([He(3,A.$Oj)],W)}),define(Ee[347],Ce([1,0,6,16,2]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nlc=void 0;class M{constructor(p,$){this.d=$,this.c=new Map,this.b=p.getProxy(o.$sM.MainThreadShare)}async $provideShare(p,$,w){return await this.c.get(p)?.provideShare({selection:R.Range.to($.selection),resourceUri:I.URI.revive($.resourceUri)},w)??void 0}registerShareProvider(p,$){const w=M.a++;return this.c.set(w,$),this.b.$registerShareProvider(w,R.DocumentSelector.from(p,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(w),this.c.delete(w)}}}}e.$nlc=M,M.a=0});var it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o},qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Ee[348],Ce([1,0,7,6,225,3,16,18]),function(re,e,o,R,I,M,L,p){"use strict";var $,w;Object.defineProperty(e,"__esModule",{value:!0}),e.$qlc=e.$plc=void 0;class A{constructor(y,a,m,c,i,n=o.StatusBarAlignment.Left,r){if($.set(this,void 0),w.set(this,void 0),this.i=!1,this.k="",this.q=new M.$Tc,it(this,$,y,"f"),it(this,w,a,"f"),i&&c){this.c=(0,o.$6M)(c.identifier,i);const s=m.get(this.c);s&&(n=s.alignLeft?o.StatusBarAlignment.Left:o.StatusBarAlignment.Right,r=s.priority,this.j=!0,this.name=s.name,this.text=s.text,this.tooltip=s.tooltip,this.command=s.command,this.accessibilityInformation=s.accessibilityInformation)}else this.c=String(A.a++);this.e=c,this.f=i,this.g=n,this.h=this.u(r)}u(y){if((0,p.$Zf)(y))return y===Number.POSITIVE_INFINITY?Number.MAX_VALUE:y===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:y}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(y){this.k=y,this.v()}set name(y){this.m=y,this.v()}set tooltip(y){this.l=y,this.v()}set color(y){this.n=y,this.v()}set backgroundColor(y){y&&!A.b.has(y.id)&&(y=void 0),this.o=y,this.v()}set command(y){this.r?.fromApi!==y&&(this.p&&this.q.add(this.p),this.p=new M.$Tc,typeof y=="string"?this.r={fromApi:y,internal:qe(this,w,"f").toInternal({title:"",command:y},this.p)}:y?this.r={fromApi:y,internal:qe(this,w,"f").toInternal(y,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(y){this.t=y,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,qe(this,$,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let y;this.e?this.f?y=`${this.e.identifier.value}.${this.f}`:y=this.e.identifier.value:y=this.f;let a;this.m?a=this.m:a=(0,I.localize)(0,null,this.e.displayName||this.e.name);let m=this.n;this.o&&(m=A.b.get(this.o.id));const c=L.MarkdownString.fromStrict(this.l);qe(this,$,"f").$setEntry(this.c,y,this.e?.identifier.value,a,this.k,c,this.r?.internal,m,this.o,this.g===o.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$plc=A,$=new WeakMap,w=new WeakMap,A.a=0,A.b=new Map([["statusBarItem.errorBackground",new o.$rN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new o.$rN("statusBarItem.warningForeground")]]);class P{constructor(y){this.b=[],this.a=y.createStatusBarEntry(void 0,"status.extensionMessage",o.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(y){const a={message:y};return this.b.unshift(a),this.c(),new o.$uM(()=>{const m=this.b.indexOf(a);m>=0&&(this.b.splice(m,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class b{constructor(y,a){this.e=new Map,this.a=y.getProxy(R.$sM.MainThreadStatusBar),this.b=a,this.c=new P(this)}$acceptStaticEntries(y){for(const a of y)this.e.set(a.entryId,a)}createStatusBarEntry(y,a,m,c){return new A(this.a,this.b,this.e,y,a,m,c)}setStatusBarMessage(y,a){const m=this.c.setMessage(y);let c;return typeof a=="number"?c=setTimeout(()=>m.dispose(),a):typeof a<"u"&&a.then(()=>m.dispose(),()=>m.dispose()),new o.$uM(()=>{m.dispose(),clearTimeout(c)})}}e.$qlc=b}),define(Ee[155],Ce([1,0,29,145,67,113,89,16,2]),function(re,e,o,R,I,M,L,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=e.$3O=e.$2O=e.$1O=void 0;const w=(n,r,s,t)=>{let f=r;return{enumerable:!0,configurable:!1,get(){return f},set(d){if(!s(f,d)){const u=f;f=d,n.listener?.(t(d,u))}}}},A=(n,r)=>n===r,P={range:(n,r)=>n===r?!0:!n||!r?!1:n.isEqual(r),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(n,r)=>!(n.length!==r.length||n.some(s=>!r.find(t=>s.id===t.id)))},b=n=>r=>({op:4,update:n(r)}),C=(n,r)=>({range:(()=>{let s;const t=b(f=>({range:o.$dt.lift(p.Range.from(f))}));return{enumerable:!0,configurable:!1,get(){return s},set(f){n.listener?.({op:6}),P.range(s,f)||(s=f,n.listener?.(t(f)))}}})(),label:w(n,r,P.label,b(s=>({label:s}))),description:w(n,void 0,P.description,b(s=>({description:s}))),sortText:w(n,void 0,P.sortText,b(s=>({sortText:s}))),canResolveChildren:w(n,!1,P.canResolveChildren,s=>({op:2,state:s})),busy:w(n,!1,P.busy,b(s=>({busy:s}))),error:w(n,void 0,P.error,b(s=>({error:p.MarkdownString.fromStrict(s)||null}))),tags:w(n,[],P.tags,(s,t)=>({op:1,new:s.map(p.TestTag.from),old:t.map(p.TestTag.from)}))}),y=n=>{const r=I.$eL.fromString(n.extId),s=new m(r.controllerId,r.localId,n.label,$.URI.revive(n.uri)||void 0);return s.range=p.Range.to(n.range||void 0),s.description=n.description||void 0,s.sortText=n.sortText||void 0,s.tags=n.tags.map(t=>p.TestTag.to({id:(0,L.$kL)(t).tagId})),s},a=n=>{let r;for(const s of n.tests){const t=y(s.item);(0,R.$KO)(t).parent=r,r=t}return r};e.$1O=a;class m{constructor(r,s,t,f){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const d=(0,R.$JO)(this,r);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:f,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof c?void 0:d.parent}},children:{value:(0,M.$IO)(d,R.$KO,m),enumerable:!0,writable:!1},...C(d,t)})}}e.$2O=m;class c extends m{constructor(r,s){super(r,r,s,void 0),this._isRoot=!0}}e.$3O=c;class i extends M.$EO{constructor(r,s,t){super({controllerId:r,getDocumentVersion:f=>f&&t.getDocument(f)?.version,getApiFor:R.$KO,getChildren:f=>f.children,root:new c(r,s),toITestItem:p.TestItem.from})}}e.$4O=i});var it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o},qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Ee[33],Ce([1,0,18,7,16,24,6,19,12,57,29,52,2,3,5,20,155,21,68,47,40,87,90,30]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i,n,r,s,t,f){"use strict";var d,u,h;Object.defineProperty(e,"__esModule",{value:!0}),e.$cP=e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=void 0;let l=class{constructor(D,F,W){d.set(this,void 0),this.b=new Map,this.c=new Map,u.set(this,void 0),h.set(this,void 0),it(this,d,D.getProxy(L.$sM.MainThreadCommands),"f"),this.d=F,it(this,h,W,"f"),it(this,u,D.getProxy(L.$sM.MainThreadTelemetry),"f"),this.converter=new g(this,B=>{const j=this.c.get(B);return j?.result===v.Void?j:void 0},F),this.f=[{processArgument(B){return(0,w.$Rh)(B)}},{processArgument(B){return(0,M.$Rn)(B,function(j){if(A.$dt.isIRange(j))return I.Range.to(j);if(P.$ct.isIPosition(j))return I.Position.to(j);if(A.$dt.isIRange(j.range)&&b.URI.isUri(j.uri))return I.location.to(j);if(j instanceof c.$ue)return j.buffer.buffer;if(!Array.isArray(j))return j})}}]}registerArgumentProcessor(D){this.f.push(D)}registerApiCommand(D){const F=this.registerCommand(!1,D.id,async(...W)=>{const B=D.args.map((N,T)=>{if(!N.validate(W[T]))throw new Error(`Invalid argument '${N.name}' when running '${D.id}', received: ${typeof W[T]=="object"?JSON.stringify(W[T],null,"	"):W[T]} `);return N.convert(W[T])}),j=await this.executeCommand(D.internalId,...B);return D.result.convert(j,W,this.converter)},void 0,{description:D.description,args:D.args,returns:D.result.description});return this.c.set(D.id,D),new R.$uM(()=>{F.dispose(),this.c.delete(D.id)})}registerCommand(D,F,W,B,j,N){if(this.d.trace("ExtHostCommands#registerCommand",F),!F.trim().length)throw new Error("invalid id");if(this.b.has(F))throw new Error(`command '${F}' already exists`);return this.b.set(F,{callback:W,thisArg:B,metadata:j,extension:N}),D&&qe(this,d,"f").$registerCommand(F),new R.$uM(()=>{this.b.delete(F)&&D&&qe(this,d,"f").$unregisterCommand(F)})}executeCommand(D,...F){return this.d.trace("ExtHostCommands#executeCommand",D),this.g(D,F,!0)}async g(D,F,W){if(this.b.has(D))return qe(this,d,"f").$fireCommandActivationEvent(D),this.h(D,F,!1);{let B=!1;const j=(0,M.$Rn)(F,function(N){if(N instanceof R.$vM)return I.Position.from(N);if(N instanceof R.$wM)return I.Range.from(N);if(N instanceof R.$GM)return I.location.from(N);if(R.$VN.isNotebookRange(N))return I.NotebookRange.from(N);if(N instanceof ArrayBuffer)return B=!0,c.$ue.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return B=!0,c.$ue.wrap(N);if(N instanceof c.$ue)return B=!0,N;if(!Array.isArray(N))return N});try{const N=await qe(this,d,"f").$executeCommand(D,B?new i.$fw(j):j,W);return(0,w.$Rh)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(D,F,!1);throw N}}}async h(D,F,W){const B=this.b.get(D);if(!B)throw new Error("Unknown command");const{callback:j,thisArg:N,metadata:T}=B;if(T?.args)for(let z=0;z<T.args.length;z++)try{(0,o.$ag)(F[z],T.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${D}' failed. Illegal argument '${T.args[z].name}' - ${T.args[z].description}`)}const O=r.$3d.create();try{return await j.apply(N,F)}catch(z){if(D===this.converter.delegatingCommandId){const Q=this.converter.getActualCommand(...F);Q&&(D=Q.command)}if(this.d.error(z,D,B.extension?.identifier),!W)throw z;if(B.extension?.identifier){const Q=qe(this,h,"f").onExtensionError(B.extension.identifier,z);this.d.trace("forwarded error to extension?",Q,B.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$6i)(z)),this.id=D,this.source=B.extension?.displayName??B.extension?.name}}}finally{this.j(B,D,O.elapsed())}}j(D,F,W){D.extension&&qe(this,u,"f").$publicLog2("Extension:ActionExecuted",{extensionId:D.extension.identifier.value,id:new s.$5o(F),duration:W})}$executeContributedCommand(D,...F){this.d.trace("ExtHostCommands#$executeContributedCommand",D);const W=this.b.get(D);return W?(F=F.map(B=>this.f.reduce((j,N)=>N.processArgument(j,W.extension?.identifier),B)),this.h(D,F,!0)):Promise.reject(new Error(`Contributed command '${D}' does not exist.`))}getCommands(D=!1){return this.d.trace("ExtHostCommands#getCommands",D),qe(this,d,"f").$getCommands().then(F=>(D&&(F=F.filter(W=>W[0]!=="_")),F))}$getContributedCommandMetadata(){const D=Object.create(null);for(const[F,W]of this.b){const{metadata:B}=W;B&&(D[F]=B)}return Promise.resolve(D)}};e.$0O=l,d=new WeakMap,u=new WeakMap,h=new WeakMap,e.$0O=l=Qe([He(0,a.$OO),He(1,$.$Oj),He(2,t.$9O)],l),e.$$O=(0,y.$ii)("IExtHostCommands");class g{constructor(D,F,W){this.d=D,this.f=F,this.g=W,this.delegatingCommandId=`__vsc${(0,f.$Eg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(D,F){if(!D)return;const W={$ident:void 0,id:D.command,title:D.title,tooltip:D.tooltip};if(!D.command)return W;const B=this.f(D.command);if(B)W.id=B.internalId,W.arguments=B.args.map((j,N)=>j.convert(D.arguments&&D.arguments[N]));else if((0,p.$Lb)(D.arguments)){const j=`${D.command} /${++this.c}`;this.b.set(j,D),F.add((0,C.$Sc)(()=>{this.b.delete(j),this.g.trace("CommandsConverter#DISPOSE",j)})),W.$ident=j,W.id=this.delegatingCommandId,W.arguments=[j],this.g.trace("CommandsConverter#CREATE",D.command,j)}return W}fromInternal(D){return typeof D.$ident=="string"?this.b.get(D.$ident):{command:D.id,title:D.title,arguments:D.arguments}}getActualCommand(...D){return this.b.get(D[0])}h(...D){const F=this.getActualCommand(...D);return this.g.trace("CommandsConverter#EXECUTE",D[0],F?F.command:"MISSING"),F?this.d.executeCommand(F.command,...F.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${D[0]}`)}}e.$_O=g;class E{static Arr(D){return new E(`${D.name}_array`,`Array of ${D.name}, ${D.description}`,F=>Array.isArray(F)&&F.every(W=>D.validate(W)),F=>F.map(W=>D.convert(W)))}constructor(D,F,W,B){this.name=D,this.description=F,this.validate=W,this.convert=B}optional(){return new E(this.name,`(optional) ${this.description}`,D=>D==null||this.validate(D),D=>D===void 0?void 0:D===null?null:this.convert(D))}with(D,F){return new E(D??this.name,F??this.description,this.validate,this.convert)}}e.$aP=E,E.Uri=new E("uri","Uri of a text document",k=>b.URI.isUri(k),k=>k),E.Position=new E("position","A position in a text document",k=>R.$vM.isPosition(k),I.Position.from),E.Range=new E("range","A range in a text document",k=>R.$wM.isRange(k),I.Range.from),E.Selection=new E("selection","A selection in a text document",k=>R.$xM.isSelection(k),I.Selection.from),E.Number=new E("number","",k=>typeof k=="number",k=>k),E.String=new E("string","",k=>typeof k=="string",k=>k),E.StringArray=E.Arr(E.String),E.CallHierarchyItem=new E("item","A call hierarchy item",k=>k instanceof R.$RM,I.CallHierarchyItem.from),E.TypeHierarchyItem=new E("item","A type hierarchy item",k=>k instanceof R.$dO,I.TypeHierarchyItem.from),E.TestItem=new E("testItem","A VS Code TestItem",k=>k instanceof m.$2O,I.TestItem.from);class v{constructor(D,F){this.description=D,this.convert=F}}e.$bP=v,v.Void=new v("no result",k=>k);class S{constructor(D,F,W,B,j){this.id=D,this.internalId=F,this.description=W,this.args=B,this.result=j}}e.$cP=S}),define(Ee[349],Ce([1,0,19,15,2,83,135,42,33,16,7]),function(re,e,o,R,I,M,L,p,$,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jjc=void 0;const P=[new $.$cP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$aP.Uri,$.$aP.Position],new $.$bP("A promise that resolves to an array of DocumentHighlight-instances.",C(w.DocumentHighlight.to))),new $.$cP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$aP.Uri],new $.$bP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,m)=>{if((0,o.$Kb)(a))return;class c extends A.$MM{static to(n){const r=new c(n.name,w.SymbolKind.to(n.kind),n.containerName||"",new A.$GM(m[0],w.Range.to(n.range)));return r.detail=n.detail,r.range=r.location.range,r.selectionRange=w.Range.to(n.selectionRange),r.children=n.children?n.children.map(c.to):[],r}}return a.map(c.to)})),new $.$cP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$aP.Uri,new $.$aP("options","Formatting options",a=>!0,a=>a)],new $.$bP("A promise that resolves to an array of TextEdits.",C(w.TextEdit.to))),new $.$cP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$aP.Uri,$.$aP.Range,new $.$aP("options","Formatting options",a=>!0,a=>a)],new $.$bP("A promise that resolves to an array of TextEdits.",C(w.TextEdit.to))),new $.$cP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$aP.Uri,$.$aP.Position,new $.$aP("ch","Trigger character",a=>typeof a=="string",a=>a),new $.$aP("options","Formatting options",a=>!0,a=>a)],new $.$bP("A promise that resolves to an array of TextEdits.",C(w.TextEdit.to))),new $.$cP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$aP.Uri,$.$aP.Position],new $.$bP("A promise that resolves to an array of Location or LocationLink instances.",y)),new $.$cP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$aP.Uri,$.$aP.Position],new $.$bP("A promise that resolves to an array of Location or LocationLink instances.",y)),new $.$cP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$aP.Uri,$.$aP.Position],new $.$bP("A promise that resolves to an array of Location or LocationLink instances.",y)),new $.$cP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$aP.Uri,$.$aP.Position],new $.$bP("A promise that resolves to an array of Location or LocationLink instances.",y)),new $.$cP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$aP.Uri,$.$aP.Position],new $.$bP("A promise that resolves to an array of Location-instances.",C(w.location.to))),new $.$cP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$aP.Uri,$.$aP.Position],new $.$bP("A promise that resolves to an array of Hover-instances.",C(w.Hover.to))),new $.$cP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$aP.Uri,new $.$aP("position","A position in a text document",a=>Array.isArray(a)&&a.every(m=>A.$vM.isPosition(m)),a=>a.map(w.Position.from))],new $.$bP("A promise that resolves to an array of ranges.",a=>a.map(m=>{let c;for(const i of m.reverse())c=new A.$QM(w.Range.to(i),c);return c}))),new $.$cP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$aP.String.with("query","Search string")],new $.$bP("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(w.WorkspaceSymbol.to))),new $.$cP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$aP.Uri,$.$aP.Position],new $.$bP("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(w.CallHierarchyItem.to))),new $.$cP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$aP.CallHierarchyItem],new $.$bP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(w.CallHierarchyIncomingCall.to))),new $.$cP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$aP.CallHierarchyItem],new $.$bP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(w.CallHierarchyOutgoingCall.to))),new $.$cP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$aP.Uri,$.$aP.Position],new $.$bP("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:w.Range.to(a.range),placeholder:a.text}})),new $.$cP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$aP.Uri,$.$aP.Position,$.$aP.String.with("newName","The new symbol name")],new $.$bP("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return w.WorkspaceEdit.to(a)}})),new $.$cP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$aP.Uri,$.$aP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$bP("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(w.DocumentLink.to))),new $.$cP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$aP.Uri],new $.$bP("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new A.$MN(a.tokenTypes,a.tokenModifiers)})),new $.$cP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$aP.Uri],new $.$bP("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,L.$Zab)(a);if(m.type==="full")return new A.$ON(m.data,void 0)})),new $.$cP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$aP.Uri,$.$aP.Range.optional()],new $.$bP("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new A.$MN(a.tokenTypes,a.tokenModifiers)})),new $.$cP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$aP.Uri,$.$aP.Range],new $.$bP("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,L.$Zab)(a);if(m.type==="full")return new A.$ON(m.data,void 0)})),new $.$cP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$aP.Uri,$.$aP.Position,$.$aP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$aP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$bP("A promise that resolves to a CompletionList-instance.",(a,m,c)=>{if(!a)return new A.$3M([]);const i=a.suggestions.map(n=>w.CompletionItem.to(n,c));return new A.$3M(i,a.incomplete)})),new $.$cP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$aP.Uri,$.$aP.Position,$.$aP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$bP("A promise that resolves to SignatureHelp.",a=>{if(a)return w.SignatureHelp.to(a)})),new $.$cP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$aP.Uri,$.$aP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$bP("A promise that resolves to an array of CodeLens-instances.",(a,m,c)=>C(i=>new A.$UM(w.Range.to(i.range),i.command&&c.fromInternal(i.command)))(a))),new $.$cP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$aP.Uri,new $.$aP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>A.$wM.isRange(a),a=>A.$xM.isSelection(a)?w.Selection.from(a):w.Range.from(a)),$.$aP.String.with("kind","Code action kind to return code actions for").optional(),$.$aP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$bP("A promise that resolves to an array of Command-instances.",(a,m,c)=>C(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(i.command)}else{const n=new A.$OM(i.title,i.kind?new A.$PM(i.kind):void 0);return i.edit&&(n.edit=w.WorkspaceEdit.to(i.edit)),i.command&&(n.command=c.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(a))),new $.$cP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$aP.Uri],new $.$bP("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(m=>new A.$9M(w.Range.to(m.range),w.Color.to(m.color))):[])),new $.$cP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$aP("color","The color to show and insert",a=>a instanceof A.$8M,w.Color.from),new $.$aP("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:w.Range.from(a.range)}))],new $.$bP("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(w.ColorPresentation.to):[])),new $.$cP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$aP.Uri,$.$aP.Range],new $.$bP("A promise that resolves to an array of Inlay objects",(a,m,c)=>a.map(w.InlayHint.to.bind(void 0,c)))),new $.$cP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$aP.Uri],new $.$bP("A promise that resolves to an array of FoldingRange objects",(a,m)=>{if(a)return a.map(w.FoldingRange.to)})),new $.$cP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$bP("A promise that resolves to an array of NotebookContentProvider static info objects.",C(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(m=>w.NotebookExclusiveDocumentPattern.to(m))})))),new $.$cP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$aP.Uri,$.$aP.Range,new $.$aP("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof A.$wM,a=>w.InlineValueContext.from(a))],new $.$bP("A promise that resolves to an array of InlineValue objects",a=>a.map(w.InlineValue.to))),new $.$cP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$aP("uriOrString","Uri-instance or string (only http/https)",a=>I.URI.isUri(a)||typeof a=="string"&&(0,R.$sg)(a,R.Schemas.http,R.Schemas.https),a=>a),new $.$aP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[w.ViewColumn.from(a),void 0]:[w.ViewColumn.from(a.viewColumn),w.TextEditorOpenOptions.from(a)])).optional(),$.$aP.String.with("label","").optional()],$.$bP.Void),new $.$cP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$aP.Uri.with("resource","Resource to open"),$.$aP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$aP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[w.ViewColumn.from(a),void 0]:[w.ViewColumn.from(a.viewColumn),w.TextEditorOpenOptions.from(a)])).optional()],$.$bP.Void),new $.$cP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$aP.Uri.with("left","Left-hand side resource of the diff editor"),$.$aP.Uri.with("right","Right-hand side resource of the diff editor"),$.$aP.String.with("title","Human readable title for the diff editor").optional(),new $.$aP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[w.ViewColumn.from(a.viewColumn),w.TextEditorOpenOptions.from(a)]).optional()],$.$bP.Void),new $.$cP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$aP.String.with("title","Human readable title for the changes editor"),new $.$aP("resourceList","List of resources to compare",a=>{for(const m of a){if(m.length!==3)return!1;const[c,i,n]=m;if(!I.URI.isUri(c)||!I.URI.isUri(i)&&i!==void 0&&i!==null||!I.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},a=>a)],$.$bP.Void),new $.$cP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$aP.Uri,$.$aP.Position],new $.$bP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(w.TypeHierarchyItem.to))),new $.$cP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$aP.TypeHierarchyItem],new $.$bP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(w.TypeHierarchyItem.to))),new $.$cP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$aP.TypeHierarchyItem],new $.$bP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(w.TypeHierarchyItem.to))),new $.$cP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$aP.TestItem],$.$bP.Void),new $.$cP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$aP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$bP.Void),new $.$cP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$aP.String.with("name","The context key name"),new $.$aP("value","The context key value",()=>!0,a=>a)],$.$bP.Void),new $.$cP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$aP.Uri,$.$aP.StringArray,new $.$aP("MappedEditsContext","Mapped Edits Context",a=>w.MappedEditsContext.is(a),a=>w.MappedEditsContext.from(a))],new $.$bP("A promise that resolves to a workspace edit or null",a=>a?w.WorkspaceEdit.to(a):null))];class b{static register(m){P.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",p.$hj)}}e.$Jjc=b;function C(a){return m=>{if(Array.isArray(m))return m.map(a)}}function y(a){if(!Array.isArray(a))return;const m=[];for(const c of a)M.$4t(c)?m.push(w.DefinitionLink.to(c)):m.push(w.location.to(c));return m}}),define(Ee[350],Ce([1,0,8,3,2,6,33,16,7]),function(re,e,o,R,I,M,L,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tkc=void 0;class w{constructor(C,y){this.extension=C,this.provider=y,this.handle=w.a++}}w.a=0;class A{constructor(C){this.session=C,this.responses=[]}}class P{constructor(C,y,a,m){this.f=a,this.g=m,this.b=new Map,this.d=new Map,this.e=C.getProxy(M.$sM.MainThreadInlineChat),y.registerApiCommand(new L.$cP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new L.$aP("Run arguments","",c=>!0,c=>{if(c)return{initialRange:c.initialRange?p.Range.from(c.initialRange):void 0,initialSelection:$.$xM.isSelection(c.initialSelection)?p.Selection.from(c.initialSelection):void 0,message:c.message,autoSend:c.autoSend,position:c.position?p.Position.from(c.position):void 0}})],L.$bP.Void))}registerProvider(C,y,a){const m=new w(C,y);return this.b.set(m.handle,m),this.e.$registerInteractiveEditorProvider(m.handle,a?.label??C.displayName??C.name,C.identifier,typeof y.handleInteractiveEditorResponseFeedback=="function",typeof y.provideFollowups=="function",a?.supportReportIssue??!1),(0,R.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(m.handle),this.b.delete(m.handle)})}async $prepareSession(C,y,a,m){const c=this.b.get(C);if(!c){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(I.URI.revive(y)),n=p.Selection.to(a),r=await c.provider.prepareInteractiveEditorSession({document:i,selection:n},m);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const s=P.a++;return this.d.set(s,new A(r)),{id:s,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:p.Range.from(r.wholeRange),message:r.message}}async $provideResponse(C,y,a,m){const c=this.b.get(C);if(!c)return;const i=this.d.get(y.id);if(!i)return;const n={prompt:a.prompt,selection:p.Selection.to(a.selection),wholeRange:p.Range.to(a.wholeRange),attempt:a.attempt,live:a.live,previewDocument:this.f.getDocument(I.URI.revive(a.previewDocument)),withIntentDetection:a.withIntentDetection};let r=!1;const s={report:async E=>{if(!a.live&&E.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||m.isCancellationRequested||await this.e.$handleProgressChunk(a.requestId,{message:E.message,edits:E.edits?.map(p.TextEdit.from),editsShouldBeInstant:E.editsShouldBeInstant,slashCommand:E.slashCommand?.command,markdownFragment:$.$VM.isMarkdownString(E.content)?E.content.value:E.content})}},t=Promise.resolve(c.provider.provideInteractiveEditorResponse(i.session,n,s,m));let f;try{f=await(0,o.$9g)(t,m)}finally{r=!0}if(!f)return;const d=i.responses.push(f)-1,u={wholeRange:p.Range.from(f.wholeRange),placeholder:f.placeholder};if(!P.h(f))return{...u,id:d,type:"editorEdit",message:p.MarkdownString.from(f.contents),edits:[]};const{edits:h,contents:l}=f,g=l!==void 0?p.MarkdownString.from(l):void 0;return h instanceof $.$EM?{...u,id:d,type:"bulkEdit",edits:p.WorkspaceEdit.from(h),message:g}:{...u,id:d,type:"editorEdit",edits:h.map(p.TextEdit.from),message:g}}async $provideFollowups(C,y,a,m){const c=this.b.get(C),i=this.d.get(y),n=i?.responses[a];if(c&&n&&c.provider.provideFollowups){const r=Promise.resolve(c.provider.provideFollowups(i.session,n,m));return(await(0,o.$9g)(r,m))?.map(p.ChatInlineFollowup.from)}}$handleFeedback(C,y,a,m){const c=this.b.get(C),i=this.d.get(y),n=i?.responses[a];if(c&&n){const r=p.InteractiveEditorResponseFeedbackKind.to(m);c.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,r)}}$releaseSession(C,y){}static h(C){return typeof C=="object"&&typeof C.edits=="object"}}e.$Tkc=P,P.a=0}),define(Ee[351],Ce([1,0,2,33]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7kc=void 0;class I{constructor(L,p,$,w,A){this.a=p,this.b=$,this.c=w;const P=new R.$cP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.$aP("showOptions","Show Options",b=>!0,b=>b),new R.$aP("resource","Interactive resource Uri",b=>!0,b=>b),new R.$aP("controllerId","Notebook controller Id",b=>!0,b=>b),new R.$aP("title","Interactive editor title",b=>!0,b=>b)],new R.$bP("Notebook and input URI",b=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",b.notebookEditorId),b.notebookEditorId!==void 0){const C=this.a.getEditorById(b.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",C.id),{notebookUri:o.URI.revive(b.notebookUri),inputUri:o.URI.revive(b.inputUri),notebookEditor:C.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",b.notebookUri,b.inputUri),{notebookUri:o.URI.revive(b.notebookUri),inputUri:o.URI.revive(b.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(L,p,$,w){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:$,uri:L,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(L,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.$7kc=I}),define(Ee[352],Ce([1,0,19,8,22,4,3,27,2,25,12,6,33,16,7,114,294,26,68,295]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=void 0,e.$dlc=h;let r=class{constructor(g,E,v,S,k){this.m=E,this.n=v,this.o=S,this.q=k,this.b=new p.$Bc,this.c=new p.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new M.$7d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=g.getProxy(P.$sM.MainThreadNotebookKernels);const D=new b.$cP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.$aP("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const B=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:B}}else if(W&&"notebookEditor"in W){const B=this.n.getIdByEditor(W.notebookEditor);if(B===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:B}}return W})],b.$bP.Void),F=new b.$cP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[b.$aP.Uri],new b.$bP("A promise that resolves to an array of variables",(W,B)=>W.map(j=>({variable:{name:j.name,value:j.value,expression:j.expression,type:j.type,language:j.language},hasNamedChildren:j.hasNamedChildren,indexedChildrenCount:j.indexedChildrenCount}))));this.o.registerApiCommand(D),this.o.registerApiCommand(F)}createNotebookController(g,E,v,S,k,D){for(const pe of this.j.values())if(pe.controller.id===E&&w.$Em.equals(g.identifier,pe.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const F=this.k++,W=this;this.q.trace(`NotebookController[${F}], CREATED by ${g.identifier.value}, ${E}`);const B=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${g.identifier}'`);let j=!1;const N=new M.$7d,T=new M.$7d,O={id:h(g.identifier,E),notebookType:v,extensionId:g.identifier,extensionLocation:g.extensionLocation,label:S||g.identifier.value,preloads:D?D.map(C.NotebookRendererScript.from):[]};let z=k??B,Q,Z;this.a.$addKernel(F,O).catch(pe=>{console.log(pe),j=!0});let J=0;const x=()=>{if(j)return;const pe=++J;Promise.resolve().then(()=>{pe===J&&this.a.$updateKernel(F,O)})},ce=new p.$Bc,te={get id(){return E},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return O.label},set label(pe){O.label=pe??g.displayName??g.name,x()},get detail(){return O.detail??""},set detail(pe){O.detail=pe,x()},get description(){return O.description??""},set description(pe){O.description=pe,x()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(pe){O.supportedLanguages=pe,x()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(pe){O.supportsExecutionOrder=pe,x()},get rendererScripts(){return O.preloads?O.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(pe){z=pe??B},get interruptHandler(){return Q},set interruptHandler(pe){Q=pe,O.supportsInterrupt=!!pe,x()},set variableProvider(pe){(0,c.$dG)(g,"notebookVariableProvider"),Z=pe,O.hasVariableProvider=!!pe,pe?.onDidChangeVariables(ye=>W.a.$variablesUpdated(ye.uri)),x()},get variableProvider(){return Z},createNotebookCellExecution(pe){if(j)throw new Error("notebook controller is DISPOSED");if(!ce.has(pe.notebook.uri))throw W.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.notebook.uri.toString()}`);return W._createNotebookCellExecution(pe,h(g.identifier,this.id))},createNotebookExecution(pe){if((0,c.$dG)(g,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!ce.has(pe.uri))throw W.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.uri.toString()}`);return W._createNotebookExecution(pe,h(g.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${F}], DISPOSED`),j=!0,this.j.delete(F),N.dispose(),T.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(pe,ye){ye===y.NotebookControllerAffinity2.Hidden&&(0,c.$dG)(g,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(F,pe.uri,ye)},onDidReceiveMessage:T.event,postMessage(pe,ye){return(0,c.$dG)(g,"notebookMessaging"),W.a.$postMessage(F,ye&&W.n.getIdByEditor(ye),pe)},asWebviewUri(pe){return(0,c.$dG)(g,"notebookMessaging"),(0,a.$Bzb)(pe,W.m.remote)}};return this.j.set(F,{extensionId:g.identifier,controller:te,onDidReceiveMessage:T,onDidChangeSelection:N,associatedNotebooks:ce}),te}getIdByController(g){for(const[E,v]of this.j)if(v.controller===g)return h(v.extensionId,g.id);return null}createNotebookControllerDetectionTask(g,E){const v=this.g++,S=this;this.q.trace(`NotebookControllerDetectionTask[${v}], CREATED by ${g.identifier.value}`),this.a.$addKernelDetectionTask(v,E);const k={dispose:()=>{this.f.delete(v),S.a.$removeKernelDetectionTask(v)}};return this.f.set(v,k),k}registerKernelSourceActionProvider(g,E,v){const S=this.i++,k=typeof v.onDidChangeNotebookKernelSourceActions=="function"?S:void 0,D=this;this.h.set(S,v),this.q.trace(`NotebookKernelSourceActionProvider[${S}], CREATED by ${g.identifier.value}`),this.a.$addKernelSourceActionProvider(S,S,E);let F;return k!==void 0&&(F=v.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(k))),{dispose:()=>{this.h.delete(S),D.a.$removeKernelSourceActionProvider(S,S),F?.dispose()}}}async $provideKernelSourceActions(g,E){const v=this.h.get(g);if(v){const S=new L.$Tc;return(await v.provideNotebookKernelSourceActions(E)??[]).map(D=>C.NotebookKernelSourceAction.from(D,this.o.converter,S))}return[]}$acceptNotebookAssociation(g,E,v){const S=this.j.get(g);if(S){const k=this.n.getNotebookDocument($.URI.revive(E));v?S.associatedNotebooks.set(k.uri,!0):S.associatedNotebooks.delete(k.uri),this.q.trace(`NotebookController[${g}] ASSOCIATE notebook`,k.uri.toString(),v),S.onDidChangeSelection.fire({selected:v,notebook:k.apiNotebook})}}async $executeCells(g,E,v){const S=this.j.get(g);if(!S)return;const k=this.n.getNotebookDocument($.URI.revive(E)),D=[];for(const F of v){const W=k.getCell(F);W&&D.push(W.apiCell)}try{this.q.trace(`NotebookController[${g}] EXECUTE cells`,k.uri.toString(),D.length),await S.controller.executeHandler.call(S.controller,D,k.apiNotebook,S.controller)}catch(F){this.q.error(`NotebookController[${g}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(g,E,v){const S=this.j.get(g);if(!S)return;const k=this.n.getNotebookDocument($.URI.revive(E));if(S.controller.interruptHandler)await S.controller.interruptHandler.call(S.controller,k.apiNotebook);else for(const D of v){const F=k.getCell(D);F&&this.b.get(F.uri)?.cancel()}if(S.controller.interruptHandler){const D=this.c.get(k.uri);v.length&&Array.isArray(D)&&D.length&&D.forEach(F=>F.dispose())}}async $provideVariables(g,E,v,S,k,D,F){const W=this.j.get(g);if(!W)return;const B=this.n.getNotebookDocument($.URI.revive(v)),j=W.controller.variableProvider;if(!j)return;let N;if(S!==void 0){if(N=this.s[S],!N)return}else this.s={};const T=k==="named"?y.NotebookVariablesRequestKind.Named:y.NotebookVariablesRequestKind.Indexed,O=j.provideVariables(B.apiNotebook,N,T,D,F);let z=0;for await(const Q of O){if(F.isCancellationRequested)return;const Z={id:this.r++,name:Q.variable.name,value:Q.variable.value,type:Q.variable.type,interfaces:Q.variable.interfaces,language:Q.variable.language,expression:Q.variable.expression,hasNamedChildren:Q.hasNamedChildren,indexedChildrenCount:Q.indexedChildrenCount,extensionId:W.extensionId.value};if(this.s[Z.id]=Q.variable,this.a.$receiveVariable(E,Z),z++>=n.$Whb)return}}$acceptKernelMessageFromRenderer(g,E,v){const S=this.j.get(g);if(!S)return;const k=this.n.getEditorById(E);S.onDidReceiveMessage.fire(Object.freeze({editor:k.apiEditor,message:v}))}$cellExecutionChanged(g,E,v){const k=this.n.getNotebookDocument($.URI.revive(g)).getCell(E);if(k){const D=v?C.NotebookCellExecutionState.to(v):y.NotebookCellExecutionState.Idle;D!==void 0&&this.l.fire({cell:k.apiCell,state:D})}}_createNotebookCellExecution(g,E){if(g.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const S=this.n.getNotebookDocument(g.notebook.uri).getCellFromApiCell(g);if(!S)throw new Error("invalid cell");if(this.b.has(S.uri))throw new Error(`duplicate execution for ${S.uri}`);const k=new t(E,S,this.a);this.b.set(S.uri,k);const D=k.onDidChangeState(()=>{k.state===s.Resolved&&(k.dispose(),D.dispose(),this.b.delete(S.uri))});return k.asApiObject()}_createNotebookExecution(g,E){const v=this.n.getNotebookDocument(g.uri),S=g.getCells().find(F=>{const W=v.getCellFromApiCell(F);return W&&this.b.has(W.uri)});if(S)throw new Error(`duplicate cell execution for ${S.document.uri}`);if(this.c.has(v.uri))throw new Error(`duplicate notebook execution for ${v.uri}`);const k=new d(E,v,this.a),D=k.onDidChangeState(()=>{k.state===f.Resolved&&(k.dispose(),D.dispose(),this.c.delete(v.uri))});return this.c.set(v.uri,[k,D]),k.asApiObject()}};e.$clc=r,e.$clc=r=Qe([He(4,A.$Oj)],r);var s;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(s||(s={}));class t extends L.$Uc{get state(){return this.f}constructor(g,E,v){super(),this.m=E,this.n=v,this.b=t.a++,this.c=new M.$7d,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new I.$ee),this.h=new u(10,S=>this.s(S)),this.j=E.internalMetadata.executionOrder,this.n.$createExecution(this.b,g,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(g){await this.h.addItem(g)}async s(g){const E=Array.isArray(g)?g:[g];return this.n.$updateExecution(this.b,new i.$fw(E))}t(){if(this.f===s.Init)throw new Error("Must call start before modifying cell output");if(this.f===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(g){let E=this.m;if(g&&(E=this.m.notebook.getCellFromApiCell(g)),!E)throw new Error("INVALID cell");return E.handle}y(g){return g.map(E=>{const v=y.$ZN.ensureUniqueMimeTypes(E.items,!0);return v===E.items?C.NotebookCellOutput.from(E):C.NotebookCellOutput.from({items:v,id:E.id,metadata:E.metadata})})}async z(g,E,v){const S=this.w(E),k=this.y((0,o.$3b)(g));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:S,append:v,outputs:k})}async C(g,E,v){return g=y.$ZN.ensureUniqueMimeTypes((0,o.$3b)(g),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:g.map(C.NotebookCellOutputItem.from),outputId:E.id,append:v})}asApiObject(){const g=this;return Object.freeze({get token(){return g.g.token},get cell(){return g.m.apiCell},get executionOrder(){return g.j},set executionOrder(v){g.j=v,g.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:g.j}])},start(v){if(g.f===s.Resolved||g.f===s.Started)throw new Error("Cannot call start again");g.f=s.Started,g.c.fire(),g.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:v})},end(v,S,k){if(g.f===s.Resolved)throw new Error("Cannot call resolve twice");g.f=s.Resolved,g.c.fire(),g.h.flush();const D=k?{message:k.message,stack:k.stack,location:k?.location?{startLineNumber:k.location.start.line,startColumn:k.location.start.character,endLineNumber:k.location.end.line,endColumn:k.location.end.character}:void 0,uri:k.uri}:void 0;g.n.$completeExecution(g.b,new i.$fw({runEndTime:S,lastRunSuccess:v,error:D}))},clearOutput(v){return g.t(),g.z([],v,!1)},appendOutput(v,S){return g.t(),g.z(v,S,!0)},replaceOutput(v,S){return g.t(),g.z(v,S,!1)},appendOutputItems(v,S){return g.t(),g.C(v,S,!0)},replaceOutputItems(v,S){return g.t(),g.C(v,S,!1)}})}}t.a=0;var f;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(f||(f={}));class d extends L.$Uc{get state(){return this.f}constructor(g,E,v){super(),this.h=E,this.j=v,this.b=d.a++,this.c=new M.$7d,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new I.$ee),this.j.$createNotebookExecution(this.b,g,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===f.Resolved||this.f===f.Started)throw new Error("Cannot call start again");this.f=f.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===f.Resolved)throw new Error("Cannot call resolve twice");this.f=f.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}d.a=0;class u{constructor(g,E){this.f=g,this.g=E,this.a=[],this.b=Date.now()}addItem(g){return this.a.push(g),this.c||(this.c=new R.$Fh,this.b=Date.now(),(0,R.$jh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const g=this.c;this.c=void 0;const E=this.a;return this.a=[],this.g(E).finally(()=>g.complete())}}function h(l,g){return`${l.value}/${g}`}}),define(Ee[44],Ce([1,0,4,6,5,2,20,3,7,227,13,272,22,30,273,56,8,16,33]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rkc=e.$qkc=e.$pkc=e.$okc=void 0,e.$okc=(0,I.$ii)("IExtHostTerminalService");class n extends p.$Uc{constructor(v,S,k,D){super(),this.u=v,this._id=S,this.w=k,this.y=D,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new o.$7d),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(W=>this.g=W);const F=this;this.value={get name(){return F.y||""},get processId(){return F.b},get creationOptions(){return F.w},get exitStatus(){return F.j},get state(){return F.m},get selection(){return F.n},get shellIntegration(){return F.shellIntegration},sendText(W,B=!0){F.C(),F.u.$sendText(F._id,W,B)},show(W){F.C(),F.u.$show(F._id,W)},hide(){F.C(),F.u.$hide(F._id)},dispose(){F.a||(F.a=!0,F.u.$dispose(F._id))},get dimensions(){if(!(F.f===void 0||F.h===void 0))return{columns:F.f,rows:F.h}}}}dispose(){this.s.fire(),super.dispose()}async create(v,S){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:v.name,shellPath:v.shellPath??void 0,shellArgs:v.shellArgs??void 0,cwd:v.cwd??S?.cwd??void 0,env:v.env??void 0,icon:h(v.iconPath)??void 0,color:a.ThemeColor.isThemeColor(v.color)?v.color.id:void 0,initialText:v.message??void 0,strictEnv:v.strictEnv??void 0,hideFromUser:v.hideFromUser??void 0,forceShellIntegration:S?.forceShellIntegration??void 0,isFeatureTerminal:S?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:S?.useShellEnvironment??void 0,location:S?.location||this.z(v.location,S?.resolvedExtHostIdentifier),isTransient:v.isTransient??void 0})}async createExtensionTerminal(v,S,k,D,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:D,color:a.ThemeColor.isThemeColor(F)?F.id:void 0,location:S?.location||this.z(v,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(v,S){return typeof v=="object"?"parentTerminal"in v&&v.parentTerminal&&S?{parentTerminal:S}:"viewColumn"in v?{viewColumn:c.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus}:void 0:v}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(v){this.y=v}setExitStatus(v,S){this.j=Object.freeze({code:v,reason:S})}setDimensions(v,S){return v===this.f&&S===this.h||v===0||S===0?!1:(this.f=v,this.h=S,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(v){this.n=v}_setProcessId(v){this.g?(this.g(v),this.g=void 0):this.b.then(S=>{S!==v&&(this.b=Promise.resolve(v))})}}e.$pkc=n;class r{get onProcessReady(){return this.b.event}constructor(v){this.g=v,this.id=0,this.shouldPersist=!1,this.a=new o.$7d,this.onProcessData=this.a.event,this.b=new o.$7d,this.d=new o.$7d,this.onDidChangeProperty=this.d.event,this.f=new o.$7d,this.onProcessExit=this.f.event}refreshProperty(v){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${v}`)}updateProperty(v,S){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${v}, value: ${S}`)}async start(){}shutdown(){this.g.close()}input(v){this.g.handleInput?.(v)}resize(v,S){this.g.setDimensions?.({columns:v,rows:S})}clearBuffer(){}async processBinary(v){}acknowledgeDataEvent(v){}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(v){this.g.onDidWrite(S=>this.a.fire(S)),this.g.onDidClose?.((S=void 0)=>{this.f.fire(S===void 0?void 0:S)}),this.g.onDidOverrideDimensions?.(S=>{S&&this.d.fire({type:"overrideDimensions",value:{cols:S.columns,rows:S.rows}})}),this.g.onDidChangeName?.(S=>{this.d.fire({type:"title",value:S})}),this.g.open(v||void 0),v&&this.g.setDimensions?.(v),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let s=1,t=class extends p.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(v=>v.value)}constructor(v,S,k){super(),this.Q=S,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new o.$7d,this.onDidCloseTerminal=this.H.event,this.I=new o.$7d,this.onDidOpenTerminal=this.I.event,this.J=new o.$7d,this.onDidChangeActiveTerminal=this.J.event,this.L=new o.$7d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new o.$7d,this.onDidChangeTerminalState=this.M.event,this.N=new o.$7d,this.onDidChangeShell=this.N.event,this.O=new o.$7d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new o.$7d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(R.$sM.MainThreadTerminalService),this.y=new y.$yub(this.a.$sendProcessData),this.a.$registerProcessSupport(v),this.Q.registerArgumentProcessor({processArgument:D=>{const F=W=>{const B=W;return this.getTerminalById(B.instanceId)?.value};switch(D?.$mid){case 15:return F(D);default:{if(Array.isArray(D))for(let W=0;W<D.length&&D[W].$mid===15;W++)D[W]=F(D[W]);return D}}}}),this.B({dispose:()=>{for(const[D,F]of this.g)F.shutdown(!0)}})}getDefaultShell(v){return(v?this.u:this.s)?.path||""}getDefaultShellArgs(v){return(v?this.u:this.s)?.args||[]}createExtensionTerminal(v,S){const k=new n(this.a,(0,C.$Eg)(),v,v.name),D=new r(v.pty);return k.createExtensionTerminal(v.location,S,this.R(v,S).resolvedExtHostIdentifier,h(v.iconPath),l(v.color)).then(F=>{const W=this.S(F,D);this.h[F]=W}),this.f.push(k),k.value}R(v,S){if(S=S||{},v.location&&typeof v.location=="object"&&"parentTerminal"in v.location){const k=v.location.parentTerminal;if(k){const D=this.f.find(F=>F.value===k);D&&(S.resolvedExtHostIdentifier=D._id)}}else v.location&&typeof v.location!="object"?S.location=v.location:S.location&&typeof S.location=="object"&&"splitActiveTerminal"in S.location&&(S.location={splitActiveTerminal:!0});return S}attachPtyToTerminal(v,S){if(!this.getTerminalById(v))throw new Error(`Cannot resolve terminal with id ${v} for virtual process`);const D=new r(S),F=this.S(v,D);this.h[v]=F}async $acceptActiveTerminalChanged(v){const S=this.b;if(v===null){this.b=void 0,S!==this.b&&this.J.fire(this.b);return}const k=this.getTerminalById(v);k&&(this.b=k,S!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(v,S){const k=this.getTerminalById(v);k&&this.O.fire({terminal:k.value,data:S})}async $acceptTerminalDimensions(v,S,k){const D=this.getTerminalById(v);D&&D.setDimensions(S,k)&&this.L.fire({terminal:D.value,dimensions:D.value.dimensions})}async $acceptDidExecuteCommand(v,S){const k=this.getTerminalById(v);k&&this.P.fire({terminal:k.value,...S})}async $acceptTerminalMaximumDimensions(v,S,k){this.g.get(v)?.resize(S,k)}async $acceptTerminalTitleChange(v,S){const k=this.getTerminalById(v);k&&(k.name=S)}async $acceptTerminalClosed(v,S,k){const D=this.X(this.f,v);if(D!==null){const F=this.f.splice(D,1)[0];F.setExitStatus(S,k),this.H.fire(F.value)}}$acceptTerminalOpened(v,S,k,D){if(S){const B=this.X(this.f,S);if(B!==null){this.f[B]._id=v,this.I.fire(this.terminals[B]),this.f[B].isOpen=!0;return}}const F={name:D.name,shellPath:D.executable,shellArgs:D.args,cwd:typeof D.cwd=="string"?D.cwd:M.URI.revive(D.cwd),env:D.env,hideFromUser:D.hideFromUser},W=new n(this.a,v,F,k);this.f.push(W),this.I.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(v,S){this.getTerminalById(v)?._setProcessId(S)}async $startExtensionTerminal(v,S){const k=this.getTerminalById(v);if(!k)return{message:(0,w.localize)(0,null,v)};k.isOpen||await new Promise(F=>{const W=this.onDidOpenTerminal(async B=>{B===k.value&&(W.dispose(),F())})});const D=this.g.get(v);D?D.startSendingEvents(S):this.j[v]={initialDimensions:S}}S(v,S){const k=new p.$Tc;k.add(S.onProcessReady(F=>this.a.$sendProcessReady(v,F.pid,F.cwd,F.windowsPty))),k.add(S.onDidChangeProperty(F=>this.a.$sendProcessProperty(v,F))),this.y.startBuffering(v,S.onProcessData),k.add(S.onProcessExit(F=>this.U(v,F))),this.g.set(v,S);const D=this.j[v];return D&&S instanceof r&&(S.startSendingEvents(D.initialDimensions),delete this.j[v]),k}$acceptProcessAckDataEvent(v,S){this.g.get(v)?.acknowledgeDataEvent(S)}$acceptProcessInput(v,S){this.g.get(v)?.input(S)}$acceptTerminalInteraction(v){const S=this.getTerminalById(v);S?.setInteractedWith()&&this.M.fire(S.value)}$acceptTerminalSelection(v,S){this.getTerminalById(v)?.setSelection(S)}$acceptProcessResize(v,S,k){try{this.g.get(v)?.resize(S,k)}catch(D){if(D.code!=="EPIPE"&&D.code!=="ERR_IPC_CHANNEL_CLOSED")throw D}}$acceptProcessShutdown(v,S){this.g.get(v)?.shutdown(S)}$acceptProcessRequestInitialCwd(v){this.g.get(v)?.getInitialCwd().then(S=>this.a.$sendProcessProperty(v,{type:"initialCwd",value:S}))}$acceptProcessRequestCwd(v){this.g.get(v)?.getCwd().then(S=>this.a.$sendProcessProperty(v,{type:"cwd",value:S}))}$acceptProcessRequestLatency(v){return Promise.resolve(v)}registerLinkProvider(v){return this.z.add(v),this.z.size===1&&this.a.$startLinkProvider(),new $.$uM(()=>{this.z.delete(v),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(v,S,k){if(this.C.has(S))throw new Error(`Terminal profile provider "${S}" already registered`);return this.C.set(S,k),this.a.$registerProfileProvider(S,v.identifier.value),new $.$uM(()=>{this.C.delete(S),this.a.$unregisterProfileProvider(S)})}registerTerminalQuickFixProvider(v,S,k){if(this.D.has(v))throw new Error(`Terminal quick fix provider "${v}" is already registered`);return this.D.set(v,k),this.a.$registerQuickFixProvider(v,S),new $.$uM(()=>{this.D.delete(v),this.a.$unregisterQuickFixProvider(v)})}async $provideTerminalQuickFixes(v,S){const k=new b.$ee().token;if(k.isCancellationRequested)return;const D=this.D.get(v);if(!D)return;const F=await D.provideTerminalQuickFixes(S,k);if(F===null||Array.isArray(F)&&F.length===0)return;const W=new p.$Tc;if(this.w.value=W,!Array.isArray(F))return F?c.TerminalQuickFix.from(F,this.Q.converter,W):void 0;const B=[];for(const j of F){const N=c.TerminalQuickFix.from(j,this.Q.converter,W);N&&B.push(N)}return B}async $createContributedProfileTerminal(v,S){const k=new b.$ee().token;let D=await this.C.get(v)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(D&&!("options"in D)&&(D={options:D}),!D||!("options"in D))throw new Error(`No terminal profile options provided for id "${v}"`);if("pty"in D.options){this.createExtensionTerminal(D.options,S);return}this.createTerminalFromOptions(D.options,S)}}async $provideLinks(v,S){const k=this.getTerminalById(v);if(!k)return[];this.F.delete(v),this.G.get(v)?.dispose(!0);const F=new b.$ee;this.G.set(v,F);const W=[],B={terminal:k.value,line:S},j=[];for(const O of this.z)j.push(m.Promises.withAsyncBody(async z=>{F.token.onCancellationRequested(()=>z({provider:O,links:[]}));const Q=await O.provideTerminalLinks(B,F.token)||[];F.token.isCancellationRequested||z({provider:O,links:Q})}));const N=await Promise.all(j);if(F.token.isCancellationRequested)return[];const T=new Map;for(const O of N)O&&O.links.length>0&&W.push(...O.links.map(z=>{const Q={id:s++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return T.set(Q.id,{provider:O.provider,link:z}),Q}));return this.F.set(v,T),W}$activateLink(v,S){const k=this.F.get(v)?.get(S);k&&k.provider.handleTerminalLink(k.link)}U(v,S){this.y.stopBuffering(v),this.g.delete(v),delete this.j[v];const k=this.h[v];k&&(k.dispose(),delete this.h[v]),this.a.$sendProcessExit(v,S)}getTerminalById(v){return this.W(this.f,v)}getTerminalIdByApiObject(v){const S=this.f.findIndex(k=>k.value===v);return S>=0?S:null}W(v,S){const k=this.X(v,S);return k!==null?v[k]:null}X(v,S){const k=v.findIndex(D=>D._id===S);return k>=0?k:null}getEnvironmentVariableCollection(v){let S=this.n.get(v.identifier.value);return S||(S=new f,this.Z(v.identifier.value,S)),S.getScopedEnvironmentVariableCollection(void 0)}Y(v,S){const k=(0,P.$8r)(S.map),D=(0,P.$9r)(S.descriptionMap);this.a.$setEnvironmentVariableCollection(v,S.persistent,k.length===0?void 0:k,D)}$initEnvironmentVariableCollections(v){v.forEach(S=>{const k=S[0],D=new f(S[1]);this.Z(k,D)})}$acceptDefaultProfile(v,S){const k=this.s;this.s=v,this.u=S,k?.path!==v.path&&this.N.fire(v.path)}Z(v,S){this.n.set(v,S),S.onDidChangeCollection(()=>{this.Y(v,S)})}};e.$qkc=t,e.$qkc=t=Qe([He(1,i.$$O),He(2,L.$OO)],t);class f{get persistent(){return this.b}set persistent(v){this.b=v,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(v){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new o.$7d,this.map=new Map(v)}getScopedEnvironmentVariableCollection(v){const S=this.h(v);let k=this.a.get(S);return k||(k=new d(this,v),this.a.set(S,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(v,S,k,D){this.f(v,{value:S,type:$.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:D})}append(v,S,k,D){this.f(v,{value:S,type:$.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:D})}prepend(v,S,k,D){this.f(v,{value:S,type:$.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:D})}f(v,S){if(S.options&&S.options.applyAtProcessCreation===!1&&!S.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(v,S.scope),D=this.map.get(k),F=S.options?{applyAtProcessCreation:S.options.applyAtProcessCreation??!1,applyAtShellIntegration:S.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!D||D.value!==S.value||D.type!==S.type||D.options?.applyAtProcessCreation!==F.applyAtProcessCreation||D.options?.applyAtShellIntegration!==F.applyAtShellIntegration||D.scope?.workspaceFolder?.index!==S.scope?.workspaceFolder?.index){const W=this.g(v,S.scope),B={variable:v,...S,options:F};this.map.set(W,B),this.d.fire()}}get(v,S){const k=this.g(v,S),D=this.map.get(k);return D?g(D):void 0}g(v,S){const k=this.h(S);return k.length?`${v}:::${k}`:v}h(v){return this.j(v?.workspaceFolder)??""}j(v){return v?v.uri.toString():void 0}getVariableMap(v){const S=new Map;for(const[k,D]of this.map)this.h(D.scope)===this.h(v)&&S.set(D.variable,g(D));return S}delete(v,S){const k=this.g(v,S);this.map.delete(k),this.d.fire()}clear(v){if(v?.workspaceFolder){for(const[S,k]of this.map)k.scope?.workspaceFolder?.index===v.workspaceFolder.index&&this.map.delete(S);this.k(v)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(v,S){const k=this.h(S),D=this.descriptionMap.get(k);if(!D||D.description!==v){let F;typeof v=="string"?F=v:F=v?.value.split(`

`)[0];const W={description:F,scope:S};this.descriptionMap.set(k,W),this.d.fire()}}getDescription(v){const S=this.h(v);return this.descriptionMap.get(S)?.description}k(v){const S=this.h(v);this.descriptionMap.delete(S)}}class d{get persistent(){return this.b.persistent}set persistent(v){this.b.persistent=v}get onDidChangeCollection(){return this.a&&this.a.event}constructor(v,S){this.b=v,this.d=S,this.a=new o.$7d}getScoped(v){return this.b.getScopedEnvironmentVariableCollection(v)}replace(v,S,k){this.b.replace(v,S,k,this.d)}append(v,S,k){this.b.append(v,S,k,this.d)}prepend(v,S,k){this.b.prepend(v,S,k,this.d)}get(v){return this.b.get(v,this.d)}forEach(v,S){this.b.getVariableMap(this.d).forEach((k,D)=>v.call(S,D,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(v){this.b.delete(v,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(v){this.b.setDescription(v,this.d)}get description(){return this.b.getDescription(this.d)}}let u=class extends t{constructor(v,S){super(!1,v,S)}createTerminal(v,S,k){throw new A.$_}createTerminalFromOptions(v,S){throw new A.$_}};e.$rkc=u,e.$rkc=u=Qe([He(0,i.$$O),He(1,L.$OO)],u);function h(E){if(!(!E||typeof E=="string"))return"id"in E?{id:E.id,color:E.color}:E}function l(E){return a.ThemeColor.isThemeColor(E)?E:void 0}function g(E){const v={...E};return delete v.scope,v.options=v.options??void 0,delete v.variable,v}}),define(Ee[156],Ce([1,0,3,5,6,20,44,4,2,8]),function(re,e,o,R,I,M,L,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=e.$Hlc=void 0,e.$Hlc=(0,R.$ii)("IExtHostTerminalShellIntegration");let A=class extends o.$Uc{constructor(a,m){super(),this.h=m,this.b=new Map,this.c=new p.$7d,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$7d,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$7d,this.onDidEndTerminalShellExecution=this.g.event,this.a=a.getProxy(I.$sM.MainThreadTerminalShellIntegration),this.B((0,o.$Sc)(()=>{for(const[c,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(a){const m=this.h.getTerminalById(a);if(!m)return;const c=m.value;let i=this.b.get(a);i||(i=new P(m.value,this.f),this.b.set(a,i),i.store.add(m.onWillDispose(()=>this.b.get(a)?.dispose())),i.store.add(i.onDidRequestShellExecution(n=>this.a.$executeCommand(a,n))),i.store.add(i.onDidRequestEndExecution(n=>this.g.fire(n.value))),i.store.add(i.onDidRequestChangeShellIntegration(n=>this.c.fire(n))),m.shellIntegration=i.value),this.c.fire({terminal:c,shellIntegration:i.value})}$shellExecutionStart(a,m,c){this.b.has(a)||this.$shellIntegrationChange(a),this.b.get(a)?.startShellExecution(m,c)}$shellExecutionEnd(a,m,c){this.b.get(a)?.endShellExecution(m,c)}$shellExecutionData(a,m){this.b.get(a)?.emitData(m)}$cwdChange(a,m){this.b.get(a)?.setCwd(m)}$closeTerminal(a){this.b.get(a)?.dispose(),this.b.delete(a)}};e.$Ilc=A,e.$Ilc=A=Qe([He(0,M.$OO),He(1,L.$okc)],A);class P extends o.$Uc{get currentExecution(){return this.a}constructor(a,m){super(),this.j=a,this.m=m,this.b=!1,this.store=this.B(new o.$Tc),this.f=this.B(new p.$7d),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$7d),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$7d),this.onDidRequestEndExecution=this.h.event;const c=this;this.value={get cwd(){return c.c},executeCommand(i){c.g.fire(i);const n=c.startShellExecution(i,c.c).value;return c.b=!0,n}}}startShellExecution(a,m){return this.b&&this.a?this.b=!1:(this.a&&(this.a.endExecution(void 0,void 0),this.h.fire(this.a)),this.a=new b(this.j,a,m),this.m.fire(this.a.value)),this.a}emitData(a){this.currentExecution?.emitData(a)}endShellExecution(a,m){this.a&&(this.a.endExecution(a,m),this.h.fire(this.a),this.a=void 0)}setCwd(a){let m=!1;$.URI.isUri(this.c)?this.c.toString()!==a.toString()&&(m=!0):this.c!==a&&(m=!0),m&&(this.c=a,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class b{constructor(a,m,c){this.terminal=a,this.d=m,this.cwd=c,this.b=new Promise(n=>{this.c=n});const i=this;this.value={get terminal(){return a},get commandLine(){return i.d},get cwd(){return c},get exitCode(){return i.b},createDataStream(){return i.f()}}}f(){if(!this.a){if(this.c===void 0)return w.$Ih.EMPTY;this.a=new C}return this.a.createIterable()}emitData(a){this.a?.emitData(a)}endExecution(a,m){a&&(this.d=a),this.a?.endExecution(),this.a=void 0,this.c?.(m),this.c=void 0}}class C extends o.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){const a=this.a=new w.$hh;return new w.$Ih(async c=>{this.b.push(c),await a.wait()})}emitData(a){for(const m of this.b)m.emitOne(a)}endExecution(){this.a?.open(),this.a=void 0}}});var qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)},it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o};define(Ee[353],Ce([1,0,8,21,22,4,74,55,3,18,30,12,6,20,155,16,7,67,113,89]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i,n){"use strict";var r,s,t,f,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=e.$wlc=e.$vlc=e.$ulc=void 0;let u=class extends $.$Uc{constructor(T,O,z,Q){super(),this.w=Q,this.f=this.B(new M.$7d),this.g=new Map,this.s=this.B(new M.$7d),this.onResultsChanged=this.f.event,this.results=[],this.h=T.getProxy(b.$sM.MainThreadTesting),this.m=new F(this.h),this.j=new E(this.h,O),z.registerArgumentProcessor({processArgument:Z=>{switch(Z?.$mid){case 16:{const J=Z,x=J.tests[J.tests.length-1].item.extId;return this.g.get(c.$eL.root(x))?.collection.tree.get(x)?.actual??(0,y.$1O)(Z)}case 18:{const{test:J,message:x}=Z,ce=J.item.extId;return{test:this.g.get(c.$eL.root(ce))?.collection.tree.get(ce)?.actual??(0,y.$1O)({$mid:16,tests:[J]}),message:a.TestMessage.to(x)}}default:return Z}}}),z.registerCommand(!1,"testing.getExplorerSelection",async()=>{const Z=await z.executeCommand("_testing.getExplorerSelection"),J=x=>{const ce=this.g.get(c.$eL.root(x));if(ce)return c.$eL.isRoot(x)?ce.controller:ce.collection.tree.get(x)?.actual};return{include:Z?.include.map(J).filter(w.$4f)||[],exclude:Z?.exclude.map(J).filter(w.$4f)||[]}})}createTestController(T,O,z,Q){if(this.g.has(O))throw new Error(`Attempt to insert a duplicate controller with ID "${O}"`);const Z=new $.$Tc,J=Z.add(new y.$4O(O,z,this.w));J.root.label=z;const x=new Map,ce=new Set,te=this.h,pe={items:J.root.children,get label(){return z},set label(_){z=_,J.root.label=_,te.$updateController(O,{label:z})},get refreshHandler(){return Q},set refreshHandler(_){Q=_,te.$updateController(O,{canRefresh:!!_})},get id(){return O},createRunProfile:(_,U,he,Se,me,ie)=>{let se=(0,p.$9i)(_);for(;x.has(se);)se++;return new B(this.h,x,ce,this.s.event,O,se,_,U,he,Se,me,ie)},createTestItem(_,U,he){return new y.$2O(O,_,U,he)},createTestRun:(_,U,he=!0)=>this.j.createTestRun(O,J,_,U,he),invalidateTestResults:_=>{if(_===void 0)this.h.$markTestRetired(void 0);else{const U=_ instanceof Array?_:[_];this.h.$markTestRetired(U.map(he=>c.$eL.fromExtHostTestItem(he,O).toString()))}},set resolveHandler(_){J.resolveHandler=_},get resolveHandler(){return J.resolveHandler},dispose:()=>{Z.dispose()}};te.$registerTestController(O,z,!!Q),Z.add((0,$.$Sc)(()=>te.$unregisterTestController(O)));const ye={controller:pe,collection:J,profiles:x,extension:T,activeProfiles:ce};return this.g.set(O,ye),Z.add((0,$.$Sc)(()=>this.g.delete(O))),Z.add(J.onDidGenerateDiff(_=>te.$publishDiff(O,_.map(n.TestsDiffOp.serialize)))),pe}createTestObserver(){return this.m.checkout()}async runTests(T,O=I.CancellationToken.None){const z=v(T);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const Q=this.g.get(z.controllerId);if(!Q)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:T.include?.map(Z=>c.$eL.fromExtHostTestItem(Z,Q.collection.root.id).toString())??[Q.collection.root.id],profileGroup:j[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:T.exclude?.map(Z=>Z.id)},O)}$syncTests(){for(const{collection:T}of this.g.values())T.flushDiff();return Promise.resolve()}async $getCoverageDetails(T,O){return(await this.j.getCoverageDetails(T,O))?.map(a.TestCoverage.fromDetails)}async $disposeRun(T){this.j.disposeTestRun(T)}$configureRunProfile(T,O){this.g.get(T)?.profiles.get(O)?.configureHandler?.()}$setDefaultRunProfiles(T){const O=new Map;for(const[z,Q]of Object.entries(T)){const Z=this.g.get(z);if(!Z)continue;const J=new Map,x=Q.filter(te=>!Z.activeProfiles.has(te)),ce=[...Z.activeProfiles].filter(te=>!Q.includes(te));for(const te of x)J.set(te,!0),Z.activeProfiles.add(te);for(const te of ce)J.set(te,!1),Z.activeProfiles.delete(te);J.size&&O.set(z,J)}this.s.fire(O)}async $refreshTests(T,O){await this.g.get(T)?.controller.refreshHandler?.(O)}$publishTestResults(T){this.results=Object.freeze(T.map(a.TestResults.to).concat(this.results).sort((O,z)=>z.completedAt-O.completedAt).slice(0,32)),this.f.fire()}async $expandTest(T,O){const z=this.g.get(c.$eL.fromString(T).controllerId)?.collection;z&&(await z.expand(T,O<0?1/0:O),z.flushDiff())}$acceptDiff(T){this.m.applyDiff(T.map(O=>n.TestsDiffOp.deserialize({asCanonicalUri:z=>z},O)))}async $runControllerTests(T,O){return Promise.all(T.map(z=>this.y(z,!1,O)))}async $startContinuousRun(T,O){const z=new I.$ee(O),Q=await Promise.all(T.map(Z=>this.y(Z,!0,z.token)));return!O.isCancellationRequested&&!Q.some(Z=>Z.error)&&await new Promise(Z=>O.onCancellationRequested(Z)),z.dispose(!0),Q}async y(T,O,z){const Q=this.g.get(T.controllerId);if(!Q)return{};const{collection:Z,profiles:J}=Q,x=J.get(T.profileId);if(!x)return{};const ce=T.testIds.map(_=>Z.tree.get(_)).filter(w.$4f),te=T.excludeExtIds.map(_=>Q.collection.tree.get(_)).filter(w.$4f).filter(_=>ce.some(U=>U.fullId.compare(_.fullId)===2));if(!ce.length)return{};const pe=new m.$7N(ce.some(_=>_.actual instanceof y.$3O)?void 0:ce.map(_=>_.actual),te.map(_=>_.actual),x,O),ye=(0,n.$hL)(T)&&this.j.prepareForMainThreadTestRun(pe,S.fromInternal(T,Q.collection),x,z);try{return await x.runHandler(pe,z),{}}catch(_){return{error:String(_)}}finally{ye&&ye.hasRunningTasks&&!z.isCancellationRequested&&await M.Event.toPromise(ye.onEnd)}}$cancelExtensionTestRun(T){T===void 0?this.j.cancelAllRuns():this.j.cancelRunById(T)}};e.$ulc=u,e.$ulc=u=Qe([He(0,C.$OO),He(1,P.$Oj)],u);const h=1e4;var l;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(l||(l={}));class g extends $.$Uc{get hasRunningTasks(){return this.g>0}get id(){return this.z.id}constructor(T,O,z,Q,Z){super(),this.z=T,this.C=O,this.D=z,this.F=Q,this.f=0,this.g=0,this.h=new Map,this.j=new Set,this.s=this.B(new M.$7d),this.y=new Map,this.onEnd=this.s.event,this.m=this.B(new I.$ee(Z));const J=this.B(new o.$uh(()=>this.G(),h));this.B(this.m.token.onCancellationRequested(()=>J.schedule()));const x=new M.$7d;this.w=x.event,this.B((0,$.$Sc)(()=>{x.fire(),x.dispose()}))}cancel(){this.f===0?(this.m.cancel(),this.f=1):this.f===1&&this.G()}getCoverageDetails(T,O){const[,z,Q]=c.$eL.fromString(T).path,Z=this.y.get(Q);if(!Z)return[];if(Z.backCompatResolve)return Z.backCompatResolve(O);const J=this.h.get(z);if(!J)throw new Error("unreachable: run task was not found");return this.F?.loadDetailedCoverage?.(J.run,Z.coverage,O)??[]}createRun(T){const O=this.z.id,z=this.z.controllerId,Q=(0,A.$Eg)(),Z=ye=>(_,...U)=>{if(ce){this.D.warn(`Setting the state of test "${_.id}" is a no-op after the run ends.`);return}this.z.isIncluded(_)&&(this.I(_),ye(_,...U))},J=(ye,_)=>{const U=_ instanceof Array?_.map(a.TestMessage.from):[a.TestMessage.from(_)];if(ye.uri&&ye.range){const he={range:a.Range.from(ye.range),uri:ye.uri};for(const Se of U)Se.location=Se.location||he}this.C.$appendTestMessagesInRun(O,Q,c.$eL.fromExtHostTestItem(ye,z).toString(),U)},x=(ye,_)=>{const U=ye.uri.toString(),he=new c.$eL([O,Q,U]).toString();this.y.set(U,{coverage:ye,backCompatResolve:_}),this.C.$appendCoverage(O,Q,a.TestCoverage.fromFile(he,ye))};let ce=!1,te;const pe={isPersisted:this.z.isPersisted,token:this.m.token,name:T,onDidDispose:this.w,get coverageProvider(){return te},set coverageProvider(ye){te=ye,ye&&Promise.resolve(ye.provideFileCoverage(I.CancellationToken.None)).then(_=>{_?.forEach(U=>x(U,ye.resolveFileCoverage&&(async he=>(await ye.resolveFileCoverage(U,he)||U).detailedCoverage)))})},addCoverage:x,enqueued:Z(ye=>{this.C.$updateTestStateInRun(O,Q,c.$eL.fromExtHostTestItem(ye,z).toString(),1)}),skipped:Z(ye=>{this.C.$updateTestStateInRun(O,Q,c.$eL.fromExtHostTestItem(ye,z).toString(),5)}),started:Z(ye=>{this.C.$updateTestStateInRun(O,Q,c.$eL.fromExtHostTestItem(ye,z).toString(),2)}),errored:Z((ye,_,U)=>{J(ye,_),this.C.$updateTestStateInRun(O,Q,c.$eL.fromExtHostTestItem(ye,z).toString(),6,U)}),failed:Z((ye,_,U)=>{J(ye,_),this.C.$updateTestStateInRun(O,Q,c.$eL.fromExtHostTestItem(ye,z).toString(),4,U)}),passed:Z((ye,_)=>{this.C.$updateTestStateInRun(O,Q,c.$eL.fromExtHostTestItem(ye,this.z.controllerId).toString(),3,_)}),appendOutput:(ye,_,U)=>{ce||(U&&(this.z.isIncluded(U)?this.I(U):U=void 0),this.C.$appendOutputToRun(O,Q,R.$ue.fromString(ye),_&&a.location.from(_),U&&c.$eL.fromExtHostTestItem(U,z).toString()))},end:()=>{ce||(ce=!0,this.C.$finishedTestRunTask(O,Q),--this.g||this.H())}};return this.g++,this.h.set(Q,{run:pe}),this.C.$startedTestRunTask(O,{id:Q,name:T,running:!0}),pe}G(){for(const{run:T}of this.h.values())T.end()}H(){this.f!==2&&(this.f=2,this.s.fire())}I(T){if(!(T instanceof y.$2O))throw new i.$GO(T.id);if(this.j.has(c.$eL.fromExtHostTestItem(T,this.z.controllerId).toString()))return;const O=[],z=this.z.colllection.root;for(;;){const Q=a.TestItem.from(T);if(O.unshift(Q),this.j.has(Q.extId)||(this.j.add(Q.extId),T===z))break;T=T.parent||z}this.C.$addTestsToRun(this.z.controllerId,this.z.id,O)}dispose(){this.H(),super.dispose()}}class E{get trackers(){return this.f.values()}constructor(T,O){this.h=T,this.j=O,this.f=new Map,this.g=new Map}getCoverageDetails(T,O){const z=c.$eL.root(T);return this.g.get(z)?.getCoverageDetails(T,O)||[]}disposeTestRun(T){this.g.get(T)?.dispose(),this.g.delete(T);for(const[O,{id:z}]of this.f)z===T&&this.f.delete(O)}prepareForMainThreadTestRun(T,O,z,Q){return this.k(T,O,z,Q)}cancelRunById(T){this.g.get(T)?.cancel()}cancelAllRuns(){for(const T of this.f.values())T.cancel()}createTestRun(T,O,z,Q,Z){const J=this.f.get(z);if(J)return J.createRun(Q);const x=S.fromPublic(T,O,z,Z),ce=v(z);this.h.$startedExtensionTestRun({controllerId:T,continuous:!!z.continuous,profile:ce&&{group:j[ce.kind],id:ce.profileId},exclude:z.exclude?.map(pe=>c.$eL.fromExtHostTestItem(pe,O.root.id).toString())??[],id:x.id,include:z.include?.map(pe=>c.$eL.fromExtHostTestItem(pe,O.root.id).toString())??[O.root.id],persist:Z});const te=this.k(z,x,z.profile);return M.Event.once(te.onEnd)(()=>{this.h.$finishedExtensionTestRun(x.id)}),te.createRun(Q)}k(T,O,z,Q){const Z=new g(O,this.h,this.j,z,Q);return this.f.set(T,Z),this.g.set(Z.id,Z),Z}}e.$vlc=E;const v=N=>{if(N.profile){if(!(N.profile instanceof B))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class S{static fromPublic(T,O,z,Q){return new S(T,(0,A.$Eg)(),z.include?.map(Z=>c.$eL.fromExtHostTestItem(Z,T).toString())??[T],z.exclude?.map(Z=>c.$eL.fromExtHostTestItem(Z,T).toString())??[],Q,O)}static fromInternal(T,O){return new S(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,O)}constructor(T,O,z,Q,Z,J){this.controllerId=T,this.id=O,this.isPersisted=Z,this.colllection=J,this.f=z.map(x=>x+"\0"),this.g=Q.map(x=>x+"\0")}isIncluded(T){const O=c.$eL.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const z of this.g)if(O===z||O.startsWith(z))return!1;for(const z of this.f)if(O===z||O.startsWith(z))return!0;return!1}}e.$wlc=S;class k{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(T){this.k=T,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(T){this.f.add(T)}update(T){Object.assign(T.revived,a.TestItem.toPlain(T.item)),this.f.has(T)||this.g.add(T)}remove(T){if(this.f.has(T)){this.f.delete(T);return}this.g.delete(T);const O=c.$eL.parentId(T.item.extId);if(O&&this.j.has(O.toString())){this.j.add(T.item.extId);return}this.h.add(T)}getChangeEvent(){const{f:T,g:O,h:z}=this;return{get added(){return[...T].map(Q=>Q.revived)},get updated(){return[...O].map(Q=>Q.revived)},get removed(){return[...z].map(Q=>Q.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class D extends n.$nL{constructor(){super(...arguments),this.s=new M.$7d,this.onDidChangeTests=this.s.event}get rootTests(){return this.h}getMirroredTestDataById(T){return this.g.get(T)}getMirroredTestDataByReference(T){return this.g.get(T.id)}x(T,O){return{...T,revived:a.TestItem.toPlain(T.item),depth:O?O.depth+1:0,children:new Set}}w(){return new k(this.s)}}class F{constructor(T){this.g=T}checkout(){this.f||(this.f=this.h());const T=this.f;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(O=>O.revived)},dispose:(0,L.$db)(()=>{--T.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(T){return this.f?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.f?.tests.apply(T)}h(){const T=new D({asCanonicalUri:O=>O});return this.g.$subscribeToDiffs(),{observers:0,tests:T}}}const W=(N,T,O,z)=>{O?Object.assign(O,z):T.$updateTestRunConfig(N.controllerId,N.profileId,z)};class B{get label(){return this.g}set label(T){T!==this.g&&(this.g=T,W(this,qe(this,r,"f"),qe(this,f,"f"),{label:T}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(T){T!==this.h&&(this.h=T,W(this,qe(this,r,"f"),qe(this,f,"f"),{supportsContinuousRun:T}))}get isDefault(){return qe(this,s,"f").has(this.profileId)}set isDefault(T){T!==this.isDefault&&(T?qe(this,s,"f").add(this.profileId):qe(this,s,"f").delete(this.profileId),W(this,qe(this,r,"f"),qe(this,f,"f"),{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,W(this,qe(this,r,"f"),qe(this,f,"f"),{tag:T?a.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this.f}set configureHandler(T){T!==this.f&&(this.f=T,W(this,qe(this,r,"f"),qe(this,f,"f"),{hasConfigurationHandler:!!T}))}get onDidChangeDefault(){return M.Event.chain(qe(this,t,"f"),T=>T.map(O=>O.get(this.controllerId)?.get(this.profileId)).filter(w.$4f))}constructor(T,O,z,Q,Z,J,x,ce,te,pe=!1,ye=void 0,_=!1){this.controllerId=Z,this.profileId=J,this.g=x,this.kind=ce,this.runHandler=te,this._tag=ye,this.h=_,r.set(this,void 0),s.set(this,void 0),t.set(this,void 0),f.set(this,void 0),d.set(this,void 0),it(this,r,T,"f"),it(this,d,O,"f"),it(this,s,z,"f"),it(this,t,Q,"f"),O.set(J,this);const U=j[ce];if(typeof U!="number")throw new Error(`Unknown TestRunProfile.group ${ce}`);pe&&z.add(J),it(this,f,{profileId:J,controllerId:Z,tag:ye?a.TestTag.namespace(this.controllerId,ye.id):null,label:x,group:U,isDefault:pe,hasConfigurationHandler:!1,supportsContinuousRun:_},"f"),queueMicrotask(()=>{qe(this,f,"f")&&(qe(this,r,"f").$publishTestRunProfile(qe(this,f,"f")),it(this,f,void 0,"f"))})}dispose(){qe(this,d,"f")?.delete(this.profileId)&&(it(this,d,void 0,"f"),qe(this,r,"f").$removeTestProfile(this.controllerId,this.profileId)),it(this,f,void 0,"f")}}e.$xlc=B,r=new WeakMap,s=new WeakMap,t=new WeakMap,f=new WeakMap,d=new WeakMap;const j={[m.TestRunProfileKind.Coverage]:8,[m.TestRunProfileKind.Debug]:4,[m.TestRunProfileKind.Run]:2}}),define(Ee[157],Ce([1,0,61,13,125,16,7]),function(re,e,o,R,I,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XO=e.$WO=e.$VO=void 0;class p{constructor(b,C,y){const a=p.c.nextId();b.$registerTextEditorDecorationType(C.identifier,a,M.DecorationRenderOptions.from(y)),this.value=Object.freeze({key:a,dispose(){b.$removeTextEditorDecorationType(a)}})}}e.$VO=p,p.c=new I.$TO("TextEditorDecorationType");class ${constructor(b,C){this.g=[],this.h=void 0,this.j=!1,this.c=b,this.d=b.version,this.e=C.undoStopBefore,this.f=C.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(b,C){this.k();let y=null;if(b instanceof L.$vM)y=new L.$wM(b,b);else if(b instanceof L.$wM)y=b;else throw new Error("Unrecognized location");this.l(y,C,!1)}insert(b,C){this.k(),this.l(new L.$wM(b,b),C,!0)}delete(b){this.k();let C=null;if(b instanceof L.$wM)C=b;else throw new Error("Unrecognized location");this.l(C,null,!0)}l(b,C,y){const a=this.c.validateRange(b);this.g.push({range:a,text:C,forceMoveMarkers:y})}setEndOfLine(b){if(this.k(),b!==L.EndOfLine.LF&&b!==L.EndOfLine.CRLF)throw(0,R.$7)("endOfLine");this.h=b}}class w{constructor(b,C,y,a){this.c=b,this.d=C,this._accept(y),this.e=a;const m=this;this.value={get tabSize(){return m.f},set tabSize(c){m.n(c)},get indentSize(){return m.g},set indentSize(c){m.p(c)},get insertSpaces(){return m.j},set insertSpaces(c){m.s(c)},get cursorStyle(){return m.k},set cursorStyle(c){m.t(c)},get lineNumbers(){return m.l},set lineNumbers(c){m.u(c)}}}_accept(b){this.f=b.tabSize,this.g=b.indentSize,this.h=b.originalIndentSize,this.j=b.insertSpaces,this.k=b.cursorStyle,this.l=M.TextEditorLineNumbersStyle.to(b.lineNumbers)}m(b){if(b==="auto")return"auto";if(typeof b=="number"){const C=Math.floor(b);return C>0?C:null}if(typeof b=="string"){const C=parseInt(b,10);return isNaN(C)?null:C>0?C:null}return null}n(b){const C=this.m(b);if(C!==null){if(typeof C=="number"){if(this.f===C)return;this.f=C}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:C}))}}o(b){if(b==="tabSize")return"tabSize";if(typeof b=="number"){const C=Math.floor(b);return C>0?C:null}if(typeof b=="string"){const C=parseInt(b,10);return isNaN(C)?null:C>0?C:null}return null}p(b){const C=this.o(b);if(C!==null){if(typeof C=="number"){if(this.h===C)return;this.g=C,this.h=C}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:C}))}}q(b){return b==="auto"?"auto":b==="false"?!1:!!b}s(b){const C=this.q(b);if(typeof C=="boolean"){if(this.j===C)return;this.j=C}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:C}))}t(b){this.k!==b&&(this.k=b,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:b})))}u(b){this.l!==b&&(this.l=b,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(b)})))}assign(b){const C={};let y=!1;if(typeof b.tabSize<"u"){const a=this.m(b.tabSize);a==="auto"?(y=!0,C.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,y=!0,C.tabSize=a)}if(typeof b.indentSize<"u"){const a=this.o(b.indentSize);a==="tabSize"?(y=!0,C.indentSize=a):typeof a=="number"&&this.h!==a&&(this.g=a,this.h=a,y=!0,C.indentSize=a)}if(typeof b.insertSpaces<"u"){const a=this.q(b.insertSpaces);a==="auto"?(y=!0,C.insertSpaces=a):this.j!==a&&(this.j=a,y=!0,C.insertSpaces=a)}typeof b.cursorStyle<"u"&&this.k!==b.cursorStyle&&(this.k=b.cursorStyle,y=!0,C.cursorStyle=b.cursorStyle),typeof b.lineNumbers<"u"&&this.l!==b.lineNumbers&&(this.l=b.lineNumbers,y=!0,C.lineNumbers=M.TextEditorLineNumbersStyle.from(b.lineNumbers)),y&&this.v("setOptions",this.c.$trySetOptions(this.d,C))}v(b,C){C.catch(y=>{this.e.warn(`ExtHostTextEditorOptions '${b}' failed:'`),this.e.warn(y)})}}e.$WO=w;class A{constructor(b,C,y,a,m,c,i,n){this.id=b,this.j=C,this.k=y,this.g=!1,this.h=new Set,this.c=m,this.d=new w(this.j,this.id,c,y),this.e=i,this.f=n;const r=this;this.value=Object.freeze({get document(){return a.value},set document(s){throw new R.$9("document")},get selection(){return r.c&&r.c[0]},set selection(s){if(!(s instanceof L.$xM))throw(0,R.$7)("selection");r.c=[s],r.l()},get selections(){return r.c},set selections(s){if(!Array.isArray(s)||s.some(t=>!(t instanceof L.$xM)))throw(0,R.$7)("selections");r.c=s,r.l()},get visibleRanges(){return r.e},set visibleRanges(s){throw new R.$9("visibleRanges")},get options(){return r.d.value},set options(s){r.g||r.d.assign(s)},get viewColumn(){return r.f},set viewColumn(s){throw new R.$9("viewColumn")},edit(s,t={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new $(a.value,t);return s(f),r.m(f)},insertSnippet(s,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=r.c.map(u=>M.Range.from(u));else if(t instanceof L.$vM){const{lineNumber:u,column:h}=M.Position.from(t);d=[{startLineNumber:u,startColumn:h,endLineNumber:u,endColumn:h}]}else if(t instanceof L.$wM)d=[M.Range.from(t)];else{d=[];for(const u of t)if(u instanceof L.$wM)d.push(M.Range.from(u));else{const{lineNumber:h,column:l}=M.Position.from(u);d.push({startLineNumber:h,startColumn:l,endLineNumber:h,endColumn:l})}}return C.$tryInsertSnippet(b,a.value.version,s.value,d,f)},setDecorations(s,t){const f=t.length===0;f&&!r.h.has(s.key)||(f?r.h.delete(s.key):r.h.add(s.key),r.n(()=>{if(M.$LO(t))return C.$trySetDecorations(b,s.key,M.$MO(t));{const d=new Array(4*t.length);for(let u=0,h=t.length;u<h;u++){const l=t[u];d[4*u]=l.start.line+1,d[4*u+1]=l.start.character+1,d[4*u+2]=l.end.line+1,d[4*u+3]=l.end.character+1}return C.$trySetDecorationsFast(b,s.key,d)}}))},revealRange(s,t){r.n(()=>C.$tryRevealRange(b,M.Range.from(s),t||L.TextEditorRevealType.Default))},show(s){C.$tryShowEditor(b,M.ViewColumn.from(s))},hide(){C.$tryHideEditor(b)}})}dispose(){(0,o.ok)(!this.g),this.g=!0}_acceptOptions(b){(0,o.ok)(!this.g),this.d._accept(b)}_acceptVisibleRanges(b){(0,o.ok)(!this.g),this.e=b}_acceptViewColumn(b){(0,o.ok)(!this.g),this.f=b}_acceptSelections(b){(0,o.ok)(!this.g),this.c=b}async l(){const b=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,b)),this.value}m(b){const C=b.finalize();if(C.edits.length===0&&!C.setEndOfLine)return Promise.resolve(!0);const y=C.edits.map(m=>m.range);y.sort((m,c)=>m.end.line===c.end.line?m.end.character===c.end.character?m.start.line===c.start.line?m.start.character-c.start.character:m.start.line-c.start.line:m.end.character-c.end.character:m.end.line-c.end.line);for(let m=0,c=y.length-1;m<c;m++){const i=y[m].end;if(y[m+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=C.edits.map(m=>({range:M.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,C.documentVersionId,a,{setEndOfLine:typeof C.setEndOfLine=="number"?M.EndOfLine.from(C.setEndOfLine):void 0,undoStopBefore:C.undoStopBefore,undoStopAfter:C.undoStopAfter})}n(b){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):b().then(()=>this,C=>(C instanceof Error&&C.name==="DISPOSED"||this.k.warn(C),null))}}e.$XO=A}),define(Ee[72],Ce([1,0,61,4,3,2,5,6,153,20,157,16,12,27,15,39,46]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZO=e.$YO=void 0;class c{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(r,s){this.h=r,this.i=s,this.a=null,this.b=new Map,this.c=new C.$Bc,this.d=new R.$7d,this.e=new R.$7d,this.f=new R.$7d,this.g=new R.$7d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const s=[],t=[],f=[];if(r.removedDocuments)for(const d of r.removedDocuments){const u=M.URI.revive(d),h=this.c.get(u);h?.unref()&&(this.c.delete(u),s.push(h.value))}if(r.addedDocuments)for(const d of r.addedDocuments){const u=M.URI.revive(d.uri);let h=this.c.get(u);if(h&&u.scheme!==y.Schemas.vscodeNotebookCell&&u.scheme!==y.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);h||(h=new c(new $.$RO(this.h.getProxy(p.$sM.MainThreadDocuments),u,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty)),this.c.set(u,h),t.push(h.value)),h.ref()}if(r.removedEditors)for(const d of r.removedEditors){const u=this.b.get(d);this.b.delete(d),u&&f.push(u)}if(r.addedEditors)for(const d of r.addedEditors){const u=M.URI.revive(d.documentUri);o.ok(this.c.has(u),`document '${u}' does not exist`),o.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const h=this.c.get(u).value,l=new A.$XO(d.id,this.h.getProxy(p.$sM.MainThreadTextEditors),this.i,new m.$V(()=>h.document),d.selections.map(P.Selection.to),d.options,d.visibleRanges.map(g=>P.Range.to(g)),typeof d.editorPosition=="number"?P.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,l)}r.newActiveEditor!==void 0&&(o.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,I.$Pc)(s),(0,I.$Pc)(f),r.removedDocuments&&this.e.fire(s),r.addedDocuments&&this.d.fire(t),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return a.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const s=this.b.get(this.a);return r?s:s?.value}allEditors(){return[...this.b.values()]}};e.$YO=i,e.$YO=i=Qe([He(0,w.$OO),He(1,b.$Oj)],i),e.$ZO=(0,L.$ii)("IExtHostDocumentsAndEditors")}),define(Ee[354],Ce([1,0,19,4,6,157,16,7]),function(re,e,o,R,I,M,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tjc=void 0;class ${constructor(A,P){this.i=P,this.a=new R.$7d,this.b=new R.$7d,this.c=new R.$7d,this.d=new R.$7d,this.f=new R.$7d,this.g=new R.$7d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(I.$sM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const P=this.i.allEditors();return A?P:P.map(b=>b.value)}async showTextDocument(A,P,b){let C;typeof P=="number"?C={position:L.ViewColumn.from(P),preserveFocus:b}:typeof P=="object"?C={position:L.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?L.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:C={preserveFocus:!1};const y=await this.h.$tryShowTextDocument(A.uri,C),a=y&&this.i.getEditor(y);if(a)return a.value;throw y?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,P){return new M.$VO(this.h,A,P).value}$acceptEditorPropertiesChanged(A,P){const b=this.i.getEditor(A);if(!b)throw new Error("unknown text editor");if(P.options&&b._acceptOptions(P.options),P.selections){const C=P.selections.selections.map(L.Selection.to);b._acceptSelections(C)}if(P.visibleRanges){const C=o.$Hb(P.visibleRanges.map(L.Range.to));b._acceptVisibleRanges(C)}if(P.options&&this.b.fire({textEditor:b.value,options:{...P.options,lineNumbers:L.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const C=p.TextEditorSelectionChangeKind.fromValue(P.selections.source),y=P.selections.selections.map(L.Selection.to);this.a.fire({textEditor:b.value,selections:y,kind:C})}if(P.visibleRanges){const C=o.$Hb(P.visibleRanges.map(L.Range.to));this.c.fire({textEditor:b.value,visibleRanges:C})}}$acceptEditorPositionData(A){for(const P in A){const b=this.i.getEditor(P);if(!b)throw new Error("Unknown text editor");const C=L.ViewColumn.to(A[P]);b.value.viewColumn!==C&&(b._acceptViewColumn(C),this.d.fire({textEditor:b.value,viewColumn:C}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$Tjc=$}),define(Ee[355],Ce([1,0,2,5,6,3,7,16,25,18]),function(re,e,o,R,I,M,L,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Alc=e.$zlc=void 0,e.$zlc=(0,R.$ii)("IExtHostTimeline");class A{constructor(C,y){this.b=new Map,this.c=new Map,this.a=C.getProxy(I.$sM.MainThreadTimeline),y.registerArgumentProcessor({processArgument:(a,m)=>{if(a&&a.$mid===12)if(this.b.get(a.source)&&$.$Em.equals(m,this.b.get(a.source)?.extension)){const c=a.uri===void 0?void 0:o.URI.revive(a.uri);return this.c.get(a.source)?.get(P(c))?.get(a.handle)}else return;return a}})}async $getTimeline(C,y,a,m){return this.b.get(C)?.provider.provideTimeline(o.URI.revive(y),a,m)}registerTimelineProvider(C,y,a,m){const c=new M.$Tc,i=this.d(y.id,m,c).bind(this);let n;y.onDidChange&&(n=y.onDidChange(s=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...s,id:y.id}),this));const r=this.c;return this.f({...y,scheme:C,onDidChange:void 0,async provideTimeline(s,t,f){t?.resetCache&&(c.clear(),r.get(y.id)?.clear());const d=await y.provideTimeline(s,t,f);if(d==null)return;const u=i(s,t);return{...d,source:y.id,items:d.items.map(u)}},dispose(){for(const s of r.values())s.get(y.id)?.clear();n?.dispose(),c.dispose()}},a)}d(C,y,a){return(m,c)=>{let i;if(c?.cacheResults){let n=this.c.get(C);n===void 0&&(n=new Map,this.c.set(C,n));const r=P(m);i=n.get(r),i===void 0&&(i=new Map,n.set(r,i))}return n=>{const{iconPath:r,...s}=n,t=`${C}|${n.id??n.timestamp}`;i?.set(t,n);let f,d,u;n.iconPath&&(r instanceof L.$qN?u={id:r.id,color:r.color}:o.URI.isUri(r)?(f=r,d=r):{light:f,dark:d}=r);let h;return L.$VM.isMarkdownString(s.tooltip)?h=p.MarkdownString.from(s.tooltip):(0,w.$Vf)(s.tooltip)?h=s.tooltip:L.$VM.isMarkdownString(s.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),h=p.MarkdownString.from(s.detail)):(0,w.$Vf)(s.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),h=s.detail),{...s,id:s.id??void 0,handle:t,source:C,command:n.command?y.toInternal(n.command,a):void 0,icon:f,iconDark:d,themeIcon:u,tooltip:h,accessibilityInformation:n.accessibilityInformation}}}}f(C,y){if(this.b.get(C.id))throw new Error(`Timeline Provider ${C.id} already exists.`);return this.a.$registerTimelineProvider({id:C.id,label:C.label,scheme:C.scheme}),this.b.set(C.id,{provider:C,extension:y}),(0,M.$Sc)(()=>{for(const m of this.c.values())m.get(C.id)?.clear();this.b.delete(C.id),this.a.$unregisterTimelineProvider(C.id),C.dispose()})}}e.$Alc=A;function P(b){return b?.toString()}}),define(Ee[356],Ce([1,0,228,23,2,4,3,287,8,7,18,19,16,79,22,194,26]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=void 0;function c(r,s){if((0,A.$Vf)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class i extends L.$Uc{constructor(s,t,f){super(),this.f=s,this.g=t,this.h=f,this.a=new Map,this.b=new a.$r0;function d(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:u=>d(u)?this.r(u):Array.isArray(u)&&u.length>0?u.map(h=>d(h)?this.r(h):h):u})}registerTreeDataProvider(s,t,f){const d=this.createTreeView(s,{treeDataProvider:t},f);return{dispose:()=>d.dispose()}}createTreeView(s,t,f){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],u=t.dragAndDropController?.dragMimeTypes??[],h=!!t.dragAndDropController?.handleDrag,l=!!t.dragAndDropController?.handleDrop,g=this.m(s,t,f),E={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:u,hasHandleDrag:h,hasHandleDrop:l,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},v=this.f.$registerTreeViewDataProvider(s,E),S={get onDidCollapseElement(){return g.onDidCollapseElement},get onDidExpandElement(){return g.onDidExpandElement},get selection(){return g.selectedElements},get onDidChangeSelection(){return g.onDidChangeSelection},get activeItem(){return(0,m.$dG)(f,"treeViewActiveItem"),g.focusedElement},get onDidChangeActiveItem(){return(0,m.$dG)(f,"treeViewActiveItem"),g.onDidChangeActiveItem},get visible(){return g.visible},get onDidChangeVisibility(){return g.onDidChangeVisibility},get onDidChangeCheckboxState(){return g.onDidChangeCheckboxState},get message(){return g.message},set message(k){(0,C.$Hk)(k)&&(0,m.$dG)(f,"treeViewMarkdownMessage"),g.message=k},get title(){return g.title},set title(k){g.title=k},get description(){return g.description},set description(k){g.description=k},get badge(){return g.badge},set badge(k){k!==void 0&&w.ViewBadge.isViewBadge(k)?g.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(g.badge=void 0)},reveal:(k,D)=>g.reveal(k,D),dispose:async()=>{await v,this.a.delete(s),g.dispose()}};return this.B(S),S}$getChildren(s,t){const f=this.a.get(s);return f?f.getChildren(t):Promise.reject(new p.$GF(s))}async $handleDrop(s,t,f,d,u,h,l,g){const E=this.a.get(s);if(!E)return Promise.reject(new p.$GF(s));const v=b.DataTransfer.toDataTransfer(f,async S=>(await this.f.$resolveDropFileData(s,t,S)).buffer);return l===s&&g&&await this.j(v,E,g,u,h),E.onDrop(v,d,u)}async j(s,t,f,d,u){const h=this.b.removeDragOperationTransfer(u);if(h)(await h)?.forEach((l,g)=>{l&&s.set(g,l)});else if(u&&t.handleDrag){const l=t.handleDrag(f,s,d);this.b.addDragOperationTransfer(u,l),await l}return s}async $handleDrag(s,t,f,d){const u=this.a.get(s);if(!u)return Promise.reject(new p.$GF(s));const h=await this.j(new w.$mN,u,t,d,f);if(!(!h||d.isCancellationRequested))return b.DataTransfer.from(h)}async $hasResolve(s){const t=this.a.get(s);if(!t)throw new p.$GF(s);return t.hasResolve}$resolve(s,t,f){const d=this.a.get(s);if(!d)throw new p.$GF(s);return d.resolveTreeItem(t,f)}$setExpanded(s,t,f){const d=this.a.get(s);if(!d)throw new p.$GF(s);d.setExpanded(t,f)}$setSelectionAndFocus(s,t,f){const d=this.a.get(s);if(!d)throw new p.$GF(s);d.setSelectionAndFocus(t,f)}$setVisible(s,t){const f=this.a.get(s);if(!f){if(!t)return;throw new p.$GF(s)}f.setVisible(t)}$changeCheckboxState(s,t){const f=this.a.get(s);if(!f)throw new p.$GF(s);f.setCheckboxState(t)}m(s,t,f){const d=this.B(new n(s,t,this.f,this.g.converter,this.h,f));return this.a.set(s,d),d}r(s){const t=this.a.get(s.$treeViewId);return t&&"$treeItemHandle"in s?t.getExtensionElement(s.$treeItemHandle):t&&"$focusedTreeItem"in s&&s.$focusedTreeItem?t.focusedElement:null}}e.$Blc=i;class n extends L.$Uc{get visible(){return this.r}get selectedElements(){return this.s.map(s=>this.getExtensionElement(s)).filter(s=>!(0,A.$5f)(s))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(s,t,f,d,u,h){if(super(),this.I=s,this.J=f,this.L=d,this.M=u,this.N=h,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$7d),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$7d),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$7d),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$7d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$7d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$7d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$7d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new y.$ee,h.contributes&&h.contributes.views)for(const v in h.contributes.views)for(const S of h.contributes.views[v])S.id===s&&(this.P=S.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>this.F.fire({message:!1,element:v})));let l,g;const E=M.Event.debounce(this.F.event,(v,S)=>(v||(v={message:!1,elements:[]}),S.element!==!1&&(l||(l=new Promise(k=>g=k),this.G=this.G.then(()=>l)),Array.isArray(S.element)?v.elements.push(...S.element):v.elements.push(S.element)),S.message&&(v.message=!0),v),200,!0);this.B(E(({message:v,elements:S})=>{S.length&&(this.H=this.H.then(()=>{const k=g;return l=null,this.$(S).then(()=>k())})),v&&this.J.$setMessage(this.I,b.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(s){const t=s?this.getExtensionElement(s):void 0;if(s&&!t)return this.M.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let f=this.X(s);return f||(f=await this.Y(t)),f?f.map(d=>d.item):void 0}getExtensionElement(s){return this.j.get(s)}reveal(s,t){t=t||{select:!0,focus:!1};const f=(0,A.$5f)(t.select)?!0:t.select,d=(0,A.$5f)(t.focus)?!1:t.focus,u=(0,A.$5f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.G.then(()=>this.S(s)).then(h=>this.W(s,h[h.length-1]).then(l=>this.J.$reveal(this.I,{item:l.item,parentChain:h.map(g=>g.item)},{select:f,focus:d,expand:u})),h=>this.M.error(h)):this.J.$reveal(this.I,void 0,{select:f,focus:d,expand:u})}get message(){return this.O}set message(s){this.O=s,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(s){this.P=s,this.J.$setTitle(this.I,s,this.Q)}get description(){return this.Q}set description(s){this.Q=s,this.J.$setTitle(this.I,this.P,s)}get badge(){return this.R}set badge(s){this.R?.value===s?.value&&this.R?.tooltip===s?.tooltip||(this.R=b.ViewBadge.from(s),this.J.$setBadge(this.I,s))}setExpanded(s,t){const f=this.getExtensionElement(s);f&&(t?this.u.fire(Object.freeze({element:f})):this.w.fire(Object.freeze({element:f})))}setSelectionAndFocus(s,t){const f=!(0,P.$ub)(this.s,s);this.s=s;const d=this.t!==t;this.t=t,f&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(s){s!==this.r&&(this.r=s,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(s){const t=(await Promise.all(s.map(async f=>{const d=this.getExtensionElement(f.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:f.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(f=>f!==void 0);t.forEach(f=>{f.treeItem.checkboxState=f.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(f=>[f.extensionItem,f.newState])})}async handleDrag(s,t,f){const d=[];for(const u of s){const h=this.getExtensionElement(u);h&&d.push(h)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,f),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(s,t,f){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,$.$ah)(()=>this.g?.handleDrop?this.g.handleDrop(d,s,f):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(s,t){if(!this.f.resolveTreeItem)return;const f=this.j.get(s);if(f){const d=this.m.get(f);if(d){const u=await this.f.resolveTreeItem(d.extensionItem,f,t)??d.extensionItem;return this.hb(u),d.item.tooltip=this.eb(u.tooltip),d.item.command=this.fb(d.disposableStore,u.command),d.item}}}S(s){return this.U(s).then(t=>t?this.S(t).then(f=>this.W(t,f[f.length-1]).then(d=>(f.push(d),f))):Promise.resolve([]))}U(s){const t=this.m.get(s);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$ah)(()=>this.f.getParent(s))}W(s,t){const f=this.m.get(s);return f?Promise.resolve(f):(0,$.$ah)(()=>this.f.getTreeItem(s)).then(d=>this.kb(s,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const u=this.getExtensionElement(d);if(u){const h=this.m.get(u);if(h)return Promise.resolve(h)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(s){if(s){let t;if(typeof s=="string"){const f=this.getExtensionElement(s);t=f?this.m.get(f):void 0}else t=s;return t&&t.children||void 0}return this.h}async Y(s){this.rb(s);const t=new y.$ee(this.Z.token);try{const f=s?this.m.get(s):void 0,d=await this.f.getChildren(s);if(t.token.isCancellationRequested)return;const u=(0,P.$Hb)(d||[]),h=await Promise.all((0,P.$Hb)(u).map(g=>this.f.getTreeItem(g)));if(t.token.isCancellationRequested)return;const l=h.map((g,E)=>g?this.db(u[E],g,f):null);return(0,P.$Hb)(l)}finally{t.dispose()}}$(s){if(s.some(f=>!f))return this.Z.dispose(!0),this.Z=new y.$ee,this.tb(),this.J.$refresh(this.I);{const f=this.ab(s);if(f.length)return this.bb(f)}return Promise.resolve(void 0)}ab(s){const t=new Set,f=s.map(u=>this.m.get(u));for(const u of f)if(u&&!t.has(u.item.handle)){let h=u;for(;h&&h.parent&&f.findIndex(l=>h&&h.parent&&l&&l.item.handle===h.parent.item.handle)===-1;){const l=this.j.get(h.parent.item.handle);h=l?this.m.get(l):void 0}h&&!h.parent&&t.add(u.item.handle)}const d=[];return t.forEach(u=>{const h=this.j.get(u);if(h){const l=this.m.get(h);l&&(!l.parent||!t.has(l.parent.item.handle))&&d.push(u)}}),d}bb(s){const t={};return Promise.all(s.map(f=>this.cb(f).then(d=>{d&&(t[f]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(s){const t=this.getExtensionElement(s);if(t){const f=this.m.get(t);if(f)return this.rb(t),(0,$.$ah)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const u=this.ib(t,d,f.parent);return this.pb(t,u,f,f.parent),f.dispose(),u}return null})}return Promise.resolve(null)}db(s,t,f){const d=this.ib(s,t,f);if(t.id&&this.j.has(d.item.handle))throw new Error((0,o.localize)(0,null,t.id));return this.ob(s,d),this.qb(d,f),d}eb(s){return w.$VM.isMarkdownString(s)?b.MarkdownString.from(s):s}fb(s,t){return t?{...this.L.toInternal(t,s),originalId:t.command}:void 0}gb(s){if(s.checkboxState===void 0)return;let t,f,d;return typeof s.checkboxState=="number"?t=s.checkboxState:(t=s.checkboxState.state,f=s.checkboxState.tooltip,d=s.checkboxState.accessibilityInformation),{isChecked:t===w.TreeItemCheckboxState.Checked,tooltip:f,accessibilityInformation:d}}hb(s){if(!w.$hN.isTreeItem(s,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(s,t,f){this.hb(t);const d=this.B(new L.$Tc),u=this.kb(s,t,f),h=this.lb(t);return{item:{handle:u,parentHandle:f?f.item.handle:void 0,label:c(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:h,iconDark:this.mb(t)||h,themeIcon:this.jb(t),collapsibleState:(0,A.$5f)(t.collapsibleState)?w.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:f,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(s){return s.iconPath instanceof w.$qN?s.iconPath:void 0}kb(s,{id:t,label:f,resourceUri:d},u,h){if(t)return`${n.b}/${t}`;const l=c(f,this.N),g=u?u.item.handle:n.a;let E=l?l.label:d?(0,R.$Sg)(d):"";E=E.indexOf("/")!==-1?E.replace("/","//"):E;const v=this.m.has(s)?this.m.get(s).item.handle:void 0,S=this.X(u)||[];let k,D=0;do{if(k=`${g}/${D}:${E}`,h||!this.j.has(k)||v===k)break;D++}while(D<=S.length);return k}lb(s){if(s.iconPath&&!(s.iconPath instanceof w.$qN))return typeof s.iconPath=="string"||I.URI.isUri(s.iconPath)?this.nb(s.iconPath):this.nb(s.iconPath.light)}mb(s){if(s.iconPath&&!(s.iconPath instanceof w.$qN)&&s.iconPath.dark)return this.nb(s.iconPath.dark)}nb(s){return I.URI.isUri(s)?s:I.URI.file(s)}ob(s,t){this.j.set(t.item.handle,s),this.m.set(s,t)}pb(s,t,f,d){this.j.delete(t.item.handle),this.m.delete(s),t.item.handle!==f.item.handle&&this.j.delete(f.item.handle),this.ob(s,t);const u=this.X(d)||[],h=u.filter(l=>l.item.handle===f.item.handle)[0];h&&u.splice(u.indexOf(h),1,t)}qb(s,t){t?(t.children||(t.children=[]),t.children.push(s)):(this.h||(this.h=[]),this.h.push(s))}rb(s){if(s){const t=this.m.get(s);if(t){if(t.children)for(const f of t.children){const d=this.j.get(f.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(s){const t=this.m.get(s);if(t){if(t.children)for(const f of t.children){const d=this.j.get(f.item.handle);d&&this.sb(d)}this.m.delete(s),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(s=>s.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}n.a="0",n.b="1"});var it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o},qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Ee[357],Ce([1,0,4,3,2,30,16,92,6,7]),function(re,e,o,R,I,M,L,p,$,w){"use strict";var A,P,b,C,y,a,m,c,i,n,r,s,t;Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=void 0;class f extends R.$Uc{constructor(l,g,E,v){super(),A.set(this,void 0),P.set(this,void 0),b.set(this,void 0),C.set(this,void 0),y.set(this,void 0),a.set(this,void 0),m.set(this,void 0),c.set(this,void 0),i.set(this,!0),n.set(this,void 0),r.set(this,!1),s.set(this,this.B(new o.$7d)),this.onDidDispose=qe(this,s,"f").event,t.set(this,this.B(new o.$7d)),this.onDidChangeViewState=qe(this,t,"f").event,it(this,A,l,"f"),it(this,P,g,"f"),it(this,C,E,"f"),it(this,b,v.viewType,"f"),it(this,y,v.panelOptions,"f"),it(this,c,v.viewColumn,"f"),it(this,a,v.title,"f"),it(this,n,v.active,"f")}dispose(){qe(this,r,"f")||(it(this,r,!0,"f"),qe(this,s,"f").fire(),qe(this,P,"f").$disposeWebview(qe(this,A,"f")),qe(this,C,"f").dispose(),super.dispose())}get webview(){return this.c(),qe(this,C,"f")}get viewType(){return this.c(),qe(this,b,"f")}get title(){return this.c(),qe(this,a,"f")}set title(l){this.c(),qe(this,a,"f")!==l&&(it(this,a,l,"f"),qe(this,P,"f").$setTitle(qe(this,A,"f"),l))}get iconPath(){return this.c(),qe(this,m,"f")}set iconPath(l){this.c(),qe(this,m,"f")!==l&&(it(this,m,l,"f"),qe(this,P,"f").$setIconPath(qe(this,A,"f"),I.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return qe(this,y,"f")}get viewColumn(){if(this.c(),!(typeof qe(this,c,"f")=="number"&&qe(this,c,"f")<0))return qe(this,c,"f")}get active(){return this.c(),qe(this,n,"f")}get visible(){return this.c(),qe(this,i,"f")}_updateViewState(l){qe(this,r,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(it(this,n,l.active,"f"),it(this,i,l.visible,"f"),it(this,c,l.viewColumn,"f"),qe(this,t,"f").fire({webviewPanel:this}))}reveal(l,g){this.c(),qe(this,P,"f").$reveal(qe(this,A,"f"),{viewColumn:typeof l>"u"?void 0:L.ViewColumn.from(l),preserveFocus:!!g})}c(){if(qe(this,r,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,P=new WeakMap,b=new WeakMap,C=new WeakMap,y=new WeakMap,a=new WeakMap,m=new WeakMap,c=new WeakMap,i=new WeakMap,n=new WeakMap,r=new WeakMap,s=new WeakMap,t=new WeakMap;class d extends R.$Uc{static c(){return(0,M.$Eg)()}constructor(l,g,E){super(),this.j=g,this.m=E,this.g=new Map,this.h=new Map,this.f=l.getProxy($.$sM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(l=>l.dispose()),this.g.clear()}createWebviewPanel(l,g,E,v,S={}){const k=typeof v=="object"?v.viewColumn:v,D={viewColumn:L.ViewColumn.from(k),preserveFocus:typeof v=="object"&&!!v.preserveFocus},F=(0,p.$9jc)(l),W=d.c();this.f.$createWebviewPanel((0,p.$$jc)(l),W,g,{title:E,panelOptions:u(S),webviewOptions:(0,p.$_jc)(l,this.m,S),serializeBuffersForPostMessage:F},D);const B=this.j.createNewWebview(W,S,l);return this.createNewWebviewPanel(W,g,E,k,S,B,!0)}$onDidChangeWebviewPanelViewStates(l){const g=Object.keys(l);g.sort((E,v)=>{const S=l[E],k=l[v];return S.active?1:k.active?-1:+S.visible-+k.visible});for(const E of g){const v=this.getWebviewPanel(E);if(!v)continue;const S=l[E];v._updateViewState({active:S.active,visible:S.visible,viewColumn:L.ViewColumn.to(S.position)})}}async $onDidDisposeWebviewPanel(l){this.getWebviewPanel(l)?.dispose(),this.g.delete(l),this.j.deleteWebview(l)}registerWebviewPanelSerializer(l,g,E){if(this.h.has(g))throw new Error(`Serializer for '${g}' already registered`);return this.h.set(g,{serializer:E,extension:l}),this.f.$registerSerializer(g,{serializeBuffersForPostMessage:(0,p.$9jc)(l)}),new w.$uM(()=>{this.h.delete(g),this.f.$unregisterSerializer(g)})}async $deserializeWebviewPanel(l,g,E,v){const S=this.h.get(g);if(!S)throw new Error(`No serializer found for '${g}'`);const{serializer:k,extension:D}=S,F=this.j.createNewWebview(l,E.webviewOptions,D),W=this.createNewWebviewPanel(l,g,E.title,v,E.panelOptions,F,E.active);await k.deserializeWebviewPanel(W,E.state)}createNewWebviewPanel(l,g,E,v,S,k,D){const F=new f(l,this.f,k,{viewType:g,title:E,viewColumn:v,panelOptions:S,active:D});return this.g.set(l,F),F}getWebviewPanel(l){return this.g.get(l)}}e.$akc=d;function u(h){return{enableFindWidget:h.enableFindWidget,retainContextWhenHidden:h.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o},qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Ee[358],Ce([1,0,4,3,92,16,6,7]),function(re,e,o,R,I,M,L,p){"use strict";var $,w,A,P,b,C,y,a,m,c,i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Elc=void 0;class n extends R.$Uc{constructor(t,f,d,u,h,l){super(),$.set(this,void 0),w.set(this,void 0),A.set(this,void 0),P.set(this,void 0),b.set(this,!1),C.set(this,void 0),y.set(this,void 0),a.set(this,void 0),m.set(this,void 0),c.set(this,this.B(new o.$7d)),this.onDidChangeVisibility=qe(this,c,"f").event,i.set(this,this.B(new o.$7d)),this.onDidDispose=qe(this,i,"f").event,it(this,A,d,"f"),it(this,y,u,"f"),it(this,$,t,"f"),it(this,w,f,"f"),it(this,P,h,"f"),it(this,C,l,"f")}dispose(){qe(this,b,"f")||(it(this,b,!0,"f"),qe(this,i,"f").fire(),qe(this,P,"f").dispose(),super.dispose())}get title(){return this.a(),qe(this,y,"f")}set title(t){this.a(),qe(this,y,"f")!==t&&(it(this,y,t,"f"),qe(this,w,"f").$setWebviewViewTitle(qe(this,$,"f"),t))}get description(){return this.a(),qe(this,a,"f")}set description(t){this.a(),qe(this,a,"f")!==t&&(it(this,a,t,"f"),qe(this,w,"f").$setWebviewViewDescription(qe(this,$,"f"),t))}get visible(){return qe(this,C,"f")}get webview(){return qe(this,P,"f")}get viewType(){return qe(this,A,"f")}_setVisible(t){t===qe(this,C,"f")||qe(this,b,"f")||(it(this,C,t,"f"),qe(this,c,"f").fire())}get badge(){return this.a(),qe(this,m,"f")}set badge(t){this.a(),!(t?.value===qe(this,m,"f")?.value&&t?.tooltip===qe(this,m,"f")?.tooltip)&&(it(this,m,M.ViewBadge.from(t),"f"),qe(this,w,"f").$setWebviewViewBadge(qe(this,$,"f"),t))}show(t){this.a(),qe(this,w,"f").$show(qe(this,$,"f"),!!t)}a(){if(qe(this,b,"f"))throw new Error("Webview is disposed")}}$=new WeakMap,w=new WeakMap,A=new WeakMap,P=new WeakMap,b=new WeakMap,C=new WeakMap,y=new WeakMap,a=new WeakMap,m=new WeakMap,c=new WeakMap,i=new WeakMap;class r{constructor(t,f){this.d=f,this.b=new Map,this.c=new Map,this.a=t.getProxy(L.$sM.MainThreadWebviewViews)}registerWebviewViewProvider(t,f,d,u){if(this.b.has(f))throw new Error(`View provider for '${f}' already registered`);return this.b.set(f,{provider:d,extension:t}),this.a.$registerWebviewViewProvider((0,I.$$jc)(t),f,{retainContextWhenHidden:u?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$9jc)(t)}),new p.$uM(()=>{this.b.delete(f),this.a.$unregisterWebviewViewProvider(f)})}async $resolveWebviewView(t,f,d,u,h){const l=this.b.get(f);if(!l)throw new Error(`No view provider found for '${f}'`);const{provider:g,extension:E}=l,v=this.d.createNewWebview(t,{},E),S=new n(t,this.a,f,d,v,!0);this.c.set(t,S),await g.resolveWebviewView(S,{state:u},h)}async $onDidChangeWebviewViewVisibility(t,f){this.e(t)._setVisible(f)}async $disposeWebviewView(t){const f=this.e(t);this.c.delete(t),f.dispose(),this.d.deleteWebview(t)}e(t){const f=this.c.get(t);if(!f)throw new Error("No webview found");return f}}e.$Elc=r}),define(Ee[359],Ce([1,0,69,15,12,259,32,11]),function(re,e,o,R,I,M,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=void 0;let $=class{constructor(P,b){P.addFileSystemProvider(R.Schemas.file,new w(b),{isCaseSensitive:p.$e})}};e.$lmc=$,e.$lmc=$=Qe([He(0,o.$5jc),He(1,I.$Oj)],$);class w{constructor(P){this.b=P,this.a=new M.$Wq(this.b)}async stat(P){const b=await this.a.stat(P);return{type:b.type,ctime:b.ctime,mtime:b.mtime,size:b.size,permissions:b.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(P){return this.a.readdir(P)}createDirectory(P){return this.a.mkdir(P)}readFile(P){return this.a.readFile(P)}writeFile(P,b,C){return this.a.writeFile(P,b,{...C,unlock:!1,atomic:!1})}delete(P,b){return this.a.delete(P,{...b,useTrash:!1,atomic:!1})}rename(P,b,C){return this.a.rename(P,b,C)}copy(P,b,C){return this.a.copy(P,b,C)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(P,b){throw new Error("Method not implemented.")}}}),define(Ee[360],Ce([1,0,17,62,30,33,3,6,2,20]),function(re,e,o,R,I,M,L,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=void 0;let A=class extends L.$Uc{constructor(b,C){super();const y=b.getProxy(p.$sM.MainThreadDownloadService);C.registerCommand(!1,"_workbench.downloadResource",async a=>{const m=$.URI.file((0,o.$kc)((0,R.tmpdir)(),(0,I.$Eg)()));return await y.$download(a,m),m})}};e.$jmc=A,e.$jmc=A=Qe([He(0,w.$OO),He(1,M.$$O)],A)}),define(Ee[361],Ce([1,0,50,17,2,93,3,15,8,31]),function(re,e,o,R,I,M,L,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=void 0;class A extends M.$7jc{constructor(){super(...arguments),this.i=null}async g(t){const f=await super.g(t);if(f.scheme!==p.Schemas.file)return f;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${f.fsPath}.`),f;const d=f.fsPath;let u=0;do{let h;u===0?h=d:h=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${u}`:`${d}-${u}`,await P(h);const l=R.$kc(h,"vscode.lock"),g=await a(this.d,l,!1);if(g)return this.i=g,process.on("exit",()=>{g.dispose()}),I.URI.file(h);u++}while(u<10);return f}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$vmc=A;async function P(s){try{await w.Promises.stat(s);return}catch{}try{await w.Promises.mkdir(s,{recursive:!0})}catch{}}const b=1e3,C=10*60*1e3;class y extends L.$Uc{constructor(t,f){super(),this.b=t,this.c=f,this.a=this.B(new $.$th),this.a.cancelAndSet(async()=>{const d=await m(t,f);(!d||d.pid!==process.pid)&&(t.info(`Lock '${f}': The lock was lost unexpectedly.`),this.a.cancel());try{await w.Promises.utimes(f,new Date,new Date)}catch(u){t.error(u),t.info(`Lock '${f}': Could not update mtime.`)}},b)}dispose(){super.dispose();try{o.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const f={pid:process.pid,willReleaseAt:Date.now()+t};await w.Promises.writeFile(this.c,JSON.stringify(f),{flag:"w"})}catch(f){this.b.error(f)}}}async function a(s,t,f){try{const u={pid:process.pid,willReleaseAt:0};await w.Promises.writeFile(t,JSON.stringify(u),{flag:"wx"})}catch(u){s.error(u)}const d=await m(s,t);return!d||d.pid!==process.pid?f?(s.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(s.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(s,t)):(s.info(`Lock '${t}': Lock acquired.`),new y(s,t))}async function m(s,t){let f;try{f=await w.Promises.readFile(t)}catch(d){return s.error(d),null}try{return JSON.parse(String(f))}catch(d){return s.error(d),null}}async function c(s,t){let f;try{f=await w.Promises.stat(t)}catch(d){return s.error(d),0}return f.mtime.getTime()}function i(s){try{return process.kill(s,0),!0}catch{return!1}}async function n(s,t){const f=await m(s,t);if(!f)return s.info(`Lock '${t}': Could not read pid of lock holder.`),r(s,t);if(f.willReleaseAt){let g=f.willReleaseAt-Date.now();if(g<5e3){for(g>0?s.info(`Lock '${t}': The lockfile is scheduled to be released in ${g} ms.`):s.info(`Lock '${t}': The lockfile is scheduled to have been released.`);g>0;){if(await(0,$.$jh)(Math.min(100,g)),await c(s,t)===0)return r(s,t);g=f.willReleaseAt-Date.now()}return r(s,t)}}if(!i(f.pid))return s.info(`Lock '${t}': The pid ${f.pid} appears to be gone.`),r(s,t);const d=await c(s,t),u=Date.now()-d;if(u<=C)return s.info(`Lock '${t}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;s.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$jh)(2e3);const h=await c(s,t),l=Date.now()-h;return l<=C?(s.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(s.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(s,t))}async function r(s,t){s.info(`Lock '${t}': Deleting a stale lock.`);try{await w.Promises.unlink(t)}catch{}return a(s,t,!0)}}),define(Ee[362],Ce([1,0,30,20,44,33]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=void 0;let L=class extends I.$qkc{constructor($,w){super(!0,$,w)}createTerminal($,w,A){return this.createTerminalFromOptions({name:$,shellPath:w,shellArgs:A})}createTerminalFromOptions($,w){const A=new I.$pkc(this.a,(0,o.$Eg)(),$,$.name);return this.f.push(A),A.create($,this.R($,w)),A.value}};e.$Qlc=L,e.$Qlc=L=Qe([He(0,M.$$O),He(1,R.$OO)],L)}),define(Ee[363],Ce([1,0,4,37,42,5]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OL=e.$NL=e.OutputChannelUpdateMode=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=void 0,e.$AL="text/x-code-output",e.$BL="output",e.$CL="Log",e.$DL="text/x-code-log-output",e.$EL="log",e.$FL="workbench.panel.output",e.$GL=new I.$zj("inOutput",!1),e.$HL=new I.$zj("activeLogOutput",!1),e.$IL=new I.$zj("activeLogOutput.levelSettable",!1),e.$JL=new I.$zj("activeLogOutput.level",""),e.$KL=new I.$zj("activeLogOutput.levelIsDefault",!1),e.$LL=new I.$zj("outputView.scrollLock",!1),e.$ML=(0,M.$ii)("outputService");var L;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.$NL={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new o.$7d,this.onDidRegisterChannel=this.b.event,this.c=new o.$7d,this.onDidRemoveChannel=this.c.event}registerChannel(w){this.a.has(w.id)||(this.a.set(w.id,w),this.b.fire(w.id))}getChannels(){const w=[];return this.a.forEach(A=>w.push(A)),w}getChannel(w){return this.a.get(w)}removeChannel(w){this.a.delete(w),this.c.fire(w)}}R.$2n.add(e.$NL.OutputChannels,new p),e.$OL=new I.$zj("activeOutputChannel","")}),define(Ee[158],Ce([1,0,6,5,20,25,12,363,69,28,59,199,21,18,32,4,3]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=e.$flc=void 0;class c extends L.$Uj{get disposed(){return this.n}constructor(s,t,f,d,u){super(),this.id=s,this.name=t,this.r=f,this.s=d,this.extension=u,this.m=0,this.n=!1,this.visible=!1,this.setLevel(f.getLevel()),this.B(f.onDidChangeLogLevel(h=>this.setLevel(h)))}get logLevel(){return this.getLevel()}appendLine(s){this.append(s+`
`)}append(s){this.info(s)}clear(){const s=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,s)}replace(s){const t=this.m;this.info(s),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(s,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof s=="boolean"?s:t))}hide(){this.s.$close(this.id)}g(s,t){this.m+=b.$ue.fromString(t).byteLength,(0,L.log)(this.r,s,t),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends c{appendLine(s){this.append(s)}}let n=class{constructor(s,t,f,d,u,h){this.i=t,this.j=f,this.k=d,this.l=u,this.m=h,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=s.getProxy(o.$sM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,P.$Qm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(s){this.h=s;for(const[t,f]of this.g)f.visible=t===this.h}createOutputChannel(s,t,f){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,u=(0,C.$Vf)(t)?t:void 0;if((0,C.$Vf)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let h;const l=this.i.environment.extensionLogLevel?.find(([E])=>M.$Em.equals(f.identifier,E))?.[1];l&&(h=(0,L.$6j)(l));const g=d?this.o(s,h,f):this.n(s,u,f);return g.then(E=>{this.g.set(E.id,E),E.visible=E.id===this.h}),d?this.r(s,h??this.m.getLevel(),g):this.q(s,g)}async n(s,t,f){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,u=this.k.extUri.joinPath(d,`${this.f++}-${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),h=this.l.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),l=await this.a.$register(s,u,t,f.identifier.value);return new c(l,s,h,this.a,f)}async o(s,t,f){const d=await this.p(f),u=s.replace(/[\\/:\*\?"<>\|]/g,""),h=this.k.extUri.joinPath(d,`${u}.log`),l=`${f.identifier.value}.${u}`,g=this.l.createLogger(h,{id:l,name:s,logLevel:t,extensionId:f.identifier.value});return new i(l,s,g,this.a,f)}p(s){let t=this.d.get(s.identifier.value);if(!t){const f=this.k.extUri.joinPath(this.i.logsLocation,s.identifier.value);this.d.set(s.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(f)}catch(d){if((0,y.$5k)(d)!==y.FileSystemProviderErrorCode.FileExists)throw d}return f})())}return t}q(s,t){let f=!1;const d=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return s},append(u){d(),t.then(h=>h.append(u))},appendLine(u){d(),t.then(h=>h.appendLine(u))},clear(){d(),t.then(u=>u.clear())},replace(u){d(),t.then(h=>h.replace(u))},show(u,h){d(),t.then(l=>l.show(u,h))},hide(){d(),t.then(u=>u.hide())},dispose(){f=!0,t.then(u=>u.dispose())}}}r(s,t,f){const d=new m.$Tc,u=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},h=d.add(new a.$7d);function l(g){t=g,h.fire(g)}return f.then(g=>{d.add(g),g.logLevel!==t&&l(g.logLevel),d.add(g.onDidChangeLogLevel(E=>l(E)))}),{...this.q(s,f),get logLevel(){return t},onDidChangeLogLevel:h.event,trace(g,...E){u(),f.then(v=>v.trace(g,...E))},debug(g,...E){u(),f.then(v=>v.debug(g,...E))},info(g,...E){u(),f.then(v=>v.info(g,...E))},warn(g,...E){u(),f.then(v=>v.warn(g,...E))},error(g,...E){u(),f.then(v=>v.error(g,...E))},dispose(){d.dispose()}}}};e.$flc=n,e.$flc=n=Qe([He(0,I.$OO),He(1,w.$5O),He(2,$.$5jc),He(3,A.$Ejc),He(4,L.$Pj),He(5,L.$Oj)],n),e.$glc=(0,R.$ii)("IExtHostOutputService")}),define(Ee[159],Ce([1,0,5,8]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=void 0,e.$6m=(0,o.$ii)("remoteAgentService"),e.$7m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let M=1/0;for(let p=0;p<this.maxSampleCount;p++){const $=await I.getRoundTripTime();if($===void 0)return;M=Math.min(M,$/2),await(0,R.$jh)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(M):L=this.initial.reduce((p,$)=>p+$,0)/this.initial.length,this.lastMeasurement={initial:L,current:M,average:this.average.reduce((p,$)=>p+$,0)/this.average.length,high:typeof L>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>L*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ee[364],Ce([1,0,232,85,37,43,53,3,4,159,11,24,8]),function(re,e,o,R,I,M,L,p,$,w,A,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=void 0,e.$6I=Object.freeze({id:"application",order:100,title:(0,o.localize)(0,null),type:"object"}),e.$7I=Object.freeze({id:"workbench",order:7,title:(0,o.localize)(1,null),type:"object"}),e.$8I=Object.freeze({id:"security",scope:1,title:(0,o.localize)(2,null),type:"object",order:7}),e.$9I=Object.freeze({id:"problems",title:(0,o.localize)(3,null),type:"object",order:101}),e.$0I={ConfigurationMigration:"base.contributions.configuration.migration"};class C{constructor(){this.migrations=[],this.a=new $.$7d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const y=new C;I.$2n.add(e.$0I.ConfigurationMigration,y);let a=class extends p.$Uc{constructor(i,n){super(),this.a=i,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async r=>{for(const s of r.added)await this.f(s,y.migrations)})),this.c(y.migrations),this.B(y.onDidRegisterConfigurationMigration(r=>this.c(r)))}async c(i){await this.f(void 0,i);for(const n of this.b.getWorkspace().folders)await this.f(n,i)}async f(i,n){await Promise.all([n.map(r=>this.g(r,i?.uri))])}async g(i,n){const r=this.a.inspect(i.key,{resource:n}),s=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,f]of s){const d=r[t];if(!d)continue;const u=[];if(d.value!==void 0){const h=await this.h(i,t,d.value,n,void 0);for(const l of h??[])u.push([l,[]])}for(const{identifiers:h,value:l}of d.overrides??[])if(l!==void 0){const g=await this.h(i,t,l,n,h);for(const E of g??[])u.push([E,h])}u.length&&await Promise.allSettled(u.map(async([[h,l],g])=>this.a.updateValue(h,l.value,{resource:n,overrideIdentifiers:g},f)))}}async h(i,n,r,s,t){const f=u=>{const l=this.a.inspect(u,{resource:s})[n];if(l)return t?l.overrides?.find(({identifiers:g})=>(0,P.$Tn)(g,t))?.value:l.value},d=await i.migrateFn(r,f);return Array.isArray(d)?d:[[i.key,d]]}};e.$$I=a,a.ID="workbench.contrib.configurationMigration",e.$$I=a=Qe([He(0,L.$Oi),He(1,M.$ri)],a);let m=class extends p.$Uc{constructor(i){super(),this.b=i,this.a=new b.$Fh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$c&&(await this.b.getEnvironment())?.os!==1)return;I.$2n.as(R.$7n.Configuration).registerConfiguration({...e.$8I,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,o.localize)(4,null)},default:[],markdownDescription:(0,o.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,o.localize)(6,null),scope:2}}})}};e.$_I=m,m.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration",e.$_I=m=Qe([He(0,w.$6m)],m)}),define(Ee[365],Ce([1,0,35,15,17,23,241,364,85,5,37]),function(re,e,o,R,I,M,L,p,$,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Tfb=e.$Sfb=void 0,e.$Ufb=a,e.$Vfb=m,e.$Sfb=(0,w.$ii)("editorResolverService"),e.$Tfb="workbench.editorAssociations";const P=A.$2n.as($.$7n.Configuration),b={...p.$7I,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(0,null),additionalProperties:{type:"string"}}}};P.registerConfiguration(b);var C;(function(c){c.builtin="builtin",c.option="option",c.exclusive="exclusive",c.default="default"})(C||(e.RegisteredEditorPriority=C={}));var y;(function(c){c[c.ABORT=1]="ABORT",c[c.NONE=2]="NONE"})(y||(e.ResolvedStatus=y={}));function a(c){switch(c){case C.exclusive:return 5;case C.default:return 4;case C.builtin:return 3;case C.option:default:return 1}}function m(c,i){if(new Set([R.Schemas.extension,R.Schemas.webviewPanel,R.Schemas.vscodeWorkspaceTrust,R.Schemas.vscodeSettings]).has(i.scheme))return!1;const s=typeof c=="string"&&c.indexOf(I.$hc.sep)>=0?`${i.scheme}:${i.path}`:(0,M.$Sg)(i);return o.$bk(typeof c=="string"?c.toLowerCase():c,s.toLowerCase())}}),define(Ee[366],Ce([1,0,34,15,17,11,23,2,5,277,43,148,159]),function(re,e,o,R,I,M,L,p,$,w,A,P,b){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$8L=e.$7L=void 0,e.$7L=(0,$.$ii)("pathService");let y=C=class{constructor(m,c,i,n){this.d=m,this.e=c,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??m})()}hasValidBasename(m,c,i){return typeof c=="string"||typeof c>"u"?this.a.then(n=>this.h(m,n,c)):this.h(m,c,i)}h(m,c,i){return m.scheme===R.Schemas.file||m.scheme===R.Schemas.vscodeRemote?(0,o.$gg)(i??(0,L.$Sg)(m),c===1):!0}get defaultUriScheme(){return C.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,c){if(m.remoteAuthority)return R.Schemas.vscodeRemote;const i=(0,w.$4L)(c.getWorkspace());if(i)return i;const n=c.getWorkspace().folders[0];if(n)return n.uri.scheme;const r=c.getWorkspace().configuration;return r?r.scheme:R.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===1?I.$gc:I.$hc)}async fileURI(m){let c="";if(await this.a===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const n=m.indexOf("/",2);n===-1?(c=m.substring(2),m="/"):(c=m.substring(2,n),m=m.substring(n)||"/")}return p.URI.from({scheme:R.Schemas.file,authority:c,path:m,query:"",fragment:""})}};e.$8L=y,e.$8L=y=C=Qe([He(1,b.$6m),He(2,P.$PL),He(3,A.$ri)],y)}),define(Ee[367],Ce([1,0,243,19,54,4,55,3,2,53,248,12,65,279,88,43,148,26,22,18,24,42]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i,n,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1L=e.$ZL=e.OnPortForward=e.$UL=e.$TL=e.TunnelSource=e.TunnelCloseReason=e.$RL=e.$QL=void 0,e.$SL=h,e.$VL=E,e.$WL=v,e.$XL=S,e.$YL=D;const t=10*1e3,f="remote.tunnels.toRestore",d="remote.tunnels.toRestoreExpiration",u=1e3*60*60*24*14;e.$QL="onTunnel",e.$RL=new s.$zj("forwardedPortsViewEnabled",!1,o.localize(0,null));function h(B){const j=B.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(j)return{host:j[1]?.substring(0,j[1].length-1)||"localhost",port:Number(j[2])}}var l;(function(B){B.Other="Other",B.User="User",B.AutoForwardEnd="AutoForwardEnd"})(l||(e.TunnelCloseReason=l={}));var g;(function(B){B[B.User=0]="User",B[B.Auto=1]="Auto",B[B.Extension=2]="Extension"})(g||(e.TunnelSource=g={})),e.$TL={source:g.User,description:o.localize(1,null)},e.$UL={source:g.Auto,description:o.localize(2,null)};function E(B,j,N){const T=B.get(S(j,N));if(T)return T;if((0,y.$4v)(j))for(const O of y.$3v){const z=S(O,N);if(B.has(z))return B.get(z)}else if((0,y.$6v)(j))for(const O of y.$5v){const z=S(O,N);if(B.has(z))return B.get(z)}}function v(B,j,N){const T=E(B,j,N);if(T)return T;const O=(0,y.$6v)(j)?"localhost":(0,y.$4v)(j)?"0.0.0.0":void 0;if(O)return E(B,O,N)}function S(B,j){return B+":"+j}var k;(function(B){B.Notify="notify",B.OpenBrowser="openBrowser",B.OpenBrowserOnce="openBrowserOnce",B.OpenPreview="openPreview",B.Silent="silent",B.Ignore="ignore"})(k||(e.OnPortForward=k={}));function D(B){return B&&"host"in B&&typeof B.host=="string"&&"port"in B&&typeof B.port=="number"&&(!("detail"in B)||typeof B.detail=="string")&&(!("pid"in B)||typeof B.pid=="string")}class F extends p.$Uc{constructor(j){super(),this.r=j,this.j=[],this.n=new M.$7d,this.onDidChangeAttributes=this.n.event,this.B(j.onDidChangeConfiguration(N=>{(N.affectsConfiguration(F.c)||N.affectsConfiguration(F.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(j,N,T){let O=this.w(j,N,T,this.j,0);const z={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;O>=0;){const Q=this.j[O];Q.key===j?(z.onAutoForward=Q.onAutoForward??z.onAutoForward,z.elevateIfNeeded=Q.elevateIfNeeded!==void 0?Q.elevateIfNeeded:z.elevateIfNeeded,z.label=Q.label??z.label,z.requireLocalPort=Q.requireLocalPort,z.protocol=Q.protocol):(z.onAutoForward=z.onAutoForward??Q.onAutoForward,z.elevateIfNeeded=z.elevateIfNeeded!==void 0?z.elevateIfNeeded:Q.elevateIfNeeded,z.label=z.label??Q.label,z.requireLocalPort=z.requireLocalPort!==void 0?z.requireLocalPort:void 0,z.protocol=z.protocol??Q.protocol),O=this.w(j,N,T,this.j,O+1)}return z.onAutoForward!==void 0||z.elevateIfNeeded!==void 0||z.label!==void 0||z.requireLocalPort!==void 0||z.protocol!==void 0?z:this.C()}t(j){return j.start!==void 0&&j.end!==void 0}u(j){return j.host!==void 0&&j.port!==void 0&&(0,n.$Vf)(j.host)&&(0,n.$Zf)(j.port)}w(j,N,T,O,z){if(z>=O.length)return-1;const Q=!(0,y.$4v)(N)&&!(0,y.$6v)(N),J=O.slice(z).findIndex(x=>(0,n.$Zf)(x.key)?Q?!1:x.key===j:this.t(x.key)?Q?!1:j>=x.key.start&&j<=x.key.end:this.u(x.key)?j===x.key.port&&N===x.key.host:T?x.key.test(T):!1);return J>=0?J+z:-1}y(){const j=this.r.getValue(F.c);if(!j||!(0,n.$Xf)(j))return[];const N=[];for(const O in j){if(O===void 0)continue;const z=j[O];let Q;if(Number(O))Q=Number(O);else if((0,n.$Vf)(O))if(F.g.test(O)){const Z=O.match(F.g);Q={start:Number(Z[1]),end:Number(Z[2])}}else if(F.h.test(O)){const Z=O.match(F.h);Q={host:Z[1],port:Number(Z[2])}}else{let Z;try{Z=RegExp(O)}catch{}Z&&(Q=Z)}Q&&N.push({key:Q,elevateIfNeeded:z.elevateIfNeeded,onAutoForward:z.onAutoForward,label:z.label,requireLocalPort:z.requireLocalPort,protocol:z.protocol})}const T=this.r.getValue(F.f);return T&&(this.m={elevateIfNeeded:T.elevateIfNeeded,label:T.label,onAutoForward:T.onAutoForward,requireLocalPort:T.requireLocalPort,protocol:T.protocol}),this.z(N)}z(j){function N(T,O){return(0,n.$Zf)(T.key)?T.key:O.t(T.key)?T.key.start:O.u(T.key)?T.key.port:Number.MAX_VALUE}return j.sort((T,O)=>N(T,this)-N(O,this))}C(){return this.m}static providedActionToAction(j){switch(j){case y.ProvidedOnAutoForward.Notify:return k.Notify;case y.ProvidedOnAutoForward.OpenBrowser:return k.OpenBrowser;case y.ProvidedOnAutoForward.OpenBrowserOnce:return k.OpenBrowserOnce;case y.ProvidedOnAutoForward.OpenPreview:return k.OpenPreview;case y.ProvidedOnAutoForward.Silent:return k.Silent;case y.ProvidedOnAutoForward.Ignore:return k.Ignore;default:return}}async addAttributes(j,N,T){const z=this.r.inspect(F.c).userRemoteValue;let Q;!z||!(0,n.$Xf)(z)?Q={}:Q=(0,r.$Pn)(z),Q[`${j}`]||(Q[`${j}`]={});for(const Z in N)Q[`${j}`][Z]=N[Z];return this.r.updateValue(F.c,Q,T)}}e.$ZL=F,F.c="remote.portsAttributes",F.f="remote.otherPortsAttributes",F.g=/^(\d+)\-(\d+)$/,F.h=/^([a-z0-9\-]+):(\d{1,5})$/;let W=class extends p.$Uc{constructor(j,N,T,O,z,Q,Z,J,x,ce){super(),this.H=j,this.I=N,this.J=T,this.L=O,this.M=z,this.N=Q,this.O=Z,this.P=J,this.Q=x,this.R=ce,this.c=new Map,this.g=new M.$7d,this.onForwardPort=this.g.event,this.h=new M.$7d,this.onClosePort=this.h.event,this.j=new M.$7d,this.onPortName=this.j.event,this.n=new M.$7d,this.onCandidatesChanged=this.n.event,this.t=new M.$7d,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new M.$7d,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new F(T),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async te=>{const pe=await this.getAttributes(te.map(ye=>({port:ye.tunnelRemotePort,host:ye.tunnelRemoteHost})));for(const ye of te)if(ye.localAddress){const _=S(ye.tunnelRemoteHost,ye.tunnelRemotePort),U=v(this.m??new Map,ye.tunnelRemoteHost,ye.tunnelRemotePort);this.forwarded.set(_,{remotePort:ye.tunnelRemotePort,remoteHost:ye.tunnelRemoteHost,localAddress:ye.localAddress,protocol:pe?.get(ye.tunnelRemotePort)?.protocol??y.TunnelProtocol.Http,localUri:await this.X(ye.localAddress,pe?.get(ye.tunnelRemotePort)),localPort:ye.tunnelLocalPort,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:ye.privacy,source:e.$TL}),this.f.set(_,ye)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async te=>{const pe=S(te.tunnelRemoteHost,te.tunnelRemotePort);if(!v(this.forwarded,te.tunnelRemoteHost,te.tunnelRemotePort)&&!v(this.detected,te.tunnelRemoteHost,te.tunnelRemotePort)&&!v(this.c,te.tunnelRemoteHost,te.tunnelRemotePort)&&te.localAddress){const ye=v(this.m??new Map,te.tunnelRemoteHost,te.tunnelRemotePort),_=(await this.getAttributes([{port:te.tunnelRemotePort,host:te.tunnelRemoteHost}]))?.get(te.tunnelRemotePort);this.forwarded.set(pe,{remoteHost:te.tunnelRemoteHost,remotePort:te.tunnelRemotePort,localAddress:te.localAddress,protocol:_?.protocol??y.TunnelProtocol.Http,localUri:await this.X(te.localAddress,_),localPort:te.tunnelLocalPort,closeable:!0,runningProcess:ye?.detail,hasRunningProcess:!!ye,pid:ye?.pid,privacy:te.privacy,source:e.$TL})}await this.cb(),this.f.set(pe,te),this.g.fire(this.forwarded.get(pe))})),this.B(this.H.onTunnelClosed(te=>this.W(te,l.Other))),this.U()}S(){return this.Q.extensions.find(j=>j.activationEvents?.includes(e.$QL))?(this.R.createKey(e.$RL.key,!0),!0):!1}U(){if(this.S())return;const j=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&j.dispose()}))}async W(j,N){const T=S(j.host,j.port);this.forwarded.has(T)&&(this.forwarded.delete(T),await this.cb(),this.h.fire(j))}X(j,N){if(j.startsWith("http"))return $.URI.parse(j);const T=N?.protocol??"http";return $.URI.parse(`${T}://${j}`)}async Y(j){const N=this.N.getWorkspace(),T=N.configuration?(0,L.$9i)(N.configuration.path):N.folders.length>0?(0,L.$9i)(N.folders[0].uri.path):void 0;if(T===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${j}.${this.L.remoteAuthority}.${T}`}async Z(){return this.Y(f)}async $(){return this.Y(d)}async ab(){const j=this.I.get(f,1);if(j)return this.I.remove(f,1),await this.cb(),j;const N=await this.Z();if(N)return this.I.get(N,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const j=await this.s;if(j&&j!==this.y){const N=JSON.parse(j)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${N.map(T=>T.remotePort).join(", ")}`);for(const T of N){const O=v(this.detected,T.remoteHost,T.remotePort);T.source.source!==g.Extension&&!O||T.source.source===g.Extension&&O?await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,elevateIfNeeded:!0,source:T.source}):T.source.source===g.Extension&&!O&&this.D.set(S(T.remoteHost,T.remotePort),T)}}}if(this.z=!0,this.C.fire(),!this.w){const j=await this.Z();this.w=this.B(new p.$Tc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async N=>{N.key===j&&(this.s=Promise.resolve(this.I.get(j,0)),await this.restoreForwarded())}))}}bb(){const j=this.I.keys(0,0).filter(N=>N.startsWith(d));for(const N of j){const T=this.I.getNumber(N,0);if(T&&T<Date.now()){this.s=Promise.resolve(void 0);const O=N.replace(d,f);this.I.remove(N,0),this.I.remove(O,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const j=Array.from(this.forwarded.values()),N=j.map(Q=>({remoteHost:Q.remoteHost,remotePort:Q.remotePort,localPort:Q.localPort,name:Q.name,localAddress:Q.localAddress,localUri:Q.localUri,protocol:Q.protocol,source:Q.source}));let T;j.length>0&&(T=JSON.stringify(N));const O=await this.Z(),z=await this.$();!T&&O&&z?(this.I.remove(O,0),this.I.remove(z,0)):T!==this.y&&O&&z&&(this.I.store(O,T,0,0),this.I.store(z,Date.now()+u,0,0)),this.y=T}}async eb(j,N,T){if(!j.tunnelLocalPort||!T?.requireLocalPort||j.tunnelLocalPort===N)return;const O=new Date;if(this.db.getTime()+t>O.getTime())return;this.db=O;const z=o.localize(3,null,N,j.tunnelRemotePort,j.tunnelLocalPort);return this.P.info(z)}async forward(j,N){return!this.z&&this.L.remoteAuthority&&await M.Event.toPromise(this.C.event),this.fb(j,N)}async fb(j,N){await this.Q.activateByEvent(e.$QL);const T=v(this.forwarded,j.remote.host,j.remote.port);N=N??(N!==null?(await this.getAttributes([j.remote]))?.get(j.remote.port):void 0);const O=j.local!==void 0?j.local:j.remote.port;let z;if(T)return this.hb(T,j,N);{const Q=this.L.remoteAuthority,Z=Q?{getAddress:async()=>(await this.M.resolveAuthority(Q)).authority}:void 0,J=S(j.remote.host,j.remote.port);this.c.set(J,!0),j=this.gb(J,j);const x=await this.H.openTunnel(Z,j.remote.host,j.remote.port,void 0,O,j.elevateIfNeeded?j.elevateIfNeeded:N?.elevateIfNeeded,j.privacy,N?.protocol);if(typeof x=="string")z=x;else if(x&&x.localAddress){const ce=v(this.m??new Map,j.remote.host,j.remote.port),te=x.protocol?x.protocol===y.TunnelProtocol.Https?y.TunnelProtocol.Https:y.TunnelProtocol.Http:N?.protocol??y.TunnelProtocol.Http,pe={remoteHost:x.tunnelRemoteHost,remotePort:x.tunnelRemotePort,localPort:x.tunnelLocalPort,name:N?.label??j.name,closeable:!0,localAddress:x.localAddress,protocol:te,localUri:await this.X(x.localAddress,N),runningProcess:ce?.detail,hasRunningProcess:!!ce,pid:ce?.pid,source:j.source??e.$TL,privacy:x.privacy};return this.forwarded.set(J,pe),this.f.set(J,x),this.c.delete(J),await this.cb(),await this.eb(x,O,N),this.g.fire(pe),x}this.c.delete(J)}return z}gb(j,N){const T=this.D.has(j)?this.D:this.F.has(j)?this.F:void 0;if(T){const O=T.get(j);T.delete(j),O&&(N.name=O.name??N.name,N.local=("local"in O?O.local:"localPort"in O?O.localPort:void 0)??N.local,N.privacy=N.privacy)}return N}async hb(j,N,T){const O=T?.label??N.name;let z;(function(Z){Z[Z.None=0]="None",Z[Z.Fire=1]="Fire",Z[Z.Reopen=2]="Reopen"})(z||(z={}));let Q=z.None;switch(O!==j.name&&(j.name=O,Q=z.Fire),(T?.protocol||j.protocol!==y.TunnelProtocol.Http)&&T?.protocol!==j.protocol&&(N.source=j.source,Q=z.Reopen),N.privacy&&j.privacy!==N.privacy&&(Q=z.Reopen),Q){case z.Fire:{this.g.fire();break}case z.Reopen:await this.close(j.remoteHost,j.remotePort,l.User),await this.fb(N,T)}return v(this.f,N.remote.host,N.remote.port)}async name(j,N,T){const O=v(this.forwarded,j,N),z=S(j,N);if(O){O.name=T,await this.cb(),this.j.fire({host:j,port:N});return}else this.detected.has(z)&&(this.detected.get(z).name=T,this.j.fire({host:j,port:N}))}async close(j,N,T){const O=S(j,N),z=this.forwarded.get(O);return T===l.AutoForwardEnd&&z&&z.source.source===g.Auto&&this.F.set(O,{local:z.localPort,name:z.name,privacy:z.privacy}),await this.H.closeTunnel(j,N),this.W({host:j,port:N},T)}address(j,N){const T=S(j,N);return(this.forwarded.get(T)||this.detected.get(T))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(j){if(j)for(const N of j){const T=v(this.m??new Map,N.remoteAddress.host,N.remoteAddress.port),O=typeof N.localAddress=="string"?N.localAddress:S(N.localAddress.host,N.localAddress.port);this.detected.set(S(N.remoteAddress.host,N.remoteAddress.port),{remoteHost:N.remoteAddress.host,remotePort:N.remoteAddress.port,localAddress:O,protocol:y.TunnelProtocol.Http,localUri:this.X(O),closeable:!1,runningProcess:T?.detail,hasRunningProcess:!!T,pid:T?.pid,privacy:y.TunnelPrivacyId.ConstantPrivate,source:{source:g.Extension,description:o.localize(4,null)}}),this.H.setEnvironmentTunnel(N.remoteAddress.host,N.remoteAddress.port,O,y.TunnelPrivacyId.ConstantPrivate,y.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(j){this.r=j}async setCandidates(j){let N=j;this.r&&(N=await this.r(j));const T=this.ib(N);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(T.values()).map(O=>O.port).join(", ")}`),this.n.fire(T)}ib(j){const N=this.m??new Map,T=new Map;return this.m=T,j.forEach(O=>{const z=S(O.host,O.port);T.set(z,{host:O.host,port:O.port,detail:O.detail,pid:O.pid}),N.has(z)&&N.delete(z);const Q=v(this.forwarded,O.host,O.port);Q&&(Q.runningProcess=O.detail,Q.hasRunningProcess=!0,Q.pid=O.pid)}),N.forEach((O,z)=>{const Q=h(z);if(!Q)return;const Z=v(this.forwarded,Q.host,Q.port);Z&&(Z.runningProcess=void 0,Z.hasRunningProcess=!1,Z.pid=void 0);const J=v(this.detected,Q.host,Q.port);J&&(J.runningProcess=void 0,J.hasRunningProcess=!1,J.pid=void 0)}),N}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const j=Array.from(this.forwarded.values()),N=await this.getAttributes(j.map(T=>({port:T.remotePort,host:T.remoteHost})),!1);if(N)for(const T of j){const O=N.get(T.remotePort);(O?.protocol||T.protocol!==y.TunnelProtocol.Http)&&O?.protocol!==T.protocol&&await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,source:T.source},O),O&&O.label&&O.label!==T.name&&await this.name(T.remoteHost,T.remotePort,O.label)}}async getAttributes(j,N=!0){const T=new Map,O=new Map;j.forEach(x=>{const ce=v(this.m??new Map,y.$3v[0],x.port)??x;if(ce){T.set(x.port,ce);const te=D(ce)?ce.pid:void 0;O.has(te)||O.set(te,[]),O.get(te)?.push(x.port)}});const z=new Map;if(j.forEach(x=>{const ce=this.configPortsAttributes.getAttributes(x.port,x.host,T.get(x.port)?.detail);ce&&z.set(x.port,ce)}),this.G.length===0||!N)return z.size>0?z:void 0;const Q=await Promise.all((0,R.$Rb)(this.G.map(x=>Array.from(O.entries()).map(ce=>{const te=ce[1],pe=T.get(te[0]);return x.providePortAttributes(te,pe?.pid,pe?.detail,i.CancellationToken.None)})))),Z=new Map;if(Q.forEach(x=>x.forEach(ce=>{ce&&Z.set(ce.port,ce)})),!z&&!Z)return;const J=new Map;return j.forEach(x=>{const ce=z.get(x.port),te=Z.get(x.port);J.set(x.port,{elevateIfNeeded:ce?.elevateIfNeeded,label:ce?.label,onAutoForward:ce?.onAutoForward??F.providedActionToAction(te?.autoForwardAction),requireLocalPort:ce?.requireLocalPort,protocol:ce?.protocol})}),J}addAttributesProvider(j){this.G.push(j)}};e.$1L=W,Qe([(0,I.$Nh)(1e3)],W.prototype,"cb",null),e.$1L=W=Qe([He(0,y.$Xv),He(1,C.$Np),He(2,w.$Oi),He(3,m.$PL),He(4,b.$tl),He(5,a.$ri),He(6,P.$Oj),He(7,A.$rw),He(8,c.$_F),He(9,s.$Aj)],W)}),define(Ee[94],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$AK=e.$zK=void 0;class o{constructor(L,p){this.line=L,this.character=p}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,p){return new o(0,0)}with(L){return new o(0,0)}}e.$zK=o;class R{constructor(L,p,$,w){this.isEmpty=!1,this.isSingleLine=!1,this.start=new o(L,p),this.end=new o($,w)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new R(0,0,0,0)}with(L){return new R(0,0,0,0)}}e.$AK=R;var I;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Ee[36],Ce([1,0,19,35,24,34,14,5,17,13,94,8]),function(re,e,o,R,I,M,L,p,$,w,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZK=e.$XK=e.$QK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$NK=e.$MK=e.$LK=e.$KK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.TextSearchCompleteMessageType=void 0,e.$HK=c,e.$IK=i,e.$JK=n,e.$OK=g,e.$PK=E,e.$RK=k,e.$SK=D,e.$TK=F,e.$UK=W,e.$VK=B,e.$WK=j,e.$YK=T,e.$1K=Q,e.$2K=Z,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$BK="workbench.view.search",e.$CK="workbench.panel.search",e.$DK="workbench.view.search",e.$EK="search-result",e.$FK="search.exclude";const b="\u27EA ",C=" characters skipped \u27EB",y=(b.length+C.length+5)*2;e.$GK=(0,p.$ii)("searchService");var a;(function(x){x[x.file=0]="file",x[x.text=1]="text",x[x.aiText=2]="aiText"})(a||(e.SearchProviderType=a={}));var m;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.aiText=3]="aiText"})(m||(e.QueryType=m={}));function c(x){return!!x.preview}function i(x){return!!x.resource}function n(x){return!!x.message}var r;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class s{constructor(ce){this.resource=ce,this.results=[]}}e.$KK=s;class t{constructor(ce,te,pe,ye){this.ranges=te,this.webviewIndex=ye;const _=Array.isArray(te)?te:[te];if(pe&&pe.matchLines===1&&f(_)){ce=(0,L.$Of)(ce,pe.matchLines);let U="",he=0,Se=0;const me=Math.floor(pe.charsPerLine/5),ie=[];for(const se of _){const oe=Math.max(se.startColumn-me,0),G=se.startColumn+pe.charsPerLine;if(oe>Se+me+y){const ee=b+(oe-Se)+C;U+=ee+ce.slice(oe,G),he+=oe-(Se+ee.length)}else U+=ce.slice(Se,G);ie.push(new u(0,se.startColumn-he,se.endColumn-he)),Se=G}this.preview={text:U,matches:Array.isArray(this.ranges)?ie:ie[0]}}else{const U=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:ce,matches:(0,o.$2b)(te,he=>new d(he.startLineNumber-U,he.startColumn,he.endLineNumber-U,he.endColumn))}}}}e.$LK=t;function f(x){const ce=x[0].startLineNumber;for(const te of x)if(te.startLineNumber!==ce||te.endLineNumber!==ce)return!1;return!0}class d{constructor(ce,te,pe,ye){this.startLineNumber=ce,this.startColumn=te,this.endLineNumber=pe,this.endColumn=ye}}e.$MK=d;class u extends d{constructor(ce,te,pe){super(ce,te,ce,pe)}}e.$NK=u;var h;(function(x){x.List="list",x.Tree="tree"})(h||(e.ViewMode=h={}));var l;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(l||(e.SearchSortOrder=l={}));function g(x,ce=!0){const te=x&&x.files&&x.files.exclude,pe=ce&&x&&x.search&&x.search.exclude;if(!te&&!pe)return;if(!te||!pe)return te||pe;let ye=Object.create(null);return ye=I.$Sn(ye,I.$Pn(te)),ye=I.$Sn(ye,I.$Pn(pe),!0),ye}function E(x,ce){return x.excludePattern&&R.$bk(x.excludePattern,ce)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&R.$bk(x.includePattern,ce)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(te=>{const pe=te.folder.fsPath;if(M.$ig(ce,pe)){const ye=$.$mc(pe,ce);return!te.includePattern||!!R.$bk(te.includePattern,ye)}else return!1}):!1:!0}var v;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class S extends Error{constructor(ce,te){super(ce),this.code=te}}e.$QK=S;function k(x){const ce=x.message;if((0,w.$4)(x))return new S(ce,v.canceled);try{const te=JSON.parse(ce);return new S(te.message,te.code)}catch{return new S(ce,v.other)}}function D(x){const ce={message:x.message,code:x.code};return new Error(JSON.stringify(ce))}function F(x){return x.type==="error"?!0:x.type==="success"}function W(x){return x.type==="success"}function B(x){return!!x.path}function j(x,ce,te=!0){const pe=x.searchPath?x.searchPath:x.relativePath;return te?(0,L.$Lf)(pe,ce):R.$bk(ce,pe)}class N{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$XK=N;function T(x,ce){const te={...x||{},...ce||{}};return Object.keys(te).filter(pe=>{const ye=te[pe];return typeof ye=="boolean"&&ye})}class O{constructor(ce,te){this.c=null,this.a={...ce.excludePattern||{},...te.excludePattern||{}},this.b=R.$ck(this.a);let pe=ce.includePattern;te.includePattern&&(pe?pe={...pe,...te.includePattern}:pe=te.includePattern),pe&&(this.c=R.$ck(pe))}matchesExcludesSync(ce,te,pe){return!!(this.b&&this.b(ce,te,pe))}includedInQuerySync(ce,te,pe){return!(this.b&&this.b(ce,te,pe)||this.c&&!this.c(ce,te,pe))}includedInQuery(ce,te,pe){const ye=this.b(ce,te,pe),_=()=>this.c?!!this.c(ce,te,pe):!0;return(0,P.$7g)(ye)?ye.then(U=>U?!1:_()):_()}hasSiblingExcludeClauses(){return z(this.a)}}e.$ZK=O;function z(x){for(const ce in x)if(typeof x[ce]!="boolean")return!0;return!1}function Q(x){if(!x)return;let ce;return te=>(ce||(ce=(x()||Promise.resolve([])).then(pe=>pe?J(pe):{})),ce.then(pe=>!!pe[te]))}function Z(x){if(!x)return;let ce;return te=>{if(!ce){const pe=x();ce=pe?J(pe):{}}return!!ce[te]}}function J(x){const ce={};for(const te of x)ce[te]=!0;return ce}}),define(Ee[38],Ce([1,0,19,8,22,4,3,77,15,126,23,14,2,230,5,12,262,43,59,28,20,16,7,66,36,6,57]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i,n,r,s,t,f,d,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjc=e.$Yjc=void 0;function l(W,B,j){return new A.$Kg(N=>S(N,j)).isEqual(W,B)}function g(W,B,j){return l(W.uri,B.uri,j)?0:(0,P.$ef)(W.uri.toString(),B.uri.toString())}function E(W,B,j){return W.index!==B.index?W.index<B.index?-1:1:l(W.uri,B.uri,j)?(0,P.$ef)(W.name,B.name):(0,P.$ef)(W.uri.toString(),B.uri.toString())}function v(W,B,j,N){const T=W.slice(0).sort((z,Q)=>j(z,Q,N)),O=B.slice(0).sort((z,Q)=>j(z,Q,N));return(0,o.$Eb)(T,O,(z,Q)=>j(z,Q,N))}function S(W,B){const j=B.getCapabilities(W.scheme);return!(j&&j&1024)}class k extends c.$Bi{static toExtHostWorkspace(B,j,N,T){if(!B)return{workspace:null,added:[],removed:[]};const{id:O,name:z,folders:Q,configuration:Z,transient:J,isUntitled:x}=B,ce=[],te=j;j?Q.forEach((U,he)=>{const Se=b.URI.revive(U.uri),me=k.o(N||j,Se,T);me?(me.name=U.name,me.index=U.index,ce.push(me)):ce.push({uri:Se,name:U.name,index:he})}):ce.push(...Q.map(({uri:U,name:he,index:Se})=>({uri:b.URI.revive(U),name:he,index:Se}))),ce.sort((U,he)=>U.index<he.index?-1:1);const pe=new k(O,z,ce,!!J,Z?b.URI.revive(Z):null,!!x,U=>S(U,T)),{added:ye,removed:_}=v(te?te.workspaceFolders:[],pe.workspaceFolders,g,T);return{workspace:pe,added:ye,removed:_}}static o(B,j,N){for(let T=0;T<B.folders.length;T++){const O=B.workspaceFolders[T];if(l(O.uri,j,N))return O}}constructor(B,j,N,T,O,z,Q){super(B,N.map(Z=>new c.$Ci(Z)),T,O,Q),this.t=j,this.u=z,this.q=[],this.s=p.$oi.forUris(Q),N.forEach(Z=>{this.q.push(Z),this.s.set(Z.uri,Z)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(B,j){return j&&this.s.get(B)&&(B=(0,A.$Ug)(B)),this.s.findSubstr(B)}resolveWorkspaceFolder(B){return this.s.get(B)}}let D=class{constructor(B,j,N,T,O){this.c=new M.$7d,this.onDidChangeWorkspace=this.c.event,this.g=new M.$7d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new M.$9d,this.C=new Map,this.h=T,this.s=N,this.t=O,this.j=new w.$qm,this.k=new R.$hh,this.o=B.getProxy(u.$sM.MainThreadWorkspace),this.q=B.getProxy(u.$sM.MainThreadMessageService);const z=j.workspace;this.l=z?new k(z.id,z.name,[],!!z.transient,z.configuration?b.URI.revive(z.configuration):null,!!z.isUntitled,Q=>S(Q,N)):void 0}$initializeWorkspace(B,j){this.v=j,this.$acceptWorkspaceData(B),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?b.URI.from({scheme:$.Schemas.untitled,path:(0,A.$Sg)((0,A.$Ug)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(B,j,N,...T){const O=[];if(Array.isArray(T)&&T.forEach(x=>{b.URI.isUri(x.uri)&&!O.some(ce=>l(ce.uri,x.uri,this.s))&&O.push({uri:x.uri,name:x.name||(0,A.$Rg)(x.uri)})}),this.n||[j,N].some(x=>typeof x!="number"||x<0)||N===0&&O.length===0)return!1;const z=this.x?this.x.workspaceFolders:[];if(j+N>z.length)return!1;const Q=z.slice(0);Q.splice(j,N,...O.map(x=>({uri:x.uri,name:x.name||(0,A.$Rg)(x.uri),index:void 0})));for(let x=0;x<Q.length;x++){const ce=Q[x];if(Q.some((te,pe)=>pe!==x&&l(ce.uri,te.uri,this.s)))return!1}Q.forEach((x,ce)=>x.index=ce);const{added:Z,removed:J}=v(z,Q,E,this.s);if(Z.length===0&&J.length===0)return!1;if(this.o){const x=B.displayName||B.name;this.o.$updateWorkspaceFolders(x,j,N,O).then(void 0,ce=>{this.n=void 0;const te={source:{identifier:B.identifier,label:B.displayName||B.name}};this.q.$showMessage(m.Severity.Error,(0,C.localize)(0,null,x,ce.toString()),te,[])})}return this.y(Q),!0}getWorkspaceFolder(B,j){if(this.x)return this.x.getWorkspaceFolder(B,j)}async getWorkspaceFolder2(B,j){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(B,j)}async resolveWorkspaceFolder(B){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(B)}getPath(){if(!this.x)return;const{folders:B}=this.x;if(B.length!==0)return B[0].uri.fsPath}getRelativePath(B,j){let N,T="";if(typeof B=="string"?(N=b.URI.file(B),T=B):typeof B<"u"&&(N=B,T=B.fsPath),!N)return T;const O=this.getWorkspaceFolder(N,!0);if(!O)return T;typeof j>"u"&&this.x&&(j=this.x.folders.length>1);let z=(0,A.$Xg)(O.uri,N);return j&&O.name&&(z=`${O.name}/${z}`),z}y(B){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:B,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(B){const{workspace:j,added:N,removed:T}=k.toExtHostWorkspace(B,this.l,this.n,this.s);this.l=j||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:T}))}findFiles(B,j,N,T,O=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${T.value}, entryPoint: findFiles`);let z="",Q=!0;return j===null?Q=!1:j!==void 0&&(typeof j=="string"?z=j:z=j.pattern),this.z(B,void 0,{exclude:z,maxResults:N,useDefaultExcludes:Q,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},O)}findFiles2(B,j={},N,T=I.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${N.value}, entryPoint: findFiles2`),this.z(void 0,B,j,T)}async z(B,j,N,T=I.CancellationToken.None){if(T&&T.isCancellationRequested)return Promise.resolve([]);const O=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,z={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof N.useDefaultSearchExcludes=="boolean"?!N.useDefaultSearchExcludes:!1,maxResults:N.maxResults,excludePattern:O,shouldGlobSearch:typeof N.fuzzy=="boolean"?!N.fuzzy:!0,_reason:"startFileSearch"};let Q;if(B){const{includePattern:Z,folder:J}=F(s.GlobPattern.from(B));Q=J,z.includePattern=Z}else{const{includePattern:Z,folder:J}=F(s.GlobPattern.from(j));Q=J,z.filePattern=Z}return this.o.$startFileSearch(Q??null,z,T).then(Z=>Array.isArray(Z)?Z.map(J=>b.URI.revive(J)):[])}async findTextInFiles(B,j,N,T,O=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${T.value}, entryPoint: findTextInFiles`);const z=this.j.getNext(),Q=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:Z,folder:J}=F(s.GlobPattern.from(j.include)),x=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,ce={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:Q,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:Z,excludePattern:x},te=!1;if(this.u[z]=pe=>{if(te)return;const ye=b.URI.revive(pe.resource);pe.results.forEach(_=>{const U=(0,h.$Rh)(_);(0,d.$HK)(U)?N({uri:ye,preview:{text:U.preview.text,matches:(0,o.$2b)(U.preview.matches,he=>new t.$wM(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))},ranges:(0,o.$2b)(U.ranges,he=>new t.$wM(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))}):N({uri:ye,text:U.text,lineNumber:U.lineNumber})})},O.isCancellationRequested)return{};try{const pe=await this.o.$startTextSearch(B,J??null,ce,z,O);return delete this.u[z],pe||{}}catch(pe){throw delete this.u[z],pe}}$handleTextSearchResult(B,j){this.u[j]?.(B)}async save(B){const j=await this.o.$save(B,{saveAs:!1});return b.URI.revive(j)}async saveAs(B){const j=await this.o.$save(B,{saveAs:!0});return b.URI.revive(j)}saveAll(B){return this.o.$saveAll(B)}resolveProxy(B){return this.o.$resolveProxy(B)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(B){return this.o.$requestWorkspaceTrust(B)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(B,j){if(this.w.has(B))throw new Error(`A provider has already been registered for scheme ${B}`);this.w.set(B,j);const N=this.t.transformOutgoingScheme(B),T=this.A++;return this.o.$registerEditSessionIdentityProvider(T,N),(0,L.$Sc)(()=>{this.w.delete(B),this.o.$unregisterEditSessionIdentityProvider(T)})}async $getEditSessionIdentifier(B,j){this.h.info("Getting edit session identifier for workspaceFolder",B);const N=await this.resolveWorkspaceFolder(b.URI.revive(B));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const T=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!T),!T)return;const O=await T.provideEditSessionIdentity(N,j);if(this.h.info("Provider returned edit session identifier: ",O),!!O)return O}async $provideEditSessionIdentityMatch(B,j,N,T){this.h.info("Getting edit session identifier for workspaceFolder",B);const O=await this.resolveWorkspaceFolder(b.URI.revive(B));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const z=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!z),!z)return;const Q=await z.provideEditSessionIdentityMatch?.(j,N,T);if(this.h.info("Provider returned edit session identifier match result: ",Q),!!Q)return Q}getOnWillCreateEditSessionIdentityEvent(B){return(j,N,T)=>{const O=function(Q){j.call(N,Q)};return O.extension=B,this.B.event(O,void 0,T)}}async $onWillCreateEditSessionIdentity(B,j,N){const T=await this.resolveWorkspaceFolder(b.URI.revive(B));if(T===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:T},j,async(O,z)=>{const Q=Date.now();await Promise.resolve(O),Date.now()-Q>N&&this.h.warn("SLOW edit session create-participant",z.extension.identifier)}),j.isCancellationRequested}registerCanonicalUriProvider(B,j){if(this.C.has(B))throw new Error(`A provider has already been registered for scheme ${B}`);this.C.set(B,j);const N=this.t.transformOutgoingScheme(B),T=this.A++;return this.o.$registerCanonicalUriProvider(T,N),(0,L.$Sc)(()=>{this.C.delete(B),this.o.$unregisterCanonicalUriProvider(T)})}async provideCanonicalUri(B,j,N){const T=this.C.get(B.scheme);if(!T)return;const O=await T.provideCanonicalUri?.(b.URI.revive(B),j,N);if(O)return O}async $provideCanonicalUri(B,j,N){return this.provideCanonicalUri(b.URI.revive(B),{targetScheme:j},N)}};e.$Yjc=D,e.$Yjc=D=Qe([He(0,r.$OO),He(1,n.$5O),He(2,i.$Ejc),He(3,a.$Oj),He(4,f.$Wjc)],D),e.$Zjc=(0,y.$ii)("IExtHostWorkspace");function F(W){let B,j;return W&&(typeof W=="string"?B=W:(B=W.pattern,j=b.URI.revive(W.baseUri))),{includePattern:B,folder:j}}}),define(Ee[45],Ce([1,0,24,4,38,6,7,264,85,18,8,5,20,12,2]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3jc=e.$2jc=e.$1jc=void 0;function a(f,d){if(d){const u=d.split(".");let h=f;for(let l=0;h&&l<u.length;l++)h=h[u[l]];return h}}function m(f){return f instanceof y.URI}function c(f){return f&&f.uri instanceof y.URI&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&f.uri instanceof y.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function r(f){if(m(f))return{resource:f};if(c(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(i(f))return{overrideIdentifier:f.languageId};if(n(f))return{resource:f.uri};if(f===null)return{resource:null}}let s=class{constructor(d,u,h){this.a=d.getProxy(M.$sM.MainThreadConfiguration),this.c=u,this.b=h,this.d=new A.$hh,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,u){this.getConfigProvider().then(h=>h.$acceptConfigurationChanged(d,u))}};e.$1jc=s,e.$1jc=s=Qe([He(0,b.$OO),He(1,I.$Zjc),He(2,C.$Oj)],s);class t{constructor(d,u,h,l){this.a=new R.$7d,this.b=d,this.f=l,this.c=u,this.e=p.$no.parse(h),this.d=this.k(h.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,u){const h={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$no.parse(d),this.d=this.k(d.configurationScopes),this.a.fire(this.j(u,h))}getConfiguration(d,u,h){const l=r(u)||{},g=this.g(d?a(this.e.getValue(void 0,l,this.c.workspace),d):this.e.getValue(void 0,l,this.c.workspace));d&&this.h(d,l,h?.identifier);function E(S){if(S==null)return null;if(typeof S=="boolean")return S?2:5;switch(S){case L.ConfigurationTarget.Global:return 2;case L.ConfigurationTarget.Workspace:return 5;case L.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(S){return typeof a(g,S)<"u"},get:(S,k)=>{this.h(d?`${d}.${S}`:S,l,h?.identifier);let D=a(g,S);if(typeof D>"u")D=k;else{let F;const W=(B,j)=>{if((0,w.$Xf)(B)){let N;const T=()=>{F=F||(0,o.$Pn)(g),N=N||a(F,j)};return new Proxy(B,{get:(O,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return T(),()=>N;if(F)return N=N||a(F,j),N[z];const Q=O[z];return typeof z=="string"?W(Q,`${j}.${z}`):Q},set:(O,z,Q)=>(T(),N&&(N[z]=Q),!0),deleteProperty:(O,z)=>(T(),N&&delete N[z],!0),defineProperty:(O,z,Q)=>(T(),N&&Object.defineProperty(N,z,Q),!0)})}return Array.isArray(B)?(0,o.$Pn)(B):B};D=W(D,S)}return D},update:(S,k,D,F)=>{S=d?`${d}.${S}`:S;const W=E(D);return k!==void 0?this.b.$updateConfigurationOption(W,S,k,l,F):this.b.$removeConfigurationOption(W,S,l,F)},inspect:S=>{S=d?`${d}.${S}`:S;const k=this.e.inspect(S,l,this.c.workspace);if(k)return{key:S,defaultValue:(0,o.$Pn)(k.policy?.value??k.default?.value),globalValue:(0,o.$Pn)(k.user?.value??k.application?.value),workspaceValue:(0,o.$Pn)(k.workspace?.value),workspaceFolderValue:(0,o.$Pn)(k.workspaceFolder?.value),defaultLanguageValue:(0,o.$Pn)(k.default?.override),globalLanguageValue:(0,o.$Pn)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,o.$Pn)(k.workspace?.override),workspaceFolderLanguageValue:(0,o.$Pn)(k.workspaceFolder?.override),languageIds:(0,o.$Pn)(k.overrideIdentifiers)}}};return typeof g=="object"&&(0,o.$Sn)(v,g,!1),Object.freeze(v)}g(d){const u=h=>(0,w.$Xf)(h)?new Proxy(h,{get:(l,g)=>u(l[g]),set:(l,g,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(l,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(l,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):h;return u(d)}h(d,u,h){const l=$.$eo.test(d)?4:this.d.get(d),g=h?`[${h.value}] `:"";if(l===4){typeof u?.resource>"u"&&this.f.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){u?.resource&&this.f.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,u){const h=new p.$po(d,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(l,g)=>h.affectsConfiguration(l,r(g))})}k(d){return d.reduce((u,h)=>(u.set(h[0],h[1]),u),new Map)}}e.$2jc=t,e.$3jc=(0,P.$ii)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o},qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Ee[95],Ce([1,0,2,8,4,6,7,38,72,45,22,44,20,28,5,15,11,12,91,306,13]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i,n,r){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=e.$slc=e.$rlc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(B){function j(T){if(T!=null)return T}B.from=j;function N(T){if(T!=null)return T}B.to=N})(t||(t={}));var f;(function(B){function j(T){if(T!=null)return T}B.from=j;function N(T){if(T!=null)return T}B.to=N})(f||(f={}));var d;(function(B){function j(T){if(T!=null)return T}B.from=j;function N(T){if(T!=null)return T}B.to=N})(d||(d={}));var u;(function(B){function j(O){if(O){const z=O;return z&&!!z.process}else return!1}B.is=j;function N(O){if(O==null)return;const z={process:O.process,args:O.args};return O.options&&(z.options=d.from(O.options)),z}B.from=N;function T(O){if(O!=null)return new L.$dN(O.process,O.args,O.options)}B.to=T})(u||(u={}));var h;(function(B){function j(T){if(T!=null)return T}B.from=j;function N(T){if(T!=null)return T}B.to=N})(h||(h={}));var l;(function(B){function j(O){if(O){const z=O;return z&&(!!z.commandLine||!!z.command)}else return!1}B.is=j;function N(O){if(O==null)return;const z={};return O.commandLine!==void 0?z.commandLine=O.commandLine:(z.command=O.command,z.args=O.args),O.options&&(z.options=h.from(O.options)),z}B.from=N;function T(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new L.$eN(O.commandLine,O.options):new L.$eN(O.command,O.args?O.args:[],O.options)}B.to=T})(l||(l={}));var g;(function(B){function j(O){if(O){const z=O;return z&&z.customExecution==="customExecution"}else return!1}B.is=j;function N(O){return{customExecution:"customExecution"}}B.from=N;function T(O,z){return z.get(O)}B.to=T})(g||(e.CustomExecutionDTO=g={}));var E;(function(B){function j(N,T){let O;return N.scope!==void 0&&typeof N.scope!="number"?O=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===L.TaskScope.Workspace&&T&&T.workspaceFile?O=T.workspaceFile:O=n.$zH),{id:N._id,workspaceFolder:O}}B.from=j})(E||(e.TaskHandleDTO=E={}));var v;(function(B){function j(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}B.from=j})(v||(v={}));var S;(function(B){function j(O,z){if(O==null)return[];const Q=[];for(const Z of O){const J=N(Z,z);J&&Q.push(J)}return Q}B.fromMany=j;function N(O,z){if(O==null)return;let Q;O.execution instanceof L.$dN?Q=u.from(O.execution):O.execution instanceof L.$eN?Q=l.from(O.execution):O.execution&&O.execution instanceof L.$fN&&(Q=g.from(O.execution));const Z=t.from(O.definition);let J;return O.scope?typeof O.scope=="number"?J=O.scope:J=O.scope.uri:J=L.TaskScope.Workspace,!Z||!J?void 0:{_id:O._id,definition:Z,name:O.name,source:{extensionId:z.identifier.value,label:O.source,scope:J},execution:Q,isBackground:O.isBackground,group:v.from(O.group),presentationOptions:f.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}B.from=N;async function T(O,z,Q){if(O==null)return;let Z;u.is(O.execution)?Z=u.to(O.execution):l.is(O.execution)?Z=l.to(O.execution):g.is(O.execution)&&(Z=g.to(O._id,Q));const J=t.to(O.definition);let x;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?x=O.source.scope:x=await z.resolveWorkspaceFolder(o.URI.revive(O.source.scope)):x=L.TaskScope.Workspace),!J||!x)return;const ce=new L.$gN(J,x,O.name,O.source.label,Z,O.problemMatchers);return O.isBackground!==void 0&&(ce.isBackground=O.isBackground),O.group!==void 0&&(ce.group=L.$cN.from(O.group._id),ce.group&&O.group.isDefault&&(ce.group=new L.$cN(ce.group.id,ce.group.label),O.group.isDefault===!0&&(ce.group.isDefault=O.group.isDefault))),O.presentationOptions&&(ce.presentationOptions=f.to(O.presentationOptions)),O._id&&(ce._id=O._id),O.detail&&(ce.detail=O.detail),ce}B.to=T})(S||(e.TaskDTO=S={}));var k;(function(B){function j(T){return T}B.from=j;function N(T){if(T)return Object.assign(Object.create(null),T)}B.to=N})(k||(k={}));class D{constructor(j,N,T){this._id=N,this.a=T,s.set(this,void 0),it(this,s,j,"f")}get task(){return this.a}terminate(){qe(this,s,"f").terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}s=new WeakMap;let F=class{constructor(j,N,T,O,z,Q,Z,J){this.q=new I.$7d,this.r=new I.$7d,this.s=new I.$7d,this.u=new I.$7d,this.a=j.getProxy(M.$sM.MainThreadTask),this.b=T,this.c=O,this.d=z,this.e=Q,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Z,this.g=J,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,N,T){if(!T)return new L.$uM(()=>{});const O=this.x();return this.j.set(O,{type:N,provider:T,extension:j}),this.a.$registerTaskProvider(O,N),new L.$uM(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(j,N){this.a.$registerTaskSystem(j,N)}fetchTasks(j){return this.a.$fetchTasks(k.from(j)).then(async N=>{const T=[];for(const O of N){const z=await S.to(O,this.b,this.m);z&&T.push(z)}return T})}get taskExecutions(){const j=[];return this.k.forEach(N=>j.push(N)),j}terminateTask(j){if(!(j instanceof D))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,N,T){const O=this.m.get(j.id);O&&(this.o.set(j.id,O),this.e.attachPtyToTerminal(N,await O.callback(T))),this.p=j.id,this.q.fire({execution:await this.z(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){if(!this.l.has(j.id))return;const N=await this.z(j);this.l.delete(j.id),this.k.delete(j.id),this.B(j),this.r.fire({execution:N})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const N=await this.z(j.id);this.s.fire({execution:N,processId:j.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(j){const N=await this.z(j.id);this.u.fire({execution:N,exitCode:j.exitCode})}$provideTasks(j,N){const T=this.j.get(j);if(!T)return Promise.reject(new Error("no handler found"));const O=[],z=(0,R.$ah)(()=>T.provider.provideTasks(A.CancellationToken.None)).then(Q=>this.v(N,O,T,Q));return new Promise(Q=>{z.then(Z=>{Promise.all(O).then(()=>{Q(Z)})})})}async $resolveTask(j,N){const T=this.j.get(j);if(!T)return Promise.reject(new Error("no handler found"));if(N.definition.type!==T.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${T.type}].`);const O=await S.to(N,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const z=await T.provider.resolveTask(O,A.CancellationToken.None);if(!z)return;this.A(z,T);const Q=S.from(z,T.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(Q.execution)&&await this.y(Q,z,!0),await this.w(Q)}x(){return this.h++}async y(j,N,T){const O=await this.a.$createTaskId(j);!T&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,N.execution)),this.m.set(O,N.execution)}async z(j,N){if(typeof j=="string"){const z=this.l.get(j);if(!z)throw new r.$bb("Unexpected: The specified task is missing an execution");return z}const T=this.l.get(j.id);if(T)return T;let O;return N?O=Promise.resolve(new D(this,j.id,N)):O=S.to(j.task,this.b,this.m).then(z=>{if(!z)throw new r.$bb("Unexpected: Task does not exist.");return new D(this,j.id,z)}),this.l.set(j.id,O),O.then(z=>(this.k.set(j.id,z),z))}A(j,N){j._deprecated&&this.g.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}B(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const T=this.n.values();let O=T.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=T.next()}};e.$rlc=F,e.$rlc=F=Qe([He(0,b.$OO),He(1,C.$5O),He(2,p.$Zjc),He(3,$.$ZO),He(4,w.$3jc),He(5,P.$okc),He(6,c.$Oj),He(7,i.$Ajc)],F);let W=class extends F{constructor(j,N,T,O,z,Q,Z,J){super(j,N,T,O,z,Q,Z,J),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:m.$b(0)})}async executeTask(j,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const T=S.from(N,j);if(T===void 0)throw new Error("Task is not valid");if(g.is(T.execution))await this.y(T,N,!1);else throw new r.$_;const O=await this.z(await this.a.$getTaskExecution(T),N);return this.a.$executeTask(T).catch(z=>{throw new Error(z)}),O}v(j,N,T,O){const z=[];if(O)for(const Q of O){if(this.A(Q,T),!Q.definition||!j[Q.definition.type]){const J=Q.source?Q.source:"No task source";this.f.warn(`The task [${J}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`)}const Z=S.from(Q,T.extension);Z&&g.is(Z.execution)?(z.push(Z),N.push(this.y(Z,Q,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:z,extension:T.extension}}async w(j){if(g.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,N,T){}};e.$slc=W,e.$slc=W=Qe([He(0,b.$OO),He(1,C.$5O),He(2,p.$Zjc),He(3,$.$ZO),He(4,w.$3jc),He(5,P.$okc),He(6,c.$Oj),He(7,i.$Ajc)],W),e.$tlc=(0,y.$ii)("IExtHostTask")}),define(Ee[368],Ce([1,0,36,29]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9K=void 0,e.$8K=I,e.$0K=M;function I(L){return"cellResults"in L}e.$9K="rawCell#";function M(L,p){let $=-1;const w=[];let A=[];return L.forEach(b=>{b.range.startLineNumber!==$&&A.length>0&&(w.push([...A]),A=[]),A.push(b),$=b.range.endLineNumber}),A.length>0&&w.push([...A]),w.map(b=>{const C=[],y=b[0].range.startLineNumber,a=b[b.length-1].range.endLineNumber;for(let m=y;m<=a;m++)C.push(p.getLineContent(m));return new o.$LK(C.join(`
`)+`
`,b.map(m=>new R.$dt(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(Ee[369],Ce([1,0,224,21,4,3,27,14,18,2,32,111,6,33,16,7,68,339,154,24,15,296,368,365]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i,n,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6kc=void 0;class d{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(h=>h.apiEditor)}constructor(h,l,g,E,v,S){this.q=g,this.r=E,this.s=v,this.t=S,this.f=new Map,this.g=new L.$Bc,this.h=new Map,this.j=new I.$7d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$7d,this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$7d,this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$7d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new P.$yjc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=h.getProxy(b.$sM.MainThreadNotebook),this.c=h.getProxy(b.$sM.MainThreadNotebookDocuments),this.d=h.getProxy(b.$sM.MainThreadNotebookEditors),this.i=l.converter,l.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const D=k.notebookEditor?.notebookUri,F=k.cell.handle,B=this.g.get(D)?.getCell(F);if(B)return B.apiCell}if(k&&k.$mid===14){const D=k.uri,F=this.g.get(D);if(F)return F.apiNotebook}return k}}),d.B(l)}getEditorById(h){const l=this.h.get(h);if(!l)throw new Error(`unknown text editor: ${h}. known editors: ${[...this.h.keys()]} `);return l}getIdByEditor(h){for(const[l,g]of this.h)if(g.apiEditor===h)return l}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(h,l){const g=this.g.get(h);if(!g&&!l)throw new Error(`NO notebook document for '${h}'`);return g}static u(h,l){if(!l)return;const g=l.filenamePattern.map(E=>y.NotebookExclusiveDocumentPattern.from(E)).filter(E=>E!==void 0);if(l.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${l.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:l.displayName,filenamePattern:g,exclusive:l.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,l,g){const E=d.a++,v=typeof g.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(E,g),this.b.$registerNotebookCellStatusBarItemProvider(E,v,l);let S;return v!==void 0&&(S=g.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(v))),new a.$uM(()=>{this.f.delete(E),this.b.$unregisterNotebookCellStatusBarItemProvider(E,v),S?.dispose()})}async createNotebookDocument(h){const l=await this.c.$tryCreateNotebook({viewType:h.viewType,content:h.content&&y.NotebookData.from(h.content)});return w.URI.revive(l)}async openNotebookDocument(h){const l=this.g.get(h);if(l)return l.apiNotebook;const g=await this.c.$tryOpenNotebook(h),E=this.g.get(w.URI.revive(g));return(0,$.$7f)(E?.apiNotebook)}async showNotebookDocument(h,l){w.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let g;typeof l=="object"?g={position:y.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selections:l.selections&&l.selections.map(y.NotebookRange.from),pinned:typeof l.preview=="boolean"?!l.preview:void 0}:g={preserveFocus:!1};const E=await this.d.$tryShowNotebookDocument(h.uri,h.notebookType,g),v=E&&this.h.get(E)?.apiEditor;if(v)return v;throw E?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,l,g,E){const v=this.f.get(h),S=w.URI.revive(l),k=this.g.get(S);if(!k||!v)return;const D=k.getCellFromIndex(g);if(!D)return;const F=await v.provideCellStatusBarItems(D.apiCell,E);if(!F)return;const W=new M.$Tc,B=this.p.add([W]),N=(Array.isArray(F)?F:[F]).map(T=>y.NotebookStatusBarItem.from(T,this.i,W));return{cacheId:B,items:N}}$releaseNotebookCellStatusBarItems(h){this.p.delete(h)}registerNotebookSerializer(h,l,g,E,v){if((0,p.$Ue)(l))throw new Error("viewType cannot be empty or just whitespace");const S=this.w++;return this.x.set(S,{viewType:l,serializer:g,options:E}),this.b.$registerNotebookSerializer(S,{id:h.identifier,location:h.extensionLocation},l,y.NotebookDocumentContentOptions.from(E),d.u(h,v)),(0,M.$Sc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(h,l,g){const E=this.x.get(h);if(!E)throw new Error("NO serializer found");const v=await E.serializer.deserializeNotebook(l.buffer,g);return new m.$fw(y.NotebookData.from(v))}async $notebookToData(h,l,g){const E=this.x.get(h);if(!E)throw new Error("NO serializer found");const v=await E.serializer.serializeNotebook(y.NotebookData.to(l.value),g);return R.$ue.wrap(v)}async $saveNotebook(h,l,g,E,v){const S=w.URI.revive(l),k=this.x.get(h);if(!k)throw new Error("NO serializer found");const D=this.g.get(S);if(!D)throw new Error("Document NOT found");if(D.versionId!==g)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new A.$0k((0,o.localize)(0,null,this.z(S)),6);await this.y(S,E);const F={metadata:(0,n.$Xn)(D.apiNotebook.metadata,T=>!(k.options?.transientDocumentMetadata??{})[T]),cells:[]};for(const T of D.apiNotebook.getCells()){const O=new a.$WN(T.kind,T.document.getText(),T.document.languageId,T.mime,k.options?.transientOutputs?[]:[...T.outputs],T.metadata,T.executionSummary);O.metadata=(0,n.$Xn)(T.metadata,z=>!(k.options?.transientCellMetadata??{})[z]),F.cells.push(O)}const W=await k.serializer.serializeNotebook(F,v);await this.s.value.writeFile(S,W);const B=this.s.getFileSystemProviderExtUri(S.scheme),j=await this.s.value.stat(S);return{name:B.basename(S),isFile:(j.type&A.FileType.File)!==0,isDirectory:(j.type&A.FileType.Directory)!==0,isSymbolicLink:(j.type&A.FileType.SymbolicLink)!==0,mtime:j.mtime,ctime:j.ctime,size:j.size,readonly:!!((j.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((j.permissions??0)&A.FilePermission.Locked),etag:A.$il({mtime:j.mtime,size:j.size}),children:void 0}}async $searchInNotebooks(h,l,g,E,v){const S=this.x.get(h)?.serializer;if(!S)return{limitHit:!1,results:[]};const k=new L.$Cc;await(async(j,N,T)=>{await Promise.all(j.map(async O=>await Promise.all(O.filenamePatterns.map(z=>{const Q={_reason:T._reason,folderQueries:T.folderQueries,includePattern:T.includePattern,excludePattern:T.excludePattern,maxResults:T.maxResults,type:1,filePattern:z};return this.t.doInternalFileSearchWithCustomCallback(Q,N,Z=>{Z.forEach(J=>{k.has(J)||E.some(ce=>O.isFromSettings&&!ce.isFromSettings?!1:ce.filenamePatterns.some(te=>(0,f.$Vfb)(te,J)))||k.add(J)})}).catch(Z=>{if(Z.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Z})}))))})(g,v,l);const F=new L.$Bc;let W=!1;const B=Array.from(k).map(async j=>{const N=[];try{if(v.isCancellationRequested)return;if(l.maxResults&&[...F.values()].reduce((Q,Z)=>Q+Z.cellResults.length,0)>l.maxResults){W=!0;return}const T=[],O=this.g.get(j);if(O)O.apiNotebook.getCells().forEach(Z=>T.push({input:Z.document.getText(),outputs:Z.outputs.flatMap(J=>J.items.map(x=>x.data.toString()))}));else{const Q=await this.s.value.readFile(j),Z=R.$ue.fromString(Q.toString()),J=await S.deserializeNotebook(Z.buffer,v);if(v.isCancellationRequested)return;y.NotebookData.from(J).cells.forEach(ce=>T.push({input:ce.source,outputs:ce.outputs.flatMap(te=>te.items.map(pe=>pe.valueBytes.toString()))}))}if(v.isCancellationRequested)return;T.forEach((Q,Z)=>{const J=l.contentPattern.pattern,x=new s.$7Ub(Q.input,void 0,Q.outputs),ce=x.findInInputs(J),te=x.findInOutputs(J),pe=te.flatMap(ye=>(0,t.$0K)(ye.matches,ye.textBuffer)).map((ye,_)=>(ye.webviewIndex=_,ye));if(ce.length>0||te.length>0){const ye={index:Z,contentResults:(0,t.$0K)(ce,x.inputTextBuffer),webviewResults:pe};N.push(ye)}});const z={resource:j,cellResults:N};F.set(j,z);return}catch{return}});return await Promise.all(B),{limitHit:W,results:[...F.values()]}}async y(h,l){const g=await this.s.value.stat(h);if(typeof l?.mtime=="number"&&typeof l.etag=="string"&&l.etag!==A.$hl&&typeof g.mtime=="number"&&typeof g.size=="number"&&l.mtime<g.mtime&&l.etag!==A.$il({mtime:l.mtime,size:g.size}))throw new A.$0k((0,o.localize)(1,null),3,l)}z(h){return h.scheme===r.Schemas.file?h.fsPath:h.toString()}A(h,l,g){if(this.h.has(l))throw new Error(`editor with id ALREADY EXSIST: ${l}`);const E=new i.$Wkc(l,this.d,h,g.visibleRanges.map(y.NotebookRange.to),g.selections.map(y.NotebookRange.to),typeof g.viewColumn=="number"?y.ViewColumn.to(g.viewColumn):void 0);this.h.set(l,E)}$acceptDocumentAndEditorsDelta(h){if(h.value.removedDocuments)for(const g of h.value.removedDocuments){const E=w.URI.revive(g),v=this.g.get(E);v&&(v.dispose(),this.g.delete(E),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(v.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===E.toString()&&this.h.delete(S.id)}if(h.value.addedDocuments){const g=[];for(const E of h.value.addedDocuments){const v=w.URI.revive(E.uri);if(this.g.has(v))throw new Error(`adding EXISTING notebook ${v} `);const S=new c.$Vkc(this.c,this.q,this.r,v,E);g.push(...E.cells.map(k=>c.$Ukc.asModelAddData(k))),this.g.get(v)?.dispose(),this.g.set(v,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this.m.fire(S.apiNotebook)}}if(h.value.addedEditors)for(const g of h.value.addedEditors){if(this.h.has(g.id))return;const E=w.URI.revive(g.documentUri),v=this.g.get(E);v&&this.A(v,g.id,g)}const l=[];if(h.value.removedEditors)for(const g of h.value.removedEditors){const E=this.h.get(g);E&&(this.h.delete(g),this.k?.id===E.id&&(this.k=void 0),l.push(E))}if(h.value.visibleEditors){this.l=h.value.visibleEditors.map(E=>this.h.get(E)).filter(E=>!!E);const g=new Set;this.l.forEach(E=>g.add(E.id));for(const E of this.h.values()){const v=g.has(E.id);E._acceptVisibility(v)}this.l=[...this.h.values()].map(E=>E).filter(E=>E.visible),this.o.fire(this.visibleNotebookEditors)}h.value.newActiveEditor===null?this.k=void 0:h.value.newActiveEditor&&(this.h.get(h.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${h.value.newActiveEditor}`),this.k=this.h.get(h.value.newActiveEditor)),h.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(h){const l=C.$aP.String.with("notebookType","A notebook type"),g=new C.$cP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[l,new C.$aP("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>R.$ue.wrap(v))],new C.$bP("Notebook Data",v=>y.NotebookData.to(v.value))),E=new C.$cP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[l,new C.$aP("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new m.$fw(y.NotebookData.from(v)))],new C.$bP("Bytes",v=>v.buffer));h.registerApiCommand(g),h.registerApiCommand(E)}}e.$6kc=d,d.a=0}),define(Ee[370],Ce([1,0,17,22,47,35,23,40,36]),function(re,e,o,R,I,M,L,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkc=void 0;class w{constructor(b,C,y){this.k=b,this.l=C,this.o=y,this.e=!1,this.f=0,this.g=!1,this.a=b.filePattern,this.b=b.includePattern&&M.$ck(b.includePattern),this.c=b.maxResults||void 0,this.d=b.exists,this.h=new Set,this.j=b.excludePattern&&M.$ck(b.excludePattern)}cancel(){this.g=!0,this.h.forEach(b=>b.cancel()),this.h=new Set}search(b){const C=this.k.folderQueries||[];return new Promise((y,a)=>{const m=c=>{this.f++,b(c)};if(this.g)return y({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(c=>{const i=c.toString(),n=o.$oc(i);this.j&&this.j(i,n)||this.v(m,{base:c,basename:n})}),Promise.all(C.map(c=>this.p(c,m))).then(c=>{y({limitHit:this.e,stats:c[0]||void 0})},c=>{a(new Error((0,I.$6i)(c)))})})}async p(b,C){const y=new R.$ee,a=this.q(b),m=this.r(),c=new $.$ZK(this.k,b),i=!c.hasSiblingExcludeClauses();let n;try{this.h.add(y),n=p.$3d.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,y.token),s=n.elapsed(),t=p.$3d.create();return this.g&&!this.e||(r&&r.forEach(f=>{const d=o.$hc.relative(b.folder.path,f.path);if(i){const u=o.$oc(f.path);this.v(C,{base:b.folder,relativePath:d,basename:u});return}this.s(m,b.folder,d,C)}),this.g&&!this.e)?null:(this.u(m,c,C),{providerTime:s,postProcessTime:t.elapsed()})}finally{y.dispose(),this.h.delete(y)}}q(b){const C=(0,$.$YK)(this.k.includePattern,b.includePattern),y=(0,$.$YK)(this.k.excludePattern,b.excludePattern);return{folder:b.folder,excludes:y,includes:C,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!b.disregardParentIgnoreFiles,followSymlinks:!b.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const b={rootEntries:[],pathToEntries:Object.create(null)};return b.pathToEntries["."]=b.rootEntries,b}s({pathToEntries:b},C,y,a){if(y===this.a){const c=o.$oc(this.a);this.v(a,{base:C,relativePath:this.a,basename:c})}function m(c){const i=o.$oc(c),n=o.$nc(c);let r=b[n];r||(r=b[n]=[],m(n)),r.push({base:C,relativePath:c,basename:i})}m(y)}u({rootEntries:b,pathToEntries:C},y,a){const m=this,c=this.a;function i(n){const r=(0,$.$2K)(()=>n.map(s=>s.basename));for(let s=0,t=n.length;s<t;s++){const f=n[s],{relativePath:d,basename:u}=f;if(y.matchesExcludesSync(d,u,c!==u?r:void 0))continue;const h=C[d];if(h)i(h);else{if(d===c)continue;m.v(a,f)}if(m.e)break}}i(b)}v(b,C){(!this.b||C.relativePath&&this.b(C.relativePath,C.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||b(C))}}class A{constructor(){this.b=new Map}fileSearch(b,C,y,a){const m=this.c(b.cacheKey),c=new w(b,C,m&&m.token);let i=0;const n=r=>{i+=r.length,y(r.map(s=>this.d(s)))};return this.e(c,A.a,n,a).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:r.stats}}))}clearCache(b){this.c(b)?.cancel()}c(b){if(b)return this.b.has(b)||this.b.set(b,new R.$ee),this.b.get(b)}d(b){return b.relativePath?{resource:L.$Vg(b.base,b.relativePath)}:{resource:b.base}}e(b,C,y,a){const m=a.onCancellationRequested(()=>{b.cancel()}),c=n=>{n&&(i.push(n),C>0&&i.length>=C&&(y(i),i=[]))};let i=[];return b.search(c).then(n=>(i.length&&y(i),m.dispose(),n),n=>(i.length&&y(i),m.dispose(),Promise.reject(n)))}}e.$Xkc=A,A.a=512}),define(Ee[371],Ce([1,0,19,73,35,102,27,15,17,23,14,18,2,105,244,53,12,43,147,366,36]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9L=void 0,e.$0L=E;let s=class{constructor(S,k,D,F,W){this.a=S,this.b=k,this.c=D,this.d=F,this.e=W}text(S,k,D={}){S=this.f(S,D);const F=this.a.getValue(),W=k&&k.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(k?.map(c.$Di),D),type:2,contentPattern:S,previewOptions:D.previewOptions,maxFileSize:D.maxFileSize,usePCRE2:F.search.usePCRE2||W||!1,beforeContext:D.beforeContext,afterContext:D.afterContext,userDisabledExcludesAndIgnoreFiles:D.disregardExcludeSettings&&D.disregardIgnoreFiles}}f(S,k){const D=this.a.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const F={...S,wordSeparators:D.editor.wordSeparators};return this.j(S,k)&&(F.isCaseSensitive=!0),this.k(S)&&(F.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),F}file(S,k={}){return{...this.h(S,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey,shouldGlobMatchFilePattern:k.shouldGlobSearch}}g(S,k){return S?(S=Array.isArray(S)?S.map(h):h(S),k?this.parseSearchPaths(S):{pattern:f(...Array.isArray(S)?S:[S])}):{}}h(S=[],k={}){const D=this.g(k.includePattern,k.expandPatterns),F=this.g(k.excludePattern,k.expandPatterns),W=S.length>1,B=(D.searchPaths&&D.searchPaths.length?D.searchPaths.map(T=>this.q(T,k,F)):S.map(T=>this.r(T,k,F,W))).filter(T=>!!T),j={_reason:k._reason,folderQueries:B,usingSearchPaths:!!(D.searchPaths&&D.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:F.pattern,includePattern:D.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const T=o.$Hb(o.$Rb(this.c.groups.map(Q=>Q.editors.map(Z=>Z.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const O=T.filter(Q=>(0,r.$PK)(j,Q.fsPath)),z=this.i(O);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...j,...z}}const N=k.extraFileResources&&k.extraFileResources.filter(T=>(0,r.$PK)(j,T.fsPath));return j.extraFileResources=N&&N.length?N:void 0,j}i(S){const k=[],D=new L.$Bc,F={};let W=!1;return S.forEach(B=>{if(B.scheme===p.Schemas.walkThrough)return;if((0,w.$Zg)(B)){const N=this.b.getWorkspaceFolder(B)?.uri??B.with({path:$.$nc(B.fsPath)});let T=D.get(N);T||(W=!0,T={folder:N,includePattern:{}},k.push(T),D.set(N,T));const O=$.$mc(N.fsPath,B.fsPath);(0,P.$7f)(T.includePattern)[O.replace(/\\/g,"/")]=!0}else B.fsPath&&(W=!0,F[B.fsPath]=!0)}),{folderQueries:k,includePattern:F,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}j(S,k){if(k.isSmartCase){if(S.isRegExp){if(A.$Mf(S.pattern,!0))return!0}else if(A.$Mf(S.pattern))return!0}return!!S.isCaseSensitive}k(S){return S.isMultiline||S.isRegExp&&(0,C.$uC)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const k=z=>$.$jc(z)||/^\.\.?([\/\\]|$)/.test(z),F=(Array.isArray(S)?S:d(S)).map(z=>{const Q=this.e.resolvedUserHome;return Q?(0,M.$kw)(z,Q.scheme===p.Schemas.file?Q.fsPath:Q.path):z}),W=R.$E(F,z=>k(z)?"searchPaths":"exprSegments"),B=(W.exprSegments||[]).map(z=>A.$6e(z,"/")).map(z=>A.$6e(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),u(z))),j={},N=this.m(W.searchPaths||[]);N&&N.length&&(j.searchPaths=N);const T=o.$Rb(B),O=f(...T);return O&&(j.pattern=O),j}l(S,k){return k.disregardExcludeSettings?void 0:(0,r.$OK)(S,!k.disregardSearchExcludeSettings)}m(S){if(!S||!S.length)return[];const k=S.flatMap(F=>{let{pathPortion:W,globPortion:B}=t(F);return B&&(B=l(B)),this.n(W).flatMap(N=>this.o(N,B))}),D=new Map;return k.forEach(F=>{const W=F.searchPath.toString(),B=D.get(W);B?F.pattern&&(B.pattern=B.pattern||{},B.pattern[F.pattern]=!0):D.set(W,{searchPath:F.searchPath,pattern:F.pattern?f(F.pattern):void 0})}),Array.from(D.values())}n(S){if($.$jc(S)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==p.Schemas.file?[{searchPath:k[0].uri.with({path:S})}]:[{searchPath:b.URI.file($.$ic(S))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(S=h(S),S.startsWith("../")||S===".."){const F=$.$hc.resolve(k.path,S);return[{searchPath:k.with({path:F})}]}const D=l(S);return[{searchPath:k,pattern:D}]}else{if(S==="./"||S===".\\")return[];{const k=S.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(W=>{const B=k.match(new RegExp(`^${A.$Ze(W.name)}(?:/(.*)|$)`));return B?{match:B,folder:W}:null}).filter(P.$4f);if(F.length)return F.map(W=>{const B=W.match[1];return{searchPath:W.folder.uri,pattern:B&&l(B)}});{const W=S.match(/\.[\/\\](.+)[\/\\]?/),B=W?W[1]:S,j=y.localize(0,null,B);throw new Error(j)}}}}o(S,k){const D=S.pattern&&k?`${S.pattern}/${k}`:S.pattern||k,F=[{searchPath:S.searchPath,pattern:D}];return D&&!D.endsWith("**")&&F.push({searchPath:S.searchPath,pattern:D+"/**"}),F}q(S,k,D){const F=this.r((0,c.$Di)(S.searchPath),k,D,!1);return F?{...F,includePattern:S.pattern}:null}r(S,k,D,F){let W;const B=b.URI.isUri(S)?S:S.uri;if(D.searchPaths){const z=D.searchPaths.filter(Q=>(0,w.$Og)(Q.searchPath,B))[0];if(z&&!z.pattern)return null;z&&(W=z.pattern)}const j=this.a.getValue({resource:B}),T={...this.l(j,k)||{},...W||{}},O=b.URI.isUri(S)?(0,w.$Sg)(S):S.name;return{folder:B,folderName:F?O:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!j.search.followSymlinks}}};e.$9L=s,e.$9L=s=Qe([He(0,a.$Oi),He(1,c.$ri),He(2,i.$BD),He(3,m.$Oj),He(4,n.$7L)],s);function t(v){const S=v.match(/[\*\{\}\(\)\[\]\?]/);if(S){const k=S.index,D=v.substr(0,k).match(/[/|\\][^/\\]*$/);if(D){let F=v.substr(0,D.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:v.substr((D.index||0)+1)}}}return{pathPortion:v}}function f(...v){return v.length?v.reduce((S,k)=>(S[k]=!0,S),Object.create(null)):void 0}function d(v){return I.$ak(v,",").map(S=>S.trim()).filter(S=>!!S.length)}function u(v){return[`**/${v}/**`,`**/${v}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function h(v){return v.replace(/\\/g,"/")}function l(v){return h(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(v){return v.replace(/([?*[\]])/g,"[$1]")}function E(v,S){v=o.$Mb(v,F=>F.toString());const k=[],D=S.getWorkspace();return v&&v.forEach(F=>{let W;if(S.getWorkbenchState()===2)W=(0,w.$Xg)(D.folders[0].uri,F),W&&W!=="."&&(W="./"+W);else{const B=S.getWorkspaceFolder(F);if(B){const j=B.name;if(D.folders.filter(T=>T.name===j).length===1){const T=(0,w.$Xg)(B.uri,F);T===""?W=`./${B.name}`:W=`./${B.name}/${T}`}else W=F.fsPath}}W&&k.push(g(W))}),k}}),define(Ee[372],Ce([1,0,23,2,22,13,5,371,36,43,8]),function(re,e,o,R,I,M,L,p,$,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fvb=b,e.$gvb=a;const P=7e3;function b(m,c){const i=c.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],r=[];for(const h of i)if(/^workspaceContains:/.test(h)){const l=h.substr(18);l.indexOf("*")>=0||l.indexOf("?")>=0||m.forceUsingSearch?r.push(l):n.push(l)}if(n.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:s,resolve:t}=(0,A.$bh)(),f=h=>t({activationEvent:h}),d=Promise.all(n.map(h=>C(m,h,f))).then(()=>{}),u=y(m,c.identifier,r,f);return Promise.all([d,u]).then(()=>{t(void 0)}),s}async function C(m,c,i){for(const n of m.folders)if(await m.exists(o.$Vg(R.URI.revive(n),c))){i(`workspaceContains:${c}`);return}}async function y(m,c,i,n){if(i.length===0)return Promise.resolve(void 0);const r=new I.$ee,s=m.checkExists(m.folders,i,r.token),t=setTimeout(async()=>{r.cancel(),m.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},P);let f=!1;try{f=await s}catch(d){M.$4(d)||M.$1(d)}r.dispose(),clearTimeout(t),f&&n(`workspaceContains:${i.join(",")}`)}function a(m,c,i,n){const r=m.get(L.$hi),s=m.get($.$GK),f=r.createInstance(p.$9L).file(c.map(d=>(0,w.$Di)(R.URI.revive(d))),{_reason:"checkExists",includePattern:i,exists:!0});return s.fileSearch(f,n).then(d=>!!d.limitHit,d=>M.$4(d)?!1:Promise.reject(d))}});var it=this&&this.__classPrivateFieldSet||function(re,e,o,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!I:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(re,o):I?I.value=o:e.set(re,o),o},qe=this&&this.__classPrivateFieldGet||function(re,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(re):R?R.value:e.get(re)};define(Ee[48],Ce([1,0,220,17,58,23,8,3,77,2,12,6,45,302,119,38,26,149,13,25,21,281,7,65,5,28,93,20,107,70,44,122,4,372,118,283,15,116,40,11,117]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i,n,r,s,t,f,d,u,h,l,g,E,v,S,k,D,F,W,B,j,N,T,O){"use strict";var z,Q,Z,J;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dkc=e.$Ckc=e.$Bkc=e.$Akc=e.$zkc=void 0,e.$zkc=(0,d.$ii)("IHostUtils");let x=J=class extends p.$Uc{constructor(me,ie,se,oe,G,ee,le,de,Me,be,Pe,Re,ze){super(),this.Y=Re,this.Z=ze,this.a=this.B(new k.$7d),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=ie,this.g=se,this.f=le,this.j=oe,this.m=G,this.s=ee,this.t=Me,this.u=be,this.w=Pe,this.y=this.g.getProxy(P.$sM.MainThreadWorkspace),this.z=this.g.getProxy(P.$sM.MainThreadTelemetry),this.C=this.g.getProxy(P.$sM.MainThreadExtensionService),this.D=new L.$hh,this.F=new L.$hh,this.G=new L.$hh,this.H=new L.$hh,this.I=new he(this.f.extensions.activationEvents),this.L=new c.$r$b(this.I,this.f.extensions.allExtensions);const V=new n.$Fm(this.f.extensions.myExtensions);this.J=new c.$r$b(this.I,_(this.L,V)),T.$n&&(this.s.info(`Creating extension host with the following global extensions: ${pe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${pe(this.J)}`)),this.M=new y.$kkc(this.g,this.s),this.N=new F.$skc(this.g),this.O=de,this.h=me.createChild(new g.$gi([y.$lkc,this.M],[F.$tkc,this.N])),this.P=this.B(new C.$jkc(this.J,this.L,{onExtensionActivationError:(H,Y,X)=>{this.C.$onExtensionActivationError(H,i.$3(Y),X)},actualActivateExtension:async(H,Y)=>{if(c.$r$b.isHostExtension(H,this.J,this.L))return await this.C.$activateExtension(H,Y),new C.$ikc;const X=this.J.getExtensionDescription(H);return this.fb(X,Y)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(me){i.$1(me)}}async $(){this.O.onWillDeactivateAll();let me=[];try{me=this.J.getAllExtensionDescriptions().map(G=>G.identifier).filter(G=>this.isActivated(G)).map(G=>this.eb(G))}catch{}await Promise.all(me)}terminate(me,ie=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${me}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(oe=>{this.s.error(oe)}),this.g.dispose();const se=this.$();Promise.race([(0,L.$jh)(5e3),se]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ie}`):this.s.info(`Extension host exiting with code ${ie}`),this.s.flush(),this.s.dispose(),this.c.exit(ie)})}isActivated(me){return this.G.isOpen()?this.P.isActivated(me):!1}async getExtension(me){const ie=await this.C.$getExtension(me);return ie&&{...ie,identifier:new n.$Em(ie.identifier.value),extensionLocation:w.URI.revive(ie.extensionLocation)}}ab(me,ie){return this.P.activateByEvent(me,ie)}bb(me,ie){return this.P.activateById(me,ie)}activateByIdWithErrors(me,ie){return this.bb(me,ie).then(()=>{const se=this.P.getActivatedExtension(me);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(me=>this.J)}getExtensionExports(me){if(this.G.isOpen())return this.P.getActivatedExtension(me).exports;try{return this.P.getActivatedExtension(me).exports}catch{return null}}async cb(me){if(me.scheme===B.Schemas.file&&this.c.fsRealpath){const ie=me.fsPath;this.R.has(ie)||this.R.set(ie,this.c.fsRealpath(ie));const se=await this.R.get(ie);return w.URI.file(se)}return me}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(me=>new U(me))),this.Q}async db(me){const ie=$.$oi.forUris(se=>M.$Mg.ignorePathCasing(se));return await Promise.all(me.map(async se=>{if(this.wb(se)){const oe=await this.cb(se.extensionLocation);ie.set(oe,se)}})),ie}eb(me){let ie=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(me))return ie;const se=this.P.getActivatedExtension(me);if(!se)return ie;try{typeof se.module.deactivate=="function"&&(ie=Promise.resolve(se.module.deactivate()).then(void 0,oe=>(this.s.error(oe),Promise.resolve(void 0))))}catch(oe){this.s.error(`An error occurred when deactivating the extension '${me.value}':`),this.s.error(oe)}try{(0,p.$Pc)(se.subscriptions)}catch(oe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${me.value}':`),this.s.error(oe)}return ie}async fb(me,ie){return this.f.remote.isRemote?this.C.$onWillActivateExtension(me.identifier):await this.C.$onWillActivateExtension(me.identifier),this.hb(me,ie).then(se=>{const oe=se.activationTimes;return this.C.$onDidActivateExtension(me.identifier,oe.codeLoadingTime,oe.activateCallTime,oe.activateResolvedTime,ie),this.gb(me,ie,"success",oe),se},se=>{throw this.gb(me,ie,"failure"),se})}gb(me,ie,se,oe){const G=te(me,ie);this.z.$publicLog2("extensionActivationTimes",{...G,...oe||{},outcome:se})}hb(me,ie){const se=te(me,ie);this.z.$publicLog2("activatePlugin",se);const oe=this.wb(me);if(!oe)return Promise.resolve(new C.$hkc(C.$ekc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${me.identifier.value}, startup: ${ie.startup}, activationEvent: '${ie.activationEvent}'${me.identifier.value!==ie.extensionId.value?`, root cause: ${ie.extensionId.value}`:""}`),this.s.flush();const G=new C.$fkc(ie.startup);return Promise.all([this.xb(me,(0,M.$Vg)(me.extensionLocation,oe),G),this.ib(me)]).then(ee=>(I.mark(`code/extHost/willActivateExtension/${me.identifier.value}`),J.jb(this.s,me.identifier,ee[0],ee[1],G))).then(ee=>(I.mark(`code/extHost/didActivateExtension/${me.identifier.value}`),ee))}ib(me){const ie=this.Z.createLanguageModelAccessInformation(me),se=new s.$nkc(me,this.M),oe=new s.$mkc(me.identifier.value,!1,this.M),G=new W.$ukc(me,this.N),ee=me.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,le=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${me.identifier.value}`),Promise.all([se.whenReady,oe.whenReady,this.O.whenReady]).then(()=>{const de=this;let Me,be;const Pe=(0,m.$cG)(me,"ipc")?this.f.messagePorts?.get(n.$Em.toKey(me.identifier)):void 0;return Object.freeze({globalState:se,workspaceState:oe,secrets:G,subscriptions:[],get languageModelAccessInformation(){return ie},get extensionUri(){return me.extensionLocation},get extensionPath(){return me.extensionLocation.fsPath},asAbsolutePath(Re){return R.$kc(me.extensionLocation.fsPath,Re)},get storagePath(){return de.O.workspaceValue(me)?.fsPath},get globalStoragePath(){return de.O.globalValue(me).fsPath},get logPath(){return R.$kc(de.f.logsLocation.fsPath,me.identifier.value)},get logUri(){return w.URI.joinPath(de.f.logsLocation,me.identifier.value)},get storageUri(){return de.O.workspaceValue(me)},get globalStorageUri(){return de.O.globalValue(me)},get extensionMode(){return ee},get extension(){return Me===void 0&&(Me=new ye(de,me.identifier,me,le,!1)),Me},get extensionRuntime(){return(0,m.$dG)(me,"extensionRuntime"),de.extensionRuntime},get environmentVariableCollection(){return de.u.getEnvironmentVariableCollection(me)},get messagePassingProtocol(){if(!be){if(!Pe)return;const Re=k.Event.buffer(k.Event.fromDOMEventEmitter(Pe,"message",ze=>ze.data));Pe.start(),be={onDidReceiveMessage:Re,postMessage:Pe.postMessage.bind(Pe)}}return be}})})}static jb(me,ie,se,oe,G){return se=se||{activate:void 0,deactivate:void 0},this.kb(me,ie,se,oe,G).then(ee=>new C.$gkc(!1,null,G.build(),se,ee,oe.subscriptions))}static kb(me,ie,se,oe,G){if(typeof se.activate=="function")try{G.activateCallStart(),me.trace(`ExtensionService#_callActivateOptional ${ie.value}`);const ee=typeof global=="object"?global:self,le=se.activate.apply(ee,[oe]);return G.activateCallStop(),G.activateResolveStart(),Promise.resolve(le).then(de=>(G.activateResolveStop(),de))}catch(ee){return Promise.reject(ee)}else return Promise.resolve(se)}lb(me,ie){this.bb(me.identifier,{startup:!1,extensionId:me.identifier,activationEvent:ie}).then(void 0,se=>{this.s.error(se)})}mb(me,ie=0){const oe=Date.now();(0,T.$v)(()=>{for(let G=ie;G<me.length;G+=1){const ee=me[G];for(const le of ee.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-oe>50){this.mb(me,G);break}else this.lb(ee,le)}})}nb(){this.C.$setPerformanceMarks(I.getMarks()),this.m.getConfigProvider().then(me=>{const ie=me.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),se=this.J.getAllExtensionDescriptions();if(ie)this.mb(se);else for(const oe of se)if(oe.activationEvents)for(const G of oe.activationEvents)G==="onStartupFinished"&&this.lb(oe,G)})}ob(){const me=this.ab("*",!0).then(void 0,ee=>{this.s.error(ee)});this.B(this.j.onDidChangeWorkspace(ee=>this.pb(ee.added)));const ie=this.j.workspace?this.j.workspace.folders:[],se=this.pb(ie),oe=this.rb(),G=Promise.all([oe,me,se]).then(()=>{});return Promise.race([G,(0,L.$jh)(1e4)]).then(()=>{this.nb()}),G}pb(me){return me.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ie=>this.qb(me,ie))).then(()=>{})}async qb(me,ie){if(this.isActivated(ie.identifier))return;const se=!this.f.remote.isRemote&&!!this.f.remote.authority,oe={logService:this.s,folders:me.map(ee=>ee.uri),forceUsingSearch:se||!this.c.fsExists,exists:ee=>this.c.fsExists(ee.fsPath),checkExists:(ee,le,de)=>this.y.$checkExists(ee,le,de)},G=await(0,D.$fvb)(oe,ie);if(G)return this.bb(ie.identifier,{startup:!0,extensionId:ie.identifier,activationEvent:G.activationEvent}).then(void 0,ee=>this.s.error(ee))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(me){throw console.error(me),me}}async sb(){const{extensionDevelopmentLocationURI:me,extensionTestsLocationURI:ie}=this.f.environment;if(!me||!ie)throw new Error(o.localize(0,null));const se=await this.xb(null,ie,new C.$fkc(!1));if(!se||typeof se.run!="function")throw new Error(o.localize(1,null,ie.toString()));return new Promise((oe,G)=>{const ee=(Me,be)=>{Me?(T.$n&&this.s.error("Test runner called back with error",Me),G(Me)):(T.$n&&(be?this.s.info(`Test runner called back with ${be} failures.`):this.s.info("Test runner called back with successful outcome.")),oe(typeof be=="number"&&be>0?1:0))},le=(0,M.$Jg)(ie),de=se.run(le,ee);de&&de.then&&de.then(()=>{T.$n&&this.s.info("Test runner finished successfully."),oe(0)}).catch(Me=>{T.$n&&this.s.error("Test runner finished with error",Me),G(Me instanceof Error&&Me.stack?Me.stack:String(Me))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,L.$jh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(me,ie){return this.S[me]=ie,(0,p.$Sc)(()=>{delete this.S[me]})}async getRemoteExecServer(me){const{resolver:ie}=await this.ub(me);return ie?.resolveExecServer?.(me,{resolveAttempt:0})}async ub(me){const ie=me.indexOf("+");if(ie===-1)throw new t.$AM("Not an authority that can be resolved!",f.RemoteAuthorityResolverErrorCode.InvalidAuthority);const se=me.substr(0,ie);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this.S[se]}}async $resolveAuthority(me,ie){const se=N.$3d.create(!1),oe=()=>`[resolveAuthority(${(0,f.$xl)(me)},${ie})][${se.elapsed()}ms] `,G=fe=>this.s.info(`${oe()}${fe}`),ee=fe=>this.s.warn(`${oe()}${fe}`),le=(fe,we=void 0)=>this.s.error(`${oe()}${fe}`,we),de=fe=>{if(fe instanceof t.$AM)return{type:"error",error:{code:fe._code,message:fe._message,detail:fe._detail}};throw fe},Me=async fe=>{G(`activating resolver for ${fe}...`);const{resolver:we,authorityPrefix:Te}=await this.ub(fe);if(!we)throw le(`no resolver for ${Te}`),new t.$AM(`No remote extension installed to resolve ${Te}.`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:we,authorityPrefix:Te,remoteAuthority:fe}},be=me.split(/@|%40/g).reverse();G(`activating remote resolvers ${be.join(" -> ")}`);let Pe;try{Pe=await Promise.all(be.map(Me)).catch(async fe=>{if(!(fe instanceof t.$AM)||fe._code!==f.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw fe;return ee(`resolving nested authorities failed: ${fe.message}`),[await Me(me)]})}catch(fe){return de(fe)}const Re=new L.$th;Re.cancelAndSet(()=>G("waiting..."),1e3);let ze,V;for(const[fe,{authorityPrefix:we,resolver:Te,remoteAuthority:Ve}]of Pe.entries())try{if(fe===Pe.length-1)G("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${we}`),ze=await Te.resolve(Ve,{resolveAttempt:ie,execServer:V}),I.mark(`code/extHost/didResolveAuthorityOK/${we}`),G("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Te,t.$zM.isManagedResolvedAuthority(ze)?ze:void 0));else{if(G(`invoking resolveExecServer() for ${Ve}`),I.mark(`code/extHost/willResolveExecServer/${we}`),V=await Te.resolveExecServer?.(Ve,{resolveAttempt:ie,execServer:V}),!V)throw new t.$AM(`Exec server was not available for ${Ve}`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${we}`)}}catch(Ye){return I.mark(`code/extHost/didResolveAuthorityError/${we}`),le("returned an error",Ye),Re.dispose(),de(Ye)}Re.dispose();const H={environmentTunnels:ze.environmentTunnels,features:ze.tunnelFeatures?{elevation:ze.tunnelFeatures.elevation,privacyOptions:ze.tunnelFeatures.privacyOptions,protocol:ze.tunnelFeatures.protocol===void 0?!0:ze.tunnelFeatures.protocol}:void 0},Y={extensionHostEnv:ze.extensionHostEnv,isTrusted:ze.isTrusted,authenticationSession:ze.authenticationSessionForInitializingExtensions?{id:ze.authenticationSessionForInitializingExtensions.id,providerId:ze.authenticationSessionForInitializingExtensions.providerId}:void 0};G(`returned ${t.$zM.isManagedResolvedAuthority(ze)?"managed authority":`${ze.host}:${ze.port}`}`);let X;if(t.$zM.isManagedResolvedAuthority(ze)){const fe=ie;this.Y.setFactory(fe,ze.makeConnection),X={authority:me,connectTo:new f.$ul(fe),connectionToken:ze.connectionToken}}else X={authority:me,connectTo:new f.$vl(ze.host,ze.port),connectionToken:ze.connectionToken};return{type:"ok",value:{authority:X,options:Y,tunnelInformation:H}}}async $getCanonicalURI(me,ie){this.s.info(`$getCanonicalURI invoked for authority (${(0,f.$xl)(me)})`);const{resolver:se}=await this.ub(me);if(!se)return null;const oe=w.URI.revive(ie);if(typeof se.getCanonicalURI>"u")return oe;const G=await(0,L.$ah)(()=>se.getCanonicalURI(oe));return G||oe}async $startExtensionHost(me){me.toAdd.forEach(ee=>ee.extensionLocation=w.URI.revive(ee.extensionLocation));const{globalRegistry:ie,myExtensions:se}=ce(this.I,this.L,this.J,me),oe=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.L.set(ie.getAllExtensionDescriptions()),this.J.set(se),T.$n&&(this.s.info(`$startExtensionHost: global extensions: ${pe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${pe(this.J)}`)),this.tb()}$activateByEvent(me,ie){return ie===1?this.D.wait().then(se=>this.ab(me,!1)):this.G.wait().then(se=>this.ab(me,!1))}async $activate(me,ie){return await this.G.wait(),this.J.getExtensionDescription(me)?(await this.bb(me,ie),!0):!1}async $deltaExtensions(me){me.toAdd.forEach(ee=>ee.extensionLocation=w.URI.revive(ee.extensionLocation));const{globalRegistry:ie,myExtensions:se}=ce(this.I,this.L,this.J,me),oe=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.L.set(ie.getAllExtensionDescriptions()),this.J.set(se),T.$n&&(this.s.info(`$deltaExtensions: global extensions: ${pe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${pe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(me){return me}async $test_up(me){return me.byteLength}async $test_down(me){const ie=r.$ue.alloc(me),se=Math.random()%256;for(let oe=0;oe<me;oe++)ie.writeUInt8(se,oe);return ie}async $updateRemoteConnectionData(me){this.X=me,this.a.fire()}};e.$Akc=x,e.$Akc=x=J=Qe([He(0,d.$hi),He(1,e.$zkc),He(2,l.$OO),He(3,a.$Zjc),He(4,b.$3jc),He(5,A.$Oj),He(6,u.$5O),He(7,h.$6jc),He(8,E.$lCb),He(9,v.$okc),He(10,j.$wkc),He(11,O.$xkc),He(12,S.$Pjc)],x);function ce(Se,me,ie,se){Se.addActivationEvents(se.addActivationEvents);const oe=new c.$r$b(Se,me.getAllExtensionDescriptions());oe.deltaExtensions(se.toAdd,se.toRemove);const G=new n.$Fm(ie.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of se.myToRemove)G.delete(le);for(const le of se.myToAdd)G.add(le);const ee=_(oe,G);return{globalRegistry:oe,myExtensions:ee}}function te(Se,me){return{id:Se.identifier.value,name:Se.name,extensionVersion:Se.version,publisherDisplayName:Se.publisher,activationEvents:Se.activationEvents?Se.activationEvents.join(","):null,isBuiltin:Se.isBuiltin,reason:me.activationEvent,reasonId:me.extensionId.value}}function pe(Se){return Se.getAllExtensionDescriptions().map(me=>me.identifier.value).join(",")}e.$Bkc=(0,d.$ii)("IExtHostExtensionService");class ye{constructor(me,ie,se,oe,G){z.set(this,void 0),Q.set(this,void 0),Z.set(this,void 0),it(this,z,me,"f"),it(this,Q,ie,"f"),it(this,Z,se.identifier,"f"),this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=R.$ic((0,M.$Jg)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=oe,this.isFromDifferentExtensionHost=G}get isActive(){return qe(this,z,"f").isActivated(qe(this,Z,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return qe(this,z,"f").getExtensionExports(qe(this,Z,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await qe(this,z,"f").activateByIdWithErrors(qe(this,Z,"f"),{startup:!1,extensionId:qe(this,Q,"f"),activationEvent:"api"}),this.exports}}e.$Ckc=ye,z=new WeakMap,Q=new WeakMap,Z=new WeakMap;function _(Se,me){return Se.getAllExtensionDescriptions().filter(ie=>me.has(ie.identifier))}class U{constructor(me){this.a=me}setSearchTree(me){this.a=me}findSubstr(me){return this.a.findSubstr(me)}forEach(me){return this.a.forEach(me)}}e.$Dkc=U;class he{constructor(me){this.a=new n.$Gm,this.addActivationEvents(me)}readActivationEvents(me){return this.a.get(me.identifier)??[]}addActivationEvents(me){for(const ie of Object.keys(me))this.a.set(ie,me[ie])}}}),define(Ee[373],Ce([1,0,58,2,6,45,26,25,20,28,5,48,12,14]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=void 0;let a=class{constructor(r,s,t,f,d,u,h){this.c=r,this.d=s,this.f=t,this.g=f,this.h=d,this.i=u,this.j=h,this.a=new Map,this.b=[]}async install(){this.k(),o.mark("code/extHost/willWaitForConfig");const r=await this.g.getConfigProvider();o.mark("code/extHost/didWaitForConfig");const s=await this.h.getExtensionPathIndex();this.register(new c(this.c,s,this.d,r,this.j)),this.register(this.f.createInstance(m)),this.i.remote.isRemote&&this.register(this.f.createInstance(i,s,this.i.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const s of r.nodeModuleName)this.a.set(s,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(s=>r.alternativeModuleName(s))}};e.$Nlc=a,e.$Nlc=a=Qe([He(2,A.$hi),He(3,M.$3jc),He(4,P.$Bkc),He(5,w.$5O),He(6,b.$Oj)],a);let m=y=class{constructor(r){if(r.environment.appRoot&&y.a.size){const s=(0,C.$Ze)(this.c(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",f=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${d}\\/)(${f})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const s=this.b.exec(this.c(r));if(!s)return;const[,t,f,d]=s,u=y.a.get(f);if(u!==void 0)return console.warn(`${f} as been renamed to ${u}, please update your imports`),t+u+d}c(r){return r.replace(/\\/g,"/")}};m.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),m=y=Qe([He(0,w.$5O)],m);class c{constructor(r,s,t,f,d){this.c=r,this.d=s,this.e=t,this.f=f,this.g=d,this.nodeModuleName="vscode",this.a=new p.$Gm}load(r,s){const t=this.d.findSubstr(s);if(t){let f=this.a.get(t.identifier);return f||(f=this.c(t,this.e,this.f),this.a.set(t.identifier,f)),f}if(!this.b){let f="";this.d.forEach((d,u)=>f+=`	${u} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${f}`),this.b=this.c(L.$0F,this.e,this.f)}return this.b}}let i=class{constructor(r,s,t){this.e=r,this.f=s,this.nodeModuleName=["open","opn"],this.d=t.getProxy(I.$sM.MainThreadTelemetry);const f=t.getProxy(I.$sM.MainThreadWindow);this.c=(d,u)=>{const h=R.URI.parse(d);return u?this.g(d,u):h.scheme==="http"||h.scheme==="https"?f.$openUri(h,d,{allowTunneling:!0}):h.scheme==="mailto"||h.scheme===this.f?f.$openUri(h,d,{}):this.g(d,u)}}load(r,s,t){const f=this.e.findSubstr(s);return f&&(this.a=f.identifier.value,this.h()),this.b=t(r),this.c}g(r,s){return this.i(),this.b(r,s)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Qe([He(2,$.$OO)],i)}),define(Ee[60],Ce([1,0,46,3,17,49,5,72,71,48,7,38,299,45]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fkc=e.$Ekc=void 0,e.$Ekc=(0,L.$ii)("IExtHostVariableResolverProvider");class y extends b.$QP{constructor(c,i,n,r,s,t,f){function d(){if(n){const u=n.activeEditor();if(u)return u.document.uri;const h=r.tabGroups.all.find(l=>l.isActive)?.activeTab;if(h!==void 0){if(h.input instanceof A.$fO||h.input instanceof A.$kO)return h.input.modified;if(h.input instanceof A.$eO||h.input instanceof A.$jO||h.input instanceof A.$hO)return h.input.uri}}}super({getFolderUri:u=>{const h=t.folders.filter(l=>l.name===u);if(h&&h.length>0)return h[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(u,h)=>s.getConfiguration(void 0,u).get(h),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=d();if(u)return I.$ic(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const u=d();if(u){const h=i.getWorkspaceFolder(u);if(h)return I.$ic(h.uri.fsPath)}}},getSelectedText:()=>{if(n){const u=n.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(n){const u=n.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>c.getExtension(u)},void 0,f?Promise.resolve(f):void 0,Promise.resolve(M.env))}}let a=class extends R.$Uc{constructor(c,i,n,r,s){super(),this.b=c,this.c=i,this.g=n,this.h=r,this.j=s,this.a=new o.$V(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new y(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$Fkc=a,e.$Fkc=a=Qe([He(0,w.$Bkc),He(1,P.$Zjc),He(2,p.$ZO),He(3,C.$3jc),He(4,$.$ckc)],a)}),define(Ee[96],Ce([1,0,8,4,2,25,5,6,71,48,20,7,38,144,291,45,60,3,56,33,16]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=e.$Jkc=e.$Ikc=e.$Hkc=e.$Gkc=void 0,e.$Gkc=(0,L.$ii)("IExtHostDebugService");let s=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(g,E,v,S,k,D,F){this.N=E,this.O=v,this.P=S,this.Q=k,this.R=D,this.S=F,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new R.$7d,this.o=new R.$7d,this.q=new R.$7d,this.w=new R.$7d,this.l=g.getProxy(p.$sM.MainThreadDebugService),this.A=new R.$7d,this.C=new R.$7d,this.y=new f(this.l),this.z=new Map,this.O.getExtensionRegistry().then(W=>{W.onDidChange(B=>{this.V(W)}),this.V(W)})}async $getVisualizerTreeItem(g,E){const v=this.W(E);if(!v)return;const S=await this.H.get(g)?.getTreeItem?.(v);return S?this.U(g,S):void 0}registerDebugVisualizationTree(g,E,v){const S=M.$Em.toKey(g.identifier),k=this.jb(S,E);if(this.G.has(k))throw new Error(`A debug visualization provider with id '${E}' is already registered`);return this.H.set(k,v),this.l.$registerDebugVisualizerTree(k,!!v.editItem),(0,c.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(k),this.H.delete(E)})}async $getVisualizerTreeItemChildren(g,E){const v=this.J.get(E)?.item;return v?(await this.H.get(g)?.getChildren?.(v))?.map(k=>this.U(g,k))||[]:[]}async $editVisualizerTreeItem(g,E){const v=this.J.get(g);if(!v)return;const S=await this.H.get(v.provider)?.editItem?.(v.item,E);return this.U(v.provider,S||v.item)}$disposeVisualizedTree(g){const E=this.J.get(g);if(!E)return;const v=[E.children];for(const S of v)if(S)for(const k of S)v.push(this.J.get(k)?.children),this.J.delete(k)}U(g,E){let v=this.I.get(E);return v||(v=this.F++,this.I.set(E,v),this.J.set(v,{provider:g,item:E})),r.DebugTreeItem.from(E,v)}asDebugSourceUri(g,E){const v=g;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let S=`debug:${encodeURIComponent(v.path||"")}`,k="?";return E&&(S+=`${k}session=${encodeURIComponent(E.id)}`,k="&"),S+=`${k}ref=${v.sourceReference}`,I.URI.parse(S)}else{if(v.path)return I.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(g){const E=[];for(const v of g.getAllExtensionDescriptions())if(v.contributes){const S=v.contributes.debuggers;if(S&&S.length>0)for(const k of S)(0,y.$PG)(k)&&E.push(k.type)}this.l.$registerDebugTypes(E)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const g=[];return this.z.forEach(E=>g.push(E)),g}async $resolveDebugVisualizer(g,E){const v=this.L.get(g);if(!v)throw new Error(`No debug visualizer found with id '${g}'`);let{v:S,provider:k,extensionId:D}=v;if(S.visualization||(S=await k.resolveDebugVisualization?.(S,E)||S,v.v=S),!S.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${k}'`);return this.kb(D,S.visualization)}async $executeDebugVisualizerCommand(g){const E=this.L.get(g);if(!E)throw new Error(`No debug visualizer found with id '${g}'`);const v=E.v.visualization;v&&"command"in v&&this.S.executeCommand(v.command,...v.arguments||[])}W(g){const E=this.m.get(g.sessionId);return E&&{session:E.api,variable:g.variable,containerId:g.containerId,frameId:g.frameId,threadId:g.threadId}}async $provideDebugVisualizers(g,E,v,S){const k=this.W(v),D=this.jb(g,E),F=this.G.get(D);if(!k||!F)return[];const W=await F.provideDebugVisualization(k,S);return W?W.map(B=>{const j=++this.M;this.L.set(j,{v:B,provider:F,extensionId:g});const N=B.iconPath?this.lb(B.iconPath):void 0;return{id:j,name:B.name,iconClass:N?.iconClass,iconPath:N?.iconPath,visualization:this.kb(g,B.visualization)}}):[]}$disposeDebugVisualizers(g){for(const E of g)this.L.delete(E)}registerDebugVisualizationProvider(g,E,v){if(!g.contributes?.debugVisualizers?.some(D=>D.id===E))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${E})`);const S=M.$Em.toKey(g.identifier),k=this.jb(S,E);if(this.G.has(k))throw new Error(`A debug visualization provider with id '${E}' is already registered`);return this.G.set(k,v),this.l.$registerDebugVisualizer(S,E),(0,c.$Sc)(()=>{this.l.$unregisterDebugVisualizer(S,E),this.G.delete(E)})}addBreakpoints(g){const E=g.filter(k=>{const D=k.id;return this.z.has(D)?!1:(this.z.set(D,k),!0)});this.gb(E,[],[]);const v=[],S=new Map;for(const k of E)if(k instanceof P.$vN){let D=S.get(k.location.uri.toString());D||(D={type:"sourceMulti",uri:k.location.uri,lines:[]},S.set(k.location.uri.toString(),D),v.push(D)),D.lines.push({id:k.id,enabled:k.enabled,condition:k.condition,hitCondition:k.hitCondition,logMessage:k.logMessage,line:k.location.range.start.line,character:k.location.range.start.character,mode:k.mode})}else k instanceof P.$wN&&v.push({type:"function",id:k.id,enabled:k.enabled,hitCondition:k.hitCondition,logMessage:k.logMessage,condition:k.condition,functionName:k.functionName,mode:k.mode});return this.l.$registerBreakpoints(v)}removeBreakpoints(g){const E=g.filter(D=>this.z.delete(D.id));this.gb([],E,[]);const v=E.filter(D=>D instanceof P.$vN).map(D=>D.id),S=E.filter(D=>D instanceof P.$wN).map(D=>D.id),k=E.filter(D=>D instanceof P.$xN).map(D=>D.id);return this.l.$unregisterBreakpoints(v,S,k)}startDebugging(g,E,v){return this.l.$startDebugging(g?g.uri:void 0,E,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,suppressSaveBeforeStart:v.suppressSaveBeforeStart,suppressDebugStatusbar:v.suppressDebugStatusbar??v.debugUI?.simple,suppressDebugToolbar:v.suppressDebugToolbar??v.debugUI?.simple,suppressDebugView:v.suppressDebugView??v.debugUI?.simple})}stopDebugging(g){return this.l.$stopDebugging(g?g.id:void 0)}registerDebugConfigurationProvider(g,E,v){if(!E)return new P.$uM(()=>{});const S=this.d++;return this.f.push({type:g,handle:S,provider:E}),this.l.$registerDebugConfigurationProvider(g,v,!!E.provideDebugConfigurations,!!E.resolveDebugConfiguration,!!E.resolveDebugConfigurationWithSubstitutedVariables,S),new P.$uM(()=>{this.f=this.f.filter(k=>k.provider!==E),this.l.$unregisterDebugConfigurationProvider(S)})}registerDebugAdapterDescriptorFactory(g,E,v){if(!v)return new P.$uM(()=>{});if(!this.cb(g,E))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${E}' debugger.`);if(this.$(E))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const S=this.g++;return this.h.push({type:E,handle:S,factory:v}),this.l.$registerDebugAdapterDescriptorFactory(E,S),new P.$uM(()=>{this.h=this.h.filter(k=>k.factory!==v),this.l.$unregisterDebugAdapterDescriptorFactory(S)})}registerDebugAdapterTrackerFactory(g,E){if(!E)return new P.$uM(()=>{});const v=this.j++;return this.k.push({type:g,handle:v,factory:E}),new P.$uM(()=>{this.k=this.k.filter(S=>S.factory!==E)})}async $runInTerminal(g,E){return Promise.resolve(void 0)}async $substituteVariables(g,E){let v;const S=await this.ib(g);return S&&(v={uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(v,E)}X(g,E){if(g.type==="implementation")return new u(g.implementation)}Y(){}async $startDASession(g,E){const v=this,S=await this.hb(E);return this.eb(this.$(S.type),S).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}' (extension might have failed to activate)`);const D=this.Z(k),F=this.X(D,S);if(!F)throw new Error(`Couldn't create a debug adapter for type '${S.type}'.`);const W=F;return this.D.set(g,W),this.db(S).then(B=>(B&&this.E.set(g,B),W.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const N=j,T={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const O=await this.K.sign(N.arguments.value);T.body={signature:O},W.sendResponse(T)}else throw new Error("no signer")}catch(O){T.success=!1,T.message=O.message,W.sendResponse(T)}}else B&&B.onDidSendMessage&&B.onDidSendMessage(j),j=(0,y.$UG)(j,!0),v.l.$acceptDAMessage(g,j)}),W.onError(j=>{B&&B.onError&&B.onError(j),this.l.$acceptDAError(g,j.name,j.message,j.stack)}),W.onExit(j=>{B&&B.onExit&&B.onExit(j??void 0,void 0),this.l.$acceptDAExit(g,j??void 0,void 0)}),B&&B.onWillStartSession&&B.onWillStartSession(),W.startSession()))})}$sendDAMessage(g,E){E=(0,y.$TG)(E,!1);const v=this.E.get(g);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(E),this.D.get(g)?.sendMessage(E)}$stopDASession(g){const E=this.E.get(g);this.E.delete(g),E&&E.onWillStopSession&&E.onWillStopSession();const v=this.D.get(g);return this.D.delete(g),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(g){const E=[],v=[],S=[];if(g.added)for(const k of g.added){const D=k.id;if(D&&!this.z.has(D)){let F;if(k.type==="function")F=new P.$wN(k.functionName,k.enabled,k.condition,k.hitCondition,k.logMessage,k.mode);else if(k.type==="data")F=new P.$xN(k.label,k.dataId,k.canPersist,k.enabled,k.hitCondition,k.condition,k.logMessage,k.mode);else{const W=I.URI.revive(k.uri);F=new P.$vN(new P.$GM(W,new P.$vM(k.line,k.character)),k.enabled,k.condition,k.hitCondition,k.logMessage,k.mode)}(0,P.$tN)(F,D),this.z.set(D,F),E.push(F)}}if(g.removed)for(const k of g.removed){const D=this.z.get(k);D&&(this.z.delete(k),v.push(D))}if(g.changed){for(const k of g.changed)if(k.id){const D=this.z.get(k.id);if(D){if(D instanceof P.$wN&&k.type==="function"){const F=D;F.enabled=k.enabled,F.condition=k.condition,F.hitCondition=k.hitCondition,F.logMessage=k.logMessage,F.functionName=k.functionName}else if(D instanceof P.$vN&&k.type==="source"){const F=D;F.enabled=k.enabled,F.condition=k.condition,F.hitCondition=k.hitCondition,F.logMessage=k.logMessage,F.location=new P.$GM(I.URI.revive(k.uri),new P.$vM(k.line,k.character))}S.push(D)}}}this.gb(E,v,S)}async $acceptStackFrameFocus(g){let E;if(g){const v=await this.hb(g.sessionId);g.kind==="thread"?E=new P.$DN(v.api,g.threadId):E=new P.$CN(v.api,g.threadId,g.frameId)}this.B=E,this.C.fire(this.B)}$provideDebugConfigurations(g,E,v){return(0,o.$ah)(async()=>{const S=this.bb(g);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const k=await this.ib(E);return S.provideDebugConfigurations(k,v)}).then(S=>{if(!S)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return S})}$resolveDebugConfiguration(g,E,v,S){return(0,o.$ah)(async()=>{const k=this.bb(g);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const D=await this.ib(E);return k.resolveDebugConfiguration(D,v,S)})}$resolveDebugConfigurationWithSubstitutedVariables(g,E,v,S){return(0,o.$ah)(async()=>{const k=this.bb(g);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const D=await this.ib(E);return k.resolveDebugConfigurationWithSubstitutedVariables(D,v,S)})}async $provideDebugAdapter(g,E){const v=this.ab(g);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const S=await this.hb(E);return this.eb(v,S).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}'`);return this.Z(k)})}async $acceptDebugSessionStarted(g){const E=await this.hb(g);this.n.fire(E.api)}async $acceptDebugSessionTerminated(g){const E=await this.hb(g);E&&(this.o.fire(E.api),this.m.delete(E.id))}async $acceptDebugSessionActiveChanged(g){this.u=g?await this.hb(g):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(g,E){(await this.hb(g))?._acceptNameChanged(E)}async $acceptDebugSessionCustomEvent(g,E){const S={session:(await this.hb(g)).api,event:E.event,body:E.body};this.w.fire(S)}Z(g){if(g instanceof P.$yN)return{type:"executable",command:g.command,args:g.args,options:g.options};if(g instanceof P.$zN)return{type:"server",port:g.port,host:g.host};if(g instanceof P.$AN)return{type:"pipeServer",path:g.path};if(g instanceof P.$BN)return{type:"implementation",implementation:g.implementation};throw new Error("convertToDto unexpected type")}$(g){const E=this.h.filter(v=>v.type===g);if(E.length>0)return E[0].factory}ab(g){const E=this.h.filter(v=>v.handle===g);if(E.length>0)return E[0].factory}bb(g){const E=this.f.filter(v=>v.handle===g);if(E.length>0)return E[0].provider}cb(g,E){if(g.contributes){const v=g.contributes.debuggers;if(v&&v.length>0){for(const S of v)if(S.label&&S.type&&S.type===E)return!0}}return!1}db(g){const v=g.configuration.type,S=this.k.filter(k=>k.type===v||k.type==="*").map(k=>(0,o.$ah)(()=>k.factory.createDebugAdapterTracker(g.api)).then(D=>D,D=>null));return Promise.race([Promise.all(S).then(k=>{const D=k.filter(F=>!!F);if(D.length>0)return new d(D)}),new Promise(k=>setTimeout(()=>k(void 0),1e3))]).catch(k=>{})}async eb(g,E){const v=E.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new P.$zN(v));if(g){const k=await this.O.getExtensionRegistry();return(0,o.$ah)(()=>g.createDebugAdapterDescriptor(E.api,this.fb(E,k))).then(D=>{if(D)return D})}const S=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(E,S))}fb(g,E){}gb(g,E,v){(g.length>0||E.length>0||v.length>0)&&this.A.fire(Object.freeze({added:g,removed:E,changed:v}))}async hb(g){if(g)if(typeof g=="string"){const E=this.m.get(g);if(E)return E}else{let E=this.m.get(g.id);if(!E){const v=await this.ib(g.folderUri),S=g.parent?this.m.get(g.parent):void 0;E=new t(this.l,g.id,g.type,g.name,v,g.configuration,S?.api),this.m.set(E.id,E),this.l.$sessionCached(E.id)}return E}throw new Error("cannot find session")}ib(g){if(g){const E=I.URI.revive(g);return this.N.resolveWorkspaceFolder(E)}return Promise.resolve(void 0)}jb(g,E){return`${g}\0${E}`}kb(g,E){if(E){if("title"in E&&"command"in E)return{type:0};if("treeId"in E)return{type:1,id:`${g}\0${E.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(g){const E=this.mb(g);let v,S;return"id"in E?S=i.ThemeIcon.asClassName(E):v=E,{iconPath:v,iconClass:S}}mb(g){if(g instanceof P.$qN)return{id:g.id};const E=typeof g=="object"&&"dark"in g?g.dark:g,v=typeof g=="object"&&"light"in g?g.light:g;return{dark:typeof E=="string"?I.URI.file(E):E,light:typeof v=="string"?I.URI.file(v):v}}};e.$Hkc=s,e.$Hkc=s=Qe([He(0,A.$OO),He(1,b.$Zjc),He(2,w.$Bkc),He(3,a.$3jc),He(4,$.$ckc),He(5,m.$Ekc),He(6,n.$$O)],s);class t{constructor(g,E,v,S,k,D,F){this.f=g,this.g=E,this.h=v,this.j=S,this.k=k,this.l=D,this.m=F}get api(){const g=this;return this.d??(this.d=Object.freeze({id:g.g,type:g.h,get name(){return g.j},set name(E){g.j=E,g.f.$setDebugSessionName(g.g,E)},parentSession:g.m,workspaceFolder:g.k,configuration:g.l,customRequest(E,v){return g.f.$customDebugAdapterRequest(g.g,E,v)},getDebugProtocolBreakpoint(E){return g.f.$getDebugProtocolBreakpoint(g.g,E.id)}}))}get id(){return this.g}get type(){return this.h}_acceptNameChanged(g){this.j=g}get configuration(){return this.l}}e.$Ikc=t;class f{constructor(g){this.value=Object.freeze({append(E){g.$appendDebugConsole(E)},appendLine(E){this.append(E+`
`)}})}}e.$Jkc=f;class d{constructor(g){this.d=g}onWillStartSession(){this.d.forEach(g=>g.onWillStartSession?g.onWillStartSession():void 0)}onWillReceiveMessage(g){this.d.forEach(E=>E.onWillReceiveMessage?E.onWillReceiveMessage(g):void 0)}onDidSendMessage(g){this.d.forEach(E=>E.onDidSendMessage?E.onDidSendMessage(g):void 0)}onWillStopSession(){this.d.forEach(g=>g.onWillStopSession?g.onWillStopSession():void 0)}onError(g){this.d.forEach(E=>E.onError?E.onError(g):void 0)}onExit(g,E){this.d.forEach(v=>v.onExit?v.onExit(g,E):void 0)}}class u extends C.$kob{constructor(g){super(),this.h=g,g.onDidSendMessage(E=>{this.acceptMessage(E)})}startSession(){return Promise.resolve(void 0)}sendMessage(g){this.h.handleMessage(g)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends s{constructor(g,E,v,S,k,D,F){super(g,E,v,S,k,D,F)}};e.$Kkc=h,e.$Kkc=h=Qe([He(0,A.$OO),He(1,b.$Zjc),He(2,w.$Bkc),He(3,a.$3jc),He(4,$.$ckc),He(5,m.$Ekc),He(6,n.$$O)],h)}),define(Ee[374],Ce([1,0,13,58,2,6,320,12,84,107,28,257,20,66,48,90]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Plc=e.$Olc=void 0;class m{static async installEarlyHandler(n){Error.stackTraceLimit=100;const r=n.get(p.$Oj),t=n.get(b.$OO).getProxy(M.$sM.MainThreadErrors);o.setUnexpectedErrorHandler(f=>{r.error(f);const d=o.$3(f);t.$onUnexpectedError(d)})}static async installFullHandler(n){const r=n.get(p.$Oj),s=n.get(b.$OO),t=n.get(y.$Bkc),f=n.get(a.$9O),d=s.getProxy(M.$sM.MainThreadExtensionService),u=s.getProxy(M.$sM.MainThreadErrors),h=await t.getExtensionPathIndex(),l=new WeakMap;function g(S,k){if(l.has(S))return l.get(S).stack;let D="",F,W;for(const j of k)D+=`
	at ${j.toString()}`,W=j.getFileName(),!F&&W&&(F=h.findSubstr(I.URI.file(W)));const B=`${S.name||"Error"}: ${S.message||""}${D}`;return l.set(S,{extensionIdentifier:F?.identifier,stack:B}),B}const E=Symbol("prepareStackTrace wrapped");let v=g;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(S){if(S===g||!S||S[E]){v=S||g;return}v=function(k,D){return g(k,D),S.call(Error,k,D)},Object.assign(v,{[E]:!0})}}),o.setUnexpectedErrorHandler(S=>{r.error(S);const k=o.$3(S),D=l.get(S);if(!D?.extensionIdentifier){u.$onUnexpectedError(k);return}d.$onExtensionRuntimeError(D.extensionIdentifier,k);const F=f.onExtensionError(D.extensionIdentifier,S);r.trace("forwarded error to extension?",F,D)})}}e.$Olc=m;class c{constructor(n,r,s,t,f){this.a=s,this.b=new L.$z$b(n,null,t),r=c.e(r,this.b);const d=new w.$gi(...(0,$.$is)());d.set(A.$5O,{_serviceBrand:void 0,...r,messagePorts:f}),d.set(b.$OO,new b.$PO(this.b)),d.set(C.$Wjc,new C.$Xjc(t)),d.set(y.$zkc,s);const u=new P.$Zq(d,!0);u.invokeFunction(m.installEarlyHandler),this.d=u.invokeFunction(h=>h.get(p.$Oj)),R.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=u.invokeFunction(h=>h.get(y.$Bkc)),this.c.initialize(),u.invokeFunction(m.installFullHandler)}async asBrowserUri(n){const r=this.b.getProxy(M.$sM.MainThreadExtensionService);return I.URI.revive(await r.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,r){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=I.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=I.URI.revive(r.transformIncomingURIs(n.environment.appRoot));const s=n.environment.extensionDevelopmentLocationURI;return s&&(n.environment.extensionDevelopmentLocationURI=s.map(t=>I.URI.revive(r.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=I.URI.revive(r.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=I.URI.revive(r.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=I.URI.revive(r.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=I.URI.revive(r.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=I.URI.revive(r.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=I.URI.revive(r.transformIncomingURIs(n.logsLocation)),n.workspace=r.transformIncomingURIs(n.workspace),n}}e.$Plc=c}),define(Ee[375],Ce([1,0,8,11,231,250,142,96,71,48,20,44,7,60,38,292,293,45,33]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlc=void 0;let n=class extends p.$Hkc{constructor(d,u,h,l,g,E,v,S){super(d,u,h,l,E,v,S),this.pb=g,this.nb=new t}X(d,u){switch(d.type){case"server":return new a.$Ulc(d);case"pipeServer":return new a.$Vlc(d);case"executable":return new a.$Wlc(d,u.type)}return super.X(d,u)}fb(d,u){const h=a.$Wlc.platformAdapterExecutable(u.getAllExtensionDescriptions(),d.type);if(h)return new b.$yN(h.command,h.args,h.options)}Y(){return new L.$mcc}async $runInTerminal(d,u){if(d.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(j=>{this.nb.onTerminalClosed(j)}));const h=await this.P.getConfigProvider(),l=this.pb.getDefaultShell(!0),g=this.pb.getDefaultShellArgs(!0),E=d.title||I.localize(0,null),v=JSON.stringify({shell:l,shellArgs:g});let S=await this.nb.checkout(v,E),k,D=!1;if(S)k=d.cwd;else{const j={shellPath:l,shellArgs:g,cwd:d.cwd,name:E,iconPath:new b.$qN("debug")};D=!0,S=this.pb.createTerminalFromOptions(j,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(S,v)}S.show(!0);const F=await S.processId;D?await new Promise(j=>setTimeout(j,1e3)):(S.state.isInteractedWith&&S.sendText(""),h.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0||l.indexOf("cmd.exe")>=0?S.sendText("cls"):l.indexOf("bash")>=0?S.sendText("clear"):R.$c?S.sendText("cls"):S.sendText("clear")));const W=(0,m.$Ylc)(l,d.args,!!d.argsCanBeInterpretedByShell,k,d.env);S.sendText(W);const B=this.onDidTerminateDebugSession(j=>{j.id===u&&(this.nb.free(S),B.dispose())});return F}else if(d.kind==="external")return s(d,await this.P.getConfigProvider());return super.$runInTerminal(d,u)}};e.$Zlc=n,e.$Zlc=n=Qe([He(0,A.$OO),He(1,y.$Zjc),He(2,w.$Bkc),He(3,c.$3jc),He(4,P.$okc),He(5,$.$ckc),He(6,C.$Ekc),He(7,i.$$O)],n);let r;function s(f,d){if(!r)if(R.$c)r=new M.$0ac;else if(R.$d)r=new M.$$ac;else if(R.$e)r=new M.$_ac;else throw new Error("external terminals not supported on this platform");const u=d.getConfiguration("terminal");return r.runInTerminal(f.title,f.cwd,f.args,f.env||{},u.external||{})}class t{constructor(){this.b=new Map}async checkout(d,u,h=!1){const g=[...this.b.entries()].map(([E,v])=>(0,o.$8g)(async S=>{if(E.name!==u||v.lastUsedAt!==-1&&await(0,m.$Xlc)(await E.processId))return null;const k=Date.now();return v.lastUsedAt+t.a>k||S.isCancellationRequested?null:v.config!==d?(h&&E.dispose(),null):(v.lastUsedAt=k,E)}));return await(0,o.$nh)(g,E=>!!E)}insert(d,u){this.b.set(d,{lastUsedAt:Date.now(),config:u})}free(d){const u=this.b.get(d);u&&(u.lastUsedAt=-1)}onTerminalClosed(d){this.b.delete(d)}}t.a=1e3}),define(Ee[376],Ce([1,0,17,2,104,38,72,45,43,44,20,28,95,15,12,91,23,62,60]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rlc=void 0;let n=class extends b.$rlc{constructor(s,t,f,d,u,h,l,g,E){super(s,t,f,d,u,h,l,g),this.C=f,this.D=E,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(C.Schemas.vscodeRemote,{scheme:C.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(C.Schemas.file,{scheme:C.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(s,t){const f=t;if(!t.execution&&f._id===void 0)throw new Error("Tasks to execute must include an execution");if(f._id!==void 0){const d=b.TaskHandleDTO.from(f,this.C),u=await this.a.$getTaskExecution(d);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const h=await this.z(u,t);return this.a.$executeTask(d).catch(()=>{}),h}else{const d=b.TaskDTO.from(t,s);if(d===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(d.execution)&&await this.y(d,t,!1);const u=await this.z(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),u}}v(s,t,f,d){const u=[];if(d)for(const h of d){this.A(h,f),(!h.definition||!s[h.definition.type])&&this.f.warn(`The task [${h.source}, ${h.name}] uses an undefined task type. The task will be ignored in the future.`);const l=b.TaskDTO.from(h,f.extension);l&&(u.push(l),b.CustomExecutionDTO.is(l.execution)&&t.push(this.y(l,h,!0)))}return{tasks:u,extension:f.extension}}async w(s){return s}async G(s){let t=s&&s.length>0?s[0]:void 0;if(!t){const f=R.URI.file((0,c.homedir)());t=new $.$Ci({uri:f,name:m.$Sg(f),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(s,t){const f=R.URI.revive(s),d={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(f),h=await this.b.getWorkspaceFolders2()??[],l=await this.D.getResolver(),g=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(h);for(const E of t.variables)d.variables[E]=await l.resolveAsync(g,E);if(t.process!==void 0){let E;if(t.process.path!==void 0){E=t.process.path.split(o.$uc);for(let v=0;v<E.length;v++)E[v]=await l.resolveAsync(g,E[v])}d.process=await I.win32.findExecutable(await l.resolveAsync(g,t.process.name),t.process.cwd!==void 0?await l.resolveAsync(g,t.process.cwd):void 0,E)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(s,t,f){return I.win32.findExecutable(s,t,f)}};e.$Rlc=n,e.$Rlc=n=Qe([He(0,A.$OO),He(1,P.$5O),He(2,M.$Zjc),He(3,L.$ZO),He(4,p.$3jc),He(5,w.$okc),He(6,y.$Oj),He(7,a.$Ajc),He(8,i.$Ekc)],n)}),define(Ee[377],Ce([1,0,62,60]),function(re,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xmc=void 0;class I extends R.$Fkc{m(){return(0,o.homedir)()}}e.$xmc=I}),define(Ee[160],Ce([1,0,19,8,22,47,15,17,23,2,36]),function(re,e,o,R,I,M,L,p,$,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2kc=e.$Zkc=e.$Ykc=void 0,e.$1kc=a;class P{constructor(i,n,r){this.d=i,this.e=n,this.f=r,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(i,n){const r=this.g.folderQueries||[],s=new I.$ee(n);return new Promise((t,f)=>{this.a=new C(i);let d=!1;const u=(h,l)=>{if(!d&&!this.b){const g=this.h(h);a(h)&&typeof this.g.maxResults=="number"&&this.c+g>this.g.maxResults&&(this.b=!0,d=!0,s.cancel(),h=this.j(h,this.g.maxResults-this.c));const E=this.h(h);this.c+=E,(E>0||!a(h))&&this.a.add(h,l)}};Promise.all(r.map((h,l)=>this.k(h,g=>u(g,l),s.token))).then(h=>{s.dispose(),this.a.flush();const l=h.some(g=>!!g&&!!g.limitHit);t({limitHit:this.b||l,messages:(0,o.$Rb)(h.map(g=>g?.message?Array.isArray(g.message)?g.message:[g.message]:[])),stats:{type:this.f}})},h=>{s.dispose();const l=(0,M.$6i)(h);f(new Error(l))})})}h(i){return a(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const r=Array.isArray(i.ranges)?i.ranges:[i.ranges],s=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:r.slice(0,n),preview:{matches:s.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,r){const s=new A.$ZK(this.g,i),t=[],f={report:h=>{if(!this.l(h))return;const l=i.folder.scheme===L.Schemas.file?(0,A.$1K)(()=>this.e.readdir($.$Ug(h.uri))):void 0,g=$.$Xg(i.folder,h.uri);if(g){const E=s.includedInQuery(g,p.$oc(g),l);(0,R.$7g)(E)?t.push(E.then(v=>{v&&n(h)})):E&&n(h)}}},d=this.n(i);let u;return this.d.query.type===3?u=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,d,f,r):u=await this.d.provider.provideTextSearchResults(b(this.d.query.contentPattern),d,f,r),t.length&&await Promise.all(t),u}l(i){if(a(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,A.$YK)(this.g.includePattern,i.includePattern),r=(0,A.$YK)(this.g.excludePattern,i.excludePattern),s={folder:w.URI.from(i.folder),excludes:r,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.e.toCanonicalName(i.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(s.usePCRE2=this.g.usePCRE2),s}}e.$Ykc=P;function b(c){return{isCaseSensitive:c.isCaseSensitive||!1,isRegExp:c.isRegExp||!1,isWordMatch:c.isWordMatch||!1,isMultiline:c.isMultiline||!1,pattern:c.pattern}}class C{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new m(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!$.$Og(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(y(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$Zkc=C;function y(c){return a(c)?{preview:{matches:(0,o.$2b)(c.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:c.preview.text},ranges:(0,o.$2b)(c.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:c.text,lineNumber:c.lineNumber}}function a(c){return!!c.preview}class m{constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$2kc=m,m.a=4e3,m.b=50}),define(Ee[97],Ce([1,0,3,6,5,370,20,66,12,2,160]),function(re,e,o,R,I,M,L,p,$,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4kc=e.$3kc=void 0,e.$5kc=b,e.$3kc=(0,I.$ii)("IExtHostSearch");let P=class{constructor(a,m,c){this.n=a,this.o=m,this.q=c,this.c=this.n.getProxy(R.$sM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new M.$Xkc}s(a){return this.o.transformOutgoingScheme(a)}registerTextSearchProvider(a,m){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const c=this.d++;return this.e.set(c,m),this.c.$registerTextSearchProvider(c,this.s(a)),(0,o.$Sc)(()=>{this.g.delete(a),this.e.delete(c),this.c.$unregisterProvider(c)})}registerAITextSearchProvider(a,m){if(this.i.has(a))throw new Error(`an AI text search provider for the scheme '${a}'is already registered`);this.i.add(a);const c=this.d++;return this.h.set(c,m),this.c.$registerAITextSearchProvider(c,this.s(a)),(0,o.$Sc)(()=>{this.i.delete(a),this.h.delete(c),this.c.$unregisterProvider(c)})}registerFileSearchProvider(a,m){if(this.k.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.k.add(a);const c=this.d++;return this.j.set(c,m),this.c.$registerFileSearchProvider(c,this.s(a)),(0,o.$Sc)(()=>{this.k.delete(a),this.j.delete(c),this.c.$unregisterProvider(c)})}$provideFileSearchResults(a,m,c,i){const n=b(c),r=this.j.get(a);if(r)return this.l.fileSearch(n,r,s=>{this.c.$handleFileMatch(a,m,s.map(t=>t.resource))},i);throw new Error("3 unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,m,c){return{messages:[]}}$clearCache(a){return this.l.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,m,c,i){const n=this.e.get(a);if(!n||!n.provideTextSearchResults)throw new Error(`2 Unknown provider ${a}`);const r=b(c);return this.t(r,n).search(t=>this.c.$handleTextMatch(a,m,t),i)}$provideAITextSearchResults(a,m,c,i){const n=this.h.get(a);if(!n||!n.provideAITextSearchResults)throw new Error(`1 Unknown provider ${a}`);const r=b(c);return this.v(r,n).search(t=>this.c.$handleTextMatch(a,m,t),i)}$enableExtensionHostSearch(){}t(a,m){return new A.$Ykc({query:a,provider:m},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}v(a,m){return new A.$Ykc({query:a,provider:m},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"aiTextSearchProvider")}};e.$4kc=P,e.$4kc=P=Qe([He(0,L.$OO),He(1,p.$Wjc),He(2,$.$Oj)],P);function b(y){return{...y,folderQueries:y.folderQueries&&y.folderQueries.map(C),extraFileResources:y.extraFileResources&&y.extraFileResources.map(a=>w.URI.revive(a))}}function C(y){return{...y,folder:w.URI.revive(y.folder)}}}),define(Ee[378],Ce([1,0,22,13,4,3,15,41,2,136,186,187,82,25,32,12,86,87,276,6,322,349,91,121,327,308,328,122,329,309,297,33,330,45,331,96,152,332,311,323,333,334,72,71,324,48,335,69,336,59,28,350,351,325,312,337,338,116,117,313,369,340,282,341,352,342,158,314,343,344,345,20,346,97,118,347,315,348,119,93,95,90,44,353,354,326,355,356,70,16,7,316,66,317,92,357,358,151,38,290,115,26,94,156]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i,n,r,s,t,f,d,u,h,l,g,E,v,S,k,D,F,W,B,j,N,T,O,z,Q,Z,J,x,ce,te,pe,ye,_,U,he,Se,me,ie,se,oe,G,ee,le,de,Me,be,Pe,Re,ze,V,H,Y,X,fe,we,Te,Ve,Ye,nt,ot,lt,at,st,Ie,We,Ae,Ke,ae,ue,De,Je,et,Ne,ht,vt,Mt,zt,Yt,xt,Pt,sn,_t,dn,tt,on,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=Kt;function Kt(gt){const bt=gt.get(_.$5O),Xt=gt.get(ye.$Ejc),Bt=gt.get(te.$5jc),Vt=gt.get(x.$Bkc),$t=gt.get(sn.$Zjc),Rt=gt.get(Ie.$9O),cn=gt.get(D.$3jc),en=gt.get(vt.$Wjc),Xe=gt.get(fe.$OO),Zt=gt.get(lt.$lkc),tn=gt.get(at.$6jc),nn=gt.get(a.$Pj),yt=gt.get(a.$Oj),Ut=gt.get(Je.$lCb),Tt=gt.get(t.$Ajc),Lt=gt.get(Pt.$Glc),un=gt.get(Ve.$tkc),Wt=gt.get(Z.$ckc),Ht=gt.get(G.$xkc),It=gt.get(f.$Kjc),Ft=gt.get(l.$Pjc);Xe.set(n.$tM.ExtHostFileSystemInfo,Xt),Xe.set(n.$tM.ExtHostLogLevelServiceShape,nn),Xe.set(n.$tM.ExtHostWorkspace,$t),Xe.set(n.$tM.ExtHostConfiguration,cn),Xe.set(n.$tM.ExtHostExtensionService,Vt),Xe.set(n.$tM.ExtHostStorage,Zt),Xe.set(n.$tM.ExtHostTunnelService,Ut),Xe.set(n.$tM.ExtHostWindow,Lt),Xe.set(n.$tM.ExtHostSecretState,un),Xe.set(n.$tM.ExtHostTelemetry,Rt),Xe.set(n.$tM.ExtHostEditorTabs,Wt),Xe.set(n.$tM.ExtHostManagedSockets,Ht),Xe.set(n.$tM.ExtHostAuthentication,It),Xe.set(n.$tM.ExtHostChatProvider,Ft);const rn=Xe.set(n.$tM.ExtHostDecorations,gt.get(B.$Mkc)),At=Xe.set(n.$tM.ExtHostDocumentsAndEditors,gt.get(Q.$ZO)),Et=Xe.set(n.$tM.ExtHostCommands,gt.get(S.$$O)),Nt=Xe.set(n.$tM.ExtHostTerminalService,gt.get(We.$okc)),fn=Xe.set(n.$tM.ExtHostTerminalShellIntegration,gt.get(Gt.$Hlc)),Ct=Xe.set(n.$tM.ExtHostDebugService,gt.get(W.$Gkc)),ln=Xe.set(n.$tM.ExtHostSearch,gt.get(Te.$3kc)),Jt=Xe.set(n.$tM.ExtHostTask,gt.get(st.$tlc)),En=Xe.set(n.$tM.ExtHostOutputService,gt.get(ze.$glc)),wn=Xe.set(n.$tM.ExtHostLocalization,gt.get(oe.$wkc)),Oe=Xe.set(n.$tM.ExtHostUrls,new Mt.$Dlc(Xe)),Fe=Xe.set(n.$tM.ExtHostDocuments,new z.$Hjc(Xe,At)),ke=Xe.set(n.$tM.ExtHostDocumentContentProviders,new T.$Okc(Xe,At,yt)),ne=Xe.set(n.$tM.ExtHostDocumentSaveParticipant,new O.$Pkc(yt,Fe,Xe.getProxy(n.$sM.MainThreadBulkEdits))),Le=Xe.set(n.$tM.ExtHostNotebook,new le.$6kc(Xe,Et,At,Fe,Bt,ln)),Ge=Xe.set(n.$tM.ExtHostNotebookDocuments,new Me.$alc(Le)),_e=Xe.set(n.$tM.ExtHostNotebookEditors,new be.$blc(yt,Le)),Ze=Xe.set(n.$tM.ExtHostNotebookKernels,new Pe.$clc(Xe,bt,Le,Et,yt)),dt=Xe.set(n.$tM.ExtHostNotebookRenderers,new Re.$elc(Xe,Le)),St=Xe.set(n.$tM.ExtHostNotebookDocumentSaveParticipant,new de.$_kc(yt,Le,Xe.getProxy(n.$sM.MainThreadBulkEdits))),Dt=Xe.set(n.$tM.ExtHostEditors,new Ke.$Tjc(Xe,At)),an=Xe.set(n.$tM.ExtHostTreeViews,new De.$Blc(Xe.getProxy(n.$sM.MainThreadTreeViews),Et,yt)),Ot=Xe.set(n.$tM.ExtHostEditorInsets,new v.$Ujc(Xe.getProxy(n.$sM.MainThreadEditorInsets),Dt,bt.remote)),qt=Xe.set(n.$tM.ExtHostDiagnostics,new j.$Gjc(Xe,yt,Xt,At)),Cn=Xe.set(n.$tM.ExtHostLanguages,new se.$0kc(Xe,Fe,Et.converter,en)),mt=Xe.set(n.$tM.ExtHostLanguageFeatures,new ie.$Ijc(Xe,en,Fe,Et,qt,yt,Tt,Rt)),Tn=Xe.set(n.$tM.ExtHostFileSystem,new ce.$Rkc(Xe,mt)),gn=Xe.set(n.$tM.ExtHostFileSystemEventService,new pe.$Skc(Xe,yt,At)),vn=Xe.set(n.$tM.ExtHostQuickOpen,(0,X.$klc)(Xe,$t,Et)),Mn=Xe.set(n.$tM.ExtHostSCM,new we.$mlc(Xe,Et,Fe,yt)),mi=Xe.set(n.$tM.ExtHostQuickDiff,new Y.$jlc(Xe,en)),$i=Xe.set(n.$tM.ExtHostShare,new Ye.$nlc(Xe,en)),Fn=Xe.set(n.$tM.ExtHostComments,(0,k.$Vjc)(Xe,Et,Fe)),zn=Xe.set(n.$tM.ExtHostProgress,new H.$ilc(Xe.getProxy(n.$sM.MainThreadProgress))),Bn=Xe.set(n.$tM.ExtHostLabelService,new me.$9kc(Xe)),Rn=Xe.set(n.$tM.ExtHostTheming,new ae.$ylc(Xe)),Un=Xe.set(n.$tM.ExtHostTimeline,new ue.$Alc(Xe,Et)),Sn=Xe.set(n.$tM.ExtHostWebviews,new zt.$0jc(Xe,bt.remote,$t,yt,Tt)),Ln=Xe.set(n.$tM.ExtHostWebviewPanels,new Yt.$akc(Xe,Sn,$t)),pi=Xe.set(n.$tM.ExtHostCustomEditors,new F.$bkc(Xe,Fe,tn,Sn,Ln)),xn=Xe.set(n.$tM.ExtHostWebviewViews,new xt.$Elc(Xe,Sn)),yn=Xe.set(n.$tM.ExtHostTesting,new Ae.$ulc(Xe,yt,Et,At)),Wn=Xe.set(n.$tM.ExtHostUriOpeners,new ht.$Clc(Xe)),_n=Xe.set(n.$tM.ExtHostProfileContentHandlers,new V.$hlc(Xe));Xe.set(n.$tM.ExtHostInteractive,new he.$7kc(Xe,Le,At,Et,yt));const ei=Xe.set(n.$tM.ExtHostInlineChat,new U.$Tkc(Xe,Et,Fe,yt)),Vn=Xe.set(n.$tM.ExtHostChatAgents2,new h.$Ojc(Xe,yt,Et)),ti=Xe.set(n.$tM.ExtHostChatVariables,new g.$Rjc(Xe)),qn=Xe.set(n.$tM.ExtHostChat,new u.$Njc(Xe)),Hn=Xe.set(n.$tM.ExtHostAiRelatedInformation,new r.$zjc(Xe)),bi=Xe.set(n.$tM.ExtHostAiEmbeddingVector,new J.$Qkc(Xe)),ni=Xe.set(n.$tM.ExtHostIssueReporter,new Se.$8kc(Xe)),On=Xe.set(n.$tM.ExtHostStatusBar,new ot.$qlc(Xe,Et.converter)),Gn=Xe.set(n.$tM.ExtHostSpeech,new nt.$olc(Xe)),wi=Object.values(n.$tM);Xe.assertRegistered(wi);const vi=new d.$Mjc(Xe,At),ii=new E.$Sjc(Xe),Kn=new ee.$$kc(Xe,yt),Dn=new N.$Nkc(Xe);return s.$Jjc.register(Et),function(Ue,mn,Jn){function ct(ge){return(ve,Be,ut)=>{const kt=ge(jt=>{try{ve.call(Be,jt)}catch(An){R.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${An.toString()}`,{cause:An})),Rt.onExtensionError(Ue.identifier,An)}});return ut?.push(kt),kt}}const wt=function(){let ge=!Ue.isUnderDevelopment;function ve(){ge||(yt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Be(ut){if(Array.isArray(ut))ut.forEach(Be);else if(typeof ut=="string")ve();else{const kt=ut;typeof kt.scheme>"u"&&ve(),typeof kt.exclusive=="boolean"&&(0,tt.$dG)(Ue,"documentFiltersExclusive")}return ut}}(),ri={getSession(ge,ve,Be){return typeof Be?.forceNewSession=="object"&&Be.forceNewSession.learnMore&&(0,tt.$dG)(Ue,"authLearnMore"),It.getSession(Ue,ge,ve,Be)},getSessions(ge,ve){return(0,tt.$dG)(Ue,"authGetSessions"),It.getSessions(Ue,ge,ve)},async hasSession(ge,ve){return(0,tt.$dG)(Ue,"authSession"),!!await It.getSession(Ue,ge,ve,{silent:!0})},get onDidChangeSessions(){return ct(It.onDidChangeSessions)},registerAuthenticationProvider(ge,ve,Be,ut){return It.registerAuthenticationProvider(ge,ve,Be,ut)}},pn={registerCommand(ge,ve,Be){return Et.registerCommand(!0,ge,ve,Be,void 0,Ue)},registerTextEditorCommand(ge,ve,Be){return Et.registerCommand(!0,ge,(...ut)=>{const kt=Dt.getActiveTextEditor();if(!kt){yt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return kt.edit(jt=>{ve.apply(Be,[kt,jt,...ut])}).then(jt=>{jt||yt.warn("Edits from command "+ge+" were not applied.")},jt=>{yt.warn("An error occurred while running command "+ge,jt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ge,ve,Be)=>((0,tt.$dG)(Ue,"diffCommand"),Et.registerCommand(!0,ge,async(...ut)=>{const kt=At.activeEditor(!0);if(!kt){yt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const jt=await Dt.getDiffInformation(kt.id);ve.apply(Be,[jt,...ut])},void 0,void 0,Ue)),executeCommand(ge,...ve){return Et.executeCommand(ge,...ve)},getCommands(ge=!1){return Et.getCommands(ge)}},Pn={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return ii.value},get shell(){return Nt.getDefaultShell(!1)},get onDidChangeShell(){return ct(Nt.onDidChangeShell)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ct(Rt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,tt.$dG)(Ue,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.$dG)(Ue,"telemetry"),ct(Rt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Ie.$8O)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge,ve){return Ie.$7O.validateSender(ge),Rt.instantiateLogger(Ue,ge,ve)},openExternal(ge,ve){return Lt.openUri(ge,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:ve?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===bt.environment.appUriScheme)return Oe.createAppUri(ge);try{return await Lt.asExternalUri(ge,{allowTunneling:!!bt.remote.authority})}catch(ve){if((0,L.$rg)(ge,L.Schemas.http)||(0,L.$rg)(ge,L.Schemas.https))return ge;throw ve}},get remoteName(){return(0,m.$vm)(bt.remote.authority)},get remoteAuthority(){return(0,tt.$dG)(Ue,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return yt.getLevel()},get onDidChangeLogLevel(){return ct(yt.onDidChangeLogLevel)},registerIssueUriRequestHandler(ge){return(0,tt.$dG)(Ue,"handleIssueUri"),ni.registerIssueUriRequestHandler(Ue,ge)},registerIssueDataProvider(ge){return(0,tt.$dG)(Ue,"handleIssueUri"),ni.registerIssueDataProvider(Ue,ge)},get appQuality(){return(0,tt.$dG)(Ue,"resolvers"),bt.quality},get appCommit(){return(0,tt.$dG)(Ue,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(Pn);const yi={createTestController(ge,ve,Be){return yn.createTestController(Ue,ge,ve,Be)},createTestObserver(){return(0,tt.$dG)(Ue,"testObserver"),yn.createTestObserver()},runTests(ge){return(0,tt.$dG)(Ue,"testObserver"),yn.runTests(ge)},get onDidChangeTestResults(){return(0,tt.$dG)(Ue,"testObserver"),ct(yn.onResultsChanged)},get testResults(){return(0,tt.$dG)(Ue,"testObserver"),yn.results}},In=bt.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,Nn={getExtension(ge,ve){(0,tt.$cG)(Ue,"extensionsAny")||(ve=!1);const Be=mn.mine.getExtensionDescription(ge);if(Be)return new x.$Ckc(Vt,Ue.identifier,Be,In,!1);if(ve){const ut=mn.all.getExtensionDescription(ge);if(ut)return new x.$Ckc(Vt,Ue.identifier,ut,In,!0)}},get all(){const ge=[];for(const ve of mn.mine.getAllExtensionDescriptions())ge.push(new x.$Ckc(Vt,Ue.identifier,ve,In,!1));return ge},get allAcrossExtensionHosts(){(0,tt.$dG)(Ue,"extensionsAny");const ge=new C.$Fm(mn.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),ve=[];for(const Be of mn.all.getAllExtensionDescriptions()){const ut=!ge.has(Be.identifier);ve.push(new x.$Ckc(Vt,Ue.identifier,Be,In,ut))}return ve},get onDidChange(){return(0,tt.$cG)(Ue,"extensionsAny")?ct(I.Event.any(mn.mine.onDidChange,mn.all.onDidChange)):ct(mn.mine.onDidChange)}},si={createDiagnosticCollection(ge){return qt.createDiagnosticCollection(Ue.identifier,ge)},get onDidChangeDiagnostics(){return ct(qt.onDidChangeDiagnostics)},getDiagnostics:ge=>qt.getDiagnostics(ge),getLanguages(){return Cn.getLanguages()},setTextDocumentLanguage(ge,ve){return Cn.changeLanguage(ge.uri,ve)},match(ge,ve){const Be=et.LanguageSelector.from(ge);let ut;return(0,A.$Xt)(Be)&&(ut=Le.notebookDocuments.find(kt=>kt.apiNotebook.getCells().find(jt=>jt.document===ve))?.apiNotebook),(0,A.$Wt)(Be,ve.uri,ve.languageId,!0,ut?.uri,ut?.notebookType)},registerCodeActionsProvider(ge,ve,Be){return mt.registerCodeActionProvider(Ue,wt(ge),ve,Be)},registerDocumentPasteEditProvider(ge,ve,Be){return(0,tt.$dG)(Ue,"documentPaste"),mt.registerDocumentPasteEditProvider(Ue,wt(ge),ve,Be)},registerCodeLensProvider(ge,ve){return mt.registerCodeLensProvider(Ue,wt(ge),ve)},registerDefinitionProvider(ge,ve){return mt.registerDefinitionProvider(Ue,wt(ge),ve)},registerDeclarationProvider(ge,ve){return mt.registerDeclarationProvider(Ue,wt(ge),ve)},registerImplementationProvider(ge,ve){return mt.registerImplementationProvider(Ue,wt(ge),ve)},registerTypeDefinitionProvider(ge,ve){return mt.registerTypeDefinitionProvider(Ue,wt(ge),ve)},registerHoverProvider(ge,ve){return mt.registerHoverProvider(Ue,wt(ge),ve,Ue.identifier)},registerEvaluatableExpressionProvider(ge,ve){return mt.registerEvaluatableExpressionProvider(Ue,wt(ge),ve,Ue.identifier)},registerInlineValuesProvider(ge,ve){return mt.registerInlineValuesProvider(Ue,wt(ge),ve,Ue.identifier)},registerDocumentHighlightProvider(ge,ve){return mt.registerDocumentHighlightProvider(Ue,wt(ge),ve)},registerMultiDocumentHighlightProvider(ge,ve){return mt.registerMultiDocumentHighlightProvider(Ue,wt(ge),ve)},registerLinkedEditingRangeProvider(ge,ve){return mt.registerLinkedEditingRangeProvider(Ue,wt(ge),ve)},registerReferenceProvider(ge,ve){return mt.registerReferenceProvider(Ue,wt(ge),ve)},registerRenameProvider(ge,ve){return mt.registerRenameProvider(Ue,wt(ge),ve)},registerNewSymbolNamesProvider(ge,ve){return(0,tt.$dG)(Ue,"newSymbolNamesProvider"),mt.registerNewSymbolNamesProvider(Ue,wt(ge),ve)},registerDocumentSymbolProvider(ge,ve,Be){return mt.registerDocumentSymbolProvider(Ue,wt(ge),ve,Be)},registerWorkspaceSymbolProvider(ge){return mt.registerWorkspaceSymbolProvider(Ue,ge)},registerDocumentFormattingEditProvider(ge,ve){return mt.registerDocumentFormattingEditProvider(Ue,wt(ge),ve)},registerDocumentRangeFormattingEditProvider(ge,ve){return mt.registerDocumentRangeFormattingEditProvider(Ue,wt(ge),ve)},registerOnTypeFormattingEditProvider(ge,ve,Be,...ut){return mt.registerOnTypeFormattingEditProvider(Ue,wt(ge),ve,[Be].concat(ut))},registerDocumentSemanticTokensProvider(ge,ve,Be){return mt.registerDocumentSemanticTokensProvider(Ue,wt(ge),ve,Be)},registerDocumentRangeSemanticTokensProvider(ge,ve,Be){return mt.registerDocumentRangeSemanticTokensProvider(Ue,wt(ge),ve,Be)},registerSignatureHelpProvider(ge,ve,Be,...ut){return typeof Be=="object"?mt.registerSignatureHelpProvider(Ue,wt(ge),ve,Be):mt.registerSignatureHelpProvider(Ue,wt(ge),ve,typeof Be>"u"?[]:[Be,...ut])},registerCompletionItemProvider(ge,ve,...Be){return mt.registerCompletionItemProvider(Ue,wt(ge),ve,Be)},registerInlineCompletionItemProvider(ge,ve,Be){return ve.handleDidShowCompletionItem&&(0,tt.$dG)(Ue,"inlineCompletionsAdditions"),ve.handleDidPartiallyAcceptCompletionItem&&(0,tt.$dG)(Ue,"inlineCompletionsAdditions"),Be&&(0,tt.$dG)(Ue,"inlineCompletionsAdditions"),mt.registerInlineCompletionsProvider(Ue,wt(ge),ve,Be)},registerInlineEditProvider(ge,ve){return(0,tt.$dG)(Ue,"inlineEdit"),mt.registerInlineEditProvider(Ue,wt(ge),ve)},registerDocumentLinkProvider(ge,ve){return mt.registerDocumentLinkProvider(Ue,wt(ge),ve)},registerColorProvider(ge,ve){return mt.registerColorProvider(Ue,wt(ge),ve)},registerFoldingRangeProvider(ge,ve){return mt.registerFoldingRangeProvider(Ue,wt(ge),ve)},registerSelectionRangeProvider(ge,ve){return mt.registerSelectionRangeProvider(Ue,ge,ve)},registerCallHierarchyProvider(ge,ve){return mt.registerCallHierarchyProvider(Ue,ge,ve)},registerTypeHierarchyProvider(ge,ve){return mt.registerTypeHierarchyProvider(Ue,ge,ve)},setLanguageConfiguration:(ge,ve)=>mt.setLanguageConfiguration(Ue,ge,ve),getTokenInformationAtPosition(ge,ve){return(0,tt.$dG)(Ue,"tokenInformation"),Cn.tokenAtPosition(ge,ve)},registerInlayHintsProvider(ge,ve){return mt.registerInlayHintsProvider(Ue,ge,ve)},createLanguageStatusItem(ge,ve){return Cn.createLanguageStatusItem(Ue,ge,ve)},registerDocumentDropEditProvider(ge,ve,Be){return mt.registerDocumentOnDropEditProvider(Ue,ge,ve,(0,tt.$cG)(Ue,"dropMetadata")?Be:void 0)}},oi={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return Nt.activeTerminal},get terminals(){return Nt.terminals},async showTextDocument(ge,ve,Be){$.URI.isUri(ge)&&ge.scheme===L.Schemas.vscodeRemote&&!ge.authority&&Tt.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const ut=await($.URI.isUri(ge)?Promise.resolve(Qn.openTextDocument(ge)):Promise.resolve(ge));return Dt.showTextDocument(ut,ve,Be)},createTextEditorDecorationType(ge){return Dt.createTextEditorDecorationType(Ue,ge)},onDidChangeActiveTextEditor(ge,ve,Be){return ct(Dt.onDidChangeActiveTextEditor)(ge,ve,Be)},onDidChangeVisibleTextEditors(ge,ve,Be){return ct(Dt.onDidChangeVisibleTextEditors)(ge,ve,Be)},onDidChangeTextEditorSelection(ge,ve,Be){return ct(Dt.onDidChangeTextEditorSelection)(ge,ve,Be)},onDidChangeTextEditorOptions(ge,ve,Be){return ct(Dt.onDidChangeTextEditorOptions)(ge,ve,Be)},onDidChangeTextEditorVisibleRanges(ge,ve,Be){return ct(Dt.onDidChangeTextEditorVisibleRanges)(ge,ve,Be)},onDidChangeTextEditorViewColumn(ge,ve,Be){return ct(Dt.onDidChangeTextEditorViewColumn)(ge,ve,Be)},onDidCloseTerminal(ge,ve,Be){return ct(Nt.onDidCloseTerminal)(ge,ve,Be)},onDidOpenTerminal(ge,ve,Be){return ct(Nt.onDidOpenTerminal)(ge,ve,Be)},onDidChangeActiveTerminal(ge,ve,Be){return ct(Nt.onDidChangeActiveTerminal)(ge,ve,Be)},onDidChangeTerminalDimensions(ge,ve,Be){return(0,tt.$dG)(Ue,"terminalDimensions"),ct(Nt.onDidChangeTerminalDimensions)(ge,ve,Be)},onDidChangeTerminalState(ge,ve,Be){return ct(Nt.onDidChangeTerminalState)(ge,ve,Be)},onDidWriteTerminalData(ge,ve,Be){return(0,tt.$dG)(Ue,"terminalDataWriteEvent"),ct(Nt.onDidWriteTerminalData)(ge,ve,Be)},onDidExecuteTerminalCommand(ge,ve,Be){return(0,tt.$dG)(Ue,"terminalExecuteCommandEvent"),ct(Nt.onDidExecuteTerminalCommand)(ge,ve,Be)},onDidChangeTerminalShellIntegration(ge,ve,Be){return(0,tt.$dG)(Ue,"terminalShellIntegration"),ct(fn.onDidChangeTerminalShellIntegration)(ge,ve,Be)},onDidStartTerminalShellExecution(ge,ve,Be){return(0,tt.$dG)(Ue,"terminalShellIntegration"),ct(fn.onDidStartTerminalShellExecution)(ge,ve,Be)},onDidEndTerminalShellExecution(ge,ve,Be){return(0,tt.$dG)(Ue,"terminalShellIntegration"),ct(fn.onDidEndTerminalShellExecution)(ge,ve,Be)},get state(){return Lt.getState(Ue)},onDidChangeWindowState(ge,ve,Be){return ct(Lt.onDidChangeWindowState)(ge,ve,Be)},showInformationMessage(ge,...ve){return Kn.showMessage(Ue,p.default.Info,ge,ve[0],ve.slice(1))},showWarningMessage(ge,...ve){return Kn.showMessage(Ue,p.default.Warning,ge,ve[0],ve.slice(1))},showErrorMessage(ge,...ve){return Kn.showMessage(Ue,p.default.Error,ge,ve[0],ve.slice(1))},showQuickPick(ge,ve,Be){return vn.showQuickPick(Ue,ge,ve,Be)},showWorkspaceFolderPick(ge){return vn.showWorkspaceFolderPick(ge)},showInputBox(ge,ve){return vn.showInput(ge,ve)},showOpenDialog(ge){return Dn.showOpenDialog(Ue,ge)},showSaveDialog(ge){return Dn.showSaveDialog(ge)},createStatusBarItem(ge,ve,Be){let ut,kt,jt;return typeof ge=="string"?(ut=ge,kt=ve,jt=Be):(kt=ge,jt=ve),On.createStatusBarEntry(Ue,ut,kt,jt)},setStatusBarMessage(ge,ve){return On.setStatusBarMessage(ge,ve)},withScmProgress(ge){return Tt.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),zn.withProgress(Ue,{location:Ne.ProgressLocation.SourceControl},(ve,Be)=>ge({report(ut){}}))},withProgress(ge,ve){return zn.withProgress(Ue,ge,ve)},createOutputChannel(ge,ve){return En.createOutputChannel(ge,ve,Ue)},createWebviewPanel(ge,ve,Be,ut){return Ln.createWebviewPanel(Ue,ge,ve,Be,ut)},createWebviewTextEditorInset(ge,ve,Be,ut){return(0,tt.$dG)(Ue,"editorInsets"),Ot.createWebviewEditorInset(ge,ve,Be,ut,Ue)},createTerminal(ge,ve,Be){return typeof ge=="object"?"pty"in ge?Nt.createExtensionTerminal(ge):Nt.createTerminalFromOptions(ge):Nt.createTerminal(ge,ve,Be)},registerTerminalLinkProvider(ge){return Nt.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,ve){return Nt.registerProfileProvider(Ue,ge,ve)},registerTerminalQuickFixProvider(ge,ve){return(0,tt.$dG)(Ue,"terminalQuickFixProvider"),Nt.registerTerminalQuickFixProvider(ge,Ue.identifier.value,ve)},registerTreeDataProvider(ge,ve){return an.registerTreeDataProvider(ge,ve,Ue)},createTreeView(ge,ve){return an.createTreeView(ge,ve,Ue)},registerWebviewPanelSerializer:(ge,ve)=>Ln.registerWebviewPanelSerializer(Ue,ge,ve),registerCustomEditorProvider:(ge,ve,Be={})=>pi.registerCustomEditorProvider(Ue,ge,ve,Be),registerFileDecorationProvider(ge){return rn.registerFileDecorationProvider(ge,Ue)},registerUriHandler(ge){return Oe.registerUriHandler(Ue,ge)},createQuickPick(){return vn.createQuickPick(Ue)},createInputBox(){return vn.createInputBox(Ue)},get activeColorTheme(){return Rn.activeColorTheme},onDidChangeActiveColorTheme(ge,ve,Be){return ct(Rn.onDidChangeActiveColorTheme)(ge,ve,Be)},registerWebviewViewProvider(ge,ve,Be){return xn.registerWebviewViewProvider(Ue,ge,ve,Be?.webviewOptions)},get activeNotebookEditor(){return Le.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,ve,Be){return ct(Le.onDidChangeActiveNotebookEditor)(ge,ve,Be)},get visibleNotebookEditors(){return Le.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ct(Le.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ge,ve,Be){return ct(_e.onDidChangeNotebookEditorSelection)(ge,ve,Be)},onDidChangeNotebookEditorVisibleRanges(ge,ve,Be){return ct(_e.onDidChangeNotebookEditorVisibleRanges)(ge,ve,Be)},showNotebookDocument(ge,ve){return Le.showNotebookDocument(ge,ve)},registerExternalUriOpener(ge,ve,Be){return(0,tt.$dG)(Ue,"externalUriOpener"),Wn.registerExternalUriOpener(Ue.identifier,ge,ve,Be)},registerProfileContentHandler(ge,ve){return(0,tt.$dG)(Ue,"profileContentHandlers"),_n.registerProfileContentHandler(Ue,ge,ve)},registerQuickDiffProvider(ge,ve,Be,ut){return(0,tt.$dG)(Ue,"quickDiffProvider"),mi.registerQuickDiffProvider(wt(ge),ve,Be,ut)},get tabGroups(){return Wt.tabGroups},registerShareProvider(ge,ve){return(0,tt.$dG)(Ue,"shareProvider"),$i.registerShareProvider(wt(ge),ve)}},Qn={get rootPath(){return Tt.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),$t.getPath()},set rootPath(ge){throw new R.$9("rootPath")},getWorkspaceFolder(ge){return $t.getWorkspaceFolder(ge)},get workspaceFolders(){return $t.getWorkspaceFolders()},get name(){return $t.name},set name(ge){throw new R.$9("name")},get workspaceFile(){return $t.workspaceFile},set workspaceFile(ge){throw new R.$9("workspaceFile")},updateWorkspaceFolders:(ge,ve,...Be)=>$t.updateWorkspaceFolders(Ue,ge,ve||0,...Be),onDidChangeWorkspaceFolders:function(ge,ve,Be){return ct($t.onDidChangeWorkspace)(ge,ve,Be)},asRelativePath:(ge,ve)=>$t.getRelativePath(ge,ve),findFiles:(ge,ve,Be,ut)=>$t.findFiles(ge,ve,Be,Ue.identifier,ut),findFiles2:(ge,ve,Be)=>((0,tt.$dG)(Ue,"findFiles2"),$t.findFiles2(ge,ve,Ue.identifier,Be)),findTextInFiles:(ge,ve,Be,ut)=>{(0,tt.$dG)(Ue,"findTextInFiles");let kt,jt;return typeof ve=="object"?(kt=ve,jt=Be):(kt={},jt=ve,ut=Be),$t.findTextInFiles(ge,kt||{},jt,Ue.identifier,ut)},save:ge=>$t.save(ge),saveAs:ge=>$t.saveAs(ge),saveAll:ge=>$t.saveAll(ge),applyEdit(ge,ve){return vi.applyWorkspaceEdit(ge,Ue,ve)},createFileSystemWatcher:(ge,ve,Be,ut)=>{let kt;return typeof ve=="boolean"?kt={ignoreCreateEvents:!!ve,ignoreChangeEvents:!!Be,ignoreDeleteEvents:!!ut,correlate:!1}:ve&&((0,tt.$dG)(Ue,"createFileSystemWatcher"),kt={...ve,correlate:!0}),gn.createFileSystemWatcher($t,Ue,ge,kt)},get textDocuments(){return Fe.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw new R.$9("textDocuments")},openTextDocument(ge){let ve;const Be=ge;if(typeof ge=="string")ve=Promise.resolve($.URI.file(ge));else if($.URI.isUri(ge))ve=Promise.resolve(ge);else if(!Be||typeof Be=="object")ve=Fe.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ve.then(ut=>(ut.scheme===L.Schemas.vscodeRemote&&!ut.authority&&Tt.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),Fe.ensureDocumentData(ut).then(kt=>kt.document)))},onDidOpenTextDocument:(ge,ve,Be)=>ct(Fe.onDidAddDocument)(ge,ve,Be),onDidCloseTextDocument:(ge,ve,Be)=>ct(Fe.onDidRemoveDocument)(ge,ve,Be),onDidChangeTextDocument:(ge,ve,Be)=>ct(Fe.onDidChangeDocument)(ge,ve,Be),onDidSaveTextDocument:(ge,ve,Be)=>ct(Fe.onDidSaveDocument)(ge,ve,Be),onWillSaveTextDocument:(ge,ve,Be)=>ct(ne.getOnWillSaveTextDocumentEvent(Ue))(ge,ve,Be),get notebookDocuments(){return Le.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,ve){let Be;if($.URI.isUri(ge))Be=ge,await Le.openNotebookDocument(ge);else if(typeof ge=="string")Be=$.URI.revive(await Le.createNotebookDocument({viewType:ge,content:ve}));else throw new Error("Invalid arguments");return Le.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(ge,ve,Be){return ct(Ge.onDidSaveNotebookDocument)(ge,ve,Be)},onDidChangeNotebookDocument(ge,ve,Be){return ct(Ge.onDidChangeNotebookDocument)(ge,ve,Be)},onWillSaveNotebookDocument(ge,ve,Be){return ct(St.getOnWillSaveNotebookDocumentEvent(Ue))(ge,ve,Be)},get onDidOpenNotebookDocument(){return ct(Le.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ct(Le.onDidCloseNotebookDocument)},registerNotebookSerializer(ge,ve,Be,ut){return Le.registerNotebookSerializer(Ue,ge,ve,Be,(0,tt.$cG)(Ue,"notebookLiveShare")?ut:void 0)},onDidChangeConfiguration:(ge,ve,Be)=>ct(Jn.onDidChangeConfiguration)(ge,ve,Be),getConfiguration(ge,ve){return ve=arguments.length===1?void 0:ve,Jn.getConfiguration(ge,ve,Ue)},registerTextDocumentContentProvider(ge,ve){return ke.registerTextDocumentContentProvider(ge,ve)},registerTaskProvider:(ge,ve)=>(Tt.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Jt.registerTaskProvider(Ue,ge,ve)),registerFileSystemProvider(ge,ve,Be){return(0,M.$Rc)(Tn.registerFileSystemProvider(Ue,ge,ve,Be),Bt.addFileSystemProvider(ge,ve,Be))},get fs(){return Bt.value},registerFileSearchProvider:(ge,ve)=>((0,tt.$dG)(Ue,"fileSearchProvider"),ln.registerFileSearchProvider(ge,ve)),registerTextSearchProvider:(ge,ve)=>((0,tt.$dG)(Ue,"textSearchProvider"),ln.registerTextSearchProvider(ge,ve)),registerAITextSearchProvider:(ge,ve)=>((0,tt.$dG)(Ue,"aiTextSearchProvider"),(0,tt.$dG)(Ue,"textSearchProvider"),ln.registerAITextSearchProvider(ge,ve)),registerRemoteAuthorityResolver:(ge,ve)=>((0,tt.$dG)(Ue,"resolvers"),Vt.registerRemoteAuthorityResolver(ge,ve)),registerResourceLabelFormatter:ge=>((0,tt.$dG)(Ue,"resolvers"),Bn.$registerResourceLabelFormatter(ge)),getRemoteExecServer:ge=>((0,tt.$dG)(Ue,"resolvers"),Vt.getRemoteExecServer(ge)),onDidCreateFiles:(ge,ve,Be)=>ct(gn.onDidCreateFile)(ge,ve,Be),onDidDeleteFiles:(ge,ve,Be)=>ct(gn.onDidDeleteFile)(ge,ve,Be),onDidRenameFiles:(ge,ve,Be)=>ct(gn.onDidRenameFile)(ge,ve,Be),onWillCreateFiles:(ge,ve,Be)=>ct(gn.getOnWillCreateFileEvent(Ue))(ge,ve,Be),onWillDeleteFiles:(ge,ve,Be)=>ct(gn.getOnWillDeleteFileEvent(Ue))(ge,ve,Be),onWillRenameFiles:(ge,ve,Be)=>ct(gn.getOnWillRenameFileEvent(Ue))(ge,ve,Be),openTunnel:ge=>((0,tt.$dG)(Ue,"tunnels"),Ut.openTunnel(Ue,ge).then(ve=>{if(!ve)throw new Error("cannot open tunnel");return ve})),get tunnels(){return(0,tt.$dG)(Ue,"tunnels"),Ut.getTunnels()},onDidChangeTunnels:(ge,ve,Be)=>((0,tt.$dG)(Ue,"tunnels"),ct(Ut.onDidChangeTunnels)(ge,ve,Be)),registerPortAttributesProvider:(ge,ve)=>((0,tt.$dG)(Ue,"portsAttributes"),Ut.registerPortsAttributesProvider(ge,ve)),registerTunnelProvider:(ge,ve)=>((0,tt.$dG)(Ue,"tunnelFactory"),Ut.registerTunnelProvider(ge,ve)),registerTimelineProvider:(ge,ve)=>((0,tt.$dG)(Ue,"timeline"),Un.registerTimelineProvider(ge,ve,Ue.identifier,Et.converter)),get isTrusted(){return $t.trusted},requestWorkspaceTrust:ge=>((0,tt.$dG)(Ue,"workspaceTrust"),$t.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,ve,Be)=>ct($t.onDidGrantWorkspaceTrust)(ge,ve,Be),registerEditSessionIdentityProvider:(ge,ve)=>((0,tt.$dG)(Ue,"editSessionIdentityProvider"),$t.registerEditSessionIdentityProvider(ge,ve)),onWillCreateEditSessionIdentity:(ge,ve,Be)=>((0,tt.$dG)(Ue,"editSessionIdentityProvider"),ct($t.getOnWillCreateEditSessionIdentityEvent(Ue))(ge,ve,Be)),registerCanonicalUriProvider:(ge,ve)=>((0,tt.$dG)(Ue,"canonicalUriProvider"),$t.registerCanonicalUriProvider(ge,ve)),getCanonicalUri:(ge,ve,Be)=>((0,tt.$dG)(Ue,"canonicalUriProvider"),$t.provideCanonicalUri(ge,ve,Be))},ai={get inputBox(){return Tt.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Mn.getLastInputBox(Ue)},createSourceControl(ge,ve,Be){return Mn.createSourceControl(Ue,ge,ve,Be)}},ki={createCommentController(ge,ve){return Fn.createCommentController(Ue,ge,ve)}},ci={get activeDebugSession(){return Ct.activeDebugSession},get activeDebugConsole(){return Ct.activeDebugConsole},get breakpoints(){return Ct.breakpoints},get activeStackItem(){if((0,tt.$cG)(Ue,"debugFocus"))return Ct.activeStackItem},registerDebugVisualizationProvider(ge,ve){return(0,tt.$dG)(Ue,"debugVisualization"),Ct.registerDebugVisualizationProvider(Ue,ge,ve)},registerDebugVisualizationTreeProvider(ge,ve){return(0,tt.$dG)(Ue,"debugVisualization"),Ct.registerDebugVisualizationTree(Ue,ge,ve)},onDidStartDebugSession(ge,ve,Be){return ct(Ct.onDidStartDebugSession)(ge,ve,Be)},onDidTerminateDebugSession(ge,ve,Be){return ct(Ct.onDidTerminateDebugSession)(ge,ve,Be)},onDidChangeActiveDebugSession(ge,ve,Be){return ct(Ct.onDidChangeActiveDebugSession)(ge,ve,Be)},onDidReceiveDebugSessionCustomEvent(ge,ve,Be){return ct(Ct.onDidReceiveDebugSessionCustomEvent)(ge,ve,Be)},onDidChangeBreakpoints(ge,ve,Be){return ct(Ct.onDidChangeBreakpoints)(ge,ve,Be)},onDidChangeActiveStackItem(ge,ve,Be){return(0,tt.$dG)(Ue,"debugFocus"),ct(Ct.onDidChangeActiveStackItem)(ge,ve,Be)},registerDebugConfigurationProvider(ge,ve,Be){return Ct.registerDebugConfigurationProvider(ge,ve,Be||_t.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,ve){return Ct.registerDebugAdapterDescriptorFactory(Ue,ge,ve)},registerDebugAdapterTrackerFactory(ge,ve){return Ct.registerDebugAdapterTrackerFactory(ge,ve)},startDebugging(ge,ve,Be){return!Be||typeof Be=="object"&&"configuration"in Be?Ct.startDebugging(ge,ve,{parentSession:Be}):Ct.startDebugging(ge,ve,Be||{})},stopDebugging(ge){return Ct.stopDebugging(ge)},addBreakpoints(ge){return Ct.addBreakpoints(ge)},removeBreakpoints(ge){return Ct.removeBreakpoints(ge)},asDebugSourceUri(ge,ve){return Ct.asDebugSourceUri(ge,ve)}},ui={registerTaskProvider:(ge,ve)=>Jt.registerTaskProvider(Ue,ge,ve),fetchTasks:ge=>Jt.fetchTasks(ge),executeTask:ge=>Jt.executeTask(Ue,ge),get taskExecutions(){return Jt.taskExecutions},onDidStartTask:(ge,ve,Be)=>ct(Jt.onDidStartTask)(ge,ve,Be),onDidEndTask:(ge,ve,Be)=>ct(Jt.onDidEndTask)(ge,ve,Be),onDidStartTaskProcess:(ge,ve,Be)=>ct(Jt.onDidStartTaskProcess)(ge,ve,Be),onDidEndTaskProcess:(ge,ve,Be)=>ct(Jt.onDidEndTaskProcess)(ge,ve,Be)},Ei={createNotebookController(ge,ve,Be,ut,kt){return Ze.createNotebookController(Ue,ge,ve,Be,ut,(0,tt.$cG)(Ue,"notebookMessaging")?kt:void 0)},registerNotebookCellStatusBarItemProvider:(ge,ve)=>Le.registerNotebookCellStatusBarItemProvider(Ue,ge,ve),createRendererMessaging(ge){return dt.createRendererMessaging(Ue,ge)},createNotebookControllerDetectionTask(ge){return(0,tt.$dG)(Ue,"notebookKernelSource"),Ze.createNotebookControllerDetectionTask(Ue,ge)},registerKernelSourceActionProvider(ge,ve){return(0,tt.$dG)(Ue,"notebookKernelSource"),Ze.registerKernelSourceActionProvider(Ue,ge,ve)},onDidChangeNotebookCellExecutionState(ge,ve,Be){return(0,tt.$dG)(Ue,"notebookCellExecutionState"),ct(Ze.onDidChangeNotebookCellExecutionState)(ge,ve,Be)}},Ci={t(...ge){if(typeof ge[0]=="string"){const ve=ge.shift(),Be=!ge||typeof ge[0]!="object"?ge:ge[0];return wn.getMessage(Ue.identifier.value,{message:ve,args:Be})}return wn.getMessage(Ue.identifier.value,ge[0])},get bundle(){return wn.getBundle(Ue.identifier.value)},get uri(){return wn.getBundleUri(Ue.identifier.value)}},li={_version:1,registerInteractiveEditorSessionProvider(ge,ve){return(0,tt.$dG)(Ue,"interactive"),ei.registerProvider(Ue,ge,ve)},registerInteractiveSessionProvider(ge,ve){return(0,tt.$dG)(Ue,"interactive"),qn.registerChatProvider(Ue,ge,ve)},transferChatSession(ge,ve){return(0,tt.$dG)(Ue,"interactive"),qn.transferChatSession(ge,ve)}},Xn={getRelatedInformation(ge,ve){return(0,tt.$dG)(Ue,"aiRelatedInformation"),Hn.getRelatedInformation(Ue,ge,ve)},registerRelatedInformationProvider(ge,ve){return(0,tt.$dG)(Ue,"aiRelatedInformation"),Hn.registerRelatedInformationProvider(Ue,ge,ve)},registerEmbeddingVectorProvider(ge,ve){return(0,tt.$dG)(Ue,"aiRelatedInformation"),bi.registerEmbeddingVectorProvider(Ue,ge,ve)}},hi={registerChatResponseProvider(ge,ve,Be){return(0,tt.$dG)(Ue,"chatProvider"),Ft.registerLanguageModel(Ue,ge,ve,Be)},registerChatVariableResolver(ge,ve,Be){return(0,tt.$dG)(Ue,"chatVariableResolver"),ti.registerVariableResolver(Ue,ge,ve,Be)},registerMappedEditsProvider(ge,ve){return(0,tt.$dG)(Ue,"mappedEditsProvider"),mt.registerMappedEditsProvider(Ue,ge,ve)},createChatParticipant(ge,ve){return(0,tt.$dG)(Ue,"chatParticipant"),Vn.createChatAgent(Ue,ge,ve)},createDynamicChatParticipant(ge,ve,Be,ut){return(0,tt.$dG)(Ue,"chatParticipantAdditions"),Vn.createDynamicChatAgent(Ue,ge,ve,Be,ut)}},di={get languageModels(){return(0,tt.$dG)(Ue,"languageModels"),Ft.getLanguageModelIds()},onDidChangeLanguageModels:(ge,ve,Be)=>((0,tt.$dG)(Ue,"languageModels"),Ft.onDidChangeProviders(ge,ve,Be)),sendChatRequest(ge,ve,Be,ut){return(0,tt.$dG)(Ue,"languageModels"),Ft.sendChatRequest(Ue,ge,ve,Be,ut)}},fi={registerSpeechProvider(ge,ve){return(0,tt.$dG)(Ue,"speech"),Gn.registerProvider(Ue.identifier,ge,ve)}};return{version:bt.version,ai:Xn,authentication:ri,commands:pn,comments:ki,chat:hi,debug:ci,env:Pn,extensions:Nn,interactive:li,l10n:Ci,languages:si,lm:di,notebooks:Ei,scm:ai,speech:fi,tasks:ui,tests:yi,window:oi,workspace:Qn,Breakpoint:Ne.$uN,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatResultFeedbackKind:Ne.ChatResultFeedbackKind,ChatVariableLevel:Ne.ChatVariableLevel,ChatCompletionItem:Ne.$pO,CallHierarchyIncomingCall:Ne.$SM,CallHierarchyItem:Ne.$RM,CallHierarchyOutgoingCall:Ne.$TM,CancellationError:R.$5,CancellationTokenSource:o.$ee,CandidatePortSource:n.CandidatePortSource,CodeAction:Ne.$OM,CodeActionKind:Ne.$PM,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$UM,Color:Ne.$8M,ColorInformation:Ne.$9M,ColorPresentation:Ne.$0M,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CommentThreadApplicability:Ne.CommentThreadApplicability,CompletionItem:Ne.$2M,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$3M,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$fN,DebugAdapterExecutable:Ne.$yN,DebugAdapterInlineImplementation:Ne.$BN,DebugAdapterNamedPipeServer:Ne.$AN,DebugAdapterServer:Ne.$zN,DebugConfigurationProviderTriggerKind:_t.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DebugVisualization:Ne.$RN,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$IM,DiagnosticRelatedInformation:Ne.$HM,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$uM,DocumentHighlight:Ne.$KM,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$LM,DocumentLink:Ne.$7M,DocumentSymbol:Ne.$NM,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$EN,InlineValueText:Ne.$FN,InlineValueVariableLookup:Ne.$GN,InlineValueEvaluatableExpression:Ne.$HN,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:I.$7d,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$TN,FileDecoration2:Ne.$TN,FileSystemError:Ne.$KN,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:Ne.$LN,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$wN,InlineCompletionItem:Ne.$4M,InlineCompletionList:Ne.$5M,Hover:Ne.$JM,IndentAction:P.IndentAction,Location:Ne.$GM,MarkdownString:Ne.$VM,OverviewRulerLane:b.OverviewRulerLane,ParameterInformation:Ne.$WM,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$vM,ProcessExecution:Ne.$dN,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$SN,Range:Ne.$wM,RelativePattern:Ne.$sN,Selection:Ne.$xM,SelectionRange:Ne.$QM,SemanticTokens:Ne.$ON,SemanticTokensBuilder:Ne.$NN,SemanticTokensEdit:Ne.$PN,SemanticTokensEdits:Ne.$QN,SemanticTokensLegend:Ne.$MN,ShellExecution:Ne.$eN,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$YM,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$XM,SnippetString:Ne.$FM,SourceBreakpoint:Ne.$vN,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$MM,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$gN,TaskGroup:Ne.$cN,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$$M,TerminalQuickFixTerminalCommand:Ne.$aN,TerminalQuickFixOpener:Ne.$_M,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$bN,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$BM,SnippetTextEdit:Ne.$DM,TextEditorCursorStyle:w.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$rN,ThemeIcon:Ne.$qN,TreeItem:Ne.$hN,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$dO,UIKind:dn.UIKind,Uri:$.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$EM,DocumentPasteTriggerKind:Ne.DocumentPasteTriggerKind,DocumentDropEdit:Ne.$nN,DocumentPasteEditKind:Ne.$oN,DocumentPasteEdit:Ne.$pN,InlayHint:Ne.$1M,InlayHintLabelPart:Ne.$ZM,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$AM,ResolvedAuthority:Ne.$yM,ManagedResolvedAuthority:Ne.$zM,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$4N,NotebookRange:Ne.$VN,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$WN,NotebookData:Ne.$XN,NotebookRendererScript:Ne.$2N,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$ZN,NotebookCellOutputItem:Ne.$YN,NotebookCellStatusBarItem:Ne.$1N,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$CM,NotebookKernelSourceAction:Ne.$3N,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$6N,LinkedEditingRanges:Ne.$5N,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$7N,TestMessage:Ne.$8N,TestTag:Ne.$9N,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:on.TextSearchCompleteMessageType,DataTransfer:Ne.$mN,DataTransferItem:Ne.$iN,TestCoverageCount:Ne.$0N,FileCoverage:Ne.$_N,StatementCoverage:Ne.$aO,BranchCoverage:Ne.$bO,DeclarationCoverage:Ne.$cO,FunctionCoverage:Ne.$cO,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$eO,TabInputTextDiff:Ne.$fO,TabInputTextMerge:Ne.$gO,TabInputCustom:Ne.$hO,TabInputNotebook:Ne.$jO,TabInputNotebookDiff:Ne.$kO,TabInputWebview:Ne.$iO,TabInputTerminal:Ne.$lO,TabInputInteractiveWindow:Ne.$mO,TabInputChat:Ne.$nO,TabInputTextMultiDiff:Ne.$oO,TelemetryTrustedValue:c.$5o,LogLevel:a.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,ChatCopyKind:Ne.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrame:Ne.$CN,Thread:Ne.$DN,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus,PartialAcceptTriggerKind:Ne.PartialAcceptTriggerKind,KeywordRecognitionStatus:Ne.KeywordRecognitionStatus,ChatResponseMarkdownPart:Ne.$qO,ChatResponseFileTreePart:Ne.$rO,ChatResponseAnchorPart:Ne.$sO,ChatResponseProgressPart:Ne.$tO,ChatResponseReferencePart:Ne.$vO,ChatResponseCommandButtonPart:Ne.$uO,ChatRequestTurn:Ne.$wO,ChatResponseTurn:Ne.$xO,ChatLocation:Ne.ChatLocation,LanguageModelChatSystemMessage:Ne.$yO,LanguageModelChatUserMessage:Ne.$zO,LanguageModelChatAssistantMessage:Ne.$AO,LanguageModelSystemMessage:Ne.$yO,LanguageModelUserMessage:Ne.$zO,LanguageModelAssistantMessage:Ne.$AO,LanguageModelError:Ne.$BO,NewSymbolName:Ne.$JN,NewSymbolNameTag:Ne.NewSymbolNameTag,InlineEdit:Ne.$CO,InlineEditTriggerKind:Ne.InlineEditTriggerKind}}}}),define(Ee[379],Ce([1,0,84,158,38,152,45,33,72,44,95,96,97,119,70,91,151,69,59,118,90,71,150,12,60,116,117,121,122,156]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i,n,r,s,t,f,d,u,h,l,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.$hs)(u.$wkc,u.$vkc,1),(0,o.$hs)(f.$Pj,t.$Klc,1),(0,o.$hs)(a.$Ajc,a.$Bjc,1),(0,o.$hs)(p.$$O,p.$0O,0),(0,o.$hs)(l.$Kjc,l.$Ljc,0),(0,o.$hs)(g.$Pjc,g.$Qjc,0),(0,o.$hs)(L.$3jc,L.$1jc,0),(0,o.$hs)(c.$5jc,c.$4jc,0),(0,o.$hs)(P.$Gkc,P.$Kkc,0),(0,o.$hs)(M.$Mkc,M.$Lkc,0),(0,o.$hs)($.$ZO,$.$YO,0),(0,o.$hs)(h.$xkc,h.$ykc,0),(0,o.$hs)(i.$Ejc,i.$Djc,0),(0,o.$hs)(R.$glc,R.$flc,1),(0,o.$hs)(b.$3kc,b.$4kc,0),(0,o.$hs)(C.$lkc,C.$kkc,0),(0,o.$hs)(A.$tlc,A.$slc,0),(0,o.$hs)(w.$okc,w.$rkc,0),(0,o.$hs)(E.$Hlc,E.$Ilc,0),(0,o.$hs)(y.$lCb,y.$mCb,0),(0,o.$hs)(m.$Glc,m.$Flc,0),(0,o.$hs)(I.$Zjc,I.$Yjc,0),(0,o.$hs)(n.$tkc,n.$skc,0),(0,o.$hs)(r.$9O,r.$6O,0),(0,o.$hs)(s.$ckc,s.$dkc,0),(0,o.$hs)(d.$Ekc,d.$Fkc,0)}),define(Ee[123],Ce([1,0,19,12,36,94]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3lc=void 0,e.$1lc=L,e.$2lc=p;function L(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}function p(P,b,C,y){const a=(0,o.$2b)(C,$),m=new I.$LK(b,a,y),c=m.preview.matches;return{ranges:(0,o.$2b)(a,w),uri:P,preview:{text:m.preview.text,matches:(0,o.$2b)(c,w)}}}function $(P){return new I.$MK(P.start.line,P.start.character,P.end.line,P.end.character)}function w(P){return new M.$AK(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let A=class{constructor(b,C){this.a=b,this.b=C}appendLine(b){this.b.debug(`${this.a}#search`,b)}};e.$3lc=A,e.$3lc=A=Qe([He(1,R.$Oj)],A)}),define(Ee[380],Ce([1,0,51,17,76,34,11,14,123,381]),function(re,e,o,R,I,M,L,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=P,e.$5lc=m,e.$6lc=i;const A=w.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(n,r,s,t){const f=b(n,r,s,t),d=r.folder.fsPath;return{cmd:o.spawn(A,f.args,{cwd:d}),rgDiskPath:A,siblingClauses:f.siblingClauses,rgArgs:f,cwd:d}}function b(n,r,s,t){const f=["--files","--hidden","--case-sensitive","--no-require-git"];y([r],s,!1).forEach(u=>{const h=(0,$.$1lc)(u);if(f.push("-g",h),L.$d){const l=(0,I.$2l)(h);l!==h&&f.push("-g",l)}});const d=C([r],t,void 0,!1);return d.globArgs.forEach(u=>{const h=`!${(0,$.$1lc)(u)}`;if(f.push("-g",h),L.$d){const l=(0,I.$2l)(h);l!==h&&f.push("-g",l)}}),r.disregardIgnoreFiles!==!1?f.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&f.push("--no-ignore-parent"),r.ignoreSymlinks||f.push("--follow"),n.exists&&f.push("--quiet"),f.push("--no-config"),r.disregardGlobalIgnoreFiles&&f.push("--no-ignore-global"),{args:f,siblingClauses:d.siblingClauses}}function C(n,r,s,t=!0){const f=[];let d={};return n.forEach(u=>{const h=Object.assign({},u.excludePattern||{},r||{}),l=a(h,t?u.folder.fsPath:void 0,s);f.push(...l.globArgs),l.siblingClauses&&(d=Object.assign(d,l.siblingClauses))}),{globArgs:f,siblingClauses:d}}function y(n,r,s=!0){const t=[];return n.forEach(f=>{const d=Object.assign({},r||{},f.includePattern||{}),u=a(d,s?f.folder.fsPath:void 0);t.push(...u.globArgs)}),t}function a(n,r,s){const t=[],f={};return Object.keys(n).forEach(d=>{if(s&&s.has(d)||!d)return;const u=n[d];d=c(r?m(r,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof u=="boolean"&&u?(d.startsWith("\\\\")&&(d+="**"),t.push(i(d))):u&&u.when&&(f[d]=u)}),{globArgs:t,siblingClauses:f}}function m(n,r){return R.$jc(r)?r:R.$kc(n,r)}function c(n){return n=p.$6e(n,"\\"),p.$6e(n,"/")}function i(n){return M.$eg(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}}),define(Ee[382],Ce([1,0,51,50,17,383,19,47,35,76,34,11,40,14,18,31,36,380,129]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8lc=e.$7lc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(d=>d())});class r{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&$.$ck(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=u.shouldGlobMatchFilePattern?null:(0,i.$ir)(this.b).normalizedLowercase),this.u=u.excludePattern&&$.$ck(u.excludePattern),this.t=new Map,u.folderQueries.forEach(h=>{const l=Object.assign({},h.excludePattern||{},this.a.excludePattern||{}),g=h.folder.fsPath;u.folderQueries.map(E=>E.folder.fsPath).filter(E=>E!==g).forEach(E=>{(0,A.$ig)(E,g)&&(l[I.$mc(g,E)]=!0)}),this.t.set(g,new t(l,g))})}cancel(){this.l=!0,n.forEach(u=>u())}walk(u,h,l,g,E){if(this.m=b.$3d.create(!1),this.l)return E(null,this.j);h.forEach(v=>{const S=I.$oc(v.fsPath);this.u&&this.u(v.fsPath,S)||this.J(l,{relativePath:v.fsPath,searchPath:void 0})}),this.r=b.$3d.create(!1),this.w(u,(v,S)=>{this.x(this.y,this,v,l,g,k=>{if(k){const D=(0,p.$6i)(k);console.error(D),this.q.push(D),S(k,void 0)}else S(null,void 0)})},(v,S)=>{this.m.stop();const k=v?L.$Hb(v)[0]:null;E(k,this.j)})}w(u,h,l){const g=new Array(u.length),E=new Array(u.length);let v=!1,S=0;if(u.length===0)return l(null,[]);u.forEach((k,D)=>{h(k,(F,W)=>{if(F?(v=!0,g[D]=null,E[D]=F):(g[D]=W,E[D]=null),++S===u.length)return l(v?E:null,g)})})}x(u,h,...l){try{u.apply(h,l)}catch(g){l[l.length-1](g)}}y(u,h,l,g){const E=u.folder.fsPath,v=P.$d,S=()=>B&&B.kill();n.add(S);let k=O=>{n.delete(S),k=()=>{},g(O)},D="";const F=this.D(),W=(0,c.$4lc)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression),B=W.cmd,j=!Object.keys(W.siblingClauses).length,N=W.rgArgs.args.map(O=>O.match(/^-/)?O:`'${O}'`).join(" ");let T=`${W.rgDiskPath} ${N}
 - cwd: ${W.cwd}`;W.rgArgs.siblingClauses&&(T+=`
 - Sibling clauses: ${JSON.stringify(W.rgArgs.siblingClauses)}`),l({message:T}),this.s=0,this.z(B,"utf8",l,(O,z,Q)=>{if(O){k(O);return}if(this.j){k();return}const J=(D+(v?w.$1l(z||""):z)).split(`
`);if(Q){const x=J.length;J[x-1]=J[x-1].trim(),J[x-1]||J.pop()}else D=J.pop()||"";if(J.length&&J[0].indexOf(`
`)!==-1){k(new Error("Splitting up files failed"));return}if(this.s+=J.length,j){for(const x of J)if(this.J(h,{base:E,relativePath:x,searchPath:this.N(u,x)}),this.j){S();break}(Q||this.j)&&k();return}this.G(u,F,E,J,h),Q&&(this.H(F,E,h),k())})}spawnFindCmd(u){const h=this.t.get(u.folder.fsPath),l=h.getBasenameTerms(),g=h.getPathTerms(),E=["-L","."];if(l.length||g.length){E.push("-not","(","(");for(const v of l)E.push("-name",v),E.push("-o");for(const v of g)E.push("-path",v),E.push("-o");E.pop(),E.push(")","-prune",")")}return E.push("-type","f"),o.spawn("find",E,{cwd:u.folder.fsPath})}readStdout(u,h,l){let g="";this.z(u,h,()=>{},(E,v,S)=>{if(E){l(E);return}g+=v,S&&l(null,g)})}z(u,h,l,g){let E=(k,D,F)=>{(k||F)&&(E=()=>{},this.r?.stop()),g(k,D,F)},v=!1;u.stdout?(this.A(u.stdout,h,E),u.stdout.once("data",()=>v=!0)):l({message:"stdout is null"});let S;u.stderr?S=this.B(u.stderr):l({message:"stderr is null"}),u.on("error",k=>{E(k)}),u.on("close",k=>{let D;!v&&(D=this.C(S,h))&&f(D)?E(new Error(`command failed with error code ${k}: ${this.C(S,h)}`)):(this.g&&k===0&&(this.j=!0),E(null,"",!0))})}A(u,h,l){const g=new M.StringDecoder(h);return u.on("data",E=>{l(null,g.write(E))}),g}B(u){const h=[];return u.on("data",l=>{h.push(l)}),h}C(u,h){const l=new M.StringDecoder(h);return u.map(g=>l.write(g)).join("")}D(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}G(u,{pathToEntries:h},l,g,E){g.indexOf(this.b)!==-1&&this.J(E,{base:l,relativePath:this.b,searchPath:this.N(u,this.b)});const v=S=>{const k=I.$oc(S),D=I.$nc(S);let F=h[D];F||(F=h[D]=[],v(D)),F.push({base:l,relativePath:S,basename:k,searchPath:this.N(u,S)})};g.forEach(v)}H({rootEntries:u,pathToEntries:h},l,g){const E=this,v=this.t.get(l),S=this.b;function k(D){E.o++;const F=(0,m.$2K)(()=>D.map(W=>W.basename));for(let W=0,B=D.length;W<B;W++){const j=D[W],{relativePath:N,basename:T}=j;if(v.test(N,T,S!==T?F:void 0))continue;const O=h[N];if(O)k(O);else{if(E.p++,N===S)continue;E.J(g,j)}if(E.j)break}}k(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(u,h,l,g,E){const v=u.folder,S=(0,m.$2K)(()=>l);this.w(l,(k,D)=>{if(this.l||this.j)return D(null);const F=h?[h,k].join(I.sep):k;if(this.t.get(u.folder.fsPath).test(F,k,this.a.filePattern!==k?S:void 0))return D(null);const W=[v.fsPath,F].join(I.sep);R.lstat(W,(B,j)=>{if(B||this.l||this.j)return D(null);this.L(W,j,(N,T)=>N||this.l||this.j?D(null):T.isDirectory()?(this.o++,this.M(W,j,(O,z)=>O||this.l||this.j||(z=z||"",this.v[z])?D(null):(this.v[z]=!0,a.Promises.readdir(W).then(Q=>{if(this.l||this.j)return D(null);this.I(u,F,Q,g,Z=>D(Z||null))},Q=>{D(null)})))):(this.p++,F===this.b||this.h&&y.$Zf(T.size)&&T.size>this.h||this.J(g,{base:v.fsPath,relativePath:F,searchPath:this.N(u,F)}),D(null,void 0)))})},k=>{const D=k&&L.$Hb(k);return E(D&&D.length>0?D[0]:void 0)})}J(u,h){this.K(h)&&(!this.d||this.d(h.relativePath,I.$oc(h.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(h))}K(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$WK)(u,this.c);if(this.b)return(0,m.$WK)(u,this.b,!1)}return!0}L(u,h,l){return h.isSymbolicLink()?R.stat(u,l):l(null,h)}M(u,h,l){return h.isSymbolicLink()?R.realpath(u,(g,E)=>g?l(g):l(null,E)):l(null,u)}N(u,h){return u.folderName?I.$kc(u.folderName,h):h}}e.$7lc=r;class s{constructor(u){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.c=new r(u)}search(u,h,l){this.c.walk(this.a,this.b,u,h,(g,E)=>{l(g,{limitHit:E,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$8lc=s;class t{constructor(u,h){this.expression=u,this.c=h,this.d(u)}d(u){let h,l;Object.keys(u).filter(g=>u[g]).forEach(g=>{I.$jc(g)?(h=h||$.$0j(),h[g]=u[g]):(l=l||$.$0j(),l[g]=u[g])}),this.a=h&&$.$ck(h,{trimForExclusions:!0}),this.b=l&&$.$ck(l,{trimForExclusions:!0})}test(u,h,l){return this.b&&this.b(u,h,l)||this.a&&this.a(I.$kc(this.c,u),h,l)}getBasenameTerms(){const u=[];return this.a&&u.push(...$.$ek(this.a)),this.b&&u.push(...$.$ek(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...$.$fk(this.a)),this.b&&u.push(...$.$fk(this.b)),u}}function f(d){const u=d.trim().split(`
`),h=u[0].trim();if(h.startsWith("Error parsing regex"))return h;if(h.startsWith("regex parse error"))return C.$Nf(u[u.length-1].trim());if(h.startsWith("error parsing glob")||h.startsWith("unsupported encoding"))return h.charAt(0).toUpperCase()+h.substr(1);if(h==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(h.startsWith("Literal "))return h}}),define(Ee[384],Ce([1,0,100,21,174,22]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2D=e.$TD=e.DecodeStreamErrorKind=e.$SD=e.$RD=e.$QD=e.$OD=e.$ND=e.$MD=e.$LD=void 0,e.$PD=L,e.$UD=y,e.$VD=a,e.$WD=m,e.$XD=c,e.$YD=i,e.$ZD=d,e.$1D=u,e.$LD="utf8",e.$MD="utf8bom",e.$ND="utf16be",e.$OD="utf16le";function L(h){return[e.$LD,e.$MD,e.$ND,e.$OD].some(l=>l===h)}e.$QD=[254,255],e.$RD=[255,254],e.$SD=[239,187,191];const p=512,$=512,w=512*8,A=512*128;var P;(function(h){h[h.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class b extends Error{constructor(l,g){super(l),this.decodeStreamErrorKind=g}}e.$TD=b;class C{static async create(l){let g;if(l!==e.$LD)g=(await(0,I.$KD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(c(l));else{const E=new TextDecoder;g={write(v){return E.decode(v,{stream:!0})},end(){return E.decode()}}}return new C(g)}constructor(l){this.a=l}write(l){return this.a.write(l)}end(){return this.a.end()}}function y(h,l){const g=l.minBytesRequiredForDetection??l.guessEncoding?w:$;return new Promise((E,v)=>{const S=(0,o.$ie)(j=>j.join("")),k=[];let D=0,F;const W=new M.$ee,B=async()=>{try{const j=await u({buffer:R.$ue.concat(k),bytesRead:D},l.guessEncoding);if(j.seemsBinary&&l.acceptTextOnly)throw new b("Stream is binary but only text is accepted for decoding",1);j.encoding=await l.overwriteEncoding(j.encoding),F=await C.create(j.encoding);const N=F.write(R.$ue.concat(k).buffer);S.write(N),k.length=0,D=0,E({stream:S,detected:j})}catch(j){W.cancel(),S.destroy(),v(j)}};(0,o.$me)(h,{onData:async j=>{F?S.write(F.write(j.buffer)):(k.push(j),D+=j.byteLength,D>=g&&(h.pause(),await B(),setTimeout(()=>h.resume())))},onError:j=>S.error(j),onEnd:async()=>{F||await B(),S.end(F?.end())}},W.token)})}async function a(h,l,g){const v=(await(0,I.$KD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(c(l),g);let S=!1,k=!1;return{read(){if(k)return null;const D=h.read();if(typeof D!="string"){if(k=!0,!S&&g?.addBOM)switch(l){case e.$LD:case e.$MD:return R.$ue.wrap(Uint8Array.from(e.$SD));case e.$ND:return R.$ue.wrap(Uint8Array.from(e.$QD));case e.$OD:return R.$ue.wrap(Uint8Array.from(e.$RD))}const F=v.end();return F&&F.length>0?(S=!0,R.$ue.wrap(F)):null}return S=!0,R.$ue.wrap(v.write(D))}}}async function m(h){return(await(0,I.$KD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(c(h))}function c(h){return h===e.$MD||h===null?e.$LD:h}function i(h,l){if(!h||l<e.$QD.length)return null;const g=h.readUInt8(0),E=h.readUInt8(1);if(g===e.$QD[0]&&E===e.$QD[1])return e.$ND;if(g===e.$RD[0]&&E===e.$RD[1])return e.$OD;if(l<e.$SD.length)return null;const v=h.readUInt8(2);return g===e.$SD[0]&&E===e.$SD[1]&&v===e.$SD[2]?e.$MD:null}const n=["ascii","utf-16","utf-32"];async function r(h){const l=await(0,I.$KD)("jschardet","dist/jschardet.min.js"),g=h.slice(0,A),E=f(g.buffer),v=l.detect(E);if(!v||!v.encoding)return null;const S=v.encoding.toLowerCase();return 0<=n.indexOf(S)?null:t(v.encoding)}const s={ibm866:"cp866",big5:"cp950"};function t(h){const l=h.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return s[l]||l}function f(h){let l="";for(let g=0;g<h.length;g++)l+=String.fromCharCode(h[g]);return l}function d(h){switch(h){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=h.match(/windows(\d+)/);return l?"windows-"+l[1]:h}}}function u({buffer:h,bytesRead:l},g){let E=i(h,l),v=!1;if(E!==e.$ND&&E!==e.$OD&&h){let S=!0,k=!0,D=!1;for(let F=0;F<l&&F<p;F++){const W=F%2===1,B=h.readUInt8(F)===0;if(B&&(D=!0),S&&(W&&!B||!W&&B)&&(S=!1),k&&(W&&B||!W&&!B)&&(k=!1),B&&!S&&!k)break}D&&(S?E=e.$OD:k?E=e.$ND:v=!0)}return g&&!v&&!E&&h?r(h.slice(0,l)).then(S=>({seemsBinary:!1,encoding:S})):{seemsBinary:v,encoding:E}}e.$2D={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ee[161],Ce([1,0,384,31,160]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=void 0;class M extends I.$Ykc{constructor(p,$,w=R,A="searchProcess"){super({query:p,provider:$},{readdir:P=>w.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,o.$ZD)(P)},A)}}e.$dmc=M}),define(Ee[162],Ce([1,0,51,400,383,19,73,35,14,2,36,94,401,381,123]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=e.$9lc=void 0,e.$$lc=t,e.$_lc=d,e.$amc=h,e.$bmc=l,e.$cmc=E;const a=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(S){this.a=S}provideTextSearchResults(S,k,D,F){return this.a.appendLine(`provideTextSearchResults ${S.pattern}, ${JSON.stringify({...k,folder:k.folder.toString()})}`),new Promise((W,B)=>{F.onCancellationRequested(()=>J());const j=t(S,k),N=k.folder.fsPath,T=j.map(ye=>ye.match(/^-/)?ye:`'${ye}'`).join(" ");this.a.appendLine(`${a} ${T}
 - cwd: ${N}`);let O=o.spawn(a,j,{cwd:N});O.on("error",ye=>{console.error(ye),this.a.appendLine("Error: "+(ye&&ye.message)),B((0,A.$SK)(new A.$QK(ye&&ye.message,A.SearchErrorCode.rgProcessError)))});let z=!1;const Q=new n(k.maxResults,k.folder,k.previewOptions);Q.on("result",ye=>{z=!0,ce="",D.report(ye)});let Z=!1;const J=()=>{Z=!0,O?.kill(),Q?.cancel()};let x=!1;Q.on("hitLimit",()=>{x=!0,J()});let ce="";O.stdout.on("data",ye=>{Q.handleData(ye),z||(ce+=ye)});let te=!1;O.stdout.once("data",()=>te=!0);let pe="";O.stderr.on("data",ye=>{const _=ye.toString();this.a.appendLine(_),pe.length+_.length<1e6&&(pe+=_)}),O.on("close",()=>{if(this.a.appendLine(te?"Got data from stdout":"No data from stdout"),this.a.appendLine(z?"Got result from parser":"No result from parser"),ce&&this.a.appendLine(`Got data without result: ${ce}`),this.a.appendLine(""),Z)W({limitHit:x});else{Q.flush(),O=null;let ye;pe&&!te&&(ye=c(pe))?B((0,A.$SK)(new A.$QK(ye.message,ye.code))):W({limitHit:x})}})})}}e.$9lc=m;function c(v){const S=v.split(`
`),k=S[0].trim();if(S.some(F=>F.startsWith("regex parse error")))return new A.$QK(i(S),A.SearchErrorCode.regexParseError);const D=k.match(/grep config error: unknown encoding: (.*)/);if(D)return new A.$QK(`Unknown encoding: ${D[1]}`,A.SearchErrorCode.unknownEncoding);if(k.startsWith("error parsing glob"))return new A.$QK(k.charAt(0).toUpperCase()+k.substr(1),A.SearchErrorCode.globParseError);if(k.startsWith("the literal"))return new A.$QK(k.charAt(0).toUpperCase()+k.substr(1),A.SearchErrorCode.invalidLiteral);if(k.startsWith("PCRE2: error compiling pattern"))return new A.$QK(k,A.SearchErrorCode.regexParseError)}function i(v){const S=["Regex parse error"],k=v.filter(D=>D.startsWith("PCRE2:"));if(k.length>=1){const D=k[0].replace("PCRE2:","");if(D.indexOf(":")!==-1&&D.split(":").length>=2){const F=D.split(":")[1];S.push(":"+F)}}return S.join("")}class n extends R.EventEmitter{constructor(S,k,D){super(),this.g=S,this.h=k,this.j=D,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new I.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(S,k){return super.on(S,k),this}handleData(S){if(this.b)return;const k=typeof S=="string"?S:this.d.write(S);this.k(k)}k(S){let k=S.indexOf(`
`);const D=this.a+S;if(k>=0)k+=this.a.length;else{this.a=D;return}let F=0;for(;k>=0;)this.m(D.substring(F,k).trim()),F=k+1,k=D.indexOf(`
`,F);this.a=D.substring(F)}m(S){if(this.b||!S)return;let k;try{k=JSON.parse(S)}catch{throw new Error(`malformed line from rg: ${S}`)}if(k.type==="match"){const D=r(k.data.path),F=w.URI.joinPath(this.h,D),W=this.n(k.data,F);this.p(W),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(k.type==="context"){const D=r(k.data.path),F=w.URI.joinPath(this.h,D);this.o(k.data,F).forEach(B=>this.p(B))}}n(S,k){const D=S.line_number-1,F=r(S.lines),W=Buffer.from(F);let B=0,j=0,N=D;S.submatches.length===0&&S.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const T=(0,M.$Hb)(S.submatches.map((O,z)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const Q=r(O.match),Z=W.slice(B,O.start).toString(),J=s(Z),x=J.numLines>0?J.lastLineLength:J.lastLineLength+j,ce=s(Q),te=J.numLines+N,pe=ce.numLines+te,ye=ce.numLines>0?ce.lastLineLength:ce.lastLineLength+x;return B=O.end,j=ye,N=pe,new P.$AK(te,x,pe,ye)}));return(0,y.$2lc)(k,F,T,this.j)}o(S,k){const D=r(S.lines),F=S.line_number;return D.replace(/\r?\n$/,"").split(`
`).map((W,B)=>({text:W,uri:k,lineNumber:F+B}))}p(S){this.emit("result",S)}}e.$0lc=n;function r(v){return v.bytes?Buffer.from(v.bytes,"base64").toString():v.text}function s(v){const S=/\n/g;let k=0,D=-1,F;for(;F=S.exec(v);)k++,D=F.index;const W=D>=0?v.length-D-1:v.length;return{numLines:k,lastLineLength:W}}function t(v,S){const k=["--hidden","--no-require-git"];k.push(v.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:D,otherIncludes:F}=(0,L.$E)(S.includes,B=>B.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const B=new Set;F.forEach(j=>{B.add(j)}),k.push("-g","!*"),B.forEach(j=>{f(j).map(y.$1lc).forEach(N=>{k.push("-g",N)})})}D&&D.length&&D.forEach(B=>{k.push("-g",B)}),S.excludes.map(y.$1lc).forEach(B=>k.push("-g",`!${B}`)),S.maxFileSize&&k.push("--max-filesize",S.maxFileSize+""),S.useIgnoreFiles?S.useParentIgnoreFiles||k.push("--no-ignore-parent"):k.push("--no-ignore"),S.followSymlinks&&k.push("--follow"),S.encoding&&S.encoding!=="utf8"&&k.push("--encoding",S.encoding),v.pattern==="--"&&(v.isRegExp=!0,v.pattern="\\-\\-"),v.isMultiline&&!v.isRegExp&&(v.pattern=(0,$.$Ze)(v.pattern),v.isRegExp=!0),S.usePCRE2&&k.push("--pcre2"),k.push("--crlf"),v.isRegExp&&(v.pattern=d(v.pattern),k.push("--engine","auto"));let W;if(v.isWordMatch){const j=(0,$.$9e)(v.pattern,!!v.isRegExp,{wholeWord:v.isWordMatch}).source.replace(/\\\//g,"/");k.push("--regexp",j)}else if(v.isRegExp){let B=h(v.pattern);B=l(B),k.push("--regexp",B)}else W=v.pattern,k.push("--fixed-strings");return k.push("--no-config"),S.useGlobalIgnoreFiles||k.push("--no-ignore-global"),k.push("--json"),v.isMultiline&&k.push("--multiline"),S.beforeContext&&k.push("--before-context",S.beforeContext+""),S.afterContext&&k.push("--after-context",S.afterContext+""),k.push("--"),W&&k.push(W),k.push("."),k}function f(v){return E(v).flatMap(k=>{const D=(0,p.$ak)(k,"/");return D.map((F,W)=>D.slice(0,W+1).join("/"))})}function d(v){const S=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;v.match(S);)v=v.replace(S,"$1\\x{$2}");const k=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;v.match(k);)v=v.replace(k,"$1\\x{$2}");return v}const u=v=>v.type==="Assertion"&&v.kind==="lookbehind";function h(v){let S;try{S=new b.RegExpParser().parsePattern(v)}catch{return v}let k="",D=0;const F=(j,N,T)=>{k+=v.slice(D,j)+T,D=N},W=[];return new b.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const N=W[0];if(!N)F(j.start,j.end,"\\r?\\n");else if(!W.some(u))if(N.type==="CharacterClass")if(N.negate){const T=v.slice(N.start+2,j.start)+v.slice(j.end,N.end-1);N.parent?.type==="Quantifier"?F(N.start,N.end,T?`[^${T}]`:"."):F(N.start,N.end,"(?!\\r?\\n"+(T?`|[${T}]`:"")+")")}else{const T=v.slice(N.start+1,j.start)+v.slice(j.end,N.end-1);F(N.start,N.end,T===""?"\\r?\\n":`(?:[${T}]|\\r?\\n)`)}else N.type==="Quantifier"&&F(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){W.unshift(j)},onQuantifierLeave(){W.shift()},onCharacterClassRangeEnter(j){W.unshift(j)},onCharacterClassRangeLeave(){W.shift()},onCharacterClassEnter(j){W.unshift(j)},onCharacterClassLeave(){W.shift()},onAssertionEnter(j){u(j)&&W.push(j)},onAssertionLeave(j){W[0]===j&&W.shift()}}).visit(S),k+=v.slice(D),k}function l(v){return v.replace(/\n/g,"\\r?\\n")}function g(v){let S=!1,k=!1,D="",F="";for(let W=0;W<v.length;W++){const B=v[W];switch(B){case"\\":k?(S?F+="\\"+B:D+="\\"+B,k=!1):k=!0;break;case"{":if(k)S?F+=B:D+=B,k=!1;else{if(S)return{strInBraces:D+"{"+F+"{"+v.substring(W+1)};S=!0}break;case"}":if(k)S?F+=B:D+=B,k=!1;else{if(S)return{fixedStart:D,strInBraces:F,fixedEnd:v.substring(W+1)};D+=B}break;default:S?F+=(k?"\\":"")+B:D+=(k?"\\":"")+B,k=!1;break}}return{strInBraces:D+(S?"{"+F:"")}}function E(v){const{fixedStart:S,strInBraces:k,fixedEnd:D}=g(v);if(S===void 0||D===void 0)return[k];let F=(0,p.$ak)(k,",");F.length||(F=[""]);const W=E(D);return F.flatMap(B=>{const j=S+B;return W.map(N=>j+N)})}}),define(Ee[385],Ce([1,0,22,162,108,15]),function(re,e,o,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gmc=void 0;class L{constructor(w){this.b=w,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(w,A,P,b){const C=new R.$9lc(this.b);if(A.folder.scheme===M.Schemas.vscodeUserData){const y={...A,folder:A.folder.with({scheme:M.Schemas.file})},a=new I.$Sv(m=>P.report({...m,uri:m.uri.with({scheme:A.folder.scheme})}));return this.c(b,m=>C.provideTextSearchResults(w,y,a,m))}else return this.c(b,y=>C.provideTextSearchResults(w,A,P,y))}async c(w,A){const P=p(w);this.a.add(P);const b=await A(P.token);return this.a.delete(P),b}d(){this.a.forEach(w=>w.cancel())}}e.$gmc=L;function p($){const w=new o.$ee;return $.onCancellationRequested(()=>w.cancel()),w}}),define(Ee[386],Ce([1,0,31,162,161]),function(re,e,o,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=void 0;class M{constructor($){this.a=$}search($,w,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(C){A({message:C})}},b=new I.$dmc(this.a,new R.$9lc(P),o);return new Promise((C,y)=>b.search(a=>{w(a.map(L))},$).then(a=>C({limitHit:a.limitHit,type:"success",stats:a.stats}),y))}}e.$emc=M;function L(p){return{path:p.resource&&p.resource.fsPath,results:p.results,numMatches:(p.results||[]).reduce(($,w)=>{if(w.ranges){const A=w;return $+(Array.isArray(A.ranges)?A.ranges.length:1)}else return $+1},0)}}}),define(Ee[387],Ce([1,0,19,8,13,4,129,17,40,2,32,36,382,386]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fmc=void 0;class y{constructor(r="searchProcess"){this.d=r,this.b=Object.create(null)}fileSearch(r){let s;const t=c(r),f=new M.$7d({onDidAddFirstListener:()=>{s=(0,R.$8g)(d=>this.doFileSearchWithEngine(b.$8lc,t,u=>f.fire(u),d)),s.then(d=>f.fire(d),d=>f.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return f.event}textSearch(r){let s;const t=c(r),f=new M.$7d({onDidAddFirstListener:()=>{s=(0,R.$8g)(d=>this.f(t,u=>f.fire(u),d)),s.then(d=>f.fire(d),d=>f.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return f.event}f(r,s,t){return r.maxFileSize=this.g().maxFileSize,new C.$emc(r).search(t,s,s)}g(){return{maxFileSize:16*A.$kl.GB}}doFileSearch(r,s,t){return this.doFileSearchWithEngine(b.$8lc,r,s,t)}doFileSearchWithEngine(r,s,t,f,d=y.a){let u=0;const h=g=>{Array.isArray(g)?(u+=g.length,t(g.map(E=>this.h(E)))):g.relativePath?(u++,t(this.h(g))):t(g)};if(s.sortByScore){let g=this.l(s,h,f);if(!g){const E=s.maxResults?Object.assign({},s,{maxResults:null}):s,v=new r(E);g=this.j(v,s,t,h,f)}return new Promise((E,v)=>{g.then(([S,k])=>{const D=k.map(F=>this.h(F));this.o(D,t,d),E(S)},v)})}const l=new r(s);return this.r(l,h,d,f).then(g=>({limitHit:g.limitHit,type:"success",stats:{detailStats:g.stats,type:this.d,fromCache:!1,resultCount:u,sortingTime:void 0}}))}h(r){return{path:r.base?(0,p.$kc)(r.base,r.relativePath):r.relativePath}}j(r,s,t,f,d){const u=new M.$7d;let h=(0,R.$8g)(g=>{let E=[];const v=S=>{Array.isArray(S)?E=S:(f(S),u.fire(S))};return this.r(r,v,-1,g).then(S=>[S,E])}),l;if(s.cacheKey){l=this.k(s.cacheKey);const g={promise:h,event:u.event,resolved:!1};l.resultsToSearchCache[s.filePattern||""]=g,h.then(()=>{g.resolved=!0},E=>{delete l.resultsToSearchCache[s.filePattern||""]}),h=this.s(h)}return h.then(([g,E])=>{const v=l?l.scorerCache:Object.create(null),S=(typeof s.maxResults!="number"||s.maxResults>0)&&$.$3d.create(!1);return this.n(s,E,v,d).then(k=>{const D=S?S.elapsed():-1;return[{type:"success",stats:{detailStats:g.stats,sortingTime:D,fromCache:!1,type:this.d,workspaceFolderCount:s.folderQueries.length,resultCount:k.length},messages:g.messages,limitHit:g.limitHit||typeof s.maxResults=="number"&&E.length>s.maxResults},k]})})}k(r){const s=this.b[r];return s||(this.b[r]=new a)}l(r,s,t){const f=r.cacheKey&&this.b[r.cacheKey];if(!f)return;const d=this.q(f,r.filePattern||"",s,t);if(d)return d.then(([u,h,l])=>{const g=$.$3d.create(!1);return this.n(r,h,f.scorerCache,t).then(E=>{const v=g.elapsed(),S={fromCache:!0,detailStats:l,type:this.d,resultCount:h.length,sortingTime:v};return[{type:"success",limitHit:u.limitHit||typeof r.maxResults=="number"&&h.length>r.maxResults,stats:S},E]})})}n(r,s,t,f){const d=(0,L.$ir)(r.filePattern||""),u=(l,g)=>(0,L.$hr)(l,g,d,!0,m,t),h=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return o.$Gb(s,u,h,1e4,f)}o(r,s,t){if(t&&t>0)for(let f=0;f<r.length;f+=t)s(r.slice(f,f+t));else s(r)}q(r,s,t,f){const d=$.$3d.create(!1),u=s.indexOf(p.sep)>=0;let h;for(const v in r.resultsToSearchCache)if(s.startsWith(v)){if(u&&v.indexOf(p.sep)<0&&v!=="")continue;const S=r.resultsToSearchCache[v];h={promise:this.s(S.promise),event:S.event,resolved:S.resolved};break}if(!h)return null;const l=d.elapsed(),g=$.$3d.create(!1),E=h.event(t);return f&&f.onCancellationRequested(()=>{E.dispose()}),h.promise.then(([v,S])=>{if(f&&f.isCancellationRequested)throw(0,I.$6)();const k=[],D=(0,L.$ir)(s).normalizedLowercase;for(const F of S)(0,P.$WK)(F,D)&&k.push(F);return[v,k,{cacheWasResolved:h.resolved,cacheLookupTime:l,cacheFilterTime:g.elapsed(),cacheEntryCount:S.length}]})}r(r,s,t,f){return new Promise((d,u)=>{let h=[];f?.onCancellationRequested(()=>r.cancel()),r.search(l=>{l&&(t?(h.push(l),t>0&&h.length>=t&&(s(h),h=[])):s(l))},l=>{s(l)},(l,g)=>{h.length&&s(h),l?(s({message:"Search finished. Error: "+l.message}),u(l)):(s({message:"Search finished. Stats: "+JSON.stringify(g.stats)}),d(g))})})}clearCache(r){return delete this.b[r],Promise.resolve(void 0)}s(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,t){return r.then(s,t)}catch(s){return this.then(void 0,s)}finally(s){return r.finally(s)}}}}e.$fmc=y,y.a=512;class a{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(n){return(0,p.$oc)(n.relativePath)}getItemDescription(n){return(0,p.$nc)(n.relativePath)}getItemPath(n){return n.relativePath}};function c(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(r=>w.URI.revive(r))}}function i(n){return{...n,folder:w.URI.revive(n.folder)}}}),define(Ee[388],Ce([1,0,3,15,2,31,12,28,20,97,66,36,387,385,123,161]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hmc=void 0;let m=class extends w.$4kc{constructor(i,n,r,s){super(i,r,s),this.w=M,this.x=-1,this.y=null,this.z=!1,this.A=new o.$Tc;const t=new y.$3lc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(R.Schemas.vscodeUserData,new C.$gmc(t))),n.remote.isRemote&&n.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const i=new y.$3lc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(R.Schemas.file,new C.$gmc(i))),this.A.add(this.C(R.Schemas.file,new b.$fmc("fileSearchProvider")))}C(i,n){const r=this.d++;return this.y=n,this.x=r,this.c.$registerFileSearchProvider(r,this.s(i)),(0,o.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(r)})}$provideFileSearchResults(i,n,r,s){const t=(0,w.$5kc)(r);if(i===this.x){const f=Date.now();return this.D(i,n,t,s).then(d=>{const u=Date.now()-f;return this.q.debug(`Ext host file search time: ${u}ms`),d})}return super.$provideFileSearchResults(i,n,r,s)}doInternalFileSearchWithCustomCallback(i,n,r){const s=t=>{if((0,P.$VK)(t)&&(t=[t]),Array.isArray(t)){r(t.map(f=>I.URI.file(f.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(i,s,n)}async D(i,n,r,s){return this.doInternalFileSearchWithCustomCallback(r,s,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.y?.clearCache(i),super.$clearCache(i)}t(i,n){return new a.$dmc(i,n,void 0,"textSearchProvider")}};e.$hmc=m,e.$hmc=m=Qe([He(0,$.$OO),He(1,p.$5O),He(2,A.$Wjc),He(3,L.$Oj)],m)}),define(Ee[124],Ce([1,0,402,63,62,403,21,13,4,3,17,11,30,80,81]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$_h=e.$$h=e.$0h=void 0,e.$ai=d,e.$bi=u,e.$di=g,e.$ei=E;class a{traceSocketEvent(S,k){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,S,k)}constructor(S,k=""){this.f=!0,this.debugLabel=k,this.socket=S,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,p.$1)(D)}},this.socket.on("error",this.a),this.b=D=>{this.traceSocketEvent("close",{hadError:D}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(S){const k=D=>{this.traceSocketEvent("read",D),S(L.$ue.wrap(D))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(S){const k=D=>{S({type:0,hadError:D,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(S){const k=()=>{S()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(S){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",S),this.socket.write(S.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,p.$1)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,p.$1)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((S,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),S();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),S()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.$0h=a;var m;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize",v[v.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var c;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(c||(c={}));class i extends w.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(S,k){this.socket.traceSocketEvent(S,k)}constructor(S,k,D,F){super(),this.f=this.B(new $.$7d),this.g=this.B(new $.$7d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=S,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:D?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new n(this,k,D,F,this.f,(W,B)=>this.m(W,B))),this.B(this.a.onError(W=>{console.error(W),(0,p.$1)(W),this.g.fire({type:0,hadError:!0,error:W})})),this.b=new y.$5h,this.B(this.socket.onData(W=>this.n(W))),this.B(this.socket.onClose(async W=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(W)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this.f.event(S)}onClose(S){return this.g.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){let k=0;for(;k<S.byteLength;)this.a.writeMessage(S.slice(k,Math.min(k+262144,S.byteLength)),{compressed:!0,opcode:2}),k+=262144}m(S,{compressed:k,opcode:D}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",S);let F=2;S.byteLength<126?F+=0:S.byteLength<2**16?F+=2:F+=8;const W=L.$ue.alloc(F),B=k?64:0,j=D&15;if(W.writeUInt8(128|B|j,0),S.byteLength<126)W.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){W.writeUInt8(126,1);let N=1;W.writeUInt8(S.byteLength>>>8&255,++N),W.writeUInt8(S.byteLength>>>0&255,++N)}else{W.writeUInt8(127,1);let N=1;W.writeUInt8(0,++N),W.writeUInt8(0,++N),W.writeUInt8(0,++N),W.writeUInt8(0,++N),W.writeUInt8(S.byteLength>>>24&255,++N),W.writeUInt8(S.byteLength>>>16&255,++N),W.writeUInt8(S.byteLength>>>8&255,++N),W.writeUInt8(S.byteLength>>>0&255,++N)}this.socket.write(L.$ue.concat([W,S]))}end(){this.h=!0,this.socket.end()}n(S){if(S.byteLength!==0){for(this.b.acceptChunk(S);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const k=this.b.peek(this.j.readLen),D=k.readUInt8(0),F=(D&128)>>>7,W=(D&64)>>>6,B=D&15,j=k.readUInt8(1),N=(j&128)>>>7,T=j&127;this.j.state=2,this.j.readLen=2+(N?4:0)+(T===126?2:0)+(T===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!W),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=B,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const k=this.b.read(this.j.readLen),D=k.readUInt8(1),F=(D&128)>>>7;let W=D&127,B=1;W===126?W=k.readUInt8(++B)*2**8+k.readUInt8(++B):W===127&&(W=k.readUInt8(++B)*0+k.readUInt8(++B)*0+k.readUInt8(++B)*0+k.readUInt8(++B)*0+k.readUInt8(++B)*2**24+k.readUInt8(++B)*2**16+k.readUInt8(++B)*2**8+k.readUInt8(++B));let j=0;F&&(j=k.readUInt8(++B)*2**24+k.readUInt8(++B)*2**16+k.readUInt8(++B)*2**8+k.readUInt8(++B)),this.j.state=3,this.j.readLen=W,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const k=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),t(k,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(k,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(k,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$$h=i;class n extends w.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$ue.alloc(0)}constructor(S,k,D,F,W,B){super(),this.n=S,this.r=W,this.s=B,this.a=this.B(new $.$7d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$7d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$7d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,k?(this.b=this.B(new r(this.n,F,D,{windowBits:15})),this.f=this.B(new s(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(S,k){this.g.push({data:S,options:k}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:S,options:k}=this.g.shift();if(this.f&&k.compressed){const D=await this.w(this.f,S);this.s(D,k)}else this.s(S,{...k,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(S,k){return new Promise((D,F)=>{S.write(k),S.flush(W=>D(W))})}acceptFrame(S,k,D){this.h.push({data:S,isCompressed:k,isLastFrameOfMessage:D}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const S=this.h.shift();if(this.b&&S.isCompressed){const k=await this.C(this.b,S.data,S.isLastFrameOfMessage);this.r.fire(k)}else this.r.fire(S.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(S,k,D){return new Promise((F,W)=>{S.write(k),D&&S.write(L.$ue.fromByteArray([0,0,255,255])),S.flush(B=>F(B))})}}class r extends w.$Uc{get recordedInflateBytes(){return this.j?L.$ue.concat(this.f):L.$ue.alloc(0)}constructor(S,k,D,F){super(),this.h=S,this.j=k,this.a=this.B(new $.$7d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(F),this.b.on("error",W=>{this.h.traceSocketEvent("zlibInflateError",{message:W?.message,code:W?.code}),this.a.fire(W)}),this.b.on("data",W=>{this.h.traceSocketEvent("zlibInflateData",W),this.g.push(L.$ue.wrap(W))}),D&&(this.h.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this.b.write(D.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(S){this.j&&this.f.push(S.clone()),this.h.traceSocketEvent("zlibInflateWrite",S),this.b.write(S.buffer)}flush(S){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const k=L.$ue.concat(this.g);this.g.length=0,S(k)})}}class s extends w.$Uc{constructor(S,k){super(),this.g=S,this.a=this.B(new $.$7d),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",D=>{this.g.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.g.traceSocketEvent("zlibDeflateData",D),this.f.push(L.$ue.wrap(D))})}write(S){this.g.traceSocketEvent("zlibDeflateWrite",S.buffer),this.b.write(S.buffer)}flush(S){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let k=L.$ue.concat(this.f);this.f.length=0,k=k.slice(0,k.byteLength-4),S(k)})}}function t(v,S){if(S===0)return;const k=v.byteLength>>>2;for(let N=0;N<k;N++){const T=v.readUInt32BE(N*4);v.writeUInt32BE(T^S,N*4)}const D=k*4,F=v.byteLength-D,W=S>>>24&255,B=S>>>16&255,j=S>>>8&255;F>=1&&v.writeUInt8(v.readUInt8(D)^W,D),F>=2&&v.writeUInt8(v.readUInt8(D+1)^B,D+1),F>=3&&v.writeUInt8(v.readUInt8(D+2)^j,D+2)}e.$_h=process.env.XDG_RUNTIME_DIR;const f={2:107,1:103};function d(){const v=(0,b.$Eg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;const S=process.platform!=="darwin"&&e.$_h?e.$_h:(0,I.tmpdir)(),k=(0,A.$kc)(S,`vscode-ipc-${v}.sock`);return h(k),k}function u(v,S,k){const F=(0,o.createHash)("sha256").update(v).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${k}-${S}-sock`;const W=k.substr(0,4),B=S.substr(0,6);let j;return process.platform!=="darwin"&&e.$_h&&!process.env.VSCODE_PORTABLE?j=(0,A.$kc)(e.$_h,`vscode-${F}-${W}-${B}.sock`):j=(0,A.$kc)(v,`${W}-${B}.sock`),h(j),j}function h(v){const S=f[P.$o];typeof S=="number"&&v.length>=S&&console.warn(`WARNING: IPC handle "${v}" is longer than ${S} chars, try a shorter --user-data-dir`)}class l extends C.$Yh{static b(S){const k=$.Event.fromNodeEventEmitter(S,"connection");return $.Event.map(k,D=>({protocol:new y.$6h(new a(D,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(D,"close"))}))}constructor(S){super(l.b(S)),this.d=S}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ci=l;function g(v){return new Promise((S,k)=>{const D=(0,R.createServer)();D.on("error",k),D.listen(v,()=>{D.removeListener("error",k),S(new l(D))})})}function E(v,S){return new Promise((k,D)=>{const F=(0,R.createConnection)(v,()=>{F.removeListener("error",D),k(y.$7h.fromSocket(new a(F,`ipc-client${S}`),S))});F.once("error",D)})}}),define(Ee[389],Ce([1,0,63,62,176,124,8,3,11,53,12,140,266,267,110,88,21]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=e.$jcc=e.$icc=e.$hcc=void 0;async function c(t,f,d,u,h){let l;for(let g=3;g&&(l?.dispose(),l=await new i(t,f,d,u,h).waitForReady(),!(h&&I.$Hg[h]||!I.$Hg[l.tunnelLocalPort]));g--);return l}class i extends p.$Uc{constructor(f,d,u,h,l){super(),this.m=d,this.n=l,this.privacy=a.TunnelPrivacyId.Private,this.j=new Map,this.a=f,this.b=o.createServer(),this.c=new L.$hh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=g=>this.r(g),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=h,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const f=this.n??this.tunnelRemotePort,d=(0,a.$6v)(this.m)?"0.0.0.0":"127.0.0.1";let u=await(0,I.$Ig)(f,2,1e3,d),h=null;return this.b.listen(u,this.m),await this.c.wait(),h=this.b.address(),h||(u=0,this.b.listen(u,this.m),await this.c.wait(),h=this.b.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async r(f){f.pause();const d=(0,a.$4v)(this.tunnelRemoteHost)||(0,a.$6v)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,b.$El)(this.a,d,this.tunnelRemotePort),h=u.getSocket(),l=u.readEntireBuffer();u.dispose(),l.byteLength>0&&f.write(l.buffer),f.on("end",()=>{f.localAddress&&this.j.delete(f.localAddress),h.end()}),f.on("close",()=>h.end()),f.on("error",()=>{f.localAddress&&this.j.delete(f.localAddress),h instanceof M.$0h?h.socket.destroy():h.end()}),h instanceof M.$0h?this.t(f,h):this.s(f,h),f.localAddress&&this.j.set(f.localAddress,()=>{f.end(),h.end()})}s(f,d){d.onClose(()=>f.destroy()),d.onEnd(()=>f.end()),d.onData(u=>f.write(u.buffer)),f.on("data",u=>d.write(m.$ue.wrap(u))),f.resume()}t(f,d){const u=d.socket;u.on("end",()=>f.end()),u.on("close",()=>f.end()),u.on("error",()=>{f.destroy()}),u.pipe(f),f.pipe(u)}}e.$hcc=i;let n=class extends a.$9v{constructor(f,d,u,h,l){super(d,l),this.v=f,this.w=u,this.y=h}isPortPrivileged(f){return(0,a.$7v)(f,this.m,$.OS,R.release())}t(f,d,u,h,l,g,E,v){const S=this.s(d,u);if(S)return++S.refcount,S.value;if((0,a.$Zv)(f))return this.u(f,d,u,l,g,E,v);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${u} on local port ${l}.`);const k={commit:this.y.commit,quality:this.y.quality,addressProvider:f,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},D=c(k,h,d,u,l);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(d,u,D),D}}};e.$icc=n,e.$icc=n=Qe([He(0,C.$yl),He(1,A.$Oj),He(2,y.$Bl),He(3,P.$8j),He(4,w.$Oi)],n);let r=class extends n{constructor(f,d,u,h,l){super(f,d,u,h,l)}};e.$jcc=r,e.$jcc=r=Qe([He(0,C.$yl),He(1,A.$Oj),He(2,y.$Bl),He(3,P.$8j),He(4,w.$Oi)],r);let s=class extends p.$Uc{constructor(f,d,u,h,l){super(),this.b=f,this.c=d,this.f=u,this.g=h,this.h=l,this.a=new Map}async openTunnel(f,d,u,h,l,g,E,v,S){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${h} on local port ${g}.`),!this.a.has(f)){const k=new r(this.b,this.c,this.g,this.f,this.h);this.B(k),this.a.set(f,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this.a.delete(f))})}return this.a.get(f).openTunnel(d,u,h,l,g,E,v,S)}};e.$kcc=s,e.$kcc=s=Qe([He(0,C.$yl),He(1,A.$Oj),He(2,P.$8j),He(3,y.$Bl),He(4,w.$Oi)],s)}),define(Ee[390],Ce([1,0,124,112,50,33,2,12,43]),function(re,e,o,R,I,M,L,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eP=e.$dP=void 0;class w{constructor(b,C,y){this.b=b,this.c=C,this.f=y,this.a=R.createServer((a,m)=>this.h(a,m)),this.g().catch(a=>(C.error(a),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",b=>this.c.error(b))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(b,C){const y=(m,c)=>{C.writeHead(m,{"content-type":"application/json"}),C.end(JSON.stringify(c||null),i=>i&&this.c.error(i))},a=[];b.setEncoding("utf8"),b.on("data",m=>a.push(m)),b.on("end",async()=>{try{const m=JSON.parse(a.join(""));let c;switch(m.type){case"open":c=await this.i(m);break;case"openExternal":c=await this.j(m);break;case"status":c=await this.l(m);break;case"extensionManagement":c=await this.k(m);break;default:y(404,`Unknown message type: ${m.type}`);break}y(200,c)}catch(m){const c=m instanceof Error?m.message:JSON.stringify(m);y(500,c),this.c.error("Error while processing pipe request",m)}})}async i(b){const{fileURIs:C,folderURIs:y,forceNewWindow:a,diffMode:m,mergeMode:c,addMode:i,forceReuseWindow:n,gotoLineMode:r,waitMarkerFilePath:s,remoteAuthority:t}=b,f=[];if(Array.isArray(y))for(const l of y)try{f.push({folderUri:L.URI.parse(l)})}catch{}if(Array.isArray(C))for(const l of C)try{(0,$.$Ni)(l)?f.push({workspaceUri:L.URI.parse(l)}):f.push({fileUri:L.URI.parse(l)})}catch{}const d=s?L.URI.file(s):void 0,h={forceNewWindow:a,diffMode:m,mergeMode:c,addMode:i,gotoLineMode:r,forceReuseWindow:n,preferNewWindow:!n&&!d&&!i,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",f,h)}async j(b){for(const C of b.uris){const y=L.URI.parse(C),a=y.scheme==="file"?y:C;await this.b.executeCommand("_remoteCLI.openExternal",a)}}async k(b){const C=a=>a?.map(m=>/\.vsix$/i.test(m)?L.URI.parse(m):m),y={list:b.list,install:C(b.install),uninstall:C(b.uninstall),force:b.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",y)}async l(b){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&I.existsSync(this.f)&&I.unlinkSync(this.f)}}e.$dP=w;let A=class extends w{constructor(b,C){super(b,C,(0,o.$ai)())}};e.$eP=A,e.$eP=A=Qe([He(0,M.$$O),He(1,p.$Oj)],A)}),define(Ee[391],Ce([1,0,112,58,378,373,285,48,360,2,15,7,390,103,318,38,359]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=void 0;class c extends M.$Nlc{k(){const r=this,s=globalThis._VSCODE_NODE_MODULES.module,t=s._load;s._load=function(h,l,g){return h=d(h),r.a.has(h)?r.a.get(h).load(h,w.URI.file((0,C.$Rq)(l.filename)),E=>t.apply(this,[E,l,g])):t.apply(this,arguments)};const f=s._resolveLookupPaths;s._resolveLookupPaths=(u,h)=>f.call(this,d(u),h);const d=u=>{for(const h of r.b){const l=h(u);if(l){u=l;break}}return u}}}class i extends p.$Akc{constructor(){super(...arguments),this.extensionRuntime=P.ExtensionRuntime.Node}async vb(){this.h.createInstance(y.$kmc);const r=this.h.invokeFunction(I.$Jlc);if(this.h.createInstance($.$jmc),this.f.remote.isRemote&&this.f.remote.authority){const f=this.h.createInstance(b.$eP);process.env.VSCODE_IPC_HOOK_CLI=f.ipcHandlePath}this.h.createInstance(m.$lmc),await this.h.createInstance(c,r,{mine:this.J,all:this.L}).install(),R.mark("code/extHost/didInitAPI"),(async()=>{const f=process.env.VSCODE_IPC_HOOK_CLI,d=process.env.CODE_SERVER_SESSION_SOCKET;if(!f||!d)return;const h={workspace:this.h.invokeFunction(g=>g.get(a.$Zjc).workspace),socketPath:f},l=JSON.stringify({entry:h});await new Promise((g,E)=>{const v={path:"/add-session",socketPath:d,method:"POST",headers:{"content-type":"application/json"}},S=o.request(v,k=>{k.on("error",E),k.on("end",()=>{try{k.statusCode===200?g():E(new Error("Unexpected status code: "+k.statusCode))}catch(D){E(D)}})});S.on("error",E),S.write(l),S.end()})})().catch(f=>{this.s.error(f)});const t=await this.m.getConfigProvider();await(0,L.$imc)(this.j,t,this,this.s,this.z,this.f),R.mark("code/extHost/didInitProxyResolver")}wb(r){return r.main}async xb(r,s,t){if(s.scheme!==A.Schemas.file)throw new Error(`Cannot load URI: '${s}', must be of file-scheme`);let f=null;t.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${s.toString(!0)}`),this.s.flush();const d=r?.identifier.value;r&&await this.w.initializeLocalizedMessages(r);try{d&&R.mark(`code/extHost/willLoadExtensionCode/${d}`),f=re.__$__nodeRequire(s.fsPath)}finally{d&&R.mark(`code/extHost/didLoadExtensionCode/${d}`),t.codeLoadingStop()}return f}async $setRemoteEnvironment(r){if(this.f.remote.isRemote)for(const s in r){const t=r[s];t===null?delete process.env[s]:process.env[s]=t}}}e.$mmc=i}),define(Ee[392],Ce([1,0,51,21,4,3,126,11,23,2,31,12,265,65,110,88,389,28,20,70,367]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=void 0,e.$nmc=s,e.$omc=t,e.$pmc=f,e.$qmc=d,e.$rmc=h,e.$smc=l,e.$tmc=g;function s(S){const k=S.trim().split(`
`),D=[];return k.forEach(W=>{const B=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(W);B&&B.length>=3&&D.push({pid:parseInt(B[1],10),socket:parseInt(B[2],10)})}),D.reduce((W,B)=>(W[B.socket]=B,W),{})}function t(...S){const k=[].concat(...S.map(d));return[...new Map(k.filter(D=>D.st==="0A").map(D=>{const F=D.local_address.split(":");return{socket:parseInt(D.inode,10),ip:f(F[0]),port:parseInt(F[1],16)}}).map(D=>[D.ip+":"+D.port,D])).values()]}function f(S){let k="";if(S.length===8)for(let D=S.length-2;D>=0;D-=2)k+=parseInt(S.substr(D,2),16),D!==0&&(k+=".");else for(let D=0;D<S.length;D+=8){const F=S.substring(D,D+8);let W="";for(let B=8;B>=2;B-=2)W+=F.substring(B-2,B),(B===6||B===2)&&(W=parseInt(W,16).toString(16),k+=`${W}`,W="",D+B!==S.length-6&&(k+=":"))}return k}function d(S){const k=S.trim().split(`
`),D=k.shift().trim().split(/\s+/).filter(W=>W!=="rx_queue"&&W!=="tm->when");return k.map(W=>W.trim().split(/\s+/).reduce((B,j,N)=>(B[D[N]||N]=j,B),{}))}function u(S){return!!S.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||S.indexOf("out/server-main.js")!==-1||S.indexOf("_productName=VSCode")!==-1}function h(S){const k=S.trim().split(`
`),D=[];return k.forEach(F=>{const W=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(F);W&&W.length>=4&&D.push({pid:parseInt(W[1],10),ppid:parseInt(W[2]),cmd:W[3]})}),D}async function l(S,k,D){const F=D.reduce((B,j)=>(B[j.pid]=j,B),{}),W=[];return S.forEach(({socket:B,ip:j,port:N})=>{const T=k[B]?k[B].pid:void 0,O=T?F[T]?.cmd:void 0;T&&O&&!u(O)&&W.push({host:j,port:N,detail:O,pid:T})}),W}function g(S,k,D){const F=new Map,W=h(k);for(const B of S){const j=D.get(B.port);if(j){F.set(B.port,j);continue}const N=W.find(T=>T.cmd.includes(`${B.port}`));if(N){let T=N,O;do O=W.find(z=>z.ppid===T.pid),O&&(T=O);while(O);F.set(B.port,{host:B.ip,port:B.port,pid:T.pid,detail:T.cmd,ppid:T.ppid})}else F.set(B.port,{host:B.ip,port:B.port,ppid:Number.MAX_VALUE})}return F}let E=class extends n.$mCb{constructor(k,D,F,W){super(k,D,F),this.D=D,this.F=W,this.y=void 0,this.z=new Map,this.C=!1,p.$e&&D.remote.isRemote&&D.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(k){if(k&&this.C)return;this.C=k;let D;this.y&&(D=this.y,await this.a.$onFoundNewCandidates(this.y));const F=new L.$rm;let W=0;for(;this.C;){const B=new Date().getTime(),j=(await this.I()).filter(O=>(0,a.$4v)(O.host)||(0,a.$6v)(O.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(O=>O.port).join(", ")}`);const N=new Date().getTime()-B;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${N} ms.`),W++>3&&F.update(N),(!D||JSON.stringify(D)!==JSON.stringify(j))&&(D=j,await this.a.$onFoundNewCandidates(D));const T=this.G(F.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${T} ms.`),await new Promise(O=>setTimeout(()=>O(),T))}}G(k){return Math.max(k*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(k=>k.port).join(", ")}`)}async I(){let k="",D="";try{k=await A.Promises.readFile("/proc/net/tcp","utf8"),D=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const F=t(k,D),W=await new Promise(Z=>{(0,o.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(J,x,ce)=>{Z(x)})}),B=s(W),j=await A.Promises.readdir("/proc"),N=[];for(const Z of j)try{const J=Number(Z),x=$.$Vg(w.URI.file("/proc"),Z);if((await A.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(J)){const te=await A.Promises.readlink($.$Vg(x,"cwd").fsPath),pe=await A.Promises.readFile($.$Vg(x,"cmdline").fsPath,"utf8");N.push({pid:J,cwd:te,cmd:pe})}}catch{}const T=[],O=F.filter(Z=>{const J=B[Z.socket];return J||T.push(Z),J}),z=l(O,B,N);let Q;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${T.length}`),T.length>0){const Z=await new Promise(J=>{(0,o.exec)("ps -F -A -l | grep root",(x,ce,te)=>{J(ce)})});this.z=g(T,Z,this.z),Q=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${Q.map(J=>J.port).join(", ")}`)}return z.then(Z=>Q?Z.concat(Q):Z)}w(k){return async D=>{const F=new m.$hcc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(B,j,N,T){const O=await k.makeConnection();return v.connect(O,j,N,T)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new C.$ul(0),connectionToken:k.connectionToken})}},signService:this.F},"localhost",D.remoteAddress.host||"localhost",D.remoteAddress.port,D.localAddressPort);await F.waitForReady();const W=new I.$7d;return{localAddress:(0,r.$SL)(F.localAddress)??F.localAddress,remoteAddress:{port:F.tunnelRemotePort,host:F.tunnelRemoteHost},onDidDispose:W.event,dispose:()=>{F.dispose(),W.fire(),W.dispose()}}}}};e.$umc=E,e.$umc=E=Qe([He(0,i.$OO),He(1,c.$5O),He(2,P.$Oj),He(3,y.$Bl)],E);class v extends b.$gub{static connect(k,D,F,W){const B=new M.$Tc,j={onClose:B.add(new I.$7d),onData:B.add(new I.$7d),onEnd:B.add(new I.$7d)};B.add(k.onDidReceiveMessage(T=>j.onData.fire(R.$ue.wrap(T)))),B.add(k.onDidEnd(()=>j.onEnd.fire())),B.add(k.onDidClose(T=>j.onClose.fire({type:0,error:T,hadError:!!T})));const N=new v(k,W,j);return N.B(B),(0,b.$fub)(N,D,F,W,j)}constructor(k,D,F){super(D,F),this.n=k}write(k){this.n.send(k.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Ee[393],Ce([1,0,84,362,376,375,388,391,392,96,48,97,95,44,70,93,361,319,12,377,60,280,106,110,142]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i,n,r,s,t,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.$hs)(A.$Bkc,p.$mmc,0),(0,o.$hs)(i.$Pj,c.$wmc,1),(0,o.$hs)(i.$Oj,new t.$fi(s.$Mlc,[!1],!0)),(0,o.$hs)(f.$Bl,d.$mcc,1),(0,o.$hs)(a.$6jc,m.$vmc,0),(0,o.$hs)(w.$Gkc,M.$Zlc,0),(0,o.$hs)(P.$3kc,L.$hmc,0),(0,o.$hs)(b.$tlc,I.$Rlc,0),(0,o.$hs)(C.$okc,R.$Qlc,0),(0,o.$hs)(y.$lCb,$.$umc,0),(0,o.$hs)(r.$Ekc,n.$xmc,0)}),define(Ee[404],Ce([1,0,112,63,405,58,13,81,124,263,115,374,21,31,103,8,136,286,301,379,393]),function(re,e,o,R,I,M,L,p,$,w,A,P,b,C,y,a,m,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let E=0;E<process.execArgv.length;E++)process.execArgv[E]==="--inspect-port=0"&&(process.execArgv.splice(E,1),E--)}();const n=I(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const g=globalThis._VSCODE_NODE_MODULES.module,E=g._load;g._load=function(v){if(v==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return E.apply(this,arguments)}})();const r=process.exit.bind(process),s=process.on.bind(process);function t(g){process.exit=function(E){if(g)r(E);else{const v=new Error("An extension called process.exit() and this was prevented.");console.warn(v.stack)}},process.crash=function(){const E=new Error("An extension called process.crash() and this was prevented.");console.warn(E.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(E,v){E==="uncaughtException"&&(v=function(){try{return v.call(void 0,arguments)}catch{}}),s(E,v)}}let f=function(g){r()};function d(){const g=(0,i.$bn)(process.env);if(g.type===3)return new Promise((E,v)=>{const S=k=>{const D=k[0],F=new p.$8h;D.on("message",W=>F.fire(b.$ue.wrap(W.data))),D.on("close",()=>{f("renderer closed the MessagePort")}),D.start(),E({onMessage:F.event,send:W=>D.postMessage(W.buffer)})};process.parentPort.on("message",k=>S(k.ports))});if(g.type===2)return new Promise((E,v)=>{let S=null;const k=setTimeout(()=>{f("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),D=108e5,F=3e5,W=new a.$vh(()=>f("renderer disconnected for too long (1)"),D),B=new a.$vh(()=>f("renderer disconnected for too long (2)"),F);process.on("message",(N,T)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){T.setNoDelay(!0);const O=b.$ue.wrap(Buffer.from(N.initialDataChunk,"base64"));let z;if(N.skipWebSocketFrames)z=new $.$0h(T,"extHost-socket");else{const Q=b.$ue.wrap(Buffer.from(N.inflateBytes,"base64"));z=new $.$$h(new $.$0h(T,"extHost-socket"),N.permessageDeflate,Q,!1)}S?(W.cancel(),B.cancel(),S.beginAcceptReconnection(z,O),S.endAcceptReconnection(),S.sendResume()):(clearTimeout(k),S=new p.$9h({socket:z,initialChunk:O}),S.sendResume(),S.onDidDispose(()=>f("renderer disconnected")),E(S),S.onSocketClose(()=>{W.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(B.isScheduled())return;W.isScheduled()&&B.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const E=g.pipeName;return new Promise((v,S)=>{const k=R.createConnection(E,()=>{k.removeListener("error",S);const D=new p.$9h({socket:new $.$0h(k,"extHost-renderer")});D.sendResume(),v(D)});k.once("error",S),k.on("close",()=>{f("renderer closed the socket")})})}}async function u(){const g=await d();return new class{constructor(){this.a=new p.$8h,this.onMessage=this.a.event,this.b=!1,g.onMessage(E=>{(0,A.$Nm)(E,2)?(this.b=!0,f("received terminate message from renderer")):this.a.fire(E)})}send(E){this.b||g.send(E)}async drain(){if(g.drain)return g.drain()}}}function h(g){return new Promise(E=>{const v=g.onMessage(S=>{v.dispose();const k=JSON.parse(S.toString()),D=k.commit,F=w.default.commit;if(D&&F&&D!==F&&r(55),k.parentPid){let W=0;setInterval(function(){try{process.kill(k.parentPid,0),W=0}catch(j){j&&j.code==="EPERM"?(W++,W>=3&&f(`parent process ${k.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):f(`parent process ${k.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let B;try{B=globalThis._VSCODE_NODE_MODULES["native-watchdog"],B.start(k.parentPid)}catch(j){(0,L.$1)(j)}}g.send((0,A.$Mm)(0)),E({protocol:g,initData:k})});g.send((0,A.$Mm)(1))})}async function l(){const g=[];process.on("unhandledRejection",(W,B)=>{g.push(B),setTimeout(()=>{const j=g.indexOf(B);j>=0&&B.catch(N=>{g.splice(j,1),(0,L.$4)(N)||(console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),W&&(0,L.$1)(W))})},1e3)}),process.on("rejectionHandled",W=>{const B=g.indexOf(W);B>=0&&g.splice(B,1)}),process.on("uncaughtException",function(W){(0,L.$Z)(W)||(0,L.$1)(W)}),M.mark("code/extHost/willConnectToRenderer");const E=await u();M.mark("code/extHost/didConnectToRenderer");const v=await h(E);M.mark("code/extHost/didWaitForInitData");const{initData:S}=v;t(!!S.environment.extensionTestsLocationURI),S.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,S.environment.skipWorkspaceStorageLock=(0,m.boolean)(n.skipWorkspaceStorageLock,!1);const k=new class{constructor(){this.pid=process.pid}exit(B){r(B)}fsExists(B){return C.Promises.exists(B)}fsRealpath(B){return(0,y.$Qq)(B)}};let D=null;S.remote.authority&&n.transformURIs&&(D=(0,c.$ls)(S.remote.authority));const F=new P.$Plc(v.protocol,S,k,D);f=W=>{F.terminate(W);const B=process.env.VSCODE_IPC_HOOK_CLI,j=process.env.CODE_SERVER_SESSION_SOCKET;if(!B||!j)return;const N=JSON.stringify({socketPath:B}),T={path:"/delete-session",socketPath:j,method:"POST",headers:{"content-type":"application/json",accept:"application/json"}},O=o.request(T);O.write(N),O.end()}}l().catch(g=>console.log(g))})}).call(this);

//# sourceMappingURL=extensionHostProcess.js.map
